/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],re=function(K){for(var e=[],O=0,k=K.length;O<k;O++)e[O]=ne[K[O]];return e};define(ne[72],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class O{static get(){const D=new Map,A=new Map,x=new Map,P=new Map;function c(S,m){S.has(m.detail)||S.set(m.detail,-m.timestamp)}function a(S,m){const C=S.get(m.detail);C&&(C>=0||S.set(m.detail,C+m.timestamp))}let h=[];typeof K=="function"&&typeof K.getStats=="function"&&(h=K.getStats().slice(0).sort((S,m)=>S.timestamp-m.timestamp));for(const S of h)switch(S.type){case 10:c(D,S);break;case 11:case 12:a(D,S);break;case 21:c(A,S);break;case 22:a(A,S);break;case 33:c(x,S);break;case 34:a(x,S);break;case 31:c(P,S);break;case 32:a(P,S);break}let E=0;x.forEach(S=>E+=S);function y(S){const m=[];return S.forEach((C,g)=>m.push([g,C])),m}return{amdLoad:y(D),amdInvoke:y(A),nodeRequire:y(x),nodeEval:y(P),nodeRequireTotal:E}}static toMarkdownTable(D,A){let x="";const P=[];return D.forEach((c,a)=>{P[a]=c.length}),A.forEach(c=>{c.forEach((a,h)=>{typeof a>"u"&&(a=c[h]="-");const E=a.toString().length;P[h]=Math.max(E,P[h])})}),D.forEach((c,a)=>{x+=`| ${c+" ".repeat(P[a]-c.toString().length)} `}),x+=`|
`,D.forEach((c,a)=>{x+=`| ${"-".repeat(P[a])} `}),x+=`|
`,A.forEach(c=>{c.forEach((a,h)=>{typeof a<"u"&&(x+=`| ${a+" ".repeat(P[h]-a.toString().length)} `)}),x+=`|
`}),x}}e.LoaderStats=O}),define(ne[54],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=k,e.debounce=D,e.throttle=A;function O(x){return(P,c,a)=>{let h=null,E=null;if(typeof a.value=="function"?(h="value",E=a.value):typeof a.get=="function"&&(h="get",E=a.get),!E)throw new Error("not supported");a[h]=x(E,c)}}function k(x,P,c){let a=null,h=null;if(typeof c.value=="function"?(a="value",h=c.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(a="get",h=c.get),!h)throw new Error("not supported");const E=`$memoize$${P}`;c[a]=function(...y){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,y)}),this[E]}}function D(x,P,c){return O((a,h)=>{const E=`$debounce$${h}`,y=`$debounce$result$${h}`;return function(...S){this[y]||(this[y]=c?c():void 0),clearTimeout(this[E]),P&&(this[y]=P(this[y],...S),S=[this[y]]),this[E]=setTimeout(()=>{a.apply(this,S),this[y]=c?c():void 0},x)}})}function A(x,P,c){return O((a,h)=>{const E=`$throttle$timer$${h}`,y=`$throttle$result$${h}`,S=`$throttle$lastRun$${h}`,m=`$throttle$pending$${h}`;return function(...C){if(this[y]||(this[y]=c?c():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...C)),this[m])return;const g=this[S]+x;g<=Date.now()?(this[S]=Date.now(),a.apply(this,[this[y]]),this[y]=c?c():void 0):(this[m]=!0,this[E]=setTimeout(()=>{this[m]=!1,this[S]=Date.now(),a.apply(this,[this[y]]),this[y]=c?c():void 0},g-Date.now()))}})}}),define(ne[73],re([0,1,9]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=k,e.assertNever=D,e.assert=A,e.softAssert=x,e.assertFn=P,e.checkAdjacentItems=c;function k(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function D(a,h="Unreachable"){throw new Error(h)}function A(a){if(!a)throw new O.BugIndicatingError("Assertion Failed")}function x(a){a||(0,O.onUnexpectedError)(new O.BugIndicatingError("Soft Assertion Failed"))}function P(a){if(!a()){debugger;a(),(0,O.onUnexpectedError)(new O.BugIndicatingError("Assertion Failed"))}}function c(a,h){let E=0;for(;E<a.length-1;){const y=a[E],S=a[E+1];if(!h(y,S))return!1;E++}return!0}}),define(ne[38],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=x,e.getLocation=E,e.parse=y,e.parseTree=S,e.findNodeAtLocation=m,e.getNodePath=C,e.getNodeValue=g,e.contains=l,e.findNodeAtOffset=u,e.visit=w,e.stripComments=p,e.getNodeType=v;var O;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var k;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(k||(e.SyntaxKind=k={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function x(n,s=!1){let t=0;const i=n.length;let r="",o=0,f=16,b=0;function R(ie){let fe=0,ce=0;for(;fe<ie;){const le=n.charCodeAt(t);if(le>=48&&le<=57)ce=ce*16+le-48;else if(le>=65&&le<=70)ce=ce*16+le-65+10;else if(le>=97&&le<=102)ce=ce*16+le-97+10;else break;t++,fe++}return fe<ie&&(ce=-1),ce}function L(ie){t=ie,r="",o=0,f=16,b=0}function N(){const ie=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&a(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&a(n.charCodeAt(t)))for(t++;t<n.length&&a(n.charCodeAt(t));)t++;else return b=3,n.substring(ie,t);let fe=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&a(n.charCodeAt(t))){for(t++;t<n.length&&a(n.charCodeAt(t));)t++;fe=t}else b=3;return n.substring(ie,fe)}function _(){let ie="",fe=t;for(;;){if(t>=i){ie+=n.substring(fe,t),b=2;break}const ce=n.charCodeAt(t);if(ce===34){ie+=n.substring(fe,t),t++;break}if(ce===92){if(ie+=n.substring(fe,t),t++,t>=i){b=2;break}switch(n.charCodeAt(t++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const j=R(4);j>=0?ie+=String.fromCharCode(j):b=4;break}default:b=5}fe=t;continue}if(ce>=0&&ce<=31)if(c(ce)){ie+=n.substring(fe,t),b=2;break}else b=6;t++}return ie}function V(){if(r="",b=0,o=t,t>=i)return o=i,f=17;let ie=n.charCodeAt(t);if(P(ie)){do t++,r+=String.fromCharCode(ie),ie=n.charCodeAt(t);while(P(ie));return f=15}if(c(ie))return t++,r+=String.fromCharCode(ie),ie===13&&n.charCodeAt(t)===10&&(t++,r+=`
`),f=14;switch(ie){case 123:return t++,f=1;case 125:return t++,f=2;case 91:return t++,f=3;case 93:return t++,f=4;case 58:return t++,f=6;case 44:return t++,f=5;case 34:return t++,r=_(),f=10;case 47:{const fe=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!c(n.charCodeAt(t));)t++;return r=n.substring(fe,t),f=12}if(n.charCodeAt(t+1)===42){t+=2;const ce=i-1;let le=!1;for(;t<ce;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,le=!0;break}t++}return le||(t++,b=1),r=n.substring(fe,t),f=13}return r+=String.fromCharCode(ie),t++,f=16}case 45:if(r+=String.fromCharCode(ie),t++,t===i||!a(n.charCodeAt(t)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=N(),f=11;default:for(;t<i&&H(ie);)t++,ie=n.charCodeAt(t);if(o!==t){switch(r=n.substring(o,t),r){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return r+=String.fromCharCode(ie),t++,f=16}}function H(ie){if(P(ie)||c(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ie;do ie=V();while(ie>=12&&ie<=15);return ie}return{setPosition:L,getPosition:()=>t,scan:s?se:V,getToken:()=>f,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>b}}function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function c(n){return n===10||n===13||n===8232||n===8233}function a(n){return n>=48&&n<=57}var h;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(h||(h={}));function E(n,s){const t=[],i=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function b(R,L,N,_){o.value=R,o.offset=L,o.length=N,o.type=_,o.colonOffset=void 0,r=o}try{w(n,{onObjectBegin:(R,L)=>{if(s<=R)throw i;r=void 0,f=s>R,t.push("")},onObjectProperty:(R,L,N)=>{if(s<L||(b(R,L,N,"property"),t[t.length-1]=R,s<=L+N))throw i},onObjectEnd:(R,L)=>{if(s<=R)throw i;r=void 0,t.pop()},onArrayBegin:(R,L)=>{if(s<=R)throw i;r=void 0,t.push(0)},onArrayEnd:(R,L)=>{if(s<=R)throw i;r=void 0,t.pop()},onLiteralValue:(R,L,N)=>{if(s<L||(b(R,L,N,v(R)),s<=L+N))throw i},onSeparator:(R,L,N)=>{if(s<=L)throw i;if(R===":"&&r&&r.type==="property")r.colonOffset=L,f=!1,r=void 0;else if(R===","){const _=t[t.length-1];typeof _=="number"?t[t.length-1]=_+1:(f=!0,t[t.length-1]=""),r=void 0}}})}catch(R){if(R!==i)throw R}return{path:t,previousNode:r,isAtPropertyKey:f,matches:R=>{let L=0;for(let N=0;L<R.length&&N<t.length;N++)if(R[L]===t[N]||R[L]==="*")L++;else if(R[L]!=="**")return!1;return L===R.length}}}function y(n,s=[],t=A.DEFAULT){let i=null,r=[];const o=[];function f(R){Array.isArray(r)?r.push(R):i!==null&&(r[i]=R)}return w(n,{onObjectBegin:()=>{const R={};f(R),o.push(r),r=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const R=[];f(R),o.push(r),r=R,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:f,onError:(R,L,N)=>{s.push({error:R,offset:L,length:N})}},t),r[0]}function S(n,s=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function o(R){return i.children.push(R),R}w(n,{onObjectBegin:R=>{i=o({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,L,N)=>{i=o({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:L,length:N,parent:i})},onObjectEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onArrayBegin:(R,L)=>{i=o({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,L)=>{i.length=R+L-i.offset,i=i.parent,r(R+L)},onLiteralValue:(R,L,N)=>{o({type:v(R),offset:L,length:N,parent:i,value:R}),r(L+N)},onSeparator:(R,L,N)=>{i.type==="property"&&(R===":"?i.colonOffset=L:R===","&&r(L))},onError:(R,L,N)=>{s.push({error:R,offset:L,length:N})}},t);const b=i.children[0];return b&&delete b.parent,b}function m(n,s){if(!n)return;let t=n;for(const i of s)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],r=!0;break}if(!r)return}else{const r=i;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}function C(n){if(!n.parent||!n.parent.children)return[];const s=C(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;s.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&s.push(t)}return s}function g(n){switch(n.type){case"array":return n.children.map(g);case"object":{const s=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(s[t.children[0].value]=g(i))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}function l(n,s,t=!1){return s>=n.offset&&s<n.offset+n.length||t&&s===n.offset+n.length}function u(n,s,t=!1){if(l(n,s,t)){const i=n.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=s;r++){const o=u(i[r],s,t);if(o)return o}return n}}function w(n,s,t=A.DEFAULT){const i=x(n,!1);function r(J){return J?()=>J(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(J){return J?Z=>J(Z,i.getTokenOffset(),i.getTokenLength()):()=>!0}const f=r(s.onObjectBegin),b=o(s.onObjectProperty),R=r(s.onObjectEnd),L=r(s.onArrayBegin),N=r(s.onArrayEnd),_=o(s.onLiteralValue),V=o(s.onSeparator),H=r(s.onComment),se=o(s.onError),ie=t&&t.disallowComments,fe=t&&t.allowTrailingComma;function ce(){for(;;){const J=i.scan();switch(i.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:ie||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(J){case 12:case 13:ie?le(10):H();break;case 16:le(1);break;case 15:case 14:break;default:return J}}}function le(J,Z=[],F=[]){if(se(J),Z.length+F.length>0){let M=i.getToken();for(;M!==17;){if(Z.indexOf(M)!==-1){ce();break}else if(F.indexOf(M)!==-1)break;M=ce()}}}function j(J){const Z=i.getTokenValue();return J?_(Z):b(Z),ce(),!0}function Y(){switch(i.getToken()){case 11:{let J=0;try{J=JSON.parse(i.getTokenValue()),typeof J!="number"&&(le(2),J=0)}catch{le(2)}_(J);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return ce(),!0}function z(){return i.getToken()!==10?(le(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(V(":"),ce(),X()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function W(){f(),ce();let J=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(J||le(4,[],[]),V(","),ce(),i.getToken()===2&&fe)break}else J&&le(6,[],[]);z()||le(4,[],[2,5]),J=!0}return R(),i.getToken()!==2?le(7,[2],[]):ce(),!0}function q(){L(),ce();let J=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(J||le(4,[],[]),V(","),ce(),i.getToken()===4&&fe)break}else J&&le(6,[],[]);X()||le(4,[],[4,5]),J=!0}return N(),i.getToken()!==4?le(8,[4],[]):ce(),!0}function X(){switch(i.getToken()){case 3:return q();case 1:return W();case 10:return j(!0);default:return Y()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(le(4,[],[]),!1):X()?(i.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}function p(n,s){const t=x(n),i=[];let r,o=0,f;do switch(f=t.getPosition(),r=t.scan(),r){case 12:case 13:case 17:o!==f&&i.push(n.substring(o,f)),s!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,s)),o=t.getPosition();break}while(r!==17);return i.join("")}function v(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}}),define(ne[74],re([0,1,38]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=k,e.toFormattedString=D,e.getEOL=P,e.isEOL=c;function k(a,h,E){let y,S,m,C,g;if(h){for(C=h.offset,g=C+h.length,m=C;m>0&&!c(a,m-1);)m--;let f=g;for(;f<a.length&&!c(a,f);)f++;S=a.substring(m,f),y=x(S,E)}else S=a,y=0,m=0,C=0,g=a.length;const l=P(E,a);let u=!1,w=0,p;E.insertSpaces?p=A(" ",E.tabSize||4):p="	";const v=(0,O.createScanner)(S,!1);let n=!1;function s(){return l+A(p,y+w)}function t(){let f=v.scan();for(u=!1;f===15||f===14;)u=u||f===14,f=v.scan();return n=f===16||v.getTokenError()!==0,f}const i=[];function r(f,b,R){!n&&b<g&&R>C&&a.substring(b,R)!==f&&i.push({offset:b,length:R-b,content:f})}let o=t();if(o!==17){const f=v.getTokenOffset()+m,b=A(p,y);r(b,m,f)}for(;o!==17;){let f=v.getTokenOffset()+v.getTokenLength()+m,b=t(),R="";for(;!u&&(b===12||b===13);){const N=v.getTokenOffset()+m;r(" ",f,N),f=v.getTokenOffset()+v.getTokenLength()+m,R=b===12?s():"",b=t()}if(b===2)o!==1&&(w--,R=s());else if(b===4)o!==3&&(w--,R=s());else{switch(o){case 3:case 1:w++,R=s();break;case 5:case 12:R=s();break;case 13:u?R=s():R=" ";break;case 6:R=" ";break;case 10:if(b===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?R=" ":b!==5&&b!==17&&(n=!0);break;case 16:n=!0;break}u&&(b===12||b===13)&&(R=s())}const L=v.getTokenOffset()+m;r(R,f,L),o=b}return i}function D(a,h){const E=JSON.stringify(a,void 0,h.insertSpaces?h.tabSize||4:"	");return h.eol!==void 0?E.replace(/\r\n|\r|\n/g,h.eol):E}function A(a,h){let E="";for(let y=0;y<h;y++)E+=a;return E}function x(a,h){let E=0,y=0;const S=h.tabSize||4;for(;E<a.length;){const m=a.charAt(E);if(m===" ")y++;else if(m==="	")y+=S;else break;E++}return Math.floor(y/S)}function P(a,h){for(let E=0;E<h.length;E++){const y=h.charAt(E);if(y==="\r")return E+1<h.length&&h.charAt(E+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}function c(a,h){return`\r
`.indexOf(a.charAt(h))!==-1}}),define(ne[75],re([0,1,38,74]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=D,e.setProperty=A,e.withFormatting=x,e.applyEdit=P,e.applyEdits=c;function D(a,h,E){return A(a,h,void 0,E)}function A(a,h,E,y,S){const m=h.slice(),C=[],g=(0,O.parseTree)(a,C);let l,u;for(;m.length>0&&(u=m.pop(),l=(0,O.findNodeAtLocation)(g,m),l===void 0&&E!==void 0);)typeof u=="string"?E={[u]:E}:E=[E];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const w=(0,O.findNodeAtLocation)(l,[u]);if(w!==void 0)if(E===void 0){if(!w.parent)throw new Error("Malformed AST");const p=l.children.indexOf(w.parent);let v,n=w.parent.offset+w.parent.length;if(p>0){const s=l.children[p-1];v=s.offset+s.length}else v=l.offset+1,l.children.length>1&&(n=l.children[1].offset);return x(a,{offset:v,length:n-v,content:""},y)}else return x(a,{offset:w.offset,length:w.length,content:JSON.stringify(E)},y);else{if(E===void 0)return[];const p=`${JSON.stringify(u)}: ${JSON.stringify(E)}`,v=S?S(l.children.map(s=>s.children[0].value)):l.children.length;let n;if(v>0){const s=l.children[v-1];n={offset:s.offset+s.length,length:0,content:","+p}}else l.children.length===0?n={offset:l.offset+1,length:0,content:p}:n={offset:l.offset+1,length:0,content:p+","};return x(a,n,y)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(E!==void 0){const w=`${JSON.stringify(E)}`;let p;if(l.children.length===0||u===0)p={offset:l.offset+1,length:0,content:l.children.length===0?w:w+","};else{const v=u===-1||u>l.children.length?l.children.length:u,n=l.children[v-1];p={offset:n.offset+n.length,length:0,content:","+w}}return x(a,p,y)}else{const w=u,p=l.children[w];let v;if(l.children.length===1)v={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===w){const n=l.children[w-1],s=n.offset+n.length,t=l.offset+l.length;v={offset:s,length:t-2-s,content:""}}else v={offset:p.offset,length:l.children[w+1].offset-p.offset,content:""};return x(a,v,y)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else return E===void 0?[]:x(a,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(E)},y)}function x(a,h,E){let y=P(a,h),S=h.offset,m=h.offset+h.content.length;if(h.length===0||h.content.length===0){for(;S>0&&!(0,k.isEOL)(y,S-1);)S--;for(;m<y.length&&!(0,k.isEOL)(y,m);)m++}const C=(0,k.format)(y,{offset:S,length:m-S},E);for(let l=C.length-1;l>=0;l--){const u=C[l];y=P(y,u),S=Math.min(S,u.offset),m=Math.max(m,u.offset+u.length),m+=u.content.length-u.length}const g=a.length-(y.length-m)-S;return[{offset:S,length:g,content:y.substring(S,m)}]}function P(a,h){return a.substring(0,h.offset)+h.content+a.substring(h.offset+h.length)}function c(a,h){const E=h.slice(0).sort((S,m)=>{const C=S.offset-m.offset;return C===0?S.length-m.length:C});let y=a.length;for(let S=E.length-1;S>=0;S--){const m=E[S];if(m.offset+m.length<=y)a=P(a,m);else throw new Error("Overlapping edit");y=m.offset}return a}}),define(ne[76],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=O,e.rot=k;function O(P,c,a){return Math.min(Math.max(P,c),a)}function k(P,c){return(c+P%c)%c}class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class A{constructor(){this._n=1,this._val=0}update(c){return this._val=this._val+(c-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class x{constructor(c){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(c),this._values.fill(0,0,c)}update(c){const a=this._values[this._index];return this._values[this._index]=c,this._index=(this._index+1)%this._values.length,this._sum-=a,this._sum+=c,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=x}),function(){function K(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function x(c){A.push(c,Date.now())}function P(){const c=[];for(let a=0;a<A.length;a+=2)c.push({name:A[a],startTime:A[a+1]});return c}return{mark:x,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const x of performance.getEntriesByType("mark"))A.push({name:x.name,startTime:Math.round(D+x.startTime)});return A}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function O(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=O(k))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var k in O)(typeof exports=="object"?exports:K)[k]=O[k]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function O(k){if(e[k])return e[k].exports;var D=e[k]={i:k,l:!1,exports:{}};return K[k].call(D.exports,D,D.exports,O),D.l=!0,D.exports}return O.m=K,O.c=e,O.d=function(k,D,A){O.o(k,D)||Object.defineProperty(k,D,{enumerable:!0,get:A})},O.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},O.t=function(k,D){if(1&D&&(k=O(k)),8&D||4&D&&typeof k=="object"&&k&&k.__esModule)return k;var A=Object.create(null);if(O.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:k}),2&D&&typeof k!="string")for(var x in k)O.d(A,x,function(P){return k[P]}.bind(null,x));return A},O.n=function(k){var D=k&&k.__esModule?function(){return k.default}:function(){return k};return O.d(D,"a",D),D},O.o=function(k,D){return Object.prototype.hasOwnProperty.call(k,D)},O.p="",O(O.s=0)}([function(K,e,O){(function(k){var D;e=K.exports=F,D=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var $=Array.prototype.slice.call(arguments,0);$.unshift("SEMVER"),console.log.apply(console,$)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,x=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],c=e.src=[],a=0,h=a++;c[h]="0|[1-9]\\d*";var E=a++;c[E]="[0-9]+";var y=a++;c[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=a++;c[S]="("+c[h]+")\\.("+c[h]+")\\.("+c[h]+")";var m=a++;c[m]="("+c[E]+")\\.("+c[E]+")\\.("+c[E]+")";var C=a++;c[C]="(?:"+c[h]+"|"+c[y]+")";var g=a++;c[g]="(?:"+c[E]+"|"+c[y]+")";var l=a++;c[l]="(?:-("+c[C]+"(?:\\."+c[C]+")*))";var u=a++;c[u]="(?:-?("+c[g]+"(?:\\."+c[g]+")*))";var w=a++;c[w]="[0-9A-Za-z-]+";var p=a++;c[p]="(?:\\+("+c[w]+"(?:\\."+c[w]+")*))";var v=a++,n="v?"+c[S]+c[l]+"?"+c[p]+"?";c[v]="^"+n+"$";var s="[v=\\s]*"+c[m]+c[u]+"?"+c[p]+"?",t=a++;c[t]="^"+s+"$";var i=a++;c[i]="((?:<|>)?=?)";var r=a++;c[r]=c[E]+"|x|X|\\*";var o=a++;c[o]=c[h]+"|x|X|\\*";var f=a++;c[f]="[v=\\s]*("+c[o]+")(?:\\.("+c[o]+")(?:\\.("+c[o]+")(?:"+c[l]+")?"+c[p]+"?)?)?";var b=a++;c[b]="[v=\\s]*("+c[r]+")(?:\\.("+c[r]+")(?:\\.("+c[r]+")(?:"+c[u]+")?"+c[p]+"?)?)?";var R=a++;c[R]="^"+c[i]+"\\s*"+c[f]+"$";var L=a++;c[L]="^"+c[i]+"\\s*"+c[b]+"$";var N=a++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=a++;c[_]="(?:~>?)";var V=a++;c[V]="(\\s*)"+c[_]+"\\s+",P[V]=new RegExp(c[V],"g");var H=a++;c[H]="^"+c[_]+c[f]+"$";var se=a++;c[se]="^"+c[_]+c[b]+"$";var ie=a++;c[ie]="(?:\\^)";var fe=a++;c[fe]="(\\s*)"+c[ie]+"\\s+",P[fe]=new RegExp(c[fe],"g");var ce=a++;c[ce]="^"+c[ie]+c[f]+"$";var le=a++;c[le]="^"+c[ie]+c[b]+"$";var j=a++;c[j]="^"+c[i]+"\\s*("+s+")$|^$";var Y=a++;c[Y]="^"+c[i]+"\\s*("+n+")$|^$";var z=a++;c[z]="(\\s*)"+c[i]+"\\s*("+s+"|"+c[f]+")",P[z]=new RegExp(c[z],"g");var W=a++;c[W]="^\\s*("+c[f]+")\\s+-\\s+("+c[f]+")\\s*$";var q=a++;c[q]="^\\s*("+c[b]+")\\s+-\\s+("+c[b]+")\\s*$";var X=a++;c[X]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)D(J,c[J]),P[J]||(P[J]=new RegExp(c[J]));function Z($,Q){if($ instanceof F)return $;if(typeof $!="string"||$.length>A||!(Q?P[t]:P[v]).test($))return null;try{return new F($,Q)}catch{return null}}function F($,Q){if($ instanceof F){if($.loose===Q)return $;$=$.version}else if(typeof $!="string")throw new TypeError("Invalid Version: "+$);if($.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof F))return new F($,Q);D("SemVer",$,Q),this.loose=Q;var ee=$.trim().match(Q?P[t]:P[v]);if(!ee)throw new TypeError("Invalid Version: "+$);if(this.raw=$,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>x||this.major<0)throw new TypeError("Invalid major version");if(this.minor>x||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>x||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var we=+ge;if(we>=0&&we<x)return we}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=Z,e.valid=function($,Q){var ee=Z($,Q);return ee?ee.version:null},e.clean=function($,Q){var ee=Z($.trim().replace(/^[=v]+/,""),Q);return ee?ee.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function($){return D("SemVer.compare",this.version,this.loose,$),$ instanceof F||($=new F($,this.loose)),this.compareMain($)||this.comparePre($)},F.prototype.compareMain=function($){return $ instanceof F||($=new F($,this.loose)),d(this.major,$.major)||d(this.minor,$.minor)||d(this.patch,$.patch)},F.prototype.comparePre=function($){if($ instanceof F||($=new F($,this.loose)),this.prerelease.length&&!$.prerelease.length)return-1;if(!this.prerelease.length&&$.prerelease.length)return 1;if(!this.prerelease.length&&!$.prerelease.length)return 0;var Q=0;do{var ee=this.prerelease[Q],ge=$.prerelease[Q];if(D("prerelease compare",Q,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return d(ee,ge)}while(++Q)},F.prototype.inc=function($,Q){switch($){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+$)}return this.format(),this.raw=this.version,this},e.inc=function($,Q,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new F($,ee).inc(Q,ge).version}catch{return null}},e.diff=function($,Q){if(G($,Q))return null;var ee=Z($),ge=Z(Q);if(ee.prerelease.length||ge.prerelease.length){for(var we in ee)if((we==="major"||we==="minor"||we==="patch")&&ee[we]!==ge[we])return"pre"+we;return"prerelease"}for(var we in ee)if((we==="major"||we==="minor"||we==="patch")&&ee[we]!==ge[we])return we},e.compareIdentifiers=d;var M=/^[0-9]+$/;function d($,Q){var ee=M.test($),ge=M.test(Q);return ee&&ge&&($=+$,Q=+Q),ee&&!ge?-1:ge&&!ee?1:$<Q?-1:$>Q?1:0}function I($,Q,ee){return new F($,ee).compare(new F(Q,ee))}function T($,Q,ee){return I($,Q,ee)>0}function U($,Q,ee){return I($,Q,ee)<0}function G($,Q,ee){return I($,Q,ee)===0}function B($,Q,ee){return I($,Q,ee)!==0}function te($,Q,ee){return I($,Q,ee)>=0}function ae($,Q,ee){return I($,Q,ee)<=0}function ue($,Q,ee,ge){var we;switch(Q){case"===":typeof $=="object"&&($=$.version),typeof ee=="object"&&(ee=ee.version),we=$===ee;break;case"!==":typeof $=="object"&&($=$.version),typeof ee=="object"&&(ee=ee.version),we=$!==ee;break;case"":case"=":case"==":we=G($,ee,ge);break;case"!=":we=B($,ee,ge);break;case">":we=T($,ee,ge);break;case">=":we=te($,ee,ge);break;case"<":we=U($,ee,ge);break;case"<=":we=ae($,ee,ge);break;default:throw new TypeError("Invalid operator: "+Q)}return we}function me($,Q){if($ instanceof me){if($.loose===Q)return $;$=$.value}if(!(this instanceof me))return new me($,Q);D("comparator",$,Q),this.loose=Q,this.parse($),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function($,Q){return d(Q,$)},e.major=function($,Q){return new F($,Q).major},e.minor=function($,Q){return new F($,Q).minor},e.patch=function($,Q){return new F($,Q).patch},e.compare=I,e.compareLoose=function($,Q){return I($,Q,!0)},e.rcompare=function($,Q,ee){return I(Q,$,ee)},e.sort=function($,Q){return $.sort(function(ee,ge){return e.compare(ee,ge,Q)})},e.rsort=function($,Q){return $.sort(function(ee,ge){return e.rcompare(ee,ge,Q)})},e.gt=T,e.lt=U,e.eq=G,e.neq=B,e.gte=te,e.lte=ae,e.cmp=ue,e.Comparator=me;var ye={};function he($,Q){if($ instanceof he)return $.loose===Q?$:new he($.raw,Q);if($ instanceof me)return new he($.value,Q);if(!(this instanceof he))return new he($,Q);if(this.loose=Q,this.raw=$,this.set=$.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$);this.format()}function pe($){return!$||$.toLowerCase()==="x"||$==="*"}function de($,Q,ee,ge,we,Oe,be,Te,Re,xe,_e,Le,Ae){return((Q=pe(ee)?"":pe(ge)?">="+ee+".0.0":pe(we)?">="+ee+"."+ge+".0":">="+Q)+" "+(Te=pe(Re)?"":pe(xe)?"<"+(+Re+1)+".0.0":pe(_e)?"<"+Re+"."+(+xe+1)+".0":Le?"<="+Re+"."+xe+"."+_e+"-"+Le:"<="+Te)).trim()}function Se($,Q){for(var ee=0;ee<$.length;ee++)if(!$[ee].test(Q))return!1;if(Q.prerelease.length){for(ee=0;ee<$.length;ee++)if(D($[ee].semver),$[ee].semver!==ye&&$[ee].semver.prerelease.length>0){var ge=$[ee].semver;if(ge.major===Q.major&&ge.minor===Q.minor&&ge.patch===Q.patch)return!0}return!1}return!0}function Pe($,Q,ee){try{Q=new he(Q,ee)}catch{return!1}return Q.test($)}function De($,Q,ee,ge){var we,Oe,be,Te,Re;switch($=new F($,ge),Q=new he(Q,ge),ee){case">":we=T,Oe=ae,be=U,Te=">",Re=">=";break;case"<":we=U,Oe=te,be=T,Te="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe($,Q,ge))return!1;for(var xe=0;xe<Q.set.length;++xe){var _e=Q.set[xe],Le=null,Ae=null;if(_e.forEach(function(Ne){Ne.semver===ye&&(Ne=new me(">=0.0.0")),Le=Le||Ne,Ae=Ae||Ne,we(Ne.semver,Le.semver,ge)?Le=Ne:be(Ne.semver,Ae.semver,ge)&&(Ae=Ne)}),Le.operator===Te||Le.operator===Re||(!Ae.operator||Ae.operator===Te)&&Oe($,Ae.semver)||Ae.operator===Re&&be($,Ae.semver))return!1}return!0}me.prototype.parse=function($){var Q=this.loose?P[j]:P[Y],ee=$.match(Q);if(!ee)throw new TypeError("Invalid comparator: "+$);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new F(ee[2],this.loose):this.semver=ye},me.prototype.toString=function(){return this.value},me.prototype.test=function($){return D("Comparator.test",$,this.loose),this.semver===ye||(typeof $=="string"&&($=new F($,this.loose)),ue($,this.operator,this.semver,this.loose))},me.prototype.intersects=function($,Q){if(!($ instanceof me))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new he($.value,Q),Pe(this.value,ee,Q);if($.operator==="")return ee=new he(this.value,Q),Pe($.semver,ee,Q);var ge=!(this.operator!==">="&&this.operator!==">"||$.operator!==">="&&$.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||$.operator!=="<="&&$.operator!=="<"),Oe=this.semver.version===$.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||$.operator!==">="&&$.operator!=="<="),Te=ue(this.semver,"<",$.semver,Q)&&(this.operator===">="||this.operator===">")&&($.operator==="<="||$.operator==="<"),Re=ue(this.semver,">",$.semver,Q)&&(this.operator==="<="||this.operator==="<")&&($.operator===">="||$.operator===">");return ge||we||Oe&&be||Te||Re},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function($){return $.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function($){var Q=this.loose;$=$.trim(),D("range",$,Q);var ee=Q?P[q]:P[W];$=$.replace(ee,de),D("hyphen replace",$),$=$.replace(P[z],"$1$2$3"),D("comparator trim",$,P[z]),$=($=($=$.replace(P[V],"$1~")).replace(P[fe],"$1^")).split(/\s+/).join(" ");var ge=Q?P[j]:P[Y],we=$.split(" ").map(function(Oe){return function(be,Te){return D("comp",be),be=function(Re,xe){return Re.trim().split(/\s+/).map(function(_e){return function(Le,Ae){D("caret",Le,Ae);var Ne=Ae?P[le]:P[ce];return Le.replace(Ne,function(Me,Ee,Ie,Ce,ke){var Fe;return D("caret",Le,Me,Ee,Ie,Ce,ke),pe(Ee)?Fe="":pe(Ie)?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":pe(Ce)?Fe=Ee==="0"?">="+Ee+"."+Ie+".0 <"+Ee+"."+(+Ie+1)+".0":">="+Ee+"."+Ie+".0 <"+(+Ee+1)+".0.0":ke?(D("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Fe=Ee==="0"?Ie==="0"?">="+Ee+"."+Ie+"."+Ce+ke+" <"+Ee+"."+Ie+"."+(+Ce+1):">="+Ee+"."+Ie+"."+Ce+ke+" <"+Ee+"."+(+Ie+1)+".0":">="+Ee+"."+Ie+"."+Ce+ke+" <"+(+Ee+1)+".0.0"):(D("no pr"),Fe=Ee==="0"?Ie==="0"?">="+Ee+"."+Ie+"."+Ce+" <"+Ee+"."+Ie+"."+(+Ce+1):">="+Ee+"."+Ie+"."+Ce+" <"+Ee+"."+(+Ie+1)+".0":">="+Ee+"."+Ie+"."+Ce+" <"+(+Ee+1)+".0.0"),D("caret return",Fe),Fe})}(_e,xe)}).join(" ")}(be,Te),D("caret",be),be=function(Re,xe){return Re.trim().split(/\s+/).map(function(_e){return function(Le,Ae){var Ne=Ae?P[se]:P[H];return Le.replace(Ne,function(Me,Ee,Ie,Ce,ke){var Fe;return D("tilde",Le,Me,Ee,Ie,Ce,ke),pe(Ee)?Fe="":pe(Ie)?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":pe(Ce)?Fe=">="+Ee+"."+Ie+".0 <"+Ee+"."+(+Ie+1)+".0":ke?(D("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Fe=">="+Ee+"."+Ie+"."+Ce+ke+" <"+Ee+"."+(+Ie+1)+".0"):Fe=">="+Ee+"."+Ie+"."+Ce+" <"+Ee+"."+(+Ie+1)+".0",D("tilde return",Fe),Fe})}(_e,xe)}).join(" ")}(be,Te),D("tildes",be),be=function(Re,xe){return D("replaceXRanges",Re,xe),Re.split(/\s+/).map(function(_e){return function(Le,Ae){Le=Le.trim();var Ne=Ae?P[L]:P[R];return Le.replace(Ne,function(Me,Ee,Ie,Ce,ke,Fe){D("xRange",Le,Me,Ee,Ie,Ce,ke,Fe);var Ve=pe(Ie),Ue=Ve||pe(Ce),We=Ue||pe(ke);return Ee==="="&&We&&(Ee=""),Ve?Me=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&We?(Ue&&(Ce=0),We&&(ke=0),Ee===">"?(Ee=">=",Ue?(Ie=+Ie+1,Ce=0,ke=0):We&&(Ce=+Ce+1,ke=0)):Ee==="<="&&(Ee="<",Ue?Ie=+Ie+1:Ce=+Ce+1),Me=Ee+Ie+"."+Ce+"."+ke):Ue?Me=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":We&&(Me=">="+Ie+"."+Ce+".0 <"+Ie+"."+(+Ce+1)+".0"),D("xRange return",Me),Me})}(_e,xe)}).join(" ")}(be,Te),D("xrange",be),be=function(Re,xe){return D("replaceStars",Re,xe),Re.trim().replace(P[X],"")}(be,Te),D("stars",be),be}(Oe,Q)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Oe){return!!Oe.match(ge)})),we=we.map(function(Oe){return new me(Oe,Q)})},he.prototype.intersects=function($,Q){if(!($ instanceof he))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return $.set.some(function(we){return we.every(function(Oe){return ge.intersects(Oe,Q)})})})})},e.toComparators=function($,Q){return new he($,Q).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},he.prototype.test=function($){if(!$)return!1;typeof $=="string"&&($=new F($,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Se(this.set[Q],$))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function($,Q,ee){var ge=null,we=null;try{var Oe=new he(Q,ee)}catch{return null}return $.forEach(function(be){Oe.test(be)&&(ge&&we.compare(be)!==-1||(we=new F(ge=be,ee)))}),ge},e.minSatisfying=function($,Q,ee){var ge=null,we=null;try{var Oe=new he(Q,ee)}catch{return null}return $.forEach(function(be){Oe.test(be)&&(ge&&we.compare(be)!==1||(we=new F(ge=be,ee)))}),ge},e.validRange=function($,Q){try{return new he($,Q).range||"*"}catch{return null}},e.ltr=function($,Q,ee){return De($,Q,"<",ee)},e.gtr=function($,Q,ee){return De($,Q,">",ee)},e.outside=De,e.prerelease=function($,Q){var ee=Z($,Q);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function($,Q,ee){return $=new he($,ee),Q=new he(Q,ee),$.intersects(Q)},e.coerce=function($){if($ instanceof F)return $;if(typeof $!="string")return null;var Q=$.match(P[N]);return Q==null?null:Z((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,O(1))},function(K,e){var O,k,D=K.exports={};function A(){throw new Error("setTimeout has not been defined")}function x(){throw new Error("clearTimeout has not been defined")}function P(g){if(O===setTimeout)return setTimeout(g,0);if((O===A||!O)&&setTimeout)return O=setTimeout,setTimeout(g,0);try{return O(g,0)}catch{try{return O.call(null,g,0)}catch{return O.call(this,g,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:A}catch{O=A}try{k=typeof clearTimeout=="function"?clearTimeout:x}catch{k=x}})();var c,a=[],h=!1,E=-1;function y(){h&&c&&(h=!1,c.length?a=c.concat(a):E=-1,a.length&&S())}function S(){if(!h){var g=P(y);h=!0;for(var l=a.length;l;){for(c=a,a=[];++E<l;)c&&c[E].run();E=-1,l=a.length}c=null,h=!1,function(u){if(k===clearTimeout)return clearTimeout(u);if((k===x||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(u);try{k(u)}catch{try{return k.call(null,u)}catch{return k.call(this,u)}}}(g)}}function m(g,l){this.fun=g,this.array=l}function C(){}D.nextTick=function(g){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];a.push(new m(g,l)),a.length!==1||h||P(S)},m.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=C,D.addListener=C,D.once=C,D.off=C,D.removeListener=C,D.removeAllListeners=C,D.emit=C,D.prependListener=C,D.prependOnceListener=C,D.listeners=function(g){return[]},D.binding=function(g){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(g){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ne[77],re([0,1]),function(K,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class k{constructor(P,c,a){this.level=P,this.key=c,this.value=a,this.forward=[]}}const D=void 0;class A{constructor(P,c=2**16){this.comparator=P,this[O]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new k(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new k(this._maxLevel,D,D),this._size=0}has(P){return!!A._search(this,P,this.comparator)}get(P){return A._search(this,P,this.comparator)?.value}set(P,c){return A._insert(this,P,c,this.comparator)&&(this._size+=1),this}delete(P){const c=A._delete(this,P,this.comparator);return c&&(this._size-=1),c}forEach(P,c){let a=this._header.forward[0];for(;a;)P.call(c,a.value,a.key,this),a=a.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",c=this._header.forward[0];for(;c;)P+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return P}static _search(P,c,a){let h=P._header;for(let E=P._level-1;E>=0;E--)for(;h.forward[E]&&a(h.forward[E].key,c)<0;)h=h.forward[E];if(h=h.forward[0],h&&a(h.key,c)===0)return h}static _insert(P,c,a,h){const E=[];let y=P._header;for(let S=P._level-1;S>=0;S--){for(;y.forward[S]&&h(y.forward[S].key,c)<0;)y=y.forward[S];E[S]=y}if(y=y.forward[0],y&&h(y.key,c)===0)return y.value=a,!1;{const S=A._randomLevel(P);if(S>P._level){for(let m=P._level;m<S;m++)E[m]=P._header;P._level=S}y=new k(S,c,a);for(let m=0;m<S;m++)y.forward[m]=E[m].forward[m],E[m].forward[m]=y;return!0}}static _randomLevel(P,c=.5){let a=1;for(;Math.random()<c&&a<P._maxLevel;)a+=1;return a}static _delete(P,c,a){const h=[];let E=P._header;for(let y=P._level-1;y>=0;y--){for(;E.forward[y]&&a(E.forward[y].key,c)<0;)E=E.forward[y];h[y]=E}if(E=E.forward[0],!E||a(E.key,c)!==0)return!1;for(let y=0;y<P._level&&h[y].forward[y]===E;y++)h[y].forward[y]=E.forward[y];for(;P._level>0&&P._header.forward[P._level-1]===D;)P._level-=1;return!0}}e.SkipList=A}),define(ne[46],re([0,1,9,2]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=D,e.isReadableStream=A,e.isReadableBufferedStream=x,e.newWriteableStream=P,e.consumeReadable=a,e.peekReadable=h,e.consumeStream=E,e.listenStream=y,e.peekStream=S,e.toStream=m,e.emptyStream=C,e.toReadable=g,e.transform=l,e.prefixedReadable=u,e.prefixedStream=w;function D(p){const v=p;return v?typeof v.read=="function":!1}function A(p){const v=p;return v?[v.on,v.pause,v.resume,v.destroy].every(n=>typeof n=="function"):!1}function x(p){const v=p;return v?A(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}function P(p,v){return new c(p,v)}class c{constructor(v,n){this.reducer=v,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v<"u"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(n=>n(v))}emitError(v){this.listeners.error.length===0?(0,O.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(n=>n(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,n){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(v,n){if(this.state.destroyed)return;let s;switch(v){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(n);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(p,v){const n=[];let s;for(;(s=p.read())!==null;)n.push(s);return v(n)}function h(p,v,n){const s=[];let t;for(;(t=p.read())!==null&&s.length<n;)s.push(t);return t===null&&s.length>0?v(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return p.read()}}}function E(p,v){return new Promise((n,s)=>{const t=[];y(p,{onData:i=>{v&&t.push(i)},onError:i=>{v?s(i):n(void 0)},onEnd:()=>{n(v?v(t):void 0)}})})}function y(p,v,n){p.on("error",s=>{n?.isCancellationRequested||v.onError(s)}),p.on("end",()=>{n?.isCancellationRequested||v.onEnd()}),p.on("data",s=>{n?.isCancellationRequested||v.onData(s)})}function S(p,v){return new Promise((n,s)=>{const t=new k.DisposableStore,i=[],r=b=>{if(i.push(b),i.length>v)return t.dispose(),p.pause(),n({stream:p,buffer:i,ended:!1})},o=b=>(t.dispose(),s(b)),f=()=>(t.dispose(),n({stream:p,buffer:i,ended:!0}));t.add((0,k.toDisposable)(()=>p.removeListener("error",o))),p.on("error",o),t.add((0,k.toDisposable)(()=>p.removeListener("end",f))),p.on("end",f),t.add((0,k.toDisposable)(()=>p.removeListener("data",r))),p.on("data",r)})}function m(p,v){const n=P(v);return n.end(p),n}function C(){const p=P(()=>{throw new Error("not supported")});return p.end(),p}function g(p){let v=!1;return{read:()=>v?null:(v=!0,p)}}function l(p,v,n){const s=P(n);return y(p,{onData:t=>s.write(v.data(t)),onError:t=>s.error(v.error?v.error(t):t),onEnd:()=>s.end()}),s}function u(p,v,n){let s=!1;return{read:()=>{const t=v.read();return s?t:(s=!0,t!==null?n([p,t]):p)}}}function w(p,v,n){let s=!1;const t=P(n);return y(v,{onData:i=>s?t.write(i):(s=!0,t.write(n([p,i]))),onError:i=>t.error(i),onEnd:()=>{s||(s=!0,t.write(p)),t.end()}}),t}}),define(ne[14],re([0,1,169,46]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=a,e.readUInt16LE=h,e.writeUInt16LE=E,e.readUInt32BE=y,e.writeUInt32BE=S,e.readUInt32LE=m,e.writeUInt32LE=C,e.readUInt8=g,e.writeUInt8=l,e.readableToBuffer=u,e.bufferToReadable=w,e.streamToBuffer=p,e.bufferedStreamToBuffer=v,e.bufferToStream=n,e.streamToBufferReadableStream=s,e.newWriteableBufferStream=t,e.prefixedBufferReadable=i,e.prefixedBufferStream=r,e.decodeBase64=o,e.encodeBase64=R;const D=typeof Buffer<"u",A=new O.Lazy(()=>new Uint8Array(256));let x,P;class c{static alloc(N){return D?new c(Buffer.allocUnsafe(N)):new c(new Uint8Array(N))}static wrap(N){return D&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new c(N)}static fromString(N,_){return!(_?.dontUseNodeBuffer||!1)&&D?new c(Buffer.from(N)):(x||(x=new TextEncoder),new c(x.encode(N)))}static fromByteArray(N){const _=c.alloc(N.length);for(let V=0,H=N.length;V<H;V++)_.buffer[V]=N[V];return _}static concat(N,_){if(typeof _>"u"){_=0;for(let se=0,ie=N.length;se<ie;se++)_+=N[se].byteLength}const V=c.alloc(_);let H=0;for(let se=0,ie=N.length;se<ie;se++){const fe=N[se];V.set(fe,H),H+=fe.byteLength}return V}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=c.alloc(this.byteLength);return N.set(this),N}toString(){return D?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(N,_){return new c(this.buffer.subarray(N,_))}set(N,_){if(N instanceof c)this.buffer.set(N.buffer,_);else if(N instanceof Uint8Array)this.buffer.set(N,_);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),_);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return y(this.buffer,N)}writeUInt32BE(N,_){S(this.buffer,N,_)}readUInt32LE(N){return m(this.buffer,N)}writeUInt32LE(N,_){C(this.buffer,N,_)}readUInt8(N){return g(this.buffer,N)}writeUInt8(N,_){l(this.buffer,N,_)}indexOf(N,_=0){return a(this.buffer,N instanceof c?N.buffer:N,_)}}e.VSBuffer=c;function a(L,N,_=0){const V=N.byteLength,H=L.byteLength;if(V===0)return 0;if(V===1)return L.indexOf(N[0]);if(V>H-_)return-1;const se=A.value;se.fill(N.length);for(let le=0;le<N.length;le++)se[N[le]]=N.length-le-1;let ie=_+N.length-1,fe=ie,ce=-1;for(;ie<H;)if(L[ie]===N[fe]){if(fe===0){ce=ie;break}ie--,fe--}else ie+=Math.max(N.length-fe,se[L[ie]]),fe=N.length-1;return ce}function h(L,N){return L[N+0]<<0>>>0|L[N+1]<<8>>>0}function E(L,N,_){L[_+0]=N&255,N=N>>>8,L[_+1]=N&255}function y(L,N){return L[N]*2**24+L[N+1]*2**16+L[N+2]*2**8+L[N+3]}function S(L,N,_){L[_+3]=N,N=N>>>8,L[_+2]=N,N=N>>>8,L[_+1]=N,N=N>>>8,L[_]=N}function m(L,N){return L[N+0]<<0>>>0|L[N+1]<<8>>>0|L[N+2]<<16>>>0|L[N+3]<<24>>>0}function C(L,N,_){L[_+0]=N&255,N=N>>>8,L[_+1]=N&255,N=N>>>8,L[_+2]=N&255,N=N>>>8,L[_+3]=N&255}function g(L,N){return L[N]}function l(L,N,_){L[_]=N}function u(L){return k.consumeReadable(L,N=>c.concat(N))}function w(L){return k.toReadable(L)}function p(L){return k.consumeStream(L,N=>c.concat(N))}async function v(L){return L.ended?c.concat(L.buffer):c.concat([...L.buffer,await p(L.stream)])}function n(L){return k.toStream(L,N=>c.concat(N))}function s(L){return k.transform(L,{data:N=>typeof N=="string"?c.fromString(N):c.wrap(N)},N=>c.concat(N))}function t(L){return k.newWriteableStream(N=>c.concat(N),L)}function i(L,N){return k.prefixedReadable(L,N,_=>c.concat(_))}function r(L,N){return k.prefixedStream(L,N,_=>c.concat(_))}function o(L){let N=0,_=0,V=0;const H=new Uint8Array(Math.floor(L.length/4*3)),se=fe=>{switch(_){case 3:H[V++]=N|fe,_=0;break;case 2:H[V++]=N|fe>>>2,N=fe<<6,_=3;break;case 1:H[V++]=N|fe>>>4,N=fe<<4,_=2;break;default:N=fe<<2,_=1}};for(let fe=0;fe<L.length;fe++){const ce=L.charCodeAt(fe);if(ce>=65&&ce<=90)se(ce-65);else if(ce>=97&&ce<=122)se(ce-97+26);else if(ce>=48&&ce<=57)se(ce-48+52);else if(ce===43||ce===45)se(62);else if(ce===47||ce===95)se(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${L[fe]}`)}}const ie=V;for(;_>0;)se(0);return c.wrap(H).slice(0,ie)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:L},N=!0,_=!1){const V=_?b:f;let H="";const se=L.byteLength%3;let ie=0;for(;ie<L.byteLength-se;ie+=3){const fe=L[ie+0],ce=L[ie+1],le=L[ie+2];H+=V[fe>>>2],H+=V[(fe<<4|ce>>>4)&63],H+=V[(ce<<2|le>>>6)&63],H+=V[le&63]}if(se===1){const fe=L[ie+0];H+=V[fe>>>2],H+=V[fe<<4&63],N&&(H+="==")}else if(se===2){const fe=L[ie+0],ce=L[ie+1];H+=V[fe>>>2],H+=V[(fe<<4|ce>>>4)&63],H+=V[ce<<2&63],N&&(H+="=")}return H}}),define(ne[43],re([0,1,31]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=k,e.doHash=D,e.numberHash=A,e.stringHash=P,e.toHexString=C;function k(l){return D(l,0)}function D(l,u){switch(typeof l){case"object":return l===null?A(349,u):Array.isArray(l)?c(l,u):a(l,u);case"string":return P(l,u);case"boolean":return x(l,u);case"number":return A(l,u);case"undefined":return A(937,u);default:return A(617,u)}}function A(l,u){return(u<<5)-u+l|0}function x(l,u){return A(l?433:863,u)}function P(l,u){u=A(149417,u);for(let w=0,p=l.length;w<p;w++)u=A(l.charCodeAt(w),u);return u}function c(l,u){return u=A(104579,u),l.reduce((w,p)=>D(p,w),u)}function a(l,u){return u=A(181387,u),Object.keys(l).sort().reduce((w,p)=>(w=P(p,w),D(l[p],w)),u)}class h{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=D(u,this._value),this._value}}e.Hasher=h;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function y(l,u,w=32){const p=w-u,v=~((1<<p)-1);return(l<<u|(v&l)>>>p)>>>0}function S(l,u=0,w=l.byteLength,p=0){for(let v=0;v<w;v++)l[u+v]=p}function m(l,u,w="0"){for(;l.length<u;)l=w+l;return l}function C(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(w=>w.toString(16).padStart(2,"0")).join(""):m((l>>>0).toString(16),u/4)}class g{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const w=u.length;if(w===0)return;const p=this._buff;let v=this._buffLen,n=this._leftoverHighSurrogate,s,t;for(n!==0?(s=n,t=-1,n=0):(s=u.charCodeAt(0),t=0);;){let i=s;if(O.isHighSurrogate(s))if(t+1<w){const r=u.charCodeAt(t+1);O.isLowSurrogate(r)?(t++,i=O.computeCodePoint(s,r)):i=65533}else{n=s;break}else O.isLowSurrogate(s)&&(i=65533);if(v=this._push(p,v,i),t++,t<w)s=u.charCodeAt(t);else break}this._buffLen=v,this._leftoverHighSurrogate=n}_push(u,w,p){return p<128?u[w++]=p:p<2048?(u[w++]=192|(p&1984)>>>6,u[w++]=128|(p&63)>>>0):p<65536?(u[w++]=224|(p&61440)>>>12,u[w++]=128|(p&4032)>>>6,u[w++]=128|(p&63)>>>0):(u[w++]=240|(p&1835008)>>>18,u[w++]=128|(p&258048)>>>12,u[w++]=128|(p&4032)>>>6,u[w++]=128|(p&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),C(this._h0)+C(this._h1)+C(this._h2)+C(this._h3)+C(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=g._bigBlock32,w=this._buffDV;for(let f=0;f<64;f+=4)u.setUint32(f,w.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)u.setUint32(f,y(u.getUint32(f-12,!1)^u.getUint32(f-32,!1)^u.getUint32(f-56,!1)^u.getUint32(f-64,!1),1),!1);let p=this._h0,v=this._h1,n=this._h2,s=this._h3,t=this._h4,i,r,o;for(let f=0;f<80;f++)f<20?(i=v&n|~v&s,r=1518500249):f<40?(i=v^n^s,r=1859775393):f<60?(i=v&n|v&s|n&s,r=2400959708):(i=v^n^s,r=3395469782),o=y(p,5)+i+t+r+u.getUint32(f*4,!1)&4294967295,t=s,s=n,n=y(v,30),v=p,p=o;this._h0=this._h0+p&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=g}),define(ne[55],re([0,1,31]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(k||(k={})),function(D){const A="error",x="warning",P="warn",c="info",a="ignore";function h(y){return y?O.equalsIgnoreCase(A,y)?D.Error:O.equalsIgnoreCase(x,y)||O.equalsIgnoreCase(P,y)?D.Warning:O.equalsIgnoreCase(c,y)?D.Info:D.Ignore:D.Ignore}D.fromValue=h;function E(y){switch(y){case D.Error:return A;case D.Warning:return x;case D.Info:return c;default:return a}}D.toString=E}(k||(k={})),e.default=k}),define(ne[27],re([0,1,3]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=k,e.deepFreeze=D,e.cloneAndChange=x,e.mixin=c,e.equals=a,e.safeStringify=h,e.distinct=E,e.getCaseInsensitive=y,e.filter=S,e.getAllPropertyNames=m,e.getAllMethodNames=C,e.createProxyObject=g;function k(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([w,p])=>{u[w]=p&&typeof p=="object"?k(p):p}),u}function D(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const w=u.shift();Object.freeze(w);for(const p in w)if(A.call(w,p)){const v=w[p];typeof v=="object"&&!Object.isFrozen(v)&&!(0,O.isTypedArray)(v)&&u.push(v)}}return l}const A=Object.prototype.hasOwnProperty;function x(l,u){return P(l,u,new Set)}function P(l,u,w){if((0,O.isUndefinedOrNull)(l))return l;const p=u(l);if(typeof p<"u")return p;if(Array.isArray(l)){const v=[];for(const n of l)v.push(P(n,u,w));return v}if((0,O.isObject)(l)){if(w.has(l))throw new Error("Cannot clone recursive data-structure");w.add(l);const v={};for(const n in l)A.call(l,n)&&(v[n]=P(l[n],u,w));return w.delete(l),v}return l}function c(l,u,w=!0){return(0,O.isObject)(l)?((0,O.isObject)(u)&&Object.keys(u).forEach(p=>{p in l?w&&((0,O.isObject)(l[p])&&(0,O.isObject)(u[p])?c(l[p],u[p],w):l[p]=u[p]):l[p]=u[p]}),l):u}function a(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let w,p;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(w=0;w<l.length;w++)if(!a(l[w],u[w]))return!1}else{const v=[];for(p in l)v.push(p);v.sort();const n=[];for(p in u)n.push(p);if(n.sort(),!a(v,n))return!1;for(w=0;w<v.length;w++)if(!a(l[v[w]],u[v[w]]))return!1}return!0}function h(l){const u=new Set;return JSON.stringify(l,(w,p)=>{if((0,O.isObject)(p)||Array.isArray(p)){if(u.has(p))return"[Circular]";u.add(p)}return typeof p=="bigint"?`[BigInt ${p.toString()}]`:p})}function E(l,u){const w=Object.create(null);return!l||!u||Object.keys(u).forEach(v=>{const n=l[v],s=u[v];a(n,s)||(w[v]=s)}),w}function y(l,u){const w=u.toLowerCase(),p=Object.keys(l).find(v=>v.toLowerCase()===w);return p?l[p]:l[u]}function S(l,u){const w=Object.create(null);for(const[p,v]of Object.entries(l))u(p,v)&&(w[p]=v);return w}function m(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}function C(l){const u=[];for(const w of m(l))typeof l[w]=="function"&&u.push(w);return u}function g(l,u){const w=v=>function(){const n=Array.prototype.slice.call(arguments,0);return u(v,n)},p={};for(const v of l)p[v]=w(v);return p}}),define(ne[28],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=k;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(D){return O.test(D)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let c=0;c<P.length;c++)P[c]=Math.floor(Math.random()*256);return P};const A=new Uint8Array(16),x=[];for(let P=0;P<256;P++)x.push(P.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let c=0,a="";return a+=x[A[c++]],a+=x[A[c++]],a+=x[A[c++]],a+=x[A[c++]],a+="-",a+=x[A[c++]],a+=x[A[c++]],a+="-",a+=x[A[c++]],a+=x[A[c++]],a+="-",a+=x[A[c++]],a+=x[A[c++]],a+="-",a+=x[A[c++]],a+=x[A[c++]],a+=x[A[c++]],a+=x[A[c++]],a+=x[A[c++]],a+=x[A[c++]],a}}()}),define(ne[78],re([0,1,33]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=A;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(x){const P=x.replace(/\-/g,":").toLowerCase();return!k.has(P)}function A(){const x=(0,O.networkInterfaces)();for(const P in x){const c=x[P];if(c){for(const{mac:a}of c)if(D(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ne[79],re([7,4]),function(K,e){return K.create("vs/base/common/date",e)}),define(ne[80],re([0,1,79]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=a,e.getDurationString=h,e.toLocalISOString=E;const k=60,D=k*60,A=D*24,x=A*7,P=A*30,c=A*365;function a(y,S,m,C){typeof y!="number"&&(y=y.getTime());const g=Math.round((new Date().getTime()-y)/1e3);if(g<-30)return(0,O.localize)(0,null,a(new Date().getTime()+g*1e3,!1));if(!C&&g<30)return(0,O.localize)(1,null);let l;return g<k?(l=g,S?l===1?m?(0,O.localize)(2,null,l):(0,O.localize)(3,null,l):m?(0,O.localize)(4,null,l):(0,O.localize)(5,null,l):l===1?m?(0,O.localize)(6,null,l):(0,O.localize)(7,null,l):m?(0,O.localize)(8,null,l):(0,O.localize)(9,null,l)):g<D?(l=Math.floor(g/k),S?l===1?m?(0,O.localize)(10,null,l):(0,O.localize)(11,null,l):m?(0,O.localize)(12,null,l):(0,O.localize)(13,null,l):l===1?m?(0,O.localize)(14,null,l):(0,O.localize)(15,null,l):m?(0,O.localize)(16,null,l):(0,O.localize)(17,null,l)):g<A?(l=Math.floor(g/D),S?l===1?m?(0,O.localize)(18,null,l):(0,O.localize)(19,null,l):m?(0,O.localize)(20,null,l):(0,O.localize)(21,null,l):l===1?m?(0,O.localize)(22,null,l):(0,O.localize)(23,null,l):m?(0,O.localize)(24,null,l):(0,O.localize)(25,null,l)):g<x?(l=Math.floor(g/A),S?l===1?(0,O.localize)(26,null,l):(0,O.localize)(27,null,l):l===1?(0,O.localize)(28,null,l):(0,O.localize)(29,null,l)):g<P?(l=Math.floor(g/x),S?l===1?m?(0,O.localize)(30,null,l):(0,O.localize)(31,null,l):m?(0,O.localize)(32,null,l):(0,O.localize)(33,null,l):l===1?m?(0,O.localize)(34,null,l):(0,O.localize)(35,null,l):m?(0,O.localize)(36,null,l):(0,O.localize)(37,null,l)):g<c?(l=Math.floor(g/P),S?l===1?m?(0,O.localize)(38,null,l):(0,O.localize)(39,null,l):m?(0,O.localize)(40,null,l):(0,O.localize)(41,null,l):l===1?m?(0,O.localize)(42,null,l):(0,O.localize)(43,null,l):m?(0,O.localize)(44,null,l):(0,O.localize)(45,null,l)):(l=Math.floor(g/c),S?l===1?m?(0,O.localize)(46,null,l):(0,O.localize)(47,null,l):m?(0,O.localize)(48,null,l):(0,O.localize)(49,null,l):l===1?m?(0,O.localize)(50,null,l):(0,O.localize)(51,null,l):m?(0,O.localize)(52,null,l):(0,O.localize)(53,null,l))}function h(y,S){const m=Math.abs(y/1e3);return m<1?S?(0,O.localize)(54,null,y):(0,O.localize)(55,null,y):m<k?S?(0,O.localize)(56,null,Math.round(y)/1e3):(0,O.localize)(57,null,Math.round(y)/1e3):m<D?S?(0,O.localize)(58,null,Math.round(y/(1e3*k))):(0,O.localize)(59,null,Math.round(y/(1e3*k))):m<A?S?(0,O.localize)(60,null,Math.round(y/(1e3*D))):(0,O.localize)(61,null,Math.round(y/(1e3*D))):(0,O.localize)(62,null,Math.round(y/(1e3*A)))}function E(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ne[81],re([7,4]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,81]),function(K,e,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=c,e.isErrorWithActions=a,e.createErrorWithActions=h;function A(E,y){return y&&(E.stack||E.stacktrace)?D.localize(0,null,P(E),x(E.stack)||x(E.stacktrace)):P(E)}function x(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(1,null,E.message):E.message||D.localize(2,null)}function c(E=null,y=!1){if(!E)return D.localize(3,null);if(Array.isArray(E)){const S=O.coalesce(E),m=c(S[0],y);return S.length>1?D.localize(4,null,m,S.length):m}if(k.isString(E))return E;if(E.detail){const S=E.detail;if(S.error)return A(S.error,y);if(S.exception)return A(S.exception,y)}return E.stack?A(E,y):E.message?E.message:D.localize(5,null)}function a(E){const y=E;return y instanceof Error&&Array.isArray(y.actions)}function h(E,y){let S;return typeof E=="string"?S=new Error(E):S=E,S.actions=y,S}}),define(ne[82],re([7,4]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(ne[83],re([0,1,82]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=k;function k(D){switch(D){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}}),define(ne[56],re([0,1,12]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=A,e.removeDangerousEnvVariables=x;var k;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(k||(e.Source=k={}));var D;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function A(P,...c){const a=c.reduce((y,S)=>(y[S]=!0,y),{}),h=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!a[y]).forEach(y=>{for(let S=0;S<h.length;S++)if(y.search(h[S])!==-1){delete P[y];break}})}function x(P){P&&(delete P.DEBUG,O.isMacintosh&&delete P.DYLD_LIBRARY_PATH,O.isLinux&&delete P.LD_PRELOAD)}}),define(ne[84],re([0,1,11]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=k,e.parse=D,e.getFirstFrame=A,e.log=P;function k(a){const h=a;return h&&typeof h.type=="string"&&typeof h.severity=="string"}function D(a){const h=[];let E;try{const y=JSON.parse(a.arguments),S=y[y.length-1];S&&S.__$stack&&(y.pop(),E=S.__$stack),h.push(...y)}catch{h.push("Unable to log remote console arguments",a.arguments)}return{args:h,stack:E}}function A(a){if(typeof a!="string")return A(D(a).stack);const h=a;if(h){const E=x(h),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(y&&y.length===4)return{uri:O.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}function x(a){if(!a)return a;const h=a.indexOf(`
`);return h===-1?a:a.substring(0,h)}function P(a,h){const{args:E,stack:y}=D(a),S=typeof E[0]=="string"&&E.length===1;let m=x(y);m&&(m=`(${m.trim()})`);let C=[];if(typeof E[0]=="string"?m&&S?C=[`%c[${h}] %c${E[0]} %c${m}`,c("blue"),c(""),c("grey")]:C=[`%c[${h}] %c${E[0]}`,c("blue"),c(""),...E.slice(1)]:C=[`%c[${h}]%`,c("blue"),...E],m&&!S&&C.push(m),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,C)}function c(a){return`color: ${a}`}}),define(ne[47],re([0,1,14,11]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=D,e.parse=A,e.revive=P;function D(c){return JSON.stringify(c,x)}function A(c){let a=JSON.parse(c);return a=P(a),a}function x(c,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function P(c,a=0){if(!c||a>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return k.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 17:return new Date(c.source)}if(c instanceof O.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let h=0;h<c.length;++h)c[h]=P(c[h],a+1);else for(const h in c)Object.hasOwnProperty.call(c,h)&&(c[h]=P(c[h],a+1))}return c}}),define(ne[85],re([0,1,72,15,12,11]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=h;class x{constructor(y,S,m){this.id=y,this.dependencies=S,this.callback=m}}class P{static{this.INSTANCE=new P}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(y,S,m)=>{typeof y!="string"&&(m=S,S=y,y=null),(typeof S!="object"||!Array.isArray(S))&&(m=S,S=null),this._defineCalls.push(new x(y,S,m))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){if(y.startsWith(window.location.origin)||y.startsWith("vscode-file://vscode-app"))return y;throw new Error(`[trusted_script_src] Invalid script url: ${y}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){return y}})))}async load(y){this._initialize();const S=await(this._isWebWorker?this._workerLoadScript(y):this._isRenderer?this._rendererLoadScript(y):this._nodeJSLoadScript(y));if(!S)throw new Error(`Did not receive a define call from script ${y}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${y}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}_rendererLoadScript(y){return new Promise((S,m)=>{const C=document.createElement("script");C.setAttribute("async","async"),C.setAttribute("type","text/javascript");const g=()=>{C.removeEventListener("load",l),C.removeEventListener("error",u)},l=w=>{g(),S(this._defineCalls.pop())},u=w=>{g(),m(w)};C.addEventListener("load",l),C.addEventListener("error",u),this._amdPolicy&&(y=this._amdPolicy.createScriptURL(y)),C.setAttribute("src",y),window.document.getElementsByTagName("head")[0].appendChild(C)})}_workerLoadScript(y){return new Promise((S,m)=>{try{this._amdPolicy&&(y=this._amdPolicy.createScriptURL(y)),importScripts(y),S(this._defineCalls.pop())}catch(C){m(C)}})}async _nodeJSLoadScript(y){try{const S=globalThis._VSCODE_NODE_MODULES.fs,m=globalThis._VSCODE_NODE_MODULES.vm,C=globalThis._VSCODE_NODE_MODULES.module,g=A.URI.parse(y).fsPath,l=S.readFileSync(g).toString(),u=C.wrap(l.replace(/^#!.*/,""));return new m.Script(u).runInThisContext().apply(),this._defineCalls.pop()}catch(S){throw S}}}const c=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function h(E,y,S){if(O.isESM){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[E]&&(E=a[E]);const m=`${E}/${y}`;if(c.has(m))return c.get(m);let C;if(/^\w[\w\d+.-]*:\/\//.test(m))C=m;else{const w=`${S&&!D.isWeb?k.nodeModulesAsarPath:k.nodeModulesPath}/${m}`;C=k.FileAccess.asBrowserUri(w).toString(!0)}const g=P.INSTANCE.load(C);return c.set(m,g),g}else return await new Promise((m,C)=>{K([E],m,C)})}}),define(ne[86],re([0,1,33,48,28,78,12]),function(K,e,O,k,D,A,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=c,e.getSqmMachineId=E,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,S=0;const m=(0,O.networkInterfaces)();for(const C in m){const g=m[C];if(g)for(const{mac:l,internal:u}of g)u||(S+=1,this._isVirtualMachineMacAddress(l.toUpperCase())&&(y+=1))}this._value=S>0?y/S:0}return this._value}};let P;async function c(y){return P||(P=(async()=>await a(y)||D.generateUuid())()),P}async function a(y){try{const S=await new Promise((C,g)=>{K(["crypto"],C,g)}),m=(0,A.getMac)();return S.createHash("sha256").update(m,"utf8").digest("hex")}catch(S){y(S);return}}const h="Software\\Microsoft\\SQMClient";async function E(y){if(x.isWindows){const S=await new Promise((m,C)=>{K(["@vscode/windows-registry"],m,C)});try{return S.GetStringRegKey("HKEY_LOCAL_MACHINE",h,"MachineId")||""}catch(m){return y(m),""}}return""}}),define(ne[87],re([0,1,33,16,25]),function(K,e,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=u,e.getFirstAvailablePowerShellInstallation=w;const A=/^\d+$/,x=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var c;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(c||(c={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let h;process.env.PROCESSOR_ARCHITEW6432?h=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?h=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?h=1:h=0;class E{constructor(v,n,s){this.exePath=v,this.displayName=n,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:p=!1}={}){return p?a===0?process.env["ProgramFiles(x86)"]||null:h===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:p=!1,findPreview:v=!1}={}){const n=y({useAlternateBitness:p});if(!n)return null;const s=k.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let t=-1,i=null;for(const f of await D.Promises.readdir(s)){let b=-1;if(v){const L=f.indexOf("-");if(L<0)continue;const N=f.substring(0,L);if(!A.test(N)||f.substring(L+1)!=="preview")continue;b=parseInt(N,10)}else{if(!A.test(f))continue;b=parseInt(f,10)}if(b<=t)continue;const R=k.join(s,f,"pwsh.exe");await D.SymlinkSupport.existsFile(R)&&(i=R,t=b)}if(!i)return null;const r=n.includes("x86")?" (x86)":"",o=v?" Preview":"";return new E(i,`PowerShell${o}${r}`,!0)}async function m({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const v=k.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(v))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=p?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:x,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(v))if(n.test(t)){const i=k.join(v,t,"pwsh.exe");return new E(i,s)}return null}function C(){const p=k.join(O.homedir(),".dotnet","tools","pwsh.exe");return new E(p,".NET Core PowerShell Global Tool")}function g(){const p=k.join(process.env.windir,a===1&&h!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(p,"Windows PowerShell",!0)}async function*l(){let p=await S();p&&(yield p),p=await S({useAlternateBitness:!0}),p&&(yield p),p=await m(),p&&(yield p),p=C(),p&&(yield p),p=await S({findPreview:!0}),p&&(yield p),p=await m({findPreview:!0}),p&&(yield p),p=await S({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=g(),p&&(yield p)}async function*u(){for await(const p of l())await p.exists()&&(yield p)}async function w(){for await(const p of u())return p;return null}}),define(ne[57],re([0,1,16,12,35,56,3,25]),function(K,e,O,k,D,A,x,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=c,e.createQueuedSender=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function c(E=D.env){return E.comspec||"cmd.exe"}function a(E){let y=[],S=!1;const m=function(C){if(S){y.push(C);return}(!E.send(C,l=>{if(l&&console.error(l),S=!1,y.length>0){const u=y.slice(0);y=[],u.forEach(w=>m(w))}})||k.isWindows)&&(S=!0)};return{send:m}}var h;(function(E){async function y(S,m,C){if(O.isAbsolute(S))return S;if(m===void 0&&(m=D.cwd()),O.dirname(S)!=="."||(C===void 0&&x.isString(D.env.PATH)&&(C=D.env.PATH.split(O.delimiter)),C===void 0||C.length===0))return O.join(m,S);async function l(u){if(await P.Promises.exists(u)){let w;try{w=await P.Promises.stat(u)}catch(p){p.message.startsWith("EACCES")&&(w=await P.Promises.lstat(u))}return w?!w.isDirectory():!1}return!1}for(const u of C){let w;if(O.isAbsolute(u)?w=O.join(u,S):w=O.join(m,u,S),await l(w))return w;let p=w+".com";if(await l(p)||(p=w+".exe",await l(p)))return p}return O.join(m,S)}E.findExecutable=y})(h||(e.win32=h={}))}),define(ne[88],re([0,1,33,12,87,57]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=x;async function x(E,y){return E===1?k.isWindows?h():A.getWindowsShell(y):c(E,y)}let P=null;function c(E,y){if(k.isLinux&&E===2||k.isMacintosh&&E===3)return"/bin/bash";if(!P){let S;if(k.isWindows)S="/bin/bash";else{if(S=y.SHELL,!S)try{S=(0,O.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}P=S}return P}let a=null;async function h(){return a||(a=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),a}});var ve=this&&this.__decorate||function(K,e,O,k){var D=arguments.length,A=D<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,O):k,x;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(K,e,O,k);else for(var P=K.length-1;P>=0;P--)(x=K[P])&&(A=(D<3?x(A):D>3?x(e,O,A):x(e,O))||A);return D>3&&A&&Object.defineProperty(e,O,A),A};define(ne[58],re([0,1,19,8,14,20,54,9,5,2,47,31,3]),function(K,e,O,k,D,A,x,P,c,a,h,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=o,e.deserialize=f,e.getDelayedChannel=V,e.getNextTickChannel=H;var S;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(S||(S={}));function m(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(C||(C={}));function g(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(l||(l={}));function u(z){let W=0;for(let q=0;;q+=7){const X=z.read(1);if(W|=(X.buffer[0]&127)<<q,!(X.buffer[0]&128))return W}}const w=t(0);function p(z,W){if(W===0){z.write(w);return}let q=0;for(let J=W;J!==0;J=J>>>7)q++;const X=D.VSBuffer.alloc(q);for(let J=0;W!==0;J++)X.buffer[J]=W&127,W=W>>>7,W>0&&(X.buffer[J]|=128);z.write(X)}class v{constructor(W){this.buffer=W,this.pos=0}read(W){const q=this.buffer.slice(this.pos,this.pos+W);return this.pos+=q.byteLength,q}}e.BufferReader=v;class n{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}e.BufferWriter=n;var s;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(s||(s={}));function t(z){const W=D.VSBuffer.alloc(1);return W.writeUInt8(z,0),W}const i={Undefined:t(s.Undefined),String:t(s.String),Buffer:t(s.Buffer),VSBuffer:t(s.VSBuffer),Array:t(s.Array),Object:t(s.Object),Uint:t(s.Int)},r=typeof Buffer<"u";function o(z,W){if(typeof W>"u")z.write(i.Undefined);else if(typeof W=="string"){const q=D.VSBuffer.fromString(W);z.write(i.String),p(z,q.byteLength),z.write(q)}else if(r&&Buffer.isBuffer(W)){const q=D.VSBuffer.wrap(W);z.write(i.Buffer),p(z,q.byteLength),z.write(q)}else if(W instanceof D.VSBuffer)z.write(i.VSBuffer),p(z,W.byteLength),z.write(W);else if(Array.isArray(W)){z.write(i.Array),p(z,W.length);for(const q of W)o(z,q)}else if(typeof W=="number"&&(W|0)===W)z.write(i.Uint),p(z,W);else{const q=D.VSBuffer.fromString(JSON.stringify(W));z.write(i.Object),p(z,q.byteLength),z.write(q)}}function f(z){switch(z.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return z.read(u(z)).toString();case s.Buffer:return z.read(u(z)).buffer;case s.VSBuffer:return z.read(u(z));case s.Array:{const q=u(z),X=[];for(let J=0;J<q;J++)X.push(f(z));return X}case s.Object:return JSON.parse(z.read(u(z)).toString());case s.Int:return u(z)}}class b{constructor(W,q,X=null,J=1e3){this.protocol=W,this.ctx=q,this.logger=X,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(W,q){this.channels.set(W,q),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const q=this.send([W.type]);this.logger?.logOutgoing(q,0,1,g(W.type));return}case 201:case 202:case 204:case 203:{const q=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(q,W.id,1,g(W.type),W.data);return}}}send(W,q=void 0){const X=new n;return o(X,W),o(X,q),this.sendBuffer(X.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const q=new v(W),X=f(q),J=f(q),Z=X[0];switch(Z){case 100:return this.logger?.logIncoming(W.byteLength,X[1],1,`${m(Z)}: ${X[2]}.${X[3]}`,J),this.onPromise({type:Z,id:X[1],channelName:X[2],name:X[3],arg:J});case 102:return this.logger?.logIncoming(W.byteLength,X[1],1,`${m(Z)}: ${X[2]}.${X[3]}`,J),this.onEventListen({type:Z,id:X[1],channelName:X[2],name:X[3],arg:J});case 101:return this.logger?.logIncoming(W.byteLength,X[1],1,`${m(Z)}`),this.disposeActiveRequest({type:Z,id:X[1]});case 103:return this.logger?.logIncoming(W.byteLength,X[1],1,`${m(Z)}`),this.disposeActiveRequest({type:Z,id:X[1]})}}onPromise(W){const q=this.channels.get(W.channelName);if(!q){this.collectPendingRequest(W);return}const X=new A.CancellationTokenSource;let J;try{J=q.call(this.ctx,W.name,W.arg,X.token)}catch(M){J=Promise.reject(M)}const Z=W.id;J.then(M=>{this.sendResponse({id:Z,data:M,type:201})},M=>{M instanceof Error?this.sendResponse({id:Z,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.sendResponse({id:Z,data:M,type:203})}).finally(()=>{F.dispose(),this.activeRequests.delete(W.id)});const F=(0,a.toDisposable)(()=>X.cancel());this.activeRequests.set(W.id,F)}onEventListen(W){const q=this.channels.get(W.channelName);if(!q){this.collectPendingRequest(W);return}const X=W.id,Z=q.listen(this.ctx,W.name,W.arg)(F=>this.sendResponse({id:X,data:F,type:204}));this.activeRequests.set(W.id,Z)}disposeActiveRequest(W){const q=this.activeRequests.get(W.id);q&&(q.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let q=this.pendingRequests.get(W.channelName);q||(q=[],this.pendingRequests.set(W.channelName,q));const X=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:W,timeoutTimer:X})}flushPendingRequests(W){const q=this.pendingRequests.get(W);if(q){for(const X of q)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.onPromise(X.request);break;case 102:this.onEventListen(X.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=b;var R;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class L{constructor(W,q=null){this.protocol=W,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(X=>this.onBuffer(X)),this.logger=q}getChannel(W){const q=this;return{call(X,J,Z){return q.isDisposed?Promise.reject(new P.CancellationError):q.requestPromise(W,X,J,Z)},listen(X,J){return q.isDisposed?c.Event.None:q.requestEvent(W,X,J)}}}requestPromise(W,q,X,J=A.CancellationToken.None){const Z=this.lastRequestId++,M={id:Z,type:100,channelName:W,name:q,arg:X};if(J.isCancellationRequested)return Promise.reject(new P.CancellationError);let d;return new Promise((T,U)=>{if(J.isCancellationRequested)return U(new P.CancellationError);const G=()=>{const ue=me=>{switch(me.type){case 201:this.handlers.delete(Z),T(me.data);break;case 202:{this.handlers.delete(Z);const ye=new Error(me.data.message);ye.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,ye.name=me.data.name,U(ye);break}case 203:this.handlers.delete(Z),U(me.data);break}};this.handlers.set(Z,ue),this.sendRequest(M)};let B=null;this.state===l.Idle?G():(B=(0,k.createCancelablePromise)(ue=>this.whenInitialized()),B.then(()=>{B=null,G()}));const te=()=>{B?(B.cancel(),B=null):this.sendRequest({id:Z,type:101}),U(new P.CancellationError)},ae=J.onCancellationRequested(te);d=(0,a.combinedDisposable)((0,a.toDisposable)(te),ae),this.activeRequests.add(d)}).finally(()=>{d.dispose(),this.activeRequests.delete(d)})}requestEvent(W,q,X){const J=this.lastRequestId++,F={id:J,type:102,channelName:W,name:q,arg:X};let M=null;const d=new c.Emitter({onWillAddFirstListener:()=>{M=(0,k.createCancelablePromise)(T=>this.whenInitialized()),M.then(()=>{M=null,this.activeRequests.add(d),this.sendRequest(F)})},onDidRemoveLastListener:()=>{M?(M.cancel(),M=null):(this.activeRequests.delete(d),this.sendRequest({id:J,type:103}))}}),I=T=>d.fire(T.data);return this.handlers.set(J,I),d.event}sendRequest(W){switch(W.type){case 100:case 102:{const q=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger?.logOutgoing(q,W.id,0,`${m(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const q=this.send([W.type,W.id]);this.logger?.logOutgoing(q,W.id,0,m(W.type));return}}}send(W,q=void 0){const X=new n;return o(X,W),o(X,q),this.sendBuffer(X.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const q=new v(W),X=f(q),J=f(q),Z=X[0];switch(Z){case 200:return this.logger?.logIncoming(W.byteLength,0,0,g(Z)),this.onResponse({type:X[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(W.byteLength,X[1],0,g(Z),J),this.onResponse({type:X[0],id:X[1],data:J})}}onResponse(W){if(W.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(W.id)?.(W)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=L,ve([x.memoize],L.prototype,"onDidInitializePromise",null);class N{get connections(){const W=[];return this._connections.forEach(q=>W.push(q)),W}constructor(W,q,X){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new a.DisposableStore,this.disposables.add(W(({protocol:J,onDidClientDisconnect:Z})=>{const F=c.Event.once(J.onMessage);this.disposables.add(F(M=>{const d=new v(M),I=f(d),T=new b(J,I,q,X),U=new L(J,q);this.channels.forEach((B,te)=>T.registerChannel(te,B));const G={channelServer:T,channelClient:U,ctx:I};this._connections.add(G),this._onDidAddConnection.fire(G),this.disposables.add(Z(()=>{T.dispose(),U.dispose(),this._connections.delete(G),this._onDidRemoveConnection.fire(G)}))}))}))}getChannel(W,q){const X=this;return{call(J,Z,F){let M;if((0,y.isFunction)(q)){const I=(0,O.getRandomElement)(X.connections.filter(q));M=I?Promise.resolve(I):c.Event.toPromise(c.Event.filter(X.onDidAddConnection,q))}else M=q.routeCall(X,J,Z);const d=M.then(I=>I.channelClient.getChannel(W));return V(d).call(J,Z,F)},listen(J,Z){if((0,y.isFunction)(q))return X.getMulticastEvent(W,q,J,Z);const F=q.routeEvent(X,J,Z).then(M=>M.channelClient.getChannel(W));return V(F).listen(J,Z)}}}getMulticastEvent(W,q,X,J){const Z=this;let F;const M=new c.Emitter({onWillAddFirstListener:()=>{F=new a.DisposableStore;const d=new c.EventMultiplexer,I=new Map,T=G=>{const te=G.channelClient.getChannel(W).listen(X,J),ae=d.add(te);I.set(G,ae)},U=G=>{const B=I.get(G);B&&(B.dispose(),I.delete(G))};Z.connections.filter(q).forEach(T),c.Event.filter(Z.onDidAddConnection,q)(T,void 0,F),Z.onDidRemoveConnection(U,void 0,F),d.event(M.fire,M,F),F.add(d)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return M.event}registerChannel(W,q){this.channels.set(W,q);for(const X of this._connections)X.channelServer.registerChannel(W,q)}dispose(){this.disposables.dispose();for(const W of this._connections)W.channelClient.dispose(),W.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=N;class _{constructor(W,q,X=null){const J=new n;o(J,q),W.send(J.buffer),this.channelClient=new L(W,X),this.channelServer=new b(W,q,X)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,q){this.channelServer.registerChannel(W,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function V(z){return{call(W,q,X){return z.then(J=>J.call(W,q,X))},listen(W,q){const X=new c.Relay;return z.then(J=>X.input=J.listen(W,q)),X.event}}}function H(z){let W=!1;return{call(q,X,J){return W?z.call(q,X,J):(0,k.timeout)(0).then(()=>W=!0).then(()=>z.call(q,X,J))},listen(q,X){if(W)return z.listen(q,X);const J=new c.Relay;return(0,k.timeout)(0).then(()=>W=!0).then(()=>J.input=z.listen(q,X)),J.event}}}class se{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const q of W.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await c.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=se;var ie;(function(z){function W(Z,F,M){const d=Z,I=M&&M.disableMarshalling,T=new Map;for(const U in d)X(U)&&T.set(U,c.Event.buffer(d[U],!0,void 0,F));return new class{listen(U,G,B){const te=T.get(G);if(te)return te;const ae=d[G];if(typeof ae=="function"){if(J(G))return ae.call(d,B);if(X(G))return T.set(G,c.Event.buffer(d[G],!0,void 0,F)),T.get(G)}throw new P.ErrorNoTelemetry(`Event not found: ${G}`)}call(U,G,B){const te=d[G];if(typeof te=="function"){if(!I&&Array.isArray(B))for(let ue=0;ue<B.length;ue++)B[ue]=(0,h.revive)(B[ue]);let ae=te.apply(d,B);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new P.ErrorNoTelemetry(`Method not found: ${G}`)}}}z.fromService=W;function q(Z,F){const M=F&&F.disableMarshalling;return new Proxy({},{get(d,I){if(typeof I=="string")return F?.properties?.has(I)?F.properties.get(I):J(I)?function(T){return Z.listen(I,T)}:X(I)?Z.listen(I):async function(...T){let U;F&&!(0,y.isUndefinedOrNull)(F.context)?U=[F.context,...T]:U=T;const G=await Z.call(I,U);return M?G:(0,h.revive)(G)};throw new P.ErrorNoTelemetry(`Property not found: ${String(I)}`)}})}z.toService=q;function X(Z){return Z[0]==="o"&&Z[1]==="n"&&E.isUpperAsciiLetter(Z.charCodeAt(2))}function J(Z){return/^onDynamic/.test(Z)&&E.isUpperAsciiLetter(Z.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const W=z.toString();if(W!=="[object Object]")return W}return z}function le(z){return Array.isArray(z)?z.map(ce):ce(z)}function j(z,W,q,X,J,Z,F){F=le(F);const M=fe[J],d=M[X%M.length];let I=[`%c[${z}]%c[${String(W).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(Z)?(I=I.concat(F),I.push(")")):I.push(F),console.log.apply(console,I)}class Y{constructor(W,q){this._outgoingPrefix=W,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,q,X,J,Z){this._totalOutgoing+=W,j(this._outgoingPrefix,this._totalOutgoing,W,q,X,J,Z)}logIncoming(W,q,X,J,Z){this._totalIncoming+=W,j(this._incomingPrefix,this._totalIncoming,W,q,X,J,Z)}}e.IPCLogger=Y}),define(ne[89],re([0,1,59,8,14,20,84,9,5,2,27,57,56,58]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends S.ChannelServer{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",u=>D.VSBuffer.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=m;class C{constructor(l,u){this.modulePath=l,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new k.Delayer(w),this.child=null,this._client=null}getChannel(l){const u=this;return{call(w,p,v){return u.requestPromise(l,w,p,v)},listen(w,p){return u.requestEvent(l,w,p)}}}requestPromise(l,u,w,p=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const v=this.getCachedChannel(l),n=(0,k.createCancelablePromise)(i=>v.call(u,w,i)),s=p.onCancellationRequested(()=>n.cancel()),t=(0,a.toDisposable)(()=>n.cancel());return this.activeRequests.add(t),n.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(l,u,w){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let p;const v=new c.Emitter({onWillAddFirstListener:()=>{p=this.getCachedChannel(l).listen(u,w)(v.fire,v),this.activeRequests.add(p)},onDidRemoveLastListener:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return v.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,h.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,y.removeDangerousEnvVariables)(u.env),this.child=(0,O.fork)(this.modulePath,l,u);const w=new c.Emitter,v=c.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,x.isRemoteConsoleLog)(o)){(0,x.log)(o,`IPC Library: ${this.options.serverName}`);return}w.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))}),n=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,s=o=>this.child&&this.child.connected&&n.send(o.buffer.toString("base64")),t=w.event,i={send:s,onMessage:t};this._client=new S.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,f)=>{process.removeListener("exit",r),v.dispose(),this.activeRequests.forEach(b=>(0,a.dispose)(b)),this.activeRequests.clear(),o!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+f),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:f})})}return this._client}getCachedChannel(l){let u=this.channels.get(l);return u||(u=this.client.getChannel(l),this.channels.set(l,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(ne[90],re([0,1,8,5,2,47,3]),function(K,e,O,k,D,A,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=c;var P;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function c(y){const S=y;return S?.changed instanceof Map||S?.deleted instanceof Set}var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class h extends D.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(S,m=Object.create(null)){super(),this.database=S,this.options=m,this._onDidChangeStorage=this._register(new k.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new O.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){this._onDidChangeStorage.pause();try{S.changed?.forEach((m,C)=>this.acceptExternal(C,m)),S.deleted?.forEach(m=>this.acceptExternal(m,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(S,m){if(this.state===a.Closed)return;let C=!1;(0,x.isUndefinedOrNull)(m)?C=this.cache.delete(S):this.cache.get(S)!==m&&(this.cache.set(S,m),C=!0),C&&this._onDidChangeStorage.fire({key:S,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,m){const C=this.cache.get(S);return(0,x.isUndefinedOrNull)(C)?m:C}getBoolean(S,m){const C=this.get(S);return(0,x.isUndefinedOrNull)(C)?m:C==="true"}getNumber(S,m){const C=this.get(S);return(0,x.isUndefinedOrNull)(C)?m:parseInt(C,10)}getObject(S,m){const C=this.get(S);return(0,x.isUndefinedOrNull)(C)?m:(0,A.parse)(C)}async set(S,m,C=!1){if(this.state===a.Closed)return;if((0,x.isUndefinedOrNull)(m))return this.delete(S,C);const g=(0,x.isObject)(m)||Array.isArray(m)?(0,A.stringify)(m):String(m);if(this.cache.get(S)!==g)return this.cache.set(S,g),this.pendingInserts.set(S,g),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire({key:S,external:C}),this.doFlush()}async delete(S,m=!1){if(!(this.state===a.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire({key:S,external:m}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(this.hasPending)return this.doFlush(S)}async doFlush(S){return this.options.hint===P.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}isInMemory(){return this.options.hint===P.STORAGE_IN_MEMORY}}e.Storage=h;class E{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((m,C)=>this.items.set(C,m)),S.delete?.forEach(m=>this.items.delete(m))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=E}),define(ne[91],re([7,4]),function(K,e){return K.create("vs/base/node/zip",e)}),define(ne[49],re([0,1,60,8,16,3,25,91]),function(K,e,O,k,D,A,x,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=g,e.extract=l,e.buffer=w,e.CorruptZipMessage="end of central directory record signature not found";const c=new RegExp(e.CorruptZipMessage);class a extends Error{constructor(v,n){let s=n.message;switch(v){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=v,this.cause=n}}e.ExtractError=a;function h(p){const v=p.externalFileAttributes>>16||33188;return[448,56,7].map(n=>v&n).reduce((n,s)=>n+s,v&61440)}function E(p){if(p instanceof a)return p;let v;return c.test(p.message)&&(v="CorruptZip"),new a(v,p)}function y(p,v,n,s,t,i){const r=D.dirname(v),o=D.join(s,r);if(!o.startsWith(s))return Promise.reject(new Error(P.localize(0,null,v)));const f=D.join(s,v);let b;return i.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(x.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((R,L)=>{if(!i.isCancellationRequested)try{b=(0,O.createWriteStream)(f,{mode:n}),b.once("close",()=>R()),b.once("error",L),p.once("error",L),p.pipe(b)}catch(N){L(N)}}))}function S(p,v,n,s){let t=(0,k.createCancelablePromise)(()=>Promise.resolve()),i=0;const r=s.onCancellationRequested(()=>{t.cancel(),p.close()});return new Promise((o,f)=>{const b=new k.Sequencer,R=L=>{L.isCancellationRequested||(i++,p.readEntry())};p.once("error",f),p.once("close",()=>t.then(()=>{s.isCancellationRequested||p.entryCount===i?o():f(new a("Incomplete",new Error(P.localize(1,null,i,p.entryCount))))},f)),p.readEntry(),p.on("entry",L=>{if(s.isCancellationRequested)return;if(!n.sourcePathRegex.test(L.fileName)){R(s);return}const N=L.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(N)){const H=D.join(v,N);t=(0,k.createCancelablePromise)(se=>x.Promises.mkdir(H,{recursive:!0}).then(()=>R(se)).then(void 0,f));return}const _=C(p,L),V=h(L);t=(0,k.createCancelablePromise)(H=>b.queue(()=>_.then(se=>y(se,N,V,v,n,H).then(()=>R(H)))).then(null,f))})}).finally(()=>r.dispose())}async function m(p,v=!1){const{open:n}=await new Promise((s,t)=>{K(["yauzl"],s,t)});return new Promise((s,t)=>{n(p,v?{lazyEntries:!0}:void 0,(i,r)=>{i?t(E(i)):s((0,A.assertIsDefined)(r))})})}function C(p,v){return new Promise((n,s)=>{p.openReadStream(v,(t,i)=>{t?s(E(t)):n((0,A.assertIsDefined)(i))})})}async function g(p,v){const{ZipFile:n}=await new Promise((s,t)=>{K(["yazl"],s,t)});return new Promise((s,t)=>{const i=new n;v.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const r=(0,O.createWriteStream)(p);i.outputStream.pipe(r),i.outputStream.once("error",t),r.once("error",t),r.once("finish",()=>s(p))})}function l(p,v,n={},s){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let i=m(p,!0);return n.overwrite&&(i=i.then(r=>x.Promises.rm(v).then(()=>r))),i.then(r=>S(r,v,{sourcePathRegex:t},s))}function u(p,v){return m(p).then(n=>new Promise((s,t)=>{n.on("entry",i=>{i.fileName===v&&C(n,i).then(r=>s(r),r=>t(r))}),n.once("close",()=>t(new Error(P.localize(2,null,v))))}))}function w(p,v){return u(p,v).then(n=>new Promise((s,t)=>{const i=[];n.once("error",t),n.on("data",r=>i.push(r)),n.on("end",()=>s(Buffer.concat(i)))}))}}),define(ne[92],re([7,4]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[93],re([7,4]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[94],re([7,4]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(ne[95],re([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[96],re([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[97],re([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[98],re([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[99],re([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[100],re([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[101],re([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[102],re([7,4]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[103],re([7,4]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(ne[104],re([7,4]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(ne[105],re([7,4]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[106],re([7,4]),function(K,e){return K.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[107],re([7,4]),function(K,e){return K.create("vs/platform/log/common/log",e)}),define(ne[108],re([7,4]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(ne[109],re([7,4]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(ne[110],re([7,4]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[111],re([7,4]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[112],re([7,4]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(ne[113],re([0,1,9,94]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var D;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(D||(e.TokenType=D={}));function A(...a){switch(a.length){case 1:return(0,k.localize)(0,null,a[0]);case 2:return(0,k.localize)(1,null,a[0],a[1]);case 3:return(0,k.localize)(2,null,a[0],a[1],a[2]);default:return}}const x=(0,k.localize)(3,null),P=(0,k.localize)(4,null);class c{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return h.isTripleEq?"===":"==";case 4:return h.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return h.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return h.lexeme;case 18:return h.lexeme;case 19:return h.lexeme;case 20:return"EOF";default:throw(0,O.illegalState)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(h){return this._input=h,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const E=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:E})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const E=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:E})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(h){return this._isAtEnd()||this._input.charCodeAt(this._current)!==h?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(h){this._tokens.push({type:h,offset:this._start})}_error(h){const E=this._start,y=this._input.substring(this._start,this._current),S={type:19,offset:this._start,lexeme:y};this._errors.push({offset:E,lexeme:y,additionalInfo:h}),this._tokens.push(S)}_string(){this.stringRe.lastIndex=this._start;const h=this.stringRe.exec(this._input);if(h){this._current=this._start+h[0].length;const E=this._input.substring(this._start,this._current),y=c._keywords.get(E);y?this._addToken(y):this._tokens.push({type:17,lexeme:E,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(x);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let h=this._current,E=!1,y=!1;for(;;){if(h>=this._input.length){this._current=h,this._error(P);return}const m=this._input.charCodeAt(h);if(E)E=!1;else if(m===47&&!y){h++;break}else m===91?y=!0:m===92?E=!0:m===93&&(y=!1);h++}for(;h<this._input.length&&c._regexFlags.has(this._input.charCodeAt(h));)h++;this._current=h;const S=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:S,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=c}),define(ne[114],re([0,1,80,54,15,16,35,17,11]),function(K,e,O,k,D,A,x,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=h,e.parseDebugParams=E,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,A.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const S=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",S)}return c.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(c.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=x.env.VSCODE_PORTABLE;return S?c.URI.file((0,A.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,A.resolve)(S):(0,A.normalize)((0,A.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const S=this.args["extensions-download-dir"];return S?c.URI.file((0,A.resolve)(S)):c.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,A.resolve)(S);const m=x.env.VSCODE_EXTENSIONS;if(m)return m;const C=x.env.VSCODE_PORTABLE;return C?(0,A.join)(C,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(m=>/^[^:/?#]+?:\/\//.test(m)?c.URI.parse(m):c.URI.file((0,A.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?c.URI.parse(S):c.URI.file((0,A.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return h(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!x.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(S=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(S))}get extensionLogLevel(){const S=[];for(const m of this.args.log||[]){const C=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(m);C&&C[1]&&C[2]&&S.push([C[1],C[2]])}return S.length?S:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=x.env.VSCODE_PORTABLE;return S?c.URI.file((0,A.join)(S,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(S){this.args.continueOn=S}get args(){return this._args}constructor(S,m,C){this._args=S,this.paths=m,this.productService=C,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=a,ve([k.memoize],a.prototype,"appRoot",null),ve([k.memoize],a.prototype,"userHome",null),ve([k.memoize],a.prototype,"userDataPath",null),ve([k.memoize],a.prototype,"appSettingsHome",null),ve([k.memoize],a.prototype,"tmpDir",null),ve([k.memoize],a.prototype,"cacheHome",null),ve([k.memoize],a.prototype,"stateResource",null),ve([k.memoize],a.prototype,"userRoamingDataHome",null),ve([k.memoize],a.prototype,"userDataSyncHome",null),ve([k.memoize],a.prototype,"sync",null),ve([k.memoize],a.prototype,"machineSettingsResource",null),ve([k.memoize],a.prototype,"workspaceStorageHome",null),ve([k.memoize],a.prototype,"localHistoryHome",null),ve([k.memoize],a.prototype,"keyboardLayoutResource",null),ve([k.memoize],a.prototype,"argvResource",null),ve([k.memoize],a.prototype,"isExtensionDevelopment",null),ve([k.memoize],a.prototype,"untitledWorkspacesHome",null),ve([k.memoize],a.prototype,"builtinExtensionsPath",null),ve([k.memoize],a.prototype,"extensionsPath",null),ve([k.memoize],a.prototype,"extensionDevelopmentLocationURI",null),ve([k.memoize],a.prototype,"extensionDevelopmentKind",null),ve([k.memoize],a.prototype,"extensionTestsLocationURI",null),ve([k.memoize],a.prototype,"debugExtensionHost",null),ve([k.memoize],a.prototype,"logLevel",null),ve([k.memoize],a.prototype,"extensionLogLevel",null),ve([k.memoize],a.prototype,"serviceMachineIdResource",null),ve([k.memoize],a.prototype,"disableTelemetry",null),ve([k.memoize],a.prototype,"disableWorkspaceTrust",null),ve([k.memoize],a.prototype,"useInMemorySecretStorage",null),ve([k.memoize],a.prototype,"policyFile",null);function h(y,S){return E(y["inspect-extensions"],y["inspect-brk-extensions"],5870,S,y.debugId,y.extensionEnvironment)}function E(y,S,m,C,g,l){const w=Number(S||y)||(C?null:m),p=w?!!S:!1;let v;if(l)try{v=JSON.parse(l)}catch{}return{port:w,break:p,debugId:g,env:v}}}),function(){"use strict";function K(e,O,k){function D(x,P){const c=A(x,P),a=[c];return e.isAbsolute(c)||a.unshift(k),e.resolve(...a)}function A(x,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const c=process.env.VSCODE_PORTABLE;if(c)return e.join(c,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const h=x["user-data-dir"];if(h)return h;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(E,"AppData","Roaming")}break;case"darwin":a=e.join(O.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:D}}if(typeof define=="function")define(ne[115],re([170,33,35]),function(e,O,k){return K(e,O,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=K(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[116],re([0,1,33,114,115]),function(K,e,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=x,e.parseSharedProcessDebugPort=P;class A extends k.AbstractNativeEnvironmentService{constructor(a,h){super(a,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,D.getUserDataPath)(a,h.nameShort)},h)}}e.NativeEnvironmentService=A;function x(c,a){return(0,k.parseDebugParams)(c["inspect-ptyhost"],c["inspect-brk-ptyhost"],5877,a,c.extensionEnvironment)}function P(c,a){return(0,k.parseDebugParams)(c["inspect-sharedprocess"],c["inspect-brk-sharedprocess"],5879,a,c.extensionEnvironment)}}),define(ne[117],re([0,1,3,98]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=D;function D(x,P,c,a){try{A(x,P,c,a)}catch(h){x.error(h?.message??h)}return P}function A(x,P,c,a){const h=(E,y,S)=>{const m=E[y];if((0,O.isString)(m)){const C=m,g=C.length;if(g>1&&C[0]==="%"&&C[g-1]==="%"){const l=C.substr(1,g-2);let u=c[l];u===void 0&&a&&(u=a[l]);const w=typeof u=="string"?u:u?.message,p=a?.[l],v=typeof p=="string"?p:p?.message;if(!w){v||x.warn(`[${P.name}]: ${(0,k.localize)(0,null,l)}`);return}if(S&&(y==="title"||y==="category")&&v&&v!==w){const n={value:w,original:v};E[y]=n}else E[y]=w}}else if((0,O.isObject)(m))for(const C in m)m.hasOwnProperty(C)&&(C==="commands"?h(m,C,!0):h(m,C,S));else if(Array.isArray(m))for(let C=0;C<m.length;C++)h(m,C,S)};for(const E in P)P.hasOwnProperty(E)&&h(P,E)}}),define(ne[118],re([0,1,49,101]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=D;function D(A){return(0,O.buffer)(A,"extension/package.json").then(x=>{try{return JSON.parse(x.toString("utf8"))}catch{throw new Error((0,k.localize)(0,null))}})}}),define(ne[50],re([0,1,17,55,102,44]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=c,e.parseVersion=a,e.normalizeVersion=h,e.isValidVersion=E,e.validateExtensionManifest=y,e.isValidExtensionVersion=S,e.isEngineValid=m;const x=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function c(l){return l=l.trim(),l==="*"||x.test(l)}function a(l){if(!c(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(x);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}function h(l){if(!l)return null;const u=l.majorBase,w=l.majorMustEqual,p=l.minorBase;let v=l.minorMustEqual;const n=l.patchBase;let s=l.patchMustEqual;l.hasCaret&&(u===0||(v=!1),s=!1);let t=0;if(l.preRelease){const i=P.exec(l.preRelease);if(i){const[,r,o,f]=i;t=Date.UTC(Number(r),Number(o)-1,Number(f))}}return{majorBase:u,majorMustEqual:w,minorBase:p,minorMustEqual:v,patchBase:n,patchMustEqual:s,isMinimum:l.hasGreaterEquals,notBefore:t}}function E(l,u,w){let p;typeof l=="string"?p=h(a(l)):p=l;let v;u instanceof Date?v=u.getTime():typeof u=="string"&&(v=new Date(u).getTime());let n;if(typeof w=="string"?n=h(a(w)):n=w,!p||!n)return!1;const s=p.majorBase,t=p.minorBase,i=p.patchBase;let r=n.majorBase,o=n.minorBase,f=n.patchBase;const b=n.notBefore;let R=n.majorMustEqual,L=n.minorMustEqual,N=n.patchMustEqual;return n.isMinimum?s>r?!0:s<r?!1:t>o?!0:t<o||v&&v<b?!1:i>=f:(s===1&&r===0&&(!R||!L||!N)&&(r=1,o=0,f=0,R=!0,L=!1,N=!1),s<r?!1:s>r?!R:t<o?!1:t>o?!L:i<f?!1:i>f?!N:!(v&&v<b))}function y(l,u,w,p,v){const n=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return n.push([k.default.Error,D.localize(0,null)]),n;if(typeof p.name!="string")return n.push([k.default.Error,D.localize(1,null,"name")]),n;if(typeof p.version!="string")return n.push([k.default.Error,D.localize(2,null,"version")]),n;if(!p.engines)return n.push([k.default.Error,D.localize(3,null,"engines")]),n;if(typeof p.engines.vscode!="string")return n.push([k.default.Error,D.localize(4,null,"engines.vscode")]),n;if(typeof p.extensionDependencies<"u"&&!g(p.extensionDependencies))return n.push([k.default.Error,D.localize(5,null,"extensionDependencies")]),n;if(typeof p.activationEvents<"u"){if(!g(p.activationEvents))return n.push([k.default.Error,D.localize(6,null,"activationEvents")]),n;if(typeof p.main>"u"&&typeof p.browser>"u")return n.push([k.default.Error,D.localize(7,null,"activationEvents","main","browser")]),n}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&n.push([k.default.Warning,D.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return n.push([k.default.Error,D.localize(9,null,"main")]),n;{const i=(0,O.joinPath)(w,p.main);(0,O.isEqualOrParent)(i,w)||n.push([k.default.Warning,D.localize(10,null,i.path,w.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return n.push([k.default.Error,D.localize(11,null,"browser")]),n;{const i=(0,O.joinPath)(w,p.browser);(0,O.isEqualOrParent)(i,w)||n.push([k.default.Warning,D.localize(12,null,i.path,w.path)])}}if(!A.valid(p.version))return n.push([k.default.Error,D.localize(13,null)]),n;const s=[];if(!S(l,u,p,v,s))for(const i of s)n.push([k.default.Error,i]);return n}function S(l,u,w,p,v){return p||typeof w.main>"u"&&typeof w.browser>"u"?!0:C(l,u,w.engines.vscode,v)}function m(l,u,w){return l==="*"||C(u,w,l)}function C(l,u,w,p=[]){const v=h(a(w));if(!v)return p.push(D.localize(14,null,w)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return p.push(D.localize(15,null,w)),!1}else if(!v.majorMustEqual)return p.push(D.localize(16,null,w)),!1;return E(l,u,v)?!0:(p.push(D.localize(17,null,l,w)),!1)}function g(l){if(!Array.isArray(l))return!1;for(let u=0,w=l.length;u<w;u++)if(typeof l[u]!="string")return!1;return!0}}),define(ne[119],re([0,1,14,28]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=D;async function D(A,x,P){let c=P&&P.get("storage.serviceMachineId",-1)||null;if(c)return c;try{const h=(await x.readFile(A.serviceMachineIdResource)).value.toString();c=(0,k.isUUID)(h)?h:null}catch{c=null}if(!c){c=(0,k.generateUuid)();try{await x.writeFile(A.serviceMachineIdResource,O.VSBuffer.fromString(c))}catch{}}return P?.store("storage.serviceMachineId",c,-1,1),c}}),define(ne[51],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class O{constructor(D,A=[],x=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=x}}e.SyncDescriptor=O}),define(ne[120],re([0,1,51]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=A,e.getSingletonServiceDescriptors=x;const k=[];var D;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function A(P,c,a){c instanceof O.SyncDescriptor||(c=new O.SyncDescriptor(c,[],!!a)),k.push([P,c])}function x(){return k}}),define(ne[121],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class O{constructor(A,x){this.key=A,this.data=x,this.incoming=new Map,this.outgoing=new Map}}e.Node=O;class k{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const x of this._nodes.values())x.outgoing.size===0&&A.push(x);return A}insertEdge(A,x){const P=this.lookupOrInsertNode(A),c=this.lookupOrInsertNode(x);P.outgoing.set(c.key,c),c.incoming.set(P.key,P)}removeNode(A){const x=this._hashFn(A);this._nodes.delete(x);for(const P of this._nodes.values())P.outgoing.delete(x),P.incoming.delete(x)}lookupOrInsertNode(A){const x=this._hashFn(A);let P=this._nodes.get(x);return P||(P=new O(x,A),this._nodes.set(x,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[x,P]of this._nodes)A.push(`${x}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,x]of this._nodes){const P=new Set([A]),c=this._findCycle(x,P);if(c)return c}}_findCycle(A,x){for(const[P,c]of A.outgoing){if(x.has(P))return[...x,P].join(" -> ");x.add(P);const a=this._findCycle(c,x);if(a)return a;x.delete(P)}}}e.Graph=k}),define(ne[29],re([0,1,3,11,10]),function(K,e,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=A,e.isConfigurationUpdateOverrides=x,e.ConfigurationTargetToString=c,e.isConfigured=a,e.toValuesTree=h,e.addToValueTree=E,e.removeFromValueTree=y,e.getConfigurationValue=m,e.merge=C,e.getLanguageTagSettingPlainKey=g,e.IConfigurationService=(0,D.createDecorator)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof k.URI)}function x(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof k.URI)}var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function c(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function h(l,u){const w=Object.create(null);for(const p in l)E(w,p,l[p],u);return w}function E(l,u,w,p){const v=u.split("."),n=v.pop();let s=l;for(let t=0;t<v.length;t++){const i=v[t];let r=s[i];switch(typeof r){case"undefined":r=s[i]=Object.create(null);break;case"object":if(r===null){p(`Ignoring ${u} as ${v.slice(0,t+1).join(".")} is null`);return}break;default:p(`Ignoring ${u} as ${v.slice(0,t+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[n]=w}catch{p(`Ignoring ${u} as ${v.join(".")} is ${JSON.stringify(s)}`)}else p(`Ignoring ${u} as ${v.join(".")} is ${JSON.stringify(s)}`)}function y(l,u){const w=u.split(".");S(l,w)}function S(l,u){const w=u.shift();if(u.length===0){delete l[w];return}if(Object.keys(l).indexOf(w)!==-1){const p=l[w];typeof p=="object"&&!Array.isArray(p)&&(S(p,u),Object.keys(p).length===0&&delete l[w])}}function m(l,u,w){function p(s,t){let i=s;for(const r of t){if(typeof i!="object"||i===null)return;i=i[r]}return i}const v=u.split("."),n=p(l,v);return typeof n>"u"?w:n}function C(l,u,w){Object.keys(u).forEach(p=>{p!=="__proto__"&&(p in l?O.isObject(l[p])&&O.isObject(u[p])?C(l[p],u[p],w):w&&(l[p]=u[p]):l[p]=u[p])})}function g(l){return l.replace(/[\[\]]/g,"")}}),define(ne[122],re([0,1,12,31,113,10,93,9]),function(K,e,O,k,D,A,x,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=a,e.validateWhenClauses=s,e.expressionsAreEqualWithConstantSubstitution=t,e.implies=J;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",O.isMacintosh),c.set("isLinux",O.isLinux),c.set("isWindows",O.isWindows),c.set("isWeb",O.isWeb),c.set("isMacNative",O.isMacintosh&&!O.isWeb),c.set("isEdge",O.isEdge),c.set("isFirefox",O.isFirefox),c.set("isChrome",O.isChrome),c.set("isSafari",O.isSafari);function a(M,d){if(c.get(M)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(M,d)}const h=Object.prototype.hasOwnProperty;var E;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const y={regexParsingWithErrorRecovery:!0},S=(0,x.localize)(0,null),m=(0,x.localize)(1,null),C=(0,x.localize)(2,null),g=(0,x.localize)(3,null),l=(0,x.localize)(4,null),u=(0,x.localize)(5,null),w=(0,x.localize)(6,null),p=(0,x.localize)(7,null);class v{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(d=y){this._config=d,this._scanner=new D.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(d){if(d===""){this._parsingErrors.push({message:S,offset:0,lexeme:"",additionalInfo:m});return}this._tokens=this._scanner.reset(d).scan(),this._current=0,this._parsingErrors=[];try{const I=this._expr();if(!this._isAtEnd()){const T=this._peek(),U=T.type===17?u:void 0;throw this._parsingErrors.push({message:l,offset:T.offset,lexeme:D.Scanner.getLexeme(T),additionalInfo:U}),v._parseError}return I}catch(I){if(I!==v._parseError)throw I;return}}_expr(){return this._or()}_or(){const d=[this._and()];for(;this._matchOne(16);){const I=this._and();d.push(I)}return d.length===1?d[0]:n.or(...d)}_and(){const d=[this._term()];for(;this._matchOne(15);){const I=this._term();d.push(I)}return d.length===1?d[0]:n.and(...d)}_term(){if(this._matchOne(2)){const d=this._peek();switch(d.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const I=this._expr();return this._consume(1,g),I?.negate()}case 17:return this._advance(),_.create(d.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",d)}}return this._primary()}_primary(){const d=this._peek();switch(d.type){case 11:return this._advance(),n.true();case 12:return this._advance(),n.false();case 0:{this._advance();const I=this._expr();return this._consume(1,g),I}case 17:{const I=d.lexeme;if(this._advance(),this._matchOne(9)){const U=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),U.type!==10)throw this._errExpectedButGot("REGEX",U);const G=U.lexeme,B=G.lastIndexOf("/"),te=B===G.length-1?void 0:this._removeFlagsGY(G.substring(B+1));let ae;try{ae=new RegExp(G.substring(1,B),te)}catch{throw this._errExpectedButGot("REGEX",U)}return ce.create(I,ae)}switch(U.type){case 10:case 19:{const G=[U.lexeme];this._advance();let B=this._peek(),te=0;for(let he=0;he<U.lexeme.length;he++)U.lexeme.charCodeAt(he)===40?te++:U.lexeme.charCodeAt(he)===41&&te--;for(;!this._isAtEnd()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let he=0;he<B.lexeme.length;he++)B.lexeme.charCodeAt(he)===40?te++:U.lexeme.charCodeAt(he)===41&&te--}if(te<0)break;G.push(D.Scanner.getLexeme(B)),this._advance(),B=this._peek()}const ae=G.join(""),ue=ae.lastIndexOf("/"),me=ue===ae.length-1?void 0:this._removeFlagsGY(ae.substring(ue+1));let ye;try{ye=new RegExp(ae.substring(1,ue),me)}catch{throw this._errExpectedButGot("REGEX",U)}return n.regex(I,ye)}case 18:{const G=U.lexeme;this._advance();let B=null;if(!(0,k.isFalsyOrWhitespace)(G)){const te=G.indexOf("/"),ae=G.lastIndexOf("/");if(te!==ae&&te>=0){const ue=G.slice(te+1,ae),me=G[ae+1]==="i"?"i":"";try{B=new RegExp(ue,me)}catch{throw this._errExpectedButGot("REGEX",U)}}}if(B===null)throw this._errExpectedButGot("REGEX",U);return ce.create(I,B)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,C);const U=this._value();return n.notIn(I,U)}switch(this._peek().type){case 3:{this._advance();const U=this._value();if(this._previous().type===18)return n.equals(I,U);switch(U){case"true":return n.has(I);case"false":return n.not(I);default:return n.equals(I,U)}}case 4:{this._advance();const U=this._value();if(this._previous().type===18)return n.notEquals(I,U);switch(U){case"true":return n.not(I);case"false":return n.has(I);default:return n.notEquals(I,U)}}case 5:return this._advance(),ie.create(I,this._value());case 6:return this._advance(),fe.create(I,this._value());case 7:return this._advance(),H.create(I,this._value());case 8:return this._advance(),se.create(I,this._value());case 13:return this._advance(),n.in(I,this._value());default:return n.has(I)}}case 20:throw this._parsingErrors.push({message:w,offset:d.offset,lexeme:"",additionalInfo:p}),v._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const d=this._peek();switch(d.type){case 17:case 18:return this._advance(),d.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(d){return d.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(d){return this._check(d)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(d,I){if(this._check(d))return this._advance();throw this._errExpectedButGot(I,this._peek())}_errExpectedButGot(d,I,T){const U=(0,x.localize)(8,null,d,D.Scanner.getLexeme(I)),G=I.offset,B=D.Scanner.getLexeme(I);return this._parsingErrors.push({message:U,offset:G,lexeme:B,additionalInfo:T}),v._parseError}_check(d){return this._peek().type===d}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=v;class n{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(d){return f.create(d)}static equals(d,I){return b.create(d,I)}static notEquals(d,I){return N.create(d,I)}static regex(d,I){return ce.create(d,I)}static in(d,I){return R.create(d,I)}static notIn(d,I){return L.create(d,I)}static not(d){return _.create(d)}static and(...d){return Y.create(d,null,!0)}static or(...d){return z.create(d,null,!0)}static greater(d,I){return H.create(d,I)}static greaterEquals(d,I){return se.create(d,I)}static smaller(d,I){return ie.create(d,I)}static smallerEquals(d,I){return fe.create(d,I)}static{this._parser=new v({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this._parser.parse(d)}}e.ContextKeyExpr=n;function s(M){const d=new v({regexParsingWithErrorRecovery:!1});return M.map(I=>(d.parse(I),d.lexingErrors.length>0?d.lexingErrors.map(T=>({errorMessage:T.additionalInfo?(0,x.localize)(9,null,T.additionalInfo):(0,x.localize)(10,null),offset:T.offset,length:T.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(T=>({errorMessage:T.additionalInfo?`${T.message}. ${T.additionalInfo}`:T.message,offset:T.offset,length:T.lexeme.length})):[]))}function t(M,d){const I=M?M.substituteConstants():void 0,T=d?d.substituteConstants():void 0;return!I&&!T?!0:!I||!T?!1:I.equals(T)}function i(M,d){return M.cmp(d)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=r;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=o;class f{static create(d,I=null){const T=c.get(d);return typeof T=="boolean"?T?o.INSTANCE:r.INSTANCE:new f(d,I)}constructor(d,I){this.key=d,this.negated=I,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:q(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=c.get(this.key);return typeof d=="boolean"?d?o.INSTANCE:r.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class b{static create(d,I,T=null){if(typeof I=="boolean")return I?f.create(d,T):_.create(d,T);const U=c.get(d);return typeof U=="boolean"?I===(U?"true":"false")?o.INSTANCE:r.INSTANCE:new b(d,I,T)}constructor(d,I,T){this.key=d,this.value=I,this.negated=T,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:X(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){const d=c.get(this.key);if(typeof d=="boolean"){const I=d?"true":"false";return this.value===I?o.INSTANCE:r.INSTANCE}return this}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=b;class R{static create(d,I){return new R(d,I)}constructor(d,I){this.key=d,this.valueKey=I,this.type=10,this.negated=null}cmp(d){return d.type!==this.type?this.type-d.type:X(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}substituteConstants(){return this}evaluate(d){const I=d.getValue(this.valueKey),T=d.getValue(this.key);return Array.isArray(I)?I.includes(T):typeof T=="string"&&typeof I=="object"&&I!==null?h.call(I,T):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=L.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=R;class L{static create(d,I){return new L(d,I)}constructor(d,I){this.key=d,this.valueKey=I,this.type=11,this._negated=R.create(d,I)}cmp(d){return d.type!==this.type?this.type-d.type:this._negated.cmp(d._negated)}equals(d){return d.type===this.type?this._negated.equals(d._negated):!1}substituteConstants(){return this}evaluate(d){return!this._negated.evaluate(d)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(d){return d.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=L;class N{static create(d,I,T=null){if(typeof I=="boolean")return I?_.create(d,T):f.create(d,T);const U=c.get(d);return typeof U=="boolean"?I===(U?"true":"false")?r.INSTANCE:o.INSTANCE:new N(d,I,T)}constructor(d,I,T){this.key=d,this.value=I,this.negated=T,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:X(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){const d=c.get(this.key);if(typeof d=="boolean"){const I=d?"true":"false";return this.value===I?r.INSTANCE:o.INSTANCE}return this}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=N;class _{static create(d,I=null){const T=c.get(d);return typeof T=="boolean"?T?r.INSTANCE:o.INSTANCE:new _(d,I)}constructor(d,I){this.key=d,this.negated=I,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:q(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=c.get(this.key);return typeof d=="boolean"?d?r.INSTANCE:o.INSTANCE:this}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;function V(M,d){if(typeof M=="string"){const I=parseFloat(M);isNaN(I)||(M=I)}return typeof M=="string"||typeof M=="number"?d(M):r.INSTANCE}class H{static create(d,I,T=null){return V(I,U=>new H(d,U,T))}constructor(d,I,T){this.key=d,this.value=I,this.negated=T,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:X(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=fe.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=H;class se{static create(d,I,T=null){return V(I,U=>new se(d,U,T))}constructor(d,I,T){this.key=d,this.value=I,this.negated=T,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:X(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ie.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=se;class ie{static create(d,I,T=null){return V(I,U=>new ie(d,U,T))}constructor(d,I,T){this.key=d,this.value=I,this.negated=T,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:X(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=se.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=ie;class fe{static create(d,I,T=null){return V(I,U=>new fe(d,U,T))}constructor(d,I,T){this.key=d,this.value=I,this.negated=T,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:X(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=fe;class ce{static create(d,I){return new ce(d,I)}constructor(d,I){this.key=d,this.regexp=I,this.type=7,this.negated=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const I=this.regexp?this.regexp.source:"",T=d.regexp?d.regexp.source:"";return I<T?-1:I>T?1:0}equals(d){if(d.type===this.type){const I=this.regexp?this.regexp.source:"",T=d.regexp?d.regexp.source:"";return this.key===d.key&&I===T}return!1}substituteConstants(){return this}evaluate(d){const I=d.getValue(this.key);return this.regexp?this.regexp.test(I):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=le.create(this)),this.negated}}e.ContextKeyRegexExpr=ce;class le{static create(d){return new le(d)}constructor(d){this._actual=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}substituteConstants(){return this}evaluate(d){return!this._actual.evaluate(d)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(d){return new le(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=le;function j(M){let d=null;for(let I=0,T=M.length;I<T;I++){const U=M[I].substituteConstants();if(M[I]!==U&&d===null){d=[];for(let G=0;G<I;G++)d[G]=M[G]}d!==null&&(d[I]=U)}return d===null?M:d}class Y{static create(d,I,T){return Y._normalizeArr(d,I,T)}constructor(d,I){this.expr=d,this.negated=I,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let I=0,T=this.expr.length;I<T;I++){const U=i(this.expr[I],d.expr[I]);if(U!==0)return U}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let I=0,T=this.expr.length;I<T;I++)if(!this.expr[I].equals(d.expr[I]))return!1;return!0}return!1}substituteConstants(){const d=j(this.expr);return d===this.expr?this:Y.create(d,this.negated,!1)}evaluate(d){for(let I=0,T=this.expr.length;I<T;I++)if(!this.expr[I].evaluate(d))return!1;return!0}static _normalizeArr(d,I,T){const U=[];let G=!1;for(const B of d)if(B){if(B.type===1){G=!0;continue}if(B.type===0)return r.INSTANCE;if(B.type===6){U.push(...B.expr);continue}U.push(B)}if(U.length===0&&G)return o.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(i);for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];for(;U.length>1;){const B=U[U.length-1];if(B.type!==9)break;U.pop();const te=U.pop(),ae=U.length===0,ue=z.create(B.expr.map(me=>Y.create([me,te],null,T)),null,ae);ue&&(U.push(ue),U.sort(i))}if(U.length===1)return U[0];if(T){for(let B=0;B<U.length;B++)for(let te=B+1;te<U.length;te++)if(U[B].negate().equals(U[te]))return r.INSTANCE;if(U.length===1)return U[0]}return new Y(U,I)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const I of this.expr)d.push(...I.keys());return d}map(d){return new Y(this.expr.map(I=>I.map(d)),null)}negate(){if(!this.negated){const d=[];for(const I of this.expr)d.push(I.negate());this.negated=z.create(d,this,!0)}return this.negated}}e.ContextKeyAndExpr=Y;class z{static create(d,I,T){return z._normalizeArr(d,I,T)}constructor(d,I){this.expr=d,this.negated=I,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let I=0,T=this.expr.length;I<T;I++){const U=i(this.expr[I],d.expr[I]);if(U!==0)return U}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let I=0,T=this.expr.length;I<T;I++)if(!this.expr[I].equals(d.expr[I]))return!1;return!0}return!1}substituteConstants(){const d=j(this.expr);return d===this.expr?this:z.create(d,this.negated,!1)}evaluate(d){for(let I=0,T=this.expr.length;I<T;I++)if(this.expr[I].evaluate(d))return!0;return!1}static _normalizeArr(d,I,T){let U=[],G=!1;if(d){for(let B=0,te=d.length;B<te;B++){const ae=d[B];if(ae){if(ae.type===0){G=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){U=U.concat(ae.expr);continue}U.push(ae)}}if(U.length===0&&G)return r.INSTANCE;U.sort(i)}if(U.length!==0){if(U.length===1)return U[0];for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];if(T){for(let B=0;B<U.length;B++)for(let te=B+1;te<U.length;te++)if(U[B].negate().equals(U[te]))return o.INSTANCE;if(U.length===1)return U[0]}return new z(U,I)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const I of this.expr)d.push(...I.keys());return d}map(d){return new z(this.expr.map(I=>I.map(d)),null)}negate(){if(!this.negated){const d=[];for(const I of this.expr)d.push(I.negate());for(;d.length>1;){const I=d.shift(),T=d.shift(),U=[];for(const G of F(I))for(const B of F(T))U.push(Y.create([G,B],null,!1));d.unshift(z.create(U,null,!1))}this.negated=z.create(d,this,!0)}return this.negated}}e.ContextKeyOrExpr=z;class W extends f{static{this._info=[]}static all(){return W._info.values()}constructor(d,I,T){super(d,null),this._defaultValue=I,typeof T=="object"?W._info.push({...T,key:d}):T!==!0&&W._info.push({key:d,description:T,type:I!=null?typeof I:void 0})}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return b.create(this.key,d)}notEqualsTo(d){return N.create(this.key,d)}}e.RawContextKey=W,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function q(M,d){return M<d?-1:M>d?1:0}function X(M,d,I,T){return M<I?-1:M>I?1:d<T?-1:d>T?1:0}function J(M,d){if(M.type===0||d.type===1)return!0;if(M.type===9)return d.type===9?Z(M.expr,d.expr):!1;if(d.type===9){for(const I of d.expr)if(J(M,I))return!0;return!1}if(M.type===6){if(d.type===6)return Z(d.expr,M.expr);for(const I of M.expr)if(J(I,d))return!0;return!1}return M.equals(d)}function Z(M,d){let I=0,T=0;for(;I<M.length&&T<d.length;){const U=M[I].cmp(d[T]);if(U<0)return!1;U===0&&I++,T++}return I===M.length}function F(M){return M.type===9?M.expr:[M]}}),define(ne[61],re([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,O.createDecorator)("downloadService")}),define(ne[18],re([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,O.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,O.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[21],re([0,1,96,10]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=D,e.toTargetPlatform=A,e.getTargetPlatform=x,e.isNotWebExtensionInWebTargetPlatform=P,e.isTargetPlatformCompatible=c,e.isIExtensionIdentifier=a,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function D(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PowerPC";case"linux-riscv64":return"Linux RISC-V 64";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"linux-riscv64":return"linux-riscv64";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function x(u,w){switch(u){case 3:return w==="x64"?"win32-x64":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":w==="ppc64le"?"linux-ppc64le":w==="riscv64"?"linux-riscv64":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function P(u,w){return w==="web"&&!u.includes("web")}function c(u,w,p){return P(w,p)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===p}function a(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var h;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(h||(e.SortBy=h={}));var E;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var y;(function(u){u.Install="install",u.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var S;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var m;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));class C extends Error{constructor(w,p){super(w),this.code=p,this.name=p}}e.ExtensionManagementError=C;var g;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class l extends Error{constructor(w,p){super(w),this.code=p,this.name=p}}e.ExtensionGalleryError=l,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,O.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,O.localize2)(1,"Preferences")}),define(ne[62],re([0,1,14,9,104,13]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=x;async function x(h,E,y,S,m,C){let g;try{await P(h,E,y,S,m,C)}catch(l){g=l}finally{g&&m.errorTransformer&&(g=m.errorTransformer(g)),typeof g<"u"&&y.error(g),y.end()}}async function P(h,E,y,S,m,C){c(C);const g=await h.open(E,{create:!1});try{c(C);let l=0,u=0,w=m&&typeof m.length=="number"?m.length:void 0,p=O.VSBuffer.alloc(Math.min(m.bufferSize,typeof w=="number"?w:m.bufferSize)),v=m&&typeof m.position=="number"?m.position:0,n=0;do u=await h.read(g,v,p.buffer,n,p.byteLength-n),v+=u,n+=u,l+=u,typeof w=="number"&&(w-=u),n===p.byteLength&&(await y.write(S(p)),p=O.VSBuffer.alloc(Math.min(m.bufferSize,typeof w=="number"?w:m.bufferSize)),n=0);while(u>0&&(typeof w!="number"||w>0)&&c(C)&&a(l,m));if(n>0){let s=n;typeof w=="number"&&(s=Math.min(n,w)),y.write(S(p.slice(0,s)))}}catch(l){throw(0,A.ensureFileSystemProviderError)(l)}finally{await h.close(g)}}function c(h){if(h.isCancellationRequested)throw(0,k.canceled)();return!0}function a(h,E){if(typeof E?.limits?.size=="number"&&h>E.limits.size)throw(0,A.createFileSystemProviderError)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[123],re([0,1,60,2,52,5,11,8]),function(K,e,O,k,D,A,x,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class c extends k.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new A.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new A.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new k.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new P.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(h=>this.handleDidWatchFail(h)))}handleDidWatchFail(h){this.isCorrelated(h)&&this.suspendWatchRequest(h)}isCorrelated(h){return(0,D.isWatchRequestWithCorrelation)(h)}async watch(h){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new P.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const E of h)this.isCorrelated(E)?this.allCorrelatedWatchRequests.set(E.correlationId,E):this.allNonCorrelatedWatchRequests.add(E);for(const[E]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(E)||(this.suspendedWatchRequests.deleteAndDispose(E),this.suspendedWatchRequestsWithPolling.delete(E));return await this.updateWatchers()}finally{this.joinWatch.complete()}}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(h=>!this.suspendedWatchRequests.has(h.correlationId))])}isSuspended(h){return typeof h.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(h.correlationId)?"polling":this.suspendedWatchRequests.has(h.correlationId)}async suspendWatchRequest(h){if(this.suspendedWatchRequests.has(h.correlationId))return;const E=new k.DisposableStore;this.suspendedWatchRequests.set(h.correlationId,E),await this.joinWatch.p,!E.isDisposed&&(this.monitorSuspendedWatchRequest(h,E),this.updateWatchers())}resumeWatchRequest(h){this.suspendedWatchRequests.deleteAndDispose(h.correlationId),this.suspendedWatchRequestsWithPolling.delete(h.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(h,E){this.doMonitorWithExistingWatcher(h,E)?(this.trace(`reusing an existing recursive watcher to monitor ${h.path}`),this.suspendedWatchRequestsWithPolling.delete(h.correlationId)):(this.doMonitorWithNodeJS(h,E),this.suspendedWatchRequestsWithPolling.add(h.correlationId))}doMonitorWithExistingWatcher(h,E){const y=this.recursiveWatcher?.subscribe(h.path,(S,m)=>{E.isDisposed||(S?this.monitorSuspendedWatchRequest(h,E):m?.type===1&&this.onMonitoredPathAdded(h))});return y?(E.add(y),!0):!1}doMonitorWithNodeJS(h,E){let y=!1;const S=(m,C)=>{if(E.isDisposed)return;const g=this.isPathNotFound(m),l=this.isPathNotFound(C),u=y;y=g,!g&&(l||u)&&this.onMonitoredPathAdded(h)};this.trace(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,O.watchFile)(h.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},S)}catch(m){this.warn(`fs.watchFile() failed with error ${m} on path ${h.path} (correlationId: ${h.correlationId})`)}E.add((0,k.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,O.unwatchFile)(h.path,S)}catch(m){this.warn(`fs.unwatchFile() failed with error ${m} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}onMonitoredPathAdded(h){this.trace(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const E={resource:x.URI.file(h.path),type:1,cId:h.correlationId};this._onDidChangeFile.fire([E]),this.traceEvent(E,h),this.resumeWatchRequest(h)}isPathNotFound(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(h,E){if(this.verboseLogging){const y=` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.traceWithCorrelation(y,E)}}traceWithCorrelation(h,E){this.verboseLogging&&this.trace(`${h}${typeof E.correlationId=="number"?` <${E.correlationId}> `:""}`)}requestToString(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,D.requestFilterToString)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.verboseLogging=h}}e.BaseWatcher=c}),define(ne[124],re([0,1,5,171,123,12,172,63]),function(K,e,O,k,D,A,x,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class c extends D.BaseWatcher{constructor(h){super(),this.recursiveWatcher=h,this.onDidError=O.Event.None,this.watchers=new Set}async doWatch(h){h=this.removeDuplicateRequests(h);const E=[],y=new Set(Array.from(this.watchers));for(const S of h){const m=this.findWatcher(S);m&&(0,k.patternsEquals)(m.request.excludes,S.excludes)&&(0,k.patternsEquals)(m.request.includes,S.includes)?y.delete(m):E.push(S)}E.length&&this.trace(`Request to start watching: ${E.map(S=>this.requestToString(S)).join(",")}`),y.size&&this.trace(`Request to stop watching: ${Array.from(y).map(S=>this.requestToString(S.request)).join(",")}`);for(const S of y)this.stopWatching(S);for(const S of E)this.startWatching(S)}findWatcher(h){for(const E of this.watchers)if(typeof h.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===h.correlationId)return E}else if((0,P.isEqual)(E.request.path,h.path,!A.isLinux))return E}startWatching(h){const E=new x.NodeJSFileWatcherLibrary(h,this.recursiveWatcher,S=>this._onDidChangeFile.fire(S),()=>this._onDidWatchFail.fire(h),S=>this._onDidLogMessage.fire(S),this.verboseLogging),y={request:h,instance:E};this.watchers.add(y)}async stop(){await super.stop();for(const h of this.watchers)this.stopWatching(h)}stopWatching(h){this.trace("stopping file watcher",h),this.watchers.delete(h),h.instance.dispose()}removeDuplicateRequests(h){const E=new Map;for(const y of h){const S=A.isLinux?y.path:y.path.toLowerCase();let m=E.get(y.correlationId);m||(m=new Map,E.set(y.correlationId,m)),m.has(S)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(y)}`),m.set(S,y)}return Array.from(E.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(h){super.setVerboseLogging(h);for(const E of this.watchers)E.instance.setVerboseLogging(h)}trace(h,E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(h,E)})}warn(h){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(h)})}toMessage(h,E){return E?`[File Watcher (node.js)] ${h} (${this.requestToString(E.request)})`:`[File Watcher (node.js)] ${h}`}}e.NodeJSWatcher=c}),define(ne[125],re([0,1,52,124]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends O.AbstractNonRecursiveWatcherClient{constructor(x,P,c){super(x,P,c),this.init()}createWatcher(x){return x.add(new k.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=D}),define(ne[126],re([0,1,15,58,89,52]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class x extends A.AbstractUniversalWatcherClient{constructor(c,a,h){super(c,a,h),this.init()}createWatcher(c){const a=c.add(new D.Client(O.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(a.onDidProcessExit(({code:h,signal:E})=>this.onError(`terminated by itself with code ${h}, signal: ${E} (ETERM)`))),k.ProxyChannel.toService((0,k.getNextTickChannel)(a.getChannel("watcher")))}}e.UniversalWatcherClient=x}),define(ne[64],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class O{constructor(...D){this._entries=new Map;for(const[A,x]of D)this.set(A,x)}set(D,A){const x=this._entries.get(D);return this._entries.set(D,A),x}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=O}),define(ne[127],re([0,1,8,9,2,51,121,10,64,173]),function(K,e,O,k,D,A,x,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const h=!1;class E extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class y{constructor(g=new c.ServiceCollection,l=!1,u,w=h){this._services=g,this._strict=l,this._parent=u,this._enableTracing=w,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=w?u?._globalGraph??new x.Graph(p=>p):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,D.dispose)(this._children),this._children.clear();for(const g of this._servicesToMaybeDispose)(0,D.isDisposable)(g)&&g.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(g){this._throwIfDisposed();const l=new class extends y{dispose(){this._children.delete(l),super.dispose()}}(g,this._strict,this,this._enableTracing);return this._children.add(l),l}invokeFunction(g,...l){this._throwIfDisposed();const u=m.traceInvocation(this._enableTracing,g);let w=!1;try{return g({get:v=>{if(w)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(v,u);if(!n)throw new Error(`[invokeFunction] unknown service '${v}'`);return n}},...l)}finally{w=!0,u.stop()}}createInstance(g,...l){this._throwIfDisposed();let u,w;return g instanceof A.SyncDescriptor?(u=m.traceCreation(this._enableTracing,g.ctor),w=this._createInstance(g.ctor,g.staticArguments.concat(l),u)):(u=m.traceCreation(this._enableTracing,g),w=this._createInstance(g,l,u)),u.stop(),w}_createInstance(g,l=[],u){const w=P._util.getServiceDependencies(g).sort((n,s)=>n.index-s.index),p=[];for(const n of w){const s=this._getOrCreateServiceInstance(n.id,u);s||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${n.id}.`,!1),p.push(s)}const v=w.length>0?w[0].index:l.length;if(l.length!==v){console.trace(`[createInstance] First service dependency of ${g.name} at position ${v+1} conflicts with ${l.length} static arguments`);const n=v-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,v)}return Reflect.construct(g,l.concat(p))}_setCreatedServiceInstance(g,l){if(this._services.get(g)instanceof A.SyncDescriptor)this._services.set(g,l);else if(this._parent)this._parent._setCreatedServiceInstance(g,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){const l=this._services.get(g);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):l}_getOrCreateServiceInstance(g,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(g));const u=this._getServiceInstanceOrDescriptor(g);return u instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,u,l.branch(g,!0)):(l.branch(g,!1),u)}_safeCreateAndCacheServiceInstance(g,l,u){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,l,u)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,l,u){const w=new x.Graph(n=>n.id.toString());let p=0;const v=[{id:g,desc:l,_trace:u}];for(;v.length;){const n=v.pop();if(w.lookupOrInsertNode(n),p++>1e3)throw new E(w);for(const s of P._util.getServiceDependencies(n.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(s.id);if(t||this._throwIfStrict(`[createInstance] ${g} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),t instanceof A.SyncDescriptor){const i={id:s.id,desc:t,_trace:n._trace.branch(s.id,!0)};w.insertEdge(n,i),v.push(i)}}}for(;;){const n=w.roots();if(n.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:s}of n){if(this._getServiceInstanceOrDescriptor(s.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setCreatedServiceInstance(s.id,i)}w.removeNode(s)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,l,u=[],w,p){if(this._services.get(g)instanceof A.SyncDescriptor)return this._createServiceInstance(g,l,u,w,p,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,l,u,w,p);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(g,l,u=[],w,p,v){if(w){const n=new y(void 0,this._strict,this,this._enableTracing);n._globalGraphImplicitDependency=String(g);const s=new Map,t=new O.GlobalIdleValue(()=>{const i=n._createInstance(l,u,p);for(const[r,o]of s){const f=i[r];if(typeof f=="function")for(const b of o)b.disposable=f.apply(i,b.listener)}return s.clear(),v.add(i),i});return new Proxy(Object.create(null),{get(i,r){if(!t.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let b=s.get(r);return b||(b=new a.LinkedList,s.set(r,b)),(L,N,_)=>{if(t.isInitialized)return t.value[r](L,N,_);{const V={listener:[L,N,_],disposable:void 0},H=b.push(V);return(0,D.toDisposable)(()=>{H(),V.disposable?.dispose()})}}}if(r in i)return i[r];const o=t.value;let f=o[r];return typeof f!="function"||(f=f.bind(o),i[r]=f),f},set(i,r,o){return t.value[r]=o,!0},getPrototypeOf(i){return l.prototype}})}else{const n=this._createInstance(l,u,p);return v.add(n),n}}_throwIfStrict(g,l){if(l&&console.warn(g),this._strict)throw new Error(g)}}e.InstantiationService=y;var S;(function(C){C[C.None=0]="None",C[C.Creation=1]="Creation",C[C.Invocation=2]="Invocation",C[C.Branch=3]="Branch"})(S||(S={}));class m{static{this.all=new Set}static{this._None=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,l){return g?new m(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(g,l){return g?new m(1,l.name):m._None}static{this._totals=0}constructor(g,l){this.type=g,this.name=l,this._start=Date.now(),this._dep=[]}branch(g,l){const u=new m(3,g.toString());return this._dep.push([g,l,u]),u}stop(){const g=Date.now()-this._start;m._totals+=g;let l=!1;function u(p,v){const n=[],s=new Array(p+1).join("	");for(const[t,i,r]of v._dep)if(i&&r){l=!0,n.push(`${s}CREATES -> ${t}`);const o=u(p+1,r);o&&n.push(o)}else n.push(`${s}uses -> ${t}`);return n.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(g>2||l)&&m.all.add(w.join(`
`))}}e.Trace=m});var oe=this&&this.__param||function(K,e){return function(O,k){e(O,k,K)}};define(ne[65],re([0,1,20,2,12,106,21,10]),function(K,e,O,k,D,A,x,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=c;function c(h){return h.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let a=class extends k.Disposable{constructor(E){super(),this.extensionGalleryService=E}async getAvailableLanguages(){const E=new O.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let y;try{y=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const m=y.firstPage.filter(C=>C.properties.localizedLanguages?.length&&C.tags.some(g=>g.startsWith("lp-"))).map(C=>{const g=C.properties.localizedLanguages?.[0],l=c(C);return{...this.createQuickPickItem(l,g,C),extensionId:C.identifier.id,galleryExtension:C}});return m.push(this.createQuickPickItem("en","English")),m}createQuickPickItem(E,y,S){const m=y??E;let C;if(m!==E&&(C=`(${E})`),E.toLowerCase()===D.language.toLowerCase()&&(C??="",C+=(0,A.localize)(0,null)),S?.installCount){C??="";const g=S.installCount;let l;g>1e6?l=`${Math.floor(g/1e5)/10}M`:g>1e3?l=`${Math.floor(g/1e3)}K`:l=String(g),C+=` $(cloud-download) ${l}`}return{id:E,label:m,description:C}}};e.LanguagePackBaseService=a,e.LanguagePackBaseService=a=ve([oe(0,x.IExtensionGalleryService)],a)}),define(ne[6],re([0,1,107,34,5,43,2,30,12,17,3,11,122,10]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=C,e.log=l,e.getLogLevel=f,e.LogLevelToString=b,e.LogLevelToLocalizedString=R,e.parseLogLevel=L,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function m(){return new Date().toISOString()}function C(N){return(0,h.isNumber)(N)}var g;(function(N){N[N.Off=0]="Off",N[N.Trace=1]="Trace",N[N.Debug=2]="Debug",N[N.Info=3]="Info",N[N.Warning=4]="Warning",N[N.Error=5]="Error"})(g||(e.LogLevel=g={})),e.DEFAULT_LOG_LEVEL=g.Info;function l(N,_,V){switch(_){case g.Trace:N.trace(V);break;case g.Debug:N.debug(V);break;case g.Info:N.info(V);break;case g.Warning:N.warn(V);break;case g.Error:N.error(V);break;case g.Off:break;default:throw new Error(`Invalid log level ${_}`)}}function u(N,_=!1){let V="";for(let H=0;H<N.length;H++){let se=N[H];if(se instanceof Error&&(se=(0,k.toErrorMessage)(se,_)),typeof se=="object")try{se=JSON.stringify(se)}catch{}V+=(H>0?" ":"")+se}return V}class w extends x.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(_){this.level!==_&&(this.level=_,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(_){return this.level!==g.Off&&this.level<=_}}e.AbstractLogger=w;class p extends w{constructor(_){super(),this.logAlways=_}checkLogLevel(_){return this.logAlways||super.checkLogLevel(_)}trace(_,...V){this.checkLogLevel(g.Trace)&&this.log(g.Trace,u([_,...V],!0))}debug(_,...V){this.checkLogLevel(g.Debug)&&this.log(g.Debug,u([_,...V]))}info(_,...V){this.checkLogLevel(g.Info)&&this.log(g.Info,u([_,...V]))}warn(_,...V){this.checkLogLevel(g.Warning)&&this.log(g.Warning,u([_,...V]))}error(_,...V){if(this.checkLogLevel(g.Error))if(_ instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=_.stack,this.log(g.Error,u(H))}else this.log(g.Error,u([_,...V]))}flush(){}}e.AbstractMessageLogger=p;class v extends w{constructor(_=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(_),this.useColors=!c.isWindows}trace(_,...V){this.checkLogLevel(g.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,_,...V):console.log(`[main ${m()}]`,_,...V))}debug(_,...V){this.checkLogLevel(g.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,_,...V):console.log(`[main ${m()}]`,_,...V))}info(_,...V){this.checkLogLevel(g.Info)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,_,...V):console.log(`[main ${m()}]`,_,...V))}warn(_,...V){this.checkLogLevel(g.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,_,...V):console.warn(`[main ${m()}]`,_,...V))}error(_,...V){this.checkLogLevel(g.Error)&&(this.useColors?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,_,...V):console.error(`[main ${m()}]`,_,...V))}flush(){}}e.ConsoleMainLogger=v;class n extends w{constructor(_=e.DEFAULT_LOG_LEVEL,V=!0){super(),this.useColors=V,this.setLevel(_)}trace(_,...V){this.checkLogLevel(g.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",_,...V):console.log(_,...V))}debug(_,...V){this.checkLogLevel(g.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",_,...V):console.log(_,...V))}info(_,...V){this.checkLogLevel(g.Info)&&(this.useColors?console.log("%c INFO","color: #33f",_,...V):console.log(_,...V))}warn(_,...V){this.checkLogLevel(g.Warning)&&(this.useColors?console.log("%c WARN","color: #993",_,...V):console.log(_,...V))}error(_,...V){this.checkLogLevel(g.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",_,...V):console.error(_,...V))}flush(){}}e.ConsoleLogger=n;class s extends w{constructor(_,V=e.DEFAULT_LOG_LEVEL){super(),this.adapter=_,this.setLevel(V)}trace(_,...V){this.checkLogLevel(g.Trace)&&this.adapter.log(g.Trace,[this.extractMessage(_),...V])}debug(_,...V){this.checkLogLevel(g.Debug)&&this.adapter.log(g.Debug,[this.extractMessage(_),...V])}info(_,...V){this.checkLogLevel(g.Info)&&this.adapter.log(g.Info,[this.extractMessage(_),...V])}warn(_,...V){this.checkLogLevel(g.Warning)&&this.adapter.log(g.Warning,[this.extractMessage(_),...V])}error(_,...V){this.checkLogLevel(g.Error)&&this.adapter.log(g.Error,[this.extractMessage(_),...V])}extractMessage(_){return typeof _=="string"?_:(0,k.toErrorMessage)(_,this.checkLogLevel(g.Trace))}flush(){}}e.AdapterLogger=s;class t extends w{constructor(_){super(),this.loggers=_,_.length&&this.setLevel(_[0].getLevel())}setLevel(_){for(const V of this.loggers)V.setLevel(_);super.setLevel(_)}trace(_,...V){for(const H of this.loggers)H.trace(_,...V)}debug(_,...V){for(const H of this.loggers)H.debug(_,...V)}info(_,...V){for(const H of this.loggers)H.info(_,...V)}warn(_,...V){for(const H of this.loggers)H.warn(_,...V)}error(_,...V){for(const H of this.loggers)H.error(_,...V)}flush(){for(const _ of this.loggers)_.flush()}dispose(){for(const _ of this.loggers)_.dispose();super.dispose()}}e.MultiplexLogger=t;class i extends x.Disposable{constructor(_,V,H){if(super(),this.logLevel=_,this.logsHome=V,this._loggers=new P.ResourceMap,this._onDidChangeLoggers=this._register(new D.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,H)for(const se of H)this._loggers.set(se.resource,{logger:void 0,info:se})}getLoggerEntry(_){return(0,h.isString)(_)?[...this._loggers.values()].find(V=>V.info.id===_):this._loggers.get(_)}getLogger(_){return this.getLoggerEntry(_)?.logger}createLogger(_,V){const H=this.toResource(_),se=(0,h.isString)(_)?_:V?.id??(0,A.hash)(H.toString()).toString(16);let ie=this._loggers.get(H)?.logger;const fe=V?.logLevel==="always"?g.Trace:V?.logLevel;ie||(ie=this.doCreateLogger(H,fe??this.getLogLevel(H)??this.logLevel,{...V,id:se}));const ce={logger:ie,info:{resource:H,id:se,logLevel:fe,name:V?.name,hidden:V?.hidden,extensionId:V?.extensionId,when:V?.when}};return this.registerLogger(ce.info),this._loggers.set(H,ce),ie}toResource(_){return(0,h.isString)(_)?(0,a.joinPath)(this.logsHome,`${_}.log`):_}setLogLevel(_,V){if(E.URI.isUri(_)){const H=_,se=V,ie=this._loggers.get(H);ie&&se!==ie.info.logLevel&&(ie.info.logLevel=se===this.logLevel?void 0:se,ie.logger?.setLevel(se),this._loggers.set(ie.info.resource,ie),this._onDidChangeLogLevel.fire([H,se]))}else{this.logLevel=_;for(const[H,se]of this._loggers.entries())this._loggers.get(H)?.info.logLevel===void 0&&se.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(_,V){const H=this.getLoggerEntry(_);H&&V!==!H.info.hidden&&(H.info.hidden=!V,this._loggers.set(H.info.resource,H),this._onDidChangeVisibility.fire([H.info.resource,V]))}getLogLevel(_){let V;return _&&(V=this._loggers.get(_)?.info.logLevel),V??this.logLevel}registerLogger(_){const V=this._loggers.get(_.resource);V?V.info.hidden!==_.hidden&&this.setVisibility(_.resource,!_.hidden):(this._loggers.set(_.resource,{info:_,logger:void 0}),this._onDidChangeLoggers.fire({added:[_],removed:[]}))}deregisterLogger(_){const V=this._loggers.get(_);V&&(V.logger&&V.logger.dispose(),this._loggers.delete(_),this._onDidChangeLoggers.fire({added:[],removed:[V.info]}))}*getRegisteredLoggers(){for(const _ of this._loggers.values())yield _.info}getRegisteredLogger(_){return this._loggers.get(_)?.info}dispose(){this._loggers.forEach(_=>_.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class r{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(_){}getLevel(){return g.Info}trace(_,...V){}debug(_,...V){}info(_,...V){}warn(_,...V){}error(_,...V){}critical(_,...V){}dispose(){}flush(){}}e.NullLogger=r;class o extends r{}e.NullLogService=o;function f(N){if(N.verbose)return g.Trace;if(typeof N.logLevel=="string"){const _=L(N.logLevel.toLowerCase());if(_!==void 0)return _}return e.DEFAULT_LOG_LEVEL}function b(N){switch(N){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function R(N){switch(N){case g.Trace:return{original:"Trace",value:O.localize(0,null)};case g.Debug:return{original:"Debug",value:O.localize(1,null)};case g.Info:return{original:"Info",value:O.localize(2,null)};case g.Warning:return{original:"Warning",value:O.localize(3,null)};case g.Error:return{original:"Error",value:O.localize(4,null)};case g.Off:return{original:"Off",value:O.localize(5,null)}}}function L(N){switch(N){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",b(g.Info))}),define(ne[128],re([0,1,19,8,9,5,63,2,16,52,6]),function(K,e,O,k,D,A,x,P,c,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends P.Disposable{constructor(S,m){super(),this.logService=S,this.options=m,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new k.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new k.ThrottledDelayer(0))}watch(S,m){return m.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,m):this.watchNonRecursive(S,m)}watchUniversal(S,m){const C={path:this.toWatchPath(S),excludes:m.excludes,includes:m.includes,recursive:m.recursive,filter:m.filter,correlationId:m.correlationId},g=(0,O.insert)(this.universalWatchRequests,C);return this.refreshUniversalWatchers(),(0,P.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(m=>this._onDidChangeFile.fire((0,a.reviveFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const m of this.universalWatchRequests)(0,a.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const m of this.universalWatchRequests)(0,a.isRecursiveWatchRequest)(m)&&S.includes(m.path)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(S,m){const C={path:this.toWatchPath(S),excludes:m.excludes,includes:m.includes,recursive:!1,filter:m.filter,correlationId:m.correlationId},g=(0,O.insert)(this.nonRecursiveWatchRequests,C);return this.refreshNonRecursiveWatchers(),(0,P.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,a.reviveFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===h.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===h.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logWatcherMessage(S)}logWatcherMessage(S){this.logService[S.type](S.message)}toFilePath(S){return(0,c.normalize)(S.fsPath)}toWatchPath(S){const m=this.toFilePath(S);return(0,x.removeTrailingPathSeparator)(m)}}e.AbstractDiskFileSystemProvider=E}),define(ne[129],re([0,1,19,8,14,20,5,43,66,2,48,15,130,17,46,103,13,62,6,9]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l,u,w){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends a.Disposable{static{p=this}constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new x.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new x.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new x.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new x.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new x.Emitter),this._onDidUncorrelatedFilesChange=this._register(new x.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new x.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new k.ResourceQueue)}registerProvider(s,t){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${s}`);const i=new a.DisposableStore;return this.provider.set(s,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:t}),i.add(t.onDidChangeFile(r=>{const o=new g.FileChangesEvent(r,!this.isPathCaseSensitive(t));this.internalOnDidFilesChange.fire(o),o.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(o)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),i.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:s}))),(0,a.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:t}),this.provider.delete(s),(0,a.dispose)(i)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(i){t.push(i)}}),!this.provider.has(s)&&await k.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,t){const i=this.provider.get(s.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return c.Iterable.map(this.provider,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async withProvider(s){if(!(0,S.isAbsolutePath)(s))throw new g.FileOperationError((0,C.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const t=this.provider.get(s.scheme);if(!t){const i=new w.ErrorNoTelemetry;throw i.message=(0,C.localize)(1,null,s.toString()),i}return t}async withReadProvider(s){const t=await this.withProvider(s);if((0,g.hasOpenReadWriteCloseCapability)(t)||(0,g.hasReadWriteCapability)(t)||(0,g.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const t=await this.withProvider(s);if((0,g.hasOpenReadWriteCloseCapability)(t)||(0,g.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.doResolveFile(s,t)}catch(i){throw(0,g.toFileSystemProviderErrorCode)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,C.localize)(2,null,this.resourceForError(s)),1):(0,g.ensureFileSystemProviderError)(i)}}async doResolveFile(s,t){const i=await this.withProvider(s),r=this.isPathCaseSensitive(i),o=t?.resolveTo,f=t?.resolveSingleChildDescendants,b=t?.resolveMetadata,R=await i.stat(s);let L;return this.toFileStat(i,s,R,void 0,!!b,(N,_)=>(L||(L=h.TernarySearchTree.forUris(()=>!r),L.set(s,!0),o&&L.fill(!0,o)),L.get(N.resource)||L.findSuperstr(N.resource.with({query:null,fragment:null}))?!0:N.isDirectory&&f?_===1:!1))}async toFileStat(s,t,i,r,o,f){const{providerExtUri:b}=this.getExtUri(s),R={resource:t,name:b.basename(t),isFile:(i.type&g.FileType.File)!==0,isDirectory:(i.type&g.FileType.Directory)!==0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&g.FilePermission.Readonly)||!!(s.capabilities&2048),locked:!!((i.permissions??0)&g.FilePermission.Locked),etag:(0,g.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(R.isDirectory&&f(R,r)){try{const L=await s.readdir(t),N=await k.Promises.settled(L.map(async([_,V])=>{try{const H=b.joinPath(t,_),se=o?await s.stat(H):{type:V};return await this.toFileStat(s,H,se,L.length,o,f)}catch(H){return this.logService.trace(H),null}}));R.children=(0,O.coalesce)(N)}catch(L){this.logService.trace(L),R.children=[]}return R}return R}async resolveAll(s){return k.Promises.settled(s.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.withProvider(s),i=await t.stat(s);return this.toFileStat(t,s,i,void 0,!0,()=>!1)}async exists(s){const t=await this.withProvider(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.doValidateCreateFile(s,t)}catch(i){return i}return!0}async doValidateCreateFile(s,t){if(!t?.overwrite&&await this.exists(s))throw new g.FileOperationError((0,C.localize)(3,null,this.resourceForError(s)),3,t)}async createFile(s,t=D.VSBuffer.fromString(""),i){await this.doValidateCreateFile(s,i);const r=await this.writeFile(s,t);return this._onDidRunOperation.fire(new g.FileOperationEvent(s,0,r)),r}async writeFile(s,t,i){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:o}=this.getExtUri(r);let f=i;if((0,g.hasFileAtomicWriteCapability)(r)&&!f?.atomic){const b=r.enforceAtomicWriteFile?.(s);b&&(f={...i,atomic:b})}try{await this.validateWriteFile(r,s,f)||await this.mkdirp(r,o.dirname(s));let R;if((0,g.hasReadWriteCapability)(r)&&!(t instanceof D.VSBuffer))if((0,m.isReadableStream)(t)){const L=await(0,m.peekStream)(t,3);L.ended?R=D.VSBuffer.concat(L.buffer):R=L}else R=(0,m.peekReadable)(t,L=>D.VSBuffer.concat(L),3);else R=t;!(0,g.hasOpenReadWriteCloseCapability)(r)||(0,g.hasReadWriteCapability)(r)&&R instanceof D.VSBuffer||(0,g.hasReadWriteCapability)(r)&&(0,g.hasFileAtomicWriteCapability)(r)&&f?.atomic?await this.doWriteUnbuffered(r,s,f,R):await this.doWriteBuffered(r,s,f,R instanceof D.VSBuffer?(0,D.bufferToReadable)(R):R),this._onDidRunOperation.fire(new g.FileOperationEvent(s,4))}catch(b){throw new g.FileOperationError((0,C.localize)(4,null,this.resourceForError(s),(0,g.ensureFileSystemProviderError)(b).toString()),(0,g.toFileOperationResult)(b),f)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,t,i){const r=!!i?.unlock;if(r&&!(s.capabilities&8192))throw new Error((0,C.localize)(5,null,this.resourceForError(t)));if(!!i?.atomic){if(!(s.capabilities&32768))throw new Error((0,C.localize)(6,null,this.resourceForError(t)));if(!(s.capabilities&2))throw new Error((0,C.localize)(7,null,this.resourceForError(t)));if(r)throw new Error((0,C.localize)(8,null,this.resourceForError(t)))}let f;try{f=await s.stat(t)}catch{return}if(f.type&g.FileType.Directory)throw new g.FileOperationError((0,C.localize)(9,null,this.resourceForError(t)),0,i);if(this.throwIfFileIsReadonly(t,f),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&typeof f.mtime=="number"&&typeof f.size=="number"&&i.mtime<f.mtime&&i.etag!==(0,g.etag)({mtime:i.mtime,size:f.size}))throw new g.FileOperationError((0,C.localize)(10,null),3,i);return f}async readFile(s,t,i){const r=await this.withReadProvider(s);return t?.atomic?this.doReadFileAtomic(r,s,t,i):this.doReadFile(r,s,t,i)}async doReadFileAtomic(s,t,i,r){return new Promise((o,f)=>{this.writeQueue.queueFor(t,async()=>{try{const b=await this.doReadFile(s,t,i,r);o(b)}catch(b){f(b)}},this.getExtUri(s).providerExtUri)})}async doReadFile(s,t,i,r){const o=await this.doReadFileStream(s,t,{...i,preferUnbuffered:!0},r);return{...o,value:await(0,D.streamToBuffer)(o.value)}}async readFileStream(s,t,i){const r=await this.withReadProvider(s);return this.doReadFileStream(r,s,t,i)}async doReadFileStream(s,t,i,r){const o=new A.CancellationTokenSource(r);let f=i;(0,g.hasFileAtomicReadCapability)(s)&&s.enforceAtomicReadFile?.(t)&&(f={...i,atomic:!0});const b=this.validateReadFile(t,f).then(L=>L,L=>{throw o.dispose(!0),L});let R;try{return typeof f?.etag=="string"&&f.etag!==g.ETAG_DISABLED&&await b,f?.atomic&&(0,g.hasFileAtomicReadCapability)(s)||!((0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasFileReadStreamCapability)(s))||(0,g.hasReadWriteCapability)(s)&&f?.preferUnbuffered?R=this.readFileUnbuffered(s,t,f):(0,g.hasFileReadStreamCapability)(s)?R=this.readFileStreamed(s,t,o.token,f):R=this.readFileBuffered(s,t,o.token,f),R.on("end",()=>o.dispose()),R.on("error",()=>o.dispose()),{...await b,value:R}}catch(L){throw R&&await(0,m.consumeStream)(R),this.restoreReadError(L,t,f)}}restoreReadError(s,t,i){const r=(0,C.localize)(11,null,this.resourceForError(t),(0,g.ensureFileSystemProviderError)(s).toString());return s instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(r,s.stat,i):s instanceof g.TooLargeFileOperationError?new g.TooLargeFileOperationError(r,s.fileOperationResult,s.size,s.options):new g.FileOperationError(r,(0,g.toFileOperationResult)(s),i)}readFileStreamed(s,t,i,r=Object.create(null)){const o=s.readFileStream(t,r,i);return(0,m.transform)(o,{data:f=>f instanceof D.VSBuffer?f:D.VSBuffer.wrap(f),error:f=>this.restoreReadError(f,t,r)},f=>D.VSBuffer.concat(f))}readFileBuffered(s,t,i,r=Object.create(null)){const o=(0,D.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,t,o,f=>f,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:f=>this.restoreReadError(f,t,r)},i),o}readFileUnbuffered(s,t,i){const r=(0,m.newWriteableStream)(o=>D.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,g.hasFileAtomicReadCapability)(s)?o=await s.readFile(t,{atomic:!0}):o=await s.readFile(t),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.validateReadFileLimits(t,o.byteLength,i),r.end(D.VSBuffer.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async validateReadFile(s,t){const i=await this.resolve(s,{resolveMetadata:!0});if(i.isDirectory)throw new g.FileOperationError((0,C.localize)(12,null,this.resourceForError(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==g.ETAG_DISABLED&&t.etag===i.etag)throw new g.NotModifiedSinceFileOperationError((0,C.localize)(13,null),i,t);return this.validateReadFileLimits(s,i.size,t),i}validateReadFileLimits(s,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new g.TooLargeFileOperationError((0,C.localize)(14,null,this.resourceForError(s)),7,t,i)}async canMove(s,t,i){return this.doCanMoveCopy(s,t,"move",i)}async canCopy(s,t,i){return this.doCanMoveCopy(s,t,"copy",i)}async doCanMoveCopy(s,t,i,r){if(s.toString()!==t.toString())try{const o=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),f=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(o,s,f,t,i,r)}catch(o){return o}return!0}async move(s,t,i){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),f=await this.doMoveCopy(r,s,o,t,"move",!!i),b=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,f==="move"?2:3,b)),b}async copy(s,t,i){const r=await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),f=await this.doMoveCopy(r,s,o,t,"copy",!!i),b=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,f==="copy"?3:2,b)),b}async doMoveCopy(s,t,i,r,o,f){if(t.toString()===r.toString())return o;const{exists:b,isSameResourceWithDifferentPathCase:R}=await this.doValidateMoveCopy(s,t,i,r,o,f);if(b&&!R&&f&&await this.del(r,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r)),o==="copy"){if(s===i&&(0,g.hasFileFolderCopyCapability)(s))await s.copy(t,r,{overwrite:f});else{const L=await this.resolve(t);L.isDirectory?await this.doCopyFolder(s,L,i,r):await this.doCopyFile(s,t,i,r)}return o}else return s===i?(await s.rename(t,r,{overwrite:f}),o):(await this.doMoveCopy(s,t,i,r,"copy",f),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(s,t,i,r){if((0,g.hasOpenReadWriteCloseCapability)(s)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(s,t,i,r);if((0,g.hasOpenReadWriteCloseCapability)(s)&&(0,g.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(s,t,i,r);if((0,g.hasReadWriteCapability)(s)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(s,t,i,r);if((0,g.hasReadWriteCapability)(s)&&(0,g.hasReadWriteCapability)(i))return this.doPipeUnbuffered(s,t,i,r)}async doCopyFolder(s,t,i,r){await i.mkdir(r),Array.isArray(t.children)&&await k.Promises.settled(t.children.map(async o=>{const f=this.getExtUri(i).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.doCopyFolder(s,await this.resolve(o.resource),i,f):this.doCopyFile(s,o.resource,i,f)}))}async doValidateMoveCopy(s,t,i,r,o,f){let b=!1;if(s===i){const{providerExtUri:L,isPathCaseSensitive:N}=this.getExtUri(s);if(N||(b=L.isEqual(t,r)),b&&o==="copy")throw new Error((0,C.localize)(15,null,this.resourceForError(t),this.resourceForError(r)));if(!b&&L.isEqualOrParent(r,t))throw new Error((0,C.localize)(16,null,this.resourceForError(t),this.resourceForError(r)))}const R=await this.exists(r);if(R&&!b){if(!f)throw new g.FileOperationError((0,C.localize)(17,null,this.resourceForError(t),this.resourceForError(r)),4);if(s===i){const{providerExtUri:L}=this.getExtUri(s);if(L.isEqualOrParent(t,r))throw new Error((0,C.localize)(18,null,this.resourceForError(t),this.resourceForError(r)))}}return{exists:R,isSameResourceWithDifferentPathCase:b}}getExtUri(s){const t=this.isPathCaseSensitive(s);return{providerExtUri:t?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(t,s);const i=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(s,0,i)),i}async mkdirp(s,t){const i=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(t,r.dirname(t));)try{if(!((await s.stat(t)).type&g.FileType.Directory))throw new Error((0,C.localize)(19,null,this.resourceForError(t)));break}catch(o){if((0,g.toFileSystemProviderErrorCode)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(r.basename(t)),t=r.dirname(t)}for(let o=i.length-1;o>=0;o--){t=r.joinPath(t,i[o]);try{await s.mkdir(t)}catch(f){if((0,g.toFileSystemProviderErrorCode)(f)!==g.FileSystemProviderErrorCode.FileExists)throw f}}}async canDelete(s,t){try{await this.doValidateDelete(s,t)}catch(i){return i}return!0}async doValidateDelete(s,t){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s),r=!!t?.useTrash;if(r&&!(i.capabilities&4096))throw new Error((0,C.localize)(20,null,this.resourceForError(s)));const o=t?.atomic;if(o&&!(i.capabilities&65536))throw new Error((0,C.localize)(21,null,this.resourceForError(s)));if(r&&o)throw new Error((0,C.localize)(22,null,this.resourceForError(s)));let f;try{f=await i.stat(s)}catch{}if(f)this.throwIfFileIsReadonly(s,f);else throw new g.FileOperationError((0,C.localize)(23,null,this.resourceForError(s)),1);if(!!!t?.recursive){const R=await this.resolve(s);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,C.localize)(24,null,this.resourceForError(s)))}return i}async del(s,t){const i=await this.doValidateDelete(s,t);let r=t;if((0,g.hasFileAtomicDeleteCapability)(i)&&!r?.atomic){const R=i.enforceAtomicDelete?.(s);R&&(r={...t,atomic:R})}const o=!!r?.useTrash,f=!!r?.recursive,b=r?.atomic??!1;await i.delete(s,{recursive:f,useTrash:o,atomic:b}),this._onDidRunOperation.fire(new g.FileOperationEvent(s,1))}async cloneFile(s,t){const i=await this.withProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(!(i===r&&this.getExtUri(i).providerExtUri.isEqual(s,t)))return i===r&&(0,g.hasFileCloneCapability)(i)?i.cloneFile(s,t):(await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),i===r&&(0,g.hasFileFolderCopyCapability)(i)?this.writeQueue.queueFor(s,()=>i.copy(s,t,{overwrite:!0}),this.getExtUri(i).providerExtUri):this.writeQueue.queueFor(s,()=>this.doCopyFile(i,s,r,t),this.getExtUri(i).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(s,t){return this.watch(s,{...t,correlationId:p.WATCHER_CORRELATION_IDS++})}watch(s,t={recursive:!1,excludes:[]}){const i=new a.DisposableStore;let r=!1,o=()=>{r=!0};i.add((0,a.toDisposable)(()=>o())),(async()=>{try{const b=await this.doWatch(s,t);r?(0,a.dispose)(b):o=()=>(0,a.dispose)(b)}catch(b){this.logService.error(b)}})();const f=t.correlationId;if(typeof f=="number"){const b=i.add(new x.Emitter);return i.add(this.internalOnDidFilesChange.event(L=>{L.correlates(f)&&b.fire(L)})),{onDidChange:b.event,dispose:()=>i.dispose()}}return i}async doWatch(s,t){const i=await this.withProvider(s),r=(0,P.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(s),t]);let o=this.activeWatchers.get(r);return o||(o={count:0,disposable:i.watch(s,t)},this.activeWatchers.set(r,o)),o.count+=1,(0,a.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,a.dispose)(o.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,a.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,t,i,r){return this.writeQueue.queueFor(t,async()=>{const o=await s.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,o,r):await this.doWriteReadableBufferedQueued(s,o,r)}catch(f){throw(0,g.ensureFileSystemProviderError)(f)}finally{await s.close(o)}},this.getExtUri(s).providerExtUri)}async doWriteStreamBufferedQueued(s,t,i){let r=0,o;if((0,m.isReadableBufferedStream)(i)){if(i.buffer.length>0){const f=D.VSBuffer.concat(i.buffer);await this.doWriteBuffer(s,t,f,f.byteLength,r,0),r+=f.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((f,b)=>{(0,m.listenStream)(o,{onData:async R=>{o.pause();try{await this.doWriteBuffer(s,t,R,R.byteLength,r,0)}catch(L){return b(L)}r+=R.byteLength,setTimeout(()=>o.resume())},onError:R=>b(R),onEnd:()=>f()})})}async doWriteReadableBufferedQueued(s,t,i){let r=0,o;for(;(o=i.read())!==null;)await this.doWriteBuffer(s,t,o,o.byteLength,r,0),r+=o.byteLength}async doWriteBuffer(s,t,i,r,o,f){let b=0;for(;b<r;){const R=await s.write(t,o+b,i.buffer,f+b,r-b);b+=R}}async doWriteUnbuffered(s,t,i,r){return this.writeQueue.queueFor(t,()=>this.doWriteUnbufferedQueued(s,t,i,r),this.getExtUri(s).providerExtUri)}async doWriteUnbufferedQueued(s,t,i,r){let o;r instanceof D.VSBuffer?o=r:(0,m.isReadableStream)(r)?o=await(0,D.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?o=await(0,D.bufferedStreamToBuffer)(r):o=(0,D.readableToBuffer)(r),await s.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(s,t,i,r){return this.writeQueue.queueFor(r,()=>this.doPipeBufferedQueued(s,t,i,r),this.getExtUri(i).providerExtUri)}async doPipeBufferedQueued(s,t,i,r){let o,f;try{o=await s.open(t,{create:!1}),f=await i.open(r,{create:!0,unlock:!1});const b=D.VSBuffer.alloc(this.BUFFER_SIZE);let R=0,L=0,N=0;do N=await s.read(o,R,b.buffer,L,b.byteLength-L),await this.doWriteBuffer(i,f,b,N,R,L),R+=N,L+=N,L===b.byteLength&&(L=0);while(N>0)}catch(b){throw(0,g.ensureFileSystemProviderError)(b)}finally{await k.Promises.settled([typeof o=="number"?s.close(o):Promise.resolve(),typeof f=="number"?i.close(f):Promise.resolve()])}}async doPipeUnbuffered(s,t,i,r){return this.writeQueue.queueFor(r,()=>this.doPipeUnbufferedQueued(s,t,i,r),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedQueued(s,t,i,r){return i.writeFile(r,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(s,t,i,r){return this.writeQueue.queueFor(r,()=>this.doPipeUnbufferedToBufferedQueued(s,t,i,r),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedToBufferedQueued(s,t,i,r){const o=await i.open(r,{create:!0,unlock:!1});try{const f=await s.readFile(t);await this.doWriteBuffer(i,o,D.VSBuffer.wrap(f),f.byteLength,0,0)}catch(f){throw(0,g.ensureFileSystemProviderError)(f)}finally{await i.close(o)}}async doPipeBufferedToUnbuffered(s,t,i,r){const o=await(0,D.streamToBuffer)(this.readFileBuffered(s,t,A.CancellationToken.None));await this.doWriteUnbuffered(i,r,void 0,o)}throwIfFileSystemIsReadonly(s,t){if(s.capabilities&2048)throw new g.FileOperationError((0,C.localize)(25,null,this.resourceForError(t)),6);return s}throwIfFileIsReadonly(s,t){if((t.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,C.localize)(26,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===E.Schemas.file?s.fsPath:s.toString(!0)}};e.FileService=v,e.FileService=v=p=ve([oe(0,u.ILogService)],v)}),define(ne[131],re([0,1,60,174,8,30,14,5,63,2,16,12,17,46,25,105,13,62,128,34,126,125]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l,u,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,k.gracefulify)(O)}catch(s){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(s)}`)}})();class n extends u.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new A.ResourceMap(r=>y.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:r}=await m.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await m.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async o=>{try{let f;o.isSymbolicLink()?f=(await this.stat((0,y.joinPath)(t,o.name))).type:f=this.toType(o),r.push([o.name,f])}catch(f){this.logService.trace(f)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let r;return i?.dangling?r=g.FileType.Unknown:t.isFile()?r=g.FileType.File:t.isDirectory()?r=g.FileType.Directory:r=g.FileType.Unknown,i&&(r|=g.FileType.SymbolicLink),r}async createResourceLock(t){const i=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const o=new D.Barrier;return this.resourceLocks.set(t,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let r;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),r=await this.createResourceLock(t));const o=this.toFilePath(t);return await m.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}traceLock(t){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,i,r){const o=(0,S.newWriteableStream)(f=>x.VSBuffer.concat(f.map(b=>x.VSBuffer.wrap(b))).buffer);return(0,l.readFileIntoStream)(this,t,o,f=>f.buffer,{...i,bufferSize:256*1024},r),o}async writeFile(t,i,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.canWriteFileAtomic(t)?this.doWriteFileAtomic(t,(0,y.joinPath)((0,y.dirname)(t),`${(0,y.basename)(t)}${r.atomic.postfix}`),i,r):this.doWriteFile(t,i,r)}async canWriteFileAtomic(t){try{const i=this.toFilePath(t),{symbolicLink:r}=await m.SymlinkSupport.stat(i);if(r)return!1}catch{}return!0}async doWriteFileAtomic(t,i,r,o){const f=new a.DisposableStore;try{f.add(await this.createResourceLock(t)),f.add(await this.createResourceLock(i)),await this.doWriteFile(i,r,o,!0);try{await this.rename(i,t,{overwrite:!0})}catch(b){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}finally{f.dispose()}}async doWriteFile(t,i,r,o){let f;try{const b=this.toFilePath(t);if(!r.create||!r.overwrite){if(await m.Promises.exists(b)){if(!r.overwrite)throw(0,g.createFileSystemProviderError)((0,C.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,g.createFileSystemProviderError)((0,C.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(t,{create:!0,unlock:r.unlock},o),await this.write(f,0,i,0,i.byteLength)}catch(b){throw await this.toFileSystemProviderWriteError(t,b)}finally{typeof f=="number"&&await this.close(f)}}static{this.canFlush=!0}static configureFlushOnWrite(t){n.canFlush=t}async open(t,i,r){const o=this.toFilePath(t);let f;(0,g.isFileOpenForWriteOptions)(i)&&!r&&(f=await this.createResourceLock(t));let b;try{if((0,g.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:L}=await m.SymlinkSupport.stat(o);L.mode&128||await m.Promises.chmod(o,L.mode|128)}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}let R;if((0,g.isFileOpenForWriteOptions)(i)){if(E.isWindows)try{await m.Promises.truncate(o,0),R="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}R||(R="w")}else R="r";b=await m.Promises.open(o,R)}catch(R){throw f?.dispose(),(0,g.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,R):this.toFileSystemProviderError(R)}if(this.mapHandleToPos.set(b,0),(0,g.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(b,t),f){const R=this.mapHandleToLock.get(b);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${o})`),this.mapHandleToLock.set(b,f),R&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${o})`),R.dispose())}return b}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&n.canFlush)try{await m.Promises.fdatasync(t)}catch(r){n.configureFlushOnWrite(!1),this.logService.error(r)}return await m.Promises.close(t)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,r,o,f){const b=this.normalizePos(t,i);let R=null;try{R=(await m.Promises.read(t,r,o,f,b)).bytesRead}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(t,b,R)}return R}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,r){const o=this.mapHandleToPos.get(t);typeof o=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(t,o+r):this.mapHandleToPos.delete(t)))}async write(t,i,r,o,f){return(0,D.retry)(()=>this.doWrite(t,i,r,o,f),100,3)}async doWrite(t,i,r,o,f){const b=this.normalizePos(t,i);let R=null;try{R=(await m.Promises.write(t,r,o,f,b)).bytesWritten}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),L)}finally{this.updatePos(t,b,R)}return R}async mkdir(t){try{await m.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const r=this.toFilePath(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,h.join)((0,h.dirname)(r),`${(0,h.basename)(r)}${i.atomic.postfix}`)),await m.Promises.rm(r,m.RimRafMode.MOVE,o)}else try{await m.Promises.unlink(r)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let f=!1;try{const{stat:b,symbolicLink:R}=await m.SymlinkSupport.stat(r);f=b.isDirectory()&&!R}catch{}if(f)await m.Promises.rmdir(r);else throw o}else throw o}}catch(r){throw this.toFileSystemProviderError(r)}}async rename(t,i,r){const o=this.toFilePath(t),f=this.toFilePath(i);if(o!==f)try{await this.validateMoveCopy(t,i,"move",r.overwrite),await m.Promises.rename(o,f)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,C.localize)(2,null,(0,h.basename)(o),(0,h.basename)((0,h.dirname)(f)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(t,i,r){const o=this.toFilePath(t),f=this.toFilePath(i);if(o!==f)try{await this.validateMoveCopy(t,i,"copy",r.overwrite),await m.Promises.copy(o,f,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,C.localize)(3,null,(0,h.basename)(o),(0,h.basename)((0,h.dirname)(f)),b.toString()))),this.toFileSystemProviderError(b)}}async validateMoveCopy(t,i,r,o){const f=this.toFilePath(t),b=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,c.isEqual)(f,b,!0)),R){if(r==="copy")throw(0,g.createFileSystemProviderError)((0,C.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const N=await this.statIgnoreError(t);if(!N)throw(0,g.createFileSystemProviderError)((0,C.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const _=await this.statIgnoreError(i);if(_){if(!o)throw(0,g.createFileSystemProviderError)((0,C.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);N.type&g.FileType.File&&_.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,r){const o=this.toFilePath(t),f=this.toFilePath(i),b=!!(this.capabilities&1024);if((0,c.isEqual)(o,f,!b))return;const R=new a.DisposableStore;try{R.add(await this.createResourceLock(t)),R.add(await this.createResourceLock(i)),r&&await m.Promises.mkdir((0,h.dirname)(f),{recursive:!0}),await m.Promises.copyFile(o,f)}catch(L){if(L.code==="ENOENT"&&!r)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(L)}finally{R.dispose()}}createUniversalWatcher(t,i,r){return new p.UniversalWatcherClient(o=>t(o),o=>i(o),r)}createNonRecursiveWatcher(t,i,r){return new v.NodeJSWatcherClient(o=>t(o),o=>i(o),r)}toFileSystemProviderError(t){if(t instanceof g.FileSystemProviderError)return t;let i=t,r;switch(t.code){case"ENOENT":r=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=g.FileSystemProviderErrorCode.Unknown;break;default:r=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(t,i){let r=this.toFileSystemProviderError(i);if(t&&r.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await m.SymlinkSupport.stat(this.toFilePath(t));o.mode&128||(r=(0,g.createFileSystemProviderError)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=n}),define(ne[132],re([0,1,2,6]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends O.Disposable{constructor(x,P=[]){super(),this.logger=new k.MultiplexLogger([x,...P]),this._register(x.onDidChangeLogLevel(c=>this.setLevel(c)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(x){this.logger.setLevel(x)}getLevel(){return this.logger.getLevel()}trace(x,...P){this.logger.trace(x,...P)}debug(x,...P){this.logger.debug(x,...P)}info(x,...P){this.logger.info(x,...P)}warn(x,...P){this.logger.warn(x,...P)}error(x,...P){this.logger.error(x,...P)}flush(){this.logger.flush()}}e.LogService=D}),define(ne[133],re([0,1,13,6]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var D;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(D||(D={}));async function A(a,h,E,y,S){try{const m=await new Promise((g,l)=>{K(["@vscode/spdlog"],g,l)});m.setFlushOn(D.Trace);const C=await m.createAsyncRotatingLogger(a,h,E,y);return S?C.clearFormatters():C.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),C}catch(m){console.error(m)}return null}function x(a,h,E){switch(h){case k.LogLevel.Trace:a.trace(E);break;case k.LogLevel.Debug:a.debug(E);break;case k.LogLevel.Info:a.info(E);break;case k.LogLevel.Warning:a.warn(E);break;case k.LogLevel.Error:a.error(E);break;case k.LogLevel.Off:break;default:throw new Error(`Invalid log level ${h}`)}}function P(a,h){switch(h){case k.LogLevel.Trace:a.setLevel(D.Trace);break;case k.LogLevel.Debug:a.setLevel(D.Debug);break;case k.LogLevel.Info:a.setLevel(D.Info);break;case k.LogLevel.Warning:a.setLevel(D.Warning);break;case k.LogLevel.Error:a.setLevel(D.Error);break;case k.LogLevel.Off:a.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${h}`)}}class c extends k.AbstractMessageLogger{constructor(h,E,y,S,m){super(),this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(h,E,y,S),this._register(this.onDidChangeLogLevel(C=>{this._logger&&P(this._logger,C)}))}async _createSpdLogLogger(h,E,y,S){const m=y?6:1,C=30/m*O.ByteSize.MB,g=await A(h,E,C,m,S);if(g){this._logger=g,P(this._logger,this.getLevel());for(const{level:l,message:u}of this.buffer)x(this._logger,l,u);this.buffer=[]}}log(h,E){this._logger?x(this._logger,h,E):this.getLevel()<=h&&this.buffer.push({level:h,message:E})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=c}),define(ne[134],re([0,1,28,6,133]),function(K,e,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends k.AbstractLoggerService{doCreateLogger(P,c,a){return new D.SpdLogLogger((0,O.generateUuid)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,c)}}e.LoggerService=A}),define(ne[39],re([0,1,5,66,2,10]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class x extends D.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(a){const h=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...a,...this.policyDefinitions},h!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(a),k.Iterable.reduce(this.policies.entries(),(E,[y,S])=>({...E,[y]:S}),{})}getPolicyValue(a){return this.policies.get(a)}serialize(){return k.Iterable.reduce(Object.entries(this.policyDefinitions),(a,[h,E])=>({...a,[h]:{definition:E,value:this.policies.get(h)}}),{})}}e.AbstractPolicyService=x;class P{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ne[135],re([0,1,8,5,66,3,13,6,39]),function(K,e,O,k,D,A,x,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function a(E,y){const S=[];for(const m of new Set(D.Iterable.concat(E.keys(),y.keys())))E.get(m)!==y.get(m)&&S.push(m);return S}let h=class extends c.AbstractPolicyService{constructor(y,S,m){super(),this.file=y,this.fileService=S,this.logService=m,this.throttledDelayer=this._register(new O.ThrottledDelayer(500));const C=k.Event.filter(S.onDidFilesChange,g=>g.affects(y));this._register(S.watch(y)),this._register(C(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const y=new Map;try{const S=await this.fileService.readFile(this.file),m=JSON.parse(S.value.toString());if(!(0,A.isObject)(m))throw new Error("Policy file isn't a JSON object");for(const C of Object.keys(m))this.policyDefinitions[C]&&y.set(C,m[C])}catch(S){S.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",S)}return y}async refresh(){const y=await this.read(),S=a(this.policies,y);this.policies=y,S.length>0&&this._onDidChange.fire(S)}};e.FilePolicyService=h,e.FilePolicyService=h=ve([oe(1,x.IFileService),oe(2,P.ILogService)],h)}),define(ne[136],re([0,1,39,8,2,6]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let x=class extends O.AbstractPolicyService{constructor(c,a){super(),this.logService=c,this.productName=a,this.throttler=new k.Throttler,this.watcher=this._register(new D.MutableDisposable)}async _updatePolicyDefinitions(c){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`);const{createWatcher:a}=await new Promise((h,E)=>{K(["@vscode/policy-watcher"],h,E)});await this.throttler.queue(()=>new Promise((h,E)=>{try{this.watcher.value=a(this.productName,c,y=>{this._onDidPolicyChange(y),h()})}catch(y){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),E(y)}}))}_onDidPolicyChange(c){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const a in c){const h=c[a];h===void 0?this.policies.delete(a):this.policies.set(a,h)}this._onDidChange.fire(Object.keys(c))}};e.NativePolicyService=x,e.NativePolicyService=x=ve([oe(0,A.ILogService)],x)}),define(ne[32],re([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,O.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,73,3]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(x,P){O.ok(k.isString(x)),O.ok(k.isObject(P)),O.ok(!this.data.has(x),"There is already an extension with this id"),this.data.set(x,P)}knows(x){return this.data.has(x)}as(x){return this.data.get(x)||null}}e.Registry=new D}),define(ne[137],re([0,1,5,36]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,a){this.schemasById[D(c)]=a,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const x=new A;k.Registry.add(e.Extensions.JSONContribution,x)}),define(ne[40],re([0,1,19,5,3,92,29,137,36]),function(K,e,O,k,D,A,x,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=C,e.keyFromOverrideIdentifiers=g,e.getDefaultValue=l,e.validateProperty=w,e.getScopes=p;var a;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var h;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(h||(e.ConfigurationScope=h={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=c.Registry.as(P.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const t=new Set;this.doRegisterConfigurations(n,s,t),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(n){const s=new Set;this.doDeregisterConfigurations(n,s),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:n,remove:s}){const t=new Set;this.doDeregisterConfigurations(s,t),this.doRegisterConfigurations(n,!1,t),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}registerDefaultConfigurations(n){const s=new Set;this.doRegisterDefaultConfigurations(n,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(n,s){const t=[];for(const{overrides:i,source:r}of n)for(const o in i)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const f=this.configurationDefaultsOverrides.get(o),b=f?.valuesSources??new Map;if(r)for(const _ of Object.keys(i[o]))b.set(_,r);const R={...f?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:r,value:R,valuesSources:b});const L=(0,x.getLanguageTagSettingPlainKey)(o),N={type:"object",default:R,description:A.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:D.isString(r)?void 0:r,defaultValueSource:r};t.push(...C(o)),this.configurationProperties[o]=N,this.defaultLanguageConfigurationOverridesNode.properties[o]=N}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:r});const f=this.configurationProperties[o];f&&(this.updatePropertyDefaultValue(o,f),this.updateSchema(o,f))}this.doRegisterOverrideIdentifiers(t)}deregisterDefaultConfigurations(n){const s=new Set;this.doDeregisterDefaultConfigurations(n,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(n,s){for(const{overrides:t,source:i}of n)for(const r in t){const o=this.configurationDefaultsOverrides.get(r),f=D.isString(i)?i:i?.id,b=D.isString(o?.source)?o?.source:o?.source?.id;if(f===b)if(s.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const R=this.configurationProperties[r];R&&(this.updatePropertyDefaultValue(r,R),this.updateSchema(r,R))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(n){let s=!1;const t=new Set;n.removedDefaults&&(this.doDeregisterDefaultConfigurations(n.removedDefaults,t),s=!0),n.addedDefaults&&(this.doRegisterDefaultConfigurations(n.addedDefaults,t),s=!0),n.removedConfigurations&&this.doDeregisterConfigurations(n.removedConfigurations,t),n.addedConfigurations&&this.doRegisterConfigurations(n.addedConfigurations,!1,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){this.doRegisterOverrideIdentifiers(n),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(n){for(const s of n)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,s,t){n.forEach(i=>{this.validateAndRegisterProperties(i,s,i.extensionInfo,i.restrictedProperties,void 0,t),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(n,s){const t=i=>{if(i.properties)for(const r in i.properties){s.add(r);const o=this.configurationProperties[r];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>t(r))};for(const i of n){t(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(n,s=!0,t,i,r=3,o){r=D.isUndefinedOrNull(n.scope)?r:n.scope;const f=n.properties;if(f)for(const R in f){const L=f[R];if(s&&w(R,L)){delete f[R];continue}if(L.source=t,L.defaultDefaultValue=f[R].default,this.updatePropertyDefaultValue(R,L),e.OVERRIDE_PROPERTY_REGEX.test(R)?L.scope=void 0:(L.scope=D.isUndefinedOrNull(L.scope)?r:L.scope,L.restricted=D.isUndefinedOrNull(L.restricted)?!!i?.includes(R):L.restricted),f[R].hasOwnProperty("included")&&!f[R].included){this.excludedConfigurationProperties[R]=f[R],delete f[R];continue}else this.configurationProperties[R]=f[R],f[R].policy?.name&&this.policyConfigurations.set(f[R].policy.name,R);!f[R].deprecationMessage&&f[R].markdownDeprecationMessage&&(f[R].deprecationMessage=f[R].markdownDeprecationMessage),o.add(R)}const b=n.allOf;if(b)for(const R of b)this.validateAndRegisterProperties(R,s,t,i,r,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const s=t=>{const i=t.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);t.allOf?.forEach(s)};s(n)}updateSchema(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.resourceLanguageSettingsSchema.properties[n]=s;break}}removeFromSchema(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const s=`[${n}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}}registerOverridePropertyPatternKey(){const n={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,s){const t=this.configurationDefaultsOverrides.get(n);let i=t?.value,r=t?.source;D.isUndefined(i)&&(i=s.defaultDefaultValue,r=void 0),D.isUndefined(i)&&(i=l(s.type)),s.default=i,s.defaultValueSource=r}}const S="\\[([^\\]]+)\\]",m=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function C(v){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let s=m.exec(v);for(;s?.length;){const t=s[1].trim();t&&n.push(t),s=m.exec(v)}}return(0,O.distinct)(n)}function g(v){return v.reduce((n,s)=>`${n}[${s}]`,"")}function l(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new y;c.Registry.add(e.Extensions.Configuration,u);function w(v,n){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?A.localize(7,null,v):u.getConfigurationProperties()[v]!==void 0?A.localize(8,null,v):n.policy?.name&&u.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(9,null,v,n.policy?.name,u.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(6,null)}function p(){const v=[],n=u.getConfigurationProperties();for(const s of Object.keys(n))v.push([s,n[s].scope]);return v.push(["launch",4]),v.push(["task",4]),v}}),define(ne[67],re([0,1,19,5,38,2,30,27,3,11,29,40,36]),function(K,e,O,k,D,A,x,P,c,a,h,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=w;function S(s){return Object.isFrozen(s)?s:P.deepFreeze(s)}class m{static createEmptyModel(t){return new m({},[],[],void 0,t)}constructor(t,i,r,o,f){this._contents=t,this._keys=i,this._overrides=r,this.raw=o,this.logService=f,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof m)return i;const r=new C("",this.logService);return r.parseRaw(i),r.configurationModel});this._rawConfiguration=t.reduce((i,r)=>r===i?r:i.merge(r),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,h.getConfigurationValue)(this.contents,t):this.contents}inspect(t,i){const r=this;return{get value(){return S(r.rawConfiguration.getValue(t))},get override(){return i?S(r.rawConfiguration.getOverrideValue(t,i)):void 0},get merged(){return S(i?r.rawConfiguration.override(i).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:f,identifiers:b,keys:R}of r.rawConfiguration.overrides){const L=new m(f,R,[],void 0,r.logService).getValue(t);L!==void 0&&o.push({identifiers:b,value:L})}return o.length?S(o):void 0}}}getOverrideValue(t,i){const r=this.getContentsForOverrideIdentifer(i);return r?t?(0,h.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const r of this.overrides)r.identifiers.includes(t)&&i.push(...r.keys);return O.distinct(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return O.distinct(t)}override(t){let i=this.overrideConfigurations.get(t);return i||(i=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,i)),i}merge(...t){const i=P.deepClone(this.contents),r=P.deepClone(this.overrides),o=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const b of t)if(f.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.mergeContents(i,b.contents);for(const R of b.overrides){const[L]=r.filter(N=>O.equals(N.identifiers,R.identifiers));L?(this.mergeContents(L.contents,R.contents),L.keys.push(...R.keys),L.keys=O.distinct(L.keys)):r.push(P.deepClone(R))}for(const R of b.keys)o.indexOf(R)===-1&&o.push(R)}return new m(i,o,r,f.every(b=>b instanceof m)?void 0:f,this.logService)}createOverrideConfigurationModel(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of O.distinct([...Object.keys(this.contents),...Object.keys(i)])){let f=this.contents[o];const b=i[o];b&&(typeof f=="object"&&typeof b=="object"?(f=P.deepClone(f),this.mergeContents(f,b)):f=b),r[o]=f}return new m(r,this.keys,this.overrides,void 0,this.logService)}mergeContents(t,i){for(const r of Object.keys(i)){if(r in t&&c.isObject(t[r])&&c.isObject(i[r])){this.mergeContents(t[r],i[r]);continue}t[r]=P.deepClone(i[r])}}getContentsForOverrideIdentifer(t){let i=null,r=null;const o=f=>{f&&(r?this.mergeContents(r,f):r=P.deepClone(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===t?i=f.contents:f.identifiers.includes(t)&&o(f.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.updateValue(t,i,!0)}setValue(t,i){this.updateValue(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,h.removeFromValueTree)(this.contents,t),E.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>O.equals(r.identifiers,(0,E.overrideIdentifiersFromKey)(t))),1))}updateValue(t,i,r){(0,h.addToValueTree)(this.contents,t,i,o=>this.logService.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),E.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,h.toValuesTree)(this.contents[t],o=>this.logService.error(o))})}}e.ConfigurationModel=m;class C{constructor(t,i){this._name=t,this.logService=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||m.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!c.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:r,keys:o,overrides:f,restricted:b,hasExcludedProperties:R}=this.doParseRaw(t,i);this._configurationModel=new m(r,o,f,R?[t]:void 0,this.logService),this._restrictedConfigurations=b||[]}doParseContent(t){let i={},r=null,o=[];const f=[],b=[];function R(N){Array.isArray(o)?o.push(N):r!==null&&(o[r]=N)}const L={onObjectBegin:()=>{const N={};R(N),f.push(o),o=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{o=f.pop()},onArrayBegin:()=>{const N=[];R(N),f.push(o),o=N,r=null},onArrayEnd:()=>{o=f.pop()},onLiteralValue:R,onError:(N,_,V)=>{b.push({error:N,offset:_,length:V})}};if(t)try{D.visit(t,L),i=o[0]||{}}catch(N){this.logService.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return i}doParseRaw(t,i){const r=y.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,r,!0,i);t=o.raw;const f=(0,h.toValuesTree)(t,L=>this.logService.error(`Conflict in settings file ${this._name}: ${L}`)),b=Object.keys(t),R=this.toOverrides(t,L=>this.logService.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:f,keys:b,overrides:R,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(t,i,r,o){let f=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:f};const b={},R=[];for(const L in t)if(E.OVERRIDE_PROPERTY_REGEX.test(L)&&r){const N=this.filter(t[L],i,!1,o);b[L]=N.raw,f=f||N.hasExcludedProperties,R.push(...N.restricted)}else{const N=i[L],_=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&R.push(L),!o.exclude?.includes(L)&&(o.include?.includes(L)||(_===void 0||o.scopes===void 0||o.scopes.includes(_))&&!(o.skipRestricted&&N?.restricted))?b[L]=t[L]:f=!0}return{raw:b,restricted:R,hasExcludedProperties:f}}toOverrides(t,i){const r=[];for(const o of Object.keys(t))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const f={};for(const b in t[o])f[b]=t[o][b];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(f),contents:(0,h.toValuesTree)(f,i)})}return r}}e.ConfigurationModelParser=C;class g extends A.Disposable{constructor(t,i,r,o,f){super(),this.userSettingsResource=t,this.parseOptions=i,this.fileService=o,this.logService=f,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString(),f),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.any(k.Event.filter(this.fileService.onDidFilesChange,b=>b.contains(this.userSettingsResource)),k.Event.filter(this.fileService.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&r.isEqual(b.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return m.createEmptyModel(this.logService)}}reparse(t){return t&&(this.parseOptions=t),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class l{constructor(t,i,r,o,f,b,R,L,N,_,V,H,se){this.key=t,this.overrides=i,this._value=r,this.overrideIdentifiers=o,this.defaultConfiguration=f,this.policyConfiguration=b,this.applicationConfiguration=R,this.userConfiguration=L,this.localUserConfiguration=N,this.remoteUserConfiguration=_,this.workspaceConfiguration=V,this.folderConfigurationModel=H,this.memoryConfigurationModel=se}get value(){return S(this._value)}toInspectValue(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class u{constructor(t,i,r,o,f,b,R,L,N,_){this._defaultConfiguration=t,this._policyConfiguration=i,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=f,this._workspaceConfiguration=b,this._folderConfigurations=R,this._memoryConfiguration=L,this._memoryConfigurationByResource=N,this.logService=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new x.ResourceMap,this._userConfiguration=null}getValue(t,i,r){return this.getConsolidatedConfigurationModel(t,i,r).getValue(t)}updateValue(t,i,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=m.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,r){const o=this.getConsolidatedConfigurationModel(t,i,r),f=this.getFolderConfigurationModelForResource(i.resource,r),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,R=new Set;for(const L of o.overrides)for(const N of L.identifiers)o.getOverrideValue(t,N)!==void 0&&R.add(N);return new l(t,i,o.getValue(t),R.size?[...R]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,f||void 0,b)}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const r=[];if(!i){const{added:o,updated:f,removed:b}=v(this._defaultConfiguration,t);i=[...o,...f,...b]}for(const o of i)for(const f of(0,E.overrideIdentifiersFromKey)(o)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(f),R=t.getKeysForOverrideIdentifier(f),L=[...R.filter(N=>b.indexOf(N)===-1),...b.filter(N=>R.indexOf(N)===-1),...b.filter(N=>!P.equals(this._defaultConfiguration.override(f).getValue(N),t.override(f).getValue(N)))];r.push([f,L])}return this.updateDefaultConfiguration(t),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:r,removed:o}=v(this._policyConfiguration,t),f=[...i,...r,...o];return f.length&&this.updatePolicyConfiguration(t),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:r,removed:o,overrides:f}=v(this.applicationConfiguration,t),b=[...i,...r,...o];return b.length&&this.updateApplicationConfiguration(t),{keys:b,overrides:f}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:r,removed:o,overrides:f}=v(this.localUserConfiguration,t),b=[...i,...r,...o];return b.length&&this.updateLocalUserConfiguration(t),{keys:b,overrides:f}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:r,removed:o,overrides:f}=v(this.remoteUserConfiguration,t),b=[...i,...r,...o];return b.length&&this.updateRemoteUserConfiguration(t),{keys:b,overrides:f}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:r,removed:o,overrides:f}=v(this.workspaceConfiguration,t),b=[...i,...r,...o];return b.length&&this.updateWorkspaceConfiguration(t),{keys:b,overrides:f}}compareAndUpdateFolderConfiguration(t,i){const r=this.folderConfigurations.get(t),{added:o,updated:f,removed:b,overrides:R}=v(r,i),L=[...o,...f,...b];return(L.length||!r)&&this.updateFolderConfiguration(t,i),{keys:L,overrides:R}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:f,overrides:b}=v(i,void 0);return{keys:[...r,...o,...f],overrides:b}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,i,r){let o=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:t},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const f=this._memoryConfigurationByResource.get(t);f&&(r=r.merge(f))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=r.merge(o),this._foldersConsolidatedConfigurations.set(t,i)):i=r}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const r=i.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:r,overrides:o,keys:f}=this._folderConfigurations.get(i);return t.push([i,{contents:r,overrides:o,keys:f}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this._workspaceConfiguration.keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(r=>t.add(r))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t,i){const r=this.parseConfigurationModel(t.defaults,i),o=this.parseConfigurationModel(t.policy,i),f=this.parseConfigurationModel(t.application,i),b=this.parseConfigurationModel(t.user,i),R=this.parseConfigurationModel(t.workspace,i),L=t.folders.reduce((N,_)=>(N.set(a.URI.revive(_[0]),this.parseConfigurationModel(_[1],i)),N),new x.ResourceMap);return new u(r,o,f,b,m.createEmptyModel(i),R,L,m.createEmptyModel(i),new x.ResourceMap,i)}static parseConfigurationModel(t,i){return new m(t.contents,t.keys,t.overrides,void 0,i)}}e.Configuration=u;function w(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,i=new Map;for(const o of s)o.keys.forEach(f=>t.add(f)),o.overrides.forEach(([f,b])=>{const R=(0,x.getOrSet)(i,f,new Set);b.forEach(L=>R.add(L))});const r=[];return i.forEach((o,f)=>r.push([f,[...o.values()]])),{keys:[...t.values()],overrides:r}}class p{constructor(t,i,r,o,f){this.change=t,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=o,this.logService=f,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const b of t.keys)this.affectedKeys.add(b);for(const[,b]of t.overrides)for(const R of b)this.affectedKeys.add(R);this._affectsConfigStr=this._marker;for(const b of this.affectedKeys)this._affectsConfigStr+=b+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(t,i){const r=this._marker+t,o=this._affectsConfigStr.indexOf(r);if(o<0)return!1;const f=o+r.length;if(f>=this._affectsConfigStr.length)return!1;const b=this._affectsConfigStr.charCodeAt(f);if(b!==this._markerCode1&&b!==this._markerCode2)return!1;if(i){const R=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.previous?.workspace):void 0,L=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!P.equals(R,L)}return!0}}e.ConfigurationChangeEvent=p;function v(s,t){const{added:i,removed:r,updated:o}=n(t?.rawConfiguration,s?.rawConfiguration),f=[],b=s?.getAllOverrideIdentifiers()||[],R=t?.getAllOverrideIdentifiers()||[];if(t){const L=R.filter(N=>!b.includes(N));for(const N of L)f.push([N,t.getKeysForOverrideIdentifier(N)])}if(s){const L=b.filter(N=>!R.includes(N));for(const N of L)f.push([N,s.getKeysForOverrideIdentifier(N)])}if(t&&s){for(const L of b)if(R.includes(L)){const N=n({contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)},{contents:t.getOverrideValue(void 0,L)||{},keys:t.getKeysForOverrideIdentifier(L)});f.push([L,[...N.added,...N.removed,...N.updated]])}}return{added:i,removed:r,updated:o,overrides:f}}function n(s,t){const i=s?t?s.keys.filter(f=>t.keys.indexOf(f)===-1):[...s.keys]:[],r=t?s?t.keys.filter(f=>s.keys.indexOf(f)===-1):[...t.keys]:[],o=[];if(s&&t){for(const f of t.keys)if(s.keys.indexOf(f)!==-1){const b=(0,h.getConfigurationValue)(t.contents,f),R=(0,h.getConfigurationValue)(s.contents,f);P.equals(b,R)||o.push(f)}}return{added:i,removed:r,updated:o}}}),define(ne[138],re([0,1,19,5,2,27,3,67,40,6,39,36]),function(K,e,O,k,D,A,x,P,c,a,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends D.Disposable{get configurationModel(){return this._configurationModel}constructor(g){super(),this.logService=g,this._onDidChangeConfiguration=this._register(new k.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=P.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(E.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:l})=>this.onDidUpdateConfiguration(Array.from(g),l))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(g,l){this.updateConfigurationModel(g,E.Registry.as(c.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=P.ConfigurationModel.createEmptyModel(this.logService);const g=E.Registry.as(c.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(g),g)}updateConfigurationModel(g,l){const u=this.getConfigurationDefaultOverrides();for(const w of g){const p=u[w],v=l[w];p!==void 0?this._configurationModel.addValue(w,p):v?this._configurationModel.addValue(w,v.default):this._configurationModel.removeValue(w)}}}e.DefaultConfiguration=y;class S{constructor(){this.onDidChangeConfiguration=k.Event.None,this.configurationModel=P.ConfigurationModel.createEmptyModel(new a.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let m=class extends D.Disposable{get configurationModel(){return this._configurationModel}constructor(g,l,u){super(),this.defaultConfiguration=g,this.policyService=l,this.logService=u,this._onDidChangeConfiguration=this._register(new k.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=P.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.updatePolicyDefinitions(g),!0))),this._configurationModel}async updatePolicyDefinitions(g){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",g);const l={},u=[],w=E.Registry.as(c.Extensions.Configuration).getConfigurationProperties();for(const p of g){const v=w[p];if(!v){u.push(p);continue}if(v.policy){if(v.type!=="string"&&v.type!=="number"){this.logService.warn(`Policy ${v.policy.name} has unsupported type ${v.type}`);continue}u.push(p),l[v.policy.name]={type:v.type}}}return(0,x.isEmptyObject)(l)||await this.policyService.updatePolicyDefinitions(l),u}onDidChangePolicies(g){this.logService.trace("PolicyConfiguration#onDidChangePolicies",g);const l=E.Registry.as(c.Extensions.Configuration).getPolicyConfigurations(),u=(0,O.coalesce)(g.map(w=>l.get(w)));this.update(u,!0)}update(g,l){this.logService.trace("PolicyConfiguration#update",g);const u=E.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),w=[],p=this._configurationModel.isEmpty();for(const v of g){const n=u[v]?.policy?.name;if(n){const s=this.policyService.getPolicyValue(n);(p?s!==void 0:!(0,A.equals)(this._configurationModel.getValue(v),s))&&w.push([v,s])}else this._configurationModel.getValue(v)!==void 0&&w.push([v,void 0])}if(w.length){this.logService.trace("PolicyConfiguration#changed",w);const v=this._configurationModel;this._configurationModel=P.ConfigurationModel.createEmptyModel(this.logService);for(const n of v.keys)this._configurationModel.setValue(n,v.getValue(n));for(const[n,s]of w)s===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,s);l&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=m,e.PolicyConfiguration=m=ve([oe(1,h.IPolicyService),oe(2,a.ILogService)],m)}),define(ne[139],re([0,1,19,8,14,5,38,75,2,30,27,12,17,29,67,40,138,39]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class u extends c.Disposable{constructor(v,n,s,t){super(),this.settingsResource=v,this.logService=t,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new g.DefaultConfiguration(t)),this.policyConfiguration=s instanceof l.NullPolicyService?new g.NullPolicyConfiguration:this._register(new g.PolicyConfiguration(this.defaultConfiguration,s,t)),this.userConfiguration=this._register(new m.UserSettings(this.settingsResource,{},y.extUriBiasedIgnorePathCase,n,t)),this.configuration=new m.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,m.ConfigurationModel.createEmptyModel(t),m.ConfigurationModel.createEmptyModel(t),m.ConfigurationModel.createEmptyModel(t),m.ConfigurationModel.createEmptyModel(t),new a.ResourceMap,m.ConfigurationModel.createEmptyModel(t),new a.ResourceMap,t),this.configurationEditing=new w(v,n,this),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:i,properties:r})=>this.onDidDefaultConfigurationChange(i,r))),this._register(this.policyConfiguration.onDidChangeConfiguration(i=>this.onDidPolicyConfigurationChange(i))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,n,s]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new m.Configuration(v,n,m.ConfigurationModel.createEmptyModel(this.logService),s,m.ConfigurationModel.createEmptyModel(this.logService),m.ConfigurationModel.createEmptyModel(this.logService),new a.ResourceMap,m.ConfigurationModel.createEmptyModel(this.logService),new a.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(v,n){const s=typeof v=="string"?v:void 0,t=(0,S.isConfigurationOverrides)(v)?v:(0,S.isConfigurationOverrides)(n)?n:{};return this.configuration.getValue(s,t,void 0)}async updateValue(v,n,s,t,i){const r=(0,S.isConfigurationUpdateOverrides)(s)?s:(0,S.isConfigurationOverrides)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,o=r?t:s;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${v} to target ${o}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,O.distinct)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const f=this.inspect(v,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(f.policyValue!==void 0)throw new Error(`Unable to write ${v} because it is configured in system policy.`);if((0,h.equals)(n,f.defaultValue)&&(n=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const R=r.overrideIdentifiers.sort(),L=this.configuration.localUserConfiguration.overrides.find(N=>(0,O.equals)([...N.identifiers].sort(),R));L&&(r.overrideIdentifiers=L.identifiers)}const b=r?.overrideIdentifiers?.length?[(0,C.keyFromOverrideIdentifiers)(r.overrideIdentifiers),v]:[v];await this.configurationEditing.write(b,n),await this.reloadConfiguration()}inspect(v,n={}){return this.configuration.inspect(v,n,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const n=this.configuration.toData(),s=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(s,n,2)}onDidDefaultConfigurationChange(v,n){const s=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(v,n);this.trigger(t,s,7)}onDidPolicyConfigurationChange(v){const n=this.configuration.toData(),s=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(s,n,7)}trigger(v,n,s){const t=new m.ConfigurationChangeEvent(v,{data:n},this.configuration,void 0,this.logService);t.source=s,this._onDidChangeConfiguration.fire(t)}}e.ConfigurationService=u;class w{constructor(v,n,s){this.settingsResource=v,this.fileService=n,this.configurationService=s,this.queue=new k.Queue}write(v,n){return this.queue.queue(()=>this.doWriteConfiguration(v,n))}async doWriteConfiguration(v,n){let s;try{s=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(r){if(r.fileOperationResult===1)s="{}";else throw r}const t=[];if((0,x.parse)(s,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.getEdits(s,v,n);s=(0,P.applyEdits)(s,i),await this.fileService.writeFile(this.settingsResource,D.VSBuffer.fromString(s))}getEdits(v,n,s){const{tabSize:t,insertSpaces:i,eol:r}=this.formattingOptions;if(!n.length){const o=JSON.stringify(s,null,i?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,P.setProperty)(v,n,s,{tabSize:t,insertSpaces:i,eol:r})}get formattingOptions(){if(!this._formattingOptions){let v=E.OS===3||E.OS===2?`
`:`\r
`;const n=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(v=n),this._formattingOptions={eol:v,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ne[68],re([0,1,15]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=k,e.getRemoteName=D,e.parseAuthorityWithPort=A,e.parseAuthorityWithOptionalPort=x;function k(c){return c.scheme===O.Schemas.vscodeRemote?c.authority:void 0}function D(c){if(!c)return;const a=c.indexOf("+");return a<0?c:c.substr(0,a)}function A(c){const{host:a,port:h}=P(c);if(typeof h>"u")throw new Error(`Invalid remote authority: ${c}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:h}}function x(c,a){let{host:h,port:E}=P(c);return typeof E>"u"&&(E=a),{host:h,port:E}}function P(c){const a=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const h=c.match(/^(\[[0-9a-z:]+\])$/);if(h)return{host:h[1],port:void 0};const E=c.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,31,10,68]),function(K,e,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=A,e.isApplicationScopedExtension=E,e.isLanguagePackExtension=y,e.isAuthenticationProviderExtension=S,e.isResolverExtension=m,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(C){if(typeof C=="object"&&C!==null&&C.supported!==!0)return C.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var x;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(x||(e.ExtensionType=x={}));var P;(function(C){C.WIN32_X64="win32-x64",C.WIN32_ARM64="win32-arm64",C.LINUX_X64="linux-x64",C.LINUX_ARM64="linux-arm64",C.LINUX_ARMHF="linux-armhf",C.LINUX_PPC64LE="linux-ppc64le",C.LINUX_RISCV64="linux-riscv64",C.ALPINE_X64="alpine-x64",C.ALPINE_ARM64="alpine-arm64",C.DARWIN_X64="darwin-x64",C.DARWIN_ARM64="darwin-arm64",C.WEB="web",C.UNIVERSAL="universal",C.UNKNOWN="unknown",C.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class c{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,l){if(typeof g>"u"||g===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof g=="string"||typeof l=="string"){const u=typeof g=="string"?g:g.value,w=typeof l=="string"?l:l.value;return O.equalsIgnoreCase(u,w)}return g._lower===l._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=c;class a{get size(){return this._set.size}constructor(g){if(this._set=new Set,g)for(const l of g)this.add(l)}add(g){this._set.add(c.toKey(g))}delete(g){return this._set.delete(c.toKey(g))}has(g){return this._set.has(c.toKey(g))}}e.ExtensionIdentifierSet=a;class h{constructor(){this._map=new Map}clear(){this._map.clear()}delete(g){this._map.delete(c.toKey(g))}get(g){return this._map.get(c.toKey(g))}has(g){return this._map.has(c.toKey(g))}set(g,l){this._map.set(c.toKey(g),l)}values(){return this._map.values()}forEach(g){this._map.forEach(g)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=h;function E(C){return y(C)}function y(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}function S(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}function m(C,g){if(g){const l=`onResolveRemoteAuthority:${(0,D.getRemoteName)(g)}`;return!!C.activationEvents?.includes(l)}return!1}e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[140],re([0,1,2,37,13]),function(K,e,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends O.Disposable{constructor(P,c,a,h,E){super(),this.userDataProfilesService=P,this.fileService=c,this.uriIdentityService=a,this.logService=E,this._register(h.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(h.onDidUninstallExtension(y=>this.onDidUnInstallExtension(y)))}onDidInstallExtensions(P){for(const c of P)c.local&&this.invalidate(c.profileLocation)}onDidUnInstallExtension(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const c of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(c.extensionsResource,P)&&await this.deleteUserCacheFile(c);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(P){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(P.cacheHome,k.USER_MANIFEST_CACHE_FILE))}catch(c){(0,D.toFileOperationResult)(c)!==1&&this.logService.error(c)}}}e.ExtensionsManifestCache=A}),define(ne[45],re([0,1,14,9,2,108,40,10,6,36]),function(K,e,O,k,D,A,x,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=y,e.hasNoContent=S,e.asText=m,e.asTextOrError=C,e.asJson=g,e.updateProxyConfigurationsScope=l,e.IRequestService=(0,P.createDecorator)("requestService");class h{constructor(v){this.original=v}toJSON(){if(!this.headers){const v=Object.create(null);for(const n in this.original)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?v[n]="*****":v[n]=this.original[n];this.headers=v}return this.headers}}class E extends D.Disposable{constructor(v){super(),this.counter=0,this.logger=v.createLogger("network",{name:(0,A.localize)(0,null),when:c.CONTEXT_LOG_LEVEL.isEqualTo((0,c.LogLevelToString)(c.LogLevel.Trace)).serialize()})}async logAndRequest(v,n,s){const t=`${v} #${++this.counter}: ${n.url}`;this.logger.trace(`${t} - begin`,n.type,new h(n.headers??{}));try{const i=await s();return this.logger.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${t} - error`,n.type,(0,k.getErrorMessage)(i)),i}}}e.AbstractRequestService=E;function y(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}function S(p){return p.res.statusCode===204}async function m(p){return S(p)?null:(await(0,O.streamToBuffer)(p.stream)).toString()}async function C(p){if(!y(p))throw new Error("Server returned "+p.res.statusCode);return m(p)}async function g(p){if(!y(p))throw new Error("Server returned "+p.res.statusCode);if(S(p))return null;const n=(await(0,O.streamToBuffer)(p.stream)).toString();try{return JSON.parse(n)}catch(s){throw s.message+=`:
`+n,s}}function l(p){w(p)}let u;function w(p){const v=a.Registry.as(x.Extensions.Configuration),n=u;u={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},v.updateConfigurations({add:[u],remove:n?[n]:[]})}w(1)}),define(ne[141],re([0,1,20,15,13,45]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let x=class{constructor(c,a){this.requestService=c,this.fileService=a}async download(c,a,h=O.CancellationToken.None){if(c.scheme===k.Schemas.file||c.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(c,a);return}const E={type:"GET",url:c.toString(!0)},y=await this.requestService.request(E,h);if(y.res.statusCode===200)await this.fileService.writeFile(a,y.stream);else{const S=await(0,A.asTextOrError)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${S}`)}}};e.DownloadService=x,e.DownloadService=x=ve([oe(0,A.IRequestService),oe(1,D.IFileService)],x)}),define(ne[142],re([0,1,143,3]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=A;function D(x,P){return x.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:x.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function A(x,P,c={}){const a=(0,O.parse)(x),h=c.proxyUrl||D(a,P);if(!h)return null;const E=(0,O.parse)(h);if(!/^https?:$/.test(E.protocol||""))return null;const y={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,k.isBoolean)(c.strictSSL)?c.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((S,m)=>{K(["http-proxy-agent"],S,m)})).HttpProxyAgent(h,y):new(await new Promise((S,m)=>{K(["https-proxy-agent"],S,m)})).HttpsProxyAgent(h,y)}}),define(ne[144],re([0,1,59,16,109,20,34,9,12,28,88,175,8,76]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=C;let m;async function C(l,u,w,p){return w["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(p)&&!w["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(p)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=y.Promises.withAsyncBody(async(v,n)=>{const s=new A.CancellationTokenSource;let t=1e4;const i=l.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,S.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),n(new Error((0,D.localize)(0,null)))},t);try{v(await g(u,s.token))}catch(o){!(0,P.isCancellationError)(o)&&!s.token.isCancellationRequested?n(new Error((0,D.localize)(1,null,(0,x.toErrorMessage)(o)))):v({})}finally{clearTimeout(r),s.dispose()}})),m)}async function g(l,u){const w=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",w);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",p);const v=(0,a.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(v+"({.*})"+v),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",s);const t=await(0,h.getSystemShell)(c.OS,s);return l.trace("getUnixShellEnvironment#shell",t),new Promise((i,r)=>{if(u.isCancellationRequested)return r(new P.CancellationError);const o=(0,k.basename)(t);let f,b;const R="";/^pwsh(-preview)?$/.test(o)?(f=`& '${process.execPath}' ${R} -p '''${v}'' + JSON.stringify(process.env) + ''${v}'''`,b=["-Login","-Command"]):o==="nu"?(f=`^'${process.execPath}' ${R} -p '"${v}" + JSON.stringify(process.env) + "${v}"'`,b=["-i","-l","-c"]):o==="xonsh"?(f=`import os, json; print("${v}", json.dumps(dict(os.environ)), "${v}")`,b=["-i","-l","-c"]):(f=`'${process.execPath}' ${R} -p '"${v}" + JSON.stringify(process.env) + "${v}"'`,o==="tcsh"||o==="csh"?b=["-ic"]:b=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),f);const L=(0,O.spawn)(t,[...b,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});u.onCancellationRequested(()=>(L.kill(),r(new P.CancellationError))),L.on("error",V=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,x.toErrorMessage)(V)),r(V)});const N=[];L.stdout.on("data",V=>N.push(V));const _=[];L.stderr.on("data",V=>_.push(V)),L.on("close",(V,H)=>{const se=Buffer.concat(N).toString("utf8");l.trace("getUnixShellEnvironment#raw",se);const ie=Buffer.concat(_).toString("utf8");if(ie.trim()&&l.trace("getUnixShellEnvironment#stderr",ie),V||H)return r(new Error((0,D.localize)(2,null,V,H)));const fe=n.exec(se),ce=fe?fe[1]:"{}";try{const le=JSON.parse(ce);w?le.ELECTRON_RUN_AS_NODE=w:delete le.ELECTRON_RUN_AS_NODE,p?le.ELECTRON_NO_ATTACH_CONSOLE=p:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",le),i(le)}catch(le){l.error("getUnixShellEnvironment#errorCaught",(0,x.toErrorMessage)(le)),r(le)}})})}}),define(ne[145],re([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,O.createDecorator)("stateReadService"),e.IStateService=(0,O.createDecorator)("stateService")}),define(ne[69],re([0,1,8,14,2,3,18,13,6]),function(K,e,O,k,D,A,x,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var a;(function(S){S[S.IMMEDIATE=0]="IMMEDIATE",S[S.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class h extends D.Disposable{constructor(m,C,g,l){super(),this.storagePath=m,this.saveStrategy=C,this.logService=g,this.fileService=l,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new O.ThrottledDelayer(this.saveStrategy===0?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(m){m.fileOperationResult!==1&&this.logService.error(m)}}getItem(m,C){const g=this.storage[m];return(0,A.isUndefinedOrNull)(g)?C:g}setItem(m,C){this.setItems([{key:m,data:C}])}setItems(m){let C=!1;for(const{key:g,data:l}of m)this.storage[g]!==l&&((0,A.isUndefinedOrNull)(l)?(0,A.isUndefined)(this.storage[g])||(this.storage[g]=void 0,C=!0):(this.storage[g]=l,C=!0));C&&this.save()}removeItem(m){(0,A.isUndefined)(this.storage[m])||(this.storage[m]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const m=JSON.stringify(this.storage,null,4);if(m!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,k.VSBuffer.fromString(m),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=m}catch(C){this.logService.error(C)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=h;let E=class extends D.Disposable{constructor(m,C,g,l){super(),this.fileStorage=this._register(new h(C.stateResource,m,g,l))}async init(){await this.fileStorage.init()}getItem(m,C){return this.fileStorage.getItem(m,C)}};e.StateReadonlyService=E,e.StateReadonlyService=E=ve([oe(1,x.IEnvironmentService),oe(2,c.ILogService),oe(3,P.IFileService)],E);class y extends E{setItem(m,C){this.fileStorage.setItem(m,C)}setItems(m){this.fileStorage.setItems(m)}removeItem(m){this.fileStorage.removeItem(m)}close(){return this.fileStorage.close()}}e.StateService=y}),define(ne[70],re([0,1,12,35,28]),function(K,e,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=x,e.verifyMicrosoftInternalDomain=P;function A(c){if(O.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}function x(c,a,h,E,y,S,m,C,g){const l=Object.create(null);l["common.machineId"]=S,l["common.sqmId"]=m,l.sessionID=(0,D.generateUuid)()+Date.now(),l.commitHash=E,l.version=y,l["common.platformVersion"]=(c||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,O.PlatformToString)(O.platform),l["common.nodePlatform"]=k.platform,l["common.nodeArch"]=h,l["common.product"]=g||"desktop",C&&(l["common.msftInternal"]=C);let u=0;const w=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),O.isLinuxSnap&&(l["common.snap"]="true");const p=A(a);return p&&(l["common.platformDetail"]=p),l}function P(c){const a=k.env.USERDNSDOMAIN;if(!a)return!1;const h=a.toLowerCase();return c.some(E=>h===E)}}),define(ne[22],re([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,O.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(k||(e.TelemetryLevel=k={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(ne[71],re([0,1,9,10,6,22]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.ExtensionSignatureVerificationError=e.ExtensionSignatureVerificationCode=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");var x;(function(a){a.None="None",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.Success="Success",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(x||(e.ExtensionSignatureVerificationCode=x={}));class P extends Error{constructor(h){super(h),this.code=h}}e.ExtensionSignatureVerificationError=P;let c=class{constructor(h,E){this.logService=h,this.telemetryService=E}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((h,E)=>K(["@vscode/vsce-sign"],async y=>h(y),E))),this.moduleLoadingPromise}async verify(h,E,y){let S;try{S=await this.vsceSign()}catch(l){return this.logService.error("Could not load vsce-sign module",(0,O.getErrorMessage)(l)),this.logService.info(`Extension signature verification is not done: ${h}`),!1}const m=new Date().getTime();let C;try{C=await S.verify(E,y,this.logService.getLevel()===D.LogLevel.Trace)}catch(l){C={code:"UnknownError",didExecute:!1,output:(0,O.getErrorMessage)(l)}}const g=new Date().getTime()-m;if(this.logService.info(`Extension signature verification result for ${h}: ${C.code}. Duration: ${g}ms.`),this.logService.trace(`Extension signature verification output for ${h}:
${C.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:h,code:C.code,duration:g,didExecute:C.didExecute}),C.code==="Success")return!0;throw new P(C.code)}};e.ExtensionSignatureVerificationService=c,e.ExtensionSignatureVerificationService=c=ve([oe(0,D.ILogService),oe(1,A.ITelemetryService)],c)}),define(ne[41],re([0,1,27,3,68,70,22]),function(K,e,O,k,D,A,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=h,e.isLoggingOnly=E,e.getTelemetryLevel=y,e.validateTelemetryData=S,e.cleanRemoteAuthority=C,e.isInternalTelemetry=l,e.getPiiPathsFromEnvironment=u,e.cleanData=v;class P{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=P;class c{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=c,e.NullTelemetryService=new c;class a{async publicLog(s,t,i){}async publicLogError(s,t,i){}}e.NullEndpointTelemetryService=a,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(n,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!n.enableTelemetry)}function E(n,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function y(n){const s=n.getValue(x.TELEMETRY_SETTING_ID),t=n.getValue(x.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(x.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function S(n){const s={},t={},i={};g(n,i);for(let r in i){r=r.length>150?r.substr(r.length-149):r;const o=i[r];typeof o=="number"?t[r]=o:typeof o=="boolean"?t[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),s[r]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(s[r]=o)}return{properties:s,measurements:t}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function C(n){if(!n)return"none";const s=(0,D.getRemoteName)(n);return m.has(s)?s:"other"}function g(n,s,t=0,i){if(n)for(const r of Object.getOwnPropertyNames(n)){const o=n[r],f=i?i+r:r;Array.isArray(o)?s[f]=(0,O.safeStringify)(o):o instanceof Date?s[f]=o.toISOString():(0,k.isObject)(o)?t<2?g(o,s,t+1,f+"."):s[f]=(0,O.safeStringify)(o):s[f]=o}}function l(n,s){const t=n.msftInternalDomains||[],i=s.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(t)||i}function u(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function w(n,s){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let t=n;const i=[];for(const b of s)for(;;){const R=b.exec(n);if(!R)break;i.push([R.index,b.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(t="";;){const b=o.exec(n);if(!b)break;const R=i.some(([L,N])=>b.index<N&&L<o.lastIndex);!r.test(b[0])&&!R&&(t+=n.substring(f,b.index)+"<REDACTED: user-file-path>",f=o.lastIndex)}return f<n.length&&(t+=n.substr(f)),t}function p(n){if(!n)return n;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of s)if(t.regex.test(n))return`<REDACTED: ${t.label}>`;return n}function v(n,s){return(0,O.cloneAndChange)(n,t=>{if(t instanceof P||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let i=t.replaceAll("%20"," ");i=w(i,s);for(const r of s)i=i.replace(r,"");return i=p(i),i}})}}),define(ne[26],re([0,1,31,21,37,12,11,9,35,41]),function(K,e,O,k,D,A,x,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=h,e.getIdAndVersion=m,e.getExtensionId=C,e.adoptToGalleryExtensionId=g,e.getGalleryExtensionId=l,e.groupByExtension=u,e.getLocalExtensionTelemetryData=w,e.getGalleryExtensionTelemetryData=p,e.getExtensionDependencies=v,e.computeTargetPlatform=s;function h(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,O.compareIgnoreCase)(t.id,i.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,r,o)}static parse(i){const r=E.exec(i);return r&&r[1]&&r[2]?new y({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?h(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=y;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(t){const i=S.exec(t);return i&&i[1]?[g(i[1]),i[2]]:[g(t),void 0]}function C(t,i){return`${t}.${i}`}function g(t){return t.toLowerCase()}function l(t,i){return g(C(t??D.UNDEFINED_PUBLISHER,i))}function u(t,i){const r=[],o=f=>{for(const b of r)if(b.some(R=>h(i(R),i(f))))return b;return null};for(const f of t){const b=o(f);b?b.push(f):r.push([f])}return r}function w(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function p(t){return{id:new a.TelemetryTrustedValue(t.identifier.id),name:new a.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(t,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const f=o.shift();if(f&&r.every(b=>!h(b.identifier,{id:f}))){const b=t.filter(R=>h(R.identifier,{id:f}));b.length===1&&(r.push(b[0]),o.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}async function n(t,i){if(!A.isLinux)return!1;let r;try{r=(await t.readFile(x.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await t.readFile(x.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(f))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(t,i){const r=await n(t,i),o=(0,k.getTargetPlatform)(r?"alpine":A.platform,c.arch);return i.debug("ComputeTargetPlatform:",o),o}}),define(ne[146],re([0,1,20,9,15,17,44,11,97,21,26,37]),function(K,e,O,k,D,A,x,P,c,a,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const y=C=>(0,c.localize)(0,null,C),S=(0,c.localize)(1,null,"ms-dotnettools.csharp");let m=class{constructor(g,l,u){this.logger=g,this.extensionManagementService=l,this.extensionGalleryService=u}get location(){}async listExtensions(g,l,u){let w=await this.extensionManagementService.getInstalled(1,u);const p=E.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(l&&l!==""){if(p.indexOf(l.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}w=w.filter(n=>n.manifest.categories?n.manifest.categories.map(t=>t.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){this.logger.info("Possible Categories: "),p.forEach(n=>{this.logger.info(n)});return}this.location&&this.logger.info((0,c.localize)(2,null,this.location)),w=w.sort((n,s)=>n.identifier.id.localeCompare(s.identifier.id));let v;for(const n of w)v!==n.identifier.id&&(v=n.identifier.id,this.logger.info(g?`${v}@${n.manifest.version}`:v))}async installExtensions(g,l,u,w){const p=[];try{g.length&&this.logger.info(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const v=[],n=[],s=(i,r,o)=>{n.push({id:i,version:r!=="prerelease"?r:void 0,installOptions:{...u,isBuiltin:o,installPreReleaseVersion:r==="prerelease"||u.installPreReleaseVersion}})};for(const i of g)if(i instanceof P.URI)v.push({vsix:i,installOptions:u});else{const[r,o]=(0,h.getIdAndVersion)(i);s(r,o,!1)}for(const i of l)if(i instanceof P.URI)v.push({vsix:i,installOptions:{...u,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[r,o]=(0,h.getIdAndVersion)(i);s(r,o,!0)}const t=await this.extensionManagementService.getInstalled(void 0,u.profileLocation);if(v.length&&await Promise.all(v.map(async({vsix:i,installOptions:r})=>{try{await this.installVSIX(i,r,w,t)}catch(o){this.logger.error(o),p.push(i.toString())}})),n.length){const i=await this.installGalleryExtensions(n,t,w);p.push(...i)}}catch(v){throw this.logger.error((0,c.localize)(5,null,(0,k.getErrorMessage)(v))),v}if(p.length)throw new Error((0,c.localize)(6,null,p.join(", ")))}async updateExtensions(g){const l=await this.extensionManagementService.getInstalled(1,g),u=[];for(const n of l)n.identifier.uuid&&u.push({...n.identifier,preRelease:n.preRelease});this.logger.trace((0,c.localize)(7,null,u.length));const w=await this.extensionGalleryService.getExtensions(u,{compatible:!0},O.CancellationToken.None),p=[];for(const n of w)for(const s of l)(0,h.areSameExtensions)(s.identifier,n.identifier)&&(0,x.gt)(n.version,s.manifest.version)&&p.push({extension:n,options:{operation:3,installPreReleaseVersion:s.preRelease,profileLocation:g}});if(!p.length){this.logger.info((0,c.localize)(8,null));return}this.logger.info((0,c.localize)(9,null,p.map(n=>n.extension.identifier.id).join(", ")));const v=await this.extensionManagementService.installGalleryExtensions(p);for(const n of v)n.error?this.logger.error((0,c.localize)(10,null,n.identifier.id,(0,k.getErrorMessage)(n.error))):this.logger.info((0,c.localize)(11,null,n.identifier.id,n.local?.manifest.version))}async installGalleryExtensions(g,l,u){if(g=g.filter(({id:n,version:s})=>{const t=l.find(i=>(0,h.areSameExtensions)(i.identifier,{id:n}));if(t){if(!u&&(!s||s==="prerelease"&&t.preRelease))return this.logger.info((0,c.localize)(12,null,n,t.manifest.version,n)),!1;if(s&&t.manifest.version===s)return this.logger.info((0,c.localize)(13,null,`${n}@${s}`)),!1}return!0}),!g.length)return[];const w=[],p=[],v=await this.getGalleryExtensions(g);if(await Promise.all(g.map(async({id:n,version:s,installOptions:t})=>{const i=v.get(n.toLowerCase());if(!i){this.logger.error(`${y(s?`${n}@${s}`:n)}
${S}`),w.push(n);return}try{const o=await this.extensionGalleryService.getManifest(i,O.CancellationToken.None);if(o&&!this.validateExtensionKind(o))return}catch(o){this.logger.error(o.message||o.stack||o),w.push(n);return}const r=l.find(o=>(0,h.areSameExtensions)(o.identifier,i.identifier));if(r){if(i.version===r.manifest.version){this.logger.info((0,c.localize)(14,null,s?`${n}@${s}`:n));return}this.logger.info((0,c.localize)(15,null,n,i.version))}t.isBuiltin?this.logger.info(s?(0,c.localize)(16,null,n,s):(0,c.localize)(17,null,n)):this.logger.info(s?(0,c.localize)(18,null,n,s):(0,c.localize)(19,null,n)),p.push({extension:i,options:{...t,installGivenVersion:!!s}})})),p.length){const n=await this.extensionManagementService.installGalleryExtensions(p);for(const s of n)s.error?(this.logger.error((0,c.localize)(20,null,s.identifier.id,(0,k.getErrorMessage)(s.error))),w.push(s.identifier.id)):this.logger.info((0,c.localize)(21,null,s.identifier.id,s.local?.manifest.version))}return w}async installVSIX(g,l,u,w){const p=await this.extensionManagementService.getManifest(g);if(!p)throw new Error("Invalid vsix");if(await this.validateVSIX(p,u,l.profileLocation,w))try{await this.extensionManagementService.install(g,l),this.logger.info((0,c.localize)(22,null,(0,A.basename)(g)))}catch(n){if((0,k.isCancellationError)(n))this.logger.info((0,c.localize)(23,null,(0,A.basename)(g)));else throw n}}async getGalleryExtensions(g){const l=new Map,u=g.some(v=>v.installOptions.installPreReleaseVersion),w=await this.extensionManagementService.getTargetPlatform(),p=[];for(const v of g)a.EXTENSION_IDENTIFIER_REGEX.test(v.id)&&p.push({...v,preRelease:u});if(p.length){const v=await this.extensionGalleryService.getExtensions(p,{targetPlatform:w},O.CancellationToken.None);for(const n of v)l.set(n.identifier.id.toLowerCase(),n)}return l}validateExtensionKind(g){return!0}async validateVSIX(g,l,u,w){if(!l){const p={id:(0,h.getGalleryExtensionId)(g.publisher,g.name)},v=w.find(n=>(0,h.areSameExtensions)(p,n.identifier)&&(0,x.gt)(n.manifest.version,g.version));if(v)return this.logger.info((0,c.localize)(24,null,v.identifier.id,v.manifest.version,g.version)),!1}return this.validateExtensionKind(g)}async uninstallExtensions(g,l,u){const w=async v=>{if(v instanceof P.URI){const n=await this.extensionManagementService.getManifest(v);return(0,h.getExtensionId)(n.publisher,n.name)}return v},p=[];for(const v of g){const n=await w(v),t=(await this.extensionManagementService.getInstalled(void 0,u)).filter(i=>(0,h.areSameExtensions)(i.identifier,{id:n}));if(!t.length)throw new Error(`${this.notInstalled(n)}
${S}`);if(t.some(i=>i.type===0)){this.logger.info((0,c.localize)(25,null,n));return}if(!l&&t.some(i=>i.isBuiltin)){this.logger.info((0,c.localize)(26,null,n));return}this.logger.info((0,c.localize)(27,null,n));for(const i of t)await this.extensionManagementService.uninstall(i,{profileLocation:u}),p.push(i);this.location?this.logger.info((0,c.localize)(28,null,n,this.location)):this.logger.info((0,c.localize)(29,null,n))}}async locateExtension(g){const l=await this.extensionManagementService.getInstalled();g.forEach(u=>{l.forEach(w=>{if(w.identifier.id===u&&w.location.scheme===D.Schemas.file){this.logger.info(w.location.fsPath);return}})})}notInstalled(g){return this.location?(0,c.localize)(30,null,g,this.location):(0,c.localize)(31,null,g)}};e.ExtensionManagementCLI=m,e.ExtensionManagementCLI=m=ve([oe(1,a.IExtensionManagementService),oe(2,a.IExtensionGalleryService)],m)}),define(ne[147],re([0,1,8,9,2,15,17,44,3,28,25,49,29,18,21,26,71,13,6]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l,u){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class extends D.Disposable{static{w=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(n,s,t,i,r,o){super(),this.fileService=s,this.extensionGalleryService=t,this.configurationService=i,this.extensionSignatureVerificationService=r,this.logService=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(n,s,t){await this.cleanUpPromise;const i=(0,x.joinPath)(this.extensionsDownloadDir,this.getName(n));try{await this.downloadFile(n,i,o=>this.extensionGalleryService.download(n,o,s))}catch(o){throw new m.ExtensionManagementError(o.message,m.ExtensionManagementErrorCode.Download)}let r=!1;if(t&&this.shouldVerifySignature(n)){const o=await this.downloadSignatureArchive(n);try{r=await this.extensionSignatureVerificationService.verify(n.identifier.id,i.fsPath,o.fsPath)}catch(f){if(r=f.code,r==="PackageIsInvalidZip"||r==="SignatureArchiveIsInvalidZip"){try{await this.delete(i)}catch(R){this.logService.error(R)}throw new m.ExtensionManagementError(E.CorruptZipMessage,m.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(f){this.logService.error(f)}}}return{location:i,verificationStatus:r}}shouldVerifySignature(n){if(!n.isSigned)return this.logService.info(`Extension is not signed: ${n.identifier.id}`),!1;const s=this.configurationService.getValue("extensions.verifySignature");return(0,c.isBoolean)(s)?s:!0}async downloadSignatureArchive(n){await this.cleanUpPromise;const s=(0,x.joinPath)(this.extensionsDownloadDir,`${this.getName(n)}${w.SignatureArchiveExtension}`);try{await this.downloadFile(n,s,t=>this.extensionGalleryService.downloadSignatureArchive(n,t))}catch(t){throw new m.ExtensionManagementError(t.message,m.ExtensionManagementErrorCode.DownloadSignature)}return s}async downloadFile(n,s,t){if(await this.fileService.exists(s))return;if(s.scheme!==A.Schemas.file){await t(s);return}const i=(0,x.joinPath)(this.extensionsDownloadDir,`.${(0,a.generateUuid)()}`);await this.fileService.exists(i)||await t(i);try{await h.Promises.rename(i.fsPath,s.fsPath,2*60*1e3)}catch(r){try{await this.fileService.del(i)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(r)}. Deleted the file from downloaded location`,i.path),r}}async delete(n){await this.cleanUpPromise,await this.fileService.del(n)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const s=[],t=[],i=[];for(const f of n.children)if(f.name.endsWith(w.SignatureArchiveExtension))i.push(f.resource);else{const b=C.ExtensionKey.parse(f.name);b&&t.push([b,f])}const r=(0,C.groupByExtension)(t,([f])=>f),o=[];for(const f of r)f.sort((b,R)=>P.rcompare(b[0].version,R[0].version)),s.push(...f.slice(1).map(b=>b[1].resource)),o.push(f[0][1]);o.sort((f,b)=>f.mtime-b.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(f=>f.resource)),s.push(...i),await O.Promises.settled(s.map(f=>(this.logService.trace("Deleting from cache",f.path),this.fileService.del(f))))}}catch(n){this.logService.error(n)}}getName(n){return this.cache?C.ExtensionKey.create(n).toString().toLowerCase():(0,a.generateUuid)()}};e.ExtensionsDownloader=p,e.ExtensionsDownloader=p=w=ve([oe(0,S.INativeEnvironmentService),oe(1,l.IFileService),oe(2,m.IExtensionGalleryService),oe(3,y.IConfigurationService),oe(4,g.IExtensionSignatureVerificationService),oe(5,u.ILogService)],p)}),define(ne[148],re([0,1,5,2,30,26,37]),function(K,e,O,k,D,A,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends k.Disposable{constructor(a,h,E,y,S,m,C){super(),this.extensionManagementService=a,this.extensionsScannerService=h,this.userDataProfilesService=E,this.extensionsProfileScannerService=y,this.uriIdentityService=S,this.fileService=m,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new k.DisposableMap),this.initialize().then(null,g=>C.error(g))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(a=>this.onDidChangeProfiles(a.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(a=>this.onAddExtensions(a))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(a=>this.onDidAddExtensions(a))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(a=>this.onRemoveExtensions(a))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(a=>this.onDidRemoveExtensions(a))),this._register(this.fileService.onDidFilesChange(a=>this.onDidFilesChange(a)))}async onDidChangeProfiles(a){try{a.length&&await Promise.all(a.map(h=>(this.extensionsProfileWatchDisposables.set(h.id,(0,k.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(h.extensionsResource)),this.fileService.watch(h.extensionsResource))),this.populateExtensionsFromProfile(h.extensionsResource))))}catch(h){throw this.logService.error(h),h}}async onAddExtensions(a){for(const h of a.extensions)this.addExtensionWithKey(this.getKey(h.identifier,h.version),a.profileLocation)}async onDidAddExtensions(a){for(const h of a.extensions){const E=this.getKey(h.identifier,h.version);a.error?this.removeExtensionWithKey(E,a.profileLocation):this.addExtensionWithKey(E,a.profileLocation)}}async onRemoveExtensions(a){for(const h of a.extensions)this.removeExtensionWithKey(this.getKey(h.identifier,h.version),a.profileLocation)}async onDidRemoveExtensions(a){const h=[],E=[];for(const y of a.extensions){const S=this.getKey(y.identifier,y.version);a.error?this.addExtensionWithKey(S,a.profileLocation):(this.removeExtensionWithKey(S,a.profileLocation),this.allExtensions.has(S)||(this.logService.debug("Extension is removed from all profiles",y.identifier.id,y.version),E.push(this.extensionManagementService.scanInstalledExtensionAtLocation(y.location).then(m=>{m?h.push(m):this.logService.info("Extension not found at the location",y.location.toString())},m=>this.logService.error(m)))))}try{await Promise.all(E),h.length&&await this.uninstallExtensionsNotInProfiles(h)}catch(y){this.logService.error(y)}}onDidFilesChange(a){for(const h of this.userDataProfilesService.profiles)a.contains(h.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(h.extensionsResource)}async onDidExtensionsProfileChange(a){const h=[],E=[],y=await this.extensionsProfileScannerService.scanProfileExtensions(a),S=new Set,m=new Set;for(const[C,g]of this.allExtensions)g.has(a)&&m.add(C);for(const C of y){const g=this.getKey(C.identifier,C.version);S.add(g),m.has(g)||(h.push(C.identifier),this.addExtensionWithKey(g,a))}for(const C of m)if(!S.has(C)){const g=this.fromKey(C);g&&(E.push(g.identifier),this.removeExtensionWithKey(C,a))}(h.length||E.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:h.length?{extensions:h,profileLocation:a}:void 0,removed:E.length?{extensions:E,profileLocation:a}:void 0})}async populateExtensionsFromProfile(a){const h=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const E of h)this.addExtensionWithKey(this.getKey(E.identifier,E.version),a)}async uninstallExtensionsNotInProfiles(a){a||(a=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(E=>!this.allExtensions.has(this.getKey(E.identifier,E.manifest.version)))),a.length&&await this.extensionManagementService.markAsUninstalled(...a)}addExtensionWithKey(a,h){let E=this.allExtensions.get(a);E||this.allExtensions.set(a,E=new D.ResourceSet(y=>this.uriIdentityService.extUri.getComparisonKey(y))),E.add(h)}removeExtensionWithKey(a,h){const E=this.allExtensions.get(a);E&&E.delete(h),E?.size||this.allExtensions.delete(a)}getKey(a,h){return`${x.ExtensionIdentifier.toKey(a.id)}@${h}`}fromKey(a){const[h,E]=(0,A.getIdAndVersion)(a);return E?{identifier:{id:h},version:E}:void 0}}e.ExtensionsWatcher=P}),define(ne[149],re([0,1,119,41]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=D;async function D(A,x,P,c,a,h,E){const y={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${x.nameShort})`};if((0,k.supportsTelemetry)(x,P)&&(0,k.getTelemetryLevel)(c)===3){const S=await(0,O.getServiceMachineId)(P,a,h);y["X-Market-User-Id"]=S,y["VSCode-SessionId"]=E.machineId||S}return y}}),define(ne[150],re([0,1,176,19,8,2,15,16,25,18,21,26,6,65,11]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let C=class extends S.LanguagePackBaseService{constructor(w,p,v,n){super(v),this.extensionManagementService=w,this.logService=n,this.cache=this._register(new g(p,n)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getBuiltInExtensionTranslationsUri(w,p){const n=(await this.cache.getLanguagePacks())[p];if(!n){this.logService.warn(`No language pack found for ${p}`);return}const s=n.translations[w];return s?m.URI.file(s):void 0}async getInstalledLanguages(){const w=await this.cache.getLanguagePacks(),p=Object.keys(w).map(v=>{const n=w[v];return{...this.createQuickPickItem(v,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return p.push(this.createQuickPickItem("en","English")),p.sort((v,n)=>v.label.localeCompare(n.label)),p}async postInstallExtension(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",w.identifier.id),await this.update())}async postUninstallExtension(w){const p=await this.cache.getLanguagePacks();Object.keys(p).some(v=>p[v]&&p[v].extensions.some(n=>(0,E.areSameExtensions)(n.extensionIdentifier,w.identifier)))&&(this.logService.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(p);return!(0,k.equals)(Object.keys(w),Object.keys(v))}};e.NativeLanguagePackService=C,e.NativeLanguagePackService=C=ve([oe(0,h.IExtensionManagementService),oe(1,a.INativeEnvironmentService),oe(2,h.IExtensionGalleryService),oe(3,y.ILogService)],C);let g=class extends A.Disposable{constructor(w,p){super(),this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(w.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(w){return this.withLanguagePacks(p=>{Object.keys(p).forEach(v=>delete p[v]),this.createLanguagePacksFromExtensions(p,...w)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(w,...p){for(const v of p)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(w,v);Object.keys(w).forEach(v=>this.updateHash(w[v]))}createLanguagePacksFromExtension(w,p){const v=p.identifier,n=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const s of n)if(p.location.scheme===x.Schemas.file&&l(s)){let t=w[s.languageId];t||(t={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},w[s.languageId]=t);const i=t.extensions.filter(r=>(0,E.areSameExtensions)(r.extensionIdentifier,v))[0];i?i.version=p.manifest.version:t.extensions.push({extensionIdentifier:v,version:p.manifest.version});for(const r of s.translations)t.translations[r.id]=(0,P.join)(p.location.fsPath,r.path)}}updateHash(w){if(w){const p=(0,O.createHash)("md5");for(const v of w.extensions)p.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);w.hash=p.digest("hex")}}withLanguagePacks(w=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch{return{}}}).then(v=>(p=w(v),v)).then(v=>{for(const s of Object.keys(v))v[s]||delete v[s];this.languagePacks=v,this.initializedCache=!0;const n=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",n),c.Promises.writeFile(this.languagePacksFilePath,n)}).then(()=>p,v=>this.logService.error(v))})}};g=ve([oe(0,a.INativeEnvironmentService),oe(1,y.ILogService)],g);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const w of u.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ne[151],re([0,1,85,9,27,41]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const x="https://0.0.0.0/OneCollector/1.0",P="https://0.0.0.0/ping";async function c(h,E,y){const S=await(0,O.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),m=await(0,O.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),C=new S.AppInsightsCore,g=new m.PostChannel,l={instrumentationKey:h,endpointUrl:x,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(y){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:y};l.extensionConfig[g.identifier]=u}return C.initialize(l,[]),C.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),C}class a{constructor(E,y,S,m,C){this._isInternalTelemetry=E,this._eventPrefix=y,this._defaultData=S,this._xhrOverride=C,this.endPointUrl=x,this.endPointHealthUrl=P,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(E){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){E(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=c(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(y=>{E(y)},y=>{(0,k.onUnexpectedError)(y),console.error(y)})}}log(E,y){if(!this._aiCoreOrKey)return;y=(0,D.mixin)(y,this._defaultData),y=(0,A.validateTelemetryData)(y);const S=this._eventPrefix+"/"+E;try{this._withAIClient(m=>{m.pluginVersionString=y?.properties.version??"Unknown",m.track({name:S,baseData:{name:S,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(E=>{this._withAIClient(y=>{y.unload(!0,()=>{this._aiCoreOrKey=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=a}),define(ne[152],re([0,1,2,27,12,31,110,29,40,153,32,36,22,41]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,w){this._configurationService=u,this._productService=w,this._experimentProperties={},this._disposables=new O.DisposableStore,this._cleanupPatterns=[],this._appenders=l.appenders,this._commonProperties=l.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=l.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(p),"gi")),p.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(p.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(p=>{(p.affectsConfiguration(y.TELEMETRY_SETTING_ID)||p.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||p.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(l,u){this._experimentProperties[l]=u}_updateTelemetryLevel(){let l=(0,S.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const w=u.usage?3:u.error?2:0;l=Math.min(l,w)}this._telemetryLevel=l}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(l,u,w){this._telemetryLevel<u||(w=(0,k.mixin)(w,this._experimentProperties),w=(0,S.cleanData)(w,this._cleanupPatterns),w=(0,k.mixin)(w,this._commonProperties),this._appenders.forEach(p=>p.log(l,w)))}publicLog(l,u){this._log(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this._sendErrorTelemetry&&this._log(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.TelemetryService=m,e.TelemetryService=m=ve([oe(1,P.IConfigurationService),oe(2,h.IProductService)],m);function C(){const g=(0,x.localize)(0,null,a.default.nameLong),l=a.default.privacyStatementUrl?(0,x.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,x.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=D.isWeb?"":(0,x.localize)(3,null),w=(0,x.localize)(4,null),p=(0,x.localize)(5,null),v=(0,x.localize)(6,null),n=(0,x.localize)(7,null),s=`
|       | ${w} | ${p} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,x.localize)(8,null);return`
${g} ${l} ${u}

&nbsp;

${n}
${s}

&nbsp;

${t}
`}E.Registry.as(c.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,x.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,x.localize)(10,null),(0,x.localize)(11,null),(0,x.localize)(12,null),(0,x.localize)(13,null)],markdownDescription:C(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(c.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,x.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,x.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,x.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,x.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[154],re([0,1,14,20,177,151]),function(K,e,O,k,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function x(h,E){const y=await E.request(h,k.CancellationToken.None),S=(await(0,O.streamToBuffer)(y.stream)).toString(),m=y.res.statusCode??200;return{headers:y.res.headers,statusCode:m,responseData:S}}async function P(h){const E={method:h.type,headers:h.headers};return new Promise((S,m)=>{const C=D.request(h.url??"",E,g=>{g.on("data",function(l){S({headers:g.headers,statusCode:g.statusCode??200,responseData:l.toString()})}),g.on("error",function(l){m(l)})});C.write(h.data,g=>{g&&m(g)}),C.end()})}async function c(h,E,y){const S=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),m={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:S};try{const C=h?await x(m,h):await P(m);y(C.statusCode,C.headers,C.responseData)}catch{y(0,{})}}class a extends A.AbstractOneDataSystemAppender{constructor(E,y,S,m,C){const g={sendPOST:(l,u)=>{c(E,l,u)}};super(y,S,m,C,g)}}e.OneDataSystemAppender=a}),define(ne[155],re([0,1,16,25]),function(K,e,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=D;async function D(A,x){const P=Object.create(null),c=(h,E)=>{const y=JSON.parse(h);P[E]=y};if(x){const h=[],E=await k.Promises.readdir(x);for(const S of E)try{(await k.Promises.stat((0,O.join)(x,S))).isDirectory()&&h.push(S)}catch{}const y=[];for(const S of h)(await k.Promises.readdir((0,O.join)(x,S))).filter(C=>C==="telemetry.json").length===1&&y.push(S);for(const S of y){const m=(await k.Promises.readFile((0,O.join)(x,S,"telemetry.json"))).toString();c(m,S)}}let a=(await k.Promises.readFile((0,O.join)(A,"telemetry-core.json"))).toString();return c(a,"vscode-core"),a=(await k.Promises.readFile((0,O.join)(A,"telemetry-extensions.json"))).toString(),c(a,"vscode-extensions"),JSON.stringify(P,null,4)}}),define(ne[156],re([0,1,12,86,22]),function(K,e,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=A,e.resolveSqmId=x;async function A(P,c){let a=P.getItem(D.machineIdKey);return(typeof a!="string"||O.isMacintosh&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,k.getMachineId)(c.error.bind(c))),a}async function x(P,c){let a=P.getItem(D.sqmIdKey);return typeof a!="string"&&(a=await(0,k.getSqmMachineId)(c.error.bind(c))),a}}),define(ne[23],re([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,O.createDecorator)("IUriIdentityService")}),define(ne[157],re([0,1,23,120,13,17,77,5,2]),function(K,e,O,k,D,A,x,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let h=class{constructor(y){this._fileService=y,this._dispooables=new c.DisposableStore,this._limit=2**16;const S=new Map,m=C=>{let g=S.get(C.scheme);return g===void 0&&(g=y.hasProvider(C)&&!this._fileService.hasCapability(C,1024),S.set(C.scheme,g)),g};this._dispooables.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(C=>{S.delete(C.scheme)})),this.extUri=new A.ExtUri(m),this._canonicalUris=new x.SkipList((C,g)=>this.extUri.compare(C,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(y){this._fileService.hasProvider(y)&&(y=(0,A.normalizePath)(y));const S=this._canonicalUris.get(y);return S?S.touch().uri.with({fragment:y.fragment}):(this._canonicalUris.set(y,new a(y)),this._checkTrim(),y)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const y=[...this._canonicalUris.entries()].sort((m,C)=>m[1].time<C[1].time?1:m[1].time>C[1].time?-1:0);a._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let m=0;m<S;m++)this._canonicalUris.set(y[m][0],y[m][1].touch())}};e.UriIdentityService=h,e.UriIdentityService=h=ve([oe(0,D.IFileService)],h),(0,k.registerSingleton)(O.IUriIdentityService,h,1)}),define(ne[158],re([0,1,5,2,13,48,30]),function(K,e,O,k,D,A,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends k.Disposable{constructor(a,h,E,y,S,m){super(),this.fileSystemScheme=a,this.fileSystemProvider=h,this.userDataScheme=E,this.userDataProfilesService=y,this.uriIdentityService=S,this.logService=m,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new x.ResourceSet(C=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(C))),this.updateAtomicReadWritesResources(),this._register(y.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(C=>this.handleFileChanges(C)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const a of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(a.settingsResource),this.atomicReadWriteResources.add(a.keybindingsResource),this.atomicReadWriteResources.add(a.tasksResource),this.atomicReadWriteResources.add(a.extensionsResource)}open(a,h){return this.fileSystemProvider.open(this.toFileSystemResource(a),h)}close(a){return this.fileSystemProvider.close(a)}read(a,h,E,y,S){return this.fileSystemProvider.read(a,h,E,y,S)}write(a,h,E,y,S){return this.fileSystemProvider.write(a,h,E,y,S)}watch(a,h){this.watchResources.set(a,a);const E=this.fileSystemProvider.watch(this.toFileSystemResource(a),h);return(0,k.toDisposable)(()=>{this.watchResources.delete(a),E.dispose()})}stat(a){return this.fileSystemProvider.stat(this.toFileSystemResource(a))}mkdir(a){return this.fileSystemProvider.mkdir(this.toFileSystemResource(a))}rename(a,h,E){return this.fileSystemProvider.rename(this.toFileSystemResource(a),this.toFileSystemResource(h),E)}readFile(a,h){return this.fileSystemProvider.readFile(this.toFileSystemResource(a),h)}readFileStream(a,h,E){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(a),h,E)}readdir(a){return this.fileSystemProvider.readdir(this.toFileSystemResource(a))}enforceAtomicReadFile(a){return this.atomicReadWriteResources.has(a)}writeFile(a,h,E){return this.fileSystemProvider.writeFile(this.toFileSystemResource(a),h,E)}enforceAtomicWriteFile(a){return this.atomicReadWriteResources.has(a)?{postfix:".vsctmp"}:!1}delete(a,h){return this.fileSystemProvider.delete(this.toFileSystemResource(a),h)}copy(a,h,E){if((0,D.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(a),this.toFileSystemResource(h),E);throw new Error("copy not supported")}cloneFile(a,h){if((0,D.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(a),this.toFileSystemResource(h));throw new Error("clone not supported")}handleFileChanges(a){const h=[];for(const E of a){if(E.resource.scheme!==this.fileSystemScheme)continue;const y=this.toUserDataResource(E.resource);this.watchResources.findSubstr(y)&&h.push({resource:y,type:E.type,cId:E.cId})}h.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(h))}toFileSystemResource(a){return a.with({scheme:this.fileSystemScheme})}toUserDataResource(a){return a.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(ne[159],re([0,1,112,16,48,17,11,10,15]),function(K,e,O,k,D,A,x,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=a,e.isEmptyWorkspaceIdentifier=h,e.toWorkspaceIdentifier=E,e.isWorkspaceIdentifier=y,e.reviveIdentifier=S,e.isWorkspace=C,e.isWorkspaceFolder=g,e.toWorkspaceFolder=w,e.isUntitledWorkspace=p,e.isTemporaryWorkspace=v,e.isStandaloneEditorWorkspace=n,e.isSavedWorkspace=s,e.hasWorkspaceFileExtension=t,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function a(i){const r=i;return typeof r?.id=="string"&&x.URI.isUri(r.uri)}function h(i){return typeof i?.id=="string"&&!a(i)&&!y(i)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,k.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function y(i){const r=i;return typeof r?.id=="string"&&x.URI.isUri(r.configPath)}function S(i){const r=i;if(r?.uri)return{id:r.id,uri:x.URI.revive(r.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:x.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function C(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}function g(i){const r=i;return!!(r&&typeof r=="object"&&x.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}class l{constructor(r,o,f,b,R){this._id=r,this._transient=f,this._configuration=b,this._ignorePathCasing=R,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class u{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,A.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function w(i){return new u({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,O.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(i,r){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}function v(i){let r;return x.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===c.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function s(i,r){return!p(i,r)&&!v(i)}function t(i){return(typeof i=="string"?(0,k.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}}),define(ne[24],re([0,1,43,5,2,17,11,111,18,13,10,6,159,30,23,8,28,31,3]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=p,e.reviveProfile=v,e.toUserDataProfile=n;var w;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(w||(e.ProfileResourceType=w={}));function p(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&x.URI.isUri(r.location)&&x.URI.isUri(r.globalStorageHome)&&x.URI.isUri(r.settingsResource)&&x.URI.isUri(r.keybindingsResource)&&x.URI.isUri(r.tasksResource)&&x.URI.isUri(r.snippetsHome)&&x.URI.isUri(r.extensionsResource))}e.IUserDataProfilesService=(0,h.createDecorator)("IUserDataProfilesService");function v(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:x.URI.revive(i.location).with({scheme:r}),globalStorageHome:x.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:x.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:x.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:x.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:x.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:x.URI.revive(i.extensionsResource).with({scheme:r}),cacheHome:x.URI.revive(i.cacheHome).with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function n(i,r,o,f,b,R){return{id:i,name:r,location:o,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:R&&b?.useDefaultFlags?.globalState?R.globalStorageHome:(0,A.joinPath)(o,"globalStorage"),settingsResource:R&&b?.useDefaultFlags?.settings?R.settingsResource:(0,A.joinPath)(o,"settings.json"),keybindingsResource:R&&b?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,A.joinPath)(o,"keybindings.json"),tasksResource:R&&b?.useDefaultFlags?.tasks?R.tasksResource:(0,A.joinPath)(o,"tasks.json"),snippetsHome:R&&b?.useDefaultFlags?.snippets?R.snippetsHome:(0,A.joinPath)(o,"snippets"),extensionsResource:R&&b?.useDefaultFlags?.extensions?R.extensionsResource:(0,A.joinPath)(o,"extensions.json"),cacheHome:(0,A.joinPath)(f,i),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let s=class extends D.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,o,f,b){super(),this.environmentService=r,this.fileService=o,this.uriIdentityService=f,this.logService=b,this.enabled=!0,this._onDidChangeProfiles=this._register(new k.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new k.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new k.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new k.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new S.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.createDefaultProfile(),o=[r];if(this.enabled)try{for(const R of this.getStoredProfiles()){if(!R.name||!(0,u.isString)(R.name)||!R.location){this.logService.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(n((0,A.basename)(R.location),R.name,R.location,this.profilesCacheHome,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},r))}}catch(R){this.logService.error(R)}const f=new S.ResourceMap,b=new Map;if(o.length)try{const R=this.getStoredProfileAssociations();if(R.workspaces)for(const[L,N]of Object.entries(R.workspaces)){const _=x.URI.parse(L),V=o.find(H=>H.id===N);V&&f.set(_,V)}if(R.emptyWindows)for(const[L,N]of Object.entries(R.emptyWindows)){const _=o.find(V=>V.id===N);_&&b.set(L,_)}}catch(R){this.logService.error(R)}this._profilesObject={profiles:o,workspaces:f,emptyWindows:b}}return this._profilesObject}createDefaultProfile(){const r=n("__default__profile__",(0,P.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...r,extensionsResource:this.getDefaultProfileExtensionsLocation()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const o="Temp",f=new RegExp(`${(0,l.escapeRegExpCharacters)(o)}\\s(\\d+)`);let b=0;for(const L of this.profiles){const N=f.exec(L.name),_=N?parseInt(N[1]):0;b=_>b?_:b}const R=`${o} ${b+1}`;return this.createProfile((0,O.hash)((0,g.generateUuid)()).toString(16),R,{transient:!0},r)}async createNamedProfile(r,o,f){return this.createProfile((0,O.hash)((0,g.generateUuid)()).toString(16),r,o,f)}async createProfile(r,o,f,b){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const R=await this.doCreateProfile(r,o,f);return b&&await this.setProfileForWorkspace(b,R),R}async doCreateProfile(r,o,f){if(!(0,u.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.profileCreationPromises.get(o);return b||(b=(async()=>{try{if(this.profiles.find(_=>_.name===o||_.id===r))throw new Error(`Profile with ${o} name already exists`);const L=n(r,o,(0,A.joinPath)(this.profilesHome,r),this.profilesCacheHome,f,this.defaultProfile);await this.fileService.createFolder(L.location);const N=[];return this._onWillCreateProfile.fire({profile:L,join(_){N.push(_)}}),await C.Promises.settled(N),this.updateProfiles([L],[],[]),L}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,b)),b}async updateProfile(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(b=>b.id===r.id);if(!f)throw new Error(`Profile '${r.name}' does not exist`);return f=n(f.id,o.name??f.name,f.location,this.profilesCacheHome,{shortName:o.shortName??f.shortName,icon:o.icon===null?void 0:o.icon??f.icon,transient:o.transient??f.isTransient,useDefaultFlags:o.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[f]),f}async removeProfile(r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(b=>b.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const f=[];this._onWillRemoveProfile.fire({profile:o,join(b){f.push(b)}});try{await Promise.allSettled(f)}catch(b){this.logService.error(b)}for(const b of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(b)?.id&&this.profilesObject.emptyWindows.delete(b);for(const b of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(b)?.id&&this.profilesObject.workspaces.delete(b);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(b){(0,a.toFileOperationResult)(b)!==1&&this.logService.error(b)}}async setProfileForWorkspace(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(b=>b.id===o.id);if(!f)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(r,f)}unsetWorkspace(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(r,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(f=>!this.uriIdentityService.extUri.isEqual(f.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.getWorkspace(r);return x.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(r){return(0,y.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,y.isWorkspaceIdentifier)(r)?r.configPath:r.id}isProfileAssociatedToWorkspace(r){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location)))}updateProfiles(r,o,f){const b=[...this.profiles,...r],R=[];this.transientProfilesObject.profiles=[];for(let L of b)L.isDefault||o.some(N=>L.id===N.id)||(L=f.find(N=>L.id===N.id)??L,L.isTransient?this.transientProfilesObject.profiles.push(L):R.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags}));this.saveStoredProfiles(R),this._profilesObject=void 0,this.triggerProfilesChanges(r,o,f)}triggerProfilesChanges(r,o,f){this._onDidChangeProfiles.fire({added:r,removed:o,updated:f,all:this.profiles})}updateWorkspaceAssociation(r,o,f){f=o?.isTransient?!0:f,f||this.updateWorkspaceAssociation(r,void 0,!0);const b=this.getWorkspace(r),R=f?this.transientProfilesObject:this.profilesObject;x.URI.isUri(b)?(R.workspaces.delete(b),o&&R.workspaces.set(b,o)):(R.emptyWindows.delete(b),o&&R.emptyWindows.set(b,o)),f||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[f,b]of this.profilesObject.workspaces.entries())r[f.toString()]=b.id;const o={};for(const[f,b]of this.profilesObject.emptyWindows.entries())o[f.toString()]=b.id;this.saveStoredProfileAssociations({workspaces:r,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(r){const o={},f=this.createDefaultProfile();if(r.workspaces)for(const[R,L]of Object.entries(r.workspaces)){const N=x.URI.parse(L);o[R]=this.uriIdentityService.extUri.isEqual(N,f.location)?f.id:this.uriIdentityService.extUri.basename(N)}const b={};if(r.emptyWindows)for(const[R,L]of Object.entries(r.emptyWindows)){const N=x.URI.parse(L);b[R]=this.uriIdentityService.extUri.isEqual(N,f.location)?f.id:this.uriIdentityService.extUri.basename(N)}return{workspaces:o,emptyWindows:b}}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=s,e.UserDataProfilesService=s=ve([oe(0,c.IEnvironmentService),oe(1,a.IFileService),oe(2,m.IUriIdentityService),oe(3,E.ILogService)],s);class t extends s{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=t}),define(ne[160],re([0,1,19,8,20,9,5,2,12,3,11,95,21,26,37,6,32,22,23,24]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.toExtensionManagementError=v;let p=class extends P.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(i,r,o,f,b,R){super(),this.galleryService=i,this.telemetryService=r,this.uriIdentityService=o,this.logService=f,this.productService=b,this.userDataProfilesService=R,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new x.Emitter),this._onDidInstallExtensions=this._register(new x.Emitter),this._onUninstallExtension=this._register(new x.Emitter),this._onDidUninstallExtension=this._register(new x.Emitter),this._onDidUpdateExtensionMetadata=this._register(new x.Emitter),this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:L})=>L.cancel()),this.uninstallingExtensions.forEach(L=>L.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,y.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const f=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:b})=>(0,S.areSameExtensions)(b,i.identifier));if(f?.local)return f?.local;throw f?.error?f.error:new y.ExtensionManagementError(`Unknown error while installing extension ${i.identifier.id}`,y.ExtensionManagementErrorCode.Unknown)}catch(o){throw v(o)}}async installGalleryExtensions(i){if(!this.galleryService.isEnabled())throw new y.ExtensionManagementError(E.localize(0,null),y.ExtensionManagementErrorCode.NotAllowed);const r=[],o=[];return await Promise.allSettled(i.map(async({extension:f,options:b})=>{try{const R=await this.checkAndGetCompatibleVersion(f,!!b?.installGivenVersion,!!b?.installPreReleaseVersion,b.productVersion??{version:this.productService.version,date:this.productService.date});o.push({...R,options:b})}catch(R){r.push({identifier:f.identifier,operation:2,source:f,error:R})}})),o.length&&r.push(...await this.installExtensions(o)),r}async uninstall(i,r={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,r)}async toggleAppliationScope(i,r){if((0,m.isApplicationScopedExtension)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)||(o=await this.copyExtension(i,this.userDataProfilesService.defaultProfile.extensionsResource,r));for(const f of this.userDataProfilesService.profiles){const b=(await this.getInstalled(1,f.extensionsResource)).find(R=>(0,S.areSameExtensions)(R.identifier,i.identifier));b?this._onDidUpdateExtensionMetadata.fire(b):this._onDidUninstallExtension.fire({identifier:i.identifier,profileLocation:f.extensionsResource})}return o}else{const o=this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(i,r,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtensions(i){const r=new Map,o=new Map,f=[],b=(L,N)=>`${S.ExtensionKey.create(L).toString()}-${N.toString()}`,R=(L,N,_,V)=>{const H=this.createInstallExtensionTask(L,N,_),se=`${(0,S.getGalleryExtensionId)(L.publisher,L.name)}-${_.profileLocation.toString()}`;o.set(se,{task:H,root:V}),this._onInstallExtension.fire({identifier:H.identifier,source:N,profileLocation:_.profileLocation}),this.logService.info("Installing extension:",H.identifier.id),h.URI.isUri(N)||this.installingExtensions.set(b(N,_.profileLocation),{task:H,waitingTasks:[]})};try{for(const{manifest:L,extension:N,options:_}of i){const V=_.isApplicationScoped||_.isBuiltin||(0,m.isApplicationScopedExtension)(L),H={..._,installOnlyNewlyAddedFromExtensionPack:_.installOnlyNewlyAddedFromExtensionPack??!h.URI.isUri(N),isApplicationScoped:V,profileLocation:V?this.userDataProfilesService.defaultProfile.extensionsResource:_.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:_.productVersion??{version:this.productService.version,date:this.productService.date}},se=h.URI.isUri(N)?void 0:this.installingExtensions.get(b(N,H.profileLocation));se?(this.logService.info("Extension is already requested to install",se.task.identifier.id),f.push(se.task.waitUntilTaskIsFinished())):R(L,N,H,void 0)}return await Promise.all([...o.values()].map(async({task:L})=>{if(L.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",L.identifier.id);else try{const N=await this.getAllDepsAndPackExtensions(L.identifier,L.manifest,!!L.options.installOnlyNewlyAddedFromExtensionPack,!!L.options.installPreReleaseVersion,L.options.profileLocation,L.options.productVersion),_=await this.getInstalled(void 0,L.options.profileLocation,L.options.productVersion),V={...L.options,context:{...L.options.context,[y.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:H,manifest:se}of(0,O.distinct)(N,({gallery:ie})=>ie.identifier.id)){if(o.has(`${H.identifier.id.toLowerCase()}-${V.profileLocation.toString()}`))continue;const ie=this.installingExtensions.get(b(H,V.profileLocation));if(ie){if(this.canWaitForTask(L,ie.task)){const fe=ie.task.identifier;this.logService.info("Waiting for already requested installing extension",fe.id,L.identifier.id),ie.waitingTasks.push(L),f.push(x.Event.toPromise(x.Event.filter(this.onDidInstallExtensions,ce=>ce.some(le=>(0,S.areSameExtensions)(le.identifier,fe)))).then(ce=>{if(this.logService.info("Finished waiting for already requested installing extension",fe.id,L.identifier.id),!ce.find(j=>(0,S.areSameExtensions)(j.identifier,fe))?.local)throw new Error(`Extension ${fe.id} is not installed`)}))}}else _.some(({identifier:fe})=>(0,S.areSameExtensions)(fe,H.identifier))||R(se,H,V,L)}}catch(N){if(h.URI.isUri(L.source))(0,O.isNonEmptyArray)(L.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",L.identifier.id,N.message),(0,O.isNonEmptyArray)(L.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",L.identifier.id,N.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",L.identifier.id),N}})),await this.joinAllSettled([...o.entries()].map(async([L,{task:N}])=>{const _=new Date().getTime();try{const V=await N.run();if(await this.joinAllSettled(this.participants.map(H=>H.postInstall(V,N.source,N.options,D.CancellationToken.None))),!h.URI.isUri(N.source)){const H=N.operation===3,se=H?void 0:(new Date().getTime()-N.source.lastUpdated)/1e3;if(n(this.telemetryService,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(N.source),verificationStatus:N.verificationStatus,duration:new Date().getTime()-_,durationSinceUpdate:se}),c.isWeb&&N.operation!==3)try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}r.set(L,{local:V,identifier:N.identifier,operation:N.operation,source:N.source,context:N.options.context,profileLocation:N.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){const H=v(V);throw h.URI.isUri(N.source)||n(this.telemetryService,N.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(N.source),error:H}),r.set(L,{error:H,identifier:N.identifier,operation:N.operation,source:N.source,context:N.options.context,profileLocation:N.profileLocation,applicationScoped:N.options.isApplicationScoped}),this.logService.error("Error while installing the extension",N.identifier.id,(0,A.getErrorMessage)(H)),H}})),f.length&&await this.joinAllSettled(f),[...r.values()]}catch(L){const N=(H,se,ie)=>{const fe=[];H.manifest.extensionDependencies?.length&&fe.push(...H.manifest.extensionDependencies),H.manifest.extensionPack?.length&&fe.push(...H.manifest.extensionPack);for(const ce of fe){if(ie.includes(ce.toLowerCase()))continue;ie.push(ce.toLowerCase());const le=r.get(`${ce.toLowerCase()}-${se.toString()}`);le?.local&&(ie=N(le.local,se,ie))}return ie},_=H=>({identifier:H.identifier,operation:2,source:H.source,context:H.options.context,profileLocation:H.profileLocation,error:L}),V=[];for(const[H,{task:se,root:ie}]of o){const fe=r.get(H);fe?fe.local&&ie&&!r.get(`${ie.identifier.id.toLowerCase()}-${se.profileLocation.toString()}`)?.local&&(V.push(this.createUninstallExtensionTask(fe.local,{versionOnly:!0,profileLocation:se.profileLocation})),r.set(H,_(se))):(se.cancel(),r.set(H,_(se)))}for(const[H,{task:se}]of o){const ie=r.get(H);if(!ie?.local||se.options.donotIncludePackAndDependencies)continue;N(ie.local,se.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(ce=>o.has(`${ce.toLowerCase()}-${se.profileLocation.toString()}`)&&!r.get(`${ce.toLowerCase()}-${se.profileLocation.toString()}`)?.local)&&(V.push(this.createUninstallExtensionTask(ie.local,{versionOnly:!0,profileLocation:se.profileLocation})),r.set(H,_(se)))}throw V.length&&await Promise.allSettled(V.map(async H=>{try{await H.run(),this.logService.info("Rollback: Uninstalled extension",H.extension.identifier.id)}catch(se){this.logService.warn("Rollback: Error while uninstalling extension",H.extension.identifier.id,(0,A.getErrorMessage)(se))}})),L}finally{for(const{task:L}of o.values())L.source&&!h.URI.isUri(L.source)&&this.installingExtensions.delete(b(L.source,L.profileLocation));if(r.size){const L=[...r.values()];for(const N of L)N.local&&this.logService.info("Extension installed successfully:",N.identifier.id);this._onDidInstallExtensions.fire(L)}}}canWaitForTask(i,r){for(const[,{task:o,waitingTasks:f}]of this.installingExtensions.entries())if(o===i&&(f.includes(r)||f.some(b=>this.canWaitForTask(b,r)))||o===r&&f[0]&&!this.canWaitForTask(i,f[0]))return!1;return!0}async joinAllSettled(i){const r=[],o=[],f=await Promise.allSettled(i);for(const b of f)b.status==="fulfilled"?r.push(b.value):o.push(b.reason);if(o.length){if(o.length===1)throw o[0];let b=new y.ExtensionManagementError("",y.ExtensionManagementErrorCode.Unknown);for(const R of o){const L=R instanceof y.ExtensionManagementError?R.code:y.ExtensionManagementErrorCode.Unknown;b=new y.ExtensionManagementError(R.message?`${R.message}, ${b.message}`:b.message,L!==y.ExtensionManagementErrorCode.Unknown&&L!==y.ExtensionManagementErrorCode.Internal?L:b.code)}throw b}return r}async getAllDepsAndPackExtensions(i,r,o,f,b,R){if(!this.galleryService.isEnabled())return[];const L=await this.getInstalled(void 0,b,R),N=[],_=[],V=async(H,se)=>{N.push(H);const ie=se.extensionDependencies||[],fe=[...ie];if(se.extensionPack){const ce=o?L.find(le=>(0,S.areSameExtensions)(le.identifier,H)):void 0;for(const le of se.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(j=>(0,S.areSameExtensions)({id:j},{id:le}))||fe.every(j=>!(0,S.areSameExtensions)({id:j},{id:le}))&&fe.push(le)}if(fe.length){const ce=fe.filter(le=>N.every(j=>!(0,S.areSameExtensions)(j,{id:le})));if(ce.length){const le=await this.galleryService.getExtensions(ce.map(j=>({id:j,preRelease:f})),D.CancellationToken.None);for(const j of le){if(N.find(W=>(0,S.areSameExtensions)(W,j.identifier)))continue;const Y=ie.some(W=>(0,S.areSameExtensions)({id:W},j.identifier));let z;try{z=await this.checkAndGetCompatibleVersion(j,!1,f,R)}catch(W){if(Y)throw W;this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id,(0,A.getErrorMessage)(W));continue}_.push({gallery:z.extension,manifest:z.manifest}),await V(z.extension.identifier,z.manifest)}}}};return await V(i,r),_}async checkAndGetCompatibleVersion(i,r,o,f){let b;const R=await this.getExtensionsControlManifest();if(R.malicious.some(_=>(0,S.areSameExtensions)(i.identifier,_)))throw new y.ExtensionManagementError(E.localize(1,null,i.identifier.id),y.ExtensionManagementErrorCode.Malicious);const L=R.deprecated[i.identifier.id.toLowerCase()];if(L?.extension?.autoMigrate){if(this.logService.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${L.extension.id}' extension instead.`),b=(await this.galleryService.getExtensions([{id:L.extension.id,preRelease:L.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:f},D.CancellationToken.None))[0],!b)throw new y.ExtensionManagementError(E.localize(2,null,i.identifier.id,L.extension.id),y.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const _=await this.getTargetPlatform();throw new y.ExtensionManagementError(E.localize(3,null,i.identifier.id,this.productService.nameLong,(0,y.TargetPlatformToString)(_)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(b=await this.getCompatibleVersion(i,r,o,f),!b)throw!o&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],D.CancellationToken.None))[0]?new y.ExtensionManagementError(E.localize(4,null,i.displayName??i.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.ExtensionManagementError(E.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),y.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",b.identifier.id);const N=await this.galleryService.getManifest(b,D.CancellationToken.None);if(N===null)throw new y.ExtensionManagementError(`Missing manifest for extension ${b.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(N.version!==b.version)throw new y.ExtensionManagementError(`Cannot install '${b.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:b,manifest:N}}async getCompatibleVersion(i,r,o,f){const b=await this.getTargetPlatform();let R=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(R=(await this.galleryService.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:b,compatible:!0,productVersion:f},D.CancellationToken.None))[0]||null),!R&&await this.galleryService.isExtensionCompatible(i,o,b,f)&&(R=i),R||(r?R=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:b,compatible:!0,productVersion:f},D.CancellationToken.None))[0]||null:R=await this.galleryService.getCompatibleExtension(i,o,b,f)),R}async uninstallExtension(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},f=V=>`${V.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,b=this.uninstallingExtensions.get(f(i.identifier));if(b)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),b.waitUntilTaskIsFinished();const R=V=>{const H=this.createUninstallExtensionTask(V,o);return this.uninstallingExtensions.set(f(H.extension.identifier),H),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${V.identifier.id}@${V.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${V.identifier.id}@${V.manifest.version}`),this._onUninstallExtension.fire({identifier:V.identifier,profileLocation:o.profileLocation,applicationScoped:V.isApplicationScoped}),H},L=(V,H)=>{H?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${V.identifier.id}@${V.manifest.version}`,o.profileLocation.toString(),H.message):this.logService.error("Failed to uninstall extension:",`${V.identifier.id}@${V.manifest.version}`,H.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${V.identifier.id}@${V.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${V.identifier.id}@${V.manifest.version}`),n(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,S.getLocalExtensionTelemetryData)(V),error:H}),this._onDidUninstallExtension.fire({identifier:V.identifier,error:H?.code,profileLocation:o.profileLocation,applicationScoped:V.isApplicationScoped})},N=[],_=[];try{N.push(R(i));const V=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const H=this.getAllPackExtensionsToUninstall(i,V);for(const se of H)this.uninstallingExtensions.has(f(se.identifier))?this.logService.info("Extensions is already requested to uninstall",se.identifier.id):N.push(R(se))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(N.map(H=>H.extension),V,i),await this.joinAllSettled(N.map(async H=>{try{if(await H.run(),await this.joinAllSettled(this.participants.map(se=>se.postUninstall(H.extension,o,D.CancellationToken.None))),H.extension.identifier.uuid)try{await this.galleryService.reportStatistic(H.extension.manifest.publisher,H.extension.manifest.name,H.extension.manifest.version,"uninstall")}catch{}L(H.extension)}catch(se){const ie=v(se);throw L(H.extension,ie),ie}finally{_.push(H)}}))}catch(V){const H=v(V);for(const se of N){try{se.cancel()}catch{}_.includes(se)||L(se.extension,H)}throw H}finally{for(const V of N)this.uninstallingExtensions.delete(f(V.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",V.extension.identifier.id)}}checkForDependents(i,r,o){for(const f of i){const b=this.getDependents(f,r);if(b.length){const R=b.filter(L=>!i.some(N=>(0,S.areSameExtensions)(N.identifier,L.identifier)));if(R.length)throw new Error(this.getDependentsErrorMessage(f,R,o))}}}getDependentsErrorMessage(i,r,o){return o===i?r.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const f=i.manifest.extensionPack?i.manifest.extensionPack:[];if(f.length){const b=r.filter(L=>!L.isBuiltin&&f.some(N=>(0,S.areSameExtensions)({id:N},L.identifier))),R=[];for(const L of b)R.push(...this.getAllPackExtensionsToUninstall(L,r,o));return[...b,...R]}return[]}getDependents(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(f=>(0,S.areSameExtensions)({id:f},i.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(i){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.getErrorMessage)(i)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=p,e.AbstractExtensionManagementService=p=ve([oe(0,y.IExtensionGalleryService),oe(1,l.ITelemetryService),oe(2,u.IUriIdentityService),oe(3,C.ILogService),oe(4,g.IProductService),oe(5,w.IUserDataProfilesService)],p);function v(t){if(t instanceof y.ExtensionManagementError)return t;if(t instanceof y.ExtensionGalleryError){const r=new y.ExtensionManagementError(t.message,y.ExtensionManagementErrorCode.Gallery);return r.stack=t.stack,r}const i=new y.ExtensionManagementError(t.message,(0,A.isCancellationError)(t)?y.ExtensionManagementErrorCode.Cancelled:y.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:r,verificationStatus:o,duration:f,error:b,durationSinceUpdate:R}){let L,N;(0,a.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(L=y.ExtensionManagementErrorCode.Signature,N=o),o="Unverified")),b&&(L=b.code,b.code===y.ExtensionManagementErrorCode.Signature&&(N=b.message)),t.publicLog(i,{...r,verificationStatus:o,success:!b,duration:f,errorcode:L,errorcodeDetail:N,durationSinceUpdate:R})}class s{constructor(){this.barrier=new k.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,k.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,k.createCancelablePromise)(i=>new Promise((r,o)=>{const f=i.onCancellationRequested(()=>{f.dispose(),o(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=s}),define(ne[42],re([0,1,8,14,2,5,30,11,21,26,13,10,6,24,23,3,9,22]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class w extends Error{constructor(t,i){super(t),this.code=i}}e.ExtensionsProfileScanningError=w,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let p=class extends D.Disposable{constructor(t,i,r,o,f,b){super(),this.extensionsLocation=t,this.fileService=i,this.userDataProfilesService=r,this.uriIdentityService=o,this.telemetryService=f,this.logService=b,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new x.ResourceMap}scanProfileExtensions(t,i){return this.withProfileExtensions(t,void 0,i)}async addExtensionsToProfile(t,i,r){const o=[],f=[];try{return await this.withProfileExtensions(i,b=>{const R=[];if(r)R.push(...b);else for(const L of b)t.some(([N])=>(0,a.areSameExtensions)(N.identifier,L.identifier)&&N.manifest.version!==L.version)?o.push(L):R.push(L);for(const[L,N]of t){const _=R.findIndex(H=>(0,a.areSameExtensions)(H.identifier,L.identifier)&&H.version===L.manifest.version),V={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:N};_===-1?(f.push(V),R.push(V)):R.splice(_,1,V)}return f.length&&this._onAddExtensions.fire({extensions:f,profileLocation:i}),o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:i}),R}),f.length&&this._onDidAddExtensions.fire({extensions:f,profileLocation:i}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:i}),f}catch(b){throw f.length&&this._onDidAddExtensions.fire({extensions:f,error:b,profileLocation:i}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:b,profileLocation:i}),b}}async updateMetadata(t,i){const r=[];return await this.withProfileExtensions(i,o=>{const f=[];for(const b of o){const R=t.find(([L])=>(0,a.areSameExtensions)(L.identifier,b.identifier)&&L.manifest.version===b.version);R&&(b.metadata={...b.metadata,...R[1]},r.push(b)),f.push(b)}return f}),r}async removeExtensionFromProfile(t,i){const r=[];try{await this.withProfileExtensions(i,o=>{const f=[];for(const b of o)(0,a.areSameExtensions)(b.identifier,t.identifier)?r.push(b):f.push(b);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),f}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i})}catch(o){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:o,profileLocation:i}),o}}async withProfileExtensions(t,i,r){return this.getResourceAccessQueue(t).queue(async()=>{let o=[],f;try{const b=await this.fileService.readFile(t);f=JSON.parse(b.value.toString().trim()||"[]")}catch(b){if((0,h.toFileOperationResult)(b)!==1)throw b;if(this.uriIdentityService.extUri.isEqual(t,this.userDataProfilesService.defaultProfile.extensionsResource)&&(f=await this.migrateFromOldDefaultProfileExtensionsLocation()),!f&&r?.bailOutWhenFileNotFound)throw new w((0,g.getErrorMessage)(b),"ERROR_PROFILE_NOT_FOUND")}if(f){Array.isArray(f)||this.reportAndThrowInvalidConentError(t);let b=!1;for(const R of f){v(R)||this.reportAndThrowInvalidConentError(t);let L;if((0,C.isString)(R.relativeLocation)&&R.relativeLocation)L=this.resolveExtensionLocation(R.relativeLocation);else if((0,C.isString)(R.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{L=P.URI.revive(R.location);const N=this.toRelativePath(L);N&&(b=!0,R.relativeLocation=N)}(0,C.isUndefined)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(b=!0,R.metadata.hasPreReleaseVersion=!0),o.push({identifier:R.identifier,location:L,version:R.version,metadata:R.metadata})}b&&await this.fileService.writeFile(t,k.VSBuffer.fromString(JSON.stringify(f)))}if(i){o=i(o);const b=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.toRelativePath(R.location),metadata:R.metadata}));await this.fileService.writeFile(t,k.VSBuffer.fromString(JSON.stringify(b)))}return o})}reportAndThrowInvalidConentError(t){const i=new w(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(t){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(t),this.extensionsLocation)?this.uriIdentityService.extUri.basename(t):void 0}resolveExtensionLocation(t){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,t)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const t=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(t)).value.toString()}catch(f){if((0,h.toFileOperationResult)(f)===1)return;throw f}this.logService.info("Migrating extensions from old default profile location",t.toString());let o;try{const f=JSON.parse(r);Array.isArray(f)&&f.every(b=>v(b))?o=f:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.logService.error(f)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,k.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(f){if((0,h.toFileOperationResult)(f)===3)this.logService.info("Migration from old default profile location to new location is done by another window",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw f}try{await this.fileService.del(t)}catch(f){(0,h.toFileOperationResult)(f)!==1&&this.logService.error(f)}try{await this.fileService.del(i)}catch(f){(0,h.toFileOperationResult)(f)!==1&&this.logService.error(f)}return o})()),this._migrationPromise}getResourceAccessQueue(t){let i=this.resourcesAccessQueueMap.get(t);return i||(i=new O.Queue,this.resourcesAccessQueueMap.set(t,i)),i}};e.AbstractExtensionsProfileScannerService=p,e.AbstractExtensionsProfileScannerService=p=ve([oe(1,h.IFileService),oe(2,S.IUserDataProfilesService),oe(3,m.IUriIdentityService),oe(4,l.ITelemetryService),oe(5,y.ILogService)],p);function v(s){return(0,C.isObject)(s)&&(0,c.isIExtensionIdentifier)(s.identifier)&&(n(s.location)||(0,C.isString)(s.location)&&s.location)&&((0,C.isUndefined)(s.relativeLocation)||(0,C.isString)(s.relativeLocation))&&s.version&&(0,C.isString)(s.version)}function n(s){return s?(0,C.isString)(s.path)&&(0,C.isString)(s.scheme):!1}}),define(ne[53],re([0,1,19,8,27,14,9,38,83,2,15,16,12,17,44,55,3,11,99,18,26,37,50,13,10,6,32,5,47,42,24,23,117]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l,u,w,p,v,n,s,t,i,r,o,f,b,R,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=fe;var _;(function(le){function j(Y,z){if(Y===z)return!0;const W=Object.keys(Y),q=new Set;for(const X of Object.keys(z))q.add(X);if(W.length!==q.size)return!1;for(const X of W){if(Y[X]!==z[X])return!1;q.delete(X)}return q.size===0}le.equals=j})(_||(e.Translations=_={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let V=class extends a.Disposable{constructor(j,Y,z,W,q,X,J,Z,F,M,d,I){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=Y,this.extensionsControlLocation=z,this.currentProfile=W,this.userDataProfilesService=q,this.extensionsProfileScannerService=X,this.fileService=J,this.logService=Z,this.environmentService=F,this.productService=M,this.uriIdentityService=d,this.instantiationService=I,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,S.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(se,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,Y,z){const[W,q]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(Y)]),X=z?await this.scanExtensionsUnderDevelopment(j,[...W,...q]):[];return this.dedupExtensions(W,q,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const Y=[];Y.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),Y.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[z,W]=await Promise.all(Y);return this.applyScanOptions([...z,...W],0,j,!1)}async scanUserExtensions(j){const Y=j.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Y);const z=this.uriIdentityService.extUri.isEqual(j.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.createExtensionScannerInput(Y,!!j.profileLocation,1,!j.includeUninstalled,j.language,!0,z,j.productVersion??this.getProductVersion()),q=j.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let X;try{X=await q.scanExtensions(W)}catch(J){if(J instanceof b.ExtensionsProfileScanningError&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),X=await q.scanExtensions(W);else throw J}return X=await this.applyScanOptions(X,1,j,!0),this.logService.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(j,Y){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===h.Schemas.file).map(async W=>{const q=await this.createExtensionScannerInput(W,!1,1,!0,j.language,!1,void 0,j.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(q)).map(J=>(J.type=Y.find(Z=>(0,p.areSameExtensions)(Z.identifier,J.identifier))?.type??J.type,this.extensionsScanner.validate(J,q)))}))).flat();return this.applyScanOptions(z,"development",j,!0)}return[]}async scanExistingExtension(j,Y,z){const W=await this.createExtensionScannerInput(j,!1,Y,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),q=await this.extensionsScanner.scanExtension(W);return!q||!z.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions(j,Y,z){const W=await this.createExtensionScannerInput(j,!1,Y,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),q=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(q,Y,z,!0)}async scanMultipleExtensions(j,Y,z){const W=[];return await Promise.all(j.map(async q=>{const X=await this.scanOneOrMultipleExtensions(q,Y,z);W.push(...X)})),this.applyScanOptions(W,Y,z,!0)}async scanMetadata(j){const Y=(0,S.joinPath)(j,"package.json"),z=(await this.fileService.readFile(Y)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(j,Y){const z=(0,S.joinPath)(j,"package.json"),W=(await this.fileService.readFile(z)).value.toString(),q=JSON.parse(W);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,q.__metadata={...q.__metadata,...Y},await this.fileService.writeFile((0,S.joinPath)(j,"package.json"),A.VSBuffer.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(j){if(j instanceof b.ExtensionsProfileScanningError&&j.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw j}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const j=await this.scanUserExtensions({includeInvalid:!0});if(j.length)await this.extensionsProfileScannerService.addExtensionsToProfile(j.map(Y=>[Y,Y.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,s.toFileOperationResult)(Y)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,x.getErrorMessage)(Y))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(j){this.logService.error(j)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(j,Y,z,W){return z.includeAllVersions||(j=this.dedupExtensions(Y===0?j:void 0,Y===1?j:void 0,Y==="development"?j:void 0,await this.getTargetPlatform(),W)),z.includeInvalid||(j=j.filter(q=>q.isValid)),j.sort((q,X)=>{const J=E.basename(q.location.fsPath),Z=E.basename(X.location.fsPath);return J<Z?-1:J>Z?1:0})}dedupExtensions(j,Y,z,W,q){const X=(Z,F,M)=>{if(Z.isValid&&!F.isValid)return!1;if(Z.isValid===F.isValid){if(q&&m.gt(Z.manifest.version,F.manifest.version))return this.logService.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${Z.location.path} with version ${Z.manifest.version}`),!1;if(m.eq(Z.manifest.version,F.manifest.version)){if(Z.type===0)return this.logService.debug(`Skipping extension ${F.location.path} in favour of system extension ${Z.location.path} with same version`),!1;if(Z.targetPlatform===W)return this.logService.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return M?this.logService.warn(`Overwriting user extension ${Z.location.path} with ${F.location.path}.`):this.logService.debug(`Overwriting user extension ${Z.location.path} with ${F.location.path}.`),!0},J=new v.ExtensionIdentifierMap;return j?.forEach(Z=>{const F=J.get(Z.identifier.id);(!F||X(F,Z,!1))&&J.set(Z.identifier.id,Z)}),Y?.forEach(Z=>{const F=J.get(Z.identifier.id);if(!F&&j&&Z.type===0){this.logService.debug(`Skipping obsolete system extension ${Z.location.path}.`);return}(!F||X(F,Z,!1))&&J.set(Z.identifier.id,Z)}),z?.forEach(Z=>{const F=J.get(Z.identifier.id);(!F||X(F,Z,!0))&&J.set(Z.identifier.id,Z),J.set(Z.identifier.id,Z)}),[...J.values()]}async scanDefaultSystemExtensions(j,Y){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0,this.getProductVersion()),q=await(j&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",q.length),q}async scanDevSystemExtensions(j,Y){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=Y?await this.getBuiltInExtensionControl():{},q=[],X=l.URI.file(E.normalize(E.join(h.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Z of z){const F=W[Z.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":q.push((0,S.joinPath)(X,Z.name));break;default:q.push(l.URI.file(F));break}}const J=await Promise.all(q.map(async Z=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(Z,!1,0,!0,j,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",J.length),(0,O.coalesce)(J)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,Y,z,W,q,X,J,Z){const F=await this.getTranslations(q??y.language),M=await this.getMtime(j),d=Y&&!this.uriIdentityService.extUri.isEqual(j,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,I=d?await this.getMtime(d):void 0;return new H(j,M,d,I,Y,J,z,W,X,Z.version,Z.date,this.productService.commit,!this.environmentService.isBuilt,q,F)}async getMtime(j){try{const Y=await this.fileService.stat(j);if(typeof Y.mtime=="number")return Y.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=V,e.AbstractExtensionsScannerService=V=ve([oe(4,R.IUserDataProfilesService),oe(5,b.IExtensionsProfileScannerService),oe(6,s.IFileService),oe(7,i.ILogService),oe(8,w.IEnvironmentService),oe(9,r.IProductService),oe(10,L.IUriIdentityService),oe(11,t.IInstantiationService)],V);class H{constructor(j,Y,z,W,q,X,J,Z,F,M,d,I,T,U,G){this.location=j,this.mtime=Y,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=W,this.profile=q,this.profileScanOptions=X,this.type=J,this.excludeObsolete=Z,this.validate=F,this.productVersion=M,this.productDate=d,this.productCommit=I,this.devMode=T,this.language=U,this.translations=G}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,Y){return(0,S.isEqual)(j.location,Y.location)&&j.mtime===Y.mtime&&(0,S.isEqual)(j.applicationExtensionslocation,Y.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&j.profile===Y.profile&&D.equals(j.profileScanOptions,Y.profileScanOptions)&&j.type===Y.type&&j.excludeObsolete===Y.excludeObsolete&&j.validate===Y.validate&&j.productVersion===Y.productVersion&&j.productDate===Y.productDate&&j.productCommit===Y.productCommit&&j.devMode===Y.devMode&&j.language===Y.language&&_.equals(j.translations,Y.translations)}}e.ExtensionScannerInput=H;let se=class extends a.Disposable{constructor(j,Y,z,W,q){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=Y,this.uriIdentityService=z,this.fileService=W,this.logService=q}async scanExtensions(j){const Y=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let z={};if(j.excludeObsolete&&j.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(W)}catch{}return(0,g.isEmptyObject)(z)?Y:Y.filter(W=>!z[p.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation(j){const Y=await this.fileService.resolve(j.location);if(!Y.children?.length)return[];const z=await Promise.all(Y.children.map(async W=>{if(!W.isDirectory||j.type===1&&(0,S.basename)(W.resource).indexOf(".")===0)return null;const q=new H(W.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(q)}));return(0,O.coalesce)(z).sort((W,q)=>W.location.path<q.location.path?-1:1)}async scanExtensionsFromProfile(j){let Y=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){Y=Y.filter(W=>!W.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,j);Y.push(...z)}return Y}async scanExtensionsFromProfileResource(j,Y,z){const W=await this.extensionsProfileScannerService.scanProfileExtensions(j,z.profileScanOptions);if(!W.length)return[];const q=await Promise.all(W.map(async X=>{if(Y(X)){const J=new H(X.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(J,X.metadata)}return null}));return(0,O.coalesce)(q)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,S.joinPath)(j.location,"package.json"))){const Y=await this.scanExtension(j);return Y?[Y]:[]}else return await this.scanExtensions(j)}catch(Y){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,x.getErrorMessage)(Y)),[]}}async scanExtension(j,Y){try{let z=await this.scanExtensionManifest(j.location);if(z){z.publisher||(z.publisher=v.UNDEFINED_PUBLISHER),Y=Y??z.__metadata,delete z.__metadata;const W=(0,p.getGalleryExtensionId)(z.publisher,z.name),q=Y?.id?{id:W,uuid:Y.id}:{id:W},X=Y?.isSystem?0:j.type,J=X===0||!!Y?.isBuiltin;z=await this.translateManifest(j.location,z,H.createNlsConfiguration(j));const Z={type:X,identifier:q,manifest:z,location:j.location,isBuiltin:J,targetPlatform:Y?.targetPlatform??"undefined",publisherDisplayName:Y?.publisherDisplayName,metadata:Y,isValid:!0,validations:[]};return j.validate?this.validate(Z,j):Z}}catch(z){j.type!==0&&this.logService.error(z)}return null}validate(j,Y){let z=!0;const W=(0,n.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,j.manifest,j.isBuiltin);for(const[q,X]of W)q===C.default.Error&&(z=!1,this.logService.error(this.formatMessage(Y.location,X)));return j.isValid=z,j.validations=W,j}async scanExtensionManifest(j){const Y=(0,S.joinPath)(j,"package.json");let z;try{z=(await this.fileService.readFile(Y)).value.toString()}catch(q){return(0,s.toFileOperationResult)(q)!==1&&this.logService.error(this.formatMessage(j,(0,u.localize)(0,null,Y.path,q.message))),null}let W;try{W=JSON.parse(z)}catch{const X=[];(0,P.parse)(z,X);for(const J of X)this.logService.error(this.formatMessage(j,(0,u.localize)(1,null,Y.path,J.offset,J.length,(0,c.getParseErrorMessage)(J.error))));return null}return(0,P.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage(j,(0,u.localize)(2,null,Y.path))),null):W}async translateManifest(j,Y,z){const W=await this.getLocalizedMessages(j,Y,z);if(W)try{const q=[],X=await this.resolveOriginalMessageBundle(W.default,q);if(q.length>0)return q.forEach(Z=>{this.logService.error(this.formatMessage(j,(0,u.localize)(3,null,W.default?.path,(0,c.getParseErrorMessage)(Z.error))))}),Y;if((0,P.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage(j,(0,u.localize)(4,null,W.default?.path))),Y;const J=W.values||Object.create(null);return(0,N.localizeManifest)(this.logService,Y,J,X)}catch{}return Y}async getLocalizedMessages(j,Y,z){const W=(0,S.joinPath)(j,"package.nls.json"),q=(F,M)=>{M.forEach(d=>{this.logService.error(this.formatMessage(j,(0,u.localize)(5,null,F?.path,(0,c.getParseErrorMessage)(d.error))))})},X=F=>{this.logService.error(this.formatMessage(j,(0,u.localize)(6,null,F?.path)))},J=`${Y.publisher}.${Y.name}`,Z=z.translations[J];if(Z)try{const F=l.URI.file(Z),M=(await this.fileService.readFile(F)).value.toString(),d=[],I=(0,P.parse)(M,d);return d.length>0?(q(F,d),{values:void 0,default:W}):(0,P.getNodeType)(I)!=="object"?(X(F),{values:void 0,default:W}):{values:I.contents?I.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let M;try{M=await this.findMessageBundles(j,z)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const d=(await this.fileService.readFile(M.localized)).value.toString(),I=[],T=(0,P.parse)(d,I);return I.length>0?(q(M.localized,I),{values:void 0,default:M.original}):(0,P.getNodeType)(T)!=="object"?(X(M.localized),{values:void 0,default:M.original}):{values:T,default:M.original}}catch{return{values:void 0,default:M.original}}}}async resolveOriginalMessageBundle(j,Y){if(j)try{const z=(await this.fileService.readFile(j)).value.toString();return(0,P.parse)(z,Y)}catch{}}findMessageBundles(j,Y){return new Promise((z,W)=>{const q=X=>{const J=(0,S.joinPath)(j,`package.nls.${X}.json`);this.fileService.exists(J).then(Z=>{Z&&z({localized:J,original:(0,S.joinPath)(j,"package.nls.json")});const F=X.lastIndexOf("-");F===-1?z({localized:(0,S.joinPath)(j,"package.nls.json"),original:null}):(X=X.substring(0,F),q(X))})};if(Y.devMode||Y.pseudo||!Y.language)return z({localized:(0,S.joinPath)(j,"package.nls.json"),original:null});q(Y.language)})}formatMessage(j,Y){return`[${j.path}]: ${Y}`}};se=ve([oe(1,b.IExtensionsProfileScannerService),oe(2,L.IUriIdentityService),oe(3,s.IFileService),oe(4,i.ILogService)],se);let ie=class extends se{constructor(j,Y,z,W,q,X,J){super(Y,W,q,X,J),this.currentProfile=j,this.userDataProfilesService=z,this.cacheValidatorThrottler=this._register(new k.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const Y=this.getCacheFile(j),z=await this.readExtensionCache(Y);if(this.input=j,z&&z.input&&H.equals(z.input,this.input))return this.logService.debug("Using cached extensions scan result",j.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(q=>(q.location=l.URI.revive(q.location),q));const W=await super.scanExtensions(j);return await this.writeExtensionCache(Y,{input:j,result:W}),W}async readExtensionCache(j){try{const Y=await this.fileService.readFile(j),z=JSON.parse(Y.value.toString());return{result:z.result,input:(0,f.revive)(z.input)}}catch(Y){this.logService.debug("Error while reading the extension cache file:",j.path,(0,x.getErrorMessage)(Y))}return null}async writeExtensionCache(j,Y){try{await this.fileService.writeFile(j,A.VSBuffer.fromString(JSON.stringify(Y)))}catch(z){this.logService.debug("Error while writing the extension cache file:",j.path,(0,x.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const j=this.getCacheFile(this.input),Y=await this.readExtensionCache(j);if(!Y)return;const z=Y.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(W,z))try{this.logService.info("Invalidating Cache",z,W),await this.fileService.del(j),this._onDidChangeCache.fire()}catch(q){this.logService.error(q)}}getCacheFile(j){const Y=this.getProfile(j);return this.uriIdentityService.extUri.joinPath(Y.cacheHome,j.type===0?v.BUILTIN_MANIFEST_CACHE_FILE:v.USER_MANIFEST_CACHE_FILE)}getProfile(j){return j.type===0?this.userDataProfilesService.defaultProfile:j.profile?this.uriIdentityService.extUri.isEqual(j.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Y=>this.uriIdentityService.extUri.isEqual(j.location,Y.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};ie=ve([oe(2,R.IUserDataProfilesService),oe(3,b.IExtensionsProfileScannerService),oe(4,L.IUriIdentityService),oe(5,s.IFileService),oe(6,i.ILogService)],ie);function fe(le,j){const Y=(0,p.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:Y,identifier:new v.ExtensionIdentifier(Y),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:j,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class ce extends V{constructor(j,Y,z,W,q,X,J,Z,F,M,d,I){super(j,Y,(0,S.joinPath)(z,".vscode-oss-dev","extensions","control.json"),W,q,X,J,Z,F,M,d,I),this.translationsPromise=(async()=>{if(y.translationsConfigFile)try{const T=await this.fileService.readFile(l.URI.file(y.translationsConfigFile));return JSON.parse(T.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=ce}),define(ne[161],re([0,1,59,8,34,5,2,15,16,25,6,24]),function(K,e,O,k,D,A,x,P,c,a,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends x.Disposable{constructor(m,C){super(),this.userDataProfilesService=m,this.logService=C,this.processesLimiter=new k.Limiter(5)}async postUninstall(m){const C=this.parseScript(m,"uninstall");C&&(this.logService.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(C.script,"uninstall",C.args,!0,m),this.logService.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(g){this.logService.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.logService.error(g)}}));try{await a.Promises.rm(this.getExtensionStoragePath(m))}catch(g){this.logService.error("Error while removing extension storage path",m.identifier.id),this.logService.error(g)}}parseScript(m,C){const g=`vscode:${C}`;if(m.location.scheme===P.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[g]=="string"){const l=m.manifest.scripts[g].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(m.identifier.id,m.manifest.version,`${g} should be a node script`),null):{script:(0,c.join)(m.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(m,C,g,l,u){return new Promise((w,p)=>{const v=this.start(m,C,g,u);let n;const s=t=>{n&&(clearTimeout(n),n=null),t?p(t):w(void 0)};v.on("error",t=>{s((0,D.toErrorMessage)(t)||"Unknown")}),v.on("exit",(t,i)=>{s(t?`post-${C} process exited with code ${t}`:void 0)}),l&&(n=setTimeout(()=>{n=null,v.kill(),p("timed out")},5e3))})}start(m,C,g,l){const u={silent:!0,execArgv:void 0},w=(0,O.fork)(m,[`--type=extension-post-${C}`,...g],u);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(w.stdout,"data"),v=A.Event.fromNodeEventEmitter(w.stderr,"data");this._register(p(t=>this.logService.info(l.identifier.id,l.manifest.version,`post-${C}`,t))),this._register(v(t=>this.logService.error(l.identifier.id,l.manifest.version,`post-${C}`,t)));const n=A.Event.any(A.Event.map(p,t=>({data:`%c${t}`,format:[""]}),this._store),A.Event.map(v,t=>({data:`%c${t}`,format:["color: red"]}),this._store));return A.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this._store)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),w}getExtensionStoragePath(m){return(0,c.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=y,e.ExtensionsLifecycle=y=ve([oe(0,E.IUserDataProfilesService),oe(1,h.ILogService)],y)}),define(ne[162],re([0,1,8,14,20,34,9,5,43,2,30,15,16,17,44,3,11,28,25,49,100,61,18,160,21,26,42,53,147,161,118,140,148,50,13,10,6,32,22,23,24]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l,u,w,p,v,n,s,t,i,r,o,f,b,R,L,N,_,V,H,se,ie,fe,ce,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,H.refineServiceDecorator)(t.IExtensionManagementService);const j=".vsctmp";let Y=class extends s.AbstractExtensionManagementService{constructor(F,M,d,I,T,U,G,B,te,ae,ue,me){super(F,M,ue,d,ae,me),this.extensionsScannerService=T,this.extensionsProfileScannerService=U,this.downloadService=G,this.fileService=te,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new h.ResourceSet;const ye=this._register(B.createInstance(b.ExtensionsLifecycle));this.extensionsScanner=this._register(B.createInstance(z,pe=>ye.postUninstall(pe))),this.manifestCache=this._register(new L.ExtensionsManifestCache(me,te,ue,this,this.logService)),this.extensionsDownloader=this._register(B.createInstance(f.ExtensionsDownloader));const he=this._register(new N.ExtensionsWatcher(this,this.extensionsScannerService,me,U,ue,te,d));this._register(he.onDidChangeExtensionsByAnotherSource(pe=>this.onDidChangeExtensionsFromAnotherSource(pe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,i.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const M=await this.collectFiles(F),d=await(0,w.zip)((0,S.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,l.generateUuid)()).fsPath,M);return g.URI.file(d)}async unzip(F){return this.logService.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:M,cleanup:d}=await this.downloadVsix(F),I=y.resolve(M.fsPath);try{return await(0,R.getManifest)(I)}finally{await d()}}getInstalled(F,M=this.userDataProfilesService.defaultProfile.extensionsResource,d={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(F??null,M,d)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.extensionsScanner.scanUserExtensionAtLocation(F)}async install(F,M={}){this.logService.trace("ExtensionManagementService#install",F.toString());const{location:d,cleanup:I}=await this.downloadVsix(F);try{const T=await(0,R.getManifest)(y.resolve(d.fsPath)),U=(0,i.getGalleryExtensionId)(T.publisher,T.name);if(T.engines&&T.engines.vscode&&!(0,_.isEngineValid)(T.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,U,this.productService.version));const B=(await this.installExtensions([{manifest:T,extension:d,options:M}])).find(({identifier:te})=>(0,i.areSameExtensions)(te,{id:U}));if(B?.local)return B.local;throw B?.error?B.error:(0,s.toExtensionManagementError)(new Error(`Unknown error while installing extension ${U}`))}finally{await I()}}async installFromLocation(F,M){this.logService.trace("ExtensionManagementService#installFromLocation",F.toString());const d=await this.extensionsScanner.scanUserExtensionAtLocation(F);if(!d||!d.manifest.name||!d.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.addExtensionsToProfile([[d,{source:"resource"}]],M),this.logService.info("Successfully installed extension",d.identifier.id,M.toString()),d}async installExtensionsFromProfile(F,M,d){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",F,M.toString(),d.toString());const I=(await this.getInstalled(1,M)).filter(T=>F.some(U=>(0,i.areSameExtensions)(U,T.identifier)));if(I.length){const T=await Promise.all(I.map(U=>this.extensionsScanner.scanMetadata(U,M)));await this.addExtensionsToProfile(I.map((U,G)=>[U,T[G]]),d),this.logService.info("Successfully installed extensions",I.map(U=>U.identifier.id),d.toString())}return I}async updateMetadata(F,M,d=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id),M.isPreReleaseVersion&&(M.preRelease=!0,M.hasPreReleaseVersion=!0),M.isMachineScoped===!1&&(M.isMachineScoped=void 0),M.isBuiltin===!1&&(M.isBuiltin=void 0),M.pinned===!1&&(M.pinned=void 0),F=await this.extensionsScanner.updateMetadata(F,M,d),this.manifestCache.invalidate(d),this._onDidUpdateExtensionMetadata.fire(F),F}async reinstallFromGallery(F){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(1,null));const M=await this.getTargetPlatform(),[d]=await this.galleryService.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:M,compatible:!0},D.CancellationToken.None);if(!d)throw new Error(p.localize(2,null));await this.extensionsScanner.setUninstalled(F);try{await this.extensionsScanner.removeUninstalledExtension(F)}catch(I){throw new Error(p.localize(3,null,(0,A.toErrorMessage)(I)))}return this.installFromGallery(d)}copyExtension(F,M,d,I){return this.extensionsScanner.copyExtension(F,M,d,I)}copyExtensions(F,M){return this.extensionsScanner.copyExtensions(F,M,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...F){return this.extensionsScanner.setUninstalled(...F)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(F){this.logService.error(F)}}async download(F,M,d){const{location:I}=await this.extensionsDownloader.download(F,M,!d);return I}async downloadVsix(F){if(F.scheme===E.Schemas.file)return{location:F,async cleanup(){}};this.logService.trace("Downloading extension from",F.toString());const M=(0,S.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,l.generateUuid)());return await this.downloadService.download(F,M),this.logService.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.fileService.del(M)}catch(I){this.logService.error(I)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(F,M,d){if(g.URI.isUri(M))return new X(F,M,d,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const I=i.ExtensionKey.create(M).toString();let T=this.installGalleryExtensionsTasks.get(I);return T||(this.installGalleryExtensionsTasks.set(I,T=new q(F,M,d,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService,this.telemetryService)),T.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(I))),T}createUninstallExtensionTask(F,M){return new J(F,M.profileLocation,this.extensionsProfileScannerService)}async collectFiles(F){const M=async I=>{let T=await u.Promises.readdir(I);T=T.map(B=>y.join(I,B));const U=await Promise.all(T.map(B=>u.Promises.stat(B)));let G=Promise.resolve([]);return U.forEach((B,te)=>{const ae=T[te];B.isFile()&&(G=G.then(ue=>[...ue,ae])),B.isDirectory()&&(G=G.then(ue=>M(ae).then(me=>[...ue,...me])))}),G};return(await M(F.location.fsPath)).map(I=>({path:`extension/${y.relative(F.location.fsPath,I)}`,localPath:I}))}async onDidChangeExtensionsFromAnotherSource({added:F,removed:M}){if(M){const d=F&&this.uriIdentityService.extUri.isEqual(M.profileLocation,F.profileLocation)?M.extensions.filter(I=>F.extensions.every(T=>!(0,i.areSameExtensions)(T,I))):M.extensions;for(const I of d)this.logService.info("Extensions removed from another source",I.id,M.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:I,profileLocation:M.profileLocation})}if(F){const I=(await this.getInstalled(1,F.profileLocation)).filter(T=>F.extensions.some(U=>(0,i.areSameExtensions)(U,T.identifier)));this._onDidInstallExtensions.fire(I.map(T=>(this.logService.info("Extensions added from another source",T.identifier.id,F.profileLocation.toString()),{identifier:T.identifier,local:T,profileLocation:F.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(M=>this.knownDirectories.add(M)));const F=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const M of F.children??[])M.isDirectory&&this.knownDirectories.add(M.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(M=>this.onDidFilesChange(M)))}async onDidFilesChange(F){if(!F.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const M=[];for(const d of F.rawAdded){if(this.knownDirectories.has(d)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(d,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(d).startsWith(".")||!(await this.fileService.stat(d)).isDirectory)continue;const I=await this.extensionsScanner.scanUserExtensionAtLocation(d);I&&I.installedTimestamp===void 0&&(this.knownDirectories.add(d),M.push(I))}M.length&&(await this.addExtensionsToProfile(M.map(d=>[d,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",M.map(d=>d.identifier.id)))}async addExtensionsToProfile(F,M){const d=F.map(I=>I[0]);await this.setInstalled(d),await this.extensionsProfileScannerService.addExtensionsToProfile(F,M),this._onDidInstallExtensions.fire(d.map(I=>({local:I,identifier:I.identifier,operation:1,profileLocation:M})))}async setInstalled(F){const M=await this.extensionsScanner.getUninstalledExtensions();for(const d of F){const I=i.ExtensionKey.create(d);M[I.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",I.id),await this.extensionsScanner.setInstalled(I),this.logService.info("Removed the extension from uninstalled list:",I.id))}}};e.ExtensionManagementService=Y,e.ExtensionManagementService=Y=ve([oe(0,t.IExtensionGalleryService),oe(1,fe.ITelemetryService),oe(2,se.ILogService),oe(3,n.INativeEnvironmentService),oe(4,o.IExtensionsScannerService),oe(5,r.IExtensionsProfileScannerService),oe(6,v.IDownloadService),oe(7,H.IInstantiationService),oe(8,V.IFileService),oe(9,ie.IProductService),oe(10,ce.IUriIdentityService),oe(11,le.IUserDataProfilesService)],Y);let z=class extends a.Disposable{constructor(F,M,d,I,T,U){super(),this.beforeRemovingExtension=F,this.fileService=M,this.extensionsScannerService=d,this.extensionsProfileScannerService=I,this.uriIdentityService=T,this.logService=U,this._onExtract=this._register(new P.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,S.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new O.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(F,M,d){const I={includeInvalid:!0,profileLocation:M,productVersion:d};let T=[];return F===null||F===0?T.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},I,!1)):F===1&&T.push(...await this.extensionsScannerService.scanUserExtensions(I)),T=F!==null?T.filter(U=>U.type===F):T,Promise.all(T.map(U=>this.toLocalExtension(U)))}async scanAllUserExtensions(F){const M=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(M.map(d=>this.toLocalExtension(d)))}async scanUserExtensionAtLocation(F){try{const M=await this.extensionsScannerService.scanExistingExtension(F,1,{includeInvalid:!0});if(M)return await this.toLocalExtension(M)}catch(M){this.logService.error(M)}return null}async extractUserExtension(F,M,d,I,T){const U=F.toString(),G=g.URI.file(y.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,l.generateUuid)()}`)),B=g.URI.file(y.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U));let te=await this.fileService.exists(B);if(te&&I){try{await this.deleteExtensionFromLocation(F.id,B,"removeExisting")}catch{throw new t.ExtensionManagementError(p.localize(4,null,B.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.extensionsScannerService.updateMetadata(B,d);else try{try{this.logService.trace(`Started extracting the extension from ${M} to ${B.fsPath}`),await(0,w.extract)(M,G.fsPath,{sourcePath:"extension",overwrite:!0},T),this.logService.info(`Extracted extension to ${B}:`,F.id)}catch(ae){let ue=t.ExtensionManagementErrorCode.Extract;throw ae instanceof w.ExtractError&&(ae.type==="CorruptZip"?ue=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(ue=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(ae.message,ue)}await this.extensionsScannerService.updateMetadata(G,d);try{this.logService.trace(`Started renaming the extension from ${G.fsPath} to ${B.fsPath}`),await this.rename(G.fsPath,B.fsPath),this.logService.info("Renamed to",B.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.logService.info(`Rename failed because of ${(0,x.getErrorMessage)(ae)}. Deleted from extracted location`,G),ae}this._onExtract.fire(B)}catch(ae){try{await this.fileService.del(G,{recursive:!0})}catch{}throw ae}return this.scanLocalExtension(B,1)}async scanMetadata(F,M){return M?(await this.getScannedExtension(F,M))?.metadata:this.extensionsScannerService.scanMetadata(F.location)}async getScannedExtension(F,M){return(await this.extensionsProfileScannerService.scanProfileExtensions(M)).find(I=>(0,i.areSameExtensions)(I.identifier,F.identifier))}async updateMetadata(F,M,d){return d?await this.extensionsProfileScannerService.updateMetadata([[F,M]],d):await this.extensionsScannerService.updateMetadata(F.location,M),this.scanLocalExtension(F.location,F.type,d)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...F){const M=F.map(d=>i.ExtensionKey.create(d));await this.withUninstalledExtensions(d=>M.forEach(I=>{d[I.toString()]=!0,this.logService.info("Marked extension as uninstalled",I.toString())}))}async setInstalled(F){await this.withUninstalledExtensions(M=>delete M[F.toString()])}async removeExtension(F,M){if(this.uriIdentityService.extUri.isEqualOrParent(F.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(F.identifier.id,F.location,M)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(M=>delete M[i.ExtensionKey.create(F).toString()])}async copyExtension(F,M,d,I){const T=await this.getScannedExtension(F,M),U=await this.getScannedExtension(F,d);if(I={...T?.metadata,...I},U)if(this.uriIdentityService.extUri.isEqual(U.location,F.location))await this.extensionsProfileScannerService.updateMetadata([[F,{...U.metadata,...I}]],d);else{const G=await this.scanLocalExtension(U.location,F.type,d);await this.extensionsProfileScannerService.removeExtensionFromProfile(G,d),await this.extensionsProfileScannerService.addExtensionsToProfile([[F,{...U.metadata,...I}]],d)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[F,I]],d);return this.scanLocalExtension(F.location,F.type,d)}async copyExtensions(F,M,d){const I=await this.scanExtensions(1,F,d),T=await Promise.all(I.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,F)]));await this.extensionsProfileScannerService.addExtensionsToProfile(T,M)}async deleteExtensionFromLocation(F,M,d){this.logService.trace(`Deleting ${d} extension from disk`,F,M.fsPath);const I=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(M),`${this.uriIdentityService.extUri.basename(M)}.${(0,c.hash)((0,l.generateUuid)()).toString(16)}${j}`);await this.rename(M.fsPath,I.fsPath),await this.fileService.del(I,{recursive:!0}),this.logService.info(`Deleted ${d} extension from disk`,F,M.fsPath)}async withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let M;try{M=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(I){if((0,V.toFileOperationResult)(I)!==1)throw I}let d={};if(M)try{d=JSON.parse(M)}catch{}return F&&(F(d),Object.keys(d).length?await this.fileService.writeFile(this.uninstalledResource,k.VSBuffer.fromString(JSON.stringify(d))):await this.fileService.del(this.uninstalledResource)),d})}async rename(F,M){try{await u.Promises.rename(F,M,2*60*1e3)}catch(d){throw new t.ExtensionManagementError(d.message||p.localize(5,null,F,M),d.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,M,d){if(d){const T=(await this.extensionsScannerService.scanUserExtensions({profileLocation:d})).find(U=>this.uriIdentityService.extUri.isEqual(U.location,F));if(T)return this.toLocalExtension(T)}else{const I=await this.extensionsScannerService.scanExistingExtension(F,M,{includeInvalid:!0});if(I)return this.toLocalExtension(I)}throw new Error(p.localize(6,null,F.path))}async toLocalExtension(F){const M=await this.fileService.resolve(F.location);let d,I;return M.children&&(d=M.children.find(({name:T})=>/^readme(\.txt|\.md|)$/i.test(T))?.resource,I=M.children.find(({name:T})=>/^changelog(\.txt|\.md|)$/i.test(T))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:d,changelogUrl:I,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(F));const M=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),d=new Set;for(const T of M)F[i.ExtensionKey.create(T).toString()]||d.add(T.identifier.id.toLowerCase());try{const T=(0,i.groupByExtension)(M,U=>U.identifier);await O.Promises.settled(T.map(async U=>{const G=U.sort((B,te)=>m.rcompare(B.manifest.version,te.manifest.version))[0];d.has(G.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(G))}))}catch(T){this.logService.error(T)}const I=M.filter(T=>T.metadata&&F[i.ExtensionKey.create(T).toString()]);await Promise.allSettled(I.map(T=>this.removeUninstalledExtension(T)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(M){(0,V.toFileOperationResult)(M)!==1&&this.logService.error(M);return}if(F?.children)try{await Promise.allSettled(F.children.map(async M=>{if(!(!M.isDirectory||!M.name.endsWith(j))){this.logService.trace("Deleting the temporarily deleted folder",M.resource.toString());try{await this.fileService.del(M.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",M.resource.toString())}catch(d){(0,V.toFileOperationResult)(d)!==1&&this.logService.error(d)}}}))}catch{}}};e.ExtensionsScanner=z,e.ExtensionsScanner=z=ve([oe(1,V.IFileService),oe(2,o.IExtensionsScannerService),oe(3,r.IExtensionsProfileScannerService),oe(4,ce.IUriIdentityService),oe(5,se.ILogService)],z);class W extends s.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,C.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(F,M,d,I,T,U,G,B,te,ae){super(),this.manifest=F,this.identifier=M,this.source=d,this.options=I,this.extensionsScanner=T,this.uriIdentityService=U,this.userDataProfilesService=G,this.extensionsScannerService=B,this.extensionsProfileScannerService=te,this.logService=ae,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(F){const[M,d]=await this.install(F);return this._profileLocation=M.isBuiltin||M.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[M,d]],this._profileLocation,!M.isValid),M}async extractExtension({zipPath:F,key:M,metadata:d},I,T){let U=await this.unsetIfUninstalled(M);return U?U=await this.extensionsScanner.updateMetadata(U,d):(this.logService.trace("Extracting extension...",M.id),U=await this.extensionsScanner.extractUserExtension(M,F,d,I,T),this.logService.info("Extracting extension completed.",M.id)),U}async unsetIfUninstalled(F){return await this.isUninstalled(F)?(this.logService.trace("Removing the extension from uninstalled list:",F.id),await this.extensionsScanner.setInstalled(F),this.logService.info("Removed the extension from uninstalled list:",F.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(I=>i.ExtensionKey.create(I).equals(F))):void 0}async isUninstalled(F){return!!(await this.extensionsScanner.getUninstalledExtensions())[F.toString()]}}class q extends W{constructor(F,M,d,I,T,U,G,B,te,ae,ue){super(F,M.identifier,M,d,T,U,G,B,te,ae),this.gallery=M,this.extensionsDownloader=I,this.telemetryService=ue}async install(F){let M;try{M=await this.extensionsScanner.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(T){throw new t.ExtensionManagementError(T,t.ExtensionManagementErrorCode.Scanning)}const d=M.find(T=>(0,i.areSameExtensions)(T.identifier,this.gallery.identifier));d&&(this._operation=3);const I={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||d?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||d?.isMachineScoped,isBuiltin:this.options.isBuiltin||d?.isBuiltin,isSystem:d?.type===0?!0:void 0,updated:!!d,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,hasPreReleaseVersion:d?.hasPreReleaseVersion||this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??d?.pinned,preRelease:(0,C.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.gallery.properties.isPreReleaseVersion||d?.preRelease,source:"gallery"};if(d&&d.type!==0&&d.manifest.version===this.gallery.version)try{return[await this.extensionsScanner.updateMetadata(d,I),I]}catch(T){throw new t.ExtensionManagementError((0,x.getErrorMessage)(T),t.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.downloadAndInstallExtension(I,F)}catch(T){if(T instanceof t.ExtensionManagementError&&(T.code===t.ExtensionManagementErrorCode.CorruptZip||T.code===t.ExtensionManagementErrorCode.IncompleteZip)){this.logService.info("Downloaded VSIX is invalid. Trying to download and install again...",this.gallery.identifier.id);try{const U=await this.downloadAndInstallExtension(I,F);return this.telemetryService.publicLog2("extensiongallery:install:retry",{extensionId:this.gallery.identifier.id,succeeded:!0}),U}catch(U){throw this.telemetryService.publicLog2("extensiongallery:install:retry",{extensionId:this.gallery.identifier.id,succeeded:!1}),U}}else throw T}}async downloadAndInstallExtension(F,M){const{location:d,verificationStatus:I}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=I,this.validateManifest(d.fsPath),[await this.extractExtension({zipPath:d.fsPath,key:i.ExtensionKey.create(this.gallery),metadata:F},!1,M),F]}catch(T){try{await this.extensionsDownloader.delete(d)}catch(U){this.logService.warn("Error while deleting the downloaded file",d.toString(),(0,x.getErrorMessage)(U))}throw T}}async validateManifest(F){try{await(0,R.getManifest)(F)}catch(M){throw new t.ExtensionManagementError(M.message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=q;class X extends W{constructor(F,M,d,I,T,U,G,B,te,ae){super(F,{id:(0,i.getGalleryExtensionId)(F.publisher,F.name)},M,d,T,U,G,B,te,ae),this.location=M,this.galleryService=I}async doRun(F){const M=await super.doRun(F);return this.updateMetadata(M,F),M}async install(F){const M=new i.ExtensionKey(this.identifier,this.manifest.version),I=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,i.areSameExtensions)(this.identifier,G.identifier)),T={isApplicationScoped:this.options.isApplicationScoped||I?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||I?.isMachineScoped,isBuiltin:this.options.isBuiltin||I?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??I?.pinned,source:"vsix"};if(I)if(this._operation=3,M.equals(new i.ExtensionKey(I.identifier,I.manifest.version)))try{await this.extensionsScanner.removeExtension(I,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&m.gt(I.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(I);else{const G=await this.unsetIfUninstalled(M);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(p.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:y.resolve(this.location.fsPath),key:M,metadata:T},!0,F),T]}async updateMetadata(F,M){try{let[d]=await this.galleryService.getExtensions([{id:F.identifier.id,version:F.manifest.version}],M);if(d||([d]=await this.galleryService.getExtensions([{id:F.identifier.id}],M)),d){const I={id:d.identifier.uuid,publisherDisplayName:d.publisherDisplayName,publisherId:d.publisherId,isPreReleaseVersion:d.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||d.properties.isPreReleaseVersion,preRelease:d.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(F,I,this.options.profileLocation)}}catch{}}}class J extends s.AbstractExtensionTask{constructor(F,M,d){super(),this.extension=F,this.profileLocation=M,this.extensionsProfileScannerService=d}async doRun(F){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ne[163],re([0,1,6,24,23,22,42,13,18,11]),function(K,e,O,k,D,A,x,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let h=class extends x.AbstractExtensionsProfileScannerService{constructor(y,S,m,C,g,l){super(a.URI.file(y.extensionsPath),S,m,C,g,l)}};e.ExtensionsProfileScannerService=h,e.ExtensionsProfileScannerService=h=ve([oe(0,c.INativeEnvironmentService),oe(1,P.IFileService),oe(2,k.IUserDataProfilesService),oe(3,D.IUriIdentityService),oe(4,A.ITelemetryService),oe(5,O.ILogService)],h)}),define(ne[164],re([0,1,11,18,42,53,13,10,6,32,23,24]),function(K,e,O,k,D,A,x,P,c,a,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends A.NativeExtensionsScannerService{constructor(m,C,g,l,u,w,p,v){super(O.URI.file(u.builtinExtensionsPath),O.URI.file(u.extensionsPath),u.userHome,m.defaultProfile,m,C,g,l,u,w,p,v)}};e.ExtensionsScannerService=y,e.ExtensionsScannerService=y=ve([oe(0,E.IUserDataProfilesService),oe(1,D.IExtensionsProfileScannerService),oe(2,x.IFileService),oe(3,c.ILogService),oe(4,k.INativeEnvironmentService),oe(5,a.IProductService),oe(6,h.IUriIdentityService),oe(7,P.IInstantiationService)],y)}),define(ne[165],re([0,1,8,5,2,130,3,90,10,24]),function(K,e,O,k,D,A,x,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=S,e.isProfileUsingDefaultStorage=C,e.logStorage=l,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,c.createDecorator)("storageService");var h;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(h||(e.WillSaveStateReason=h={}));var E;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var y;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function S(u){const w=u.get(e.TARGET_KEY);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}class m extends D.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(w={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super(),this.options=w,this._onDidChangeValue=this._register(new k.PauseableEmitter),this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(w,p,v){return k.Event.filter(this._onDidChangeValue.event,n=>n.scope===w&&(p===void 0||n.key===p),v)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,p){const{key:v,external:n}=p;if(v===e.TARGET_KEY){switch(w){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:w})}else this._onDidChangeValue.fire({scope:w,key:v,target:this.getKeyTargets(w)[v],external:n})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,p,v){return this.getStorage(p)?.get(w,v)}getBoolean(w,p,v){return this.getStorage(p)?.getBoolean(w,v)}getNumber(w,p,v){return this.getStorage(p)?.getNumber(w,v)}getObject(w,p,v){return this.getStorage(p)?.getObject(w,v)}storeAll(w,p){this.withPausedEmitters(()=>{for(const v of w)this.store(v.key,v.value,v.scope,v.target,p)})}store(w,p,v,n,s=!1){if((0,x.isUndefinedOrNull)(p)){this.remove(w,v,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(w,v,n),this.getStorage(v)?.set(w,p,s)})}remove(w,p,v=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(w,p,void 0),this.getStorage(p)?.delete(w,v)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,p){const v=[],n=this.getKeyTargets(w);for(const s of Object.keys(n))n[s]===p&&v.push(s);return v}updateKeyTarget(w,p,v,n=!1){const s=this.getKeyTargets(p);typeof v=="number"?s[w]!==v&&(s[w]=v,this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(s),n)):typeof s[w]=="number"&&(delete s[w],this.getStorage(p)?.set(e.TARGET_KEY,JSON.stringify(s),n))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(w){switch(w){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(w){const p=this.getStorage(w);return p?S(p):Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=h.NONE){this._onWillSaveState.fire({reason:w});const p=this.getStorage(-1),v=this.getStorage(0),n=this.getStorage(1);switch(w){case h.NONE:await O.Promises.settled([p?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case h.SHUTDOWN:await O.Promises.settled([p?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return l(w,p,v,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(w){return await this.flush(),this.getStorage(w)?.optimize()}async switch(w,p){return this.emitWillSaveState(h.NONE),(0,a.isUserDataProfile)(w)?this.switchToProfile(w,p):this.switchToWorkspace(w,p)}canSwitchProfile(w,p){return!(w.id===p.id||C(p)&&C(w))}switchData(w,p,v){this.withPausedEmitters(()=>{const n=new Set;for(const[s,t]of w)n.add(s),p.get(s)!==t&&this.emitDidChangeValue(v,{key:s,external:!0});for(const[s]of p.items)n.has(s)||this.emitDidChangeValue(v,{key:s,external:!0})})}}e.AbstractStorageService=m;function C(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class g extends m{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.profileStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w))),this._register(this.applicationStorage.onDidChangeStorage(w=>this.emitDidChangeValue(-1,w)))}getStorage(w){switch(w){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(w){return!1}}e.InMemoryStorageService=g;async function l(u,w,p,v,n,s){const t=_=>{try{return JSON.parse(_)}catch{return _}},i=new Map,r=new Map;u.forEach((_,V)=>{i.set(V,_),r.set(V,t(_))});const o=new Map,f=new Map;w.forEach((_,V)=>{o.set(V,_),f.set(V,t(_))});const b=new Map,R=new Map;p.forEach((_,V)=>{b.set(V,_),R.set(V,t(_))}),console.group(v!==n?`Storage: Application (path: ${v})`:`Storage: Application & Profile (path: ${v}, default profile)`);const L=[];if(i.forEach((_,V)=>{L.push({key:V,value:_})}),console.table(L),console.groupEnd(),console.log(r),v!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const _=[];o.forEach((V,H)=>{_.push({key:H,value:V})}),console.table(_),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${s})`);const N=[];b.forEach((_,V)=>{N.push({key:V,value:_})}),console.table(N),console.groupEnd(),console.log(R)}}),define(ne[166],re([0,1,19,20,9,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,22,178]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l,u,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=X;const n=A.isWeb?"web":(0,E.getTargetPlatform)(A.platform,x.arch),s="X-Market-Search-Activity-Id";var t;(function(I){I[I.None=0]="None",I[I.IncludeVersions=1]="IncludeVersions",I[I.IncludeFiles=2]="IncludeFiles",I[I.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",I[I.IncludeSharedAccounts=8]="IncludeSharedAccounts",I[I.IncludeVersionProperties=16]="IncludeVersionProperties",I[I.ExcludeNonValidated=32]="ExcludeNonValidated",I[I.IncludeInstallationTargets=64]="IncludeInstallationTargets",I[I.IncludeAssetUri=128]="IncludeAssetUri",I[I.IncludeStatistics=256]="IncludeStatistics",I[I.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",I[I.Unpublished=4096]="Unpublished",I[I.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...I){return String(I.reduce((T,U)=>T|U,0))}var r;(function(I){I[I.Tag=1]="Tag",I[I.ExtensionId=4]="ExtensionId",I[I.Category=5]="Category",I[I.ExtensionName=7]="ExtensionName",I[I.Target=8]="Target",I[I.Featured=9]="Featured",I[I.SearchText=10]="SearchText",I[I.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class L{constructor(T=R){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(T,U=this.state.pageSize){return new L({...this.state,pageNumber:T,pageSize:U})}withFilter(T,...U){const G=[...this.state.criteria,...U.length?U.map(B=>({filterType:T,value:B})):[{filterType:T}]];return new L({...this.state,criteria:G})}withSortBy(T){return new L({...this.state,sortBy:T})}withSortOrder(T){return new L({...this.state,sortOrder:T})}withFlags(...T){return new L({...this.state,flags:T.reduce((U,G)=>U|G,0)})}withAssetTypes(...T){return new L({...this.state,assetTypes:T})}withSource(T){return new L({...this.state,source:T})}get raw(){const{criteria:T,pageNumber:U,pageSize:G,sortBy:B,sortOrder:te,flags:ae,assetTypes:ue}=this.state;return{filters:[{criteria:T,pageNumber:U,pageSize:G,sortBy:B,sortOrder:te}],assetTypes:ue,flags:ae}}get searchText(){const T=this.state.criteria.filter(U=>U.filterType===r.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function N(I,T){const U=(I||[]).filter(G=>G.statisticName===T)[0];return U?U.value:0}function _(I){const T="Microsoft.VisualStudio.Code.Translation.";return I.files.filter(G=>G.assetType.indexOf(T)===0).reduce((G,B)=>{const te=se(I,B.assetType);return te&&G.push([B.assetType.substring(T.length),te]),G},[])}function V(I){if(I.properties){const T=I.properties.filter(B=>B.key===o.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=T.filter(B=>U.test(B.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return se(I,o.Repository)}function H(I){return{uri:`${I.fallbackAssetUri}/${o.VSIX}?redirect=true${I.targetPlatform?`&targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${o.VSIX}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}}function se(I,T){return I.files.filter(G=>G.assetType===T)[0]?{uri:`${I.assetUri}/${T}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${T}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}:null}function ie(I,T){const U=I.properties?I.properties.filter(B=>B.key===T):[],G=U.length>0&&U[0].value;return G?G.split(",").map(B=>(0,y.adoptToGalleryExtensionId)(B)):[]}function fe(I){const T=I.properties?I.properties.filter(U=>U.key===f.Engine):[];return T.length>0&&T[0].value||""}function ce(I){const T=I.properties?I.properties.filter(U=>U.key===f.PreRelease):[];return T.length>0&&T[0].value==="true"}function le(I){const T=I.properties?I.properties.filter(G=>G.key===f.LocalizedLanguages):[],U=T.length>0&&T[0].value||"";return U?U.split(","):[]}function j(I){return I.properties?.find(T=>T.key===f.SponsorLink)?.value}function Y(I){return I.properties?.find(T=>T.key===f.SupportLink)?.value}function z(I){return I.indexOf("preview")!==-1}function W(I){return I.targetPlatform?(0,E.toTargetPlatform)(I.targetPlatform):"undefined"}function q(I){const T=(0,O.distinct)(I.versions.map(W)),U=!!I.tags?.includes(E.WEB_EXTENSION_TAG),G=T.indexOf("web");return U?G===-1&&T.push("web"):G!==-1&&T.splice(G,1),T}function X(I,T){for(let U=0;U<I.length;U++){const G=I[U];if(G.version===I[U-1]?.version){let B=U;if(W(G)===T)for(;B>0&&I[B-1].version===G.version;)B--;B!==U&&(I.splice(U,1),I.splice(B,0,G))}}return I}function J(I,T,U){I.telemetryData={index:T,querySource:U,queryActivityId:I.queryContext?.[s]}}function Z(I,T,U,G){const B=I.versions[0],te={manifest:se(T,o.Manifest),readme:se(T,o.Details),changelog:se(T,o.Changelog),license:se(T,o.License),repository:V(T),download:H(T),icon:se(T,o.Icon),signature:se(T,o.Signature),coreTranslations:_(T)};return{identifier:{id:(0,y.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},name:I.extensionName,version:T.version,displayName:I.displayName,publisherId:I.publisher.publisherId,publisher:I.publisher.publisherName,publisherDisplayName:I.publisher.displayName,publisherDomain:I.publisher.domain?{link:I.publisher.domain,verified:!!I.publisher.isDomainVerified}:void 0,publisherSponsorLink:j(B),description:I.shortDescription??"",installCount:N(I.statistics,"install"),rating:N(I.statistics,"averagerating"),ratingCount:N(I.statistics,"ratingcount"),categories:I.categories||[],tags:I.tags||[],releaseDate:Date.parse(I.releaseDate),lastUpdated:Date.parse(I.lastUpdated),allTargetPlatforms:U,assets:te,properties:{dependencies:ie(T,f.Dependency),extensionPack:ie(T,f.ExtensionPack),engine:fe(T),localizedLanguages:le(T),targetPlatform:W(T),isPreReleaseVersion:ce(T)},hasPreReleaseVersion:ce(B),hasReleaseVersion:!0,preview:z(I.flags),isSigned:!!te.signature,queryContext:G,supportLink:Y(B)}}let F=class{constructor(T,U,G,B,te,ae,ue,me){this.requestService=U,this.logService=G,this.environmentService=B,this.telemetryService=te,this.fileService=ae,this.productService=ue,this.configurationService=me;const ye=ue.extensionsGallery,he=ye?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=he?ye.servicePPEUrl:ye?.serviceUrl,this.extensionsGallerySearchUrl=he?void 0:ye?.searchUrl,this.extensionsControlUrl=ye?.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(ue.version,ue,this.environmentService,this.configurationService,this.fileService,T,this.telemetryService)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,U,G){const B=k.CancellationToken.isCancellationToken(U)?{}:U,te=k.CancellationToken.isCancellationToken(U)?U:G,ae=[],ue=[],me=[],ye=[];let he=!0;for(const Se of T){Se.uuid?ue.push(Se.uuid):ae.push(Se.id);const Pe=!!(Se.version||Se.preRelease);me.push({id:Se.id,uuid:Se.uuid,includePreRelease:Pe}),Se.version&&ye.push({id:Se.id,uuid:Se.uuid,version:Se.version}),he=he&&!!Se.hasPreRelease&&!Pe}if(!ue.length&&!ae.length)return[];let pe=new L().withPage(1,T.length);ue.length&&(pe=pe.withFilter(r.ExtensionId,...ue)),ae.length&&(pe=pe.withFilter(r.ExtensionName,...ae)),(B.queryAllVersions||he)&&(pe=pe.withFlags(pe.flags,t.IncludeVersions)),B.source&&(pe=pe.withSource(B.source));const{extensions:de}=await this.queryGalleryExtensions(pe,{targetPlatform:B.targetPlatform??n,includePreRelease:me,versions:ye,compatible:!!B.compatible,productVersion:B.productVersion??{version:this.productService.version,date:this.productService.date}},te);return B.source&&de.forEach((Se,Pe)=>J(Se,Pe,B.source)),de}async getCompatibleExtension(T,U,G,B={version:this.productService.version,date:this.productService.date}){if((0,E.isNotWebExtensionInWebTargetPlatform)(T.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(T,U,G))return T;const te=new L().withFlags(t.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,T.identifier.uuid),{extensions:ae}=await this.queryGalleryExtensions(te,{targetPlatform:G,compatible:!0,includePreRelease:U,productVersion:B},k.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(T,U,G,B={version:this.productService.version,date:this.productService.date}){if(!(0,E.isTargetPlatformCompatible)(T.properties.targetPlatform,T.allTargetPlatforms,G)||!U&&T.properties.isPreReleaseVersion)return!1;let te=T.properties.engine;if(!te){const ae=await this.getManifest(T,k.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");te=ae.engines.vscode}return(0,S.isEngineValid)(te,B.version,B.date)}async isValidVersion(T,U,G,B,te,ae,ue={version:this.productService.version,date:this.productService.date}){if(!(0,E.isTargetPlatformCompatible)(W(U),te,ae)||G!=="any"&&ce(U)!==(G==="prerelease"))return!1;if(B)try{const me=await this.getEngine(T,U);if(!(0,S.isEngineValid)(me,ue.version,ue.date))return!1}catch(me){return this.logService.error(`Error while getting the engine for the version ${U.version}.`,(0,D.getErrorMessage)(me)),!1}return!0}async query(T,U){let G=T.text||"";const B=T.pageSize??50;let te=new L().withPage(1,B);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,de)=>(te=te.withFilter(r.Category,de||pe),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,de)=>(te=te.withFilter(r.Tag,de||pe),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(r.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),te=te.withFilter(r.SearchText,G)),te=te.withSortBy(0)):T.ids?te=te.withFilter(r.ExtensionId,...T.ids):T.names?te=te.withFilter(r.ExtensionName,...T.names):te=te.withSortBy(4),typeof T.sortBy=="number"&&(te=te.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(te=te.withSortOrder(T.sortOrder)),T.source&&(te=te.withSource(T.source));const ae=async(he,pe)=>{const{extensions:de,total:Se}=await this.queryGalleryExtensions(he,{targetPlatform:n,compatible:!1,includePreRelease:!!T.includePreRelease,productVersion:T.productVersion??{version:this.productService.version,date:this.productService.date}},pe);return de.forEach((Pe,De)=>J(Pe,(he.pageNumber-1)*he.pageSize+De,T.source)),{extensions:de,total:Se}},{extensions:ue,total:me}=await ae(te,U),ye=async(he,pe)=>{if(pe.isCancellationRequested)throw new D.CancellationError;const{extensions:de}=await ae(te.withPage(he+1),pe);return de};return{firstPage:ue,total:me,pageSize:te.pageSize,getPage:ye}}async queryGalleryExtensions(T,U,G){const B=T.flags;T.flags&t.IncludeLatestVersionOnly&&T.flags&t.IncludeVersions&&(T=T.withFlags(T.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(T.flags&t.IncludeLatestVersionOnly)&&!(T.flags&t.IncludeVersions)&&(T=T.withFlags(T.flags,t.IncludeLatestVersionOnly)),U.versions?.length&&(T=T.withFlags(T.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),T=T.withFlags(T.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ae,context:ue}=await this.queryRawGalleryExtensions(T,G);if(!(T.flags&t.IncludeLatestVersionOnly)){const pe=[];for(const de of te){const Se=await this.toGalleryExtensionWithCriteria(de,U,ue);Se&&pe.push(Se)}return{extensions:pe,total:ae}}const ye=[],he=new Map;for(let pe=0;pe<te.length;pe++){const de=te[pe],Se={id:(0,y.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Pe=(0,P.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find($=>(0,y.areSameExtensions)($,Se))?.includePreRelease;if(U.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(q(de),U.targetPlatform))continue;const De=await this.toGalleryExtensionWithCriteria(de,U,ue);!De||De.properties.isPreReleaseVersion&&(!Pe||!De.hasReleaseVersion)||!De.properties.isPreReleaseVersion&&De.properties.targetPlatform!==U.targetPlatform&&De.hasPreReleaseVersion?he.set(de.extensionId,pe):ye.push([pe,De])}if(he.size){const pe=new v.StopWatch,de=new L().withFlags(B&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,he.size).withFilter(r.ExtensionId,...he.keys()),{extensions:Se}=await this.queryGalleryExtensions(de,U,G);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:he.size});for(const Pe of Se){const De=he.get(Pe.identifier.uuid);ye.push([De,Pe])}}return{extensions:ye.sort((pe,de)=>pe[0]-de[0]).map(([,pe])=>pe),total:ae}}async toGalleryExtensionWithCriteria(T,U,G){const B={id:(0,y.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},te=U.versions?.find(ye=>(0,y.areSameExtensions)(ye,B))?.version,ae=(0,P.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ye=>(0,y.areSameExtensions)(ye,B))?.includePreRelease,ue=q(T),me=X(T.versions,U.targetPlatform);if(U.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(ue,U.targetPlatform))return null;for(let ye=0;ye<me.length;ye++){const he=me[ye];if(!(te&&he.version!==te)){if(await this.isValidVersion((0,y.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),he,ae?"any":"release",U.compatible,ue,U.targetPlatform,U.productVersion))return Z(T,he,ue,G);if(te&&he.version===te)return null}}return te||U.compatible?null:Z(T,T.versions[0],ue)}async queryRawGalleryExtensions(T,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,t.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,i(t.Unpublished));const G=await this.commonHeadersPromise,B=JSON.stringify(T.raw),te={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},ae=new v.StopWatch;let ue,me,ye=0;try{if(ue=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&T.criteria.some(pe=>pe.filterType===r.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:B,headers:te},U),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ye};const he=await(0,l.asJson)(ue);if(he){const pe=he.results[0],de=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ye=Se&&Se.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[s]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(he){const pe=(0,D.isCancellationError)(he)?E.ExtensionGalleryErrorCode.Cancelled:(0,D.getErrorMessage)(he).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw me=new E.ExtensionGalleryError((0,D.getErrorMessage)(he),pe),me}finally{this.telemetryService.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(B.length),duration:ae.elapsed(),success:!!ue&&(0,l.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:me?.code,count:String(ye)})}}async reportStatistic(T,U,G,B){if(!this.isEnabled())return;const te=A.isWeb?this.api(`/itemName/${T}.${U}/version/${G}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${T}/extensions/${U}/${G}/stats?statType=${B}`),ae=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:te,headers:me},k.CancellationToken.None)}catch{}}async download(T,U,G){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const B=(0,y.getGalleryExtensionTelemetryData)(T),te=new Date().getTime(),ae=pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...B,duration:pe}),ue=G===2?"install":G===3?"update":"",me=ue?{uri:`${T.assets.download.uri}${c.URI.parse(T.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${T.assets.download.fallbackUri}${c.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:T.assets.download,ye=T.queryContext?.[s]?{[s]:T.queryContext[s]}:void 0,he=await this.getAsset(T.identifier.id,me,o.VSIX,ye?{headers:ye}:void 0);await this.fileService.writeFile(U,he.stream),ae(new Date().getTime()-te)}async downloadSignatureArchive(T,U){if(!T.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",T.identifier.id);const G=await this.getAsset(T.identifier.id,T.assets.signature,o.Signature);await this.fileService.writeFile(U,G.stream)}async getReadme(T,U){if(T.assets.readme){const G=await this.getAsset(T.identifier.id,T.assets.readme,o.Details,{},U);return await(0,l.asTextOrError)(G)||""}return""}async getManifest(T,U){if(T.assets.manifest){const G=await this.getAsset(T.identifier.id,T.assets.manifest,o.Manifest,{},U),B=await(0,l.asTextOrError)(G);return B?JSON.parse(B):null}return null}async getManifestFromRawExtensionVersion(T,U,G){const B=se(U,o.Manifest);if(!B)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},ae=await this.getAsset(T,B,o.Manifest,{headers:te});return await(0,l.asJson)(ae)}async getCoreTranslation(T,U){const G=T.assets.coreTranslations.filter(B=>B[0]===U.toUpperCase())[0];if(G){const B=await this.getAsset(T.identifier.id,G[1],G[0]),te=await(0,l.asTextOrError)(B);return te?JSON.parse(te):null}return null}async getChangelog(T,U){if(T.assets.changelog){const G=await this.getAsset(T.identifier.id,T.assets.changelog,o.Changelog,{},U);return await(0,l.asTextOrError)(G)||""}return""}async getAllCompatibleVersions(T,U,G){let B=new L().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?B=B.withFilter(r.ExtensionId,T.identifier.uuid):B=B.withFilter(r.ExtensionName,T.identifier.id);const{galleryExtensions:te}=await this.queryRawGalleryExtensions(B,k.CancellationToken.None);if(!te.length)return[];const ae=q(te[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(ae,G))return[];const ue=[];await Promise.all(te[0].versions.map(async he=>{try{await this.isValidVersion(T.identifier.id,he,U?"any":"release",!0,ae,G)&&ue.push(he)}catch{}}));const me=[],ye=new Set;for(const he of X(ue,G))ye.has(he.version)||(ye.add(he.version),me.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:ce(he)}));return me}async getAsset(T,U,G,B={},te=k.CancellationToken.None){const ae=await this.commonHeadersPromise,ue={type:"GET"},me={...ae,...B.headers||{}};B={...B,...ue,headers:me};const ye=U.uri,he=U.fallbackUri,pe={...B,url:ye};try{const de=await this.requestService.request(pe,te);if(de.res.statusCode===200)return de;const Se=await(0,l.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Se}`)}catch(de){if((0,D.isCancellationError)(de))throw de;const Se=(0,D.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:T,assetType:G,message:Se});const Pe={...B,url:he};return this.requestService.request(Pe,te)}}async getEngine(T,U){let G=fe(U);if(!G){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:T,version:U.version});const B=await this.getManifestFromRawExtensionVersion(T,U,k.CancellationToken.None);if(!B)throw new Error("Manifest was not found");G=B.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},k.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.asJson)(T),G=[],B={},te=[];if(U){for(const ae of U.malicious)G.push({id:ae});if(U.migrateToPreRelease)for(const[ae,ue]of Object.entries(U.migrateToPreRelease))(!ue.engine||(0,S.isEngineValid)(ue.engine,this.productService.version,this.productService.date))&&(B[ae.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[ae,ue]of Object.entries(U.deprecated))ue&&(B[ae.toLowerCase()]=(0,P.isBoolean)(ue)?{}:ue);if(U.search)for(const ae of U.search)te.push(ae)}return{malicious:G,deprecated:B,search:te}}};F=ve([oe(1,l.IRequestService),oe(2,C.ILogService),oe(3,h.IEnvironmentService),oe(4,p.ITelemetryService),oe(5,m.IFileService),oe(6,g.IProductService),oe(7,a.IConfigurationService)],F);let M=class extends F{constructor(T,U,G,B,te,ae,ue,me){super(T,U,G,B,te,ae,ue,me)}};e.ExtensionGalleryService=M,e.ExtensionGalleryService=M=ve([oe(0,w.IStorageService),oe(1,l.IRequestService),oe(2,C.ILogService),oe(3,h.IEnvironmentService),oe(4,p.ITelemetryService),oe(5,m.IFileService),oe(6,g.IProductService),oe(7,a.IConfigurationService)],M);let d=class extends F{constructor(T,U,G,B,te,ae,ue){super(void 0,T,U,G,B,te,ae,ue)}};e.ExtensionGalleryServiceWithNoStorageService=d,e.ExtensionGalleryServiceWithNoStorageService=d=ve([oe(0,l.IRequestService),oe(1,C.ILogService),oe(2,h.IEnvironmentService),oe(3,p.ITelemetryService),oe(4,m.IFileService),oe(5,g.IProductService),oe(6,a.IConfigurationService)],d)}),define(ne[167],re([0,1,11,18,13,6,145,23,24,3,69]),function(K,e,O,k,D,A,x,P,c,a,h){"use strict";var E,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let S=class extends c.UserDataProfilesService{static{E=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(l,u,w,p,v){super(w,p,u,v),this.stateReadonlyService=l,this.nativeEnvironmentService=w}getStoredProfiles(){return this.stateReadonlyService.getItem(E.PROFILES_KEY,[]).map(u=>({...u,location:(0,a.isString)(u.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,u.location):O.URI.revive(u.location)}))}getStoredProfileAssociations(){const l=this.stateReadonlyService.getItem(E.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(E.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?l:this.migrateStoredProfileAssociations(l)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(O.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=S,e.UserDataProfilesReadonlyService=S=E=ve([oe(0,x.IStateReadService),oe(1,P.IUriIdentityService),oe(2,k.INativeEnvironmentService),oe(3,D.IFileService),oe(4,A.ILogService)],S);let m=y=class extends S{constructor(l,u,w,p,v){super(l,u,w,p,v),this.stateService=l}saveStoredProfiles(l){l.length?this.stateService.setItem(y.PROFILES_KEY,l.map(u=>({...u,location:this.uriIdentityService.extUri.basename(u.location)}))):this.stateService.removeItem(y.PROFILES_KEY)}getStoredProfiles(){const l=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(l),this.stateService.setItem("userDataProfilesMigration",!0)),l}saveStoredProfileAssociations(l){l.emptyWindows||l.workspaces?this.stateService.setItem(y.PROFILE_ASSOCIATIONS_KEY,l):this.stateService.removeItem(y.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const l="workspaceAndProfileInfo",u=this.stateService.getItem(l,void 0);if(u){this.stateService.removeItem(l);const p=u.reduce((v,{workspace:n,profile:s})=>(v[O.URI.revive(n).toString()]=O.URI.revive(s).toString(),v),{});this.stateService.setItem(y.PROFILE_ASSOCIATIONS_KEY,{workspaces:p})}const w=super.getStoredProfileAssociations();return this.stateService.getItem(y.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(w),this.stateService.setItem(y.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),w}};e.UserDataProfilesService=m,e.UserDataProfilesService=m=y=ve([oe(0,x.IStateService),oe(1,P.IUriIdentityService),oe(2,k.INativeEnvironmentService),oe(3,D.IFileService),oe(4,A.ILogService)],m);let C=class extends m{constructor(l,u,w,p){super(new h.StateService(0,u,p,w),l,u,w,p)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=C,e.ServerUserDataProfilesService=C=ve([oe(0,P.IUriIdentityService),oe(1,k.INativeEnvironmentService),oe(2,D.IFileService),oe(3,A.ILogService)],C)}),define(ne[168],re([0,1,143,8,14,9,3,29,18,144,6,45,142,179]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=g;let m=class extends E.AbstractRequestService{constructor(u,w,p,v){super(v),this.configurationService=u,this.environmentService=w,this.logService=p,this.configure(),this._register(u.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.configure()}))}configure(){const u=this.configurationService.getValue("http");this.proxyUrl=u?.proxy,this.strictSSL=!!u?.proxyStrictSSL,this.authorization=u?.proxyAuthorization}async request(u,w){const{proxyUrl:p,strictSSL:v}=this;let n;try{n=await(0,a.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,A.getErrorMessage)(i)))}const s={...process.env,...n},t=u.agent?u.agent:await(0,y.getProxyAgent)(u.url||"",s,{proxyUrl:p,strictSSL:v});return u.agent=t,u.strictSSL=v,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(u.isChromiumNetwork?"electron":"node",u,()=>g(u,w))}async resolveProxy(u){}async loadCertificates(){return(await new Promise((w,p)=>{K(["@vscode/proxy-agent"],w,p)})).loadSystemCertificates({log:this.logService})}};e.RequestService=m,e.RequestService=m=ve([oe(0,P.IConfigurationService),oe(1,c.INativeEnvironmentService),oe(2,h.ILogService),oe(3,h.ILoggerService)],m);async function C(l){return((0,O.parse)(l.url).protocol==="https:"?await new Promise((p,v)=>{K(["https"],p,v)}):await new Promise((p,v)=>{K(["http"],p,v)})).request}async function g(l,u){return k.Promises.withAsyncBody(async(w,p)=>{const v=(0,O.parse)(l.url),n=l.getRawRequest?l.getRawRequest(l):await C(l),s={hostname:v.hostname,port:v.port?parseInt(v.port):v.protocol==="https:"?443:80,protocol:v.protocol,path:v.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,x.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(s.auth=l.user+":"+l.password);const t=n(s,i=>{const r=(0,x.isNumber)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)g({...l,url:i.headers.location,followRedirects:r-1},u).then(w,p);else{let o=i;!l.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,S.createGunzip)())),w({res:i,stream:(0,D.streamToBufferReadableStream)(o)})}});t.on("error",p),l.timeout&&t.setTimeout(l.timeout),l.isChromiumNetwork&&t.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&t.write(l.data),t.end(),u.onCancellationRequested(()=>{t.abort(),p(new A.CancellationError)})})}}),define(ne[180],re([0,1,33,8,34,9,2,15,16,12,35,11,25,29,139,61,141,18,116,166,21,71,146,42,53,162,164,13,129,131,51,127,64,65,150,6,135,39,136,153,32,45,168,69,70,22,152,41,154,155,23,157,24,167,156,163,132,134,4,158,181]),function(K,e,O,k,D,A,x,P,c,a,h,E,y,S,m,C,g,l,u,w,p,v,n,s,t,i,r,o,f,b,R,L,N,_,V,H,se,ie,fe,ce,le,j,Y,z,W,q,X,J,Z,F,M,d,I,T,U,G,B,te,ae,ue,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=he;class ye extends x.Disposable{constructor(de){super(),this.argv=de,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[de,Se]=await this.initServices();return de.invokeFunction(async Pe=>{const De=Pe.get(H.ILogService),$=Pe.get(o.IFileService),Q=Pe.get(l.INativeEnvironmentService),ee=Pe.get(I.IUserDataProfilesService);De.info("CLI main",this.argv),this.registerErrorHandler(De),await this.doRun(Q,$,ee,de),await Promise.all(Se.map(ge=>{(0,k.raceTimeout)(ge.flush(),1e3)}))})}async initServices(){const de=new N.ServiceCollection,Se={_serviceBrand:void 0,...ce.default};de.set(le.IProductService,Se);const Pe=new u.NativeEnvironmentService(this.argv,Se);de.set(l.INativeEnvironmentService,Pe),await Promise.all([this.allowWindowsUNCPath(Pe.appSettingsHome.with({scheme:P.Schemas.file}).fsPath),this.allowWindowsUNCPath(Pe.extensionsPath)].map(Ee=>Ee?y.Promises.mkdir(Ee,{recursive:!0}):void 0));const De=new te.LoggerService((0,H.getLogLevel)(Pe),Pe.logsHome);de.set(H.ILoggerService,De);const $=this._register(De.createLogger("cli",{name:(0,ae.localize)(0,null)})),Q=[];De.getLogLevel()===H.LogLevel.Trace&&Q.push(new H.ConsoleLogger(De.getLogLevel()));const ee=this._register(new B.LogService($,Q));de.set(H.ILogService,ee);const ge=this._register(new f.FileService(ee));de.set(o.IFileService,ge);const we=this._register(new b.DiskFileSystemProvider(ee));ge.registerProvider(P.Schemas.file,we);const Oe=new d.UriIdentityService(ge);de.set(M.IUriIdentityService,Oe);const be=new z.StateReadonlyService(1,Pe,ee,ge),Te=new T.UserDataProfilesReadonlyService(be,Oe,Pe,ge,ee);de.set(I.IUserDataProfilesService,Te),ge.registerProvider(P.Schemas.vscodeUserData,new ue.FileUserDataProvider(P.Schemas.file,we,P.Schemas.vscodeUserData,Te,Oe,ee));const Re=a.isWindows&&Se.win32RegValueName?this._register(new fe.NativePolicyService(ee,Se.win32RegValueName)):Pe.policyFile?this._register(new se.FilePolicyService(Pe.policyFile,ge,ee)):new ie.NullPolicyService;de.set(ie.IPolicyService,Re);const xe=this._register(new m.ConfigurationService(Te.defaultProfile.settingsResource,ge,Re,ee));de.set(S.IConfigurationService,xe),await Promise.all([be.init(),xe.initialize()]);let _e;try{_e=await(0,U.resolveMachineId)(be,ee)}catch(Ee){Ee.code!=="ENOENT"&&ee.error(Ee)}const Le=await(0,U.resolveSqmId)(be,ee);Te.init(),de.set(M.IUriIdentityService,new d.UriIdentityService(ge));const Ae=new Y.RequestService(xe,Pe,ee,De);de.set(j.IRequestService,Ae),de.set(C.IDownloadService,new R.SyncDescriptor(g.DownloadService,void 0,!0)),de.set(s.IExtensionsProfileScannerService,new R.SyncDescriptor(G.ExtensionsProfileScannerService,void 0,!0)),de.set(t.IExtensionsScannerService,new R.SyncDescriptor(r.ExtensionsScannerService,void 0,!0)),de.set(v.IExtensionSignatureVerificationService,new R.SyncDescriptor(v.ExtensionSignatureVerificationService,void 0,!0)),de.set(i.INativeServerExtensionManagementService,new R.SyncDescriptor(i.ExtensionManagementService,void 0,!0)),de.set(p.IExtensionGalleryService,new R.SyncDescriptor(w.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),de.set(_.ILanguagePackService,new R.SyncDescriptor(V.NativeLanguagePackService,void 0,!1));const Ne=[],Me=(0,J.isInternalTelemetry)(Se,xe);if((0,J.supportsTelemetry)(Se,Pe)){Se.aiConfig&&Se.aiConfig.ariaKey&&Ne.push(new Z.OneDataSystemAppender(Ae,Me,"monacoworkbench",null,Se.aiConfig.ariaKey));const Ee={appenders:Ne,sendErrorTelemetry:!1,commonProperties:(0,W.resolveCommonProperties)((0,O.release)(),(0,O.hostname)(),process.arch,Se.commit,Se.version,_e,Le,Me),piiPaths:(0,J.getPiiPathsFromEnvironment)(Pe)};de.set(q.ITelemetryService,new R.SyncDescriptor(X.TelemetryService,[Ee],!1))}else de.set(q.ITelemetryService,J.NullTelemetryService);return[new L.InstantiationService(de),Ne]}allowWindowsUNCPath(de){if(a.isWindows){const Se=(0,me.getUNCHost)(de);Se&&(0,me.addUNCHostToAllowlist)(Se)}return de}registerErrorHandler(de){(0,A.setUnexpectedErrorHandler)(Se=>{const Pe=(0,D.toErrorMessage)(Se,!0);Pe&&de.error(`[uncaught exception in CLI]: ${Pe}`)}),process.on("uncaughtException",Se=>{(0,A.isSigPipeError)(Se)||(0,A.onUnexpectedError)(Se)}),process.on("unhandledRejection",Se=>(0,A.onUnexpectedError)(Se))}async doRun(de,Se,Pe,De){let $;if(de.args.profile&&($=Pe.profiles.find(ee=>ee.name===de.args.profile),!$))throw new Error(`Profile '${de.args.profile}' not found.`);const Q=($??Pe.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return De.createInstance(n.ExtensionManagementCLI,new H.ConsoleLogger(H.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,Q);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ee={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:Q};return De.createInstance(n.ExtensionManagementCLI,new H.ConsoleLogger(H.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),ee,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return De.createInstance(n.ExtensionManagementCLI,new H.ConsoleLogger(H.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,Q);if(this.argv["update-extensions"])return De.createInstance(n.ExtensionManagementCLI,new H.ConsoleLogger(H.LogLevel.Info,!1)).updateExtensions(Q);if(this.argv["locate-extension"])return De.createInstance(n.ExtensionManagementCLI,new H.ConsoleLogger(H.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,F.buildTelemetryMessage)(de.appRoot,de.extensionsPath))}}asExtensionIdOrVSIX(de){return de.map(Se=>/\.vsix$/i.test(Se)?E.URI.file((0,c.isAbsolute)(Se)?Se:(0,c.join)((0,h.cwd)(),Se)):Se)}}async function he(pe){const de=new ye(pe);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4379b66f0d4dd9881ba96fa086f387725b69a24b/core/vs/code/node/cliProcessMain.js.map
