/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Pe=function(ue){for(var e=[],I=0,L=ue.length;I<L;I++)e[I]=Ie[ue[I]];return e};define(Ie[69],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=L,e.debounce=T,e.throttle=O;function I(A){return(E,v,_)=>{let N=null,y=null;if(typeof _.value=="function"?(N="value",y=_.value):typeof _.get=="function"&&(N="get",y=_.get),!y)throw new Error("not supported");_[N]=A(y,v)}}function L(A,E,v){let _=null,N=null;if(typeof v.value=="function"?(_="value",N=v.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(_="get",N=v.get),!N)throw new Error("not supported");const y=`$memoize$${E}`;v[_]=function(...h){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,h)}),this[y]}}function T(A,E,v){return I((_,N)=>{const y=`$debounce$${N}`,h=`$debounce$result$${N}`;return function(...b){this[h]||(this[h]=v?v():void 0),clearTimeout(this[y]),E&&(this[h]=E(this[h],...b),b=[this[h]]),this[y]=setTimeout(()=>{_.apply(this,b),this[h]=v?v():void 0},A)}})}function O(A,E,v){return I((_,N)=>{const y=`$throttle$timer$${N}`,h=`$throttle$result$${N}`,b=`$throttle$lastRun$${N}`,m=`$throttle$pending$${N}`;return function(...r){if(this[h]||(this[h]=v?v():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),E&&(this[h]=E(this[h],...r)),this[m])return;const o=this[b]+A;o<=Date.now()?(this[b]=Date.now(),_.apply(this,[this[h]]),this[h]=v?v():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[b]=Date.now(),_.apply(this,[this[h]]),this[h]=v?v():void 0},o-Date.now()))}})}}),define(Ie[125],Pe([1,0,18]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.strictEquals=void 0,e.itemsEquals=T,e.jsonStringifyEquals=O,e.itemEquals=A,e.equalsIfDefined=E,e.structuralEquals=v,e.getStructuralKey=_;const L=(b,m)=>b===m;e.strictEquals=L;function T(b=e.strictEquals){return(m,r)=>I.equals(m,r,b)}function O(){return(b,m)=>JSON.stringify(b)===JSON.stringify(m)}function A(){return(b,m)=>b.equals(m)}function E(b,m,r){return!b||!m?b===m:r(b,m)}function v(b,m){if(b===m)return!0;if(Array.isArray(b)&&Array.isArray(m)){if(b.length!==m.length)return!1;for(let r=0;r<b.length;r++)if(!v(b[r],m[r]))return!1;return!0}if(b&&typeof b=="object"&&m&&typeof m=="object"&&Object.getPrototypeOf(b)===Object.prototype&&Object.getPrototypeOf(m)===Object.prototype){const r=b,o=m,s=Object.keys(r),i=Object.keys(o),n=new Set(i);if(s.length!==i.length)return!1;for(const c of s)if(!n.has(c)||!v(r[c],o[c]))return!1;return!0}return!1}function _(b){return JSON.stringify(h(b))}let N=0;const y=new WeakMap;function h(b){if(Array.isArray(b))return b.map(h);if(b&&typeof b=="object")if(Object.getPrototypeOf(b)===Object.prototype){const m=b,r=Object.create(null);for(const o of Object.keys(m).sort())r[o]=h(m[o]);return r}else{let m=y.get(b);return m===void 0&&(m=N++,y.set(b,m)),m+"----2b76a038c20c4bcc"}return b}}),define(Ie[91],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class I{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=I,e.defaultGenerator=new I("id#")}),define(Ie[126],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=A,e.getLocation=y,e.parse=h,e.parseTree=b,e.findNodeAtLocation=m,e.getNodePath=r,e.getNodeValue=o,e.contains=s,e.findNodeAtOffset=i,e.visit=n,e.stripComments=c,e.getNodeType=u;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T||(e.ParseErrorCode=T={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,f=!1){let a=0;const p=t.length;let l="",D=0,d=16,w=0;function g(V){let R=0,z=0;for(;R<V;){const q=t.charCodeAt(a);if(q>=48&&q<=57)z=z*16+q-48;else if(q>=65&&q<=70)z=z*16+q-65+10;else if(q>=97&&q<=102)z=z*16+q-97+10;else break;a++,R++}return R<V&&(z=-1),z}function C(V){a=V,l="",D=0,d=16,w=0}function S(){const V=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&_(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&_(t.charCodeAt(a)))for(a++;a<t.length&&_(t.charCodeAt(a));)a++;else return w=3,t.substring(V,a);let R=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&_(t.charCodeAt(a))){for(a++;a<t.length&&_(t.charCodeAt(a));)a++;R=a}else w=3;return t.substring(V,R)}function k(){let V="",R=a;for(;;){if(a>=p){V+=t.substring(R,a),w=2;break}const z=t.charCodeAt(a);if(z===34){V+=t.substring(R,a),a++;break}if(z===92){if(V+=t.substring(R,a),a++,a>=p){w=2;break}switch(t.charCodeAt(a++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const ie=g(4);ie>=0?V+=String.fromCharCode(ie):w=4;break}default:w=5}R=a;continue}if(z>=0&&z<=31)if(v(z)){V+=t.substring(R,a),w=2;break}else w=6;a++}return V}function P(){if(l="",w=0,D=a,a>=p)return D=p,d=17;let V=t.charCodeAt(a);if(E(V)){do a++,l+=String.fromCharCode(V),V=t.charCodeAt(a);while(E(V));return d=15}if(v(V))return a++,l+=String.fromCharCode(V),V===13&&t.charCodeAt(a)===10&&(a++,l+=`
`),d=14;switch(V){case 123:return a++,d=1;case 125:return a++,d=2;case 91:return a++,d=3;case 93:return a++,d=4;case 58:return a++,d=6;case 44:return a++,d=5;case 34:return a++,l=k(),d=10;case 47:{const R=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<p&&!v(t.charCodeAt(a));)a++;return l=t.substring(R,a),d=12}if(t.charCodeAt(a+1)===42){a+=2;const z=p-1;let q=!1;for(;a<z;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,q=!0;break}a++}return q||(a++,w=1),l=t.substring(R,a),d=13}return l+=String.fromCharCode(V),a++,d=16}case 45:if(l+=String.fromCharCode(V),a++,a===p||!_(t.charCodeAt(a)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=S(),d=11;default:for(;a<p&&H(V);)a++,V=t.charCodeAt(a);if(D!==a){switch(l=t.substring(D,a),l){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return l+=String.fromCharCode(V),a++,d=16}}function H(V){if(E(V)||v(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let V;do V=P();while(V>=12&&V<=15);return V}return{setPosition:C,getPosition:()=>a,scan:f?$:P,getToken:()=>d,getTokenValue:()=>l,getTokenOffset:()=>D,getTokenLength:()=>a-D,getTokenError:()=>w}}function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function _(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function y(t,f){const a=[],p=new Object;let l;const D={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function w(g,C,S,k){D.value=g,D.offset=C,D.length=S,D.type=k,D.colonOffset=void 0,l=D}try{n(t,{onObjectBegin:(g,C)=>{if(f<=g)throw p;l=void 0,d=f>g,a.push("")},onObjectProperty:(g,C,S)=>{if(f<C||(w(g,C,S,"property"),a[a.length-1]=g,f<=C+S))throw p},onObjectEnd:(g,C)=>{if(f<=g)throw p;l=void 0,a.pop()},onArrayBegin:(g,C)=>{if(f<=g)throw p;l=void 0,a.push(0)},onArrayEnd:(g,C)=>{if(f<=g)throw p;l=void 0,a.pop()},onLiteralValue:(g,C,S)=>{if(f<C||(w(g,C,S,u(g)),f<=C+S))throw p},onSeparator:(g,C,S)=>{if(f<=C)throw p;if(g===":"&&l&&l.type==="property")l.colonOffset=C,d=!1,l=void 0;else if(g===","){const k=a[a.length-1];typeof k=="number"?a[a.length-1]=k+1:(d=!0,a[a.length-1]=""),l=void 0}}})}catch(g){if(g!==p)throw g}return{path:a,previousNode:l,isAtPropertyKey:d,matches:g=>{let C=0;for(let S=0;C<g.length&&S<a.length;S++)if(g[C]===a[S]||g[C]==="*")C++;else if(g[C]!=="**")return!1;return C===g.length}}}function h(t,f=[],a=O.DEFAULT){let p=null,l=[];const D=[];function d(g){Array.isArray(l)?l.push(g):p!==null&&(l[p]=g)}return n(t,{onObjectBegin:()=>{const g={};d(g),D.push(l),l=g,p=null},onObjectProperty:g=>{p=g},onObjectEnd:()=>{l=D.pop()},onArrayBegin:()=>{const g=[];d(g),D.push(l),l=g,p=null},onArrayEnd:()=>{l=D.pop()},onLiteralValue:d,onError:(g,C,S)=>{f.push({error:g,offset:C,length:S})}},a),l[0]}function b(t,f=[],a=O.DEFAULT){let p={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(g){p.type==="property"&&(p.length=g-p.offset,p=p.parent)}function D(g){return p.children.push(g),g}n(t,{onObjectBegin:g=>{p=D({type:"object",offset:g,length:-1,parent:p,children:[]})},onObjectProperty:(g,C,S)=>{p=D({type:"property",offset:C,length:-1,parent:p,children:[]}),p.children.push({type:"string",value:g,offset:C,length:S,parent:p})},onObjectEnd:(g,C)=>{p.length=g+C-p.offset,p=p.parent,l(g+C)},onArrayBegin:(g,C)=>{p=D({type:"array",offset:g,length:-1,parent:p,children:[]})},onArrayEnd:(g,C)=>{p.length=g+C-p.offset,p=p.parent,l(g+C)},onLiteralValue:(g,C,S)=>{D({type:u(g),offset:C,length:S,parent:p,value:g}),l(C+S)},onSeparator:(g,C,S)=>{p.type==="property"&&(g===":"?p.colonOffset=C:g===","&&l(C))},onError:(g,C,S)=>{f.push({error:g,offset:C,length:S})}},a);const w=p.children[0];return w&&delete w.parent,w}function m(t,f){if(!t)return;let a=t;for(const p of f)if(typeof p=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let l=!1;for(const D of a.children)if(Array.isArray(D.children)&&D.children[0].value===p){a=D.children[1],l=!0;break}if(!l)return}else{const l=p;if(a.type!=="array"||l<0||!Array.isArray(a.children)||l>=a.children.length)return;a=a.children[l]}return a}function r(t){if(!t.parent||!t.parent.children)return[];const f=r(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;f.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&f.push(a)}return f}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const f=Object.create(null);for(const a of t.children){const p=a.children[1];p&&(f[a.children[0].value]=o(p))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,f,a=!1){return f>=t.offset&&f<t.offset+t.length||a&&f===t.offset+t.length}function i(t,f,a=!1){if(s(t,f,a)){const p=t.children;if(Array.isArray(p))for(let l=0;l<p.length&&p[l].offset<=f;l++){const D=i(p[l],f,a);if(D)return D}return t}}function n(t,f,a=O.DEFAULT){const p=A(t,!1);function l(Ne){return Ne?()=>Ne(p.getTokenOffset(),p.getTokenLength()):()=>!0}function D(Ne){return Ne?ae=>Ne(ae,p.getTokenOffset(),p.getTokenLength()):()=>!0}const d=l(f.onObjectBegin),w=D(f.onObjectProperty),g=l(f.onObjectEnd),C=l(f.onArrayBegin),S=l(f.onArrayEnd),k=D(f.onLiteralValue),P=D(f.onSeparator),H=l(f.onComment),$=D(f.onError),V=a&&a.disallowComments,R=a&&a.allowTrailingComma;function z(){for(;;){const Ne=p.scan();switch(p.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:V||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(Ne){case 12:case 13:V?q(10):H();break;case 16:q(1);break;case 15:case 14:break;default:return Ne}}}function q(Ne,ae=[],Re=[]){if($(Ne),ae.length+Re.length>0){let ne=p.getToken();for(;ne!==17;){if(ae.indexOf(ne)!==-1){z();break}else if(Re.indexOf(ne)!==-1)break;ne=z()}}}function ie(Ne){const ae=p.getTokenValue();return Ne?k(ae):w(ae),z(),!0}function ce(){switch(p.getToken()){case 11:{let Ne=0;try{Ne=JSON.parse(p.getTokenValue()),typeof Ne!="number"&&(q(2),Ne=0)}catch{q(2)}k(Ne);break}case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return z(),!0}function Se(){return p.getToken()!==10?(q(3,[],[2,5]),!1):(ie(!1),p.getToken()===6?(P(":"),z(),pe()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function De(){d(),z();let Ne=!1;for(;p.getToken()!==2&&p.getToken()!==17;){if(p.getToken()===5){if(Ne||q(4,[],[]),P(","),z(),p.getToken()===2&&R)break}else Ne&&q(6,[],[]);Se()||q(4,[],[2,5]),Ne=!0}return g(),p.getToken()!==2?q(7,[2],[]):z(),!0}function fe(){C(),z();let Ne=!1;for(;p.getToken()!==4&&p.getToken()!==17;){if(p.getToken()===5){if(Ne||q(4,[],[]),P(","),z(),p.getToken()===4&&R)break}else Ne&&q(6,[],[]);pe()||q(4,[],[4,5]),Ne=!0}return S(),p.getToken()!==4?q(8,[4],[]):z(),!0}function pe(){switch(p.getToken()){case 3:return fe();case 1:return De();case 10:return ie(!0);default:return ce()}}return z(),p.getToken()===17?a.allowEmptyContent?!0:(q(4,[],[]),!1):pe()?(p.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}function c(t,f){const a=A(t),p=[];let l,D=0,d;do switch(d=a.getPosition(),l=a.scan(),l){case 12:case 13:case 17:D!==d&&p.push(t.substring(D,d)),f!==void 0&&p.push(a.getTokenValue().replace(/[^\r\n]/g,f)),D=a.getPosition();break}while(l!==17);return p.join("")}function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ue,e){typeof define=="function"&&define.amd?define(Ie[127],Pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ue=typeof globalThis<"u"?globalThis:ue||self,e(ue.marked={}))}(this,function(ue){"use strict";function e(ye,Ee){for(var ge=0;ge<Ee.length;ge++){var G=Ee[ge];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ye,G.key,G)}}function I(ye,Ee,ge){return Ee&&e(ye.prototype,Ee),ge&&e(ye,ge),Object.defineProperty(ye,"prototype",{writable:!1}),ye}function L(ye,Ee){if(ye){if(typeof ye=="string")return T(ye,Ee);var ge=Object.prototype.toString.call(ye).slice(8,-1);if(ge==="Object"&&ye.constructor&&(ge=ye.constructor.name),ge==="Map"||ge==="Set")return Array.from(ye);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return T(ye,Ee)}}function T(ye,Ee){(Ee==null||Ee>ye.length)&&(Ee=ye.length);for(var ge=0,G=new Array(Ee);ge<Ee;ge++)G[ge]=ye[ge];return G}function O(ye,Ee){var ge=typeof Symbol<"u"&&ye[Symbol.iterator]||ye["@@iterator"];if(ge)return(ge=ge.call(ye)).next.bind(ge);if(Array.isArray(ye)||(ge=L(ye))||Ee&&ye&&typeof ye.length=="number"){ge&&(ye=ge);var G=0;return function(){return G>=ye.length?{done:!0}:{done:!1,value:ye[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ue.defaults=A();function E(ye){ue.defaults=ye}var v=/[&<>"']/,_=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Ee){return h[Ee]};function m(ye,Ee){if(Ee){if(v.test(ye))return ye.replace(_,b)}else if(N.test(ye))return ye.replace(y,b);return ye}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ye){return ye.replace(r,function(Ee,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(ye,Ee){ye=typeof ye=="string"?ye:ye.source,Ee=Ee||"";var ge={replace:function(Y,de){return de=de.source||de,de=de.replace(s,"$1"),ye=ye.replace(Y,de),ge},getRegex:function(){return new RegExp(ye,Ee)}};return ge}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(ye,Ee,ge){if(ye){var G;try{G=decodeURIComponent(o(ge)).replace(n,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}Ee&&!c.test(ge)&&(ge=l(Ee,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},f=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,p=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(ye,Ee){t[" "+ye]||(f.test(ye)?t[" "+ye]=ye+"/":t[" "+ye]=g(ye,"/",!0)),ye=t[" "+ye];var ge=ye.indexOf(":")===-1;return Ee.substring(0,2)==="//"?ge?Ee:ye.replace(a,"$1")+Ee:Ee.charAt(0)==="/"?ge?Ee:ye.replace(p,"$1")+Ee:ye+Ee}var D={exec:function(){}};function d(ye){for(var Ee=1,ge,G;Ee<arguments.length;Ee++){ge=arguments[Ee];for(G in ge)Object.prototype.hasOwnProperty.call(ge,G)&&(ye[G]=ge[G])}return ye}function w(ye,Ee){var ge=ye.replace(/\|/g,function(de,le,Oe){for(var he=!1,ke=le;--ke>=0&&Oe[ke]==="\\";)he=!he;return he?"|":" |"}),G=ge.split(/ \|/),Y=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>Ee)G.splice(Ee);else for(;G.length<Ee;)G.push("");for(;Y<G.length;Y++)G[Y]=G[Y].trim().replace(/\\\|/g,"|");return G}function g(ye,Ee,ge){var G=ye.length;if(G===0)return"";for(var Y=0;Y<G;){var de=ye.charAt(G-Y-1);if(de===Ee&&!ge)Y++;else if(de!==Ee&&ge)Y++;else break}return ye.slice(0,G-Y)}function C(ye,Ee){if(ye.indexOf(Ee[1])===-1)return-1;for(var ge=ye.length,G=0,Y=0;Y<ge;Y++)if(ye[Y]==="\\")Y++;else if(ye[Y]===Ee[0])G++;else if(ye[Y]===Ee[1]&&(G--,G<0))return Y;return-1}function S(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(ye,Ee){if(Ee<1)return"";for(var ge="";Ee>1;)Ee&1&&(ge+=ye),Ee>>=1,ye+=ye;return ge+ye}function P(ye,Ee,ge,G){var Y=Ee.href,de=Ee.title?m(Ee.title):null,le=ye[1].replace(/\\([\[\]])/g,"$1");if(ye[0].charAt(0)!=="!"){G.state.inLink=!0;var Oe={type:"link",raw:ge,href:Y,title:de,text:le,tokens:G.inlineTokens(le)};return G.state.inLink=!1,Oe}return{type:"image",raw:ge,href:Y,title:de,text:m(le)}}function H(ye,Ee){var ge=ye.match(/^(\s+)(?:```)/);if(ge===null)return Ee;var G=ge[1];return Ee.split(`
`).map(function(Y){var de=Y.match(/^\s+/);if(de===null)return Y;var le=de[0];return le.length>=G.length?Y.slice(G.length):Y}).join(`
`)}var $=function(){function ye(ge){this.options=ge||ue.defaults}var Ee=ye.prototype;return Ee.space=function(G){var Y=this.rules.block.newline.exec(G);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},Ee.code=function(G){var Y=this.rules.block.code.exec(G);if(Y){var de=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?de:g(de,`
`)}}},Ee.fences=function(G){var Y=this.rules.block.fences.exec(G);if(Y){var de=Y[0],le=H(de,Y[3]||"");return{type:"code",raw:de,lang:Y[2]?Y[2].trim():Y[2],text:le}}},Ee.heading=function(G){var Y=this.rules.block.heading.exec(G);if(Y){var de=Y[2].trim();if(/#$/.test(de)){var le=g(de,"#");(this.options.pedantic||!le||/ $/.test(le))&&(de=le.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:de,tokens:this.lexer.inline(de)}}},Ee.hr=function(G){var Y=this.rules.block.hr.exec(G);if(Y)return{type:"hr",raw:Y[0]}},Ee.blockquote=function(G){var Y=this.rules.block.blockquote.exec(G);if(Y){var de=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(de,[]),text:de}}},Ee.list=function(G){var Y=this.rules.block.list.exec(G);if(Y){var de,le,Oe,he,ke,Te,ze,U,M,W,j,ee,re=Y[1].trim(),Le=re.length>1,Be={type:"list",raw:"",ordered:Le,start:Le?+re.slice(0,-1):"",loose:!1,items:[]};re=Le?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Le?re:"[*+-]");for(var We=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(ee=!1,!(!(Y=We.exec(G))||this.rules.block.hr.test(G)));){if(de=Y[0],G=G.substring(de.length),U=Y[2].split(`
`,1)[0],M=G.split(`
`,1)[0],this.options.pedantic?(he=2,j=U.trimLeft()):(he=Y[2].search(/[^ ]/),he=he>4?1:he,j=U.slice(he),he+=Y[1].length),Te=!1,!U&&/^ *$/.test(M)&&(de+=M+`
`,G=G.substring(M.length+1),ee=!0),!ee)for(var Ze=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Je=new RegExp("^ {0,"+Math.min(3,he-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,he-1)+"}#");G&&(W=G.split(`
`,1)[0],U=W,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(U)||tt.test(U)||Ze.test(U)||Je.test(G)));){if(U.search(/[^ ]/)>=he||!U.trim())j+=`
`+U.slice(he);else if(!Te)j+=`
`+U;else break;!Te&&!U.trim()&&(Te=!0),de+=W+`
`,G=G.substring(W.length+1)}Be.loose||(ze?Be.loose=!0:/\n *\n *$/.test(de)&&(ze=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(j),le&&(Oe=le[0]!=="[ ] ",j=j.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:de,task:!!le,checked:Oe,loose:!1,text:j}),Be.raw+=de}Be.items[Be.items.length-1].raw=de.trimRight(),Be.items[Be.items.length-1].text=j.trimRight(),Be.raw=Be.raw.trimRight();var it=Be.items.length;for(ke=0;ke<it;ke++){this.lexer.state.top=!1,Be.items[ke].tokens=this.lexer.blockTokens(Be.items[ke].text,[]);var at=Be.items[ke].tokens.filter(function(Ue){return Ue.type==="space"}),gt=at.every(function(Ue){for(var st=Ue.raw.split(""),Q=0,X=O(st),me;!(me=X()).done;){var Ve=me.value;if(Ve===`
`&&(Q+=1),Q>1)return!0}return!1});!Be.loose&&at.length&&gt&&(Be.loose=!0,Be.items[ke].loose=!0)}return Be}},Ee.html=function(G){var Y=this.rules.block.html.exec(G);if(Y){var de={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]);de.type="paragraph",de.text=le,de.tokens=this.lexer.inline(le)}return de}},Ee.def=function(G){var Y=this.rules.block.def.exec(G);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var de=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:de,raw:Y[0],href:Y[2],title:Y[3]}}},Ee.table=function(G){var Y=this.rules.block.table.exec(G);if(Y){var de={type:"table",header:w(Y[1]).map(function(ze){return{text:ze}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=Y[0];var le=de.align.length,Oe,he,ke,Te;for(Oe=0;Oe<le;Oe++)/^ *-+: *$/.test(de.align[Oe])?de.align[Oe]="right":/^ *:-+: *$/.test(de.align[Oe])?de.align[Oe]="center":/^ *:-+ *$/.test(de.align[Oe])?de.align[Oe]="left":de.align[Oe]=null;for(le=de.rows.length,Oe=0;Oe<le;Oe++)de.rows[Oe]=w(de.rows[Oe],de.header.length).map(function(ze){return{text:ze}});for(le=de.header.length,he=0;he<le;he++)de.header[he].tokens=this.lexer.inline(de.header[he].text);for(le=de.rows.length,he=0;he<le;he++)for(Te=de.rows[he],ke=0;ke<Te.length;ke++)Te[ke].tokens=this.lexer.inline(Te[ke].text);return de}}},Ee.lheading=function(G){var Y=this.rules.block.lheading.exec(G);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},Ee.paragraph=function(G){var Y=this.rules.block.paragraph.exec(G);if(Y){var de=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:de,tokens:this.lexer.inline(de)}}},Ee.text=function(G){var Y=this.rules.block.text.exec(G);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},Ee.escape=function(G){var Y=this.rules.inline.escape.exec(G);if(Y)return{type:"escape",raw:Y[0],text:m(Y[1])}},Ee.tag=function(G){var Y=this.rules.inline.tag.exec(G);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]}},Ee.link=function(G){var Y=this.rules.inline.link.exec(G);if(Y){var de=Y[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var le=g(de.slice(0,-1),"\\");if((de.length-le.length)%2===0)return}else{var Oe=C(Y[2],"()");if(Oe>-1){var he=Y[0].indexOf("!")===0?5:4,ke=he+Y[1].length+Oe;Y[2]=Y[2].substring(0,Oe),Y[0]=Y[0].substring(0,ke).trim(),Y[3]=""}}var Te=Y[2],ze="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);U&&(Te=U[1],ze=U[3])}else ze=Y[3]?Y[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(de)?Te=Te.slice(1):Te=Te.slice(1,-1)),P(Y,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},Ee.reflink=function(G,Y){var de;if((de=this.rules.inline.reflink.exec(G))||(de=this.rules.inline.nolink.exec(G))){var le=(de[2]||de[1]).replace(/\s+/g," ");if(le=Y[le.toLowerCase()],!le||!le.href){var Oe=de[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return P(de,le,de[0],this.lexer)}},Ee.emStrong=function(G,Y,de){de===void 0&&(de="");var le=this.rules.inline.emStrong.lDelim.exec(G);if(le&&!(le[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=le[1]||le[2]||"";if(!Oe||Oe&&(de===""||this.rules.inline.punctuation.exec(de))){var he=le[0].length-1,ke,Te,ze=he,U=0,M=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(M.lastIndex=0,Y=Y.slice(-1*G.length+he);(le=M.exec(Y))!=null;)if(ke=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!ke){if(Te=ke.length,le[3]||le[4]){ze+=Te;continue}else if((le[5]||le[6])&&he%3&&!((he+Te)%3)){U+=Te;continue}if(ze-=Te,!(ze>0)){if(Te=Math.min(Te,Te+ze+U),Math.min(he,Te)%2){var W=G.slice(1,he+le.index+Te);return{type:"em",raw:G.slice(0,he+le.index+Te+1),text:W,tokens:this.lexer.inlineTokens(W)}}var j=G.slice(2,he+le.index+Te-1);return{type:"strong",raw:G.slice(0,he+le.index+Te+1),text:j,tokens:this.lexer.inlineTokens(j)}}}}}},Ee.codespan=function(G){var Y=this.rules.inline.code.exec(G);if(Y){var de=Y[2].replace(/\n/g," "),le=/[^ ]/.test(de),Oe=/^ /.test(de)&&/ $/.test(de);return le&&Oe&&(de=de.substring(1,de.length-1)),de=m(de,!0),{type:"codespan",raw:Y[0],text:de}}},Ee.br=function(G){var Y=this.rules.inline.br.exec(G);if(Y)return{type:"br",raw:Y[0]}},Ee.del=function(G){var Y=this.rules.inline.del.exec(G);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},Ee.autolink=function(G,Y){var de=this.rules.inline.autolink.exec(G);if(de){var le,Oe;return de[2]==="@"?(le=m(this.options.mangle?Y(de[1]):de[1]),Oe="mailto:"+le):(le=m(de[1]),Oe=le),{type:"link",raw:de[0],text:le,href:Oe,tokens:[{type:"text",raw:le,text:le}]}}},Ee.url=function(G,Y){var de;if(de=this.rules.inline.url.exec(G)){var le,Oe;if(de[2]==="@")le=m(this.options.mangle?Y(de[0]):de[0]),Oe="mailto:"+le;else{var he;do he=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(he!==de[0]);le=m(de[0]),de[1]==="www."?Oe="http://"+le:Oe=le}return{type:"link",raw:de[0],text:le,href:Oe,tokens:[{type:"text",raw:le,text:le}]}}},Ee.inlineText=function(G,Y){var de=this.rules.inline.text.exec(G);if(de){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):m(de[0]):de[0]:le=m(this.options.smartypants?Y(de[0]):de[0]),{type:"text",raw:de[0],text:le}}},ye}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=i(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=i(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=i(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=i(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=i(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=i(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=d({},V),V.gfm=d({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=i(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=i(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=d({},V.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:i(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=i(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=i(V._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=i(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=i(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=i(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=i(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=i(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=i(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=i(R.reflink).replace("label",R._label).replace("ref",V._label).getRegex(),R.nolink=i(R.nolink).replace("ref",V._label).getRegex(),R.reflinkSearch=i(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=d({},R),R.pedantic=d({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=d({},R.normal,{escape:i(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=i(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=d({},R.gfm,{br:i(R.br).replace("{2,}","*").getRegex(),text:i(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(ye){var Ee="",ge,G,Y=ye.length;for(ge=0;ge<Y;ge++)G=ye.charCodeAt(ge),Math.random()>.5&&(G="x"+G.toString(16)),Ee+="&#"+G+";";return Ee}var ie=function(){function ye(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||ue.defaults,this.options.tokenizer=this.options.tokenizer||new $,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:V.normal,inline:R.normal};this.options.pedantic?(G.block=V.pedantic,G.inline=R.pedantic):this.options.gfm&&(G.block=V.gfm,this.options.breaks?G.inline=R.breaks:G.inline=R.gfm),this.tokenizer.rules=G}ye.lex=function(G,Y){var de=new ye(Y);return de.lex(G)},ye.lexInline=function(G,Y){var de=new ye(Y);return de.inlineTokens(G)};var Ee=ye.prototype;return Ee.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},Ee.blockTokens=function(G,Y){var de=this;Y===void 0&&(Y=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(ze,U,M){return U+"    ".repeat(M.length)});for(var le,Oe,he,ke;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(le=ze.call({lexer:de},G,Y))?(G=G.substring(le.raw.length),Y.push(le),!0):!1}))){if(le=this.tokenizer.space(G)){G=G.substring(le.raw.length),le.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(le);continue}if(le=this.tokenizer.code(G)){G=G.substring(le.raw.length),Oe=Y[Y.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+le.raw,Oe.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(le);continue}if(le=this.tokenizer.fences(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.heading(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.hr(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.blockquote(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.list(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.html(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.def(G)){G=G.substring(le.raw.length),Oe=Y[Y.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+le.raw,Oe.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.lheading(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(he=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,U=G.slice(1),M=void 0;de.options.extensions.startBlock.forEach(function(W){M=W.call({lexer:this},U),typeof M=="number"&&M>=0&&(ze=Math.min(ze,M))}),ze<1/0&&ze>=0&&(he=G.substring(0,ze+1))}(),this.state.top&&(le=this.tokenizer.paragraph(he))){Oe=Y[Y.length-1],ke&&Oe.type==="paragraph"?(Oe.raw+=`
`+le.raw,Oe.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(le),ke=he.length!==G.length,G=G.substring(le.raw.length);continue}if(le=this.tokenizer.text(G)){G=G.substring(le.raw.length),Oe=Y[Y.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+le.raw,Oe.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(le);continue}if(G){var Te="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return this.state.top=!0,Y},Ee.inline=function(G,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:G,tokens:Y}),Y},Ee.inlineTokens=function(G,Y){var de=this;Y===void 0&&(Y=[]);var le,Oe,he,ke=G,Te,ze,U;if(this.tokens.links){var M=Object.keys(this.tokens.links);if(M.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)M.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Te.index)+"["+k("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"["+k("a",Te[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Te.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(ze||(U=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(j){return(le=j.call({lexer:de},G,Y))?(G=G.substring(le.raw.length),Y.push(le),!0):!1}))){if(le=this.tokenizer.escape(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.tag(G)){G=G.substring(le.raw.length),Oe=Y[Y.length-1],Oe&&le.type==="text"&&Oe.type==="text"?(Oe.raw+=le.raw,Oe.text+=le.text):Y.push(le);continue}if(le=this.tokenizer.link(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(le.raw.length),Oe=Y[Y.length-1],Oe&&le.type==="text"&&Oe.type==="text"?(Oe.raw+=le.raw,Oe.text+=le.text):Y.push(le);continue}if(le=this.tokenizer.emStrong(G,ke,U)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.codespan(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.br(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.del(G)){G=G.substring(le.raw.length),Y.push(le);continue}if(le=this.tokenizer.autolink(G,q)){G=G.substring(le.raw.length),Y.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(G,q))){G=G.substring(le.raw.length),Y.push(le);continue}if(he=G,this.options.extensions&&this.options.extensions.startInline&&function(){var j=1/0,ee=G.slice(1),re=void 0;de.options.extensions.startInline.forEach(function(Le){re=Le.call({lexer:this},ee),typeof re=="number"&&re>=0&&(j=Math.min(j,re))}),j<1/0&&j>=0&&(he=G.substring(0,j+1))}(),le=this.tokenizer.inlineText(he,z)){G=G.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(U=le.raw.slice(-1)),ze=!0,Oe=Y[Y.length-1],Oe&&Oe.type==="text"?(Oe.raw+=le.raw,Oe.text+=le.text):Y.push(le);continue}if(G){var W="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return Y},I(ye,null,[{key:"rules",get:function(){return{block:V,inline:R}}}]),ye}(),ce=function(){function ye(ge){this.options=ge||ue.defaults}var Ee=ye.prototype;return Ee.code=function(G,Y,de){var le=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(G,le);Oe!=null&&Oe!==G&&(de=!0,G=Oe)}return G=G.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+m(le,!0)+'">'+(de?G:m(G,!0))+`</code></pre>
`:"<pre><code>"+(de?G:m(G,!0))+`</code></pre>
`},Ee.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},Ee.html=function(G){return G},Ee.heading=function(G,Y,de,le){if(this.options.headerIds){var Oe=this.options.headerPrefix+le.slug(de);return"<h"+Y+' id="'+Oe+'">'+G+"</h"+Y+`>
`}return"<h"+Y+">"+G+"</h"+Y+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(G,Y,de){var le=Y?"ol":"ul",Oe=Y&&de!==1?' start="'+de+'"':"";return"<"+le+Oe+`>
`+G+"</"+le+`>
`},Ee.listitem=function(G){return"<li>"+G+`</li>
`},Ee.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(G){return"<p>"+G+`</p>
`},Ee.table=function(G,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+Y+`</table>
`},Ee.tablerow=function(G){return`<tr>
`+G+`</tr>
`},Ee.tablecell=function(G,Y){var de=Y.header?"th":"td",le=Y.align?"<"+de+' align="'+Y.align+'">':"<"+de+">";return le+G+("</"+de+`>
`)},Ee.strong=function(G){return"<strong>"+G+"</strong>"},Ee.em=function(G){return"<em>"+G+"</em>"},Ee.codespan=function(G){return"<code>"+G+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(G){return"<del>"+G+"</del>"},Ee.link=function(G,Y,de){if(G=u(this.options.sanitize,this.options.baseUrl,G),G===null)return de;var le='<a href="'+m(G)+'"';return Y&&(le+=' title="'+Y+'"'),le+=">"+de+"</a>",le},Ee.image=function(G,Y,de){if(G=u(this.options.sanitize,this.options.baseUrl,G),G===null)return de;var le='<img src="'+G+'" alt="'+de+'"';return Y&&(le+=' title="'+Y+'"'),le+=this.options.xhtml?"/>":">",le},Ee.text=function(G){return G},ye}(),Se=function(){function ye(){}var Ee=ye.prototype;return Ee.strong=function(G){return G},Ee.em=function(G){return G},Ee.codespan=function(G){return G},Ee.del=function(G){return G},Ee.html=function(G){return G},Ee.text=function(G){return G},Ee.link=function(G,Y,de){return""+de},Ee.image=function(G,Y,de){return""+de},Ee.br=function(){return""},ye}(),De=function(){function ye(){this.seen={}}var Ee=ye.prototype;return Ee.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(G,Y){var de=G,le=0;if(this.seen.hasOwnProperty(de)){le=this.seen[G];do le++,de=G+"-"+le;while(this.seen.hasOwnProperty(de))}return Y||(this.seen[G]=le,this.seen[de]=0),de},Ee.slug=function(G,Y){Y===void 0&&(Y={});var de=this.serialize(G);return this.getNextSafeSlug(de,Y.dryrun)},ye}(),fe=function(){function ye(ge){this.options=ge||ue.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Se,this.slugger=new De}ye.parse=function(G,Y){var de=new ye(Y);return de.parse(G)},ye.parseInline=function(G,Y){var de=new ye(Y);return de.parseInline(G)};var Ee=ye.prototype;return Ee.parse=function(G,Y){Y===void 0&&(Y=!0);var de="",le,Oe,he,ke,Te,ze,U,M,W,j,ee,re,Le,Be,We,Ze,Je,et,tt,it=G.length;for(le=0;le<it;le++){if(j=G[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(tt=this.options.extensions.renderers[j.type].call({parser:this},j),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(j.type))){de+=tt||"";continue}switch(j.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(j.tokens),j.depth,o(this.parseInline(j.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(j.text,j.lang,j.escaped);continue}case"table":{for(M="",U="",ke=j.header.length,Oe=0;Oe<ke;Oe++)U+=this.renderer.tablecell(this.parseInline(j.header[Oe].tokens),{header:!0,align:j.align[Oe]});for(M+=this.renderer.tablerow(U),W="",ke=j.rows.length,Oe=0;Oe<ke;Oe++){for(ze=j.rows[Oe],U="",Te=ze.length,he=0;he<Te;he++)U+=this.renderer.tablecell(this.parseInline(ze[he].tokens),{header:!1,align:j.align[he]});W+=this.renderer.tablerow(U)}de+=this.renderer.table(M,W);continue}case"blockquote":{W=this.parse(j.tokens),de+=this.renderer.blockquote(W);continue}case"list":{for(ee=j.ordered,re=j.start,Le=j.loose,ke=j.items.length,W="",Oe=0;Oe<ke;Oe++)We=j.items[Oe],Ze=We.checked,Je=We.task,Be="",We.task&&(et=this.renderer.checkbox(Ze),Le?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=et+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=et+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(We.tokens,Le),W+=this.renderer.listitem(Be,Je,Ze);de+=this.renderer.list(W,ee,re);continue}case"html":{de+=this.renderer.html(j.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(j.tokens));continue}case"text":{for(W=j.tokens?this.parseInline(j.tokens):j.text;le+1<it&&G[le+1].type==="text";)j=G[++le],W+=`
`+(j.tokens?this.parseInline(j.tokens):j.text);de+=Y?this.renderer.paragraph(W):W;continue}default:{var at='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return de},Ee.parseInline=function(G,Y){Y=Y||this.renderer;var de="",le,Oe,he,ke=G.length;for(le=0;le<ke;le++){if(Oe=G[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(he=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){de+=he||"";continue}switch(Oe.type){case"escape":{de+=Y.text(Oe.text);break}case"html":{de+=Y.html(Oe.text);break}case"link":{de+=Y.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,Y));break}case"image":{de+=Y.image(Oe.href,Oe.title,Oe.text);break}case"strong":{de+=Y.strong(this.parseInline(Oe.tokens,Y));break}case"em":{de+=Y.em(this.parseInline(Oe.tokens,Y));break}case"codespan":{de+=Y.codespan(Oe.text);break}case"br":{de+=Y.br();break}case"del":{de+=Y.del(this.parseInline(Oe.tokens,Y));break}case"text":{de+=Y.text(Oe.text);break}default:{var Te='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}}return de},ye}();function pe(ye,Ee,ge){if(typeof ye>"u"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof Ee=="function"&&(ge=Ee,Ee=null),Ee=d({},pe.defaults,Ee||{}),S(Ee),ge){var G=Ee.highlight,Y;try{Y=ie.lex(ye,Ee)}catch(ke){return ge(ke)}var de=function(Te){var ze;if(!Te)try{Ee.walkTokens&&pe.walkTokens(Y,Ee.walkTokens),ze=fe.parse(Y,Ee)}catch(U){Te=U}return Ee.highlight=G,Te?ge(Te):ge(null,ze)};if(!G||G.length<3||(delete Ee.highlight,!Y.length))return de();var le=0;pe.walkTokens(Y,function(ke){ke.type==="code"&&(le++,setTimeout(function(){G(ke.text,ke.lang,function(Te,ze){if(Te)return de(Te);ze!=null&&ze!==ke.text&&(ke.text=ze,ke.escaped=!0),le--,le===0&&de()})},0))}),le===0&&de();return}function Oe(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+m(ke.message+"",!0)+"</pre>";throw ke}try{var he=ie.lex(ye,Ee);if(Ee.walkTokens){if(Ee.async)return Promise.all(pe.walkTokens(he,Ee.walkTokens)).then(function(){return fe.parse(he,Ee)}).catch(Oe);pe.walkTokens(he,Ee.walkTokens)}return fe.parse(he,Ee)}catch(ke){Oe(ke)}}pe.options=pe.setOptions=function(ye){return d(pe.defaults,ye),E(pe.defaults),pe},pe.getDefaults=A,pe.defaults=ue.defaults,pe.use=function(){for(var ye=arguments.length,Ee=new Array(ye),ge=0;ge<ye;ge++)Ee[ge]=arguments[ge];var G=d.apply(void 0,[{}].concat(Ee)),Y=pe.defaults.extensions||{renderers:{},childTokens:{}},de;Ee.forEach(function(le){if(le.extensions&&(de=!0,le.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var ke=Y.renderers?Y.renderers[he.name]:null;ke?Y.renderers[he.name]=function(){for(var Te=arguments.length,ze=new Array(Te),U=0;U<Te;U++)ze[U]=arguments[U];var M=he.renderer.apply(this,ze);return M===!1&&(M=ke.apply(this,ze)),M}:Y.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[he.level]?Y[he.level].unshift(he.tokenizer):Y[he.level]=[he.tokenizer],he.start&&(he.level==="block"?Y.startBlock?Y.startBlock.push(he.start):Y.startBlock=[he.start]:he.level==="inline"&&(Y.startInline?Y.startInline.push(he.start):Y.startInline=[he.start]))}he.childTokens&&(Y.childTokens[he.name]=he.childTokens)})),le.renderer&&function(){var he=pe.defaults.renderer||new ce,ke=function(U){var M=he[U];he[U]=function(){for(var W=arguments.length,j=new Array(W),ee=0;ee<W;ee++)j[ee]=arguments[ee];var re=le.renderer[U].apply(he,j);return re===!1&&(re=M.apply(he,j)),re}};for(var Te in le.renderer)ke(Te);G.renderer=he}(),le.tokenizer&&function(){var he=pe.defaults.tokenizer||new $,ke=function(U){var M=he[U];he[U]=function(){for(var W=arguments.length,j=new Array(W),ee=0;ee<W;ee++)j[ee]=arguments[ee];var re=le.tokenizer[U].apply(he,j);return re===!1&&(re=M.apply(he,j)),re}};for(var Te in le.tokenizer)ke(Te);G.tokenizer=he}(),le.walkTokens){var Oe=pe.defaults.walkTokens;G.walkTokens=function(he){var ke=[];return ke.push(le.walkTokens.call(this,he)),Oe&&(ke=ke.concat(Oe.call(this,he))),ke}}de&&(G.extensions=Y),pe.setOptions(G)})},pe.walkTokens=function(ye,Ee){for(var ge=[],G=function(){var Oe=de.value;switch(ge=ge.concat(Ee.call(pe,Oe)),Oe.type){case"table":{for(var he=O(Oe.header),ke;!(ke=he()).done;){var Te=ke.value;ge=ge.concat(pe.walkTokens(Te.tokens,Ee))}for(var ze=O(Oe.rows),U;!(U=ze()).done;)for(var M=U.value,W=O(M),j;!(j=W()).done;){var ee=j.value;ge=ge.concat(pe.walkTokens(ee.tokens,Ee))}break}case"list":{ge=ge.concat(pe.walkTokens(Oe.items,Ee));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Oe.type]?pe.defaults.extensions.childTokens[Oe.type].forEach(function(re){ge=ge.concat(pe.walkTokens(Oe[re],Ee))}):Oe.tokens&&(ge=ge.concat(pe.walkTokens(Oe.tokens,Ee)))}},Y=O(ye),de;!(de=Y()).done;)G();return ge},pe.parseInline=function(ye,Ee){if(typeof ye>"u"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");Ee=d({},pe.defaults,Ee||{}),S(Ee);try{var ge=ie.lexInline(ye,Ee);return Ee.walkTokens&&pe.walkTokens(ge,Ee.walkTokens),fe.parseInline(ge,Ee)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+m(G.message+"",!0)+"</pre>";throw G}},pe.Parser=fe,pe.parser=fe.parse,pe.Renderer=ce,pe.TextRenderer=Se,pe.Lexer=ie,pe.lexer=ie.lex,pe.Tokenizer=$,pe.Slugger=De,pe.parse=pe;var Ne=pe.options,ae=pe.setOptions,Re=pe.use,ne=pe.walkTokens,x=pe.parseInline,J=pe,be=fe.parse,Me=ie.lex;ue.Lexer=ie,ue.Parser=fe,ue.Renderer=ce,ue.Slugger=De,ue.TextRenderer=Se,ue.Tokenizer=$,ue.getDefaults=A,ue.lexer=Me,ue.marked=pe,ue.options=Ne,ue.parse=J,ue.parseInline=x,ue.parser=be,ue.setOptions=ae,ue.use=Re,ue.walkTokens=ne,Object.defineProperty(ue,"__esModule",{value:!0})}),define(Ie[128],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=I;function I(r){const o=O(r);if(o&&o.length>0)return new Uint32Array(o)}let L=0;const T=new Uint32Array(10);function O(r){if(L=0,A(r,y,4352),L>0||(A(r,h,4449),L>0)||(A(r,b,4520),L>0)||(A(r,m,12593),L))return T.subarray(0,L);if(r>=44032&&r<=55203){const o=r-44032,s=o%588,i=Math.floor(o/588),n=Math.floor(s/28),c=s%28-1;if(i<y.length?A(i,y,0):4352+i-12593<m.length&&A(4352+i,m,12593),n<h.length?A(n,h,0):4449+n-12593<m.length&&A(4449+n-12593,m,12593),c>=0&&(c<b.length?A(c,b,0):4520+c-12593<m.length&&A(4520+c-12593,m,12593)),L>0)return T.subarray(0,L)}}function A(r,o,s){r>=s&&r<s+o.length&&E(o[r-s])}function E(r){r!==0&&(T[L++]=r&255,r>>8&&(T[L++]=r>>8&255),r>>16&&(T[L++]=r>>16&255))}var v;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var _;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(_||(_={}));var N;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(N||(N={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),h=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ie[129],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=I,e.rot=L;function I(E,v,_){return Math.min(Math.max(E,v),_)}function L(E,v){return(v+E%v)%v}class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class O{constructor(){this._n=1,this._val=0}update(v){return this._val=this._val+(v-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=O;class A{constructor(v){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(v),this._values.fill(0,0,v)}update(v){const _=this._values[this._index];return this._values[this._index]=v,this._index=(this._index+1)%this._values.length,this._sum-=_,this._sum+=v,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=A}),define(Ie[130],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=O,e.getFunctionName=h;class I{constructor(m,r,o){this.owner=m,this.debugNameSource=r,this.referenceFn=o}getDebugName(m){return O(m,this)}}e.DebugNameData=I;const L=new Map,T=new WeakMap;function O(b,m){const r=T.get(b);if(r)return r;const o=A(b,m);if(o){let s=L.get(o)??0;s++,L.set(o,s);const i=s===1?o:`${o}#${s}`;return T.set(b,i),i}}function A(b,m){const r=T.get(b);if(r)return r;const o=m.owner?N(m.owner)+".":"";let s;const i=m.debugNameSource;if(i!==void 0)if(typeof i=="function"){if(s=i(),s!==void 0)return o+s}else return o+i;const n=m.referenceFn;if(n!==void 0&&(s=h(n),s!==void 0))return o+s;if(m.owner!==void 0){const c=E(m.owner,b);if(c!==void 0)return o+c}}function E(b,m){for(const r in b)if(b[r]===m)return r}const v=new Map,_=new WeakMap;function N(b){const m=_.get(b);if(m)return m;const r=y(b);let o=v.get(r)??0;o++,v.set(r,o);const s=o===1?r:`${r}#${o}`;return _.set(b,s),s}function y(b){const m=b.constructor;return m?m.name:"Object"}function h(b){const m=b.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(m);return(o?o[1]:void 0)?.trim()}}),define(Ie[131],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=L,e.getLogger=T;let I;function L(r){I=r}function T(){return I}class O{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(o){return A([E(b("|  ",this.indentation)),o])}formatInfo(o){return o.hadValue?o.didChange?[E(" "),_(N(o.oldValue,70),{color:"red",strikeThrough:!0}),E(" "),_(N(o.newValue,60),{color:"green"})]:[E(" (unchanged)")]:[E(" "),_(N(o.newValue,60),{color:"green"}),E(" (initial)")]}handleObservableChanged(o,s){console.log(...this.textToConsoleArgs([v("observable value changed"),_(o.debugName,{color:"BlueViolet"}),...this.formatInfo(s)]))}formatChanges(o){if(o.size!==0)return _(" (changed deps: "+[...o].map(s=>s.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const s=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(i,n)=>(this.changedObservablesSets.get(o).add(i),s.apply(o,[i,n]))}handleDerivedRecomputed(o,s){const i=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([v("derived recomputed"),_(o.debugName,{color:"BlueViolet"}),...this.formatInfo(s),this.formatChanges(i),{data:[{fn:o._computeFn}]}])),i.clear()}handleFromEventObservableTriggered(o,s){console.log(...this.textToConsoleArgs([v("observable from event triggered"),_(o.debugName,{color:"BlueViolet"}),...this.formatInfo(s),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const s=o.handleChange;this.changedObservablesSets.set(o,new Set),o.handleChange=(i,n)=>(this.changedObservablesSets.get(o).add(i),s.apply(o,[i,n]))}handleAutorunTriggered(o){const s=this.changedObservablesSets.get(o);console.log(...this.textToConsoleArgs([v("autorun"),_(o.debugName,{color:"BlueViolet"}),this.formatChanges(s),{data:[{fn:o._runFn}]}])),s.clear(),this.indentation++}handleAutorunFinished(o){this.indentation--}handleBeginTransaction(o){let s=o.getDebugName();s===void 0&&(s=""),console.log(...this.textToConsoleArgs([v("transaction"),_(s,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=O;function A(r){const o=new Array,s=[];let i="";function n(u){if("length"in u)for(const t of u)t&&n(t);else"text"in u?(i+=`%c${u.text}`,o.push(u.style),u.data&&s.push(...u.data)):"data"in u&&s.push(...u.data)}n(r);const c=[i,...o];return c.push(...s),c}function E(r){return _(r,{color:"black"})}function v(r){return _(m(`${r}: `,10),{color:"black",bold:!0})}function _(r,o={color:"black"}){function s(n){return Object.entries(n).reduce((c,[u,t])=>`${c}${u}:${t};`,"")}const i={color:o.color};return o.strikeThrough&&(i["text-decoration"]="line-through"),o.bold&&(i["font-weight"]="bold"),{text:r,style:s(i)}}function N(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?y(r,o):h(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function y(r,o){let s="[ ",i=!0;for(const n of r){if(i||(s+=", "),s.length-5>o){s+="...";break}i=!1,s+=`${N(n,o-s.length)}`}return s+=" ]",s}function h(r,o){let s="{ ",i=!0;for(const[n,c]of Object.entries(r)){if(i||(s+=", "),s.length-5>o){s+="...";break}i=!1,s+=`${n}: ${N(c,o-s.length)}`}return s+=" }",s}function b(r,o){let s="";for(let i=1;i<=o;i++)s+=r;return s}function m(r,o){for(;r.length<o;)r+=" ";return r}}),define(Ie[132],Pe([1,0,125,130,131]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=A,e._setKeepObserved=v,e._setDerivedOpts=N,e.transaction=b,e.globalTransaction=r,e.asyncTransaction=o,e.subtransaction=s,e.observableValue=n,e.observableValueOpts=c,e.disposableObservableValue=t;let O;function A(a){O=a}let E;function v(a){E=a}let _;function N(a){_=a}class y{get TChange(){return null}reportChanges(){this.get()}read(p){return p?p.readObservable(this):this.get()}map(p,l){const D=l===void 0?void 0:p,d=l===void 0?p:l;return _({owner:D,debugName:()=>{const w=(0,L.getFunctionName)(d);if(w!==void 0)return w;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(d.toString());if(C)return`${this.debugName}.${C[2]}`;if(!D)return`${this.debugName} (mapped)`},debugReferenceFn:d},w=>d(this.read(w),w))}recomputeInitiallyAndOnChange(p,l){return p.add(O(this,l)),this}keepObserved(p){return p.add(E(this)),this}get debugValue(){return this.get()}}e.ConvenientObservable=y;class h extends y{constructor(){super(...arguments),this.observers=new Set}addObserver(p){const l=this.observers.size;this.observers.add(p),l===0&&this.onFirstObserverAdded()}removeObserver(p){this.observers.delete(p)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=h;function b(a,p){const l=new i(a,p);try{a(l)}finally{l.finish()}}let m;function r(a){if(m)a(m);else{const p=new i(a,void 0);m=p;try{a(p)}finally{p.finish(),m=void 0}}}async function o(a,p){const l=new i(a,p);try{await a(l)}finally{l.finish()}}function s(a,p,l){a?p(a):b(p,l)}class i{constructor(p,l){this._fn=p,this._getDebugName=l,this.updatingObservers=[],(0,T.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,L.getFunctionName)(this._fn)}updateObserver(p,l){this.updatingObservers.push({observer:p,observable:l}),p.beginUpdate(l)}finish(){const p=this.updatingObservers;for(let l=0;l<p.length;l++){const{observer:D,observable:d}=p[l];D.endUpdate(d)}this.updatingObservers=null,(0,T.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=i;function n(a,p){let l;return typeof a=="string"?l=new L.DebugNameData(void 0,a,void 0):l=new L.DebugNameData(a,void 0,void 0),new u(l,p,I.strictEquals)}function c(a,p){return new u(new L.DebugNameData(a.owner,a.debugName,void 0),p,a.equalsFn??I.strictEquals)}class u extends h{get debugName(){return this._debugNameData.getDebugName(this)??"ObservableValue"}constructor(p,l,D){super(),this._debugNameData=p,this._equalityComparator=D,this._value=l}get(){return this._value}set(p,l,D){if(this._equalityComparator(this._value,p))return;let d;l||(l=d=new i(()=>{},()=>`Setting ${this.debugName}`));try{const w=this._value;this._setValue(p),(0,T.getLogger)()?.handleObservableChanged(this,{oldValue:w,newValue:p,change:D,didChange:!0,hadValue:!0});for(const g of this.observers)l.updateObserver(g,this),g.handleChange(this,D)}finally{d&&d.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(p){this._value=p}}e.ObservableValue=u;function t(a,p){let l;return typeof a=="string"?l=new L.DebugNameData(void 0,a,void 0):l=new L.DebugNameData(a,void 0,void 0),new f(l,p,I.strictEquals)}class f extends u{_setValue(p){this._value!==p&&(this._value&&this._value.dispose(),this._value=p)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=f}),function(){function ue(T){const O=[];typeof T=="number"&&O.push("code/timeOrigin",T);function A(v){O.push(v,Date.now())}function E(){const v=[];for(let _=0;_<O.length;_+=2)v.push({name:O[_],startTime:O[_+1]});return v}return{mark:A,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ue():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(T+A.startTime)});return O}};if(typeof process=="object"){const T=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ue(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),ue()}function I(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=I(L))}(),define(Ie[133],Pe([1,0,42]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const L=Symbol("unset");class T{constructor(){this.root=new A,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||I.Iterable.empty()}insert(v,_,N){this.opNode(v,y=>y._value=_,N)}mutate(v,_){this.opNode(v,N=>N._value=_(N._value===L?void 0:N._value))}delete(v){const _=this.getPathToKey(v);if(!_)return;let N=_.length-1;const y=_[N].node._value;if(y!==L){for(this._size--,_[N].node._value=L;N>0;N--){const{node:h,part:b}=_[N];if(h.children?.size||h._value!==L)break;_[N-1].node.children.delete(b)}return y}}*deleteRecursive(v){const _=this.getPathToKey(v);if(!_)return;const N=_[_.length-1].node;for(let y=_.length-1;y>0;y--){const h=_[y-1];if(h.node.children.delete(_[y].part),h.node.children.size>0||h.node._value!==L)break}for(const y of O(N))y._value!==L&&(this._size--,yield y._value)}find(v){let _=this.root;for(const N of v){const y=_.children?.get(N);if(!y)return;_=y}return _._value===L?void 0:_._value}hasKeyOrParent(v){let _=this.root;for(const N of v){const y=_.children?.get(N);if(!y)return!1;if(y._value!==L)return!0;_=y}return!1}hasKeyOrChildren(v){let _=this.root;for(const N of v){const y=_.children?.get(N);if(!y)return!1;_=y}return!0}hasKey(v){let _=this.root;for(const N of v){const y=_.children?.get(N);if(!y)return!1;_=y}return _._value!==L}getPathToKey(v){const _=[{part:"",node:this.root}];let N=0;for(const y of v){const h=_[N].node.children?.get(y);if(!h)return;_.push({part:y,node:h}),N++}return _}opNode(v,_,N){let y=this.root;for(const m of v){if(y.children)if(y.children.has(m))y=y.children.get(m);else{const r=new A;y.children.set(m,r),y=r}else{const r=new A;y.children=new Map([[m,r]]),y=r}N?.(y)}const h=y._value===L?0:1;_(y);const b=y._value===L?0:1;this._size+=b-h}*values(){for(const{_value:v}of O(this.root))v!==L&&(yield v)}}e.WellDefinedPrefixTree=T;function*O(E){const v=[E];for(;v.length>0;){const _=v.pop();if(yield _,_.children)for(const N of _.children.values())v.push(N)}}class A{constructor(){this._value=L}get value(){return this._value===L?void 0:this._value}set value(v){this._value=v===void 0?L:v}}}),function(ue,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var L in I)(typeof exports=="object"?exports:ue)[L]=I[L]}}(typeof self<"u"?self:this,function(){return function(ue){var e={};function I(L){if(e[L])return e[L].exports;var T=e[L]={i:L,l:!1,exports:{}};return ue[L].call(T.exports,T,T.exports,I),T.l=!0,T.exports}return I.m=ue,I.c=e,I.d=function(L,T,O){I.o(L,T)||Object.defineProperty(L,T,{enumerable:!0,get:O})},I.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},I.t=function(L,T){if(1&T&&(L=I(L)),8&T||4&T&&typeof L=="object"&&L&&L.__esModule)return L;var O=Object.create(null);if(I.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:L}),2&T&&typeof L!="string")for(var A in L)I.d(O,A,function(E){return L[E]}.bind(null,A));return O},I.n=function(L){var T=L&&L.__esModule?function(){return L.default}:function(){return L};return I.d(T,"a",T),T},I.o=function(L,T){return Object.prototype.hasOwnProperty.call(L,T)},I.p="",I(I.s=0)}([function(ue,e,I){(function(L){var T;e=ue.exports=Re,T=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var M=Array.prototype.slice.call(arguments,0);M.unshift("SEMVER"),console.log.apply(console,M)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],v=e.src=[],_=0,N=_++;v[N]="0|[1-9]\\d*";var y=_++;v[y]="[0-9]+";var h=_++;v[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=_++;v[b]="("+v[N]+")\\.("+v[N]+")\\.("+v[N]+")";var m=_++;v[m]="("+v[y]+")\\.("+v[y]+")\\.("+v[y]+")";var r=_++;v[r]="(?:"+v[N]+"|"+v[h]+")";var o=_++;v[o]="(?:"+v[y]+"|"+v[h]+")";var s=_++;v[s]="(?:-("+v[r]+"(?:\\."+v[r]+")*))";var i=_++;v[i]="(?:-?("+v[o]+"(?:\\."+v[o]+")*))";var n=_++;v[n]="[0-9A-Za-z-]+";var c=_++;v[c]="(?:\\+("+v[n]+"(?:\\."+v[n]+")*))";var u=_++,t="v?"+v[b]+v[s]+"?"+v[c]+"?";v[u]="^"+t+"$";var f="[v=\\s]*"+v[m]+v[i]+"?"+v[c]+"?",a=_++;v[a]="^"+f+"$";var p=_++;v[p]="((?:<|>)?=?)";var l=_++;v[l]=v[y]+"|x|X|\\*";var D=_++;v[D]=v[N]+"|x|X|\\*";var d=_++;v[d]="[v=\\s]*("+v[D]+")(?:\\.("+v[D]+")(?:\\.("+v[D]+")(?:"+v[s]+")?"+v[c]+"?)?)?";var w=_++;v[w]="[v=\\s]*("+v[l]+")(?:\\.("+v[l]+")(?:\\.("+v[l]+")(?:"+v[i]+")?"+v[c]+"?)?)?";var g=_++;v[g]="^"+v[p]+"\\s*"+v[d]+"$";var C=_++;v[C]="^"+v[p]+"\\s*"+v[w]+"$";var S=_++;v[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var k=_++;v[k]="(?:~>?)";var P=_++;v[P]="(\\s*)"+v[k]+"\\s+",E[P]=new RegExp(v[P],"g");var H=_++;v[H]="^"+v[k]+v[d]+"$";var $=_++;v[$]="^"+v[k]+v[w]+"$";var V=_++;v[V]="(?:\\^)";var R=_++;v[R]="(\\s*)"+v[V]+"\\s+",E[R]=new RegExp(v[R],"g");var z=_++;v[z]="^"+v[V]+v[d]+"$";var q=_++;v[q]="^"+v[V]+v[w]+"$";var ie=_++;v[ie]="^"+v[p]+"\\s*("+f+")$|^$";var ce=_++;v[ce]="^"+v[p]+"\\s*("+t+")$|^$";var Se=_++;v[Se]="(\\s*)"+v[p]+"\\s*("+f+"|"+v[d]+")",E[Se]=new RegExp(v[Se],"g");var De=_++;v[De]="^\\s*("+v[d]+")\\s+-\\s+("+v[d]+")\\s*$";var fe=_++;v[fe]="^\\s*("+v[w]+")\\s+-\\s+("+v[w]+")\\s*$";var pe=_++;v[pe]="(<|>)?=?\\s*\\*";for(var Ne=0;Ne<35;Ne++)T(Ne,v[Ne]),E[Ne]||(E[Ne]=new RegExp(v[Ne]));function ae(M,W){if(M instanceof Re)return M;if(typeof M!="string"||M.length>O||!(W?E[a]:E[u]).test(M))return null;try{return new Re(M,W)}catch{return null}}function Re(M,W){if(M instanceof Re){if(M.loose===W)return M;M=M.version}else if(typeof M!="string")throw new TypeError("Invalid Version: "+M);if(M.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Re))return new Re(M,W);T("SemVer",M,W),this.loose=W;var j=M.trim().match(W?E[a]:E[u]);if(!j)throw new TypeError("Invalid Version: "+M);if(this.raw=M,this.major=+j[1],this.minor=+j[2],this.patch=+j[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");j[4]?this.prerelease=j[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var re=+ee;if(re>=0&&re<A)return re}return ee}):this.prerelease=[],this.build=j[5]?j[5].split("."):[],this.format()}e.parse=ae,e.valid=function(M,W){var j=ae(M,W);return j?j.version:null},e.clean=function(M,W){var j=ae(M.trim().replace(/^[=v]+/,""),W);return j?j.version:null},e.SemVer=Re,Re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Re.prototype.toString=function(){return this.version},Re.prototype.compare=function(M){return T("SemVer.compare",this.version,this.loose,M),M instanceof Re||(M=new Re(M,this.loose)),this.compareMain(M)||this.comparePre(M)},Re.prototype.compareMain=function(M){return M instanceof Re||(M=new Re(M,this.loose)),x(this.major,M.major)||x(this.minor,M.minor)||x(this.patch,M.patch)},Re.prototype.comparePre=function(M){if(M instanceof Re||(M=new Re(M,this.loose)),this.prerelease.length&&!M.prerelease.length)return-1;if(!this.prerelease.length&&M.prerelease.length)return 1;if(!this.prerelease.length&&!M.prerelease.length)return 0;var W=0;do{var j=this.prerelease[W],ee=M.prerelease[W];if(T("prerelease compare",W,j,ee),j===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(j===void 0)return-1;if(j!==ee)return x(j,ee)}while(++W)},Re.prototype.inc=function(M,W){switch(M){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",W);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",W);break;case"prepatch":this.prerelease.length=0,this.inc("patch",W),this.inc("pre",W);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",W),this.inc("pre",W);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var j=this.prerelease.length;--j>=0;)typeof this.prerelease[j]=="number"&&(this.prerelease[j]++,j=-2);j===-1&&this.prerelease.push(0)}W&&(this.prerelease[0]===W?isNaN(this.prerelease[1])&&(this.prerelease=[W,0]):this.prerelease=[W,0]);break;default:throw new Error("invalid increment argument: "+M)}return this.format(),this.raw=this.version,this},e.inc=function(M,W,j,ee){typeof j=="string"&&(ee=j,j=void 0);try{return new Re(M,j).inc(W,ee).version}catch{return null}},e.diff=function(M,W){if(ye(M,W))return null;var j=ae(M),ee=ae(W);if(j.prerelease.length||ee.prerelease.length){for(var re in j)if((re==="major"||re==="minor"||re==="patch")&&j[re]!==ee[re])return"pre"+re;return"prerelease"}for(var re in j)if((re==="major"||re==="minor"||re==="patch")&&j[re]!==ee[re])return re},e.compareIdentifiers=x;var ne=/^[0-9]+$/;function x(M,W){var j=ne.test(M),ee=ne.test(W);return j&&ee&&(M=+M,W=+W),j&&!ee?-1:ee&&!j?1:M<W?-1:M>W?1:0}function J(M,W,j){return new Re(M,j).compare(new Re(W,j))}function be(M,W,j){return J(M,W,j)>0}function Me(M,W,j){return J(M,W,j)<0}function ye(M,W,j){return J(M,W,j)===0}function Ee(M,W,j){return J(M,W,j)!==0}function ge(M,W,j){return J(M,W,j)>=0}function G(M,W,j){return J(M,W,j)<=0}function Y(M,W,j,ee){var re;switch(W){case"===":typeof M=="object"&&(M=M.version),typeof j=="object"&&(j=j.version),re=M===j;break;case"!==":typeof M=="object"&&(M=M.version),typeof j=="object"&&(j=j.version),re=M!==j;break;case"":case"=":case"==":re=ye(M,j,ee);break;case"!=":re=Ee(M,j,ee);break;case">":re=be(M,j,ee);break;case">=":re=ge(M,j,ee);break;case"<":re=Me(M,j,ee);break;case"<=":re=G(M,j,ee);break;default:throw new TypeError("Invalid operator: "+W)}return re}function de(M,W){if(M instanceof de){if(M.loose===W)return M;M=M.value}if(!(this instanceof de))return new de(M,W);T("comparator",M,W),this.loose=W,this.parse(M),this.semver===le?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(M,W){return x(W,M)},e.major=function(M,W){return new Re(M,W).major},e.minor=function(M,W){return new Re(M,W).minor},e.patch=function(M,W){return new Re(M,W).patch},e.compare=J,e.compareLoose=function(M,W){return J(M,W,!0)},e.rcompare=function(M,W,j){return J(W,M,j)},e.sort=function(M,W){return M.sort(function(j,ee){return e.compare(j,ee,W)})},e.rsort=function(M,W){return M.sort(function(j,ee){return e.rcompare(j,ee,W)})},e.gt=be,e.lt=Me,e.eq=ye,e.neq=Ee,e.gte=ge,e.lte=G,e.cmp=Y,e.Comparator=de;var le={};function Oe(M,W){if(M instanceof Oe)return M.loose===W?M:new Oe(M.raw,W);if(M instanceof de)return new Oe(M.value,W);if(!(this instanceof Oe))return new Oe(M,W);if(this.loose=W,this.raw=M,this.set=M.split(/\s*\|\|\s*/).map(function(j){return this.parseRange(j.trim())},this).filter(function(j){return j.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+M);this.format()}function he(M){return!M||M.toLowerCase()==="x"||M==="*"}function ke(M,W,j,ee,re,Le,Be,We,Ze,Je,et,tt,it){return((W=he(j)?"":he(ee)?">="+j+".0.0":he(re)?">="+j+"."+ee+".0":">="+W)+" "+(We=he(Ze)?"":he(Je)?"<"+(+Ze+1)+".0.0":he(et)?"<"+Ze+"."+(+Je+1)+".0":tt?"<="+Ze+"."+Je+"."+et+"-"+tt:"<="+We)).trim()}function Te(M,W){for(var j=0;j<M.length;j++)if(!M[j].test(W))return!1;if(W.prerelease.length){for(j=0;j<M.length;j++)if(T(M[j].semver),M[j].semver!==le&&M[j].semver.prerelease.length>0){var ee=M[j].semver;if(ee.major===W.major&&ee.minor===W.minor&&ee.patch===W.patch)return!0}return!1}return!0}function ze(M,W,j){try{W=new Oe(W,j)}catch{return!1}return W.test(M)}function U(M,W,j,ee){var re,Le,Be,We,Ze;switch(M=new Re(M,ee),W=new Oe(W,ee),j){case">":re=be,Le=G,Be=Me,We=">",Ze=">=";break;case"<":re=Me,Le=ge,Be=be,We="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(M,W,ee))return!1;for(var Je=0;Je<W.set.length;++Je){var et=W.set[Je],tt=null,it=null;if(et.forEach(function(at){at.semver===le&&(at=new de(">=0.0.0")),tt=tt||at,it=it||at,re(at.semver,tt.semver,ee)?tt=at:Be(at.semver,it.semver,ee)&&(it=at)}),tt.operator===We||tt.operator===Ze||(!it.operator||it.operator===We)&&Le(M,it.semver)||it.operator===Ze&&Be(M,it.semver))return!1}return!0}de.prototype.parse=function(M){var W=this.loose?E[ie]:E[ce],j=M.match(W);if(!j)throw new TypeError("Invalid comparator: "+M);this.operator=j[1],this.operator==="="&&(this.operator=""),j[2]?this.semver=new Re(j[2],this.loose):this.semver=le},de.prototype.toString=function(){return this.value},de.prototype.test=function(M){return T("Comparator.test",M,this.loose),this.semver===le||(typeof M=="string"&&(M=new Re(M,this.loose)),Y(M,this.operator,this.semver,this.loose))},de.prototype.intersects=function(M,W){if(!(M instanceof de))throw new TypeError("a Comparator is required");var j;if(this.operator==="")return j=new Oe(M.value,W),ze(this.value,j,W);if(M.operator==="")return j=new Oe(this.value,W),ze(M.semver,j,W);var ee=!(this.operator!==">="&&this.operator!==">"||M.operator!==">="&&M.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||M.operator!=="<="&&M.operator!=="<"),Le=this.semver.version===M.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||M.operator!==">="&&M.operator!=="<="),We=Y(this.semver,"<",M.semver,W)&&(this.operator===">="||this.operator===">")&&(M.operator==="<="||M.operator==="<"),Ze=Y(this.semver,">",M.semver,W)&&(this.operator==="<="||this.operator==="<")&&(M.operator===">="||M.operator===">");return ee||re||Le&&Be||We||Ze},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(M){return M.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(M){var W=this.loose;M=M.trim(),T("range",M,W);var j=W?E[fe]:E[De];M=M.replace(j,ke),T("hyphen replace",M),M=M.replace(E[Se],"$1$2$3"),T("comparator trim",M,E[Se]),M=(M=(M=M.replace(E[P],"$1~")).replace(E[R],"$1^")).split(/\s+/).join(" ");var ee=W?E[ie]:E[ce],re=M.split(" ").map(function(Le){return function(Be,We){return T("comp",Be),Be=function(Ze,Je){return Ze.trim().split(/\s+/).map(function(et){return function(tt,it){T("caret",tt,it);var at=it?E[q]:E[z];return tt.replace(at,function(gt,Ue,st,Q,X){var me;return T("caret",tt,gt,Ue,st,Q,X),he(Ue)?me="":he(st)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":he(Q)?me=Ue==="0"?">="+Ue+"."+st+".0 <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+".0 <"+(+Ue+1)+".0.0":X?(T("replaceCaret pr",X),X.charAt(0)!=="-"&&(X="-"+X),me=Ue==="0"?st==="0"?">="+Ue+"."+st+"."+Q+X+" <"+Ue+"."+st+"."+(+Q+1):">="+Ue+"."+st+"."+Q+X+" <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+"."+Q+X+" <"+(+Ue+1)+".0.0"):(T("no pr"),me=Ue==="0"?st==="0"?">="+Ue+"."+st+"."+Q+" <"+Ue+"."+st+"."+(+Q+1):">="+Ue+"."+st+"."+Q+" <"+Ue+"."+(+st+1)+".0":">="+Ue+"."+st+"."+Q+" <"+(+Ue+1)+".0.0"),T("caret return",me),me})}(et,Je)}).join(" ")}(Be,We),T("caret",Be),Be=function(Ze,Je){return Ze.trim().split(/\s+/).map(function(et){return function(tt,it){var at=it?E[$]:E[H];return tt.replace(at,function(gt,Ue,st,Q,X){var me;return T("tilde",tt,gt,Ue,st,Q,X),he(Ue)?me="":he(st)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":he(Q)?me=">="+Ue+"."+st+".0 <"+Ue+"."+(+st+1)+".0":X?(T("replaceTilde pr",X),X.charAt(0)!=="-"&&(X="-"+X),me=">="+Ue+"."+st+"."+Q+X+" <"+Ue+"."+(+st+1)+".0"):me=">="+Ue+"."+st+"."+Q+" <"+Ue+"."+(+st+1)+".0",T("tilde return",me),me})}(et,Je)}).join(" ")}(Be,We),T("tildes",Be),Be=function(Ze,Je){return T("replaceXRanges",Ze,Je),Ze.split(/\s+/).map(function(et){return function(tt,it){tt=tt.trim();var at=it?E[C]:E[g];return tt.replace(at,function(gt,Ue,st,Q,X,me){T("xRange",tt,gt,Ue,st,Q,X,me);var Ve=he(st),we=Ve||he(Q),ot=we||he(X);return Ue==="="&&ot&&(Ue=""),Ve?gt=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&ot?(we&&(Q=0),ot&&(X=0),Ue===">"?(Ue=">=",we?(st=+st+1,Q=0,X=0):ot&&(Q=+Q+1,X=0)):Ue==="<="&&(Ue="<",we?st=+st+1:Q=+Q+1),gt=Ue+st+"."+Q+"."+X):we?gt=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(gt=">="+st+"."+Q+".0 <"+st+"."+(+Q+1)+".0"),T("xRange return",gt),gt})}(et,Je)}).join(" ")}(Be,We),T("xrange",Be),Be=function(Ze,Je){return T("replaceStars",Ze,Je),Ze.trim().replace(E[pe],"")}(Be,We),T("stars",Be),Be}(Le,W)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Le){return!!Le.match(ee)})),re=re.map(function(Le){return new de(Le,W)})},Oe.prototype.intersects=function(M,W){if(!(M instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(j){return j.every(function(ee){return M.set.some(function(re){return re.every(function(Le){return ee.intersects(Le,W)})})})})},e.toComparators=function(M,W){return new Oe(M,W).set.map(function(j){return j.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(M){if(!M)return!1;typeof M=="string"&&(M=new Re(M,this.loose));for(var W=0;W<this.set.length;W++)if(Te(this.set[W],M))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(M,W,j){var ee=null,re=null;try{var Le=new Oe(W,j)}catch{return null}return M.forEach(function(Be){Le.test(Be)&&(ee&&re.compare(Be)!==-1||(re=new Re(ee=Be,j)))}),ee},e.minSatisfying=function(M,W,j){var ee=null,re=null;try{var Le=new Oe(W,j)}catch{return null}return M.forEach(function(Be){Le.test(Be)&&(ee&&re.compare(Be)!==1||(re=new Re(ee=Be,j)))}),ee},e.validRange=function(M,W){try{return new Oe(M,W).range||"*"}catch{return null}},e.ltr=function(M,W,j){return U(M,W,"<",j)},e.gtr=function(M,W,j){return U(M,W,">",j)},e.outside=U,e.prerelease=function(M,W){var j=ae(M,W);return j&&j.prerelease.length?j.prerelease:null},e.intersects=function(M,W,j){return M=new Oe(M,j),W=new Oe(W,j),M.intersects(W)},e.coerce=function(M){if(M instanceof Re)return M;if(typeof M!="string")return null;var W=M.match(E[S]);return W==null?null:ae((W[1]||"0")+"."+(W[2]||"0")+"."+(W[3]||"0"))}}).call(this,I(1))},function(ue,e){var I,L,T=ue.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function E(o){if(I===setTimeout)return setTimeout(o,0);if((I===O||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:O}catch{I=O}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch{L=A}})();var v,_=[],N=!1,y=-1;function h(){N&&v&&(N=!1,v.length?_=v.concat(_):y=-1,_.length&&b())}function b(){if(!N){var o=E(h);N=!0;for(var s=_.length;s;){for(v=_,_=[];++y<s;)v&&v[y].run();y=-1,s=_.length}v=null,N=!1,function(i){if(L===clearTimeout)return clearTimeout(i);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(i);try{L(i)}catch{try{return L.call(null,i)}catch{return L.call(this,i)}}}(o)}}function m(o,s){this.fun=o,this.array=s}function r(){}T.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];_.push(new m(o,s)),_.length!==1||N||E(b)},m.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=r,T.addListener=r,T.once=r,T.off=r,T.removeListener=r,T.removeAllListeners=r,T.emit=r,T.prependListener=r,T.prependOnceListener=r,T.listeners=function(o){return[]},T.binding=function(o){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(o){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(Ie[134],Pe([1,0,14,6]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=T,e.isReadableStream=O,e.isReadableBufferedStream=A,e.newWriteableStream=E,e.consumeReadable=_,e.peekReadable=N,e.consumeStream=y,e.listenStream=h,e.peekStream=b,e.toStream=m,e.emptyStream=r,e.toReadable=o,e.transform=s,e.prefixedReadable=i,e.prefixedStream=n;function T(c){const u=c;return u?typeof u.read=="function":!1}function O(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}function A(c){const u=c;return u?O(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function E(c,u){return new v(c,u)}class v{constructor(u,t){this.reducer=u,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u<"u"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(t=>t(u))}emitError(u){this.listeners.error.length===0?(0,I.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(t=>t(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,t){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(u,t){if(this.state.destroyed)return;let f;switch(u){case"data":f=this.listeners.data;break;case"end":f=this.listeners.end;break;case"error":f=this.listeners.error;break}if(f){const a=f.indexOf(t);a>=0&&f.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(f=>f())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(c,u){const t=[];let f;for(;(f=c.read())!==null;)t.push(f);return u(t)}function N(c,u,t){const f=[];let a;for(;(a=c.read())!==null&&f.length<t;)f.push(a);return a===null&&f.length>0?u(f):{read:()=>{if(f.length>0)return f.shift();if(typeof a<"u"){const p=a;return a=void 0,p}return c.read()}}}function y(c,u){return new Promise((t,f)=>{const a=[];h(c,{onData:p=>{u&&a.push(p)},onError:p=>{u?f(p):t(void 0)},onEnd:()=>{t(u?u(a):void 0)}})})}function h(c,u,t){c.on("error",f=>{t?.isCancellationRequested||u.onError(f)}),c.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),c.on("data",f=>{t?.isCancellationRequested||u.onData(f)})}function b(c,u){return new Promise((t,f)=>{const a=new L.DisposableStore,p=[],l=w=>{if(p.push(w),p.length>u)return a.dispose(),c.pause(),t({stream:c,buffer:p,ended:!1})},D=w=>(a.dispose(),f(w)),d=()=>(a.dispose(),t({stream:c,buffer:p,ended:!0}));a.add((0,L.toDisposable)(()=>c.removeListener("error",D))),c.on("error",D),a.add((0,L.toDisposable)(()=>c.removeListener("end",d))),c.on("end",d),a.add((0,L.toDisposable)(()=>c.removeListener("data",l))),c.on("data",l)})}function m(c,u){const t=E(u);return t.end(c),t}function r(){const c=E(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}function s(c,u,t){const f=E(t);return h(c,{onData:a=>f.write(u.data(a)),onError:a=>f.error(u.error?u.error(a):a),onEnd:()=>f.end()}),f}function i(c,u,t){let f=!1;return{read:()=>{const a=u.read();return f?a:(f=!0,a!==null?t([c,a]):c)}}}function n(c,u,t){let f=!1;const a=E(t);return h(u,{onData:p=>f?a.write(p):(f=!0,a.write(t([c,p]))),onError:p=>a.error(p),onEnd:()=>{f||(f=!0,a.write(c)),a.end()}}),a}}),define(Ie[21],Pe([1,0,43,134]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=_,e.readUInt16LE=N,e.writeUInt16LE=y,e.readUInt32BE=h,e.writeUInt32BE=b,e.readUInt32LE=m,e.writeUInt32LE=r,e.readUInt8=o,e.writeUInt8=s,e.readableToBuffer=i,e.bufferToReadable=n,e.streamToBuffer=c,e.bufferedStreamToBuffer=u,e.bufferToStream=t,e.streamToBufferReadableStream=f,e.newWriteableBufferStream=a,e.prefixedBufferReadable=p,e.prefixedBufferStream=l,e.decodeBase64=D,e.encodeBase64=g;const T=typeof Buffer<"u",O=new I.Lazy(()=>new Uint8Array(256));let A,E;class v{static alloc(S){return T?new v(Buffer.allocUnsafe(S)):new v(new Uint8Array(S))}static wrap(S){return T&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new v(S)}static fromString(S,k){return!(k?.dontUseNodeBuffer||!1)&&T?new v(Buffer.from(S)):(A||(A=new TextEncoder),new v(A.encode(S)))}static fromByteArray(S){const k=v.alloc(S.length);for(let P=0,H=S.length;P<H;P++)k.buffer[P]=S[P];return k}static concat(S,k){if(typeof k>"u"){k=0;for(let $=0,V=S.length;$<V;$++)k+=S[$].byteLength}const P=v.alloc(k);let H=0;for(let $=0,V=S.length;$<V;$++){const R=S[$];P.set(R,H),H+=R.byteLength}return P}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=v.alloc(this.byteLength);return S.set(this),S}toString(){return T?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(S,k){return new v(this.buffer.subarray(S,k))}set(S,k){if(S instanceof v)this.buffer.set(S.buffer,k);else if(S instanceof Uint8Array)this.buffer.set(S,k);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),k);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return h(this.buffer,S)}writeUInt32BE(S,k){b(this.buffer,S,k)}readUInt32LE(S){return m(this.buffer,S)}writeUInt32LE(S,k){r(this.buffer,S,k)}readUInt8(S){return o(this.buffer,S)}writeUInt8(S,k){s(this.buffer,S,k)}indexOf(S,k=0){return _(this.buffer,S instanceof v?S.buffer:S,k)}}e.VSBuffer=v;function _(C,S,k=0){const P=S.byteLength,H=C.byteLength;if(P===0)return 0;if(P===1)return C.indexOf(S[0]);if(P>H-k)return-1;const $=O.value;$.fill(S.length);for(let q=0;q<S.length;q++)$[S[q]]=S.length-q-1;let V=k+S.length-1,R=V,z=-1;for(;V<H;)if(C[V]===S[R]){if(R===0){z=V;break}V--,R--}else V+=Math.max(S.length-R,$[C[V]]),R=S.length-1;return z}function N(C,S){return C[S+0]<<0>>>0|C[S+1]<<8>>>0}function y(C,S,k){C[k+0]=S&255,S=S>>>8,C[k+1]=S&255}function h(C,S){return C[S]*2**24+C[S+1]*2**16+C[S+2]*2**8+C[S+3]}function b(C,S,k){C[k+3]=S,S=S>>>8,C[k+2]=S,S=S>>>8,C[k+1]=S,S=S>>>8,C[k]=S}function m(C,S){return C[S+0]<<0>>>0|C[S+1]<<8>>>0|C[S+2]<<16>>>0|C[S+3]<<24>>>0}function r(C,S,k){C[k+0]=S&255,S=S>>>8,C[k+1]=S&255,S=S>>>8,C[k+2]=S&255,S=S>>>8,C[k+3]=S&255}function o(C,S){return C[S]}function s(C,S,k){C[k]=S}function i(C){return L.consumeReadable(C,S=>v.concat(S))}function n(C){return L.toReadable(C)}function c(C){return L.consumeStream(C,S=>v.concat(S))}async function u(C){return C.ended?v.concat(C.buffer):v.concat([...C.buffer,await c(C.stream)])}function t(C){return L.toStream(C,S=>v.concat(S))}function f(C){return L.transform(C,{data:S=>typeof S=="string"?v.fromString(S):v.wrap(S)},S=>v.concat(S))}function a(C){return L.newWriteableStream(S=>v.concat(S),C)}function p(C,S){return L.prefixedReadable(C,S,k=>v.concat(k))}function l(C,S){return L.prefixedStream(C,S,k=>v.concat(k))}function D(C){let S=0,k=0,P=0;const H=new Uint8Array(Math.floor(C.length/4*3)),$=R=>{switch(k){case 3:H[P++]=S|R,k=0;break;case 2:H[P++]=S|R>>>2,S=R<<6,k=3;break;case 1:H[P++]=S|R>>>4,S=R<<4,k=2;break;default:S=R<<2,k=1}};for(let R=0;R<C.length;R++){const z=C.charCodeAt(R);if(z>=65&&z<=90)$(z-65);else if(z>=97&&z<=122)$(z-97+26);else if(z>=48&&z<=57)$(z-48+52);else if(z===43||z===45)$(62);else if(z===47||z===95)$(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${C[R]}`)}}const V=P;for(;k>0;)$(0);return v.wrap(H).slice(0,V)}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:C},S=!0,k=!1){const P=k?w:d;let H="";const $=C.byteLength%3;let V=0;for(;V<C.byteLength-$;V+=3){const R=C[V+0],z=C[V+1],q=C[V+2];H+=P[R>>>2],H+=P[(R<<4|z>>>4)&63],H+=P[(z<<2|q>>>6)&63],H+=P[q&63]}if($===1){const R=C[V+0];H+=P[R>>>2],H+=P[R<<4&63],S&&(H+="==")}else if($===2){const R=C[V+0],z=C[V+1];H+=P[R>>>2],H+=P[(R<<4|z>>>4)&63],H+=P[z<<2&63],S&&(H+="=")}return H}}),define(Ie[135],Pe([1,0,28,128,13]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=O,e.matchesContiguousSubString=E,e.matchesSubString=v,e.isUpper=y,e.matchesCamelCase=D,e.matchesWords=d,e.matchesFuzzy=P,e.matchesFuzzy2=H,e.anyScore=$,e.createMatches=V,e.isPatternInWord=J,e.fuzzyScore=Ee,e.fuzzyScoreGracefulAggressive=Y,e.fuzzyScoreGraceful=de;function O(...he){return function(ke,Te){for(let ze=0,U=he.length;ze<U;ze++){const M=he[ze](ke,Te);if(M)return M}return null}}e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(he,ke,Te){if(!Te||Te.length<ke.length)return null;let ze;return he?ze=T.startsWithIgnoreCase(Te,ke):ze=Te.indexOf(ke)===0,ze?ke.length>0?[{start:0,end:ke.length}]:[]:null}function E(he,ke){const Te=ke.toLowerCase().indexOf(he.toLowerCase());return Te===-1?null:[{start:Te,end:Te+he.length}]}function v(he,ke){return _(he.toLowerCase(),ke.toLowerCase(),0,0)}function _(he,ke,Te,ze){if(Te===he.length)return[];if(ze===ke.length)return null;if(he[Te]===ke[ze]){let U=null;return(U=_(he,ke,Te+1,ze+1))?c({start:ze,end:ze+1},U):null}return _(he,ke,Te,ze+1)}function N(he){return 97<=he&&he<=122}function y(he){return 65<=he&&he<=90}function h(he){return 48<=he&&he<=57}function b(he){return he===32||he===9||he===10||he===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(he=>m.add(he.charCodeAt(0)));function r(he){return b(he)||m.has(he)}function o(he,ke){return he===ke||r(he)&&r(ke)}const s=new Map;function i(he){if(s.has(he))return s.get(he);let ke;const Te=(0,L.getKoreanAltChars)(he);return Te&&(ke=Te),s.set(he,ke),ke}function n(he){return N(he)||y(he)||h(he)}function c(he,ke){return ke.length===0?ke=[he]:he.end===ke[0].start?ke[0].start=he.start:ke.unshift(he),ke}function u(he,ke){for(let Te=ke;Te<he.length;Te++){const ze=he.charCodeAt(Te);if(y(ze)||h(ze)||Te>0&&!n(he.charCodeAt(Te-1)))return Te}return he.length}function t(he,ke,Te,ze){if(Te===he.length)return[];if(ze===ke.length)return null;if(he[Te]!==ke[ze].toLowerCase())return null;{let U=null,M=ze+1;for(U=t(he,ke,Te+1,ze+1);!U&&(M=u(ke,M))<ke.length;)U=t(he,ke,Te+1,M),M++;return U===null?null:c({start:ze,end:ze+1},U)}}function f(he){let ke=0,Te=0,ze=0,U=0,M=0;for(let Le=0;Le<he.length;Le++)M=he.charCodeAt(Le),y(M)&&ke++,N(M)&&Te++,n(M)&&ze++,h(M)&&U++;const W=ke/he.length,j=Te/he.length,ee=ze/he.length,re=U/he.length;return{upperPercent:W,lowerPercent:j,alphaPercent:ee,numericPercent:re}}function a(he){const{upperPercent:ke,lowerPercent:Te}=he;return Te===0&&ke>.6}function p(he){const{upperPercent:ke,lowerPercent:Te,alphaPercent:ze,numericPercent:U}=he;return Te>.2&&ke<.8&&ze>.6&&U<.2}function l(he){let ke=0,Te=0,ze=0,U=0;for(let M=0;M<he.length;M++)ze=he.charCodeAt(M),y(ze)&&ke++,N(ze)&&Te++,b(ze)&&U++;return(ke===0||Te===0)&&U===0?he.length<=30:ke<=5}function D(he,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!l(he))return null;ke.length>60&&(ke=ke.substring(0,60));const Te=f(ke);if(!p(Te)){if(!a(Te))return null;ke=ke.toLowerCase()}let ze=null,U=0;for(he=he.toLowerCase();U<ke.length&&(ze=t(he,ke,0,U))===null;)U=u(ke,U+1);return ze}function d(he,ke,Te=!1){if(!ke||ke.length===0)return null;let ze=null,U=0;for(he=he.toLowerCase(),ke=ke.toLowerCase();U<ke.length&&(ze=w(he,ke,0,U,Te),ze===null);)U=g(ke,U+1);return ze}function w(he,ke,Te,ze,U){let M=0;if(Te===he.length)return[];if(ze===ke.length)return null;if(!o(he.charCodeAt(Te),ke.charCodeAt(ze))){const ee=i(he.charCodeAt(Te));if(!ee)return null;for(let re=0;re<ee.length;re++)if(!o(ee[re],ke.charCodeAt(ze+re)))return null;M+=ee.length-1}let W=null,j=ze+M+1;if(W=w(he,ke,Te+1,j,U),!U)for(;!W&&(j=g(ke,j))<ke.length;)W=w(he,ke,Te+1,j,U),j++;if(!W)return null;if(he.charCodeAt(Te)!==ke.charCodeAt(ze)){const ee=i(he.charCodeAt(Te));if(!ee)return W;for(let re=0;re<ee.length;re++)if(ee[re]!==ke.charCodeAt(ze+re))return W}return c({start:ze,end:ze+M+1},W)}function g(he,ke){for(let Te=ke;Te<he.length;Te++)if(r(he.charCodeAt(Te))||Te>0&&r(he.charCodeAt(Te-1)))return Te;return he.length}const C=O(e.matchesPrefix,D,E),S=O(e.matchesPrefix,D,v),k=new I.LRUCache(1e4);function P(he,ke,Te=!1){if(typeof he!="string"||typeof ke!="string")return null;let ze=k.get(he);ze||(ze=new RegExp(T.convertSimple2RegExpPattern(he),"i"),k.set(he,ze));const U=ze.exec(ke);return U?[{start:U.index,end:U.index+U[0].length}]:Te?S(he,ke):C(he,ke)}function H(he,ke){const Te=Ee(he,he.toLowerCase(),0,ke,ke.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?V(Te):null}function $(he,ke,Te,ze,U,M){const W=Math.min(13,he.length);for(;Te<W;Te++){const j=Ee(he,ke,Te,ze,U,M,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(j)return j}return[0,M]}function V(he){if(typeof he>"u")return[];const ke=[],Te=he[1];for(let ze=he.length-1;ze>1;ze--){const U=he[ze]+Te,M=ke[ke.length-1];M&&M.end===U?M.end=U+1:ke.push({start:U,end:U+1})}return ke}const R=128;function z(){const he=[],ke=[];for(let Te=0;Te<=R;Te++)ke[Te]=0;for(let Te=0;Te<=R;Te++)he.push(ke.slice(0));return he}function q(he){const ke=[];for(let Te=0;Te<=he;Te++)ke[Te]=0;return ke}const ie=q(2*R),ce=q(2*R),Se=z(),De=z(),fe=z(),pe=!1;function Ne(he,ke,Te,ze,U){function M(j,ee,re=" "){for(;j.length<ee;)j=re+j;return j}let W=` |   |${ze.split("").map(j=>M(j,3)).join("|")}
`;for(let j=0;j<=Te;j++)j===0?W+=" |":W+=`${ke[j-1]}|`,W+=he[j].slice(0,U+1).map(ee=>M(ee.toString(),3)).join("|")+`
`;return W}function ae(he,ke,Te,ze){he=he.substr(ke),Te=Te.substr(ze),console.log(Ne(De,he,he.length,Te,Te.length)),console.log(Ne(fe,he,he.length,Te,Te.length)),console.log(Ne(Se,he,he.length,Te,Te.length))}function Re(he,ke){if(ke<0||ke>=he.length)return!1;const Te=he.codePointAt(ke);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(Te)}}function ne(he,ke){if(ke<0||ke>=he.length)return!1;switch(he.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function x(he,ke,Te){return ke[he]!==Te[he]}function J(he,ke,Te,ze,U,M,W=!1){for(;ke<Te&&U<M;)he[ke]===ze[U]&&(W&&(ie[ke]=U),ke+=1),U+=1;return ke===Te}var be;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(be||(be={}));var Me;(function(he){he.Default=[-100,0];function ke(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}he.isDefault=ke})(Me||(e.FuzzyScore=Me={}));class ye{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ke,Te){this.firstMatchCanBeWeak=ke,this.boostFullMatch=Te}}e.FuzzyScoreOptions=ye;function Ee(he,ke,Te,ze,U,M,W=ye.default){const j=he.length>R?R:he.length,ee=ze.length>R?R:ze.length;if(Te>=j||M>=ee||j-Te>ee-M||!J(ke,Te,j,U,M,ee,!0))return;ge(j,ee,Te,M,ke,U);let re=1,Le=1,Be=Te,We=M;const Ze=[!1];for(re=1,Be=Te;Be<j;re++,Be++){const at=ie[Be],gt=ce[Be],Ue=Be+1<j?ce[Be+1]:ee;for(Le=at-M+1,We=at;We<Ue;Le++,We++){let st=Number.MIN_SAFE_INTEGER,Q=!1;We<=gt&&(st=G(he,ke,Be,Te,ze,U,We,ee,M,Se[re-1][Le-1]===0,Ze));let X=0;st!==Number.MAX_SAFE_INTEGER&&(Q=!0,X=st+De[re-1][Le-1]);const me=We>at,Ve=me?De[re][Le-1]+(Se[re][Le-1]>0?-5:0):0,we=We>at+1&&Se[re][Le-1]>0,ot=we?De[re][Le-2]+(Se[re][Le-2]>0?-5:0):0;if(we&&(!me||ot>=Ve)&&(!Q||ot>=X))De[re][Le]=ot,fe[re][Le]=3,Se[re][Le]=0;else if(me&&(!Q||Ve>=X))De[re][Le]=Ve,fe[re][Le]=2,Se[re][Le]=0;else if(Q)De[re][Le]=X,fe[re][Le]=1,Se[re][Le]=Se[re-1][Le-1]+1;else throw new Error("not possible")}}if(pe&&ae(he,Te,ze,M),!Ze[0]&&!W.firstMatchCanBeWeak)return;re--,Le--;const Je=[De[re][Le],M];let et=0,tt=0;for(;re>=1;){let at=Le;do{const gt=fe[re][at];if(gt===3)at=at-2;else if(gt===2)at=at-1;else break}while(at>=1);et>1&&ke[Te+re-1]===U[M+Le-1]&&!x(at+M-1,ze,U)&&et+1>Se[re][at]&&(at=Le),at===Le?et++:et=1,tt||(tt=at),re--,Le=at-1,Je.push(Le)}ee===j&&W.boostFullMatch&&(Je[0]+=2);const it=tt-j;return Je[0]-=it,Je}function ge(he,ke,Te,ze,U,M){let W=he-1,j=ke-1;for(;W>=Te&&j>=ze;)U[W]===M[j]&&(ce[W]=j,W--),j--}function G(he,ke,Te,ze,U,M,W,j,ee,re,Le){if(ke[Te]!==M[W])return Number.MIN_SAFE_INTEGER;let Be=1,We=!1;return W===Te-ze?Be=he[Te]===U[W]?7:5:x(W,U,M)&&(W===0||!x(W-1,U,M))?(Be=he[Te]===U[W]?7:5,We=!0):Re(M,W)&&(W===0||!Re(M,W-1))?Be=5:(Re(M,W-1)||ne(M,W-1))&&(Be=5,We=!0),Be>1&&Te===ze&&(Le[0]=!0),We||(We=x(W,U,M)||Re(M,W-1)||ne(M,W-1)),Te===ze?W>ee&&(Be-=We?3:5):re?Be+=We?2:0:Be+=We?0:1,W+1===j&&(Be-=We?3:5),Be}function Y(he,ke,Te,ze,U,M,W){return le(he,ke,Te,ze,U,M,!0,W)}function de(he,ke,Te,ze,U,M,W){return le(he,ke,Te,ze,U,M,!1,W)}function le(he,ke,Te,ze,U,M,W,j){let ee=Ee(he,ke,Te,ze,U,M,j);if(ee&&!W)return ee;if(he.length>=3){const re=Math.min(7,he.length-1);for(let Le=Te+1;Le<re;Le++){const Be=Oe(he,Le);if(Be){const We=Ee(Be,Be.toLowerCase(),Te,ze,U,M,j);We&&(We[0]-=3,(!ee||We[0]>ee[0])&&(ee=We))}}}return ee}function Oe(he,ke){if(ke+1>=he.length)return;const Te=he[ke],ze=he[ke+1];if(Te!==ze)return he.slice(0,ke)+ze+Te+he.slice(ke+2)}}),define(Ie[33],Pe([1,0,13]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(L||(L={})),function(T){const O="error",A="warning",E="warn",v="info",_="ignore";function N(h){return h?I.equalsIgnoreCase(O,h)?T.Error:I.equalsIgnoreCase(A,h)||I.equalsIgnoreCase(E,h)?T.Warning:I.equalsIgnoreCase(v,h)?T.Info:T.Ignore:T.Ignore}T.fromValue=N;function y(h){switch(h){case T.Error:return O;case T.Warning:return A;case T.Info:return v;default:return _}}T.toString=y}(L||(L={})),e.default=L}),define(Ie[136],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ie[54],Pe([1,0,18,13]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class T{constructor(){this._value="",this._pos=0}reset(b){return this._value=b,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(b){const m=b.charCodeAt(0),r=this._value.charCodeAt(this._pos);return m-r}value(){return this._value[this._pos]}}e.StringIterator=T;class O{constructor(b=!0){this._caseSensitive=b}reset(b){return this._value=b,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let b=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(b)this._from++;else break;else b=!1;return this}cmp(b){return this._caseSensitive?(0,L.compareSubstring)(b,this._value,0,b.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(b,this._value,0,b.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=O;class A{constructor(b=!0,m=!0){this._splitOnBackslash=b,this._caseSensitive=m}reset(b){this._from=0,this._to=0,this._value=b,this._valueLen=b.length;for(let m=b.length-1;m>=0;m--,this._valueLen--){const r=this._value.charCodeAt(m);if(!(r===47||this._splitOnBackslash&&r===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let b=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(b)this._from++;else break;else b=!1}return this}cmp(b){return this._caseSensitive?(0,L.compareSubstring)(b,this._value,0,b.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(b,this._value,0,b.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=A;var E;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(E||(E={}));class v{constructor(b,m){this._ignorePathCasing=b,this._ignoreQueryAndFragment=m,this._states=[],this._stateIdx=0}reset(b){return this._value=b,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new A(!1,!this._ignorePathCasing(b)),this._pathIterator.reset(b.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(b)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(b){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(b,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(b,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(b);if(this._states[this._stateIdx]===4)return(0,L.compare)(b,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(b,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=v;class _{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(N||(N={}));class y{static forUris(b=()=>!1,m=()=>!1){return new y(new v(b,m))}static forPaths(b=!1){return new y(new A(void 0,!b))}static forStrings(){return new y(new T)}static forConfigKeys(){return new y(new O)}constructor(b){this._iter=b}clear(){this._root=void 0}fill(b,m){if(m){const r=m.slice(0);(0,I.shuffle)(r);for(const o of r)this.set(o,b)}else{const r=b.slice(0);(0,I.shuffle)(r);for(const o of r)this.set(o[0],o[1])}}set(b,m){const r=this._iter.reset(b);let o;this._root||(this._root=new _,this._root.segment=r.value());const s=[];for(o=this._root;;){const n=r.cmp(o.segment);if(n>0)o.left||(o.left=new _,o.left.segment=r.value()),s.push([-1,o]),o=o.left;else if(n<0)o.right||(o.right=new _,o.right.segment=r.value()),s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new _,o.mid.segment=r.value()),s.push([0,o]),o=o.mid;else break}const i=o.value;o.value=m,o.key=b;for(let n=s.length-1;n>=0;n--){const c=s[n][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const t=s[n][0],f=s[n+1][0];if(t===1&&f===1)s[n][1]=c.rotateLeft();else if(t===-1&&f===-1)s[n][1]=c.rotateRight();else if(t===1&&f===-1)c.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=c.rotateLeft();else if(t===-1&&f===1)c.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this._root=s[0][1]}}return i}get(b){return this._getNode(b)?.value}_getNode(b){const m=this._iter.reset(b);let r=this._root;for(;r;){const o=m.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(m.hasNext())m.next(),r=r.mid;else break}return r}has(b){const m=this._getNode(b);return!(m?.value===void 0&&m?.mid===void 0)}delete(b){return this._delete(b,!1)}deleteSuperstr(b){return this._delete(b,!0)}_delete(b,m){const r=this._iter.reset(b),o=[];let s=this._root;for(;s;){const i=r.cmp(s.segment);if(i>0)o.push([-1,s]),s=s.left;else if(i<0)o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),o.push([0,s]),s=s.mid;else break}if(s){if(m?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this._min(s.right);if(i.key){const{key:n,value:c,segment:u}=i;this._delete(i.key,!1),s.key=n,s.value=c,s.segment=u}}else{const i=s.left??s.right;if(o.length>0){const[n,c]=o[o.length-1];switch(n){case-1:c.left=i;break;case 0:c.mid=i;break;case 1:c.right=i;break}}else this._root=i}for(let i=o.length-1;i>=0;i--){const n=o[i][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),o[i][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),o[i][1]=n.rotateRight()),i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this._root=o[0][1]}}}_min(b){for(;b.left;)b=b.left;return b}findSubstr(b){const m=this._iter.reset(b);let r=this._root,o;for(;r;){const s=m.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(m.hasNext())m.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(b){return this._findSuperstrOrElement(b,!1)}_findSuperstrOrElement(b,m){const r=this._iter.reset(b);let o=this._root;for(;o;){const s=r.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):m?o.value:void 0}}hasElementOrSubtree(b){return this._findSuperstrOrElement(b,!0)!==void 0}forEach(b){for(const[m,r]of this)b(r,m)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(b){const m=[];return this._dfsEntries(b,m),m[Symbol.iterator]()}_dfsEntries(b,m){b&&(b.left&&this._dfsEntries(b.left,m),b.value&&m.push([b.key,b.value]),b.mid&&this._dfsEntries(b.mid,m),b.right&&this._dfsEntries(b.right,m))}_isBalanced(){const b=m=>{if(!m)return!0;const r=m.balanceFactor();return r<-1||r>1?!1:b(m.left)&&b(m.right)};return b(this._root)}}e.TernarySearchTree=y}),define(Ie[36],Pe([1,0,92]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=T;var L;(function(A){function E(v){return v&&typeof v=="object"&&typeof v.id=="string"}A.isThemeColor=E})(L||(e.ThemeColor=L={}));function T(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function v(i){const n=E.exec(i.id);if(!n)return v(I.Codicon.error);const[,c,u]=n,t=["codicon","codicon-"+c];return u&&t.push("codicon-modifier-"+u.substring(1)),t}A.asClassNameArray=v;function _(i){return v(i).join(" ")}A.asClassName=_;function N(i){return"."+v(i).join(".")}A.asCSSSelector=N;function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||L.isThemeColor(i.color))}A.isThemeIcon=y;const h=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(i){const n=h.exec(i);if(!n)return;const[,c]=n;return{id:c}}A.fromString=b;function m(i){return{id:i}}A.fromId=m;function r(i,n){let c=i.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),n&&(c=`${c}~${n}`),{id:c}}A.modify=r;function o(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}A.getModifier=o;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}A.isEqual=s})(O||(e.ThemeIcon=O={}))}),define(Ie[137],Pe([1,0,135,13,36]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=v,e.markdownEscapeEscapedIcons=N,e.stripIcons=h,e.getCodiconAriaLabel=b,e.parseLabelWithIcons=r,e.matchesFuzzyIconAware=o;const O="$(",A=new RegExp(`\\$\\(${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?\\)`,"g"),E=new RegExp(`(\\\\)?${A.source}`,"g");function v(s){return s.replace(E,(i,n)=>n?i:`\\${i}`)}const _=new RegExp(`\\\\${A.source}`,"g");function N(s){return s.replace(_,i=>`\\${i}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function h(s){return s.indexOf(O)===-1?s:s.replace(y,(i,n,c,u)=>c?i:n||u||"")}function b(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const m=new RegExp(`\\$\\(${T.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){m.lastIndex=0;let i="";const n=[];let c=0;for(;;){const u=m.lastIndex,t=m.exec(s),f=s.substring(u,t?.index);if(f.length>0){i+=f;for(let a=0;a<f.length;a++)n.push(c)}if(!t)break;c+=t[0].length}return{text:i,iconOffsets:n}}function o(s,i,n=!1){const{text:c,iconOffsets:u}=i;if(!u||u.length===0)return(0,I.matchesFuzzy)(s,c,n);const t=(0,L.ltrim)(c," "),f=c.length-t.length,a=(0,I.matchesFuzzy)(s,t,n);if(a)for(const p of a){const l=u[p.start+f]+f;p.start+=l,p.end+=l}return a}}),define(Ie[34],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=L;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(T){return I.test(T)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(E){for(let v=0;v<E.length;v++)E[v]=Math.floor(Math.random()*256);return E};const O=new Uint8Array(16),A=[];for(let E=0;E<256;E++)A.push(E.toString(16).padStart(2,"0"));return function(){T(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let v=0,_="";return _+=A[O[v++]],_+=A[O[v++]],_+=A[O[v++]],_+=A[O[v++]],_+="-",_+=A[O[v++]],_+=A[O[v++]],_+="-",_+=A[O[v++]],_+=A[O[v++]],_+="-",_+=A[O[v++]],_+=A[O[v++]],_+="-",_+=A[O[v++]],_+=A[O[v++]],_+=A[O[v++]],_+=A[O[v++]],_+=A[O[v++]],_+=A[O[v++]],_}}()}),define(Ie[138],Pe([1,0,18,42,34]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=O,e.createFileDataTransferItem=A,e.matchesMimeType=_;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,h,b){const m={id:(0,T.generateUuid)(),name:y,uri:h,data:b};return{asString:async()=>"",asFile:()=>m,value:void 0}}class E{constructor(){this._entries=new Map}get size(){let h=0;for(const b of this._entries)h++;return h}has(h){return this._entries.has(this.toKey(h))}matches(h){const b=[...this._entries.keys()];return L.Iterable.some(this,([m,r])=>r.asFile())&&b.push("files"),N(v(h),b)}get(h){return this._entries.get(this.toKey(h))?.[0]}append(h,b){const m=this._entries.get(h);m?m.push(b):this._entries.set(this.toKey(h),[b])}replace(h,b){this._entries.set(this.toKey(h),[b])}delete(h){this._entries.delete(this.toKey(h))}*[Symbol.iterator](){for(const[h,b]of this._entries)for(const m of b)yield[h,m]}toKey(h){return v(h)}}e.VSDataTransfer=E;function v(y){return y.toLowerCase()}function _(y,h){return N(v(y),h.map(v))}function N(y,h){if(y==="*/*")return h.length>0;if(h.includes(y))return!0;const b=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[m,r,o]=b;return o==="*"?h.some(s=>s.startsWith(r+"/")):!1}e.UriList=Object.freeze({create:y=>(0,I.distinct)(y.map(h=>h.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.UriList.split(y).filter(h=>!h.startsWith("#"))})}),define(Ie[139],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=L;var I;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function L(T){let O=0,A=0,E=0,v=0;for(let _=0,N=T.length;_<N;_++){const y=T.charCodeAt(_);y===13?(O===0&&(A=_),O++,_+1<N&&T.charCodeAt(_+1)===10?(v|=2,_++):v|=3,E=_+1):y===10&&(v|=1,O===0&&(A=_),O++,E=_+1)}return O===0&&(A=T.length),[O,A,T.length-E,v]}}),define(Ie[140],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[141],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var I;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class L{constructor(E){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=E.open,this.close=E.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(E.notIn))for(let v=0,_=E.notIn.length;v<_;v++)switch(E.notIn[v]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(E){switch(E){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(E,v){if(E.getTokenCount()===0)return!0;const _=E.findTokenIndexAtOffset(v-2),N=E.getStandardTokenType(_);return this.isOK(N)}_findNeutralCharacterInRange(E,v){for(let _=E;_<=v;_++){const N=String.fromCharCode(_);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=L;class T{constructor(E){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const v of E)O(this.autoClosingPairsOpenByStart,v.open.charAt(0),v),O(this.autoClosingPairsOpenByEnd,v.open.charAt(v.open.length-1),v),O(this.autoClosingPairsCloseByStart,v.close.charAt(0),v),O(this.autoClosingPairsCloseByEnd,v.close.charAt(v.close.length-1),v),v.close.length===1&&v.open.length===1&&O(this.autoClosingPairsCloseSingleChar,v.close,v)}}e.AutoClosingPairs=T;function O(A,E,v){A.has(E)?A.get(E).push(v):A.set(E,[v])}}),define(Ie[142],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=T,e.righttest=O,e.leftRotate=_,e.rightRotate=N,e.rbDelete=y,e.fixInsert=h,e.updateTreeMetadata=b,e.recomputeTreeMetadata=m;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return T(this.right);let o=this;for(;o.parent!==e.SENTINEL&&o.parent.left!==o;)o=o.parent;return o.parent===e.SENTINEL?e.SENTINEL:o.parent}prev(){if(this.left!==e.SENTINEL)return O(this.left);let o=this;for(;o.parent!==e.SENTINEL&&o.parent.right!==o;)o=o.parent;return o.parent===e.SENTINEL?e.SENTINEL:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=I;var L;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(L||(e.NodeColor=L={})),e.SENTINEL=new I(null,0),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=0;function T(r){for(;r.left!==e.SENTINEL;)r=r.left;return r}function O(r){for(;r.right!==e.SENTINEL;)r=r.right;return r}function A(r){return r===e.SENTINEL?0:r.size_left+r.piece.length+A(r.right)}function E(r){return r===e.SENTINEL?0:r.lf_left+r.piece.lineFeedCnt+E(r.right)}function v(){e.SENTINEL.parent=e.SENTINEL}function _(r,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.SENTINEL&&(s.left.parent=o),s.parent=o.parent,o.parent===e.SENTINEL?r.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function N(r,o){const s=o.left;o.left=s.right,s.right!==e.SENTINEL&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.SENTINEL?r.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function y(r,o){let s,i;if(o.left===e.SENTINEL?(i=o,s=i.right):o.right===e.SENTINEL?(i=o,s=i.left):(i=T(o.right),s=i.right),i===r.root){r.root=s,s.color=0,o.detach(),v(),r.root.parent=e.SENTINEL;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===o?(s.parent=i.parent,m(r,s)):(i.parent===o?s.parent=i:s.parent=i.parent,m(r,s),i.left=o.left,i.right=o.right,i.parent=o.parent,i.color=o.color,o===r.root?r.root=i:o===o.parent.left?o.parent.left=i:o.parent.right=i,i.left!==e.SENTINEL&&(i.left.parent=i),i.right!==e.SENTINEL&&(i.right.parent=i),i.size_left=o.size_left,i.lf_left=o.lf_left,m(r,i)),o.detach(),s.parent.left===s){const u=A(s),t=E(s);if(u!==s.parent.size_left||t!==s.parent.lf_left){const f=u-s.parent.size_left,a=t-s.parent.lf_left;s.parent.size_left=u,s.parent.lf_left=t,b(r,s.parent,f,a)}}if(m(r,s.parent),n){v();return}let c;for(;s!==r.root&&s.color===0;)s===s.parent.left?(c=s.parent.right,c.color===1&&(c.color=0,s.parent.color=1,_(r,s.parent),c=s.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.right.color===0&&(c.left.color=0,c.color=1,N(r,c),c=s.parent.right),c.color=s.parent.color,s.parent.color=0,c.right.color=0,_(r,s.parent),s=r.root)):(c=s.parent.left,c.color===1&&(c.color=0,s.parent.color=1,N(r,s.parent),c=s.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.left.color===0&&(c.right.color=0,c.color=1,_(r,c),c=s.parent.left),c.color=s.parent.color,s.parent.color=0,c.left.color=0,N(r,s.parent),s=r.root));s.color=0,v()}function h(r,o){for(m(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,_(r,o)),o.parent.color=0,o.parent.parent.color=1,N(r,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,N(r,o)),o.parent.color=0,o.parent.parent.color=1,_(r,o.parent.parent))}r.root.color=0}function b(r,o,s,i){for(;o!==r.root&&o!==e.SENTINEL;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=i),o=o.parent}function m(r,o){let s=0,i=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,s=A(o.left)-o.size_left,i=E(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=i;o!==r.root&&(s!==0||i!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=i),o=o.parent}}}),define(Ie[93],Pe([1,0,94,30,95,142,96]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=N,e.createLineStarts=y;const E=65535;function v(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class _{constructor(i,n,c,u,t){this.lineStarts=i,this.cr=n,this.lf=c,this.crlf=u,this.isBasicASCII=t}}function N(s,i=!0){const n=[0];let c=1;for(let u=0,t=s.length;u<t;u++){const f=s.charCodeAt(u);f===13?u+1<t&&s.charCodeAt(u+1)===10?(n[c++]=u+2,u++):n[c++]=u+1:f===10&&(n[c++]=u+1)}return i?v(n):n}function y(s,i){s.length=0,s[0]=0;let n=1,c=0,u=0,t=0,f=!0;for(let p=0,l=i.length;p<l;p++){const D=i.charCodeAt(p);D===13?p+1<l&&i.charCodeAt(p+1)===10?(t++,s[n++]=p+2,p++):(c++,s[n++]=p+1):D===10?(u++,s[n++]=p+1):f&&D!==9&&(D<32||D>126)&&(f=!1)}const a=new _(v(s),c,u,t,f);return s.length=0,a}class h{constructor(i,n,c,u,t){this.bufferIndex=i,this.start=n,this.end=c,this.lineFeedCnt=u,this.length=t}}e.Piece=h;class b{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.StringBuffer=b;class m{constructor(i,n){this._pieces=[],this._tree=i,this._BOM=n,this._index=0,i.root!==O.SENTINEL&&i.iterate(i.root,c=>(c!==O.SENTINEL&&this._pieces.push(c.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class r{constructor(i){this._limit=i,this._cache=[]}get(i){for(let n=this._cache.length-1;n>=0;n--){const c=this._cache[n];if(c.nodeStartOffset<=i&&c.nodeStartOffset+c.node.piece.length>=i)return c}return null}get2(i){for(let n=this._cache.length-1;n>=0;n--){const c=this._cache[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<i&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=i)return c}return null}set(i){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(i)}validate(i){let n=!1;const c=this._cache;for(let u=0;u<c.length;u++){const t=c[u];if(t.node.parent===null||t.nodeStartOffset>=i){c[u]=null,n=!0;continue}}if(n){const u=[];for(const t of c)t!==null&&u.push(t);this._cache=u}}}class o{constructor(i,n,c){this.create(i,n,c)}create(i,n,c){this._buffers=[new b("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=O.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=n,this._EOLLength=n.length,this._EOLNormalized=c;let u=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=N(i[t].buffer));const a=new h(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this._buffers.push(i[t]),u=this.rbInsertRight(u,a)}this._searchCache=new r(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(i){const n=E,c=n-Math.floor(n/3),u=c*2;let t="",f=0;const a=[];if(this.iterate(this.root,p=>{const l=this.getNodeContent(p),D=l.length;if(f<=c||f+D<u)return t+=l,f+=D,!0;const d=t.replace(/\r\n|\r|\n/g,i);return a.push(new b(d,N(d))),t=l,f=D,!0}),f>0){const p=t.replace(/\r\n|\r|\n/g,i);a.push(new b(p,N(p)))}this.create(a,i,!0)}getEOL(){return this._EOL}setEOL(i){this._EOL=i,this._EOLLength=this._EOL.length,this.normalizeEOL(i)}createSnapshot(i){return new m(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,u=>{if(u===O.SENTINEL)return!0;const t=this.getNodeContent(u),f=t.length,a=i.nodeAt(n),p=i.nodeAt(n+f),l=i.getValueInRange2(a,p);return n+=f,t===l})}getOffsetAt(i,n){let c=0,u=this.root;for(;u!==O.SENTINEL;)if(u.left!==O.SENTINEL&&u.lf_left+1>=i)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=i){c+=u.size_left;const t=this.getAccumulatedValue(u,i-u.lf_left-2);return c+=t+n-1}else i-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right;return c}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,c=0;const u=i;for(;n!==O.SENTINEL;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.getIndexOf(n,i-n.size_left);if(c+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(c+1,1),a=u-f;return new I.Position(c+1,a+1)}return new I.Position(c+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===O.SENTINEL){const t=this.getOffsetAt(c+1,1),f=u-i-t;return new I.Position(c+1,f+1)}else n=n.right;return new I.Position(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const c=this.nodeAt2(i.startLineNumber,i.startColumn),u=this.nodeAt2(i.endLineNumber,i.endColumn),t=this.getValueInRange2(c,u);return n?n!==this._EOL||!this._EOLNormalized?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this._EOLNormalized?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const a=i.node,p=this._buffers[a.piece.bufferIndex].buffer,l=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);return p.substring(l+i.remainder,l+n.remainder)}let c=i.node;const u=this._buffers[c.piece.bufferIndex].buffer,t=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);let f=u.substring(t+i.remainder,t+c.piece.length);for(c=c.next();c!==O.SENTINEL;){const a=this._buffers[c.piece.bufferIndex].buffer,p=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);if(c===n.node){f+=a.substring(p,p+n.remainder);break}else f+=a.substr(p,c.piece.length);c=c.next()}return f}getLinesContent(){const i=[];let n=0,c="",u=!1;return this.iterate(this.root,t=>{if(t===O.SENTINEL)return!0;const f=t.piece;let a=f.length;if(a===0)return!0;const p=this._buffers[f.bufferIndex].buffer,l=this._buffers[f.bufferIndex].lineStarts,D=f.start.line,d=f.end.line;let w=l[D]+f.start.column;if(u&&(p.charCodeAt(w)===10&&(w++,a--),i[n++]=c,c="",u=!1,a===0))return!0;if(D===d)return!this._EOLNormalized&&p.charCodeAt(w+a-1)===13?(u=!0,c+=p.substr(w,a-1)):c+=p.substr(w,a),!0;c+=this._EOLNormalized?p.substring(w,Math.max(w,l[D+1]-this._EOLLength)):p.substring(w,l[D+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;for(let g=D+1;g<d;g++)c=this._EOLNormalized?p.substring(l[g],l[g+1]-this._EOLLength):p.substring(l[g],l[g+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;return!this._EOLNormalized&&p.charCodeAt(l[d]+f.end.column-1)===13?(u=!0,f.end.column===0?n--:c=p.substr(l[d],f.end.column-1)):c=p.substr(l[d],f.end.column),!0}),u&&(i[n++]=c,c=""),i[n++]=c,i}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(i){return this._lastVisitedLine.lineNumber===i?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=i,i===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(i):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(i,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const c=this._buffers[n.piece.bufferIndex],u=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(u)}else{const n=this._buffers[i.node.piece.bufferIndex],u=this.offsetInBuffer(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(u)}}getLineCharCode(i,n){const c=this.nodeAt2(i,n+1);return this._getCharCode(c)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this._EOLLength}getCharCode(i){const n=this.nodeAt(i);return this._getCharCode(n)}findMatchesInNode(i,n,c,u,t,f,a,p,l,D,d){const w=this._buffers[i.piece.bufferIndex],g=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start),C=this.offsetInBuffer(i.piece.bufferIndex,t),S=this.offsetInBuffer(i.piece.bufferIndex,f);let k;const P={line:0,column:0};let H,$;n._wordSeparators?(H=w.buffer.substring(C,S),$=V=>V+C,n.reset(0)):(H=w.buffer,$=V=>V,n.reset(C));do if(k=n.next(H),k){if($(k.index)>=S)return D;this.positionInBuffer(i,$(k.index)-g,P);const V=this.getLineFeedCnt(i.piece.bufferIndex,t,P),R=P.line===t.line?P.column-t.column+u:P.column+1,z=R+k[0].length;if(d[D++]=(0,A.createFindMatch)(new L.Range(c+V,R,c+V,z),k,p),$(k.index)+k[0].length>=S||D>=l)return D}while(k);return D}findMatchesLineByLine(i,n,c,u){const t=[];let f=0;const a=new A.Searcher(n.wordSeparators,n.regex);let p=this.nodeAt2(i.startLineNumber,i.startColumn);if(p===null)return[];const l=this.nodeAt2(i.endLineNumber,i.endColumn);if(l===null)return[];let D=this.positionInBuffer(p.node,p.remainder);const d=this.positionInBuffer(l.node,l.remainder);if(p.node===l.node)return this.findMatchesInNode(p.node,a,i.startLineNumber,i.startColumn,D,d,n,c,u,f,t),t;let w=i.startLineNumber,g=p.node;for(;g!==l.node;){const S=this.getLineFeedCnt(g.piece.bufferIndex,D,g.piece.end);if(S>=1){const P=this._buffers[g.piece.bufferIndex].lineStarts,H=this.offsetInBuffer(g.piece.bufferIndex,g.piece.start),$=P[D.line+S],V=w===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(g,a,w,V,D,this.positionInBuffer(g,$-H),n,c,u,f,t),f>=u)return t;w+=S}const k=w===i.startLineNumber?i.startColumn-1:0;if(w===i.endLineNumber){const P=this.getLineContent(w).substring(k,i.endColumn-1);return f=this._findMatchesInLine(n,a,P,i.endLineNumber,k,f,t,c,u),t}if(f=this._findMatchesInLine(n,a,this.getLineContent(w).substr(k),w,k,f,t,c,u),f>=u)return t;w++,p=this.nodeAt2(w,1),g=p.node,D=this.positionInBuffer(p.node,p.remainder)}if(w===i.endLineNumber){const S=w===i.startLineNumber?i.startColumn-1:0,k=this.getLineContent(w).substring(S,i.endColumn-1);return f=this._findMatchesInLine(n,a,k,i.endLineNumber,S,f,t,c,u),t}const C=w===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(l.node,a,w,C,D,d,n,c,u,f,t),t}_findMatchesInLine(i,n,c,u,t,f,a,p,l){const D=i.wordSeparators;if(!p&&i.simpleSearch){const w=i.simpleSearch,g=w.length,C=c.length;let S=-g;for(;(S=c.indexOf(w,S+g))!==-1;)if((!D||(0,A.isValidMatch)(D,c,C,S,g))&&(a[f++]=new T.FindMatch(new L.Range(u,S+1+t,u,S+1+g+t),null),f>=l))return f;return f}let d;n.reset(0);do if(d=n.next(c),d&&(a[f++]=(0,A.createFindMatch)(new L.Range(u,d.index+1+t,u,d.index+1+d[0].length+t),d,p),f>=l))return f;while(d);return f}insert(i,n,c=!1){if(this._EOLNormalized=this._EOLNormalized&&c,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==O.SENTINEL){const{node:u,remainder:t,nodeStartOffset:f}=this.nodeAt(i),a=u.piece,p=a.bufferIndex,l=this.positionInBuffer(u,t);if(u.piece.bufferIndex===0&&a.end.line===this._lastChangeBufferPos.line&&a.end.column===this._lastChangeBufferPos.column&&f+a.length===i&&n.length<E){this.appendToNode(u,n),this.computeBufferMetadata();return}if(f===i)this.insertContentToNodeLeft(n,u),this._searchCache.validate(i);else if(f+u.piece.length>i){const D=[];let d=new h(a.bufferIndex,l,a.end,this.getLineFeedCnt(a.bufferIndex,l,a.end),this.offsetInBuffer(p,a.end)-this.offsetInBuffer(p,l));if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.nodeCharCodeAt(u,t)===10){const S={line:d.start.line+1,column:0};d=new h(d.bufferIndex,S,d.end,this.getLineFeedCnt(d.bufferIndex,S,d.end),d.length-1),n+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(n))if(this.nodeCharCodeAt(u,t-1)===13){const S=this.positionInBuffer(u,t-1);this.deleteNodeTail(u,S),n="\r"+n,u.piece.length===0&&D.push(u)}else this.deleteNodeTail(u,l);else this.deleteNodeTail(u,l);const w=this.createNewPieces(n);d.length>0&&this.rbInsertRight(u,d);let g=u;for(let C=0;C<w.length;C++)g=this.rbInsertRight(g,w[C]);this.deleteNodes(D)}else this.insertContentToNodeRight(n,u)}else{const u=this.createNewPieces(n);let t=this.rbInsertLeft(null,u[0]);for(let f=1;f<u.length;f++)t=this.rbInsertRight(t,u[f])}this.computeBufferMetadata()}delete(i,n){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",n<=0||this.root===O.SENTINEL)return;const c=this.nodeAt(i),u=this.nodeAt(i+n),t=c.node,f=u.node;if(t===f){const w=this.positionInBuffer(t,c.remainder),g=this.positionInBuffer(t,u.remainder);if(c.nodeStartOffset===i){if(n===t.piece.length){const C=t.next();(0,O.rbDelete)(this,t),this.validateCRLFWithPrevNode(C),this.computeBufferMetadata();return}this.deleteNodeHead(t,g),this._searchCache.validate(i),this.validateCRLFWithPrevNode(t),this.computeBufferMetadata();return}if(c.nodeStartOffset+t.piece.length===i+n){this.deleteNodeTail(t,w),this.validateCRLFWithNextNode(t),this.computeBufferMetadata();return}this.shrinkNode(t,w,g),this.computeBufferMetadata();return}const a=[],p=this.positionInBuffer(t,c.remainder);this.deleteNodeTail(t,p),this._searchCache.validate(i),t.piece.length===0&&a.push(t);const l=this.positionInBuffer(f,u.remainder);this.deleteNodeHead(f,l),f.piece.length===0&&a.push(f);const D=t.next();for(let w=D;w!==O.SENTINEL&&w!==f;w=w.next())a.push(w);const d=t.piece.length===0?t.prev():t;this.deleteNodes(a),this.validateCRLFWithNextNode(d),this.computeBufferMetadata()}insertContentToNodeLeft(i,n){const c=[];if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.startWithLF(n)){const f=n.piece,a={line:f.start.line+1,column:0},p=new h(f.bufferIndex,a,f.end,this.getLineFeedCnt(f.bufferIndex,a,f.end),f.length-1);n.piece=p,i+=`
`,(0,O.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const u=this.createNewPieces(i);let t=this.rbInsertLeft(n,u[u.length-1]);for(let f=u.length-2;f>=0;f--)t=this.rbInsertLeft(t,u[f]);this.validateCRLFWithPrevNode(t),this.deleteNodes(c)}insertContentToNodeRight(i,n){this.adjustCarriageReturnFromNext(i,n)&&(i+=`
`);const c=this.createNewPieces(i),u=this.rbInsertRight(n,c[0]);let t=u;for(let f=1;f<c.length;f++)t=this.rbInsertRight(t,c[f]);this.validateCRLFWithPrevNode(u)}positionInBuffer(i,n,c){const u=i.piece,t=i.piece.bufferIndex,f=this._buffers[t].lineStarts,p=f[u.start.line]+u.start.column+n;let l=u.start.line,D=u.end.line,d=0,w=0,g=0;for(;l<=D&&(d=l+(D-l)/2|0,g=f[d],d!==D);)if(w=f[d+1],p<g)D=d-1;else if(p>=w)l=d+1;else break;return c?(c.line=d,c.column=p-g,null):{line:d,column:p-g}}getLineFeedCnt(i,n,c){if(c.column===0)return c.line-n.line;const u=this._buffers[i].lineStarts;if(c.line===u.length-1)return c.line-n.line;const t=u[c.line+1],f=u[c.line]+c.column;if(t>f+1)return c.line-n.line;const a=f-1;return this._buffers[i].buffer.charCodeAt(a)===13?c.line-n.line+1:c.line-n.line}offsetInBuffer(i,n){return this._buffers[i].lineStarts[n.line]+n.column}deleteNodes(i){for(let n=0;n<i.length;n++)(0,O.rbDelete)(this,i[n])}createNewPieces(i){if(i.length>E){const D=[];for(;i.length>E;){const w=i.charCodeAt(E-1);let g;w===13||w>=55296&&w<=56319?(g=i.substring(0,E-1),i=i.substring(E-1)):(g=i.substring(0,E),i=i.substring(E));const C=N(g);D.push(new h(this._buffers.length,{line:0,column:0},{line:C.length-1,column:g.length-C[C.length-1]},C.length-1,g.length)),this._buffers.push(new b(g,C))}const d=N(i);return D.push(new h(this._buffers.length,{line:0,column:0},{line:d.length-1,column:i.length-d[d.length-1]},d.length-1,i.length)),this._buffers.push(new b(i,d)),D}let n=this._buffers[0].buffer.length;const c=N(i,!1);let u=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===n&&n!==0&&this.startWithLF(i)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},u=this._lastChangeBufferPos;for(let D=0;D<c.length;D++)c[D]+=n+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(c.slice(1)),this._buffers[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let D=0;D<c.length;D++)c[D]+=n;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(c.slice(1)),this._buffers[0].buffer+=i}const t=this._buffers[0].buffer.length,f=this._buffers[0].lineStarts.length-1,a=t-this._buffers[0].lineStarts[f],p={line:f,column:a},l=new h(0,u,p,this.getLineFeedCnt(0,u,p),t-n);return this._lastChangeBufferPos=p,[l]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(i,n=0){let c=this.root,u="";const t=this._searchCache.get2(i);if(t){c=t.node;const f=this.getAccumulatedValue(c,i-t.nodeStartLineNumber-1),a=this._buffers[c.piece.bufferIndex].buffer,p=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===i)u=a.substring(p+f,p+c.piece.length);else{const l=this.getAccumulatedValue(c,i-t.nodeStartLineNumber);return a.substring(p+f,p+l-n)}}else{let f=0;const a=i;for(;c!==O.SENTINEL;)if(c.left!==O.SENTINEL&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const p=this.getAccumulatedValue(c,i-c.lf_left-2),l=this.getAccumulatedValue(c,i-c.lf_left-1),D=this._buffers[c.piece.bufferIndex].buffer,d=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);return f+=c.size_left,this._searchCache.set({node:c,nodeStartOffset:f,nodeStartLineNumber:a-(i-1-c.lf_left)}),D.substring(d+p,d+l-n)}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const p=this.getAccumulatedValue(c,i-c.lf_left-2),l=this._buffers[c.piece.bufferIndex].buffer,D=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);u=l.substring(D+p,D+c.piece.length);break}else i-=c.lf_left+c.piece.lineFeedCnt,f+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==O.SENTINEL;){const f=this._buffers[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.getAccumulatedValue(c,0),p=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);return u+=f.substring(p,p+a-n),u}else{const a=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);u+=f.substr(a,c.piece.length)}c=c.next()}return u}computeBufferMetadata(){let i=this.root,n=1,c=0;for(;i!==O.SENTINEL;)n+=i.lf_left+i.piece.lineFeedCnt,c+=i.size_left+i.piece.length,i=i.right;this._lineCnt=n,this._length=c,this._searchCache.validate(this._length)}getIndexOf(i,n){const c=i.piece,u=this.positionInBuffer(i,n),t=u.line-c.start.line;if(this.offsetInBuffer(c.bufferIndex,c.end)-this.offsetInBuffer(c.bufferIndex,c.start)===n){const f=this.getLineFeedCnt(i.piece.bufferIndex,c.start,u);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:u.column}}getAccumulatedValue(i,n){if(n<0)return 0;const c=i.piece,u=this._buffers[c.bufferIndex].lineStarts,t=c.start.line+n+1;return t>c.end.line?u[c.end.line]+c.end.column-u[c.start.line]-c.start.column:u[t]-u[c.start.line]-c.start.column}deleteNodeTail(i,n){const c=i.piece,u=c.lineFeedCnt,t=this.offsetInBuffer(c.bufferIndex,c.end),f=n,a=this.offsetInBuffer(c.bufferIndex,f),p=this.getLineFeedCnt(c.bufferIndex,c.start,f),l=p-u,D=a-t,d=c.length+D;i.piece=new h(c.bufferIndex,c.start,f,p,d),(0,O.updateTreeMetadata)(this,i,D,l)}deleteNodeHead(i,n){const c=i.piece,u=c.lineFeedCnt,t=this.offsetInBuffer(c.bufferIndex,c.start),f=n,a=this.getLineFeedCnt(c.bufferIndex,f,c.end),p=this.offsetInBuffer(c.bufferIndex,f),l=a-u,D=t-p,d=c.length+D;i.piece=new h(c.bufferIndex,f,c.end,a,d),(0,O.updateTreeMetadata)(this,i,D,l)}shrinkNode(i,n,c){const u=i.piece,t=u.start,f=u.end,a=u.length,p=u.lineFeedCnt,l=n,D=this.getLineFeedCnt(u.bufferIndex,u.start,l),d=this.offsetInBuffer(u.bufferIndex,n)-this.offsetInBuffer(u.bufferIndex,t);i.piece=new h(u.bufferIndex,u.start,l,D,d),(0,O.updateTreeMetadata)(this,i,d-a,D-p);const w=new h(u.bufferIndex,c,f,this.getLineFeedCnt(u.bufferIndex,c,f),this.offsetInBuffer(u.bufferIndex,f)-this.offsetInBuffer(u.bufferIndex,c)),g=this.rbInsertRight(i,w);this.validateCRLFWithPrevNode(g)}appendToNode(i,n){this.adjustCarriageReturnFromNext(n,i)&&(n+=`
`);const c=this.shouldCheckCRLF()&&this.startWithLF(n)&&this.endWithCR(i),u=this._buffers[0].buffer.length;this._buffers[0].buffer+=n;const t=N(n,!1);for(let g=0;g<t.length;g++)t[g]+=u;if(c){const g=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:u-g}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1));const f=this._buffers[0].lineStarts.length-1,a=this._buffers[0].buffer.length-this._buffers[0].lineStarts[f],p={line:f,column:a},l=i.piece.length+n.length,D=i.piece.lineFeedCnt,d=this.getLineFeedCnt(0,i.piece.start,p),w=d-D;i.piece=new h(i.piece.bufferIndex,i.piece.start,p,d,l),this._lastChangeBufferPos=p,(0,O.updateTreeMetadata)(this,i,n.length,w)}nodeAt(i){let n=this.root;const c=this._searchCache.get(i);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:i-c.nodeStartOffset};let u=0;for(;n!==O.SENTINEL;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){u+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:u};return this._searchCache.set(t),t}else i-=n.size_left+n.piece.length,u+=n.size_left+n.piece.length,n=n.right;return null}nodeAt2(i,n){let c=this.root,u=0;for(;c!==O.SENTINEL;)if(c.left!==O.SENTINEL&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const t=this.getAccumulatedValue(c,i-c.lf_left-2),f=this.getAccumulatedValue(c,i-c.lf_left-1);return u+=c.size_left,{node:c,remainder:Math.min(t+n-1,f),nodeStartOffset:u}}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const t=this.getAccumulatedValue(c,i-c.lf_left-2);if(t+n-1<=c.piece.length)return{node:c,remainder:t+n-1,nodeStartOffset:u};n-=c.piece.length-t;break}else i-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==O.SENTINEL;){if(c.piece.lineFeedCnt>0){const t=this.getAccumulatedValue(c,0),f=this.offsetOfNode(c);return{node:c,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(c.piece.length>=n-1){const t=this.offsetOfNode(c);return{node:c,remainder:n-1,nodeStartOffset:t}}else n-=c.piece.length;c=c.next()}return null}nodeCharCodeAt(i,n){if(i.piece.lineFeedCnt<1)return-1;const c=this._buffers[i.piece.bufferIndex],u=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start)+n;return c.buffer.charCodeAt(u)}offsetOfNode(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===O.SENTINEL||i.piece.lineFeedCnt===0)return!1;const n=i.piece,c=this._buffers[n.bufferIndex].lineStarts,u=n.start.line,t=c[u]+n.start.column;return u===c.length-1||c[u+1]>t+1?!1:this._buffers[n.bufferIndex].buffer.charCodeAt(t)===10}endWithCR(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===O.SENTINEL||i.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(i,i.piece.length-1)===13}validateCRLFWithPrevNode(i){if(this.shouldCheckCRLF()&&this.startWithLF(i)){const n=i.prev();this.endWithCR(n)&&this.fixCRLF(n,i)}}validateCRLFWithNextNode(i){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const n=i.next();this.startWithLF(n)&&this.fixCRLF(i,n)}}fixCRLF(i,n){const c=[],u=this._buffers[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:u[i.piece.end.line]-u[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,a=i.piece.lineFeedCnt-1;i.piece=new h(i.piece.bufferIndex,i.piece.start,t,a,f),(0,O.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&c.push(i);const p={line:n.piece.start.line+1,column:0},l=n.piece.length-1,D=this.getLineFeedCnt(n.piece.bufferIndex,p,n.piece.end);n.piece=new h(n.piece.bufferIndex,p,n.piece.end,D,l),(0,O.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&c.push(n);const d=this.createNewPieces(`\r
`);this.rbInsertRight(i,d[0]);for(let w=0;w<c.length;w++)(0,O.rbDelete)(this,c[w])}adjustCarriageReturnFromNext(i,n){if(this.shouldCheckCRLF()&&this.endWithCR(i)){const c=n.next();if(this.startWithLF(c)){if(i+=`
`,c.piece.length===1)(0,O.rbDelete)(this,c);else{const u=c.piece,t={line:u.start.line+1,column:0},f=u.length-1,a=this.getLineFeedCnt(u.bufferIndex,t,u.end);c.piece=new h(u.bufferIndex,t,u.end,a,f),(0,O.updateTreeMetadata)(this,c,-1,-1)}return!0}}return!1}iterate(i,n){if(i===O.SENTINEL)return n(O.SENTINEL);const c=this.iterate(i.left,n);return c&&n(i)&&this.iterate(i.right,n)}getNodeContent(i){if(i===O.SENTINEL)return"";const n=this._buffers[i.piece.bufferIndex],c=i.piece,u=this.offsetInBuffer(c.bufferIndex,c.start),t=this.offsetInBuffer(c.bufferIndex,c.end);return n.buffer.substring(u,t)}getPieceContent(i){const n=this._buffers[i.bufferIndex],c=this.offsetInBuffer(i.bufferIndex,i.start),u=this.offsetInBuffer(i.bufferIndex,i.end);return n.buffer.substring(c,u)}rbInsertRight(i,n){const c=new O.TreeNode(n,1);if(c.left=O.SENTINEL,c.right=O.SENTINEL,c.parent=O.SENTINEL,c.size_left=0,c.lf_left=0,this.root===O.SENTINEL)this.root=c,c.color=0;else if(i.right===O.SENTINEL)i.right=c,c.parent=i;else{const t=(0,O.leftest)(i.right);t.left=c,c.parent=t}return(0,O.fixInsert)(this,c),c}rbInsertLeft(i,n){const c=new O.TreeNode(n,1);if(c.left=O.SENTINEL,c.right=O.SENTINEL,c.parent=O.SENTINEL,c.size_left=0,c.lf_left=0,this.root===O.SENTINEL)this.root=c,c.color=0;else if(i.left===O.SENTINEL)i.left=c,c.parent=i;else{const u=(0,O.righttest)(i.left);u.right=c,c.parent=u}return(0,O.fixInsert)(this,c),c}getContentOfSubTree(i){let n="";return this.iterate(i,c=>(n+=this.getNodeContent(c),!0)),n}}e.PieceTreeBase=o}),define(Ie[143],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(O){if(O&&this._dragOperations.has(O)){const A=this._dragOperations.get(O);return this._dragOperations.delete(O),A}}addDragOperationTransfer(O,A){this._dragOperations.set(O,A)}}e.TreeViewsDnDService=I;class L{constructor(O){this.identifier=O}}e.DraggedTreeItemsIdentifier=L}),define(Ie[144],Pe([9,10]),function(ue,e){return ue.create("vs/base/common/actions",e)}),define(Ie[145],Pe([1,0,5,6,144]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=N;class O extends L.Disposable{constructor(h,b="",m="",r=!0,o){super(),this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=h,this._label=b,this._cssClass=m,this._enabled=r,this._actionCallback=o}get id(){return this._id}get label(){return this._label}set label(h){this._setLabel(h)}_setLabel(h){this._label!==h&&(this._label=h,this._onDidChange.fire({label:h}))}get tooltip(){return this._tooltip||""}set tooltip(h){this._setTooltip(h)}_setTooltip(h){this._tooltip!==h&&(this._tooltip=h,this._onDidChange.fire({tooltip:h}))}get class(){return this._cssClass}set class(h){this._setClass(h)}_setClass(h){this._cssClass!==h&&(this._cssClass=h,this._onDidChange.fire({class:h}))}get enabled(){return this._enabled}set enabled(h){this._setEnabled(h)}_setEnabled(h){this._enabled!==h&&(this._enabled=h,this._onDidChange.fire({enabled:h}))}get checked(){return this._checked}set checked(h){this._setChecked(h)}_setChecked(h){this._checked!==h&&(this._checked=h,this._onDidChange.fire({checked:h}))}async run(h,b){this._actionCallback&&await this._actionCallback(h)}}e.Action=O;class A extends L.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new I.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new I.Emitter),this.onDidRun=this._onDidRun.event}async run(h,b){if(!h.enabled)return;this._onWillRun.fire({action:h});let m;try{await this.runAction(h,b)}catch(r){m=r}this._onDidRun.fire({action:h,error:m})}async runAction(h,b){await h.run(b)}}e.ActionRunner=A;class E{constructor(){this.id=E.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let b=[];for(const m of h)m.length&&(b.length?b=[...b,new E,...m]:b=m);return b}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=E;class v{get actions(){return this._actions}constructor(h,b,m,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=b,this.class=r,this._actions=m}async run(){}}e.SubmenuAction=v;class _ extends O{static{this.ID="vs.actions.empty"}constructor(){super(_.ID,T.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=_;function N(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...h)=>y.run(...h),tooltip:y.label}}}),define(Ie[146],Pe([9,10]),function(ue,e){return ue.create("vs/base/common/date",e)}),define(Ie[147],Pe([1,0,146]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=_,e.getDurationString=N,e.toLocalISOString=y;const L=60,T=L*60,O=T*24,A=O*7,E=O*30,v=O*365;function _(h,b,m,r){typeof h!="number"&&(h=h.getTime());const o=Math.round((new Date().getTime()-h)/1e3);if(o<-30)return(0,I.localize)(0,null,_(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,I.localize)(1,null);let s;return o<L?(s=o,b?s===1?m?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):m?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?m?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):m?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<T?(s=Math.floor(o/L),b?s===1?m?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):m?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?m?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):m?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<O?(s=Math.floor(o/T),b?s===1?m?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):m?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?m?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):m?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<A?(s=Math.floor(o/O),b?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<E?(s=Math.floor(o/A),b?s===1?m?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):m?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?m?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):m?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<v?(s=Math.floor(o/E),b?s===1?m?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):m?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?m?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):m?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/v),b?s===1?m?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):m?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?m?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):m?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function N(h,b){const m=Math.abs(h/1e3);return m<1?b?(0,I.localize)(54,null,h):(0,I.localize)(55,null,h):m<L?b?(0,I.localize)(56,null,Math.round(h)/1e3):(0,I.localize)(57,null,Math.round(h)/1e3):m<T?b?(0,I.localize)(58,null,Math.round(h/(1e3*L))):(0,I.localize)(59,null,Math.round(h/(1e3*L))):m<O?b?(0,I.localize)(60,null,Math.round(h/(1e3*T))):(0,I.localize)(61,null,Math.round(h/(1e3*T))):(0,I.localize)(62,null,Math.round(h/(1e3*O)))}function y(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ie[148],Pe([9,10]),function(ue,e){return ue.create("vs/base/common/errorMessage",e)}),define(Ie[44],Pe([1,0,18,15,148]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=v,e.isErrorWithActions=_,e.createErrorWithActions=N;function O(y,h){return h&&(y.stack||y.stacktrace)?T.localize(0,null,E(y),A(y.stack)||A(y.stacktrace)):E(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function E(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?T.localize(1,null,y.message):y.message||T.localize(2,null)}function v(y=null,h=!1){if(!y)return T.localize(3,null);if(Array.isArray(y)){const b=I.coalesce(y),m=v(b[0],h);return b.length>1?T.localize(4,null,m,b.length):m}if(L.isString(y))return y;if(y.detail){const b=y.detail;if(b.error)return O(b.error,h);if(b.exception)return O(b.exception,h)}return y.stack?O(y,h):y.message?y.message:T.localize(5,null)}function _(y){const h=y;return h instanceof Error&&Array.isArray(h.actions)}function N(y,h){let b;return typeof y=="string"?b=new Error(y):b=y,b.actions=h,b}}),define(Ie[149],Pe([1,0,43,19]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=E,e.compareFileNamesDefault=v,e.compareFileNamesUpper=_,e.compareFileNamesLower=N,e.compareFileNamesUnicode=y,e.compareFileExtensions=h,e.compareFileExtensionsDefault=b,e.compareFileExtensionsUpper=m,e.compareFileExtensionsLower=r,e.compareFileExtensionsUnicode=o,e.comparePaths=l,e.compareAnything=D,e.compareByPrefix=d;const T=new I.Lazy(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),O=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new I.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function E(w,g,C=!1){const S=w||"",k=g||"",P=T.value.collator.compare(S,k);return T.value.collatorIsNumeric&&P===0&&S!==k?S<k?-1:1:P}function v(w,g){const C=O.value.collator;return w=w||"",g=g||"",c(C,w,g)}function _(w,g){const C=O.value.collator;return w=w||"",g=g||"",a(w,g)||c(C,w,g)}function N(w,g){const C=O.value.collator;return w=w||"",g=g||"",f(w,g)||c(C,w,g)}function y(w,g){return w=w||"",g=g||"",w===g?0:w<g?-1:1}function h(w,g){const[C,S]=i(w),[k,P]=i(g);let H=T.value.collator.compare(S,P);if(H===0){if(T.value.collatorIsNumeric&&S!==P)return S<P?-1:1;if(H=T.value.collator.compare(C,k),T.value.collatorIsNumeric&&H===0&&C!==k)return C<k?-1:1}return H}function b(w,g){w=w||"",g=g||"";const C=n(w),S=n(g),k=O.value.collator,P=A.value.collator;return c(P,C,S)||c(k,w,g)}function m(w,g){w=w||"",g=g||"";const C=n(w),S=n(g),k=O.value.collator,P=A.value.collator;return c(P,C,S)||a(w,g)||c(k,w,g)}function r(w,g){w=w||"",g=g||"";const C=n(w),S=n(g),k=O.value.collator,P=A.value.collator;return c(P,C,S)||f(w,g)||c(k,w,g)}function o(w,g){w=w||"",g=g||"";const C=n(w).toLowerCase(),S=n(g).toLowerCase();return C!==S?C<S?-1:1:w!==g?w<g?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function i(w,g=!1){const C=w?s.exec(w):[];let S=[C&&C[1]||"",C&&C[3]||""];return g&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function n(w){const g=w?s.exec(w):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function c(w,g,C){const S=w.compare(g,C);return S!==0?S:g.length!==C.length?g.length<C.length?-1:1:0}function u(w){const g=w.charAt(0);return g.toLocaleUpperCase()!==g}function t(w){const g=w.charAt(0);return g.toLocaleLowerCase()!==g}function f(w,g){return u(w)&&t(g)?-1:t(w)&&u(g)?1:0}function a(w,g){return t(w)&&u(g)?-1:u(w)&&t(g)?1:0}function p(w,g,C=!1){return C||(w=w&&w.toLowerCase(),g=g&&g.toLowerCase()),w===g?0:w<g?-1:1}function l(w,g,C=!1){const S=w.split(L.sep),k=g.split(L.sep),P=S.length-1,H=k.length-1;let $,V;for(let R=0;;R++){if($=P===R,V=H===R,$&&V)return E(S[R],k[R],C);if($)return-1;if(V)return 1;const z=p(S[R],k[R],C);if(z!==0)return z}}function D(w,g,C){const S=w.toLowerCase(),k=g.toLowerCase(),P=d(w,g,C);if(P)return P;const H=S.endsWith(C),$=k.endsWith(C);if(H!==$)return H?-1:1;const V=E(S,k);return V!==0?V:S.localeCompare(k)}function d(w,g,C){const S=w.toLowerCase(),k=g.toLowerCase(),P=S.startsWith(C),H=k.startsWith(C);if(P!==H)return P?-1:1;if(P&&H){if(S.length<k.length)return-1;if(S.length>k.length)return 1}return 0}}),define(Ie[48],Pe([1,0,19,22,13,15]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=A,e.toSlashes=E,e.toPosixPath=v,e.getRoot=_,e.isUNC=N,e.isValidBasename=m,e.isEqual=r,e.isEqualOrParent=o,e.isWindowsDriveLetter=s,e.sanitizeFilePath=i,e.removeTrailingPathSeparator=n,e.isRootOrDriveLetter=c,e.hasDriveLetter=u,e.getDriveLetter=t,e.indexOfPath=f,e.parseLineAndColumnAware=a,e.randomPath=D;function A(d){return d===47||d===92}function E(d){return d.replace(/[\\/]/g,I.posix.sep)}function v(d){return d.indexOf("/")===-1&&(d=E(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}function _(d,w=I.posix.sep){if(!d)return"";const g=d.length,C=d.charCodeAt(0);if(A(C)){if(A(d.charCodeAt(1))&&!A(d.charCodeAt(2))){let k=3;const P=k;for(;k<g&&!A(d.charCodeAt(k));k++);if(P!==k&&!A(d.charCodeAt(k+1))){for(k+=1;k<g;k++)if(A(d.charCodeAt(k)))return d.slice(0,k+1).replace(/[\\/]/g,w)}}return w}else if(s(C)&&d.charCodeAt(1)===58)return A(d.charCodeAt(2))?d.slice(0,2)+w:d.slice(0,2);let S=d.indexOf("://");if(S!==-1){for(S+=3;S<g;S++)if(A(d.charCodeAt(S)))return d.slice(0,S+1)}return""}function N(d){if(!L.isWindows||!d||d.length<5)return!1;let w=d.charCodeAt(0);if(w!==92||(w=d.charCodeAt(1),w!==92))return!1;let g=2;const C=g;for(;g<d.length&&(w=d.charCodeAt(g),w!==92);g++);return!(C===g||(w=d.charCodeAt(g+1),isNaN(w)||w===92))}const y=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(d,w=L.isWindows){const g=w?y:h;return!(!d||d.length===0||/^\s+$/.test(d)||(g.lastIndex=0,g.test(d))||w&&b.test(d)||d==="."||d===".."||w&&d[d.length-1]==="."||w&&d.length!==d.trim().length||d.length>255)}function r(d,w,g){const C=d===w;return!g||C?C:!d||!w?!1:(0,T.equalsIgnoreCase)(d,w)}function o(d,w,g,C=I.sep){if(d===w)return!0;if(!d||!w||w.length>d.length)return!1;if(g){if(!(0,T.startsWithIgnoreCase)(d,w))return!1;if(w.length===d.length)return!0;let k=w.length;return w.charAt(w.length-1)===C&&k--,d.charAt(k)===C}return w.charAt(w.length-1)!==C&&(w+=C),d.indexOf(w)===0}function s(d){return d>=65&&d<=90||d>=97&&d<=122}function i(d,w){return L.isWindows&&d.endsWith(":")&&(d+=I.sep),(0,I.isAbsolute)(d)||(d=(0,I.join)(w,d)),d=(0,I.normalize)(d),n(d)}function n(d){return L.isWindows?(d=(0,T.rtrim)(d,I.sep),d.endsWith(":")&&(d+=I.sep)):(d=(0,T.rtrim)(d,I.sep),d||(d=I.sep)),d}function c(d){const w=(0,I.normalize)(d);return L.isWindows?d.length>3?!1:u(w)&&(d.length===2||w.charCodeAt(2)===92):w===I.posix.sep}function u(d,w=L.isWindows){return w?s(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}function t(d,w=L.isWindows){return u(d,w)?d[0]:void 0}function f(d,w,g){return w.length>d.length?-1:d===w?0:(g&&(d=d.toLowerCase(),w=w.toLowerCase()),d.indexOf(w))}function a(d){const w=d.split(":");let g,C,S;for(const k of w){const P=Number(k);(0,O.isNumber)(P)?C===void 0?C=P:S===void 0&&(S=P):g=g?[g,k].join(":"):k}if(!g)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:g,line:C!==void 0?C:void 0,column:S!==void 0?S:C!==void 0?1:void 0}}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(d,w,g=8){let C="";for(let k=0;k<g;k++){let P;k===0&&L.isWindows&&!w&&(g===3||g===4)?P=l:P=p,C+=P.charAt(Math.floor(Math.random()*P.length))}let S;return w?S=`${w}-${C}`:S=C,d?(0,I.join)(d,S):S}}),define(Ie[70],Pe([1,0,19]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=O,e.getMediaMime=A,e.getExtensionForMimeType=E,e.normalizeMimeType=_,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(N){const y=(0,I.extname)(N),h=L[y.toLowerCase()];return h!==void 0?h:A(N)}function A(N){const y=(0,I.extname)(N);return T[y.toLowerCase()]}function E(N){for(const y in T)if(T[y]===N)return y}const v=/^(.+)\/(.+?)(;.+)?$/;function _(N,y){const h=v.exec(N);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:y?void 0:N}}),define(Ie[49],Pe([1,0,21,2]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=T,e.parse=O,e.revive=E;function T(v){return JSON.stringify(v,A)}function O(v){let _=JSON.parse(v);return _=E(_),_}function A(v,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:_.flags}:_}function E(v,_=0){if(!v||_>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return L.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 17:return new Date(v.source)}if(v instanceof I.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let N=0;N<v.length;++N)v[N]=E(v[N],_+1);else for(const N in v)Object.hasOwnProperty.call(v,N)&&(v[N]=E(v[N],_+1))}return v}}),define(Ie[16],Pe([1,0,14,22,13,2,19]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=v,e.matchesSomeScheme=_,e.getServerRootPath=y;var E;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.commentsInput="comment",m.codeSetting="code-setting"})(E||(e.Schemas=E={}));function v(m,r){return O.URI.isUri(m)?(0,T.equalsIgnoreCase)(m.scheme,r):(0,T.startsWithIgnoreCase)(m,r+":")}function _(m,...r){return r.some(o=>v(m,o))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r,o){this._serverRootPath=y(r,o)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return A.posix.join(this._serverRootPath,E.vscodeRemoteResource)}set(r,o,s){this._hosts[r]=o,this._ports[r]=s}setConnectionToken(r,o){this._connectionTokens[r]=o}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(u){return I.onUnexpectedError(u),r}const o=r.authority;let s=this._hosts[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const i=this._ports[o],n=this._connectionTokens[o];let c=`path=${encodeURIComponent(r.path)}`;return typeof n=="string"&&(c+=`&${e.connectionTokenQueryName}=${encodeURIComponent(n)}`),O.URI.from({scheme:L.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${s}:${i}`,path:this._remoteResourcesPath,query:c})}}e.RemoteAuthorities=new N;function y(m,r){return A.posix.join(r??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class h{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(r){const o=this.toUri(r,ue);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===E.file&&(L.isNative||L.webWorkerOrigin===`${E.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?r.with({scheme:E.vscodeFileResource,authority:r.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const o=this.toUri(r,ue);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===E.vscodeFileResource?r.with({scheme:E.file,authority:r.authority!==h.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,o){return O.URI.isUri(r)?r:O.URI.parse(o.toUrl(r))}}e.FileAccess=new h;var b;(function(m){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function s(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:O.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const u=c?.get(o);if(u)return r.get(u)}m.getHeadersFromQuery=s;function i(n,c,u){if(!globalThis.crossOriginIsolated)return;const t=c&&u?"3":u?"2":"1";n instanceof URLSearchParams?n.set(o,t):n[o]=t}m.addSearchParam=i})(b||(e.COI=b={}))}),define(Ie[23],Pe([1,0,48,16,19,22,13,2]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=v,e.distinctParents=N,e.toLocalResource=h;function v(b){return(0,E.uriToFsPath)(b,!0)}class _{constructor(m){this._ignorePathCasing=m}compare(m,r,o=!1){return m===r?0:(0,A.compare)(this.getComparisonKey(m,o),this.getComparisonKey(r,o))}isEqual(m,r,o=!1){return m===r?!0:!m||!r?!1:this.getComparisonKey(m,o)===this.getComparisonKey(r,o)}getComparisonKey(m,r=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,r,o=!1){if(m.scheme===r.scheme){if(m.scheme===L.Schemas.file)return I.isEqualOrParent(v(m),v(r),this._ignorePathCasing(m))&&m.query===r.query&&(o||m.fragment===r.fragment);if((0,e.isEqualAuthority)(m.authority,r.authority))return I.isEqualOrParent(m.path,r.path,this._ignorePathCasing(m),"/")&&m.query===r.query&&(o||m.fragment===r.fragment)}return!1}joinPath(m,...r){return E.URI.joinPath(m,...r)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return T.posix.basename(m.path)}extname(m){return T.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let r;return m.scheme===L.Schemas.file?r=E.URI.file(T.dirname(v(m))).path:(r=T.posix.dirname(m.path),m.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),r="/")),m.with({path:r})}normalizePath(m){if(!m.path.length)return m;let r;return m.scheme===L.Schemas.file?r=E.URI.file(T.normalize(v(m))).path:r=T.posix.normalize(m.path),m.with({path:r})}relativePath(m,r){if(m.scheme!==r.scheme||!(0,e.isEqualAuthority)(m.authority,r.authority))return;if(m.scheme===L.Schemas.file){const i=T.relative(v(m),v(r));return O.isWindows?I.toSlashes(i):i}let o=m.path||"/";const s=r.path||"/";if(this._ignorePathCasing(m)){let i=0;for(const n=Math.min(o.length,s.length);i<n&&!(o.charCodeAt(i)!==s.charCodeAt(i)&&o.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);o=s.substr(0,i)+o.substr(i)}return T.posix.relative(o,s)}resolvePath(m,r){if(m.scheme===L.Schemas.file){const o=E.URI.file(T.resolve(v(m),r));return m.with({authority:o.authority,path:o.path})}return r=I.toPosixPath(r),m.with({path:T.posix.resolve(m.path,r)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,r){return m===r||m!==void 0&&r!==void 0&&(0,A.equalsIgnoreCase)(m,r)}hasTrailingPathSeparator(m,r=T.sep){if(m.scheme===L.Schemas.file){const o=v(m);return o.length>I.getRoot(o).length&&o[o.length-1]===r}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,r=T.sep){return(0,e.hasTrailingPathSeparator)(m,r)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,r=T.sep){let o=!1;if(m.scheme===L.Schemas.file){const s=v(m);o=s!==void 0&&s.length===I.getRoot(s).length&&s[s.length-1]===r}else{r="/";const s=m.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(m,r)?m.with({path:m.path+"/"}):m}}e.ExtUri=_,e.extUri=new _(()=>!1),e.extUriBiasedIgnorePathCase=new _(b=>b.scheme===L.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new _(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(b,m){const r=[];for(let o=0;o<b.length;o++){const s=m(b[o]);b.some((i,n)=>n===o?!1:(0,e.isEqualOrParent)(s,m(i)))||r.push(b[o])}return r}var y;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function m(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,u]=n.split(":");c&&u&&o.set(c,u)});const i=r.path.substring(0,r.path.indexOf(";"));return i&&o.set(b.META_DATA_MIME,i),o}b.parseMetaData=m})(y||(e.DataUri=y={}));function h(b,m,r){if(m){let o=b.path;return o&&o[0]!==T.posix.sep&&(o=T.posix.sep+o),b.with({scheme:r,authority:m,path:o})}return b.with({scheme:r})}}),define(Ie[11],Pe([1,0,24,14,5,6,23,22,136,43]),function(ue,e,I,L,T,O,A,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=N,e.createCancelablePromise=y,e.raceCancellation=h,e.raceCancellationError=b,e.raceCancellablePromises=m,e.raceTimeout=r,e.asPromise=o,e.promiseWithResolvers=s,e.timeout=D,e.disposableTimeout=d,e.sequence=w,e.first=g,e.firstParallel=C,e.retry=De,e.createCancelableAsyncIterable=ye;function N(ge){return!!ge&&typeof ge.then=="function"}function y(ge){const G=new I.CancellationTokenSource,Y=ge(G.token),de=new Promise((le,Oe)=>{const he=G.token.onCancellationRequested(()=>{he.dispose(),Oe(new L.CancellationError)});Promise.resolve(Y).then(ke=>{he.dispose(),G.dispose(),le(ke)},ke=>{he.dispose(),G.dispose(),Oe(ke)})});return new class{cancel(){G.cancel(),G.dispose()}then(le,Oe){return de.then(le,Oe)}catch(le){return this.then(void 0,le)}finally(le){return de.finally(le)}}}function h(ge,G,Y){return new Promise((de,le)=>{const Oe=G.onCancellationRequested(()=>{Oe.dispose(),de(Y)});ge.then(de,le).finally(()=>Oe.dispose())})}function b(ge,G){return new Promise((Y,de)=>{const le=G.onCancellationRequested(()=>{le.dispose(),de(new L.CancellationError)});ge.then(Y,de).finally(()=>le.dispose())})}async function m(ge){let G=-1;const Y=ge.map((de,le)=>de.then(Oe=>(G=le,Oe)));try{return await Promise.race(Y)}finally{ge.forEach((de,le)=>{le!==G&&de.cancel()})}}function r(ge,G,Y){let de;const le=setTimeout(()=>{de?.(void 0),Y?.()},G);return Promise.race([ge.finally(()=>clearTimeout(le)),new Promise(Oe=>de=Oe)])}function o(ge){return new Promise((G,Y)=>{const de=ge();N(de)?de.then(G,Y):G(de)})}function s(){let ge,G;return{promise:new Promise((de,le)=>{ge=de,G=le}),resolve:ge,reject:G}}class i{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(G){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=G,!this.queuedPromise){const Y=()=>{if(this.queuedPromise=null,this.isDisposed)return;const de=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,de};this.queuedPromise=new Promise(de=>{this.activePromise.then(Y,Y).then(de)})}return new Promise((Y,de)=>{this.queuedPromise.then(Y,de)})}return this.activePromise=G(),new Promise((Y,de)=>{this.activePromise.then(le=>{this.activePromise=null,Y(le)},le=>{this.activePromise=null,de(le)})})}dispose(){this.isDisposed=!0}}e.Throttler=i;class n{constructor(){this.current=Promise.resolve(null)}queue(G){return this.current=this.current.then(()=>G(),()=>G())}}e.Sequencer=n;class c{constructor(){this.promiseMap=new Map}queue(G,Y){const le=(this.promiseMap.get(G)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.promiseMap.get(G)===le&&this.promiseMap.delete(G)});return this.promiseMap.set(G,le),le}}e.SequencerByKey=c;const u=(ge,G)=>{let Y=!0;const de=setTimeout(()=>{Y=!1,G()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(de),Y=!1}}},t=ge=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,ge())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class f{constructor(G){this.defaultDelay=G,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(G,Y=this.defaultDelay){this.task=G,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((le,Oe)=>{this.doResolve=le,this.doReject=Oe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const le=this.task;return this.task=null,le()}}));const de=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Y===v.MicrotaskDelay?t(de):u(Y,de),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new L.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class a{constructor(G){this.delayer=new f(G),this.throttler=new i}trigger(G,Y){return this.delayer.trigger(()=>this.throttler.queue(G),Y)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=a;class p{constructor(){this._isOpen=!1,this._promise=new Promise((G,Y)=>{this._completePromise=G})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class l extends p{constructor(G){super(),this._timeout=setTimeout(()=>this.open(),G)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function D(ge,G){return G?new Promise((Y,de)=>{const le=setTimeout(()=>{Oe.dispose(),Y()},ge),Oe=G.onCancellationRequested(()=>{clearTimeout(le),Oe.dispose(),de(new L.CancellationError)})}):y(Y=>D(ge,Y))}function d(ge,G=0,Y){const de=setTimeout(()=>{ge(),Y&&le.dispose()},G),le=(0,O.toDisposable)(()=>{clearTimeout(de),Y?.deleteAndLeak(le)});return Y?.add(le),le}function w(ge){const G=[];let Y=0;const de=ge.length;function le(){return Y<de?ge[Y++]():null}function Oe(he){he!=null&&G.push(he);const ke=le();return ke?ke.then(Oe):Promise.resolve(G)}return Promise.resolve(null).then(Oe)}function g(ge,G=de=>!!de,Y=null){let de=0;const le=ge.length,Oe=()=>{if(de>=le)return Promise.resolve(Y);const he=ge[de++];return Promise.resolve(he()).then(Te=>G(Te)?Promise.resolve(Te):Oe())};return Oe()}function C(ge,G=de=>!!de,Y=null){if(ge.length===0)return Promise.resolve(Y);let de=ge.length;const le=()=>{de=-1;for(const Oe of ge)Oe.cancel?.()};return new Promise((Oe,he)=>{for(const ke of ge)ke.then(Te=>{--de>=0&&G(Te)?(le(),Oe(Te)):de===0&&Oe(Y)}).catch(Te=>{--de>=0&&(le(),he(Te))})})}class S{constructor(G){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=G,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}whenIdle(){return this.size>0?T.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(G){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((Y,de)=>{this.outstandingPromises.push({factory:G,c:Y,e:de}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const G=this.outstandingPromises.shift();this.runningPromises++;const Y=G.factory();Y.then(G.c,G.e),Y.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=S;class k extends S{constructor(){super(1)}}e.Queue=k;class P{constructor(){this.sequentializer=new fe,this.tasks=0}queue(G){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,G())):this.sequentializer.run(this.tasks++,G())}}e.LimitedQueue=P;class H{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const G=new ae;return this.drainers.add(G),G.p}isDrained(){for(const[,G]of this.queues)if(G.size>0)return!1;return!0}queueSize(G,Y=A.extUri){const de=Y.getComparisonKey(G);return this.queues.get(de)?.size??0}queueFor(G,Y,de=A.extUri){const le=de.getComparisonKey(G);let Oe=this.queues.get(le);if(!Oe){Oe=new k;const he=this.drainListenerCount++,ke=T.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.queues.delete(le),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(he),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(he,ke),this.queues.set(le,Oe)}return Oe.queue(Y)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const G of this.drainers)G.complete();this.drainers.clear()}dispose(){for(const[,G]of this.queues)G.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=H;class ${constructor(G,Y){this._token=-1,typeof G=="function"&&typeof Y=="number"&&this.setIfNotSet(G,Y)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(G,Y){this.cancel(),this._token=setTimeout(()=>{this._token=-1,G()},Y)}setIfNotSet(G,Y){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,G()},Y))}}e.TimeoutTimer=$;class V{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(G,Y,de=globalThis){this.cancel();const le=de.setInterval(()=>{G()},Y);this.disposable=(0,O.toDisposable)(()=>{de.clearInterval(le),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=V;class R{constructor(G,Y){this.timeoutToken=-1,this.runner=G,this.timeout=Y,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(G=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,G)}get delay(){return this.timeout}set delay(G){this.timeout=G}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=R;class z{constructor(G,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.runner=G,this.timeout=Y,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(G=this.timeout){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(G/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=z;class q extends R{constructor(G,Y){super(G,Y),this.units=[]}work(G){this.units.push(G),this.isScheduled()||this.schedule()}doRun(){const G=this.units;this.units=[],this.runner?.(G)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=q;class ie extends O.Disposable{constructor(G,Y){super(),this.options=G,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(G){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+G.length>this.options.maxBufferedWork)return!1}else if(this.pending+G.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const Y of G)this.pendingWork.push(Y);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(ge,G)=>{(0,E.setTimeout0)(()=>{if(Y)return;const de=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e._runWhenIdle=(ge,G,Y)=>{const de=ge.requestIdleCallback(G,typeof Y=="number"?{timeout:Y}:void 0);let le=!1;return{dispose(){le||(le=!0,ge.cancelIdleCallback(de))}}},e.runWhenGlobalIdle=ge=>(0,e._runWhenIdle)(globalThis,ge)}();class ce{constructor(G,Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(de){this._error=de}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(G,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ce;class Se extends ce{constructor(G){super(globalThis,G)}}e.GlobalIdleValue=Se;async function De(ge,G,Y){let de;for(let le=0;le<Y;le++)try{return await ge()}catch(Oe){de=Oe,await D(G)}throw de}class fe{isRunning(G){return typeof G=="number"?this._running?.taskId===G:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(G,Y,de){return this._running={taskId:G,cancel:()=>de?.(),promise:Y},Y.then(()=>this.doneRunning(G),()=>this.doneRunning(G)),Y}doneRunning(G){this._running&&G===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const G=this._queued;this._queued=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this._queued)this._queued.run=G;else{const{promise:Y,resolve:de,reject:le}=s();this._queued={run:G,promise:Y,promiseResolve:de,promiseReject:le}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=fe;class pe{constructor(G,Y=()=>Date.now()){this.interval=G,this.nowFn=Y,this.lastIncrementTime=0,this.value=0}increment(){const G=this.nowFn();return G-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=G,this.value=0),this.value++,this.value}}e.IntervalCounter=pe;var Ne;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(Ne||(Ne={}));class ae{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((G,Y)=>{this.completeCallback=G,this.errorCallback=Y})}complete(G){return new Promise(Y=>{this.completeCallback(G),this.outcome={outcome:0,value:G},Y()})}error(G){return new Promise(Y=>{this.errorCallback(G),this.outcome={outcome:1,value:G},Y()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=ae;var Re;(function(ge){async function G(de){let le;const Oe=await Promise.all(de.map(he=>he.then(ke=>ke,ke=>{le||(le=ke)})));if(typeof le<"u")throw le;return Oe}ge.settled=G;function Y(de){return new Promise(async(le,Oe)=>{try{await de(le,Oe)}catch(he){Oe(he)}})}ge.withAsyncBody=Y})(Re||(e.Promises=Re={}));class ne{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(G){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=G.then(Y=>(this._value=Y,this._isResolved=!0,Y),Y=>{throw this._error=Y,this._isResolved=!0,Y})}requireValue(){if(!this._isResolved)throw new L.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=ne;class x{constructor(G){this._compute=G,this._promise=new _.Lazy(()=>new ne(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=x;var J;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(J||(J={}));class be{static fromArray(G){return new be(Y=>{Y.emitMany(G)})}static fromPromise(G){return new be(async Y=>{Y.emitMany(await G)})}static fromPromises(G){return new be(async Y=>{await Promise.all(G.map(async de=>Y.emitOne(await de)))})}static merge(G){return new be(async Y=>{await Promise.all(G.map(async de=>{for await(const le of de)Y.emitOne(le)}))})}static{this.EMPTY=be.fromArray([])}constructor(G,Y){this._state=0,this._results=[],this._error=null,this._onReturn=Y,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const de={emitOne:le=>this.emitOne(le),emitMany:le=>this.emitMany(le),reject:le=>this.reject(le)};try{await Promise.resolve(G(de)),this.resolve()}catch(le){this.reject(le)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(G<this._results.length)return{done:!1,value:this._results[G++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(G,Y){return new be(async de=>{for await(const le of G)de.emitOne(Y(le))})}map(G){return be.map(this,G)}static filter(G,Y){return new be(async de=>{for await(const le of G)Y(le)&&de.emitOne(le)})}filter(G){return be.filter(this,G)}static coalesce(G){return be.filter(G,Y=>!!Y)}coalesce(){return be.coalesce(this)}static async toPromise(G){const Y=[];for await(const de of G)Y.push(de);return Y}toPromise(){return be.toPromise(this)}emitOne(G){this._state===0&&(this._results.push(G),this._onStateChanged.fire())}emitMany(G){this._state===0&&(this._results=this._results.concat(G),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(G){this._state===0&&(this._state=2,this._error=G,this._onStateChanged.fire())}}e.AsyncIterableObject=be;class Me extends be{constructor(G,Y){super(Y),this._source=G}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Me;function ye(ge){const G=new I.CancellationTokenSource,Y=ge(G.token);return new Me(G,async de=>{const le=G.token.onCancellationRequested(()=>{le.dispose(),G.dispose(),de.reject(new L.CancellationError)});try{for await(const Oe of Y){if(G.token.isCancellationRequested)return;de.emitOne(Oe)}le.dispose(),G.dispose()}catch(Oe){le.dispose(),G.dispose(),de.reject(Oe)}})}class Ee{constructor(G){this._deferred=new ae,this._asyncIterable=new be(le=>{if(Y){le.reject(Y);return}return de&&le.emitMany(de),this._errorFn=Oe=>le.reject(Oe),this._emitFn=Oe=>le.emitOne(Oe),this._deferred.p},G);let Y,de;this._emitFn=le=>{de||(de=[]),de.push(le)},this._errorFn=le=>{Y||(Y=le)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(G){this._errorFn(G),this._deferred.complete()}emitOne(G){this._emitFn(G)}}e.AsyncIterableSource=Ee}),define(Ie[37],Pe([1,0,18,11,48,28,19,22,13]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=_,e.splitGlobAware=m,e.match=k,e.parse=P,e.isRelativePattern=H,e.getBasenameTerms=$,e.getPathTerms=V,e.patternsEquals=ie;function _(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",y="[^/\\\\]",h=/\//g;function b(ce,Se){switch(ce){case 0:return"";case 1:return`${y}*?`;default:return`(?:${N}|${y}+${N}${Se?`|${N}${y}+`:""})*?`}}function m(ce,Se){if(!ce)return[];const De=[];let fe=!1,pe=!1,Ne="";for(const ae of ce){switch(ae){case Se:if(!fe&&!pe){De.push(Ne),Ne="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Ne+=ae}return Ne&&De.push(Ne),De}function r(ce){if(!ce)return"";let Se="";const De=m(ce,e.GLOB_SPLIT);if(De.every(fe=>fe===e.GLOBSTAR))Se=".*";else{let fe=!1;De.forEach((pe,Ne)=>{if(pe===e.GLOBSTAR){if(fe)return;Se+=b(2,Ne===De.length-1)}else{let ae=!1,Re="",ne=!1,x="";for(const J of pe){if(J!=="}"&&ae){Re+=J;continue}if(ne&&(J!=="]"||!x)){let be;J==="-"?be=J:(J==="^"||J==="!")&&!x?be="^":J===e.GLOB_SPLIT?be="":be=(0,v.escapeRegExpCharacters)(J),x+=be;continue}switch(J){case"{":ae=!0;continue;case"[":ne=!0;continue;case"}":{const Me=`(?:${m(Re,",").map(ye=>r(ye)).join("|")})`;Se+=Me,ae=!1,Re="";break}case"]":{Se+="["+x+"]",ne=!1,x="";break}case"?":Se+=y;continue;case"*":Se+=b(1);continue;default:Se+=(0,v.escapeRegExpCharacters)(J)}}Ne<De.length-1&&(De[Ne+1]!==e.GLOBSTAR||Ne+2<De.length)&&(Se+=N)}fe=pe===e.GLOBSTAR})}return Se}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.LRUCache(1e4),f=function(){return!1},a=function(){return null};function p(ce,Se){if(!ce)return a;let De;typeof ce!="string"?De=ce.pattern:De=ce,De=De.trim();const fe=`${De}_${!!Se.trimForExclusions}`;let pe=t.get(fe);if(pe)return l(pe,ce);let Ne;return o.test(De)?pe=d(De.substr(4),De):(Ne=s.exec(D(De,Se)))?pe=w(Ne[1],De):(Se.trimForExclusions?n:i).test(De)?pe=g(De,Se):(Ne=c.exec(D(De,Se)))?pe=C(Ne[1].substr(1),De,!0):(Ne=u.exec(D(De,Se)))?pe=C(Ne[1],De,!1):pe=S(De),t.set(fe,pe),l(pe,ce)}function l(ce,Se){if(typeof Se=="string")return ce;const De=function(fe,pe){return(0,T.isEqualOrParent)(fe,Se.base,!E.isLinux)?ce((0,v.ltrim)(fe.substr(Se.base.length),A.sep),pe):null};return De.allBasenames=ce.allBasenames,De.allPaths=ce.allPaths,De.basenames=ce.basenames,De.patterns=ce.patterns,De}function D(ce,Se){return Se.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function d(ce,Se){return function(De,fe){return typeof De=="string"&&De.endsWith(ce)?Se:null}}function w(ce,Se){const De=`/${ce}`,fe=`\\${ce}`,pe=function(ae,Re){return typeof ae!="string"?null:Re?Re===ce?Se:null:ae===ce||ae.endsWith(De)||ae.endsWith(fe)?Se:null},Ne=[ce];return pe.basenames=Ne,pe.patterns=[Se],pe.allBasenames=Ne,pe}function g(ce,Se){const De=q(ce.slice(1,-1).split(",").map(Re=>p(Re,Se)).filter(Re=>Re!==a),ce),fe=De.length;if(!fe)return a;if(fe===1)return De[0];const pe=function(Re,ne){for(let x=0,J=De.length;x<J;x++)if(De[x](Re,ne))return ce;return null},Ne=De.find(Re=>!!Re.allBasenames);Ne&&(pe.allBasenames=Ne.allBasenames);const ae=De.reduce((Re,ne)=>ne.allPaths?Re.concat(ne.allPaths):Re,[]);return ae.length&&(pe.allPaths=ae),pe}function C(ce,Se,De){const fe=A.sep===A.posix.sep,pe=fe?ce:ce.replace(h,A.sep),Ne=A.sep+pe,ae=A.posix.sep+ce;let Re;return De?Re=function(ne,x){return typeof ne=="string"&&(ne===pe||ne.endsWith(Ne)||!fe&&(ne===ce||ne.endsWith(ae)))?Se:null}:Re=function(ne,x){return typeof ne=="string"&&(ne===pe||!fe&&ne===ce)?Se:null},Re.allPaths=[(De?"*/":"./")+ce],Re}function S(ce){try{const Se=new RegExp(`^${r(ce)}$`);return function(De){return Se.lastIndex=0,typeof De=="string"&&Se.test(De)?ce:null}}catch{return a}}function k(ce,Se,De){return!ce||typeof Se!="string"?!1:P(ce)(Se,void 0,De)}function P(ce,Se={}){if(!ce)return f;if(typeof ce=="string"||H(ce)){const De=p(ce,Se);if(De===a)return f;const fe=function(pe,Ne){return!!De(pe,Ne)};return De.allBasenames&&(fe.allBasenames=De.allBasenames),De.allPaths&&(fe.allPaths=De.allPaths),fe}return R(ce,Se)}function H(ce){const Se=ce;return Se?typeof Se.base=="string"&&typeof Se.pattern=="string":!1}function $(ce){return ce.allBasenames||[]}function V(ce){return ce.allPaths||[]}function R(ce,Se){const De=q(Object.getOwnPropertyNames(ce).map(Re=>z(Re,ce[Re],Se)).filter(Re=>Re!==a)),fe=De.length;if(!fe)return a;if(!De.some(Re=>!!Re.requiresSiblings)){if(fe===1)return De[0];const Re=function(J,be){let Me;for(let ye=0,Ee=De.length;ye<Ee;ye++){const ge=De[ye](J,be);if(typeof ge=="string")return ge;(0,L.isThenable)(ge)&&(Me||(Me=[]),Me.push(ge))}return Me?(async()=>{for(const ye of Me){const Ee=await ye;if(typeof Ee=="string")return Ee}return null})():null},ne=De.find(J=>!!J.allBasenames);ne&&(Re.allBasenames=ne.allBasenames);const x=De.reduce((J,be)=>be.allPaths?J.concat(be.allPaths):J,[]);return x.length&&(Re.allPaths=x),Re}const pe=function(Re,ne,x){let J,be;for(let Me=0,ye=De.length;Me<ye;Me++){const Ee=De[Me];Ee.requiresSiblings&&x&&(ne||(ne=(0,A.basename)(Re)),J||(J=ne.substr(0,ne.length-(0,A.extname)(Re).length)));const ge=Ee(Re,ne,J,x);if(typeof ge=="string")return ge;(0,L.isThenable)(ge)&&(be||(be=[]),be.push(ge))}return be?(async()=>{for(const Me of be){const ye=await Me;if(typeof ye=="string")return ye}return null})():null},Ne=De.find(Re=>!!Re.allBasenames);Ne&&(pe.allBasenames=Ne.allBasenames);const ae=De.reduce((Re,ne)=>ne.allPaths?Re.concat(ne.allPaths):Re,[]);return ae.length&&(pe.allPaths=ae),pe}function z(ce,Se,De){if(Se===!1)return a;const fe=p(ce,De);if(fe===a)return a;if(typeof Se=="boolean")return fe;if(Se){const pe=Se.when;if(typeof pe=="string"){const Ne=(ae,Re,ne,x)=>{if(!x||!fe(ae,Re))return null;const J=pe.replace("$(basename)",()=>ne),be=x(J);return(0,L.isThenable)(be)?be.then(Me=>Me?ce:null):be?ce:null};return Ne.requiresSiblings=!0,Ne}}return fe}function q(ce,Se){const De=ce.filter(Re=>!!Re.basenames);if(De.length<2)return ce;const fe=De.reduce((Re,ne)=>{const x=ne.basenames;return x?Re.concat(x):Re},[]);let pe;if(Se){pe=[];for(let Re=0,ne=fe.length;Re<ne;Re++)pe.push(Se)}else pe=De.reduce((Re,ne)=>{const x=ne.patterns;return x?Re.concat(x):Re},[]);const Ne=function(Re,ne){if(typeof Re!="string")return null;if(!ne){let J;for(J=Re.length;J>0;J--){const be=Re.charCodeAt(J-1);if(be===47||be===92)break}ne=Re.substr(J)}const x=fe.indexOf(ne);return x!==-1?pe[x]:null};Ne.basenames=fe,Ne.patterns=pe,Ne.allBasenames=fe;const ae=ce.filter(Re=>!Re.basenames);return ae.push(Ne),ae}function ie(ce,Se){return(0,I.equals)(ce,Se,(De,fe)=>typeof De=="string"&&typeof fe=="string"?De===fe:typeof De!="string"&&typeof fe!="string"?De.base===fe.base&&De.pattern===fe.pattern:!1)}}),define(Ie[55],Pe([1,0,14,137,23,13,2]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=_,e.isMarkdownString=N,e.markdownStringEqual=y,e.escapeMarkdownSyntaxTokens=h,e.appendEscapedMarkdownCodeBlockFence=b,e.escapeDoubleQuotes=m,e.removeMarkdownEscapes=r,e.parseHrefAndDimensions=o;var E;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(E||(e.MarkdownStringTextNewlineStyle=E={}));class v{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,I.illegalArgument)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=h(this.supportThemeIcons?(0,L.escapeIcons)(i):i).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${b(n,i)}
`,this}appendLink(i,n,c){return this.value+="[",this.value+=this._escape(n,"]"),this.value+="](",this.value+=this._escape(String(i),")"),c&&(this.value+=` "${this._escape(this._escape(c,'"'),")")}"`),this.value+=")",this}_escape(i,n){const c=new RegExp((0,O.escapeRegExpCharacters)(n),"g");return i.replace(c,(u,t)=>i.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.MarkdownString=v;function _(s){return N(s)?!s.value:Array.isArray(s)?s.every(_):!0}function N(s){return s instanceof v?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function y(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,T.isEqual)(A.URI.from(s.baseUri),A.URI.from(i.baseUri)))}function h(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(s,i){const n=s.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${i}`,s,`${"`".repeat(c)}`].join(`
`)}function m(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const i=[],n=s.split("|").map(u=>u.trim());s=n[0];const c=n[1];if(c){const u=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),f=u?u[1]:"",a=t?t[1]:"",p=isFinite(parseInt(a)),l=isFinite(parseInt(f));p&&i.push(`width="${a}"`),l&&i.push(`height="${f}"`)}return{href:s,dimensions:i}}}),define(Ie[97],Pe([1,0,18,48,19,22,23,13]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=v,e.normalizeDriveLetter=N,e.tildify=h,e.untildify=b,e.shorten=s,e.template=n,e.mnemonicMenuLabel=c,e.mnemonicButtonLabel=u,e.unmnemonicLabel=t,e.splitRecentLabel=f;function v(p,l){const{os:D,tildify:d,relative:w}=l;if(w){const S=_(p,w,D);if(typeof S=="string")return S}let g=p.fsPath;if(D===1&&!O.isWindows?g=g.replace(/\//g,"\\"):D!==1&&O.isWindows&&(g=g.replace(/\\/g,"/")),D!==1&&d?.userHome){const S=d.userHome.fsPath;let k;p.scheme!==d.userHome.scheme&&p.path[0]===T.posix.sep&&p.path[1]!==T.posix.sep?k=d.userHome.with({path:p.path}).fsPath:k=g,g=h(k,S,D)}return(D===1?T.win32:T.posix).normalize(N(g,D===1))}function _(p,l,D){const d=D===1?T.win32:T.posix,w=D===3?A.extUri:A.extUriIgnorePathCase,g=l.getWorkspace(),C=(0,I.firstOrDefault)(g.folders);if(!C)return;p.scheme!==C.uri.scheme&&p.path[0]===T.posix.sep&&p.path[1]!==T.posix.sep&&(p=C.uri.with({path:p.path}));const S=l.getWorkspaceFolder(p);if(!S)return;let k;if(w.isEqual(S.uri,p)?k="":k=w.relativePath(S.uri,p)??"",k&&(k=d.normalize(k)),g.folders.length>1&&!l.noPrefix){const P=S.name?S.name:w.basenameOrAuthority(S.uri);k=k?`${P} \u2022 ${k}`:P}return k}function N(p,l=O.isWindows){return(0,L.hasDriveLetter)(p,l)?p.charAt(0).toUpperCase()+p.slice(1):p}let y=Object.create(null);function h(p,l,D=O.OS){if(D===1||!p||!l)return p;let d=y.original===l?y.normalized:void 0;d||(d=l,O.isWindows&&(d=(0,L.toSlashes)(d)),d=`${(0,E.rtrim)(d,T.posix.sep)}${T.posix.sep}`,y={original:l,normalized:d});let w=p;return O.isWindows&&(w=(0,L.toSlashes)(w)),(D===3?w.startsWith(d):(0,E.startsWithIgnoreCase)(w,d))?`~/${w.substr(d.length)}`:p}function b(p,l){return p.replace(/^~($|\/|\\)/,`${l}$1`)}const m="\u2026",r="\\\\",o="~";function s(p,l=T.sep){const D=new Array(p.length);let d=!1;for(let w=0;w<p.length;w++){const g=p[w];if(g===""){D[w]=`.${l}`;continue}if(!g){D[w]=g;continue}d=!0;let C="",S=g;S.indexOf(r)===0?(C=S.substr(0,S.indexOf(r)+r.length),S=S.substr(S.indexOf(r)+r.length)):S.indexOf(l)===0?(C=S.substr(0,S.indexOf(l)+l.length),S=S.substr(S.indexOf(l)+l.length)):S.indexOf(o)===0&&(C=S.substr(0,S.indexOf(o)+o.length),S=S.substr(S.indexOf(o)+o.length));const k=S.split(l);for(let P=1;d&&P<=k.length;P++)for(let H=k.length-P;d&&H>=0;H--){d=!1;let $=k.slice(H,H+P).join(l);for(let V=0;!d&&V<p.length;V++)if(V!==w&&p[V]&&p[V].indexOf($)>-1){const R=H+P===k.length,z=H>0&&p[V].indexOf(l)>-1?l+$:$,q=p[V].endsWith(z);d=!R||q}if(!d){let V="";(k[0].endsWith(":")||C!=="")&&(H===1&&(H=0,P++,$=k[0]+l+$),H>0&&(V=k[0]+l),V=C+V),H>0&&(V=V+m+l),V=V+$,H+P<k.length&&(V=V+l+m),D[w]=V}}d&&(D[w]=g)}return D}var i;(function(p){p[p.TEXT=0]="TEXT",p[p.VARIABLE=1]="VARIABLE",p[p.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(p,l=Object.create(null)){const D=[];let d=!1,w="";for(const g of p)if(g==="$"||d&&g==="{")w&&D.push({value:w,type:i.TEXT}),w="",d=!0;else if(g==="}"&&d){const C=l[w];if(typeof C=="string")C.length&&D.push({value:C,type:i.VARIABLE});else if(C){const S=D[D.length-1];(!S||S.type!==i.SEPARATOR)&&D.push({value:C.label,type:i.SEPARATOR})}w="",d=!1}else w+=g;return w&&!d&&D.push({value:w,type:i.TEXT}),D.filter((g,C)=>{if(g.type===i.SEPARATOR){const S=D[C-1],k=D[C+1];return[S,k].every(P=>P&&(P.type===i.VARIABLE||P.type===i.TEXT)&&P.value.length>0)}return!0}).map(g=>g.value).join("")}function c(p,l){return O.isMacintosh||l?p.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):p.replace(/&&|&/g,D=>D==="&"?"&&":"&")}function u(p,l){return O.isMacintosh||l?p.replace(/\(&&\w\)|&&/g,""):O.isWindows?p.replace(/&&|&/g,D=>D==="&"?"&&":"&"):p.replace(/&&/g,"_")}function t(p){return p.replace(/&/g,"&&")}function f(p){if(p.endsWith("]")){const l=p.lastIndexOf(" [",p.length-2);if(l!==-1){const D=a(p.substring(0,l)),d=p.substring(l);return{name:D.name+d,parentPath:D.parentPath}}}return a(p)}function a(p){const l=p.indexOf("/")!==-1?T.posix:T.win32,D=l.basename(p),d=l.dirname(p);return D.length?{name:D,parentPath:d}:{name:d,parentPath:""}}}),define(Ie[150],Pe([1,0,21,2]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=E,e.transformIncomingURIs=_,e.transformAndReviveIncomingURIs=N;function T(y){return y.toJSON()}class O{constructor(h){this._uriTransformer=h}transformIncoming(h){const b=this._uriTransformer.transformIncoming(h);return b===h?h:T(L.URI.from(b))}transformOutgoing(h){const b=this._uriTransformer.transformOutgoing(h);return b===h?h:T(L.URI.from(b))}transformOutgoingURI(h){const b=this._uriTransformer.transformOutgoing(h);return b===h?h:L.URI.from(b)}transformOutgoingScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function A(y,h,b){if(!y||b>200)return null;if(typeof y=="object"){if(y instanceof L.URI)return h.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const r=A(y[m],h,b+1);r!==null&&(y[m]=r)}}return null}function E(y,h){const b=A(y,h,0);return b===null?y:b}function v(y,h,b,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return b?L.URI.revive(h.transformIncoming(y)):h.transformIncoming(y);if(y instanceof I.VSBuffer)return null;for(const r in y)if(Object.hasOwnProperty.call(y,r)){const o=v(y[r],h,b,m+1);o!==null&&(y[r]=o)}}return null}function _(y,h){const b=v(y,h,!1,0);return b===null?y:b}function N(y,h){const b=v(y,h,!0,0);return b===null?y:b}}),define(Ie[151],Pe([1,0,11,5,6,49,15]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=v;var E;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function v(h){const b=h;return b?.changed instanceof Map||b?.deleted instanceof Set}var _;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(_||(e.StorageState=_={}));class N extends T.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(b,m=Object.create(null)){super(),this.database=b,this.options=m,this._onDidChangeStorage=this._register(new L.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=_.None,this.cache=new Map,this.flushDelayer=this._register(new I.ThrottledDelayer(N.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){this._onDidChangeStorage.pause();try{b.changed?.forEach((m,r)=>this.acceptExternal(r,m)),b.deleted?.forEach(m=>this.acceptExternal(m,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(b,m){if(this.state===_.Closed)return;let r=!1;(0,A.isUndefinedOrNull)(m)?r=this.cache.delete(b):this.cache.get(b)!==m&&(this.cache.set(b,m),r=!0),r&&this._onDidChangeStorage.fire({key:b,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===_.None&&(this.state=_.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,m){const r=this.cache.get(b);return(0,A.isUndefinedOrNull)(r)?m:r}getBoolean(b,m){const r=this.get(b);return(0,A.isUndefinedOrNull)(r)?m:r==="true"}getNumber(b,m){const r=this.get(b);return(0,A.isUndefinedOrNull)(r)?m:parseInt(r,10)}getObject(b,m){const r=this.get(b);return(0,A.isUndefinedOrNull)(r)?m:(0,O.parse)(r)}async set(b,m,r=!1){if(this.state===_.Closed)return;if((0,A.isUndefinedOrNull)(m))return this.delete(b,r);const o=(0,A.isObject)(m)||Array.isArray(m)?(0,O.stringify)(m):String(m);if(this.cache.get(b)!==o)return this.cache.set(b,o),this.pendingInserts.set(b,o),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire({key:b,external:r}),this.doFlush()}async delete(b,m=!1){if(!(this.state===_.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire({key:b,external:m}),this.doFlush()}async optimize(){if(this.state!==_.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=_.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(b){if(this.hasPending)return this.doFlush(b)}async doFlush(b){return this.options.hint===E.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),b)}async whenFlushed(){if(this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}isInMemory(){return this.options.hint===E.STORAGE_IN_MEMORY}}e.Storage=N;class y{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert?.forEach((m,r)=>this.items.set(r,m)),b.delete?.forEach(m=>this.items.delete(m))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=y}),define(Ie[152],Pe([1,0,13,22,21]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=N,e.decodeUTF16LE=y;let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let E;function v(){return E||(E=new TextDecoder("UTF-16BE")),E}let _;function N(){return _||(_=L.isLittleEndian()?A():v()),_}function y(m,r,o){const s=new Uint16Array(m.buffer,r,o);return o>0&&(s[0]===65279||s[0]===65534)?h(m,r,o):A().decode(s)}function h(m,r,o){const s=[];let i=0;for(let n=0;n<o;n++){const c=T.readUInt16LE(m,r);r+=2,s[i++]=String.fromCharCode(c)}return s.join("")}class b{constructor(r){this._capacity=r|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const r=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return N().decode(r)}_flushBuffer(){const r=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[r]:this._completedStrings[this._completedStrings.length]=r}appendCharCode(r){const o=this._capacity-this._bufferLength;o<=1&&(o===0||I.isHighSurrogate(r))&&this._flushBuffer(),this._buffer[this._bufferLength++]=r}appendASCIICharCode(r){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=r}appendString(r){const o=r.length;if(this._bufferLength+o>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=r;return}for(let s=0;s<o;s++)this._buffer[this._bufferLength++]=r.charCodeAt(s)}}e.StringBuilder=b}),define(Ie[153],Pe([1,0,21,152]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=A;function T(v){return v.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(_,N,y,h){this.oldPosition=_,this.oldText=N,this.newPosition=y,this.newText=h}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${T(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${T(this.oldText)}")`:`(replace@${this.oldPosition} "${T(this.oldText)}" with "${T(this.newText)}")`}static _writeStringSize(_){return 4+2*_.length}static _writeString(_,N,y){const h=N.length;I.writeUInt32BE(_,h,y),y+=4;for(let b=0;b<h;b++)I.writeUInt16LE(_,N.charCodeAt(b),y),y+=2;return y}static _readString(_,N){const y=I.readUInt32BE(_,N);return N+=4,(0,L.decodeUTF16LE)(_,N,y)}writeSize(){return 8+O._writeStringSize(this.oldText)+O._writeStringSize(this.newText)}write(_,N){return I.writeUInt32BE(_,this.oldPosition,N),N+=4,I.writeUInt32BE(_,this.newPosition,N),N+=4,N=O._writeString(_,this.oldText,N),N=O._writeString(_,this.newText,N),N}static read(_,N,y){const h=I.readUInt32BE(_,N);N+=4;const b=I.readUInt32BE(_,N);N+=4;const m=O._readString(_,N);N+=O._writeStringSize(m);const r=O._readString(_,N);return N+=O._writeStringSize(r),y.push(new O(h,m,b,r)),N}}e.TextChange=O;function A(v,_){return v===null||v.length===0?_:new E(v,_).compress()}class E{constructor(_,N){this._prevEdits=_,this._currEdits=N,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let _=0,N=0,y=this._getPrev(_),h=this._getCurr(N);for(;_<this._prevLen||N<this._currLen;){if(y===null){this._acceptCurr(h),h=this._getCurr(++N);continue}if(h===null){this._acceptPrev(y),y=this._getPrev(++_);continue}if(h.oldEnd<=y.newPosition){this._acceptCurr(h),h=this._getCurr(++N);continue}if(y.newEnd<=h.oldPosition){this._acceptPrev(y),y=this._getPrev(++_);continue}if(h.oldPosition<y.newPosition){const[s,i]=E._splitCurr(h,y.newPosition-h.oldPosition);this._acceptCurr(s),h=i;continue}if(y.newPosition<h.oldPosition){const[s,i]=E._splitPrev(y,h.oldPosition-y.newPosition);this._acceptPrev(s),y=i;continue}let r,o;if(h.oldEnd===y.newEnd)r=y,o=h,y=this._getPrev(++_),h=this._getCurr(++N);else if(h.oldEnd<y.newEnd){const[s,i]=E._splitPrev(y,h.oldLength);r=s,o=h,y=i,h=this._getCurr(++N)}else{const[s,i]=E._splitCurr(h,y.newLength);r=y,o=s,y=this._getPrev(++_),h=i}this._result[this._resultLen++]=new O(r.oldPosition,r.oldText,o.newPosition,o.newText),this._prevDeltaOffset+=r.newLength-r.oldLength,this._currDeltaOffset+=o.newLength-o.oldLength}const b=E._merge(this._result);return E._removeNoOps(b)}_acceptCurr(_){this._result[this._resultLen++]=E._rebaseCurr(this._prevDeltaOffset,_),this._currDeltaOffset+=_.newLength-_.oldLength}_getCurr(_){return _<this._currLen?this._currEdits[_]:null}_acceptPrev(_){this._result[this._resultLen++]=E._rebasePrev(this._currDeltaOffset,_),this._prevDeltaOffset+=_.newLength-_.oldLength}_getPrev(_){return _<this._prevLen?this._prevEdits[_]:null}static _rebaseCurr(_,N){return new O(N.oldPosition-_,N.oldText,N.newPosition,N.newText)}static _rebasePrev(_,N){return new O(N.oldPosition,N.oldText,N.newPosition+_,N.newText)}static _splitPrev(_,N){const y=_.newText.substr(0,N),h=_.newText.substr(N);return[new O(_.oldPosition,_.oldText,_.newPosition,y),new O(_.oldEnd,"",_.newPosition+N,h)]}static _splitCurr(_,N){const y=_.oldText.substr(0,N),h=_.oldText.substr(N);return[new O(_.oldPosition,y,_.newPosition,_.newText),new O(_.oldPosition+N,h,_.newEnd,"")]}static _merge(_){if(_.length===0)return _;const N=[];let y=0,h=_[0];for(let b=1;b<_.length;b++){const m=_[b];h.oldEnd===m.oldPosition?h=new O(h.oldPosition,h.oldText+m.oldText,h.newPosition,h.newText+m.newText):(N[y++]=h,h=m)}return N[y++]=h,N}static _removeNoOps(_){if(_.length===0)return _;const N=[];let y=0;for(let h=0;h<_.length;h++){const b=_[h];b.oldText!==b.newText&&(N[y++]=b)}return N}}}),define(Ie[154],Pe([1,0,37,19]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=T,e.targetsNotebooks=O;function T(A,E,v,_,N,y){if(Array.isArray(A)){let h=0;for(const b of A){const m=T(b,E,v,_,N,y);if(m===10)return m;m>h&&(h=m)}return h}else{if(typeof A=="string")return _?A==="*"?5:A===v?10:0:0;if(A){const{language:h,pattern:b,scheme:m,hasAccessToAllModels:r,notebookType:o}=A;if(!_&&!r)return 0;o&&N&&(E=N);let s=0;if(m)if(m===E.scheme)s=10;else if(m==="*")s=5;else return 0;if(h)if(h===v)s=10;else if(h==="*")s=Math.max(s,5);else return 0;if(o)if(o===y)s=10;else if(o==="*"&&y!==void 0)s=Math.max(s,5);else return 0;if(b){let i;if(typeof b=="string"?i=b:i={...b,base:(0,L.normalize)(b.base)},i===E.fsPath||(0,I.match)(i,E.fsPath))s=10;else return 0}return s}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(Ie[155],Pe([1,0,5,13,30,95,93,139,153,6]),function(ue,e,I,L,T,O,A,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class N extends _.Disposable{constructor(h,b,m,r,o,s,i){super(),this._onDidChangeContent=this._register(new I.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=b,this._mightContainNonBasicASCII=!s,this._mightContainRTL=r,this._mightContainUnusualLineTerminators=o,this._pieceTree=new A.PieceTreeBase(h,m,i)}equals(h){return!(h instanceof N)||this._BOM!==h._BOM||this.getEOL()!==h.getEOL()?!1:this._pieceTree.equal(h._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(h){return this._pieceTree.createSnapshot(h?this._BOM:"")}getOffsetAt(h,b){return this._pieceTree.getOffsetAt(h,b)}getPositionAt(h){return this._pieceTree.getPositionAt(h)}getRangeAt(h,b){const m=h+b,r=this.getPositionAt(h),o=this.getPositionAt(m);return new T.Range(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(h,b=0){if(h.isEmpty())return"";const m=this._getEndOfLine(b);return this._pieceTree.getValueInRange(h,m)}getValueLengthInRange(h,b=0){if(h.isEmpty())return 0;if(h.startLineNumber===h.endLineNumber)return h.endColumn-h.startColumn;const m=this.getOffsetAt(h.startLineNumber,h.startColumn),r=this.getOffsetAt(h.endLineNumber,h.endColumn);let o=0;const s=this._getEndOfLine(b),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,c=h.endLineNumber-h.startLineNumber;o=n*c}return r-m+o}getCharacterCountInRange(h,b=0){if(this._mightContainNonBasicASCII){let m=0;const r=h.startLineNumber,o=h.endLineNumber;for(let s=r;s<=o;s++){const i=this.getLineContent(s),n=s===r?h.startColumn-1:0,c=s===o?h.endColumn-1:i.length;for(let u=n;u<c;u++)L.isHighSurrogate(i.charCodeAt(u))?(m=m+1,u=u+1):m=m+1}return m+=this._getEndOfLine(b).length*(o-r),m}return this.getValueLengthInRange(h,b)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(h){return this._pieceTree.getLineContent(h)}getLineCharCode(h,b){return this._pieceTree.getLineCharCode(h,b)}getCharCode(h){return this._pieceTree.getCharCode(h)}getLineLength(h){return this._pieceTree.getLineLength(h)}getLineMinColumn(h){return 1}getLineMaxColumn(h){return this.getLineLength(h)+1}getLineFirstNonWhitespaceColumn(h){const b=L.firstNonWhitespaceIndex(this.getLineContent(h));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(h){const b=L.lastNonWhitespaceIndex(this.getLineContent(h));return b===-1?0:b+2}_getEndOfLine(h){switch(h){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(h){this._pieceTree.setEOL(h)}applyEdits(h,b,m){let r=this._mightContainRTL,o=this._mightContainUnusualLineTerminators,s=this._mightContainNonBasicASCII,i=!0,n=[];for(let l=0;l<h.length;l++){const D=h[l];i&&D._isTracked&&(i=!1);const d=D.range;if(D.text){let k=!0;s||(k=!L.isBasicASCII(D.text),s=k),!r&&k&&(r=L.containsRTL(D.text)),!o&&k&&(o=L.containsUnusualLineTerminators(D.text))}let w="",g=0,C=0,S=0;if(D.text){let k;[g,C,S,k]=(0,E.countEOL)(D.text);const P=this.getEOL();k===0||k===(P===`\r
`?2:1)?w=D.text:w=D.text.replace(/\r\n|\r|\n/g,P)}n[l]={sortIndex:l,identifier:D.identifier||null,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d),text:w,eolCount:g,firstLineLength:C,lastLineLength:S,forceMoveMarkers:!!D.forceMoveMarkers,isAutoWhitespaceEdit:D.isAutoWhitespaceEdit||!1}}n.sort(N._sortOpsAscending);let c=!1;for(let l=0,D=n.length-1;l<D;l++){const d=n[l].range.getEndPosition(),w=n[l+1].range.getStartPosition();if(w.isBeforeOrEqual(d)){if(w.isBefore(d))throw new Error("Overlapping ranges are not allowed!");c=!0}}i&&(n=this._reduceOperations(n));const u=m||b?N._getInverseEditRanges(n):[],t=[];if(b)for(let l=0;l<n.length;l++){const D=n[l],d=u[l];if(D.isAutoWhitespaceEdit&&D.range.isEmpty())for(let w=d.startLineNumber;w<=d.endLineNumber;w++){let g="";w===d.startLineNumber&&(g=this.getLineContent(D.range.startLineNumber),L.firstNonWhitespaceIndex(g)!==-1)||t.push({lineNumber:w,oldContent:g})}}let f=null;if(m){let l=0;f=[];for(let D=0;D<n.length;D++){const d=n[D],w=u[D],g=this.getValueInRange(d.range),C=d.rangeOffset+l;l+=d.text.length-g.length,f[D]={sortIndex:d.sortIndex,identifier:d.identifier,range:w,text:g,textChange:new v.TextChange(d.rangeOffset,g,C,d.text)}}c||f.sort((D,d)=>D.sortIndex-d.sortIndex)}this._mightContainRTL=r,this._mightContainUnusualLineTerminators=o,this._mightContainNonBasicASCII=s;const a=this._doApplyEdits(n);let p=null;if(b&&t.length>0){t.sort((l,D)=>D.lineNumber-l.lineNumber),p=[];for(let l=0,D=t.length;l<D;l++){const d=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===d)continue;const w=t[l].oldContent,g=this.getLineContent(d);g.length===0||g===w||L.firstNonWhitespaceIndex(g)!==-1||p.push(d)}}return this._onDidChangeContent.fire(),new O.ApplyEditsResult(f,a,p)}_reduceOperations(h){return h.length<1e3?h:[this._toSingleEditOperation(h)]}_toSingleEditOperation(h){let b=!1;const m=h[0].range,r=h[h.length-1].range,o=new T.Range(m.startLineNumber,m.startColumn,r.endLineNumber,r.endColumn);let s=m.startLineNumber,i=m.startColumn;const n=[];for(let a=0,p=h.length;a<p;a++){const l=h[a],D=l.range;b=b||l.forceMoveMarkers,n.push(this.getValueInRange(new T.Range(s,i,D.startLineNumber,D.startColumn))),l.text.length>0&&n.push(l.text),s=D.endLineNumber,i=D.endColumn}const c=n.join(""),[u,t,f]=(0,E.countEOL)(c);return{sortIndex:0,identifier:h[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:u,firstLineLength:t,lastLineLength:f,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}_doApplyEdits(h){h.sort(N._sortOpsDescending);const b=[];for(let m=0;m<h.length;m++){const r=h[m],o=r.range.startLineNumber,s=r.range.startColumn,i=r.range.endLineNumber,n=r.range.endColumn;if(o===i&&s===n&&r.text.length===0)continue;r.text?(this._pieceTree.delete(r.rangeOffset,r.rangeLength),this._pieceTree.insert(r.rangeOffset,r.text,!0)):this._pieceTree.delete(r.rangeOffset,r.rangeLength);const c=new T.Range(o,s,i,n);b.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return b}findMatchesLineByLine(h,b,m,r){return this._pieceTree.findMatchesLineByLine(h,b,m,r)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(h,b){const m=h.startLineNumber,r=h.startColumn,[o,s,i]=(0,E.countEOL)(b);let n;if(b.length>0){const c=o+1;c===1?n=new T.Range(m,r,m,r+s):n=new T.Range(m,r,m+c-1,i+1)}else n=new T.Range(m,r,m,r);return n}static _getInverseEditRanges(h){const b=[];let m=0,r=0,o=null;for(let s=0,i=h.length;s<i;s++){const n=h[s];let c,u;o?o.range.endLineNumber===n.range.startLineNumber?(c=m,u=r+(n.range.startColumn-o.range.endColumn)):(c=m+(n.range.startLineNumber-o.range.endLineNumber),u=n.range.startColumn):(c=n.range.startLineNumber,u=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new T.Range(c,u,c,u+n.firstLineLength):t=new T.Range(c,u,c+f-1,n.lastLineLength+1)}else t=new T.Range(c,u,c,u);m=t.endLineNumber,r=t.endColumn,b.push(t),o=n}return b}static _sortOpsAscending(h,b){const m=T.Range.compareRangesUsingEnds(h.range,b.range);return m===0?h.sortIndex-b.sortIndex:m}static _sortOpsDescending(h,b){const m=T.Range.compareRangesUsingEnds(h.range,b.range);return m===0?b.sortIndex-h.sortIndex:-m}}e.PieceTreeTextBuffer=N}),define(Ie[156],Pe([1,0,13,93,155]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class O{constructor(v,_,N,y,h,b,m,r,o){this._chunks=v,this._bom=_,this._cr=N,this._lf=y,this._crlf=h,this._containsRTL=b,this._containsUnusualLineTerminators=m,this._isBasicASCII=r,this._normalizeEOL=o}_getEOL(v){const _=this._cr+this._lf+this._crlf,N=this._cr+this._crlf;return _===0?v===1?`
`:`\r
`:N>_/2?`\r
`:`
`}create(v){const _=this._getEOL(v),N=this._chunks;if(this._normalizeEOL&&(_===`\r
`&&(this._cr>0||this._lf>0)||_===`
`&&(this._cr>0||this._crlf>0)))for(let h=0,b=N.length;h<b;h++){const m=N[h].buffer.replace(/\r\n|\r|\n/g,_),r=(0,L.createLineStartsFast)(m);N[h]=new L.StringBuffer(m,r)}const y=new T.PieceTreeTextBuffer(N,this._bom,_,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:y,disposable:y}}getFirstLineText(v){return this._chunks[0].buffer.substr(0,v).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(v){if(v.length===0)return;this.chunks.length===0&&I.startsWithUTF8BOM(v)&&(this.BOM=I.UTF8_BOM_CHARACTER,v=v.substr(1));const _=v.charCodeAt(v.length-1);_===13||_>=55296&&_<=56319?(this._acceptChunk1(v.substr(0,v.length-1),!1),this._hasPreviousChar=!0,this._previousChar=_):(this._acceptChunk1(v,!1),this._hasPreviousChar=!1,this._previousChar=_)}_acceptChunk1(v,_){!_&&v.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+v):this._acceptChunk2(v))}_acceptChunk2(v){const _=(0,L.createLineStarts)(this._tmpLineStarts,v);this.chunks.push(new L.StringBuffer(v,_.lineStarts)),this.cr+=_.cr,this.lf+=_.lf,this.crlf+=_.crlf,_.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=I.containsRTL(v)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=I.containsUnusualLineTerminators(v)))}finish(v=!0){return this._finish(),new O(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,v)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const v=this.chunks[this.chunks.length-1];v.buffer+=String.fromCharCode(this._previousChar);const _=(0,L.createLineStartsFast)(v.buffer);v.lineStarts=_,this._previousChar===13&&this.cr++}}}e.PieceTreeTextBufferBuilder=A}),define(Ie[98],Pe([1,0,21,22]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=v,e.decodeSemanticTokensDto=N;var T;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(T||(T={}));function O(y){for(let h=0,b=y.length;h<b;h+=4){const m=y[h+0],r=y[h+1],o=y[h+2],s=y[h+3];y[h+0]=s,y[h+1]=o,y[h+2]=r,y[h+3]=m}}function A(y){const h=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return L.isLittleEndian()||O(h),I.VSBuffer.wrap(h)}function E(y){const h=y.buffer;if(L.isLittleEndian()||O(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const b=new Uint8Array(h.byteLength);return b.set(h),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function v(y){const h=new Uint32Array(_(y));let b=0;if(h[b++]=y.id,y.type==="full")h[b++]=1,h[b++]=y.data.length,h.set(y.data,b),b+=y.data.length;else{h[b++]=2,h[b++]=y.deltas.length;for(const m of y.deltas)h[b++]=m.start,h[b++]=m.deleteCount,m.data?(h[b++]=m.data.length,h.set(m.data,b),b+=m.data.length):h[b++]=0}return A(h)}function _(y){let h=0;if(h+=2,y.type==="full")h+=1+y.data.length;else{h+=1,h+=3*y.deltas.length;for(const b of y.deltas)b.data&&(h+=b.data.length)}return h}function N(y){const h=E(y);let b=0;const m=h[b++];if(h[b++]===1){const i=h[b++],n=h.subarray(b,b+i);return b+=i,{id:m,type:"full",data:n}}const o=h[b++],s=[];for(let i=0;i<o;i++){const n=h[b++],c=h[b++],u=h[b++];let t;u>0&&(t=h.subarray(b,b+u),b+=u),s[i]={start:n,deleteCount:c,data:t}}return{id:m,type:"delta",deltas:s}}}),define(Ie[157],Pe([9,10]),function(ue,e){return ue.create("vs/editor/common/config/editorOptions",e)}),define(Ie[158],Pe([1,0,18,25,22,140,159,157]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=i,e.clampedFloat=c,e.stringSet=f,e.cursorStyleToString=S,e.filterValidationDecorations=le;var v;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(v||(e.EditorAutoIndentStrategy=v={})),e.MINIMAP_GUTTER_WIDTH=8;class _{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=_;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class y{constructor(X,me,Ve,we){this.id=X,this.name=me,this.defaultValue=Ve,this.schema=we}applyUpdate(X,me){return b(X,me)}compute(X,me,Ve){return Ve}}class h{constructor(X,me){this.newValue=X,this.didChange=me}}e.ApplyUpdateResult=h;function b(Q,X){if(typeof Q!="object"||typeof X!="object"||!Q||!X)return new h(X,Q!==X);if(Array.isArray(Q)||Array.isArray(X)){const Ve=Array.isArray(Q)&&Array.isArray(X)&&I.equals(Q,X);return new h(X,!Ve)}let me=!1;for(const Ve in X)if(X.hasOwnProperty(Ve)){const we=b(Q[Ve],X[Ve]);we.didChange&&(Q[Ve]=we.newValue,me=!0)}return new h(Q,me)}class m{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,me){return b(X,me)}validate(X){return this.defaultValue}}class r{constructor(X,me,Ve,we){this.id=X,this.name=me,this.defaultValue=Ve,this.schema=we}applyUpdate(X,me){return b(X,me)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,me,Ve){return Ve}}function o(Q,X){return typeof Q>"u"?X:Q==="false"?!1:!!Q}class s extends r{constructor(X,me,Ve,we=void 0){typeof we<"u"&&(we.type="boolean",we.default=Ve),super(X,me,Ve,we)}validate(X){return o(X,this.defaultValue)}}function i(Q,X,me,Ve){if(typeof Q>"u")return X;let we=parseInt(Q,10);return isNaN(we)?X:(we=Math.max(me,we),we=Math.min(Ve,we),we|0)}class n extends r{static clampedInt(X,me,Ve,we){return i(X,me,Ve,we)}constructor(X,me,Ve,we,ot,ht=void 0){typeof ht<"u"&&(ht.type="integer",ht.default=Ve,ht.minimum=we,ht.maximum=ot),super(X,me,Ve,ht),this.minimum=we,this.maximum=ot}validate(X){return n.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function c(Q,X,me,Ve){if(typeof Q>"u")return X;const we=u.float(Q,X);return u.clamp(we,me,Ve)}class u extends r{static clamp(X,me,Ve){return X<me?me:X>Ve?Ve:X}static float(X,me){if(typeof X=="number")return X;if(typeof X>"u")return me;const Ve=parseFloat(X);return isNaN(Ve)?me:Ve}constructor(X,me,Ve,we,ot){typeof ot<"u"&&(ot.type="number",ot.default=Ve),super(X,me,Ve,ot),this.validationFn=we}validate(X){return this.validationFn(u.float(X,this.defaultValue))}}class t extends r{static string(X,me){return typeof X!="string"?me:X}constructor(X,me,Ve,we=void 0){typeof we<"u"&&(we.type="string",we.default=Ve),super(X,me,Ve,we)}validate(X){return t.string(X,this.defaultValue)}}function f(Q,X,me,Ve){return typeof Q!="string"?X:Ve&&Q in Ve?Ve[Q]:me.indexOf(Q)===-1?X:Q}class a extends r{constructor(X,me,Ve,we,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=we,ot.default=Ve),super(X,me,Ve,ot),this._allowedValues=we}validate(X){return f(X,this.defaultValue,this._allowedValues)}}class p extends y{constructor(X,me,Ve,we,ot,ht,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=ot,Pt.default=we),super(X,me,Ve,Pt),this._allowedValues=ot,this._convert=ht}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function l(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class D extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",tags:["accessibility"],description:E.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,me,Ve){return Ve===0?X.accessibilitySupport:Ve}}class d extends y{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:E.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var w;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(w||(e.TextEditorCursorBlinkingStyle=w={}));function g(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var C;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(C||(e.TextEditorCursorStyle=C={}));function S(Q){switch(Q){case C.Line:return"line";case C.Block:return"block";case C.Underline:return"underline";case C.LineThin:return"line-thin";case C.BlockOutline:return"block-outline";case C.UnderlineThin:return"underline-thin"}}function k(Q){switch(Q){case"line":return C.Line;case"block":return C.Block;case"underline":return C.Underline;case"line-thin":return C.LineThin;case"block-outline":return C.BlockOutline;case"underline-thin":return C.UnderlineThin}}class P extends m{constructor(){super(142)}compute(X,me,Ve){const we=["monaco-editor"];return me.get(39)&&we.push(me.get(39)),X.extraEditorClassName&&we.push(X.extraEditorClassName),me.get(74)==="default"?we.push("mouse-default"):me.get(74)==="copy"&&we.push("mouse-copy"),me.get(111)&&we.push("showUnused"),me.get(140)&&we.push("showDeprecated"),we.join(" ")}}class H extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(X,me,Ve){return Ve&&X.emptySelectionClipboard}}class $ extends y{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[E.localize(8,null),E.localize(9,null),E.localize(10,null)],description:E.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[E.localize(12,null),E.localize(13,null),E.localize(14,null)],description:E.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:E.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:E.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:E.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":f(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":f(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class V extends y{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:E.localize(19,null)},{type:"string",description:E.localize(20,null)}],description:E.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?V.OFF:X==="true"?V.ON:X:X?V.ON:V.OFF}}e.EditorFontLigatures=V;class R extends y{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:E.localize(22,null)},{type:"string",description:E.localize(23,null)}],description:E.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?R.OFF:X==="true"?R.TRANSLATE:X:X?R.TRANSLATE:R.OFF}compute(X,me,Ve){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=R;class z extends m{constructor(){super(50)}compute(X,me,Ve){return X.fontInfo}}class q extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(25,null)})}validate(X){const me=u.float(X,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(me,6,100)}compute(X,me,Ve){return X.fontInfo.fontSize}}class ie extends y{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.MINIMUM_VALUE,maximum:ie.MAXIMUM_VALUE,errorMessage:E.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(n.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.MINIMUM_VALUE,ie.MAXIMUM_VALUE))}}class ce extends y{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[E.localize(28,null),E.localize(29,null),E.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:E.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:E.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:E.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:E.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:E.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ve,description:E.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ve,description:E.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ve,description:E.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ve,description:E.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ve,description:E.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{multiple:f(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??f(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??f(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??f(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??f(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??f(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Se extends y{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:E.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:E.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:E.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:E.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:E.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:n.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var De;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class fe extends m{constructor(){super(145)}compute(X,me,Ve){return fe.computeLayout(me,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const me=X.height/X.lineHeight,Ve=Math.floor(X.paddingTop/X.lineHeight);let we=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(we=Math.max(we,me-1));const ot=(Ve+X.viewLineCount+we)/(X.pixelRatio*X.height),ht=Math.floor(X.viewLineCount/ot);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:we,desiredRatio:ot,minimapLineCount:ht}}static _computeMinimapLayout(X,me){const Ve=X.outerWidth,we=X.outerHeight,ot=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*we),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:we};const ht=me.stableMinimapLayoutInput,Pt=ht&&X.outerHeight===ht.outerHeight&&X.lineHeight===ht.lineHeight&&X.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&X.pixelRatio===ht.pixelRatio&&X.scrollBeyondLastLine===ht.scrollBeyondLastLine&&X.paddingTop===ht.paddingTop&&X.paddingBottom===ht.paddingBottom&&X.minimap.enabled===ht.minimap.enabled&&X.minimap.side===ht.minimap.side&&X.minimap.size===ht.minimap.size&&X.minimap.showSlider===ht.minimap.showSlider&&X.minimap.renderCharacters===ht.minimap.renderCharacters&&X.minimap.maxColumn===ht.minimap.maxColumn&&X.minimap.scale===ht.minimap.scale&&X.verticalScrollbarWidth===ht.verticalScrollbarWidth&&X.isViewportWrapping===ht.isViewportWrapping,$t=X.lineHeight,Gt=X.typicalHalfwidthCharacterWidth,ti=X.scrollBeyondLastLine,Xt=X.minimap.renderCharacters;let _t=ot>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Qt=X.minimap.maxColumn,Yt=X.minimap.size,Qe=X.minimap.side,oi=X.verticalScrollbarWidth,jt=X.viewLineCount,dt=X.remainingWidth,pt=X.isViewportWrapping,Jt=Xt?2:3;let qt=Math.floor(ot*we);const Mt=qt/ot;let ft=!1,Bt=!1,Zt=Jt*_t,zt=_t/ot,Ge=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Lt,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Vt,desiredRatio:ni,minimapLineCount:kt}=fe.computeContainedMinimapLineCount({viewLineCount:jt,scrollBeyondLastLine:ti,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:we,lineHeight:$t,pixelRatio:ot});if(jt/kt>1)ft=!0,Bt=!0,_t=1,Zt=1,zt=_t/ot;else{let Rt=!1,It=_t+1;if(Yt==="fit"){const mt=Math.ceil((ii+jt+Vt)*Zt);pt&&Pt&&dt<=me.stableFitRemainingWidth?(Rt=!0,It=me.stableFitMaxMinimapScale):Rt=mt>qt}if(Yt==="fill"||Rt){ft=!0;const mt=_t;Zt=Math.min($t*ot,Math.max(1,Math.floor(1/ni))),pt&&Pt&&dt<=me.stableFitRemainingWidth&&(It=me.stableFitMaxMinimapScale),_t=Math.min(It,Math.max(1,Math.floor(Zt/Jt))),_t>mt&&(Ge=Math.min(2,_t/mt)),zt=_t/ot/Ge,qt=Math.ceil(Math.max(Lt,ii+jt+Vt)*Zt),pt?(me.stableMinimapLayoutInput=X,me.stableFitRemainingWidth=dt,me.stableFitMaxMinimapScale=_t):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const li=Math.floor(Qt*zt),Kt=Math.min(li,Math.max(0,Math.floor((dt-oi-2)*zt/(Gt+zt)))+e.MINIMAP_GUTTER_WIDTH);let Ht=Math.floor(ot*Kt);const vt=Ht/ot;Ht=Math.floor(Ht*Ge);const Ft=Xt?1:2,At=Qe==="left"?0:Ve-Kt-oi;return{renderMinimap:Ft,minimapLeft:At,minimapWidth:Kt,minimapHeightIsEditorHeight:ft,minimapIsSampling:Bt,minimapScale:_t,minimapLineHeight:Zt,minimapCanvasInnerWidth:Ht,minimapCanvasInnerHeight:qt,minimapCanvasOuterWidth:vt,minimapCanvasOuterHeight:Mt}}static computeLayout(X,me){const Ve=me.outerWidth|0,we=me.outerHeight|0,ot=me.lineHeight|0,ht=me.lineNumbersDigitCount|0,Pt=me.typicalHalfwidthCharacterWidth,$t=me.maxDigitWidth,Gt=me.pixelRatio,ti=me.viewLineCount,Xt=X.get(137),_t=Xt==="inherit"?X.get(136):Xt,Qt=_t==="inherit"?X.get(132):_t,Yt=X.get(135),Qe=me.isDominatedByLongLines,oi=X.get(57),jt=X.get(68).renderType!==0,dt=X.get(69),pt=X.get(105),Jt=X.get(84),qt=X.get(73),Mt=X.get(103),ft=Mt.verticalScrollbarSize,Bt=Mt.verticalHasArrows,Zt=Mt.arrowSize,zt=Mt.horizontalScrollbarSize,Ge=X.get(43),li=X.get(110)!=="never";let Kt=X.get(66);Ge&&li&&(Kt+=16);let Ht=0;if(jt){const ai=Math.max(ht,dt);Ht=Math.round(ai*$t)}let vt=0;oi&&(vt=ot*me.glyphMarginDecorationLaneCount);let Ft=0,At=Ft+vt,Lt=At+Ht,ii=Lt+Kt;const Vt=Ve-vt-Ht-Kt;let ni=!1,kt=!1,Ot=-1;_t==="inherit"&&Qe?(ni=!0,kt=!0):Qt==="on"||Qt==="bounded"?kt=!0:Qt==="wordWrapColumn"&&(Ot=Yt);const Rt=fe._computeMinimapLayout({outerWidth:Ve,outerHeight:we,lineHeight:ot,typicalHalfwidthCharacterWidth:Pt,pixelRatio:Gt,scrollBeyondLastLine:pt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:qt,verticalScrollbarWidth:ft,viewLineCount:ti,remainingWidth:Vt,isViewportWrapping:kt},me.memory||new N);Rt.renderMinimap!==0&&Rt.minimapLeft===0&&(Ft+=Rt.minimapWidth,At+=Rt.minimapWidth,Lt+=Rt.minimapWidth,ii+=Rt.minimapWidth);const It=Vt-Rt.minimapWidth,mt=Math.max(1,Math.floor((It-ft-2)/Pt)),yt=Bt?Zt:0;return kt&&(Ot=Math.max(1,mt),Qt==="bounded"&&(Ot=Math.min(Ot,Yt))),{width:Ve,height:we,glyphMarginLeft:Ft,glyphMarginWidth:vt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:At,lineNumbersWidth:Ht,decorationsLeft:Lt,decorationsWidth:Kt,contentLeft:ii,contentWidth:It,minimap:Rt,viewportColumn:mt,isWordWrapMinified:ni,isViewportWrapping:kt,wrappingColumn:Ot,verticalScrollbarWidth:ft,horizontalScrollbarHeight:zt,overviewRuler:{top:yt,width:ft,height:we-2*yt,right:0}}}}e.EditorLayoutInfoComputer=fe;class pe extends y{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[E.localize(47,null),E.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:E.localize(49,null)}})}validate(X){return f(X,"simple",["simple","advanced"])}compute(X,me,Ve){return me.get(2)===2?"advanced":Ve}}var Ne;(function(Q){Q.Off="off",Q.OnCode="onCode",Q.On="on"})(Ne||(e.ShowLightbulbIconMode=Ne={}));class ae extends y{constructor(){const X={enabled:Ne.On};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ne.Off,Ne.OnCode,Ne.On],default:X.enabled,enumDescriptions:[E.localize(50,null),E.localize(51,null),E.localize(52,null)],description:E.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:f(X.enabled,this.defaultValue.enabled,[Ne.Off,Ne.OnCode,Ne.On])}}}class Re extends y{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:E.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:E.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:E.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:E.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends y{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:E.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[E.localize(59,null),E.localize(60,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),E.localize(61,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),E.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:E.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:E.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:E.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:f(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class x extends y{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):n.clampedInt(X,this.defaultValue,0,1e3)}compute(X,me,Ve){return Ve<0?n.clampedInt(-Ve*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class J extends u{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>u.clamp(X,0,150),{markdownDescription:E.localize(66,null)})}compute(X,me,Ve){return X.fontInfo.lineHeight}}class be extends y{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:E.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:E.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(69,null),E.localize(70,null),E.localize(71,null)],default:X.size,description:E.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:E.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:E.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:E.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:E.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:E.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:E.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:E.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:f(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(me.side,this.defaultValue.side,["right","left"]),showSlider:f(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(me.scale,1,1,3),maxColumn:n.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Me(Q){return Q==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ye extends y{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(82,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{top:n.clampedInt(me.top,0,0,1e3),bottom:n.clampedInt(me.bottom,0,0,1e3)}}}class Ee extends y{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:E.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:E.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class ge extends m{constructor(){super(143)}compute(X,me,Ve){return X.pixelRatio}}class G extends y{constructor(){const X={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[E.localize(85,null),E.localize(86,null),E.localize(87,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:X.strings,description:E.localize(88,null)},comments:{anyOf:me,default:X.comments,description:E.localize(89,null)},other:{anyOf:me,default:X.other,description:E.localize(90,null)}},default:X,markdownDescription:E.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Gt=X?"on":"off";return{comments:Gt,strings:Gt,other:Gt}}if(!X||typeof X!="object")return this.defaultValue;const{other:me,comments:Ve,strings:we}=X,ot=["on","inline","off"];let ht,Pt,$t;return typeof me=="boolean"?ht=me?"on":"off":ht=f(me,this.defaultValue.other,ot),typeof Ve=="boolean"?Pt=Ve?"on":"off":Pt=f(Ve,this.defaultValue.comments,ot),typeof we=="boolean"?$t=we?"on":"off":$t=f(we,this.defaultValue.strings,ot),{other:ht,comments:Pt,strings:$t}}}var Y;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class de extends y{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(92,null),E.localize(93,null),E.localize(94,null),E.localize(95,null)],default:"on",description:E.localize(96,null)})}validate(X){let me=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(me=4,Ve=X):X==="interval"?me=3:X==="relative"?me=2:X==="on"?me=1:me=0),{renderType:me,renderFn:Ve}}}function le(Q){const X=Q.get(98);return X==="editable"?Q.get(91):X!=="on"}class Oe extends y{constructor(){const X=[],me={type:"number",description:E.localize(97,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:E.localize(98,null),format:"color-hex"}}}]},default:X,description:E.localize(99,null)})}validate(X){if(Array.isArray(X)){const me=[];for(const Ve of X)if(typeof Ve=="number")me.push({column:n.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const we=Ve;me.push({column:n.clampedInt(we.column,0,0,1e4),color:we.color})}return me.sort((Ve,we)=>Ve.column-we.column),me}return this.defaultValue}}class he extends y{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function ke(Q,X){if(typeof Q!="string")return X;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Te extends y{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[E.localize(100,null),E.localize(101,null),E.localize(102,null)],default:"auto",description:E.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[E.localize(104,null),E.localize(105,null),E.localize(106,null)],default:"auto",description:E.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:E.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:E.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:E.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:E.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X,Ve=n.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),we=n.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ke(me.vertical,this.defaultValue.vertical),horizontal:ke(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:n.clampedInt(me.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:we,verticalSliderSize:n.clampedInt(me.verticalSliderSize,we,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends y{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:E.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:E.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:E.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:E.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:E.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:E.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:E.localize(118,null)}})}applyUpdate(X,me){let Ve=!1;me.allowedCharacters&&X&&(L.equals(X.allowedCharacters,me.allowedCharacters)||(X={...X,allowedCharacters:me.allowedCharacters},Ve=!0)),me.allowedLocales&&X&&(L.equals(X.allowedLocales,me.allowedLocales)||(X={...X,allowedLocales:me.allowedLocales},Ve=!0));const we=super.applyUpdate(X,me);return Ve?new h(we.newValue,!0):we}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,me){if(typeof X!="object"||!X)return me;const Ve={};for(const[we,ot]of Object.entries(X))ot===!0&&(Ve[we]=!0);return Ve}}class U extends y{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:E.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[E.localize(120,null),E.localize(121,null),E.localize(122,null)],description:E.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:E.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:E.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:f(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class M extends y{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:E.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[E.localize(127,null),E.localize(128,null),E.localize(129,null)],description:E.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:E.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:E.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:f(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class W extends y{constructor(){const X={enabled:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:E.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:E.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class j extends y{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[E.localize(135,null),E.localize(136,null),E.localize(137,null)],default:X.bracketPairs,description:E.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[E.localize(139,null),E.localize(140,null),E.localize(141,null)],default:X.bracketPairsHorizontal,description:E.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:E.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:E.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[E.localize(145,null),E.localize(146,null),E.localize(147,null)],default:X.highlightActiveIndentation,description:E.localize(148,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Q,X,me){const Ve=me.indexOf(Q);return Ve===-1?X:me[Ve]}class re extends y{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(149,null),E.localize(150,null)],default:X.insertMode,description:E.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:E.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:E.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:E.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[E.localize(155,null),E.localize(156,null),E.localize(157,null),E.localize(158,null)],default:X.selectionMode,markdownDescription:E.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:E.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:E.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:E.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:E.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:E.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:E.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:E.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(196,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{insertMode:f(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:f(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Le extends y{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:E.localize(198,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(X.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends y{constructor(){const X=[];super(130,"wordSegmenterLocales",X,{anyOf:[{description:E.localize(199,null),type:"string"},{description:E.localize(200,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const me=[];for(const Ve of X)if(typeof Ve=="string")try{Intl.Segmenter.supportedLocalesOf(Ve).length>0&&me.push(Ve)}catch{}return me}return this.defaultValue}}var We;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class Ze extends y{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[E.localize(201,null),E.localize(202,null),E.localize(203,null),E.localize(204,null)],description:E.localize(205,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,me,Ve){return me.get(2)===2?0:Ve}}class Je extends m{constructor(){super(146)}compute(X,me,Ve){const we=me.get(145);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:we.isWordWrapMinified,isViewportWrapping:we.isViewportWrapping,wrappingColumn:we.wrappingColumn}}}class et extends y{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:E.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:E.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[E.localize(208,null),E.localize(209,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:f(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends y{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:E.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:E.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[E.localize(212,null),E.localize(213,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const me=X;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:f(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?at:T.isLinux?gt:it,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var st;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.autoClosingComments=7]="autoClosingComments",Q[Q.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=9]="autoClosingDelete",Q[Q.autoClosingOvertype=10]="autoClosingOvertype",Q[Q.autoClosingQuotes=11]="autoClosingQuotes",Q[Q.autoIndent=12]="autoIndent",Q[Q.automaticLayout=13]="automaticLayout",Q[Q.autoSurround=14]="autoSurround",Q[Q.bracketPairColorization=15]="bracketPairColorization",Q[Q.guides=16]="guides",Q[Q.codeLens=17]="codeLens",Q[Q.codeLensFontFamily=18]="codeLensFontFamily",Q[Q.codeLensFontSize=19]="codeLensFontSize",Q[Q.colorDecorators=20]="colorDecorators",Q[Q.colorDecoratorsLimit=21]="colorDecoratorsLimit",Q[Q.columnSelection=22]="columnSelection",Q[Q.comments=23]="comments",Q[Q.contextmenu=24]="contextmenu",Q[Q.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=26]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=28]="cursorStyle",Q[Q.cursorSurroundingLines=29]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=31]="cursorWidth",Q[Q.disableLayerHinting=32]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Q[Q.domReadOnly=34]="domReadOnly",Q[Q.dragAndDrop=35]="dragAndDrop",Q[Q.dropIntoEditor=36]="dropIntoEditor",Q[Q.emptySelectionClipboard=37]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=39]="extraEditorClassName",Q[Q.fastScrollSensitivity=40]="fastScrollSensitivity",Q[Q.find=41]="find",Q[Q.fixedOverflowWidgets=42]="fixedOverflowWidgets",Q[Q.folding=43]="folding",Q[Q.foldingStrategy=44]="foldingStrategy",Q[Q.foldingHighlight=45]="foldingHighlight",Q[Q.foldingImportsByDefault=46]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=47]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=49]="fontFamily",Q[Q.fontInfo=50]="fontInfo",Q[Q.fontLigatures=51]="fontLigatures",Q[Q.fontSize=52]="fontSize",Q[Q.fontWeight=53]="fontWeight",Q[Q.fontVariations=54]="fontVariations",Q[Q.formatOnPaste=55]="formatOnPaste",Q[Q.formatOnType=56]="formatOnType",Q[Q.glyphMargin=57]="glyphMargin",Q[Q.gotoLocation=58]="gotoLocation",Q[Q.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Q[Q.hover=60]="hover",Q[Q.inDiffEditor=61]="inDiffEditor",Q[Q.inlineSuggest=62]="inlineSuggest",Q[Q.inlineEdit=63]="inlineEdit",Q[Q.letterSpacing=64]="letterSpacing",Q[Q.lightbulb=65]="lightbulb",Q[Q.lineDecorationsWidth=66]="lineDecorationsWidth",Q[Q.lineHeight=67]="lineHeight",Q[Q.lineNumbers=68]="lineNumbers",Q[Q.lineNumbersMinChars=69]="lineNumbersMinChars",Q[Q.linkedEditing=70]="linkedEditing",Q[Q.links=71]="links",Q[Q.matchBrackets=72]="matchBrackets",Q[Q.minimap=73]="minimap",Q[Q.mouseStyle=74]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=76]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=78]="multiCursorModifier",Q[Q.multiCursorPaste=79]="multiCursorPaste",Q[Q.multiCursorLimit=80]="multiCursorLimit",Q[Q.occurrencesHighlight=81]="occurrencesHighlight",Q[Q.overviewRulerBorder=82]="overviewRulerBorder",Q[Q.overviewRulerLanes=83]="overviewRulerLanes",Q[Q.padding=84]="padding",Q[Q.pasteAs=85]="pasteAs",Q[Q.parameterHints=86]="parameterHints",Q[Q.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=89]="quickSuggestions",Q[Q.quickSuggestionsDelay=90]="quickSuggestionsDelay",Q[Q.readOnly=91]="readOnly",Q[Q.readOnlyMessage=92]="readOnlyMessage",Q[Q.renameOnType=93]="renameOnType",Q[Q.renderControlCharacters=94]="renderControlCharacters",Q[Q.renderFinalNewline=95]="renderFinalNewline",Q[Q.renderLineHighlight=96]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=98]="renderValidationDecorations",Q[Q.renderWhitespace=99]="renderWhitespace",Q[Q.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Q[Q.roundedSelection=101]="roundedSelection",Q[Q.rulers=102]="rulers",Q[Q.scrollbar=103]="scrollbar",Q[Q.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=105]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=106]="scrollPredominantAxis",Q[Q.selectionClipboard=107]="selectionClipboard",Q[Q.selectionHighlight=108]="selectionHighlight",Q[Q.selectOnLineNumbers=109]="selectOnLineNumbers",Q[Q.showFoldingControls=110]="showFoldingControls",Q[Q.showUnused=111]="showUnused",Q[Q.snippetSuggestions=112]="snippetSuggestions",Q[Q.smartSelect=113]="smartSelect",Q[Q.smoothScrolling=114]="smoothScrolling",Q[Q.stickyScroll=115]="stickyScroll",Q[Q.stickyTabStops=116]="stickyTabStops",Q[Q.stopRenderingLineAfter=117]="stopRenderingLineAfter",Q[Q.suggest=118]="suggest",Q[Q.suggestFontSize=119]="suggestFontSize",Q[Q.suggestLineHeight=120]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Q[Q.suggestSelection=122]="suggestSelection",Q[Q.tabCompletion=123]="tabCompletion",Q[Q.tabIndex=124]="tabIndex",Q[Q.unicodeHighlighting=125]="unicodeHighlighting",Q[Q.unusualLineTerminators=126]="unusualLineTerminators",Q[Q.useShadowDOM=127]="useShadowDOM",Q[Q.useTabStops=128]="useTabStops",Q[Q.wordBreak=129]="wordBreak",Q[Q.wordSegmenterLocales=130]="wordSegmenterLocales",Q[Q.wordSeparators=131]="wordSeparators",Q[Q.wordWrap=132]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=135]="wordWrapColumn",Q[Q.wordWrapOverride1=136]="wordWrapOverride1",Q[Q.wordWrapOverride2=137]="wordWrapOverride2",Q[Q.wrappingIndent=138]="wrappingIndent",Q[Q.wrappingStrategy=139]="wrappingStrategy",Q[Q.showDeprecated=140]="showDeprecated",Q[Q.inlayHints=141]="inlayHints",Q[Q.editorClassName=142]="editorClassName",Q[Q.pixelRatio=143]="pixelRatio",Q[Q.tabFocusMode=144]="tabFocusMode",Q[Q.layoutInfo=145]="layoutInfo",Q[Q.wrappingInfo=146]="wrappingInfo",Q[Q.defaultColorDecorators=147]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Q[Q.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(214,null)})),acceptSuggestionOnEnter:Ue(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(215,null),""],markdownDescription:E.localize(216,null)})),accessibilitySupport:Ue(new D),accessibilityPageSize:Ue(new n(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",E.localize(218,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:E.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(220,null),E.localize(221,null),""],description:E.localize(222,null)})),autoClosingComments:Ue(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(223,null),E.localize(224,null),""],description:E.localize(225,null)})),autoClosingDelete:Ue(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(226,null),""],description:E.localize(227,null)})),autoClosingOvertype:Ue(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(228,null),""],description:E.localize(229,null)})),autoClosingQuotes:Ue(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(230,null),E.localize(231,null),""],description:E.localize(232,null)})),autoIndent:Ue(new p(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[E.localize(233,null),E.localize(234,null),E.localize(235,null),E.localize(236,null),E.localize(237,null)],description:E.localize(238,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(239,null),E.localize(240,null),E.localize(241,null),""],description:E.localize(242,null)})),bracketPairColorization:Ue(new W),bracketPairGuides:Ue(new j),stickyTabStops:Ue(new s(116,"stickyTabStops",!1,{description:E.localize(243,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:E.localize(244,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:E.localize(245,null)})),codeLensFontSize:Ue(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:E.localize(246,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:E.localize(247,null)})),colorDecoratorActivatedOn:Ue(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[E.localize(248,null),E.localize(249,null),E.localize(250,null)],description:E.localize(251,null)})),colorDecoratorsLimit:Ue(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:E.localize(252,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:E.localize(253,null)})),comments:Ue(new d),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:E.localize(254,null)})),cursorBlinking:Ue(new p(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:E.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[E.localize(256,null),E.localize(257,null),E.localize(258,null)],description:E.localize(259,null)})),cursorStyle:Ue(new p(28,"cursorStyle",C.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],k,{description:E.localize(260,null)})),cursorSurroundingLines:Ue(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(262,null),E.localize(263,null)],markdownDescription:E.localize(264,null)})),cursorWidth:Ue(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(265,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:E.localize(266,null)})),emptySelectionClipboard:Ue(new H),dropIntoEditor:Ue(new et),stickyScroll:Ue(new Re),experimentalWhitespaceRendering:Ue(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[E.localize(267,null),E.localize(268,null),E.localize(269,null)],description:E.localize(270,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(40,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:E.localize(271,null)})),find:Ue(new $),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:E.localize(272,null)})),foldingStrategy:Ue(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(273,null),E.localize(274,null)],description:E.localize(275,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:E.localize(276,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:E.localize(277,null)})),foldingMaximumRegions:Ue(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:E.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(279,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(280,null)})),fontInfo:Ue(new z),fontLigatures2:Ue(new V),fontSize:Ue(new q),fontWeight:Ue(new ie),fontVariations:Ue(new R),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:E.localize(281,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:E.localize(282,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:E.localize(283,null)})),gotoLocation:Ue(new ce),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:E.localize(284,null)})),hover:Ue(new Se),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new u(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>u.clamp(Q,-5,20),{description:E.localize(285,null)})),lightbulb:Ue(new ae),lineDecorationsWidth:Ue(new x),lineHeight:Ue(new J),lineNumbers:Ue(new de),lineNumbersMinChars:Ue(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(70,"linkedEditing",!1,{description:E.localize(286,null)})),links:Ue(new s(71,"links",!0,{description:E.localize(287,null)})),matchBrackets:Ue(new a(72,"matchBrackets","always",["always","near","never"],{description:E.localize(288,null)})),minimap:Ue(new be),mouseStyle:Ue(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(75,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:E.localize(289,null)})),mouseWheelZoom:Ue(new s(76,"mouseWheelZoom",!1,{markdownDescription:T.isMacintosh?E.localize(290,null):E.localize(291,null)})),multiCursorMergeOverlapping:Ue(new s(77,"multiCursorMergeOverlapping",!0,{description:E.localize(292,null)})),multiCursorModifier:Ue(new p(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Me,{markdownEnumDescriptions:[E.localize(293,null),E.localize(294,null)],markdownDescription:E.localize(295,null)})),multiCursorPaste:Ue(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(296,null),E.localize(297,null)],markdownDescription:E.localize(298,null)})),multiCursorLimit:Ue(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:E.localize(299,null)})),occurrencesHighlight:Ue(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[E.localize(300,null),E.localize(301,null),E.localize(302,null)],markdownDescription:E.localize(303,null)})),overviewRulerBorder:Ue(new s(82,"overviewRulerBorder",!0,{description:E.localize(304,null)})),overviewRulerLanes:Ue(new n(83,"overviewRulerLanes",3,0,3)),padding:Ue(new ye),pasteAs:Ue(new tt),parameterHints:Ue(new Ee),peekWidgetDefaultFocus:Ue(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(305,null),E.localize(306,null)],description:E.localize(307,null)})),definitionLinkOpensInPeek:Ue(new s(88,"definitionLinkOpensInPeek",!1,{description:E.localize(308,null)})),quickSuggestions:Ue(new G),quickSuggestionsDelay:Ue(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(309,null)})),readOnly:Ue(new s(91,"readOnly",!1)),readOnlyMessage:Ue(new he),renameOnType:Ue(new s(93,"renameOnType",!1,{description:E.localize(310,null),markdownDeprecationMessage:E.localize(311,null)})),renderControlCharacters:Ue(new s(94,"renderControlCharacters",!0,{description:E.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new a(95,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:E.localize(313,null)})),renderLineHighlight:Ue(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(314,null)],description:E.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(316,null)})),renderValidationDecorations:Ue(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(317,null),E.localize(318,null),E.localize(319,null),""],description:E.localize(320,null)})),revealHorizontalRightPadding:Ue(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(101,"roundedSelection",!0,{description:E.localize(321,null)})),rulers:Ue(new Oe),scrollbar:Ue(new Te),scrollBeyondLastColumn:Ue(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:E.localize(322,null)})),scrollBeyondLastLine:Ue(new s(105,"scrollBeyondLastLine",!0,{description:E.localize(323,null)})),scrollPredominantAxis:Ue(new s(106,"scrollPredominantAxis",!0,{description:E.localize(324,null)})),selectionClipboard:Ue(new s(107,"selectionClipboard",!0,{description:E.localize(325,null),included:T.isLinux})),selectionHighlight:Ue(new s(108,"selectionHighlight",!0,{description:E.localize(326,null)})),selectOnLineNumbers:Ue(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[E.localize(327,null),E.localize(328,null),E.localize(329,null)],description:E.localize(330,null)})),showUnused:Ue(new s(111,"showUnused",!0,{description:E.localize(331,null)})),showDeprecated:Ue(new s(140,"showDeprecated",!0,{description:E.localize(332,null)})),inlayHints:Ue(new ne),snippetSuggestions:Ue(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(333,null),E.localize(334,null),E.localize(335,null),E.localize(336,null)],description:E.localize(337,null)})),smartSelect:Ue(new Le),smoothScrolling:Ue(new s(114,"smoothScrolling",!1,{description:E.localize(338,null)})),stopRenderingLineAfter:Ue(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new re),inlineSuggest:Ue(new U),inlineEdit:Ue(new M),inlineCompletionsAccessibilityVerbose:Ue(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:E.localize(339,null)})),suggestFontSize:Ue(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(121,"suggestOnTriggerCharacters",!0,{description:E.localize(342,null)})),suggestSelection:Ue(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(343,null),E.localize(344,null),E.localize(345,null)],description:E.localize(346,null)})),tabCompletion:Ue(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(347,null),E.localize(348,null),E.localize(349,null)],description:E.localize(350,null)})),tabIndex:Ue(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new ze),unusualLineTerminators:Ue(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(351,null),E.localize(352,null),E.localize(353,null)],description:E.localize(354,null)})),useShadowDOM:Ue(new s(127,"useShadowDOM",!0)),useTabStops:Ue(new s(128,"useTabStops",!0,{description:E.localize(355,null)})),wordBreak:Ue(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[E.localize(356,null),E.localize(357,null)],description:E.localize(358,null)})),wordSegmenterLocales:Ue(new Be),wordSeparators:Ue(new t(131,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:E.localize(359,null)})),wordWrap:Ue(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(360,null),E.localize(361,null),E.localize(362,null),E.localize(363,null)],description:E.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(365,null)})),wordWrapOverride1:Ue(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new P),defaultColorDecorators:Ue(new s(147,"defaultColorDecorators",!1,{markdownDescription:E.localize(366,null)})),pixelRatio:Ue(new ge),tabFocusMode:Ue(new s(144,"tabFocusMode",!1,{markdownDescription:E.localize(367,null)})),layoutInfo:Ue(new fe),wrappingInfo:Ue(new Je),wrappingIndent:Ue(new Ze),wrappingStrategy:Ue(new pe)}}),define(Ie[160],Pe([9,10]),function(ue,e){return ue.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[161],Pe([9,10]),function(ue,e){return ue.create("vs/platform/contextkey/common/contextkey",e)}),define(Ie[162],Pe([9,10]),function(ue,e){return ue.create("vs/platform/contextkey/common/scanner",e)}),define(Ie[163],Pe([9,10]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[164],Pe([9,10]),function(ue,e){return ue.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[165],Pe([9,10]),function(ue,e){return ue.create("vs/platform/files/common/files",e)}),define(Ie[166],Pe([9,10]),function(ue,e){return ue.create("vs/platform/log/common/log",e)}),define(Ie[167],Pe([9,10]),function(ue,e){return ue.create("vs/platform/markers/common/markers",e)}),define(Ie[168],Pe([9,10]),function(ue,e){return ue.create("vs/platform/request/common/request",e)}),define(Ie[169],Pe([9,10]),function(ue,e){return ue.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[170],Pe([9,10]),function(ue,e){return ue.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ie[171],Pe([9,10]),function(ue,e){return ue.create("vs/platform/workspace/common/workspace",e)}),define(Ie[172],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[173],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[174],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ie[175],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ie[176],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostLogService",e)}),define(Ie[177],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ie[178],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[179],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ie[180],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[181],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[182],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ie[183],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[184],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/common/configuration",e)}),define(Ie[185],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/common/editor",e)}),define(Ie[186],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/common/views",e)}),define(Ie[187],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ie[188],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[189],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[190],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[191],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[192],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[193],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ie[194],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[195],Pe([9,10]),function(ue,e){return ue.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[196],Pe([1,0,14,162]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var T;(function(_){_[_.LParen=0]="LParen",_[_.RParen=1]="RParen",_[_.Neg=2]="Neg",_[_.Eq=3]="Eq",_[_.NotEq=4]="NotEq",_[_.Lt=5]="Lt",_[_.LtEq=6]="LtEq",_[_.Gt=7]="Gt",_[_.GtEq=8]="GtEq",_[_.RegexOp=9]="RegexOp",_[_.RegexStr=10]="RegexStr",_[_.True=11]="True",_[_.False=12]="False",_[_.In=13]="In",_[_.Not=14]="Not",_[_.And=15]="And",_[_.Or=16]="Or",_[_.Str=17]="Str",_[_.QuotedStr=18]="QuotedStr",_[_.Error=19]="Error",_[_.EOF=20]="EOF"})(T||(e.TokenType=T={}));function O(..._){switch(_.length){case 1:return(0,L.localize)(0,null,_[0]);case 2:return(0,L.localize)(1,null,_[0],_[1]);case 3:return(0,L.localize)(2,null,_[0],_[1],_[2]);default:return}}const A=(0,L.localize)(3,null),E=(0,L.localize)(4,null);class v{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(N){switch(N.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return N.isTripleEq?"===":"==";case 4:return N.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return N.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return N.lexeme;case 18:return N.lexeme;case 19:return N.lexeme;case 20:return"EOF";default:throw(0,I.illegalState)(`unhandled token type: ${JSON.stringify(N)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(N=>N.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(N){return this._input=N,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const y=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:y})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const y=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:y})}else this._match(126)?this._addToken(9):this._error(O("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(O("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(N){return this._isAtEnd()||this._input.charCodeAt(this._current)!==N?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(N){this._tokens.push({type:N,offset:this._start})}_error(N){const y=this._start,h=this._input.substring(this._start,this._current),b={type:19,offset:this._start,lexeme:h};this._errors.push({offset:y,lexeme:h,additionalInfo:N}),this._tokens.push(b)}_string(){this.stringRe.lastIndex=this._start;const N=this.stringRe.exec(this._input);if(N){this._current=this._start+N[0].length;const y=this._input.substring(this._start,this._current),h=v._keywords.get(y);h?this._addToken(h):this._tokens.push({type:17,lexeme:y,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(A);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let N=this._current,y=!1,h=!1;for(;;){if(N>=this._input.length){this._current=N,this._error(E);return}const m=this._input.charCodeAt(N);if(y)y=!1;else if(m===47&&!h){N++;break}else m===91?h=!0:m===92?y=!0:m===93&&(h=!1);N++}for(;N<this._input.length&&v._regexFlags.has(this._input.charCodeAt(N));)N++;this._current=N;const b=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:b,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=v}),define(Ie[197],Pe([1,0,23,33,164,311]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=v,e.parseVersion=_,e.normalizeVersion=N,e.isValidVersion=y,e.validateExtensionManifest=h,e.isValidExtensionVersion=b,e.isEngineValid=m;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function v(s){return s=s.trim(),s==="*"||A.test(s)}function _(s){if(!v(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function N(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,c=s.minorBase;let u=s.minorMustEqual;const t=s.patchBase;let f=s.patchMustEqual;s.hasCaret&&(i===0||(u=!1),f=!1);let a=0;if(s.preRelease){const p=E.exec(s.preRelease);if(p){const[,l,D,d]=p;a=Date.UTC(Number(l),Number(D)-1,Number(d))}}return{majorBase:i,majorMustEqual:n,minorBase:c,minorMustEqual:u,patchBase:t,patchMustEqual:f,isMinimum:s.hasGreaterEquals,notBefore:a}}function y(s,i,n){let c;typeof s=="string"?c=N(_(s)):c=s;let u;i instanceof Date?u=i.getTime():typeof i=="string"&&(u=new Date(i).getTime());let t;if(typeof n=="string"?t=N(_(n)):t=n,!c||!t)return!1;const f=c.majorBase,a=c.minorBase,p=c.patchBase;let l=t.majorBase,D=t.minorBase,d=t.patchBase;const w=t.notBefore;let g=t.majorMustEqual,C=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?f>l?!0:f<l?!1:a>D?!0:a<D||u&&u<w?!1:p>=d:(f===1&&l===0&&(!g||!C||!S)&&(l=1,D=0,d=0,g=!0,C=!1,S=!1),f<l?!1:f>l?!g:a<D?!1:a>D?!C:p<d?!1:p>d?!S:!(u&&u<w))}function h(s,i,n,c,u){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([L.default.Error,T.localize(0,null)]),t;if(typeof c.name!="string")return t.push([L.default.Error,T.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([L.default.Error,T.localize(2,null,"version")]),t;if(!c.engines)return t.push([L.default.Error,T.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([L.default.Error,T.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return t.push([L.default.Error,T.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return t.push([L.default.Error,T.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([L.default.Error,T.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([L.default.Warning,T.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([L.default.Error,T.localize(9,null,"main")]),t;{const p=(0,I.joinPath)(n,c.main);(0,I.isEqualOrParent)(p,n)||t.push([L.default.Warning,T.localize(10,null,p.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([L.default.Error,T.localize(11,null,"browser")]),t;{const p=(0,I.joinPath)(n,c.browser);(0,I.isEqualOrParent)(p,n)||t.push([L.default.Warning,T.localize(12,null,p.path,n.path)])}}if(!O.valid(c.version))return t.push([L.default.Error,T.localize(13,null)]),t;const f=[];if(!b(s,i,c,u,f))for(const p of f)t.push([L.default.Error,p]);return t}function b(s,i,n,c,u){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:r(s,i,n.engines.vscode,u)}function m(s,i,n){return s==="*"||r(i,n,s)}function r(s,i,n,c=[]){const u=N(_(n));if(!u)return c.push(T.localize(14,null,n)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(T.localize(15,null,n)),!1}else if(!u.majorMustEqual)return c.push(T.localize(16,null,n)),!1;return y(s,i,u)?!0:(c.push(T.localize(17,null,s,n)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Ie[71],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(T,O=[],A=!1){this.ctor=T,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=I}),define(Ie[56],Pe([1,0,71]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=O,e.getSingletonServiceDescriptors=A;const L=[];var T;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(T||(e.InstantiationType=T={}));function O(E,v,_){v instanceof I.SyncDescriptor||(v=new I.SyncDescriptor(v,[],!!_)),L.push([E,v])}function A(){return L}}),define(Ie[198],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class L{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const A of this._nodes.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const E=this.lookupOrInsertNode(O),v=this.lookupOrInsertNode(A);E.outgoing.set(v.key,v),v.incoming.set(E.key,E)}removeNode(O){const A=this._hashFn(O);this._nodes.delete(A);for(const E of this._nodes.values())E.outgoing.delete(A),E.incoming.delete(A)}lookupOrInsertNode(O){const A=this._hashFn(O);let E=this._nodes.get(A);return E||(E=new I(A,O),this._nodes.set(A,E)),E}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[A,E]of this._nodes)O.push(`${A}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this._nodes){const E=new Set([O]),v=this._findCycle(A,E);if(v)return v}}_findCycle(O,A){for(const[E,v]of O.outgoing){if(A.has(E))return[...A,E].join(" -> ");A.add(E);const _=this._findCycle(v,A);if(_)return _;A.delete(E)}}}e.Graph=L}),define(Ie[3],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=T,e.refineServiceDecorator=O;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function E(v){return v[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=E})(I||(e._util=I={})),e.IInstantiationService=T("instantiationService");function L(A,E,v){E[I.DI_TARGET]===E?E[I.DI_DEPENDENCIES].push({id:A,index:v}):(E[I.DI_DEPENDENCIES]=[{id:A,index:v}],E[I.DI_TARGET]=E)}function T(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const E=function(v,_,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(E,v,N)};return E.toString=()=>A,I.serviceIds.set(A,E),E}function O(A){return A}}),define(Ie[50],Pe([1,0,15,2,3]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=O,e.isConfigurationUpdateOverrides=A,e.ConfigurationTargetToString=v,e.isConfigured=_,e.toValuesTree=N,e.addToValueTree=y,e.removeFromValueTree=h,e.getConfigurationValue=m,e.merge=r,e.getLanguageTagSettingPlainKey=o,e.IConfigurationService=(0,T.createDecorator)("configurationService");function O(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof L.URI)}function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof L.URI)}var E;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function v(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function _(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function N(s,i){const n=Object.create(null);for(const c in s)y(n,c,s[c],i);return n}function y(s,i,n,c){const u=i.split("."),t=u.pop();let f=s;for(let a=0;a<u.length;a++){const p=u[a];let l=f[p];switch(typeof l){case"undefined":l=f[p]=Object.create(null);break;case"object":if(l===null){c(`Ignoring ${i} as ${u.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${i} as ${u.slice(0,a+1).join(".")} is ${JSON.stringify(l)}`);return}f=l}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{c(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(f)}`)}else c(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(f)}`)}function h(s,i){const n=i.split(".");b(s,n)}function b(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const c=s[n];typeof c=="object"&&!Array.isArray(c)&&(b(c,i),Object.keys(c).length===0&&delete s[n])}}function m(s,i,n){function c(f,a){let p=f;for(const l of a){if(typeof p!="object"||p===null)return;p=p[l]}return p}const u=i.split("."),t=c(s,u);return typeof t>"u"?n:t}function r(s,i,n){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in s?I.isObject(s[c])&&I.isObject(i[c])?r(s[c],i[c],n):n&&(s[c]=i[c]):s[c]=i[c])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Ie[31],Pe([1,0,22,13,196,3,161,14]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=_,e.validateWhenClauses=f,e.expressionsAreEqualWithConstantSubstitution=a,e.implies=Ne;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",I.isMacintosh),v.set("isLinux",I.isLinux),v.set("isWindows",I.isWindows),v.set("isWeb",I.isWeb),v.set("isMacNative",I.isMacintosh&&!I.isWeb),v.set("isEdge",I.isEdge),v.set("isFirefox",I.isFirefox),v.set("isChrome",I.isChrome),v.set("isSafari",I.isSafari);function _(ne,x){if(v.get(ne)!==void 0)throw(0,E.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(ne,x)}const N=Object.prototype.hasOwnProperty;var y;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const h={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),m=(0,A.localize)(1,null),r=(0,A.localize)(2,null),o=(0,A.localize)(3,null),s=(0,A.localize)(4,null),i=(0,A.localize)(5,null),n=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class u{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(x=h){this._config=x,this._scanner=new T.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(x){if(x===""){this._parsingErrors.push({message:b,offset:0,lexeme:"",additionalInfo:m});return}this._tokens=this._scanner.reset(x).scan(),this._current=0,this._parsingErrors=[];try{const J=this._expr();if(!this._isAtEnd()){const be=this._peek(),Me=be.type===17?i:void 0;throw this._parsingErrors.push({message:s,offset:be.offset,lexeme:T.Scanner.getLexeme(be),additionalInfo:Me}),u._parseError}return J}catch(J){if(J!==u._parseError)throw J;return}}_expr(){return this._or()}_or(){const x=[this._and()];for(;this._matchOne(16);){const J=this._and();x.push(J)}return x.length===1?x[0]:t.or(...x)}_and(){const x=[this._term()];for(;this._matchOne(15);){const J=this._term();x.push(J)}return x.length===1?x[0]:t.and(...x)}_term(){if(this._matchOne(2)){const x=this._peek();switch(x.type){case 11:return this._advance(),l.INSTANCE;case 12:return this._advance(),D.INSTANCE;case 0:{this._advance();const J=this._expr();return this._consume(1,o),J?.negate()}case 17:return this._advance(),k.create(x.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",x)}}return this._primary()}_primary(){const x=this._peek();switch(x.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const J=this._expr();return this._consume(1,o),J}case 17:{const J=x.lexeme;if(this._advance(),this._matchOne(9)){const Me=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Me.type!==10)throw this._errExpectedButGot("REGEX",Me);const ye=Me.lexeme,Ee=ye.lastIndexOf("/"),ge=Ee===ye.length-1?void 0:this._removeFlagsGY(ye.substring(Ee+1));let G;try{G=new RegExp(ye.substring(1,Ee),ge)}catch{throw this._errExpectedButGot("REGEX",Me)}return z.create(J,G)}switch(Me.type){case 10:case 19:{const ye=[Me.lexeme];this._advance();let Ee=this._peek(),ge=0;for(let Oe=0;Oe<Me.lexeme.length;Oe++)Me.lexeme.charCodeAt(Oe)===40?ge++:Me.lexeme.charCodeAt(Oe)===41&&ge--;for(;!this._isAtEnd()&&Ee.type!==15&&Ee.type!==16;){switch(Ee.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Oe=0;Oe<Ee.lexeme.length;Oe++)Ee.lexeme.charCodeAt(Oe)===40?ge++:Me.lexeme.charCodeAt(Oe)===41&&ge--}if(ge<0)break;ye.push(T.Scanner.getLexeme(Ee)),this._advance(),Ee=this._peek()}const G=ye.join(""),Y=G.lastIndexOf("/"),de=Y===G.length-1?void 0:this._removeFlagsGY(G.substring(Y+1));let le;try{le=new RegExp(G.substring(1,Y),de)}catch{throw this._errExpectedButGot("REGEX",Me)}return t.regex(J,le)}case 18:{const ye=Me.lexeme;this._advance();let Ee=null;if(!(0,L.isFalsyOrWhitespace)(ye)){const ge=ye.indexOf("/"),G=ye.lastIndexOf("/");if(ge!==G&&ge>=0){const Y=ye.slice(ge+1,G),de=ye[G+1]==="i"?"i":"";try{Ee=new RegExp(Y,de)}catch{throw this._errExpectedButGot("REGEX",Me)}}}if(Ee===null)throw this._errExpectedButGot("REGEX",Me);return z.create(J,Ee)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,r);const Me=this._value();return t.notIn(J,Me)}switch(this._peek().type){case 3:{this._advance();const Me=this._value();if(this._previous().type===18)return t.equals(J,Me);switch(Me){case"true":return t.has(J);case"false":return t.not(J);default:return t.equals(J,Me)}}case 4:{this._advance();const Me=this._value();if(this._previous().type===18)return t.notEquals(J,Me);switch(Me){case"true":return t.not(J);case"false":return t.has(J);default:return t.notEquals(J,Me)}}case 5:return this._advance(),V.create(J,this._value());case 6:return this._advance(),R.create(J,this._value());case 7:return this._advance(),H.create(J,this._value());case 8:return this._advance(),$.create(J,this._value());case 13:return this._advance(),t.in(J,this._value());default:return t.has(J)}}case 20:throw this._parsingErrors.push({message:n,offset:x.offset,lexeme:"",additionalInfo:c}),u._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const x=this._peek();switch(x.type){case 17:case 18:return this._advance(),x.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(x){return x.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(x){return this._check(x)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(x,J){if(this._check(x))return this._advance();throw this._errExpectedButGot(J,this._peek())}_errExpectedButGot(x,J,be){const Me=(0,A.localize)(8,null,x,T.Scanner.getLexeme(J)),ye=J.offset,Ee=T.Scanner.getLexeme(J);return this._parsingErrors.push({message:Me,offset:ye,lexeme:Ee,additionalInfo:be}),u._parseError}_check(x){return this._peek().type===x}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=u;class t{static false(){return l.INSTANCE}static true(){return D.INSTANCE}static has(x){return d.create(x)}static equals(x,J){return w.create(x,J)}static notEquals(x,J){return S.create(x,J)}static regex(x,J){return z.create(x,J)}static in(x,J){return g.create(x,J)}static notIn(x,J){return C.create(x,J)}static not(x){return k.create(x)}static and(...x){return ce.create(x,null,!0)}static or(...x){return Se.create(x,null,!0)}static greater(x,J){return H.create(x,J)}static greaterEquals(x,J){return $.create(x,J)}static smaller(x,J){return V.create(x,J)}static smallerEquals(x,J){return R.create(x,J)}static{this._parser=new u({regexParsingWithErrorRecovery:!1})}static deserialize(x){return x==null?void 0:this._parser.parse(x)}}e.ContextKeyExpr=t;function f(ne){const x=new u({regexParsingWithErrorRecovery:!1});return ne.map(J=>(x.parse(J),x.lexingErrors.length>0?x.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,A.localize)(9,null,be.additionalInfo):(0,A.localize)(10,null),offset:be.offset,length:be.lexeme.length})):x.parsingErrors.length>0?x.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function a(ne,x){const J=ne?ne.substituteConstants():void 0,be=x?x.substituteConstants():void 0;return!J&&!be?!0:!J||!be?!1:J.equals(be)}function p(ne,x){return ne.cmp(x)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(x){return this.type-x.type}equals(x){return x.type===this.type}substituteConstants(){return this}evaluate(x){return!1}serialize(){return"false"}keys(){return[]}map(x){return this}negate(){return D.INSTANCE}}e.ContextKeyFalseExpr=l;class D{static{this.INSTANCE=new D}constructor(){this.type=1}cmp(x){return this.type-x.type}equals(x){return x.type===this.type}substituteConstants(){return this}evaluate(x){return!0}serialize(){return"true"}keys(){return[]}map(x){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=D;class d{static create(x,J=null){const be=v.get(x);return typeof be=="boolean"?be?D.INSTANCE:l.INSTANCE:new d(x,J)}constructor(x,J){this.key=x,this.negated=J,this.type=2}cmp(x){return x.type!==this.type?this.type-x.type:fe(this.key,x.key)}equals(x){return x.type===this.type?this.key===x.key:!1}substituteConstants(){const x=v.get(this.key);return typeof x=="boolean"?x?D.INSTANCE:l.INSTANCE:this}evaluate(x){return!!x.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(x){return x.mapDefined(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class w{static create(x,J,be=null){if(typeof J=="boolean")return J?d.create(x,be):k.create(x,be);const Me=v.get(x);return typeof Me=="boolean"?J===(Me?"true":"false")?D.INSTANCE:l.INSTANCE:new w(x,J,be)}constructor(x,J,be){this.key=x,this.value=J,this.negated=be,this.type=4}cmp(x){return x.type!==this.type?this.type-x.type:pe(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){const x=v.get(this.key);if(typeof x=="boolean"){const J=x?"true":"false";return this.value===J?D.INSTANCE:l.INSTANCE}return this}evaluate(x){return x.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(x){return x.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class g{static create(x,J){return new g(x,J)}constructor(x,J){this.key=x,this.valueKey=J,this.type=10,this.negated=null}cmp(x){return x.type!==this.type?this.type-x.type:pe(this.key,this.valueKey,x.key,x.valueKey)}equals(x){return x.type===this.type?this.key===x.key&&this.valueKey===x.valueKey:!1}substituteConstants(){return this}evaluate(x){const J=x.getValue(this.valueKey),be=x.getValue(this.key);return Array.isArray(J)?J.includes(be):typeof be=="string"&&typeof J=="object"&&J!==null?N.call(J,be):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(x){return x.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=g;class C{static create(x,J){return new C(x,J)}constructor(x,J){this.key=x,this.valueKey=J,this.type=11,this._negated=g.create(x,J)}cmp(x){return x.type!==this.type?this.type-x.type:this._negated.cmp(x._negated)}equals(x){return x.type===this.type?this._negated.equals(x._negated):!1}substituteConstants(){return this}evaluate(x){return!this._negated.evaluate(x)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(x){return x.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class S{static create(x,J,be=null){if(typeof J=="boolean")return J?k.create(x,be):d.create(x,be);const Me=v.get(x);return typeof Me=="boolean"?J===(Me?"true":"false")?l.INSTANCE:D.INSTANCE:new S(x,J,be)}constructor(x,J,be){this.key=x,this.value=J,this.negated=be,this.type=5}cmp(x){return x.type!==this.type?this.type-x.type:pe(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){const x=v.get(this.key);if(typeof x=="boolean"){const J=x?"true":"false";return this.value===J?l.INSTANCE:D.INSTANCE}return this}evaluate(x){return x.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(x){return x.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class k{static create(x,J=null){const be=v.get(x);return typeof be=="boolean"?be?l.INSTANCE:D.INSTANCE:new k(x,J)}constructor(x,J){this.key=x,this.negated=J,this.type=3}cmp(x){return x.type!==this.type?this.type-x.type:fe(this.key,x.key)}equals(x){return x.type===this.type?this.key===x.key:!1}substituteConstants(){const x=v.get(this.key);return typeof x=="boolean"?x?l.INSTANCE:D.INSTANCE:this}evaluate(x){return!x.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(x){return x.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=k;function P(ne,x){if(typeof ne=="string"){const J=parseFloat(ne);isNaN(J)||(ne=J)}return typeof ne=="string"||typeof ne=="number"?x(ne):l.INSTANCE}class H{static create(x,J,be=null){return P(J,Me=>new H(x,Me,be))}constructor(x,J,be){this.key=x,this.value=J,this.negated=be,this.type=12}cmp(x){return x.type!==this.type?this.type-x.type:pe(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(x){return x.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=H;class ${static create(x,J,be=null){return P(J,Me=>new $(x,Me,be))}constructor(x,J,be){this.key=x,this.value=J,this.negated=be,this.type=13}cmp(x){return x.type!==this.type?this.type-x.type:pe(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(x){return x.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=V.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=$;class V{static create(x,J,be=null){return P(J,Me=>new V(x,Me,be))}constructor(x,J,be){this.key=x,this.value=J,this.negated=be,this.type=14}cmp(x){return x.type!==this.type?this.type-x.type:pe(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(x){return x.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=V;class R{static create(x,J,be=null){return P(J,Me=>new R(x,Me,be))}constructor(x,J,be){this.key=x,this.value=J,this.negated=be,this.type=15}cmp(x){return x.type!==this.type?this.type-x.type:pe(this.key,this.value,x.key,x.value)}equals(x){return x.type===this.type?this.key===x.key&&this.value===x.value:!1}substituteConstants(){return this}evaluate(x){return typeof this.value=="string"?!1:parseFloat(x.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(x){return x.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=R;class z{static create(x,J){return new z(x,J)}constructor(x,J){this.key=x,this.regexp=J,this.type=7,this.negated=null}cmp(x){if(x.type!==this.type)return this.type-x.type;if(this.key<x.key)return-1;if(this.key>x.key)return 1;const J=this.regexp?this.regexp.source:"",be=x.regexp?x.regexp.source:"";return J<be?-1:J>be?1:0}equals(x){if(x.type===this.type){const J=this.regexp?this.regexp.source:"",be=x.regexp?x.regexp.source:"";return this.key===x.key&&J===be}return!1}substituteConstants(){return this}evaluate(x){const J=x.getValue(this.key);return this.regexp?this.regexp.test(J):!1}serialize(){const x=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${x}`}keys(){return[this.key]}map(x){return x.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=q.create(this)),this.negated}}e.ContextKeyRegexExpr=z;class q{static create(x){return new q(x)}constructor(x){this._actual=x,this.type=8}cmp(x){return x.type!==this.type?this.type-x.type:this._actual.cmp(x._actual)}equals(x){return x.type===this.type?this._actual.equals(x._actual):!1}substituteConstants(){return this}evaluate(x){return!this._actual.evaluate(x)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(x){return new q(this._actual.map(x))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=q;function ie(ne){let x=null;for(let J=0,be=ne.length;J<be;J++){const Me=ne[J].substituteConstants();if(ne[J]!==Me&&x===null){x=[];for(let ye=0;ye<J;ye++)x[ye]=ne[ye]}x!==null&&(x[J]=Me)}return x===null?ne:x}class ce{static create(x,J,be){return ce._normalizeArr(x,J,be)}constructor(x,J){this.expr=x,this.negated=J,this.type=6}cmp(x){if(x.type!==this.type)return this.type-x.type;if(this.expr.length<x.expr.length)return-1;if(this.expr.length>x.expr.length)return 1;for(let J=0,be=this.expr.length;J<be;J++){const Me=p(this.expr[J],x.expr[J]);if(Me!==0)return Me}return 0}equals(x){if(x.type===this.type){if(this.expr.length!==x.expr.length)return!1;for(let J=0,be=this.expr.length;J<be;J++)if(!this.expr[J].equals(x.expr[J]))return!1;return!0}return!1}substituteConstants(){const x=ie(this.expr);return x===this.expr?this:ce.create(x,this.negated,!1)}evaluate(x){for(let J=0,be=this.expr.length;J<be;J++)if(!this.expr[J].evaluate(x))return!1;return!0}static _normalizeArr(x,J,be){const Me=[];let ye=!1;for(const Ee of x)if(Ee){if(Ee.type===1){ye=!0;continue}if(Ee.type===0)return l.INSTANCE;if(Ee.type===6){Me.push(...Ee.expr);continue}Me.push(Ee)}if(Me.length===0&&ye)return D.INSTANCE;if(Me.length!==0){if(Me.length===1)return Me[0];Me.sort(p);for(let Ee=1;Ee<Me.length;Ee++)Me[Ee-1].equals(Me[Ee])&&(Me.splice(Ee,1),Ee--);if(Me.length===1)return Me[0];for(;Me.length>1;){const Ee=Me[Me.length-1];if(Ee.type!==9)break;Me.pop();const ge=Me.pop(),G=Me.length===0,Y=Se.create(Ee.expr.map(de=>ce.create([de,ge],null,be)),null,G);Y&&(Me.push(Y),Me.sort(p))}if(Me.length===1)return Me[0];if(be){for(let Ee=0;Ee<Me.length;Ee++)for(let ge=Ee+1;ge<Me.length;ge++)if(Me[Ee].negate().equals(Me[ge]))return l.INSTANCE;if(Me.length===1)return Me[0]}return new ce(Me,J)}}serialize(){return this.expr.map(x=>x.serialize()).join(" && ")}keys(){const x=[];for(const J of this.expr)x.push(...J.keys());return x}map(x){return new ce(this.expr.map(J=>J.map(x)),null)}negate(){if(!this.negated){const x=[];for(const J of this.expr)x.push(J.negate());this.negated=Se.create(x,this,!0)}return this.negated}}e.ContextKeyAndExpr=ce;class Se{static create(x,J,be){return Se._normalizeArr(x,J,be)}constructor(x,J){this.expr=x,this.negated=J,this.type=9}cmp(x){if(x.type!==this.type)return this.type-x.type;if(this.expr.length<x.expr.length)return-1;if(this.expr.length>x.expr.length)return 1;for(let J=0,be=this.expr.length;J<be;J++){const Me=p(this.expr[J],x.expr[J]);if(Me!==0)return Me}return 0}equals(x){if(x.type===this.type){if(this.expr.length!==x.expr.length)return!1;for(let J=0,be=this.expr.length;J<be;J++)if(!this.expr[J].equals(x.expr[J]))return!1;return!0}return!1}substituteConstants(){const x=ie(this.expr);return x===this.expr?this:Se.create(x,this.negated,!1)}evaluate(x){for(let J=0,be=this.expr.length;J<be;J++)if(this.expr[J].evaluate(x))return!0;return!1}static _normalizeArr(x,J,be){let Me=[],ye=!1;if(x){for(let Ee=0,ge=x.length;Ee<ge;Ee++){const G=x[Ee];if(G){if(G.type===0){ye=!0;continue}if(G.type===1)return D.INSTANCE;if(G.type===9){Me=Me.concat(G.expr);continue}Me.push(G)}}if(Me.length===0&&ye)return l.INSTANCE;Me.sort(p)}if(Me.length!==0){if(Me.length===1)return Me[0];for(let Ee=1;Ee<Me.length;Ee++)Me[Ee-1].equals(Me[Ee])&&(Me.splice(Ee,1),Ee--);if(Me.length===1)return Me[0];if(be){for(let Ee=0;Ee<Me.length;Ee++)for(let ge=Ee+1;ge<Me.length;ge++)if(Me[Ee].negate().equals(Me[ge]))return D.INSTANCE;if(Me.length===1)return Me[0]}return new Se(Me,J)}}serialize(){return this.expr.map(x=>x.serialize()).join(" || ")}keys(){const x=[];for(const J of this.expr)x.push(...J.keys());return x}map(x){return new Se(this.expr.map(J=>J.map(x)),null)}negate(){if(!this.negated){const x=[];for(const J of this.expr)x.push(J.negate());for(;x.length>1;){const J=x.shift(),be=x.shift(),Me=[];for(const ye of Re(J))for(const Ee of Re(be))Me.push(ce.create([ye,Ee],null,!1));x.unshift(Se.create(Me,null,!1))}this.negated=Se.create(x,this,!0)}return this.negated}}e.ContextKeyOrExpr=Se;class De extends d{static{this._info=[]}static all(){return De._info.values()}constructor(x,J,be){super(x,null),this._defaultValue=J,typeof be=="object"?De._info.push({...be,key:x}):be!==!0&&De._info.push({key:x,description:be,type:J!=null?typeof J:void 0})}bindTo(x){return x.createKey(this.key,this._defaultValue)}getValue(x){return x.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(x){return w.create(this.key,x)}notEqualsTo(x){return S.create(this.key,x)}}e.RawContextKey=De,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function fe(ne,x){return ne<x?-1:ne>x?1:0}function pe(ne,x,J,be){return ne<J?-1:ne>J?1:x<be?-1:x>be?1:0}function Ne(ne,x){if(ne.type===0||x.type===1)return!0;if(ne.type===9)return x.type===9?ae(ne.expr,x.expr):!1;if(x.type===9){for(const J of x.expr)if(Ne(ne,J))return!0;return!1}if(ne.type===6){if(x.type===6)return ae(x.expr,ne.expr);for(const J of ne.expr)if(Ne(J,x))return!0;return!1}return ne.equals(x)}function ae(ne,x){let J=0,be=0;for(;J<ne.length&&be<x.length;){const Me=ne[J].cmp(x[be]);if(Me<0)return!1;Me===0&&J++,be++}return J===ne.length}function Re(ne){return ne.type===9?ne.expr:[ne]}}),define(Ie[99],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[100],Pe([1,0,163,3]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=T,e.toTargetPlatform=O,e.getTargetPlatform=A,e.isNotWebExtensionInWebTargetPlatform=E,e.isTargetPlatformCompatible=v,e.isIExtensionIdentifier=_,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function T(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PowerPC";case"linux-riscv64":return"Linux RISC-V 64";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"linux-riscv64":return"linux-riscv64";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":n==="ppc64le"?"linux-ppc64le":n==="riscv64"?"linux-riscv64":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(i,n){return n==="web"&&!i.includes("web")}function v(i,n,c){return E(n,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}function _(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var N;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(N||(e.SortBy=N={}));var y;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var h;(function(i){i.Install="install",i.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var m;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));class r extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.ExtensionManagementError=r;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class s extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.ExtensionGalleryError=s,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,I.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,I.localize2)(1,"Preferences")}),define(Ie[38],Pe([1,0,54,19,13,15,2,165,3,22,16,43]),function(ue,e,I,L,T,O,A,E,v,_,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=h,e.isFileSystemWatcher=o,e.hasReadWriteCapability=i,e.hasFileFolderCopyCapability=n,e.hasFileCloneCapability=c,e.hasOpenReadWriteCloseCapability=u,e.hasFileReadStreamCapability=t,e.hasFileAtomicReadCapability=f,e.hasFileAtomicWriteCapability=a,e.hasFileAtomicDeleteCapability=p,e.hasReadonlyCapability=l,e.createFileSystemProviderError=w,e.ensureFileSystemProviderError=g,e.markAsFileSystemProviderError=C,e.toFileSystemProviderErrorCode=S,e.toFileOperationResult=k,e.isParent=R,e.etag=De,e.whenProviderRegistered=fe,e.getLargeFileConfirmationLimit=Ne,e.IFileService=(0,v.createDecorator)("fileService");function h(ae){return ae.create===!0}var b;(function(ae){ae[ae.Unknown=0]="Unknown",ae[ae.File=1]="File",ae[ae.Directory=2]="Directory",ae[ae.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var m;(function(ae){ae[ae.Readonly=1]="Readonly",ae[ae.Locked=2]="Locked"})(m||(e.FilePermission=m={}));var r;(function(ae){ae[ae.UPDATED=2]="UPDATED",ae[ae.ADDED=4]="ADDED",ae[ae.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(ae){const Re=ae;return!!Re&&typeof Re.onDidChange=="function"}var s;(function(ae){ae[ae.None=0]="None",ae[ae.FileReadWrite=2]="FileReadWrite",ae[ae.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ae[ae.FileReadStream=16]="FileReadStream",ae[ae.FileFolderCopy=8]="FileFolderCopy",ae[ae.PathCaseSensitive=1024]="PathCaseSensitive",ae[ae.Readonly=2048]="Readonly",ae[ae.Trash=4096]="Trash",ae[ae.FileWriteUnlock=8192]="FileWriteUnlock",ae[ae.FileAtomicRead=16384]="FileAtomicRead",ae[ae.FileAtomicWrite=32768]="FileAtomicWrite",ae[ae.FileAtomicDelete=65536]="FileAtomicDelete",ae[ae.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function i(ae){return!!(ae.capabilities&2)}function n(ae){return!!(ae.capabilities&8)}function c(ae){return!!(ae.capabilities&131072)}function u(ae){return!!(ae.capabilities&4)}function t(ae){return!!(ae.capabilities&16)}function f(ae){return i(ae)?!!(ae.capabilities&16384):!1}function a(ae){return i(ae)?!!(ae.capabilities&32768):!1}function p(ae){return!!(ae.capabilities&65536)}function l(ae){return!!(ae.capabilities&2048)}var D;(function(ae){ae.FileExists="EntryExists",ae.FileNotFound="EntryNotFound",ae.FileNotADirectory="EntryNotADirectory",ae.FileIsADirectory="EntryIsADirectory",ae.FileExceedsStorageQuota="EntryExceedsStorageQuota",ae.FileTooLarge="EntryTooLarge",ae.FileWriteLocked="EntryWriteLocked",ae.NoPermissions="NoPermissions",ae.Unavailable="Unavailable",ae.Unknown="Unknown"})(D||(e.FileSystemProviderErrorCode=D={}));class d extends Error{static create(Re,ne){const x=new d(Re.toString(),ne);return C(x,ne),x}constructor(Re,ne){super(Re),this.code=ne}}e.FileSystemProviderError=d;function w(ae,Re){return d.create(ae,Re)}function g(ae){return ae||w((0,E.localize)(0,null),D.Unknown)}function C(ae,Re){return ae.name=Re?`${Re} (FileSystemError)`:"FileSystemError",ae}function S(ae){if(!ae)return D.Unknown;if(ae instanceof d)return ae.code;const Re=/^(.+) \(FileSystemError\)$/.exec(ae.name);if(!Re)return D.Unknown;switch(Re[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}function k(ae){if(ae instanceof z)return ae.fileOperationResult;switch(S(ae)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 9;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileTooLarge:return 7;default:return 10}}var P;(function(ae){ae[ae.CREATE=0]="CREATE",ae[ae.DELETE=1]="DELETE",ae[ae.MOVE=2]="MOVE",ae[ae.COPY=3]="COPY",ae[ae.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class H{constructor(Re,ne,x){this.resource=Re,this.operation=ne,this.target=x}isOperation(Re){return this.operation===Re}}e.FileOperationEvent=H;var $;(function(ae){ae[ae.UPDATED=0]="UPDATED",ae[ae.ADDED=1]="ADDED",ae[ae.DELETED=2]="DELETED"})($||(e.FileChangeType=$={}));class V{static{this.MIXED_CORRELATION=null}constructor(Re,ne){this.ignorePathCasing=ne,this.correlationId=void 0,this.added=new y.Lazy(()=>{const x=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return x.fill(this.rawAdded.map(J=>[J,!0])),x}),this.updated=new y.Lazy(()=>{const x=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return x.fill(this.rawUpdated.map(J=>[J,!0])),x}),this.deleted=new y.Lazy(()=>{const x=I.TernarySearchTree.forUris(()=>this.ignorePathCasing);return x.fill(this.rawDeleted.map(J=>[J,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of Re){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.correlationId!==V.MIXED_CORRELATION&&(typeof x.cId=="number"?this.correlationId===void 0?this.correlationId=x.cId:this.correlationId!==x.cId&&(this.correlationId=V.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=V.MIXED_CORRELATION))}}contains(Re,...ne){return this.doContains(Re,{includeChildren:!1},...ne)}affects(Re,...ne){return this.doContains(Re,{includeChildren:!0},...ne)}doContains(Re,ne,...x){if(!Re)return!1;const J=x.length>0;return!!((!J||x.includes(1))&&(this.added.value.get(Re)||ne.includeChildren&&this.added.value.findSuperstr(Re))||(!J||x.includes(0))&&(this.updated.value.get(Re)||ne.includeChildren&&this.updated.value.findSuperstr(Re))||(!J||x.includes(2))&&(this.deleted.value.findSubstr(Re)||ne.includeChildren&&this.deleted.value.findSuperstr(Re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Re){return this.correlationId===Re}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=V;function R(ae,Re,ne){return!ae||!Re||ae===Re||Re.length>ae.length?!1:(Re.charAt(Re.length-1)!==L.sep&&(Re+=L.sep),ne?(0,T.startsWithIgnoreCase)(ae,Re):ae.indexOf(Re)===0)}class z extends Error{constructor(Re,ne,x){super(Re),this.fileOperationResult=ne,this.options=x}}e.FileOperationError=z;class q extends z{constructor(Re,ne,x,J){super(Re,ne,J),this.fileOperationResult=ne,this.size=x}}e.TooLargeFileOperationError=q;class ie extends z{constructor(Re,ne,x){super(Re,2,x),this.stat=ne}}e.NotModifiedSinceFileOperationError=ie;var ce;(function(ae){ae[ae.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ae[ae.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ae[ae.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ae[ae.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ae[ae.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ae[ae.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ae[ae.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ae[ae.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ae[ae.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ae[ae.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ae[ae.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Se;(function(ae){ae[ae.FILE=0]="FILE",ae[ae.FOLDER=1]="FOLDER",ae[ae.ROOT_FOLDER=2]="ROOT_FOLDER"})(Se||(e.FileKind=Se={})),e.ETAG_DISABLED="";function De(ae){if(!(typeof ae.size!="number"||typeof ae.mtime!="number"))return ae.mtime.toString(29)+ae.size.toString(31)}async function fe(ae,Re){if(!Re.hasProvider(A.URI.from({scheme:ae.scheme})))return new Promise(ne=>{const x=Re.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===ae.scheme&&J.added&&(x.dispose(),ne())})})}class pe{static{this.KB=1024}static{this.MB=pe.KB*pe.KB}static{this.GB=pe.MB*pe.KB}static{this.TB=pe.GB*pe.KB}static formatSize(Re){return(0,O.isNumber)(Re)||(Re=0),Re<pe.KB?(0,E.localize)(1,null,Re.toFixed(0)):Re<pe.MB?(0,E.localize)(2,null,(Re/pe.KB).toFixed(2)):Re<pe.GB?(0,E.localize)(3,null,(Re/pe.MB).toFixed(2)):Re<pe.TB?(0,E.localize)(4,null,(Re/pe.GB).toFixed(2)):(0,E.localize)(5,null,(Re/pe.TB).toFixed(2))}}e.ByteSize=pe;function Ne(ae){const Re=typeof ae=="string"||ae?.scheme===N.Schemas.vscodeRemote;return typeof ae!="string"&&ae?.scheme===N.Schemas.file?1024*pe.MB:Re?10*pe.MB:_.isWeb?50*pe.MB:1024*pe.MB}}),define(Ie[72],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...T){this._entries=new Map;for(const[O,A]of T)this.set(O,A)}set(T,O){const A=this._entries.get(T);return this._entries.set(T,O),A}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=I}),define(Ie[199],Pe([1,0,11,14,6,71,198,3,72,200]),function(ue,e,I,L,T,O,A,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class h{constructor(o=new v.ServiceCollection,s=!1,i,n=N){this._services=o,this._strict=s,this._parent=i,this._enableTracing=n,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(E.IInstantiationService,this),this._globalGraph=n?i?._globalGraph??new A.Graph(c=>c):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,T.dispose)(this._children),this._children.clear();for(const o of this._servicesToMaybeDispose)(0,T.isDisposable)(o)&&o.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(o){this._throwIfDisposed();const s=new class extends h{dispose(){this._children.delete(s),super.dispose()}}(o,this._strict,this,this._enableTracing);return this._children.add(s),s}invokeFunction(o,...s){this._throwIfDisposed();const i=m.traceInvocation(this._enableTracing,o);let n=!1;try{return o({get:u=>{if(n)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(u,i);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(o,...s){this._throwIfDisposed();let i,n;return o instanceof O.SyncDescriptor?(i=m.traceCreation(this._enableTracing,o.ctor),n=this._createInstance(o.ctor,o.staticArguments.concat(s),i)):(i=m.traceCreation(this._enableTracing,o),n=this._createInstance(o,s,i)),i.stop(),n}_createInstance(o,s=[],i){const n=E._util.getServiceDependencies(o).sort((t,f)=>t.index-f.index),c=[];for(const t of n){const f=this._getOrCreateServiceInstance(t.id,i);f||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(f)}const u=n.length>0?n[0].index:s.length;if(s.length!==u){console.trace(`[createInstance] First service dependency of ${o.name} at position ${u+1} conflicts with ${s.length} static arguments`);const t=u-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,u)}return Reflect.construct(o,s.concat(c))}_setCreatedServiceInstance(o,s){if(this._services.get(o)instanceof O.SyncDescriptor)this._services.set(o,s);else if(this._parent)this._parent._setCreatedServiceInstance(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const s=this._services.get(o);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):s}_getOrCreateServiceInstance(o,s){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const i=this._getServiceInstanceOrDescriptor(o);return i instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,i,s.branch(o,!0)):(s.branch(o,!1),i)}_safeCreateAndCacheServiceInstance(o,s,i){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,s,i)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,s,i){const n=new A.Graph(t=>t.id.toString());let c=0;const u=[{id:o,desc:s,_trace:i}];for(;u.length;){const t=u.pop();if(n.lookupOrInsertNode(t),c++>1e3)throw new y(n);for(const f of E._util.getServiceDependencies(t.desc.ctor)){const a=this._getServiceInstanceOrDescriptor(f.id);if(a||this._throwIfStrict(`[createInstance] ${o} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),a instanceof O.SyncDescriptor){const p={id:f.id,desc:a,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,p),u.push(p)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new y(n);break}for(const{data:f}of t){if(this._getServiceInstanceOrDescriptor(f.id)instanceof O.SyncDescriptor){const p=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setCreatedServiceInstance(f.id,p)}n.removeNode(f)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,s,i=[],n,c){if(this._services.get(o)instanceof O.SyncDescriptor)return this._createServiceInstance(o,s,i,n,c,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,s,i,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(o,s,i=[],n,c,u){if(n){const t=new h(void 0,this._strict,this,this._enableTracing);t._globalGraphImplicitDependency=String(o);const f=new Map,a=new I.GlobalIdleValue(()=>{const p=t._createInstance(s,i,c);for(const[l,D]of f){const d=p[l];if(typeof d=="function")for(const w of D)w.disposable=d.apply(p,w.listener)}return f.clear(),u.add(p),p});return new Proxy(Object.create(null),{get(p,l){if(!a.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let w=f.get(l);return w||(w=new _.LinkedList,f.set(l,w)),(C,S,k)=>{if(a.isInitialized)return a.value[l](C,S,k);{const P={listener:[C,S,k],disposable:void 0},H=w.push(P);return(0,T.toDisposable)(()=>{H(),P.disposable?.dispose()})}}}if(l in p)return p[l];const D=a.value;let d=D[l];return typeof d!="function"||(d=d.bind(D),p[l]=d),d},set(p,l,D){return a.value[l]=D,!0},getPrototypeOf(p){return s.prototype}})}else{const t=this._createInstance(s,i,c);return u.add(t),t}}_throwIfStrict(o,s){if(s&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=h;var b;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(b||(b={}));class m{static{this.all=new Set}static{this._None=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new m(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(o,s){return o?new m(1,s.name):m._None}static{this._totals=0}constructor(o,s){this.type=o,this.name=s,this._start=Date.now(),this._dep=[]}branch(o,s){const i=new m(3,o.toString());return this._dep.push([o,s,i]),i}stop(){const o=Date.now()-this._start;m._totals+=o;let s=!1;function i(c,u){const t=[],f=new Array(c+1).join("	");for(const[a,p,l]of u._dep)if(p&&l){s=!0,t.push(`${f}CREATES -> ${a}`);const D=i(c+1,l);D&&t.push(D)}else t.push(`${f}uses -> ${a}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(o>2||s)&&m.all.add(n.join(`
`))}}e.Trace=m}),define(Ie[12],Pe([1,0,166,44,5,73,6,28,22,23,15,2,31,3]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=r,e.log=s,e.getLogLevel=d,e.LogLevelToString=w,e.LogLevelToLocalizedString=g,e.parseLogLevel=C,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function m(){return new Date().toISOString()}function r(S){return(0,N.isNumber)(S)}var o;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(o||(e.LogLevel=o={})),e.DEFAULT_LOG_LEVEL=o.Info;function s(S,k,P){switch(k){case o.Trace:S.trace(P);break;case o.Debug:S.debug(P);break;case o.Info:S.info(P);break;case o.Warning:S.warn(P);break;case o.Error:S.error(P);break;case o.Off:break;default:throw new Error(`Invalid log level ${k}`)}}function i(S,k=!1){let P="";for(let H=0;H<S.length;H++){let $=S[H];if($ instanceof Error&&($=(0,L.toErrorMessage)($,k)),typeof $=="object")try{$=JSON.stringify($)}catch{}P+=(H>0?" ":"")+$}return P}class n extends A.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(k){this.level!==k&&(this.level=k,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(k){return this.level!==o.Off&&this.level<=k}}e.AbstractLogger=n;class c extends n{constructor(k){super(),this.logAlways=k}checkLogLevel(k){return this.logAlways||super.checkLogLevel(k)}trace(k,...P){this.checkLogLevel(o.Trace)&&this.log(o.Trace,i([k,...P],!0))}debug(k,...P){this.checkLogLevel(o.Debug)&&this.log(o.Debug,i([k,...P]))}info(k,...P){this.checkLogLevel(o.Info)&&this.log(o.Info,i([k,...P]))}warn(k,...P){this.checkLogLevel(o.Warning)&&this.log(o.Warning,i([k,...P]))}error(k,...P){if(this.checkLogLevel(o.Error))if(k instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=k.stack,this.log(o.Error,i(H))}else this.log(o.Error,i([k,...P]))}flush(){}}e.AbstractMessageLogger=c;class u extends n{constructor(k=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(k),this.useColors=!v.isWindows}trace(k,...P){this.checkLogLevel(o.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,k,...P):console.log(`[main ${m()}]`,k,...P))}debug(k,...P){this.checkLogLevel(o.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,k,...P):console.log(`[main ${m()}]`,k,...P))}info(k,...P){this.checkLogLevel(o.Info)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,k,...P):console.log(`[main ${m()}]`,k,...P))}warn(k,...P){this.checkLogLevel(o.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,k,...P):console.warn(`[main ${m()}]`,k,...P))}error(k,...P){this.checkLogLevel(o.Error)&&(this.useColors?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,k,...P):console.error(`[main ${m()}]`,k,...P))}flush(){}}e.ConsoleMainLogger=u;class t extends n{constructor(k=e.DEFAULT_LOG_LEVEL,P=!0){super(),this.useColors=P,this.setLevel(k)}trace(k,...P){this.checkLogLevel(o.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",k,...P):console.log(k,...P))}debug(k,...P){this.checkLogLevel(o.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",k,...P):console.log(k,...P))}info(k,...P){this.checkLogLevel(o.Info)&&(this.useColors?console.log("%c INFO","color: #33f",k,...P):console.log(k,...P))}warn(k,...P){this.checkLogLevel(o.Warning)&&(this.useColors?console.log("%c WARN","color: #993",k,...P):console.log(k,...P))}error(k,...P){this.checkLogLevel(o.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",k,...P):console.error(k,...P))}flush(){}}e.ConsoleLogger=t;class f extends n{constructor(k,P=e.DEFAULT_LOG_LEVEL){super(),this.adapter=k,this.setLevel(P)}trace(k,...P){this.checkLogLevel(o.Trace)&&this.adapter.log(o.Trace,[this.extractMessage(k),...P])}debug(k,...P){this.checkLogLevel(o.Debug)&&this.adapter.log(o.Debug,[this.extractMessage(k),...P])}info(k,...P){this.checkLogLevel(o.Info)&&this.adapter.log(o.Info,[this.extractMessage(k),...P])}warn(k,...P){this.checkLogLevel(o.Warning)&&this.adapter.log(o.Warning,[this.extractMessage(k),...P])}error(k,...P){this.checkLogLevel(o.Error)&&this.adapter.log(o.Error,[this.extractMessage(k),...P])}extractMessage(k){return typeof k=="string"?k:(0,L.toErrorMessage)(k,this.checkLogLevel(o.Trace))}flush(){}}e.AdapterLogger=f;class a extends n{constructor(k){super(),this.loggers=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const P of this.loggers)P.setLevel(k);super.setLevel(k)}trace(k,...P){for(const H of this.loggers)H.trace(k,...P)}debug(k,...P){for(const H of this.loggers)H.debug(k,...P)}info(k,...P){for(const H of this.loggers)H.info(k,...P)}warn(k,...P){for(const H of this.loggers)H.warn(k,...P)}error(k,...P){for(const H of this.loggers)H.error(k,...P)}flush(){for(const k of this.loggers)k.flush()}dispose(){for(const k of this.loggers)k.dispose();super.dispose()}}e.MultiplexLogger=a;class p extends A.Disposable{constructor(k,P,H){if(super(),this.logLevel=k,this.logsHome=P,this._loggers=new E.ResourceMap,this._onDidChangeLoggers=this._register(new T.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,H)for(const $ of H)this._loggers.set($.resource,{logger:void 0,info:$})}getLoggerEntry(k){return(0,N.isString)(k)?[...this._loggers.values()].find(P=>P.info.id===k):this._loggers.get(k)}getLogger(k){return this.getLoggerEntry(k)?.logger}createLogger(k,P){const H=this.toResource(k),$=(0,N.isString)(k)?k:P?.id??(0,O.hash)(H.toString()).toString(16);let V=this._loggers.get(H)?.logger;const R=P?.logLevel==="always"?o.Trace:P?.logLevel;V||(V=this.doCreateLogger(H,R??this.getLogLevel(H)??this.logLevel,{...P,id:$}));const z={logger:V,info:{resource:H,id:$,logLevel:R,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(z.info),this._loggers.set(H,z),V}toResource(k){return(0,N.isString)(k)?(0,_.joinPath)(this.logsHome,`${k}.log`):k}setLogLevel(k,P){if(y.URI.isUri(k)){const H=k,$=P,V=this._loggers.get(H);V&&$!==V.info.logLevel&&(V.info.logLevel=$===this.logLevel?void 0:$,V.logger?.setLevel($),this._loggers.set(V.info.resource,V),this._onDidChangeLogLevel.fire([H,$]))}else{this.logLevel=k;for(const[H,$]of this._loggers.entries())this._loggers.get(H)?.info.logLevel===void 0&&$.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(k,P){const H=this.getLoggerEntry(k);H&&P!==!H.info.hidden&&(H.info.hidden=!P,this._loggers.set(H.info.resource,H),this._onDidChangeVisibility.fire([H.info.resource,P]))}getLogLevel(k){let P;return k&&(P=this._loggers.get(k)?.info.logLevel),P??this.logLevel}registerLogger(k){const P=this._loggers.get(k.resource);P?P.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this._loggers.set(k.resource,{info:k,logger:void 0}),this._onDidChangeLoggers.fire({added:[k],removed:[]}))}deregisterLogger(k){const P=this._loggers.get(k);P&&(P.logger&&P.logger.dispose(),this._loggers.delete(k),this._onDidChangeLoggers.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const k of this._loggers.values())yield k.info}getRegisteredLogger(k){return this._loggers.get(k)?.info}dispose(){this._loggers.forEach(k=>k.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class l{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(k){}getLevel(){return o.Info}trace(k,...P){}debug(k,...P){}info(k,...P){}warn(k,...P){}error(k,...P){}critical(k,...P){}dispose(){}flush(){}}e.NullLogger=l;class D extends l{}e.NullLogService=D;function d(S){if(S.verbose)return o.Trace;if(typeof S.logLevel=="string"){const k=C(S.logLevel.toLowerCase());if(k!==void 0)return k}return e.DEFAULT_LOG_LEVEL}function w(S){switch(S){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function g(S){switch(S){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function C(S){switch(S){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.CONTEXT_LOG_LEVEL=new h.RawContextKey("logLevel",w(o.Info))}),define(Ie[201],Pe([1,0,6,12]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class T extends I.Disposable{constructor(A,E=[]){super(),this.logger=new L.MultiplexLogger([A,...E]),this._register(A.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(A){this.logger.setLevel(A)}getLevel(){return this.logger.getLevel()}trace(A,...E){this.logger.trace(A,...E)}debug(A,...E){this.logger.debug(A,...E)}info(A,...E){this.logger.info(A,...E)}warn(A,...E){this.logger.warn(A,...E)}error(A,...E){this.logger.error(A,...E)}flush(){this.logger.flush()}}e.LogService=T}),define(Ie[101],Pe([1,0,33,167,3]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(v){function _(m,r){return r-m}v.compare=_;const N=Object.create(null);N[v.Error]=(0,L.localize)(0,null),N[v.Warning]=(0,L.localize)(1,null),N[v.Info]=(0,L.localize)(2,null);function y(m){return N[m]||""}v.toString=y;function h(m){switch(m){case I.default.Error:return v.Error;case I.default.Warning:return v.Warning;case I.default.Info:return v.Info;case I.default.Ignore:return v.Hint}}v.fromSeverity=h;function b(m){switch(m){case v.Error:return I.default.Error;case v.Warning:return I.default.Warning;case v.Info:return I.default.Info;case v.Hint:return I.default.Ignore}}v.toSeverity=b}(A||(e.MarkerSeverity=A={}));var E;(function(v){const _="";function N(h){return y(h,!0)}v.makeKey=N;function y(h,b){const m=[_];return h.source?m.push(h.source.replace("\xA6","\\\xA6")):m.push(_),h.code?typeof h.code=="string"?m.push(h.code.replace("\xA6","\\\xA6")):m.push(h.code.value.replace("\xA6","\\\xA6")):m.push(_),h.severity!==void 0&&h.severity!==null?m.push(A.toString(h.severity)):m.push(_),h.message&&b?m.push(h.message.replace("\xA6","\\\xA6")):m.push(_),h.startLineNumber!==void 0&&h.startLineNumber!==null?m.push(h.startLineNumber.toString()):m.push(_),h.startColumn!==void 0&&h.startColumn!==null?m.push(h.startColumn.toString()):m.push(_),h.endLineNumber!==void 0&&h.endLineNumber!==null?m.push(h.endLineNumber.toString()):m.push(_),h.endColumn!==void 0&&h.endColumn!==null?m.push(h.endColumn.toString()):m.push(_),m.push(_),m.join("\xA6")}v.makeKeyOptionalMessage=y})(E||(e.IMarkerData=E={})),e.IMarkerService=(0,T.createDecorator)("markerService")}),define(Ie[202],Pe([1,0,5,33,3]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=E,e.Severity=L.default,e.INotificationService=(0,T.createDecorator)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function E(y){if(y){const h=y;return typeof h.id=="string"&&typeof h.label=="string"}return!1}var v;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(v||(e.NotificationsFilter=v={}));class _{constructor(){this.progress=new N,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(h){}updateMessage(h){}updateActions(h){}close(){}}e.NoOpNotification=_;class N{infinite(){}done(){}total(h){}worked(h){}}e.NoOpProgress=N}),define(Ie[102],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(ue,e,I,L){var T=arguments.length,O=T<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,I):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ue,e,I,L);else for(var E=ue.length-1;E>=0;E--)(A=ue[E])&&(O=(T<3?A(O):T>3?A(e,I,O):A(e,I))||O);return T>3&&O&&Object.defineProperty(e,I,O),O},He=this&&this.__param||function(ue,e){return function(I,L){e(I,L,ue)}};define(Ie[103],Pe([1,0,11,24,6,3]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,O.createDecorator)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class E{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(h){this.callback=h}report(h){this._value=h,this.callback(this._value)}}e.Progress=E;class v{get value(){return this._value}constructor(h){this.callback=h}report(h){this._asyncQueue?this._asyncQueue.push(h):this._asyncQueue=[h],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const h=this._asyncQueue.shift();this._value=h,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const h=this._drainListener;this._drainListener=void 0,h?.()}}drain(){return this._processingAsyncQueue?new Promise(h=>{const b=this._drainListener;this._drainListener=()=>{b?.(),h()}}):Promise.resolve()}}e.AsyncProgress=v;let _=class extends T.Disposable{constructor(h,b){super(),this.deferred=new I.DeferredPromise,b.withProgress(h,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(h){this.reporter?this.reporter.report(h):this.lastStep=h}};e.UnmanagedProgress=_,e.UnmanagedProgress=_=Ke([He(1,e.IProgressService)],_);class N extends T.Disposable{constructor(h){super(),this.progressIndicator=h,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(h){this.stop();const b=++this.currentOperationId,m=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},h),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:m.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(h){this.currentOperationId===h&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=N,e.IEditorProgressService=(0,O.createDecorator)("editorProgressService")}),define(Ie[29],Pe([1,0,57,15]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(A,E){I.ok(L.isString(A)),I.ok(L.isObject(E)),I.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,E)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new T}),define(Ie[74],Pe([1,0,5,29]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class O{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(v,_){this.schemasById[T(v)]=_,this._onDidChangeSchema.fire(v)}notifySchemaChanged(v){this._onDidChangeSchema.fire(v)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new O;L.Registry.add(e.Extensions.JSONContribution,A)}),define(Ie[51],Pe([1,0,18,5,15,160,50,74,29]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=r,e.keyFromOverrideIdentifiers=o,e.getDefaultValue=s,e.validateProperty=n,e.getScopes=c;var _;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(_||(e.EditPresentationTypes=_={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N||(e.ConfigurationScope=N={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=v.Registry.as(E.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const a=new Set;this.doRegisterConfigurations(t,f,a),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(t){const f=new Set;this.doDeregisterConfigurations(t,f),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f})}updateConfigurations({add:t,remove:f}){const a=new Set;this.doDeregisterConfigurations(f,a),this.doRegisterConfigurations(t,!1,a),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}registerDefaultConfigurations(t){const f=new Set;this.doRegisterDefaultConfigurations(t,f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,f){const a=[];for(const{overrides:p,source:l}of t)for(const D in p)if(f.add(D),e.OVERRIDE_PROPERTY_REGEX.test(D)){const d=this.configurationDefaultsOverrides.get(D),w=d?.valuesSources??new Map;if(l)for(const k of Object.keys(p[D]))w.set(k,l);const g={...d?.value||{},...p[D]};this.configurationDefaultsOverrides.set(D,{source:l,value:g,valuesSources:w});const C=(0,A.getLanguageTagSettingPlainKey)(D),S={type:"object",default:g,description:O.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:T.isString(l)?void 0:l,defaultValueSource:l};a.push(...r(D)),this.configurationProperties[D]=S,this.defaultLanguageConfigurationOverridesNode.properties[D]=S}else{this.configurationDefaultsOverrides.set(D,{value:p[D],source:l});const d=this.configurationProperties[D];d&&(this.updatePropertyDefaultValue(D,d),this.updateSchema(D,d))}this.doRegisterOverrideIdentifiers(a)}deregisterDefaultConfigurations(t){const f=new Set;this.doDeregisterDefaultConfigurations(t,f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,f){for(const{overrides:a,source:p}of t)for(const l in a){const D=this.configurationDefaultsOverrides.get(l),d=T.isString(p)?p:p?.id,w=T.isString(D?.source)?D?.source:D?.source?.id;if(d===w)if(f.add(l),this.configurationDefaultsOverrides.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const g=this.configurationProperties[l];g&&(this.updatePropertyDefaultValue(l,g),this.updateSchema(l,g))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let f=!1;const a=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,a),f=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,a),f=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,a),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const f of t)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,f,a){t.forEach(p=>{this.validateAndRegisterProperties(p,f,p.extensionInfo,p.restrictedProperties,void 0,a),this.configurationContributors.push(p),this.registerJSONConfiguration(p)})}doDeregisterConfigurations(t,f){const a=p=>{if(p.properties)for(const l in p.properties){f.add(l);const D=this.configurationProperties[l];D?.policy?.name&&this.policyConfigurations.delete(D.policy.name),delete this.configurationProperties[l],this.removeFromSchema(l,p.properties[l])}p.allOf?.forEach(l=>a(l))};for(const p of t){a(p);const l=this.configurationContributors.indexOf(p);l!==-1&&this.configurationContributors.splice(l,1)}}validateAndRegisterProperties(t,f=!0,a,p,l=3,D){l=T.isUndefinedOrNull(t.scope)?l:t.scope;const d=t.properties;if(d)for(const g in d){const C=d[g];if(f&&n(g,C)){delete d[g];continue}if(C.source=a,C.defaultDefaultValue=d[g].default,this.updatePropertyDefaultValue(g,C),e.OVERRIDE_PROPERTY_REGEX.test(g)?C.scope=void 0:(C.scope=T.isUndefinedOrNull(C.scope)?l:C.scope,C.restricted=T.isUndefinedOrNull(C.restricted)?!!p?.includes(g):C.restricted),d[g].hasOwnProperty("included")&&!d[g].included){this.excludedConfigurationProperties[g]=d[g],delete d[g];continue}else this.configurationProperties[g]=d[g],d[g].policy?.name&&this.policyConfigurations.set(d[g].policy.name,g);!d[g].deprecationMessage&&d[g].markdownDeprecationMessage&&(d[g].deprecationMessage=d[g].markdownDeprecationMessage),D.add(g)}const w=t.allOf;if(w)for(const g of w)this.validateAndRegisterProperties(g,f,a,p,l,D)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const f=a=>{const p=a.properties;if(p)for(const D in p)this.updateSchema(D,p[D]);a.allOf?.forEach(f)};f(t)}updateSchema(t,f){switch(e.allSettings.properties[t]=f,f.scope){case 1:e.applicationSettings.properties[t]=f;break;case 2:e.machineSettings.properties[t]=f;break;case 6:e.machineOverridableSettings.properties[t]=f;break;case 3:e.windowSettings.properties[t]=f;break;case 4:e.resourceSettings.properties[t]=f;break;case 5:e.resourceSettings.properties[t]=f,this.resourceLanguageSettingsSchema.properties[t]=f;break}}removeFromSchema(t,f){switch(delete e.allSettings.properties[t],f.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const f=`[${t}]`,a={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,a),e.allSettings.properties[f]=a,e.applicationSettings.properties[f]=a,e.machineSettings.properties[f]=a,e.machineOverridableSettings.properties[f]=a,e.windowSettings.properties[f]=a,e.resourceSettings.properties[f]=a}}registerOverridePropertyPatternKey(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,f){const a=this.configurationDefaultsOverrides.get(t);let p=a?.value,l=a?.source;T.isUndefined(p)&&(p=f.defaultDefaultValue,l=void 0),T.isUndefined(p)&&(p=s(f.type)),f.default=p,f.defaultValueSource=l}}const b="\\[([^\\]]+)\\]",m=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function r(u){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let f=m.exec(u);for(;f?.length;){const a=f[1].trim();a&&t.push(a),f=m.exec(u)}}return(0,I.distinct)(t)}function o(u){return u.reduce((t,f)=>`${t}[${f}]`,"")}function s(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new h;v.Registry.add(e.Extensions.Configuration,i);function n(u,t){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?O.localize(7,null,u):i.getConfigurationProperties()[u]!==void 0?O.localize(8,null,u):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,u,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function c(){const u=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))u.push([f,t[f].scope]);return u.push(["launch",4]),u.push(["task",4]),u}}),define(Ie[203],Pe([1,0,18,5,126,6,28,25,15,2,50,51,29]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=n;function b(f){return Object.isFrozen(f)?f:E.deepFreeze(f)}class m{static createEmptyModel(a){return new m({},[],[],void 0,a)}constructor(a,p,l,D,d){this._contents=a,this._keys=p,this._overrides=l,this.raw=D,this.logService=d,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const a=this.raw.map(p=>{if(p instanceof m)return p;const l=new r("",this.logService);return l.parseRaw(p),l.configurationModel});this._rawConfiguration=a.reduce((p,l)=>l===p?l:p.merge(l),a[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(a){return a?(0,N.getConfigurationValue)(this.contents,a):this.contents}inspect(a,p){const l=this;return{get value(){return b(l.rawConfiguration.getValue(a))},get override(){return p?b(l.rawConfiguration.getOverrideValue(a,p)):void 0},get merged(){return b(p?l.rawConfiguration.override(p).getValue(a):l.rawConfiguration.getValue(a))},get overrides(){const D=[];for(const{contents:d,identifiers:w,keys:g}of l.rawConfiguration.overrides){const C=new m(d,g,[],void 0,l.logService).getValue(a);C!==void 0&&D.push({identifiers:w,value:C})}return D.length?b(D):void 0}}}getOverrideValue(a,p){const l=this.getContentsForOverrideIdentifer(p);return l?a?(0,N.getConfigurationValue)(l,a):l:void 0}getKeysForOverrideIdentifier(a){const p=[];for(const l of this.overrides)l.identifiers.includes(a)&&p.push(...l.keys);return I.distinct(p)}getAllOverrideIdentifiers(){const a=[];for(const p of this.overrides)a.push(...p.identifiers);return I.distinct(a)}override(a){let p=this.overrideConfigurations.get(a);return p||(p=this.createOverrideConfigurationModel(a),this.overrideConfigurations.set(a,p)),p}merge(...a){const p=E.deepClone(this.contents),l=E.deepClone(this.overrides),D=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const w of a)if(d.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.mergeContents(p,w.contents);for(const g of w.overrides){const[C]=l.filter(S=>I.equals(S.identifiers,g.identifiers));C?(this.mergeContents(C.contents,g.contents),C.keys.push(...g.keys),C.keys=I.distinct(C.keys)):l.push(E.deepClone(g))}for(const g of w.keys)D.indexOf(g)===-1&&D.push(g)}return new m(p,D,l,d.every(w=>w instanceof m)?void 0:d,this.logService)}createOverrideConfigurationModel(a){const p=this.getContentsForOverrideIdentifer(a);if(!p||typeof p!="object"||!Object.keys(p).length)return this;const l={};for(const D of I.distinct([...Object.keys(this.contents),...Object.keys(p)])){let d=this.contents[D];const w=p[D];w&&(typeof d=="object"&&typeof w=="object"?(d=E.deepClone(d),this.mergeContents(d,w)):d=w),l[D]=d}return new m(l,this.keys,this.overrides,void 0,this.logService)}mergeContents(a,p){for(const l of Object.keys(p)){if(l in a&&v.isObject(a[l])&&v.isObject(p[l])){this.mergeContents(a[l],p[l]);continue}a[l]=E.deepClone(p[l])}}getContentsForOverrideIdentifer(a){let p=null,l=null;const D=d=>{d&&(l?this.mergeContents(l,d):l=E.deepClone(d))};for(const d of this.overrides)d.identifiers.length===1&&d.identifiers[0]===a?p=d.contents:d.identifiers.includes(a)&&D(d.contents);return D(p),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,p){this.updateValue(a,p,!0)}setValue(a,p){this.updateValue(a,p,!1)}removeValue(a){const p=this.keys.indexOf(a);p!==-1&&(this.keys.splice(p,1),(0,N.removeFromValueTree)(this.contents,a),y.OVERRIDE_PROPERTY_REGEX.test(a)&&this.overrides.splice(this.overrides.findIndex(l=>I.equals(l.identifiers,(0,y.overrideIdentifiersFromKey)(a))),1))}updateValue(a,p,l){(0,N.addToValueTree)(this.contents,a,p,D=>this.logService.error(D)),l=l||this.keys.indexOf(a)===-1,l&&this.keys.push(a),y.OVERRIDE_PROPERTY_REGEX.test(a)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(a),keys:Object.keys(this.contents[a]),contents:(0,N.toValuesTree)(this.contents[a],D=>this.logService.error(D))})}}e.ConfigurationModel=m;class r{constructor(a,p){this._name=a,this.logService=p,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||m.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(a,p){if(!v.isUndefinedOrNull(a)){const l=this.doParseContent(a);this.parseRaw(l,p)}}reparse(a){this._raw&&this.parseRaw(this._raw,a)}parseRaw(a,p){this._raw=a;const{contents:l,keys:D,overrides:d,restricted:w,hasExcludedProperties:g}=this.doParseRaw(a,p);this._configurationModel=new m(l,D,d,g?[a]:void 0,this.logService),this._restrictedConfigurations=w||[]}doParseContent(a){let p={},l=null,D=[];const d=[],w=[];function g(S){Array.isArray(D)?D.push(S):l!==null&&(D[l]=S)}const C={onObjectBegin:()=>{const S={};g(S),d.push(D),D=S,l=null},onObjectProperty:S=>{l=S},onObjectEnd:()=>{D=d.pop()},onArrayBegin:()=>{const S=[];g(S),d.push(D),D=S,l=null},onArrayEnd:()=>{D=d.pop()},onLiteralValue:g,onError:(S,k,P)=>{w.push({error:S,offset:k,length:P})}};if(a)try{T.visit(a,C),p=D[0]||{}}catch(S){this.logService.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return p}doParseRaw(a,p){const l=h.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),D=this.filter(a,l,!0,p);a=D.raw;const d=(0,N.toValuesTree)(a,C=>this.logService.error(`Conflict in settings file ${this._name}: ${C}`)),w=Object.keys(a),g=this.toOverrides(a,C=>this.logService.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:d,keys:w,overrides:g,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}filter(a,p,l,D){let d=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:d};const w={},g=[];for(const C in a)if(y.OVERRIDE_PROPERTY_REGEX.test(C)&&l){const S=this.filter(a[C],p,!1,D);w[C]=S.raw,d=d||S.hasExcludedProperties,g.push(...S.restricted)}else{const S=p[C],k=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&g.push(C),!D.exclude?.includes(C)&&(D.include?.includes(C)||(k===void 0||D.scopes===void 0||D.scopes.includes(k))&&!(D.skipRestricted&&S?.restricted))?w[C]=a[C]:d=!0}return{raw:w,restricted:g,hasExcludedProperties:d}}toOverrides(a,p){const l=[];for(const D of Object.keys(a))if(y.OVERRIDE_PROPERTY_REGEX.test(D)){const d={};for(const w in a[D])d[w]=a[D][w];l.push({identifiers:(0,y.overrideIdentifiersFromKey)(D),keys:Object.keys(d),contents:(0,N.toValuesTree)(d,p)})}return l}}e.ConfigurationModelParser=r;class o extends O.Disposable{constructor(a,p,l,D,d){super(),this.userSettingsResource=a,this.parseOptions=p,this.fileService=D,this.logService=d,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new r(this.userSettingsResource.toString(),d),this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&l.isEqual(w.resource,a)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const a=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(a.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return m.createEmptyModel(this.logService)}}reparse(a){return a&&(this.parseOptions=a),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=o;class s{constructor(a,p,l,D,d,w,g,C,S,k,P,H,$){this.key=a,this.overrides=p,this._value=l,this.overrideIdentifiers=D,this.defaultConfiguration=d,this.policyConfiguration=w,this.applicationConfiguration=g,this.userConfiguration=C,this.localUserConfiguration=S,this.remoteUserConfiguration=k,this.workspaceConfiguration=P,this.folderConfigurationModel=H,this.memoryConfigurationModel=$}get value(){return b(this._value)}toInspectValue(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class i{constructor(a,p,l,D,d,w,g,C,S,k){this._defaultConfiguration=a,this._policyConfiguration=p,this._applicationConfiguration=l,this._localUserConfiguration=D,this._remoteUserConfiguration=d,this._workspaceConfiguration=w,this._folderConfigurations=g,this._memoryConfiguration=C,this._memoryConfigurationByResource=S,this.logService=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(a,p,l){return this.getConsolidatedConfigurationModel(a,p,l).getValue(a)}updateValue(a,p,l={}){let D;l.resource?(D=this._memoryConfigurationByResource.get(l.resource),D||(D=m.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(l.resource,D))):D=this._memoryConfiguration,p===void 0?D.removeValue(a):D.setValue(a,p),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(a,p,l){const D=this.getConsolidatedConfigurationModel(a,p,l),d=this.getFolderConfigurationModelForResource(p.resource,l),w=p.resource?this._memoryConfigurationByResource.get(p.resource)||this._memoryConfiguration:this._memoryConfiguration,g=new Set;for(const C of D.overrides)for(const S of C.identifiers)D.getOverrideValue(a,S)!==void 0&&g.add(S);return new s(a,p,D.getValue(a),g.size?[...g]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this._workspaceConfiguration:void 0,d||void 0,w)}keys(a){const p=this.getFolderConfigurationModelForResource(void 0,a);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:p?p.keys.slice(0):[]}}updateDefaultConfiguration(a){this._defaultConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(a){this._policyConfiguration=a}updateApplicationConfiguration(a){this._applicationConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(a){this._localUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(a){this._remoteUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(a){this._workspaceConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(a,p){this._folderConfigurations.set(a,p),this._foldersConsolidatedConfigurations.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this._foldersConsolidatedConfigurations.delete(a)}compareAndUpdateDefaultConfiguration(a,p){const l=[];if(!p){const{added:D,updated:d,removed:w}=u(this._defaultConfiguration,a);p=[...D,...d,...w]}for(const D of p)for(const d of(0,y.overrideIdentifiersFromKey)(D)){const w=this._defaultConfiguration.getKeysForOverrideIdentifier(d),g=a.getKeysForOverrideIdentifier(d),C=[...g.filter(S=>w.indexOf(S)===-1),...w.filter(S=>g.indexOf(S)===-1),...w.filter(S=>!E.equals(this._defaultConfiguration.override(d).getValue(S),a.override(d).getValue(S)))];l.push([d,C])}return this.updateDefaultConfiguration(a),{keys:p,overrides:l}}compareAndUpdatePolicyConfiguration(a){const{added:p,updated:l,removed:D}=u(this._policyConfiguration,a),d=[...p,...l,...D];return d.length&&this.updatePolicyConfiguration(a),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:p,updated:l,removed:D,overrides:d}=u(this.applicationConfiguration,a),w=[...p,...l,...D];return w.length&&this.updateApplicationConfiguration(a),{keys:w,overrides:d}}compareAndUpdateLocalUserConfiguration(a){const{added:p,updated:l,removed:D,overrides:d}=u(this.localUserConfiguration,a),w=[...p,...l,...D];return w.length&&this.updateLocalUserConfiguration(a),{keys:w,overrides:d}}compareAndUpdateRemoteUserConfiguration(a){const{added:p,updated:l,removed:D,overrides:d}=u(this.remoteUserConfiguration,a),w=[...p,...l,...D];return w.length&&this.updateRemoteUserConfiguration(a),{keys:w,overrides:d}}compareAndUpdateWorkspaceConfiguration(a){const{added:p,updated:l,removed:D,overrides:d}=u(this.workspaceConfiguration,a),w=[...p,...l,...D];return w.length&&this.updateWorkspaceConfiguration(a),{keys:w,overrides:d}}compareAndUpdateFolderConfiguration(a,p){const l=this.folderConfigurations.get(a),{added:D,updated:d,removed:w,overrides:g}=u(l,p),C=[...D,...d,...w];return(C.length||!l)&&this.updateFolderConfiguration(a,p),{keys:C,overrides:g}}compareAndDeleteFolderConfiguration(a){const p=this.folderConfigurations.get(a);if(!p)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:l,updated:D,removed:d,overrides:w}=u(p,void 0);return{keys:[...l,...D,...d],overrides:w}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(a,p,l){let D=this.getConsolidatedConfigurationModelForResource(p,l);return p.overrideIdentifier&&(D=D.override(p.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(a)!==void 0&&(D=D.merge(this._policyConfiguration)),D}getConsolidatedConfigurationModelForResource({resource:a},p){let l=this.getWorkspaceConsolidatedConfiguration();if(p&&a){const D=p.getFolder(a);D&&(l=this.getFolderConsolidatedConfiguration(D.uri)||l);const d=this._memoryConfigurationByResource.get(a);d&&(l=l.merge(d))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(a){let p=this._foldersConsolidatedConfigurations.get(a);if(!p){const l=this.getWorkspaceConsolidatedConfiguration(),D=this._folderConfigurations.get(a);D?(p=l.merge(D),this._foldersConsolidatedConfigurations.set(a,p)):p=l}return p}getFolderConfigurationModelForResource(a,p){if(p&&a){const l=p.getFolder(a);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((a,p)=>{const{contents:l,overrides:D,keys:d}=this._folderConfigurations.get(p);return a.push([p,{contents:l,overrides:D,keys:d}]),a},[])}}allKeys(){const a=new Set;return this._defaultConfiguration.keys.forEach(p=>a.add(p)),this.userConfiguration.keys.forEach(p=>a.add(p)),this._workspaceConfiguration.keys.forEach(p=>a.add(p)),this._folderConfigurations.forEach(p=>p.keys.forEach(l=>a.add(l))),[...a.values()]}allOverrideIdentifiers(){const a=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(p=>a.add(p)),this.userConfiguration.getAllOverrideIdentifiers().forEach(p=>a.add(p)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(p=>a.add(p)),this._folderConfigurations.forEach(p=>p.getAllOverrideIdentifiers().forEach(l=>a.add(l))),[...a.values()]}getAllKeysForOverrideIdentifier(a){const p=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(a).forEach(l=>p.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(l=>p.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(a).forEach(l=>p.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(a).forEach(D=>p.add(D))),[...p.values()]}static parse(a,p){const l=this.parseConfigurationModel(a.defaults,p),D=this.parseConfigurationModel(a.policy,p),d=this.parseConfigurationModel(a.application,p),w=this.parseConfigurationModel(a.user,p),g=this.parseConfigurationModel(a.workspace,p),C=a.folders.reduce((S,k)=>(S.set(_.URI.revive(k[0]),this.parseConfigurationModel(k[1],p)),S),new A.ResourceMap);return new i(l,D,d,w,m.createEmptyModel(p),g,C,m.createEmptyModel(p),new A.ResourceMap,p)}static parseConfigurationModel(a,p){return new m(a.contents,a.keys,a.overrides,void 0,p)}}e.Configuration=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const a=new Set,p=new Map;for(const D of f)D.keys.forEach(d=>a.add(d)),D.overrides.forEach(([d,w])=>{const g=(0,A.getOrSet)(p,d,new Set);w.forEach(C=>g.add(C))});const l=[];return p.forEach((D,d)=>l.push([d,[...D.values()]])),{keys:[...a.values()],overrides:l}}class c{constructor(a,p,l,D,d){this.change=a,this.previous=p,this.currentConfiguraiton=l,this.currentWorkspace=D,this.logService=d,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const w of a.keys)this.affectedKeys.add(w);for(const[,w]of a.overrides)for(const g of w)this.affectedKeys.add(g);this._affectsConfigStr=this._marker;for(const w of this.affectedKeys)this._affectsConfigStr+=w+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=i.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(a,p){const l=this._marker+a,D=this._affectsConfigStr.indexOf(l);if(D<0)return!1;const d=D+l.length;if(d>=this._affectsConfigStr.length)return!1;const w=this._affectsConfigStr.charCodeAt(d);if(w!==this._markerCode1&&w!==this._markerCode2)return!1;if(p){const g=this.previousConfiguration?this.previousConfiguration.getValue(a,p,this.previous?.workspace):void 0,C=this.currentConfiguraiton.getValue(a,p,this.currentWorkspace);return!E.equals(g,C)}return!0}}e.ConfigurationChangeEvent=c;function u(f,a){const{added:p,removed:l,updated:D}=t(a?.rawConfiguration,f?.rawConfiguration),d=[],w=f?.getAllOverrideIdentifiers()||[],g=a?.getAllOverrideIdentifiers()||[];if(a){const C=g.filter(S=>!w.includes(S));for(const S of C)d.push([S,a.getKeysForOverrideIdentifier(S)])}if(f){const C=w.filter(S=>!g.includes(S));for(const S of C)d.push([S,f.getKeysForOverrideIdentifier(S)])}if(a&&f){for(const C of w)if(g.includes(C)){const S=t({contents:f.getOverrideValue(void 0,C)||{},keys:f.getKeysForOverrideIdentifier(C)},{contents:a.getOverrideValue(void 0,C)||{},keys:a.getKeysForOverrideIdentifier(C)});d.push([C,[...S.added,...S.removed,...S.updated]])}}return{added:p,removed:l,updated:D,overrides:d}}function t(f,a){const p=f?a?f.keys.filter(d=>a.keys.indexOf(d)===-1):[...f.keys]:[],l=a?f?a.keys.filter(d=>f.keys.indexOf(d)===-1):[...a.keys]:[],D=[];if(f&&a){for(const d of a.keys)if(f.keys.indexOf(d)!==-1){const w=(0,N.getConfigurationValue)(a.contents,d),g=(0,N.getConfigurationValue)(f.contents,d);E.equals(w,g)||D.push(d)}}return{added:p,removed:l,updated:D}}}),define(Ie[104],Pe([1,0,14,3]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=_,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var T;(function(N){N[N.WebSocket=0]="WebSocket",N[N.Managed=1]="Managed"})(T||(e.RemoteConnectionType=T={}));class O{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class A{constructor(y,h){this.host=y,this.port=h,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=A;var E;(function(N){N.Unknown="Unknown",N.NotAvailable="NotAvailable",N.TemporarilyNotAvailable="TemporarilyNotAvailable",N.NoResolverFound="NoResolverFound",N.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class v extends I.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof v&&y._code===E.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof v&&y._code===E.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof v&&y._code===E.NoResolverFound}static isInvalidAuthority(y){return y instanceof v&&y._code===E.InvalidAuthority}static isHandled(y){return y instanceof v&&y.isHandled}constructor(y,h=E.Unknown,b){super(y),this._message=y,this._code=h,this._detail=b,this.isHandled=h===E.NotAvailable&&b===!0,Object.setPrototypeOf(this,v.prototype)}}e.RemoteAuthorityResolverError=v;function _(N){const y=N.indexOf("+");return y===-1?N:N.substring(0,y)}}),define(Ie[58],Pe([1,0,16]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=L,e.getRemoteName=T,e.parseAuthorityWithPort=O,e.parseAuthorityWithOptionalPort=A;function L(v){return v.scheme===I.Schemas.vscodeRemote?v.authority:void 0}function T(v){if(!v)return;const _=v.indexOf("+");return _<0?v:v.substr(0,_)}function O(v){const{host:_,port:N}=E(v);if(typeof N>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:_,port:N}}function A(v,_){let{host:N,port:y}=E(v);return typeof y>"u"&&(y=_),{host:N,port:y}}function E(v){const _=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(_)return{host:_[1],port:parseInt(_[2],10)};const N=v.match(/^(\[[0-9a-z:]+\])$/);if(N)return{host:N[1],port:void 0};const y=v.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:v,port:void 0}}}),define(Ie[20],Pe([1,0,13,3,58]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=O,e.isApplicationScopedExtension=y,e.isLanguagePackExtension=h,e.isAuthenticationProviderExtension=b,e.isResolverExtension=m,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var E;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.LINUX_PPC64LE="linux-ppc64le",r.LINUX_RISCV64="linux-riscv64",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class v{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const i=typeof o=="string"?o:o.value,n=typeof s=="string"?s:s.value;return I.equalsIgnoreCase(i,n)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.ExtensionIdentifier=v;class _{get size(){return this._set.size}constructor(o){if(this._set=new Set,o)for(const s of o)this.add(s)}add(o){this._set.add(v.toKey(o))}delete(o){return this._set.delete(v.toKey(o))}has(o){return this._set.has(v.toKey(o))}}e.ExtensionIdentifierSet=_;class N{constructor(){this._map=new Map}clear(){this._map.clear()}delete(o){this._map.delete(v.toKey(o))}get(o){return this._map.get(v.toKey(o))}has(o){return this._map.has(v.toKey(o))}set(o,s){this._map.set(v.toKey(o),s)}values(){return this._map.values()}forEach(o){this._map.forEach(o)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=N;function y(r){return h(r)}function h(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function b(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function m(r,o){if(o){const s=`onResolveRemoteAuthority:${(0,T.getRemoteName)(o)}`;return!!r.activationEvents?.includes(s)}return!1}e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[105],Pe([1,0,14,20]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this._generators=new Map,this._cache=new WeakMap}register(A,E){this._generators.set(A,E)}readActivationEvents(A){return this._cache.has(A)||this._cache.set(A,this._readActivationEvents(A)),this._cache.get(A)}createActivationEventsMap(A){const E=Object.create(null);for(const v of A){const _=this.readActivationEvents(v);_.length>0&&(E[L.ExtensionIdentifier.toKey(v.identifier)]=_)}return E}_readActivationEvents(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const E=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let v=0;v<E.length;v++)E[v]==="onUri"&&(E[v]=`onUri:${L.ExtensionIdentifier.toKey(A.identifier)}`);if(!A.contributes)return E;for(const v in A.contributes){const _=this._generators.get(v);if(!_)continue;const N=A.contributes[v],y=Array.isArray(N)?N:[N];try{_(y,E)}catch(h){(0,I.onUnexpectedError)(h)}}return E}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(Ie[204],Pe([1,0,21,14,6,168,51,3,12,29]),function(ue,e,I,L,T,O,A,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=h,e.hasNoContent=b,e.asText=m,e.asTextOrError=r,e.asJson=o,e.updateProxyConfigurationsScope=s,e.IRequestService=(0,E.createDecorator)("requestService");class N{constructor(u){this.original=u}toJSON(){if(!this.headers){const u=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.original[t];this.headers=u}return this.headers}}class y extends T.Disposable{constructor(u){super(),this.counter=0,this.logger=u.createLogger("network",{name:(0,O.localize)(0,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async logAndRequest(u,t,f){const a=`${u} #${++this.counter}: ${t.url}`;this.logger.trace(`${a} - begin`,t.type,new N(t.headers??{}));try{const p=await f();return this.logger.trace(`${a} - end`,t.type,p.res.statusCode,p.res.headers),p}catch(p){throw this.logger.error(`${a} - error`,t.type,(0,L.getErrorMessage)(p)),p}}}e.AbstractRequestService=y;function h(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function b(c){return c.res.statusCode===204}async function m(c){return b(c)?null:(await(0,I.streamToBuffer)(c.stream)).toString()}async function r(c){if(!h(c))throw new Error("Server returned "+c.res.statusCode);return m(c)}async function o(c){if(!h(c))throw new Error("Server returned "+c.res.statusCode);if(b(c))return null;const t=(await(0,I.streamToBuffer)(c.stream)).toString();try{return JSON.parse(t)}catch(f){throw f.message+=`:
`+t,f}}function s(c){n(c)}let i;function n(c){const u=_.Registry.as(A.Extensions.Configuration),t=i;i={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[i],remove:t?[t]:[]})}n(1)}),define(Ie[205],Pe([1,0,22,75,34]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=A,e.verifyMicrosoftInternalDomain=E;function O(v){if(I.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function A(v,_,N,y,h,b,m,r,o){const s=Object.create(null);s["common.machineId"]=b,s["common.sqmId"]=m,s.sessionID=(0,T.generateUuid)()+Date.now(),s.commitHash=y,s.version=h,s["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.PlatformToString)(I.platform),s["common.nodePlatform"]=L.platform,s["common.nodeArch"]=N,s["common.product"]=o||"desktop",r&&(s["common.msftInternal"]=r);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.isLinuxSnap&&(s["common.snap"]="true");const c=O(_);return c&&(s["common.platformDetail"]=c),s}function E(v){const _=L.env.USERDNSDOMAIN;if(!_)return!1;const N=_.toLowerCase();return v.some(y=>N===y)}}),define(Ie[206],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var T;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(T||(e.TelemetryConfiguration=T={}))}),define(Ie[59],Pe([1,0,25,15,58,205,206]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=N,e.isLoggingOnly=y,e.getTelemetryLevel=h,e.validateTelemetryData=b,e.cleanRemoteAuthority=r,e.isInternalTelemetry=s,e.getPiiPathsFromEnvironment=i,e.cleanData=u;class E{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=E;class v{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=v,e.NullTelemetryService=new v;class _{async publicLog(f,a,p){}async publicLogError(f,a,p){}}e.NullEndpointTelemetryService=_,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function N(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function y(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function h(t){const f=t.getValue(A.TELEMETRY_SETTING_ID),a=t.getValue(A.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(t){const f={},a={},p={};o(t,p);for(let l in p){l=l.length>150?l.substr(l.length-149):l;const D=p[l];typeof D=="number"?a[l]=D:typeof D=="boolean"?a[l]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${D.length}`),f[l]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(f[l]=D)}return{properties:f,measurements:a}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const f=(0,T.getRemoteName)(t);return m.has(f)?f:"other"}function o(t,f,a=0,p){if(t)for(const l of Object.getOwnPropertyNames(t)){const D=t[l],d=p?p+l:l;Array.isArray(D)?f[d]=(0,I.safeStringify)(D):D instanceof Date?f[d]=D.toISOString():(0,L.isObject)(D)?a<2?o(D,f,a+1,d+"."):f[d]=(0,I.safeStringify)(D):f[d]=D}}function s(t,f){const a=t.msftInternalDomains||[],p=f.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(a)||p}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const p=[];for(const w of f)for(;;){const g=w.exec(t);if(!g)break;p.push([g.index,w.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(a="";;){const w=D.exec(t);if(!w)break;const g=p.some(([C,S])=>w.index<S&&C<D.lastIndex);!l.test(w[0])&&!g&&(a+=t.substring(d,w.index)+"<REDACTED: user-file-path>",d=D.lastIndex)}return d<t.length&&(a+=t.substr(d)),a}function c(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of f)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function u(t,f){return(0,I.cloneAndChange)(t,a=>{if(a instanceof E||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let p=a.replaceAll("%20"," ");p=n(p,f);for(const l of f)p=p.replace(l,"");return p=c(p),p}})}}),define(Ie[207],Pe([1,0,13,100,20,22,2,14,75,59]),function(ue,e,I,L,T,O,A,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=N,e.getIdAndVersion=m,e.getExtensionId=r,e.adoptToGalleryExtensionId=o,e.getGalleryExtensionId=s,e.groupByExtension=i,e.getLocalExtensionTelemetryData=n,e.getGalleryExtensionTelemetryData=c,e.getExtensionDependencies=u,e.computeTargetPlatform=f;function N(a,p){return a.uuid&&p.uuid?a.uuid===p.uuid:a.id===p.id?!0:(0,I.compareIgnoreCase)(a.id,p.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(p){const l=p.manifest?p.manifest.version:p.version,D=p.manifest?p.targetPlatform:p.properties.targetPlatform;return new h(p.identifier,l,D)}static parse(p){const l=y.exec(p);return l&&l[1]&&l[2]?new h({id:l[1]},l[2],l[4]||void 0):null}constructor(p,l,D="undefined"){this.version=l,this.targetPlatform=D,this.id=p.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(p){return p instanceof h?N(this,p)&&this.version===p.version&&this.targetPlatform===p.targetPlatform:!1}}e.ExtensionKey=h;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(a){const p=b.exec(a);return p&&p[1]?[o(p[1]),p[2]]:[o(a),void 0]}function r(a,p){return`${a}.${p}`}function o(a){return a.toLowerCase()}function s(a,p){return o(r(a??T.UNDEFINED_PUBLISHER,p))}function i(a,p){const l=[],D=d=>{for(const w of l)if(w.some(g=>N(p(g),p(d))))return w;return null};for(const d of a){const w=D(d);w?w.push(d):l.push([d])}return l}function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new _.TelemetryTrustedValue(a.identifier.id),name:new _.TelemetryTrustedValue(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function u(a,p){const l=[],D=p.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const d=D.shift();if(d&&l.every(w=>!N(w.identifier,{id:d}))){const w=a.filter(g=>N(g.identifier,{id:d}));w.length===1&&(l.push(w[0]),D.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}async function t(a,p){if(!O.isLinux)return!1;let l;try{l=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){p.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(d))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(a,p){const l=await t(a,p),D=(0,L.getTargetPlatform)(l?"alpine":O.platform,v.arch);return p.debug("ComputeTargetPlatform:",D),D}}),define(Ie[208],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=I,e.serializeEnvironmentDescriptionMap=L,e.deserializeEnvironmentVariableCollection=T,e.deserializeEnvironmentDescriptionMap=O,e.serializeEnvironmentVariableCollections=A,e.deserializeEnvironmentVariableCollections=E;function I(v){return[...v.entries()]}function L(v){return v?[...v.entries()]:[]}function T(v){return new Map(v)}function O(v){return new Map(v??[])}function A(v){return Array.from(v.entries()).map(_=>[_[0],I(_[1].map),L(_[1].descriptionMap)])}function E(v){return new Map(v.map(_=>[_[0],{map:T(_[1]),descriptionMap:O(_[2])}]))}}),define(Ie[209],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class I{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,O,A=5){const E=O(v=>{const _=typeof v=="string"?v:v.data;let N=this._terminalBufferMap.get(T);if(N){N.data.push(_);return}const y=setTimeout(()=>this.flushBuffer(T),A);N={data:[_],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(T),E.dispose()}},this._terminalBufferMap.set(T,N)});return E}stopBuffering(T){this._terminalBufferMap.get(T)?.dispose()}flushBuffer(T){const O=this._terminalBufferMap.get(T);O&&(this._terminalBufferMap.delete(T),this._callback(T,O.data.join("")))}}e.TerminalDataBufferer=I}),define(Ie[210],Pe([1,0,11,92,312,36,5,15,2,169,74,29]),function(ue,e,I,L,T,O,A,E,v,_,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=o,e.getIconRegistry=s,e.Extensions={IconContribution:"base.contributions.icons"};var h;(function(u){function t(f,a){let p=f.defaults;for(;O.ThemeIcon.isThemeIcon(p);){const l=r.getIcon(p.id);if(!l)return;p=l.defaults}return p}u.getDefinition=t})(h||(e.IconContribution=h={}));var b;(function(u){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(p=>({format:p.format,location:p.location.toString()}))}}u.toJSONObject=t;function f(a){const p=l=>(0,E.isString)(l)?l:void 0;if(a&&Array.isArray(a.src)&&a.src.every(l=>(0,E.isString)(l.format)&&(0,E.isString)(l.location)))return{weight:p(a.weight),style:p(a.style),src:a.src.map(l=>({format:l.format,location:v.URI.parse(l.location)}))}}u.fromJSONObject=f})(b||(e.IconFontDefinition=b={}));class m{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,_.localize)(0,null)},fontCharacter:{type:"string",description:(0,_.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(t,f,a,p){const l=this.iconsById[t];if(l){if(a&&!l.description){l.description=a,this.iconSchema.properties[t].markdownDescription=`${a} $(${t})`;const w=this.iconReferenceSchema.enum.indexOf(t);w!==-1&&(this.iconReferenceSchema.enumDescriptions[w]=a),this._onDidChange.fire()}return l}const D={id:t,description:a,defaults:f,deprecationMessage:p};this.iconsById[t]=D;const d={$ref:"#/definitions/icons"};return p&&(d.deprecationMessage=p),a&&(d.markdownDescription=`${a}: $(${t})`),this.iconSchema.properties[t]=d,this.iconReferenceSchema.enum.push(t),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:t}}deregisterIcon(t){delete this.iconsById[t],delete this.iconSchema.properties[t];const f=this.iconReferenceSchema.enum.indexOf(t);f!==-1&&(this.iconReferenceSchema.enum.splice(f,1),this.iconReferenceSchema.enumDescriptions.splice(f,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(t=>this.iconsById[t])}getIcon(t){return this.iconsById[t]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(t,f){const a=this.iconFontsById[t];return a||(this.iconFontsById[t]=f,this._onDidChange.fire(),f)}deregisterIconFont(t){delete this.iconFontsById[t]}getIconFont(t){return this.iconFontsById[t]}toString(){const t=(l,D)=>l.id.localeCompare(D.id),f=l=>{for(;O.ThemeIcon.isThemeIcon(l.defaults);)l=this.iconsById[l.defaults.id];return`codicon codicon-${l?l.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const p=Object.keys(this.iconsById).map(l=>this.iconsById[l]);for(const l of p.filter(D=>!!D.description).sort(t))a.push(`|<i class="${f(l)}"></i>|${l.id}|${O.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const l of p.filter(D=>!O.ThemeIcon.isThemeIcon(D.defaults)).sort(t))a.push(`|<i class="${f(l)}"></i>|${l.id}|`);return a.join(`
`)}}const r=new m;y.Registry.add(e.Extensions.IconContribution,r);function o(u,t,f,a){return r.registerIcon(u,t,f,a)}function s(){return r}function i(){const u=(0,T.getCodiconFontCharacters)();for(const t in u){const f="\\"+u[t].toString(16);r.registerIcon(t,{fontCharacter:f})}}i(),e.iconsSchemaId="vscode://schemas/icons";const n=y.Registry.as(N.Extensions.JSONContribution);n.registerSchema(e.iconsSchemaId,r.getIconSchema());const c=new I.RunOnceScheduler(()=>n.notifySchemaChanged(e.iconsSchemaId),200);r.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.widgetClose=o("widget-close",L.Codicon.close,(0,_.localize)(2,null)),e.gotoPreviousLocation=o("goto-previous-location",L.Codicon.arrowUp,(0,_.localize)(3,null)),e.gotoNextLocation=o("goto-next-location",L.Codicon.arrowDown,(0,_.localize)(4,null)),e.syncing=O.ThemeIcon.modify(L.Codicon.sync,"spin"),e.spinningLoading=O.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(Ie[211],Pe([1,0,5,2,50,3,12]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=_,e.extractLocalHostUriMetaDataForPortMapping=y,e.extractQueryLocalHostUriMetaDataForPortMapping=h,e.isLocalhost=b,e.isAllInterfaces=m,e.isPortPrivileged=r,e.ITunnelService=(0,O.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,O.createDecorator)("sharedTunnelsService");var E;(function(i){i.Http="http",i.Https="https"})(E||(e.TunnelProtocol=E={}));var v;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(v||(e.TunnelPrivacyId=v={}));function _(i){return!!i.forwardPort}var N;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(N||(e.ProvidedOnAutoForward=N={}));function y(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function h(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const c of n){const u=c.split("=")[1];if(/^https?:/.exec(u)){const t=y(L.URI.parse(u));if(t)return t}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(i){return e.LOCALHOST_ADDRESSES.indexOf(i)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(i){return e.ALL_INTERFACES_ADDRESSES.indexOf(i)>=0}function r(i,n,c,u){if(c===1)return!1;if(c===2&&m(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class o{constructor(n,c,u){this.remoteAddress=n,this.localAddress=c,this._dispose=u,this._onDispose=new I.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=o;let s=class{constructor(n,c){this.logService=n,this.configurationService=c,this._onTunnelOpened=new I.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new I.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new I.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const n=this.configurationService.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this._tunnelProvider=n,n?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this._canElevate=n.elevation,this._privacyOptions=n.privacyOptions,this._canChangeProtocol=n.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const n=[],c=Array.from(this._tunnels.values());for(const u of c){const t=Array.from(u.values());for(const f of t){const a=await f.value;a&&typeof a!="string"&&n.push(a)}}return n}async dispose(){for(const n of this._tunnels.values()){for(const{value:c}of n.values())await c.then(u=>typeof u!="string"?u?.dispose():void 0);n.clear()}this._tunnels.clear()}setEnvironmentTunnel(n,c,u,t,f){this.addTunnelToMap(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:u,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(m(n)||b(n))&&(n=e.LOCALHOST_ADDRESSES[0]);const u=this.getTunnelFromMap(n,c);if(u)return++u.refcount,u.value}openTunnel(n,c,u,t,f,a=!1,p,l){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${u} on local port ${f}.`);const D=this._tunnelProvider??n;if(!D)return;if(c||(c="localhost"),t||(t=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(u)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(D,c,u,t,f,a,p,l);return d?d.then(w=>{if(w){if(typeof w=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(c,u),w}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(c,u);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.makeTunnel(w);return(w.tunnelRemoteHost!==c||w.tunnelRemotePort!==u)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),p&&w.privacy!==p&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(g),g}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this._tunnels.get(n.tunnelRemoteHost);if(c){const u=c.get(n.tunnelRemotePort);u&&(u.refcount--,await this.tryDisposeTunnel(n.tunnelRemoteHost,n.tunnelRemotePort,u))}}}}async tryDisposeTunnel(n,c,u){if(u.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const t=u.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(n)&&this._tunnels.get(n).delete(c),t}}async closeTunnel(n,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const u=this._tunnels.get(n);if(u&&u.has(c)){const t=u.get(c);t.refcount=0,await this.tryDisposeTunnel(n,c,t)}}addTunnelToMap(n,c,u){this._tunnels.has(n)||this._tunnels.set(n,new Map),this._tunnels.get(n).set(c,{refcount:1,value:u})}async removeEmptyOrErrorTunnelFromMap(n,c){const u=this._tunnels.get(n);if(u){const t=u.get(c),f=t?await t.value:void 0;(!f||typeof f=="string")&&u.delete(c),u.size===0&&this._tunnels.delete(n)}}getTunnelFromMap(n,c){const u=[n];b(n)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):m(n)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const t=u.map(f=>this._tunnels.get(f));for(const f of t){const a=f?.get(c);if(a)return a}}canTunnel(n){return!!y(n)}createWithProvider(n,c,u,t,f,a,p){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${u} on local port ${t}.`);const l=u;this._factoryInProgress.add(l);const D=t===void 0?u:t,d={elevationRequired:f?this.isPortPrivileged(D):!1},w={remoteAddress:{host:c,port:u},localAddressPort:t,privacy:a,public:a?a!==v.Private:void 0,protocol:p},g=n.forwardPort(w,d);return g?(this.addTunnelToMap(c,u,g),g.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(l)})):this._factoryInProgress.delete(l),g}};e.AbstractTunnelService=s,e.AbstractTunnelService=s=Ke([He(0,A.ILogService),He(1,T.IConfigurationService)],s)}),define(Ie[212],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(Ie[213],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,I.createDecorator)("editSessionIdentityService");var L;(function(T){T[T.Complete=100]="Complete",T[T.Partial=50]="Partial",T[T.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Ie[214],Pe([1,0,16]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=L,e.getVirtualWorkspaceLocation=T,e.getVirtualWorkspaceScheme=O,e.getVirtualWorkspaceAuthority=A,e.isVirtualWorkspace=E;function L(v){return v.scheme!==I.Schemas.file&&v.scheme!==I.Schemas.vscodeRemote}function T(v){if(v.folders.length)return v.folders.every(_=>L(_.uri))?v.folders[0].uri:void 0;if(v.configuration&&L(v.configuration))return v.configuration}function O(v){return T(v)?.scheme}function A(v){return T(v)?.authority}function E(v){return T(v)!==void 0}}),define(Ie[45],Pe([1,0,171,19,54,23,2,3,16]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=_,e.isEmptyWorkspaceIdentifier=N,e.toWorkspaceIdentifier=y,e.isWorkspaceIdentifier=h,e.reviveIdentifier=b,e.isWorkspace=r,e.isWorkspaceFolder=o,e.toWorkspaceFolder=n,e.isUntitledWorkspace=c,e.isTemporaryWorkspace=u,e.isStandaloneEditorWorkspace=t,e.isSavedWorkspace=f,e.hasWorkspaceFileExtension=a,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function _(p){const l=p;return typeof l?.id=="string"&&A.URI.isUri(l.uri)}function N(p){return typeof p?.id=="string"&&!_(p)&&!h(p)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(p,l){if(typeof p=="string"||typeof p>"u")return typeof p=="string"?{id:(0,L.basename)(p)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const D=p;return D.configuration?{id:D.id,configPath:D.configuration}:D.folders.length===1?{id:D.id,uri:D.folders[0].uri}:{id:D.id}}function h(p){const l=p;return typeof l?.id=="string"&&A.URI.isUri(l.configPath)}function b(p){const l=p;if(l?.uri)return{id:l.id,uri:A.URI.revive(l.uri)};const D=p;if(D?.configPath)return{id:D.id,configPath:A.URI.revive(D.configPath)};if(p?.id)return{id:p.id}}var m;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function r(p){const l=p;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}function o(p){const l=p;return!!(l&&typeof l=="object"&&A.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}class s{constructor(l,D,d,w,g){this._id=l,this._transient=d,this._configuration=w,this._ignorePathCasing=g,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=D}update(l){this._id=l.id,this._configuration=l.configuration,this._transient=l.transient,this._ignorePathCasing=l._ignorePathCasing,this.folders=l.folders}get folders(){return this._folders}set folders(l){this._folders=l,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(l){this._configuration=l}getFolder(l){return l&&this._foldersMap.findSubstr(l)||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const l of this.folders)this._foldersMap.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=s;class i{constructor(l,D){this.raw=D,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,O.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function n(p){return new i({uri:p,index:0,name:(0,O.basenameOrAuthority)(p)},{uri:p.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(p,l){return O.extUriBiasedIgnorePathCase.isEqualOrParent(p,l.untitledWorkspacesHome)}function u(p){let l;return A.URI.isUri(p)?l=p:l=p.configuration,l?.scheme===v.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(p){return p.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function f(p,l){return!c(p,l)&&!u(p)}function a(p){return(typeof p=="string"?(0,L.extname)(p):(0,O.extname)(p))===e.WORKSPACE_SUFFIX}}),define(Ie[215],Pe([1,0,73,5,6,23,2,170,99,38,3,12,45,28,212,11,34,13,15]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=c,e.reviveProfile=u,e.toUserDataProfile=t;var n;(function(p){p.Settings="settings",p.Keybindings="keybindings",p.Snippets="snippets",p.Tasks="tasks",p.Extensions="extensions",p.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function c(p){const l=p;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&A.URI.isUri(l.location)&&A.URI.isUri(l.globalStorageHome)&&A.URI.isUri(l.settingsResource)&&A.URI.isUri(l.keybindingsResource)&&A.URI.isUri(l.tasksResource)&&A.URI.isUri(l.snippetsHome)&&A.URI.isUri(l.extensionsResource))}e.IUserDataProfilesService=(0,N.createDecorator)("IUserDataProfilesService");function u(p,l){return{id:p.id,isDefault:p.isDefault,name:p.name,shortName:p.shortName,icon:p.icon,location:A.URI.revive(p.location).with({scheme:l}),globalStorageHome:A.URI.revive(p.globalStorageHome).with({scheme:l}),settingsResource:A.URI.revive(p.settingsResource).with({scheme:l}),keybindingsResource:A.URI.revive(p.keybindingsResource).with({scheme:l}),tasksResource:A.URI.revive(p.tasksResource).with({scheme:l}),snippetsHome:A.URI.revive(p.snippetsHome).with({scheme:l}),extensionsResource:A.URI.revive(p.extensionsResource).with({scheme:l}),cacheHome:A.URI.revive(p.cacheHome).with({scheme:l}),useDefaultFlags:p.useDefaultFlags,isTransient:p.isTransient}}function t(p,l,D,d,w,g){return{id:p,name:l,location:D,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:g&&w?.useDefaultFlags?.globalState?g.globalStorageHome:(0,O.joinPath)(D,"globalStorage"),settingsResource:g&&w?.useDefaultFlags?.settings?g.settingsResource:(0,O.joinPath)(D,"settings.json"),keybindingsResource:g&&w?.useDefaultFlags?.keybindings?g.keybindingsResource:(0,O.joinPath)(D,"keybindings.json"),tasksResource:g&&w?.useDefaultFlags?.tasks?g.tasksResource:(0,O.joinPath)(D,"tasks.json"),snippetsHome:g&&w?.useDefaultFlags?.snippets?g.snippetsHome:(0,O.joinPath)(D,"snippets"),extensionsResource:g&&w?.useDefaultFlags?.extensions?g.extensionsResource:(0,O.joinPath)(D,"extensions.json"),cacheHome:(0,O.joinPath)(d,p),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let f=class extends T.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(l,D,d,w){super(),this.environmentService=l,this.fileService=D,this.uriIdentityService=d,this.logService=w,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new b.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(l){this.enabled!==l&&(this._profilesObject=void 0,this.enabled=l)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const l=this.createDefaultProfile(),D=[l];if(this.enabled)try{for(const g of this.getStoredProfiles()){if(!g.name||!(0,i.isString)(g.name)||!g.location){this.logService.warn("Skipping the invalid stored profile",g.location||g.name);continue}D.push(t((0,O.basename)(g.location),g.name,g.location,this.profilesCacheHome,{shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags},l))}}catch(g){this.logService.error(g)}const d=new b.ResourceMap,w=new Map;if(D.length)try{const g=this.getStoredProfileAssociations();if(g.workspaces)for(const[C,S]of Object.entries(g.workspaces)){const k=A.URI.parse(C),P=D.find(H=>H.id===S);P&&d.set(k,P)}if(g.emptyWindows)for(const[C,S]of Object.entries(g.emptyWindows)){const k=D.find(P=>P.id===S);k&&w.set(C,k)}}catch(g){this.logService.error(g)}this._profilesObject={profiles:D,workspaces:d,emptyWindows:w}}return this._profilesObject}createDefaultProfile(){const l=t("__default__profile__",(0,E.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...l,extensionsResource:this.getDefaultProfileExtensionsLocation()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const D="Temp",d=new RegExp(`${(0,s.escapeRegExpCharacters)(D)}\\s(\\d+)`);let w=0;for(const C of this.profiles){const S=d.exec(C.name),k=S?parseInt(S[1]):0;w=k>w?k:w}const g=`${D} ${w+1}`;return this.createProfile((0,I.hash)((0,o.generateUuid)()).toString(16),g,{transient:!0},l)}async createNamedProfile(l,D,d){return this.createProfile((0,I.hash)((0,o.generateUuid)()).toString(16),l,D,d)}async createProfile(l,D,d,w){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const g=await this.doCreateProfile(l,D,d);return w&&await this.setProfileForWorkspace(w,g),g}async doCreateProfile(l,D,d){if(!(0,i.isString)(D)||!D)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.profileCreationPromises.get(D);return w||(w=(async()=>{try{if(this.profiles.find(k=>k.name===D||k.id===l))throw new Error(`Profile with ${D} name already exists`);const C=t(l,D,(0,O.joinPath)(this.profilesHome,l),this.profilesCacheHome,d,this.defaultProfile);await this.fileService.createFolder(C.location);const S=[];return this._onWillCreateProfile.fire({profile:C,join(k){S.push(k)}}),await r.Promises.settled(S),this.updateProfiles([C],[],[]),C}finally{this.profileCreationPromises.delete(D)}})(),this.profileCreationPromises.set(D,w)),w}async updateProfile(l,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let d=this.profiles.find(w=>w.id===l.id);if(!d)throw new Error(`Profile '${l.name}' does not exist`);return d=t(d.id,D.name??d.name,d.location,this.profilesCacheHome,{shortName:D.shortName??d.shortName,icon:D.icon===null?void 0:D.icon??d.icon,transient:D.transient??d.isTransient,useDefaultFlags:D.useDefaultFlags??d.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[d]),d}async removeProfile(l){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const D=this.profiles.find(w=>w.id===l.id);if(!D)throw new Error(`Profile '${l.name}' does not exist`);const d=[];this._onWillRemoveProfile.fire({profile:D,join(w){d.push(w)}});try{await Promise.allSettled(d)}catch(w){this.logService.error(w)}for(const w of[...this.profilesObject.emptyWindows.keys()])D.id===this.profilesObject.emptyWindows.get(w)?.id&&this.profilesObject.emptyWindows.delete(w);for(const w of[...this.profilesObject.workspaces.keys()])D.id===this.profilesObject.workspaces.get(w)?.id&&this.profilesObject.workspaces.delete(w);this.updateStoredProfileAssociations(),this.updateProfiles([],[D],[]);try{await this.fileService.del(D.cacheHome,{recursive:!0})}catch(w){(0,_.toFileOperationResult)(w)!==1&&this.logService.error(w)}}async setProfileForWorkspace(l,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const d=this.profiles.find(w=>w.id===D.id);if(!d)throw new Error(`Profile '${D.name}' does not exist`);this.updateWorkspaceAssociation(l,d)}unsetWorkspace(l,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(l,void 0,D)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const l=await this.fileService.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(D=>D.isDirectory&&this.profiles.every(d=>!this.uriIdentityService.extUri.isEqual(d.location,D.resource))).map(D=>this.fileService.del(D.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const l=this.transientProfilesObject.profiles.filter(D=>!this.isProfileAssociatedToWorkspace(D));await Promise.allSettled(l.map(D=>this.removeProfile(D)))}getProfileForWorkspace(l){const D=this.getWorkspace(l);return A.URI.isUri(D)?this.transientProfilesObject.workspaces.get(D)??this.profilesObject.workspaces.get(D):this.transientProfilesObject.emptyWindows.get(D)??this.profilesObject.emptyWindows.get(D)}getWorkspace(l){return(0,h.isSingleFolderWorkspaceIdentifier)(l)?l.uri:(0,h.isWorkspaceIdentifier)(l)?l.configPath:l.id}isProfileAssociatedToWorkspace(l){return!!([...this.transientProfilesObject.emptyWindows.values()].some(D=>this.uriIdentityService.extUri.isEqual(D.location,l.location))||[...this.transientProfilesObject.workspaces.values()].some(D=>this.uriIdentityService.extUri.isEqual(D.location,l.location))||[...this.profilesObject.emptyWindows.values()].some(D=>this.uriIdentityService.extUri.isEqual(D.location,l.location))||[...this.profilesObject.workspaces.values()].some(D=>this.uriIdentityService.extUri.isEqual(D.location,l.location)))}updateProfiles(l,D,d){const w=[...this.profiles,...l],g=[];this.transientProfilesObject.profiles=[];for(let C of w)C.isDefault||D.some(S=>C.id===S.id)||(C=d.find(S=>C.id===S.id)??C,C.isTransient?this.transientProfilesObject.profiles.push(C):g.push({location:C.location,name:C.name,shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags}));this.saveStoredProfiles(g),this._profilesObject=void 0,this.triggerProfilesChanges(l,D,d)}triggerProfilesChanges(l,D,d){this._onDidChangeProfiles.fire({added:l,removed:D,updated:d,all:this.profiles})}updateWorkspaceAssociation(l,D,d){d=D?.isTransient?!0:d,d||this.updateWorkspaceAssociation(l,void 0,!0);const w=this.getWorkspace(l),g=d?this.transientProfilesObject:this.profilesObject;A.URI.isUri(w)?(g.workspaces.delete(w),D&&g.workspaces.set(w,D)):(g.emptyWindows.delete(w),D&&g.emptyWindows.set(w,D)),d||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const l={};for(const[d,w]of this.profilesObject.workspaces.entries())l[d.toString()]=w.id;const D={};for(const[d,w]of this.profilesObject.emptyWindows.entries())D[d.toString()]=w.id;this.saveStoredProfileAssociations({workspaces:l,emptyWindows:D}),this._profilesObject=void 0}migrateStoredProfileAssociations(l){const D={},d=this.createDefaultProfile();if(l.workspaces)for(const[g,C]of Object.entries(l.workspaces)){const S=A.URI.parse(C);D[g]=this.uriIdentityService.extUri.isEqual(S,d.location)?d.id:this.uriIdentityService.extUri.basename(S)}const w={};if(l.emptyWindows)for(const[g,C]of Object.entries(l.emptyWindows)){const S=A.URI.parse(C);w[g]=this.uriIdentityService.extUri.isEqual(S,d.location)?d.id:this.uriIdentityService.extUri.basename(S)}return{workspaces:D,emptyWindows:w}}getStoredProfiles(){return[]}saveStoredProfiles(l){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(l){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=f,e.UserDataProfilesService=f=Ke([He(0,v.IEnvironmentService),He(1,_.IFileService),He(2,m.IUriIdentityService),He(3,y.ILogService)],f);class a extends f{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(l){this.storedProfiles=l}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(l){this.storedProfileAssociations=l}}e.InMemoryUserDataProfilesService=a}),define(Ie[216],Pe([1,0,11,5,6,60,15,151,3,215]),function(ue,e,I,L,T,O,A,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=b,e.isProfileUsingDefaultStorage=r,e.logStorage=s,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var N;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(N||(e.WillSaveStateReason=N={}));var y;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var h;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function b(i){const n=i.get(e.TARGET_KEY);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class m extends T.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(n={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super(),this.options=n,this._onDidChangeValue=this._register(new L.PauseableEmitter),this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new T.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(n,c,u){return L.Event.filter(this._onDidChangeValue.event,t=>t.scope===n&&(c===void 0||t.key===c),u)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,T.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(n,c){const{key:u,external:t}=c;if(u===e.TARGET_KEY){switch(n){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:n})}else this._onDidChangeValue.fire({scope:n,key:u,target:this.getKeyTargets(n)[u],external:t})}emitWillSaveState(n){this._onWillSaveState.fire({reason:n})}get(n,c,u){return this.getStorage(c)?.get(n,u)}getBoolean(n,c,u){return this.getStorage(c)?.getBoolean(n,u)}getNumber(n,c,u){return this.getStorage(c)?.getNumber(n,u)}getObject(n,c,u){return this.getStorage(c)?.getObject(n,u)}storeAll(n,c){this.withPausedEmitters(()=>{for(const u of n)this.store(u.key,u.value,u.scope,u.target,c)})}store(n,c,u,t,f=!1){if((0,A.isUndefinedOrNull)(c)){this.remove(n,u,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(n,u,t),this.getStorage(u)?.set(n,c,f)})}remove(n,c,u=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(n,c,void 0),this.getStorage(c)?.delete(n,u)})}withPausedEmitters(n){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{n()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(n,c){const u=[],t=this.getKeyTargets(n);for(const f of Object.keys(t))t[f]===c&&u.push(f);return u}updateKeyTarget(n,c,u,t=!1){const f=this.getKeyTargets(c);typeof u=="number"?f[n]!==u&&(f[n]=u,this.getStorage(c)?.set(e.TARGET_KEY,JSON.stringify(f),t)):typeof f[n]=="number"&&(delete f[n],this.getStorage(c)?.set(e.TARGET_KEY,JSON.stringify(f),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(n){switch(n){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(n){const c=this.getStorage(n);return c?b(c):Object.create(null)}isNew(n){return this.getBoolean(e.IS_NEW_KEY,n)===!0}async flush(n=N.NONE){this._onWillSaveState.fire({reason:n});const c=this.getStorage(-1),u=this.getStorage(0),t=this.getStorage(1);switch(n){case N.NONE:await I.Promises.settled([c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case N.SHUTDOWN:await I.Promises.settled([c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.getStorage(-1)?.items??new Map,c=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return s(n,c,u,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(n){return await this.flush(),this.getStorage(n)?.optimize()}async switch(n,c){return this.emitWillSaveState(N.NONE),(0,_.isUserDataProfile)(n)?this.switchToProfile(n,c):this.switchToWorkspace(n,c)}canSwitchProfile(n,c){return!(n.id===c.id||r(c)&&r(n))}switchData(n,c,u){this.withPausedEmitters(()=>{const t=new Set;for(const[f,a]of n)t.add(f),c.get(f)!==a&&this.emitDidChangeValue(u,{key:f,external:!0});for(const[f]of c.items)t.has(f)||this.emitDidChangeValue(u,{key:f,external:!0})})}}e.AbstractStorageService=m;function r(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class o extends m{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(n=>this.emitDidChangeValue(1,n))),this._register(this.profileStorage.onDidChangeStorage(n=>this.emitDidChangeValue(0,n))),this._register(this.applicationStorage.onDidChangeStorage(n=>this.emitDidChangeValue(-1,n)))}getStorage(n){switch(n){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(n){return!1}}e.InMemoryStorageService=o;async function s(i,n,c,u,t,f){const a=k=>{try{return JSON.parse(k)}catch{return k}},p=new Map,l=new Map;i.forEach((k,P)=>{p.set(P,k),l.set(P,a(k))});const D=new Map,d=new Map;n.forEach((k,P)=>{D.set(P,k),d.set(P,a(k))});const w=new Map,g=new Map;c.forEach((k,P)=>{w.set(P,k),g.set(P,a(k))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const C=[];if(p.forEach((k,P)=>{C.push({key:P,value:k})}),console.table(C),console.groupEnd(),console.log(l),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const k=[];D.forEach((P,H)=>{k.push({key:H,value:P})}),console.table(k),console.groupEnd(),console.log(d)}console.group(`Storage: Workspace (path: ${f})`);const S=[];w.forEach((k,P)=>{S.push({key:P,value:k})}),console.table(S),console.groupEnd(),console.log(g)}}),define(Ie[76],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class I{static{this.enableDebugLogging=!1}constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const O=this._idPool++;return this._data.set(O,T),this.logDebugInfo(),O}get(T,O){return this._data.has(T)?this._data.get(T)[O]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){I.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=I}),define(Ie[46],Pe([1,0,16,23,3]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class O{constructor(){this._systemSchemes=new Set(Object.keys(I.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(E=>{const v=this._providerInfo.get(E.scheme);return!(v===void 0||v&1024)})}$acceptProviderInfos(E,v){v===null?this._providerInfo.delete(E.scheme):this._providerInfo.set(E.scheme,v)}isFreeScheme(E){return!this._providerInfo.has(E)&&!this._systemSchemes.has(E)}getCapabilities(E){return this._providerInfo.get(E)}}e.ExtHostFileSystemInfo=O,e.IExtHostFileSystemInfo=(0,T.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,I.createDecorator)("IExtHostInitDataService")}),define(Ie[217],Pe([1,0,176,12,201,27]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends T.LogService{constructor(v,_,N){const y=N.remote.isRemote?"remoteexthost":v?"workerexthost":"exthost",h=N.remote.isRemote?(0,I.localize)(0,null):v?(0,I.localize)(1,null):(0,I.localize)(2,null);super(_.createLogger(y,{name:h}))}};e.ExtHostLogService=A,e.ExtHostLogService=A=Ke([He(1,L.ILoggerService),He(2,O.IExtHostInitDataService)],A)}),define(Ie[218],Pe([1,0,11]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(A,E,v){this._deferredPromises=new Map,this._id=A,this._shared=E,this._storage=v,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(_=>(this._value=_,this)),this._storageListener=this._storage.onDidChangeStorage(_=>{_.shared===this._shared&&_.key===this._id&&(this._value=_.value)}),this._scheduler=new I.RunOnceScheduler(()=>{const _=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const N of _.values())N.complete()}catch(N){for(const y of _.values())y.error(N)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,E){let v=this._value[A];return typeof v>"u"&&(v=E),v}update(A,E){this._value[A]=E;const v=this._deferredPromises.get(A);if(v!==void 0)return v.p;const _=new I.DeferredPromise;return this._deferredPromises.set(A,_),this._scheduler.isScheduled()||this._scheduler.schedule(),_.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class T extends L{setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}constructor(A,E){super(A.identifier.value,!0,E),this._extension=A}}e.ExtensionGlobalMemento=T}),define(Ie[219],Pe([1,0,5,2]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class T{constructor(A){this._notebooksAndEditors=A,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new I.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(A,E,v,_){const y=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(A)).acceptModelChanged(E.value,v,_);this._onDidChangeNotebookDocument.fire(y)}$acceptDirtyStateChanged(A,E){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(A)).acceptDirty(E)}$acceptModelSaved(A){const E=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(A));this._onDidSaveNotebookDocument.fire(E.apiNotebook)}}e.ExtHostNotebookDocuments=T}),define(Ie[17],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,I.createDecorator)("IExtHostRpcService");class L{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.ExtHostRpcService=L}),define(Ie[220],Pe([1,0,20,5]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{#e;constructor(A,E){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=I.ExtensionIdentifier.toKey(A.identifier),this.#e=E,this.#e.onDidChangePassword(v=>{v.extensionId===this._id&&this._onDidChange.fire({key:v.key})})}get(A){return this.#e.get(this._id,A)}store(A,E){return this.#e.store(this._id,A,E)}delete(A){return this.#e.delete(this._id,A)}}e.ExtensionSecrets=T}),define(Ie[61],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,I.createDecorator)("IURITransformerService");class L{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=L}),define(Ie[221],Pe([1,0,21]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=T,e.deserializeWebviewMessage=A;class L{constructor(){this.buffers=[]}add(v){let _=this.buffers.indexOf(v);return _<0&&(_=this.buffers.length,this.buffers.push(v)),_}}function T(E,v){if(v.serializeBuffersForPostMessage){const _=new L,y=JSON.stringify(E,(b,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:_.add(m)};if(ArrayBuffer.isView(m)){const r=O(m);if(r)return{$$vscode_array_buffer_reference$$:!0,index:_.add(m.buffer),view:{type:r,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),h=_.buffers.map(b=>{const m=new Uint8Array(b);return I.VSBuffer.wrap(m)});return{message:y,buffers:h}}else return{message:JSON.stringify(E),buffers:[]}}function O(E){switch(E.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(E,v){const _=v.map(h=>{const b=new ArrayBuffer(h.byteLength);return new Uint8Array(b).set(h.buffer),b}),N=v.length?(h,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const m=b,{index:r}=m,o=_[r];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(E,N),arrayBuffers:_}}}),define(Ie[106],Pe([1,0,185,15,2,6,3,29,38,16,44,145,33]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=r,e.isEditorPaneWithScrolling=o,e.findViewStateForEditor=s,e.isResourceEditorInput=i,e.isResourceDiffEditorInput=n,e.isResourceMultiDiffEditorInput=c,e.isResourceSideBySideEditorInput=u,e.isUntitledResourceEditorInput=t,e.isResourceMergeEditorInput=f,e.isEditorInput=w,e.isSideBySideEditorInput=C,e.isDiffEditorInput=S,e.createTooLargeFileError=k,e.isEditorInputWithOptions=P,e.isEditorInputWithOptionsAndGroup=H,e.isEditorIdentifier=$,e.preventEditorClose=ce,e.pathsToEditors=fe,e.isTextEditorViewState=Ne,e.isEditorOpenError=ae,e.createEditorOpenError=Re,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var m;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function r(ne){const x=ne;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}function o(ne){const x=ne;return!!x&&typeof x.getScrollPosition=="function"&&typeof x.setScrollPosition=="function"&&!!x.onDidChangeScroll}function s(ne,x,J){for(const be of J.visibleEditorPanes)if(be.group.id===x&&ne.matches(be.input))return be.getViewState()}function i(ne){if(w(ne))return!1;const x=ne;return T.URI.isUri(x?.resource)}function n(ne){if(w(ne))return!1;const x=ne;return x?.original!==void 0&&x.modified!==void 0}function c(ne){if(w(ne))return!1;const x=ne;return!x||x.resources&&!Array.isArray(x.resources)?!1:!!x.resources||!!x.multiDiffSource}function u(ne){if(w(ne)||n(ne))return!1;const x=ne;return x?.primary!==void 0&&x.secondary!==void 0}function t(ne){if(w(ne))return!1;const x=ne;return x?x.resource===void 0||x.resource.scheme===_.Schemas.untitled||x.forceUntitled===!0:!1}function f(ne){if(w(ne))return!1;const x=ne;return T.URI.isUri(x?.base?.resource)&&T.URI.isUri(x?.input1?.resource)&&T.URI.isUri(x?.input2?.resource)&&T.URI.isUri(x?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var p;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p||(e.SaveReason=p={}));class l{constructor(){this.mapIdToSaveSource=new Map}registerSource(x,J){let be=this.mapIdToSaveSource.get(x);return be||(be={source:x,label:J},this.mapIdToSaveSource.set(x,be)),be.source}getSourceLabel(x){return this.mapIdToSaveSource.get(x)?.label??x}}e.SaveSourceRegistry=new l;var D;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(D||(e.EditorInputCapabilities=D={}));class d extends O.Disposable{}e.AbstractEditorInput=d;function w(ne){return ne instanceof d}function g(ne){const x=ne;return T.URI.isUri(x?.preferredResource)}function C(ne){const x=ne;return w(x?.primary)&&w(x?.secondary)}function S(ne){const x=ne;return w(x?.modified)&&w(x?.original)}function k(ne,x,J,be,Me){return Re(be,[(0,y.toAction)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const ye={...J,limits:{size:Number.MAX_VALUE}};ne.openEditor(x,ye)}}),(0,y.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Me.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}function P(ne){return w(ne?.editor)}function H(ne){const x=ne;return P(ne)&&x?.group!==void 0}function $(ne){const x=ne;return typeof x?.groupId=="number"&&w(x.editor)}var V;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var R;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var z;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class q{getOriginalUri(x,J){if(!x)return;if(f(x))return e.EditorResourceAccessor.getOriginalUri(x.result,J);if(J?.supportSideBySide){const{primary:Me,secondary:ye}=this.getSideEditors(x);if(Me&&ye){if(J?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(Me,{filterByScheme:J.filterByScheme}),secondary:this.getOriginalUri(ye,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===z.ANY)return this.getOriginalUri(Me,{filterByScheme:J.filterByScheme})??this.getOriginalUri(ye,{filterByScheme:J.filterByScheme});x=J.supportSideBySide===z.PRIMARY?Me:ye}}if(n(x)||c(x)||u(x)||f(x))return;const be=g(x)?x.preferredResource:x.resource;return!be||!J||!J.filterByScheme?be:this.filterUri(be,J.filterByScheme)}getSideEditors(x){return C(x)||u(x)?{primary:x.primary,secondary:x.secondary}:S(x)||n(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,J){if(!x)return;if(f(x))return e.EditorResourceAccessor.getCanonicalUri(x.result,J);if(J?.supportSideBySide){const{primary:Me,secondary:ye}=this.getSideEditors(x);if(Me&&ye){if(J?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(Me,{filterByScheme:J.filterByScheme}),secondary:this.getCanonicalUri(ye,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===z.ANY)return this.getCanonicalUri(Me,{filterByScheme:J.filterByScheme})??this.getCanonicalUri(ye,{filterByScheme:J.filterByScheme});x=J.supportSideBySide===z.PRIMARY?Me:ye}}if(n(x)||c(x)||u(x)||f(x))return;const be=x.resource;return!be||!J||!J.filterByScheme?be:this.filterUri(be,J.filterByScheme)}filterUri(x,J){if(Array.isArray(J)){if(J.some(be=>x.scheme===be))return x}else if(J===x.scheme)return x}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function ce(ne,x,J,be){if(!ne.isSticky(x))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return J===ie.MOUSE||J===ie.KEYBOARD;case"mouse":return J===ie.MOUSE;case"keyboard":return J===ie.KEYBOARD}return!1}e.EditorResourceAccessor=new q;var Se;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(Se||(e.CloseDirection=Se={}));class De{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const J=this.instantiationService=x.get(A.IInstantiationService);for(const[be,Me]of this.editorSerializerConstructors)this.createEditorSerializer(be,Me,J);this.editorSerializerConstructors.clear()}createEditorSerializer(x,J,be){const Me=be.createInstance(J);this.editorSerializerInstances.set(x,Me)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,J){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,J,this.instantiationService):this.editorSerializerConstructors.set(x,J),(0,O.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}E.Registry.add(e.EditorExtensions.EditorFactory,new De);async function fe(ne,x,J){return!ne||!ne.length?[]:await Promise.all(ne.map(async be=>{const Me=T.URI.revive(be.fileUri);if(!Me){J.info("Cannot resolve the path because it is not valid.",be);return}if(!await x.canHandleResource(Me)){J.info("Cannot resolve the path because it cannot be handled",be);return}let Ee=be.exists,ge=be.type;if(typeof Ee!="boolean"||typeof ge!="number")try{ge=(await x.stat(Me)).isDirectory?v.FileType.Directory:v.FileType.Unknown,Ee=!0}catch(Y){J.error(Y),Ee=!1}if(!Ee&&be.openOnlyIfExists){J.info("Cannot resolve the path because it does not exist",be);return}if(ge===v.FileType.Directory){J.info("Cannot resolve the path because it is a directory",be);return}const G={...be.options,pinned:!0};return Ee?{resource:Me,options:G}:{resource:Me,options:G,forceUntitled:!0}}))}var pe;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function Ne(ne){const x=ne;if(!x)return!1;const J=x;if(J.modified)return Ne(J.modified);const be=x;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function ae(ne){return(0,N.isErrorWithActions)(ne)}function Re(ne,x,J){const be=(0,N.createErrorWithActions)(ne,x);return be.forceMessage=J?.forceMessage,be.forceSeverity=J?.forceSeverity,be.allowDialog=J?.allowDialog,be}}),define(Ie[222],Pe([1,0,5,186,3,6,28,29,18,25,92,210]),function(ue,e,I,L,T,O,A,E,v,_,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=m,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,L.localize)(0,null),e.defaultViewIcon=(0,y.registerIcon)("default-view-icon",N.Codicon.window,(0,L.localize)(1,null));var h;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(h||(e.Extensions=h={}));var b;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.ViewContainerLocations=[0,1,2];function m(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class r extends O.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new I.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new I.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,v.flatten)([...this.viewContainers.values()])}registerViewContainer(a,p,l){const D=this.get(a.id);if(D)return D;const d=a;return d.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:d.openCommandActionDescriptor??{id:d.id},(0,A.getOrSet)(this.viewContainers,p,[]).push(d),l?.isDefault&&this.defaultViewContainers.push(d),this._onDidRegister.fire({viewContainer:d,viewContainerLocation:p}),d}deregisterViewContainer(a){for(const p of this.viewContainers.keys()){const l=this.viewContainers.get(p),D=l?.indexOf(a);if(D!==-1){l?.splice(D,1),l.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:a,viewContainerLocation:p});return}}}get(a){return this.all.filter(p=>p.id===a)[0]}getViewContainers(a){return[...this.viewContainers.get(a)||[]]}getViewContainerLocation(a){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(l=>l?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===a)}}E.Registry.add(h.ViewContainersRegistry,new r);var o;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(f,a){const p=f.group??o.More,l=a.group??o.More;return p!==l?p.localeCompare(l):(f.order??5)-(a.order??5)}class i extends O.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new I.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new I.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new I.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new I.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(a,p){this.registerViews2([{views:a,viewContainer:p}])}registerViews2(a){a.forEach(({views:p,viewContainer:l})=>this.addViews(p,l)),this._onViewsRegistered.fire(a)}deregisterViews(a,p){const l=this.removeViews(a,p);l.length&&this._onViewsDeregistered.fire({views:l,viewContainer:p})}moveViews(a,p){for(const l of this._views.keys())if(l!==p){const D=this.removeViews(a,l);D.length&&(this.addViews(D,p),this._onDidChangeContainer.fire({views:D,from:l,to:p}))}}getViews(a){return this._views.get(a)||[]}getView(a){for(const p of this._viewContainers){const l=(this._views.get(p)||[]).filter(D=>D.id===a)[0];if(l)return l}return null}getViewContainer(a){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(D=>D.id===a)[0])return p;return null}registerViewWelcomeContent(a,p){return this._viewWelcomeContents.add(a,p),this._onDidChangeViewWelcomeContent.fire(a),(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(a,p),this._onDidChangeViewWelcomeContent.fire(a)})}registerViewWelcomeContent2(a,p){const l=new Map;for(const[D,d]of p)this._viewWelcomeContents.add(a,d),l.set(D,(0,O.toDisposable)(()=>{this._viewWelcomeContents.delete(a,d),this._onDidChangeViewWelcomeContent.fire(a)}));return this._onDidChangeViewWelcomeContent.fire(a),l}getViewWelcomeContent(a){const p=[];return this._viewWelcomeContents.forEach(a,l=>p.push(l)),p.sort(s)}addViews(a,p){let l=this._views.get(p);l||(l=[],this._views.set(p,l),this._viewContainers.push(p));for(const D of a){if(this.getView(D.id)!==null)throw new Error((0,L.localize)(2,null,D.id));l.push(D)}}removeViews(a,p){const l=this._views.get(p);if(!l)return[];const D=[],d=[];for(const w of l)a.includes(w)?D.push(w):d.push(w);return D.length&&(d.length?this._views.set(p,d):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),D}}E.Registry.add(h.ViewsRegistry,new i),e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var c;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class u{constructor(a,p){this.resolved=!1,this._hasResolve=!1,(0,_.mixin)(this,a),this._hasResolve=!!p,this.resolve=async l=>{if(p&&!this.resolved){const D=await p(l);D&&(this.tooltip=this.tooltip??D.tooltip,this.command=this.command??D.command)}l.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=u;class t extends Error{constructor(a){super((0,L.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(Ie[223],Pe([1,0,187,31]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_CHAT_LOCATION=e.CONTEXT_CHAT_INPUT_HAS_AGENT=e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=e.CONTEXT_CHAT_ENABLED=e.CONTEXT_IN_CHAT_SESSION=e.CONTEXT_IN_CHAT_INPUT=e.CONTEXT_CHAT_INPUT_HAS_FOCUS=e.CONTEXT_CHAT_INPUT_HAS_TEXT=e.CONTEXT_CHAT_EDIT_APPLIED=e.CONTEXT_REQUEST=e.CONTEXT_RESPONSE=e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=e.CONTEXT_RESPONSE_FILTERED=e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=e.CONTEXT_RESPONSE_VOTE=void 0,e.CONTEXT_RESPONSE_VOTE=new L.RawContextKey("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.CONTEXT_RESPONSE_DETECTED_AGENT_COMMAND=new L.RawContextKey("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.CONTEXT_CHAT_RESPONSE_SUPPORT_ISSUE_REPORTING=new L.RawContextKey("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.CONTEXT_RESPONSE_FILTERED=new L.RawContextKey("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.CONTEXT_CHAT_REQUEST_IN_PROGRESS=new L.RawContextKey("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.CONTEXT_RESPONSE=new L.RawContextKey("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.CONTEXT_REQUEST=new L.RawContextKey("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.CONTEXT_CHAT_EDIT_APPLIED=new L.RawContextKey("chatEditApplied",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.CONTEXT_CHAT_INPUT_HAS_TEXT=new L.RawContextKey("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.CONTEXT_CHAT_INPUT_HAS_FOCUS=new L.RawContextKey("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.CONTEXT_IN_CHAT_INPUT=new L.RawContextKey("inChatInput",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.CONTEXT_IN_CHAT_SESSION=new L.RawContextKey("inChat",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.CONTEXT_CHAT_ENABLED=new L.RawContextKey("chatIsEnabled",!1,{type:"boolean",description:(0,I.localize)(12,null)}),e.CONTEXT_CHAT_INPUT_CURSOR_AT_TOP=new L.RawContextKey("chatCursorAtTop",!1),e.CONTEXT_CHAT_INPUT_HAS_AGENT=new L.RawContextKey("chatInputHasAgent",!1),e.CONTEXT_CHAT_LOCATION=new L.RawContextKey("chatLocation",void 0)}),define(Ie[224],Pe([1,0,11,24,5,42,6,132,13,31,3,12,102,204,216,223]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.ChatAgentNameService=e.IChatAgentNameService=e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0;var s;(function(u){u.Panel="panel",u.Terminal="terminal",u.Notebook="notebook",u.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(u){function t(f){switch(f){case"panel":return u.Panel;case"terminal":return u.Terminal;case"notebook":return u.Notebook;case"editor":return u.Editor}return u.Panel}u.fromRaw=t}(s||(e.ChatAgentLocation=s={})),e.IChatAgentService=(0,N.createDecorator)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(t){this.contextKeyService=t,this._agents=[],this._onDidChangeAgents=new T.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event,this._hasDefaultAgent=r.CONTEXT_CHAT_ENABLED.bindTo(this.contextKeyService)}registerAgent(t,f){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const p=this,l=f.slashCommands;f={...f,get slashCommands(){return l.filter(d=>!d.when||p.contextKeyService.contextMatchesRules(_.ContextKeyExpr.deserialize(d.when)))}};const D={data:f};return this._agents.push(D),(0,A.toDisposable)(()=>{this._agents=this._agents.filter(d=>d!==D),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(t,f){const a=this._getAgentEntry(t);if(!a)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(a.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return a.data.isDefault&&this._hasDefaultAgent.set(!0),a.impl=f,this._onDidChangeAgents.fire(new n(a.data,f)),(0,A.toDisposable)(()=>{a.impl=void 0,this._onDidChangeAgents.fire(void 0),a.data.isDefault&&this._hasDefaultAgent.set(!1)})}registerDynamicAgent(t,f){const a={data:t,impl:f};return this._agents.push(a),this._onDidChangeAgents.fire(new n(t,f)),(0,A.toDisposable)(()=>{this._agents=this._agents.filter(p=>p!==a),this._onDidChangeAgents.fire(void 0)})}updateAgent(t,f){const a=this._getAgentEntry(t);if(!a?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);a.data.metadata={...a.data.metadata,...f},this._onDidChangeAgents.fire(new n(a.data,a.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(f=>!!f.isDefault&&f.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(f=>!!f.isDefault&&f.locations.includes(t))}getSecondaryAgent(){return O.Iterable.find(this._agents.values(),t=>!!t.data.metadata.isSecondary)?.data}_getAgentEntry(t){return this._agents.find(f=>f.data.id===t)}getAgent(t){return this._getAgentEntry(t)?.data}getAgents(){return this._agents.map(t=>t.data)}getActivatedAgents(){return Array.from(this._agents.values()).filter(t=>!!t.impl).map(t=>new n(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(f=>f.name===t)}async invokeAgent(t,f,a,p,l){const D=this._getAgentEntry(t);if(!D?.impl)throw new Error(`No activated agent with id ${t}`);return await D.impl.invoke(f,a,p,l)}async getFollowups(t,f,a,p,l){const D=this._getAgentEntry(t);if(!D?.impl)throw new Error(`No activated agent with id ${t}`);return D.impl?.provideFollowups?D.impl.provideFollowups(f,a,p,l):[]}};e.ChatAgentService=i,e.ChatAgentService=i=Ke([He(0,_.IContextKeyService)],i);class n{constructor(t,f){this.data=t,this.impl=f}get id(){return this.data.id}get name(){return this.data.name??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get extensionPublisherId(){return this.data.extensionPublisherId}get extensionPublisherDisplayName(){return this.data.extensionPublisherDisplayName}get extensionDisplayName(){return this.data.extensionDisplayName}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get defaultImplicitVariables(){return this.data.defaultImplicitVariables}get locations(){return this.data.locations}async invoke(t,f,a,p){return this.impl.invoke(t,f,a,p)}async provideFollowups(t,f,a,p){return this.impl.provideFollowups?this.impl.provideFollowups(t,f,a,p):[]}provideWelcomeMessage(t,f){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(t,f)}provideSampleQuestions(t,f){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(t,f)}}e.MergedChatAgent=n,e.IChatAgentNameService=(0,N.createDecorator)("chatAgentNameService");let c=class{static{o=this}static{this.StorageKey="chat.participantNameRegistry"}constructor(t,f,a,p){if(this.requestService=f,this.logService=a,this.storageService=p,this.registry=(0,E.observableValue)(this,Object.create(null)),this.disposed=!1,!t.chatParticipantRegistry)return;this.url=t.chatParticipantRegistry;const l=p.get(o.StorageKey,-1);try{this.registry.set(JSON.parse(l??"{}"),void 0)}catch{p.remove(o.StorageKey,-1)}this.refresh()}refresh(){this.disposed||this.update().catch(t=>this.logService.warn("Failed to fetch chat participant registry",t)).then(()=>(0,I.timeout)(5*60*1e3)).then(()=>this.refresh())}async update(){const t=await this.requestService.request({type:"GET",url:this.url},L.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const f=await(0,b.asJson)(t);if(!f||f.version!==1)throw new Error("Unexpected chat participant registry response.");const a=f.restrictedChatParticipants;this.registry.set(a,void 0),this.storageService.store(o.StorageKey,JSON.stringify(a),-1,1)}getAgentNameRestriction(t){return this.registry.map(a=>a[t.name.toLowerCase()]).map(a=>a?a.some(p=>(0,v.equalsIgnoreCase)(p,p.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.disposed=!0}};e.ChatAgentNameService=c,e.ChatAgentNameService=c=o=Ke([He(0,h.IProductService),He(1,b.IRequestService),He(2,y.ILogService),He(3,m.IStorageService)],c)}),define(Ie[225],Pe([1,0,2,30,3]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.isIDocumentContext=O,e.isIUsedContext=A;function O(_){return!!_&&typeof _=="object"&&"uri"in _&&_.uri instanceof I.URI&&"version"in _&&typeof _.version=="number"&&"ranges"in _&&Array.isArray(_.ranges)&&_.ranges.every(L.Range.isIRange)}function A(_){return!!_&&typeof _=="object"&&"documents"in _&&Array.isArray(_.documents)&&_.documents.every(O)}var E;(function(_){_[_.Down=0]="Down",_[_.Up=1]="Up"})(E||(e.InteractiveSessionVoteDirection=E={}));var v;(function(_){_[_.Action=1]="Action",_[_.Toolbar=2]="Toolbar"})(v||(e.ChatCopyKind=v={})),e.IChatService=(0,T.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(Ie[226],Pe([1,0,5,11,188]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class O{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new I.Emitter,this._onExit=new I.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(E){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=E}onEvent(E){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=E}onRequest(E){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=E}sendResponse(E){E.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${E.command}`)):this.internalSend("response",E)}sendRequest(E,v,_,N){const y={command:E};if(v&&Object.keys(v).length>0&&(y.arguments=v),this.internalSend("request",y),typeof N=="number"){const h=setTimeout(()=>{clearTimeout(h);const b=this.pendingRequests.get(y.seq);if(b){this.pendingRequests.delete(y.seq);const m={type:"response",seq:0,request_seq:y.seq,success:!1,command:E,message:(0,T.localize)(0,null,N,E)};b(m)}},N)}return _&&this.pendingRequests.set(y.seq,_),y.seq}acceptMessage(E){this.messageCallback?this.messageCallback(E):(this.queue.push(E),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(E,v){return E.type!=="event"||v.type!=="event"}async processQueue(){let E;for(;this.queue.length;){if((!E||this.needsTaskBoundaryBetween(this.queue[0],E))&&await(0,L.timeout)(0),E=this.queue.shift(),!E)return;switch(E.type){case"event":this.eventCallback?.(E);break;case"request":this.requestCallback?.(E);break;case"response":{const v=E,_=this.pendingRequests.get(v.request_seq);_&&(this.pendingRequests.delete(v.request_seq),_(v));break}}}}internalSend(E,v){v.type=E,v.seq=this.sequence++,this.sendMessage(v)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const E=new Map;this.pendingRequests.forEach((v,_)=>E.set(_,v)),await(0,L.timeout)(500),E.forEach((v,_)=>{v({type:"response",seq:0,request_seq:_,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(_)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=O}),define(Ie[227],Pe([1,0,2,189,31,3]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=v,e.isFrameDeemphasized=N,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:L.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:L.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:L.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:L.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:L.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:L.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:L.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:L.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:L.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:L.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:L.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:L.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:L.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:L.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:L.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:L.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:L.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:L.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:L.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:L.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:L.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:L.localize(21,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new T.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:L.localize(22,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new T.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:L.localize(23,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:L.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:L.localize(25,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:L.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:L.localize(27,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new T.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:L.localize(28,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:L.localize(29,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:L.localize(30,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:L.localize(31,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:L.localize(32,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:L.localize(33,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:L.localize(34,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:L.localize(35,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:L.localize(36,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:L.localize(37,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:L.localize(38,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new T.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:L.localize(39,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:L.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:L.localize(41,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:L.localize(42,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:L.localize(43,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:L.localize(44,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:L.localize(45,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:L.localize(46,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:L.localize(47,null)}),e.CONTEXT_VARIABLE_VALUE=new T.RawContextKey("variableValue",!1,{type:"string",description:L.localize(48,null)}),e.CONTEXT_VARIABLE_TYPE=new T.RawContextKey("variableType",!1,{type:"string",description:L.localize(49,null)}),e.CONTEXT_VARIABLE_INTERFACES=new T.RawContextKey("variableInterfaces",!1,{type:"array",description:L.localize(50,null)}),e.CONTEXT_VARIABLE_NAME=new T.RawContextKey("variableName",!1,{type:"string",description:L.localize(51,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new T.RawContextKey("variableLanguage",!1,{type:"string",description:L.localize(52,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new T.RawContextKey("variableExtensionId",!1,{type:"string",description:L.localize(53,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:L.localize(54,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:L.localize(55,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:L.localize(56,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:L.localize(57,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:L.localize(58,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:L.localize(59,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:L.localize(60,null)});const A=n=>L.localize(61,null,n);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:L.localize(62,null)};var E;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(E||(e.State=E={}));function v(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var _;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(_||(e.MemoryRangeType=_={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";function N(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var y;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var h;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(h||(e.DebugConfigurationProviderTriggerKind=h={}));var b;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.IDebugService=(0,O.createDecorator)("debugService");var m;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(m||(e.BreakpointWidgetContext=m={}));var r;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var s;(function(n){n.deserialize=c=>c,n.serialize=c=>c})(s||(e.IDebugVisualizationTreeItem=s={}));var i;(function(n){n.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:I.URI.revive(c.iconPath.light),dark:I.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),n.serialize=c=>c})(i||(e.IDebugVisualization=i={}))}),define(Ie[228],Pe([1,0,13,2,19,25,16,30,24,18]),function(ue,e,I,L,T,O,A,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=y,e.filterExceptionsFromTelemetry=h,e.isSessionAttach=b,e.getExtensionHostDebugSession=m,e.isDebuggerMainContribution=r,e.getExactExpressionStartAndEnd=o,e.getEvaluatableExpressionAtPosition=s,e.isUri=n,e.convertToDAPaths=t,e.convertToVSCPaths=f,e.getVisibleAndSorted=p,e.saveAllBeforeDebugStart=D;const N=/{([^}]+)}/g;function y(w,g,C){return w.replace(N,function(S,k){return g&&k.length>0&&k[0]!=="_"?S:C&&C.hasOwnProperty(k)?C[k]:S})}function h(w){const g={};for(const C of Object.keys(w))C.startsWith("!")||(g[C]=w[C]);return g}function b(w){return w.configuration.request==="attach"&&!m(w)&&(!w.parentSession||b(w.parentSession))}function m(w){let g=w.configuration.type;if(g)return g==="vslsShare"&&(g=w.configuration.adapterProxy.configuration.type),(0,I.equalsIgnoreCase)(g,"extensionhost")||(0,I.equalsIgnoreCase)(g,"pwa-extensionhost")?w:w.parentSession?m(w.parentSession):void 0}function r(w){return w.type&&(w.label||w.program||w.runtime)}function o(w,g,C){let S,k=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let H=null;for(;H=P.exec(w);){const $=H.index+1,V=$+H[0].length;if($<=g&&V>=C){S=H[0],k=$;break}}if(S){const $=/\w+/g;let V=null;for(;(V=$.exec(S))&&!(V.index+1+k+V[0].length>=C););V&&(S=S.substring(0,$.lastIndex))}return S?{start:k,end:k+S.length-1}:{start:0,end:0}}async function s(w,g,C,S){if(w.evaluatableExpressionProvider.has(g)){const k=w.evaluatableExpressionProvider.ordered(g),P=(0,_.coalesce)(await Promise.all(k.map(async H=>{try{return await H.provideEvaluatableExpression(g,C,S??v.CancellationToken.None)}catch{return}})));if(P.length>0){let H=P[0].expression;const $=P[0].range;return H||(H=g.getLineContent(C.lineNumber).substring($.startColumn-1,$.endColumn-1)),{range:$,matchingExpression:H}}}else{const k=g.getLineContent(C.lineNumber),{start:P,end:H}=o(k,C.column,C.column),$=k.substring(P-1,H);return{matchingExpression:$,range:new E.Range(C.lineNumber,P,C.lineNumber,P+$.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(w){return!!(w&&w.match(i))}function c(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(n(w.path))return L.URI.parse(w.path);if((0,T.isAbsolute)(w.path))return L.URI.file(w.path)}return w.path}function u(w){if(typeof w.path=="object"){const g=L.URI.revive(w.path);if(g)return g.scheme===A.Schemas.file?g.fsPath:g.toString()}return w.path}function t(w,g){const C=g?c:u,S=(0,O.deepClone)(w);return a(S,(k,P)=>{k&&P&&(P.path=C(P))}),S}function f(w,g){const C=g?c:u,S=(0,O.deepClone)(w);return a(S,(k,P)=>{!k&&P&&(P.path=C(P))}),S}function a(w,g){switch(w.type){case"event":{const C=w;switch(C.event){case"output":g(!1,C.body.source);break;case"loadedSource":g(!1,C.body.source);break;case"breakpoint":g(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=w;switch(C.command){case"setBreakpoints":g(!0,C.arguments.source);break;case"breakpointLocations":g(!0,C.arguments.source);break;case"source":g(!0,C.arguments.source);break;case"gotoTargets":g(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(S=>g(!1,S));break;default:break}break}case"response":{const C=w;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(S=>g(!1,S.source));break;case"loadedSources":C.body.sources.forEach(S=>g(!1,S));break;case"scopes":C.body.scopes.forEach(S=>g(!1,S.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(S=>g(!1,S.source));break;case"setBreakpoints":C.body.breakpoints.forEach(S=>g(!1,S.source));break;case"disassemble":C.body?.instructions.forEach(k=>g(!1,k.location));break;default:break}break}}}function p(w){return w.filter(g=>!g.presentation?.hidden).sort((g,C)=>g.presentation?C.presentation?g.presentation.group?C.presentation.group?g.presentation.group!==C.presentation.group?g.presentation.group.localeCompare(C.presentation.group):l(g.presentation.order,C.presentation.order):-1:C.presentation.group?1:l(g.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function l(w,g){return typeof w!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:w-g}async function D(w,g){const C=w.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(C!=="none"&&(await g.saveAll(),C==="allEditorsInActiveGroup")){const S=g.activeEditorPane;S&&S.input.resource?.scheme===A.Schemas.untitled&&await g.save({editor:S.input,groupId:S.group.id})}await w.reloadConfiguration()}const d=(w,g)=>!w||!g?w===g:w.name===g.name&&w.path===g.path&&w.sourceReference===g.sourceReference;e.sourcesEqual=d}),define(Ie[229],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(T){T[T.Output=1]="Output",T[T.OutputItems=2]="OutputItems",T[T.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.INotebookExecutionService=(0,I.createDecorator)("INotebookExecutionService")}),define(Ie[230],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var L;(function(T){T[T.Disconnected=1]="Disconnected",T[T.Connected=2]="Connected",T[T.Initializing=3]="Initializing"})(L||(e.ProxyKernelState=L={})),e.INotebookKernelService=(0,I.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,I.createDecorator)("INotebookKernelHistoryService")}),define(Ie[231],Pe([1,0,6,30,156,96]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class A extends I.Disposable{constructor(v,_,N){super(),this._source=v,this._inputTextBuffer=_,this._outputs=N,this._outputTextBuffers=void 0}_getFullModelRange(v){const _=v.getLineCount();return new L.Range(1,1,_,this._getLineMaxColumn(v,_))}_getLineMaxColumn(v,_){if(_<1||_>v.getLineCount())throw new Error("Illegal value for lineNumber");return v.getLineLength(_)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const v=new T.PieceTreeTextBufferBuilder;v.acceptChunk(this._source);const _=v.finish(!0),{textBuffer:N,disposable:y}=_.create(1);this._inputTextBuffer=N,this._register(y)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(v=>{const _=new T.PieceTreeTextBufferBuilder;_.acceptChunk(v);const N=_.finish(!0),{textBuffer:y,disposable:h}=N.create(1);return this._register(h),y})),this._outputTextBuffers}findInInputs(v){const N=new O.SearchParams(v,!1,!1,null).parseSearchRequest();if(!N)return[];const y=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(y,N,!0,5e3)}findInOutputs(v){const N=new O.SearchParams(v,!1,!1,null).parseSearchRequest();return N?this.outputTextBuffers.map(y=>{const h=y.findMatchesLineByLine(this._getFullModelRange(y),N,!0,5e3);if(h.length!==0)return{textBuffer:y,matches:h}}).filter(y=>!!y):[]}}e.CellSearchModel=A}),define(Ie[52],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(O){O.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var L;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class T{static fromExtHostTestItem(A,E,v=A.parent){if(A._isRoot)return new T([E]);const _=[A.id];for(let N=v;N&&N.id!==E;N=N.parent)_.push(N.id);return _.push(E),new T(_.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const E=A.indexOf("\0");return E===-1?A:A.slice(0,E)}static fromString(A){return new T(A.split("\0"))}static join(A,E){return new T([...A.path,E])}static joinToString(A,E){return A.toString()+"\0"+E}static parentId(A){const E=A.lastIndexOf("\0");return E===-1?void 0:A.slice(0,E)}static localId(A){const E=A.lastIndexOf("\0");return E===-1?A:A.slice(E+1)}static isChild(A,E){return E.startsWith(A)&&E[A.length]==="\0"}static compare(A,E){return A===E?0:T.isChild(A,E)?2:T.isChild(E,A)?3:1}constructor(A,E=A.length){if(this.path=A,this.viewEnd=E,A.length===0||E<1)throw new Error("cannot create test with empty path")}get rootId(){return new T(this.path,1)}get parentId(){return this.viewEnd>1?new T(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new T(this.path,A)}*idsToRoot(){for(let A=this.viewEnd;A>0;A--)yield new T(this.path,A)}compare(A){if(typeof A=="string")return T.compare(this.toString(),A);for(let E=0;E<A.viewEnd&&E<this.viewEnd;E++)if(A.path[E]!==this.path[E])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=T}),define(Ie[62],Pe([1,0,2,94,30,52]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var A;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.testResultStateToContextValues={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var E;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(E||(e.ExtTestRunProfileKind=E={}));var v;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const _=R=>"runId"in R;e.isStartControllerTests=_;var N;(function(R){R.serialize=z=>({range:z.range.toJSON(),uri:z.uri.toJSON()}),R.deserialize=(z,q)=>({range:T.Range.lift(q.range),uri:z.asCanonicalUri(I.URI.revive(q.uri))})})(N||(e.IRichLocation=N={}));var y;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(y||(e.TestMessageType=y={}));var h;(function(R){R.serialize=z=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&N.serialize(z.location)}),R.deserialize=(z,q)=>({message:q.message,type:0,expected:q.expected,actual:q.actual,contextValue:q.contextValue,location:q.location&&N.deserialize(z,q.location)})})(h||(e.ITestErrorMessage=h={}));const b=(R,z)=>`${z?"s":"e"}${R}`;e.getMarkId=b;var m;(function(R){R.serialize=z=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&N.serialize(z.location)}),R.deserialize=(z,q)=>({message:q.message,type:1,offset:q.offset,length:q.length,location:q.location&&N.deserialize(z,q.location)})})(m||(e.ITestOutputMessage=m={}));var r;(function(R){R.serialize=z=>z.type===0?h.serialize(z):m.serialize(z),R.deserialize=(z,q)=>q.type===0?h.deserialize(z,q):m.deserialize(z,q)})(r||(e.ITestMessage=r={}));var o;(function(R){R.serializeWithoutMessages=z=>({state:z.state,duration:z.duration,messages:[]}),R.serialize=z=>({state:z.state,duration:z.duration,messages:z.messages.map(r.serialize)}),R.deserialize=(z,q)=>({state:q.state,duration:q.duration,messages:q.messages.map(ie=>r.deserialize(z,ie))})})(o||(e.ITestTaskState=o={}));const s="\0",i=(R,z)=>R+s+z;e.namespaceTestTag=i;const n=R=>{const z=R.indexOf(s);return{ctrlId:R.slice(0,z),tagId:R.slice(z+1)}};e.denamespaceTestTag=n;var c;(function(R){R.serialize=z=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?.toJSON(),range:z.range?.toJSON()||null,description:z.description,error:z.error,sortText:z.sortText}),R.deserialize=(z,q)=>({extId:q.extId,label:q.label,tags:q.tags,busy:q.busy,children:void 0,uri:q.uri?z.asCanonicalUri(I.URI.revive(q.uri)):void 0,range:q.range?T.Range.lift(q.range):null,description:q.description,error:q.error,sortText:q.sortText})})(c||(e.ITestItem=c={}));var u;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(R){R.serialize=z=>({expand:z.expand,item:c.serialize(z.item)}),R.deserialize=(z,q)=>({controllerId:O.TestId.root(q.item.extId),expand:q.expand,item:c.deserialize(z,q.item)})})(t||(e.InternalTestItem=t={}));var f;(function(R){R.serialize=z=>{let q;return z.item&&(q={},z.item.label!==void 0&&(q.label=z.item.label),z.item.tags!==void 0&&(q.tags=z.item.tags),z.item.busy!==void 0&&(q.busy=z.item.busy),z.item.uri!==void 0&&(q.uri=z.item.uri?.toJSON()),z.item.range!==void 0&&(q.range=z.item.range?.toJSON()),z.item.description!==void 0&&(q.description=z.item.description),z.item.error!==void 0&&(q.error=z.item.error),z.item.sortText!==void 0&&(q.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:q}},R.deserialize=z=>{let q;return z.item&&(q={},z.item.label!==void 0&&(q.label=z.item.label),z.item.tags!==void 0&&(q.tags=z.item.tags),z.item.busy!==void 0&&(q.busy=z.item.busy),z.item.range!==void 0&&(q.range=z.item.range?T.Range.lift(z.item.range):null),z.item.description!==void 0&&(q.description=z.item.description),z.item.error!==void 0&&(q.error=z.item.error),z.item.sortText!==void 0&&(q.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:q}}})(f||(e.ITestItemUpdate=f={}));const a=(R,z)=>{z.expand!==void 0&&(R.expand=z.expand),z.item!==void 0&&(R.item=R.item?Object.assign(R.item,z.item):z.item)};e.applyTestItemUpdate=a;var p;(function(R){R.serializeWithoutMessages=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(o.serializeWithoutMessages)}),R.serialize=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(o.serialize)}),R.deserialize=(z,q)=>({...t.deserialize(z,q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(ie=>o.deserialize(z,ie)),retired:!0})})(p||(e.TestResultItem=p={}));var l;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(z,q)=>{z.covered+=q.covered,z.total+=q.total}})(l||(e.ICoverageCount=l={}));var D;(function(R){R.serialize=z=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,uri:z.uri.toJSON()}),R.deserialize=(z,q)=>({id:q.id,statement:q.statement,branch:q.branch,declaration:q.declaration,uri:z.asCanonicalUri(I.URI.revive(q.uri))})})(D||(e.IFileCoverage=D={}));function d(R){return{...R,location:R.location?.toJSON()}}function w(R){return R.location=R.location?L.Position.isIPosition(R.location)?L.Position.lift(R.location):T.Range.lift(R.location):void 0,R}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var g;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(g||(e.DetailType=g={}));var C;(function(R){R.serialize=z=>z.type===0?k.serialize(z):P.serialize(z),R.deserialize=z=>z.type===0?k.deserialize(z):P.deserialize(z)})(C||(e.CoverageDetails=C={}));var S;(function(R){R.serialize=d,R.deserialize=w})(S||(e.IBranchCoverage=S={}));var k;(function(R){R.serialize=d,R.deserialize=w})(k||(e.IDeclarationCoverage=k={}));var P;(function(R){R.serialize=z=>({...d(z),branches:z.branches?.map(S.serialize)}),R.deserialize=z=>({...w(z),branches:z.branches?.map(S.deserialize)})})(P||(e.IStatementCoverage=P={}));var H;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(H||(e.TestDiffOpType=H={}));var $;(function(R){R.deserialize=(z,q)=>q.op===0?{op:q.op,item:t.deserialize(z,q.item)}:q.op===1?{op:q.op,item:f.deserialize(q.item)}:q.op===2?{op:q.op,uri:z.asCanonicalUri(I.URI.revive(q.uri)),docv:q.docv}:q,R.serialize=z=>z.op===0?{op:z.op,item:t.serialize(z.item)}:z.op===1?{op:z.op,item:f.serialize(z.item)}:z})($||(e.TestsDiffOp=$={}));class V{constructor(z){this.uriIdentity=z,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(z){const q=this.createChangeCollector();for(const ie of z)switch(ie.op){case 0:this.add(t.deserialize(this.uriIdentity,ie.item),q);break;case 1:this.update(f.deserialize(ie.item),q);break;case 3:this.remove(ie.itemId,q);break;case 5:this.retireTest(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this._tags.set(ie.tag.id,ie.tag);break;case 7:this._tags.delete(ie.id);break}q.complete?.()}add(z,q){const ie=O.TestId.parentId(z.item.extId)?.toString();let ce;if(!ie)ce=this.createItem(z),this.roots.add(ce),this.items.set(z.item.extId,ce);else if(this.items.has(ie)){const Se=this.items.get(ie);Se.children.add(z.item.extId),ce=this.createItem(z,Se),this.items.set(z.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(z)}`);return}return q.add?.(ce),z.expand===2&&this.busyControllerCount++,ce}update(z,q){const ie=this.items.get(z.extId);if(ie)return z.expand!==void 0&&(ie.expand===2&&this.busyControllerCount--,z.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(ie,z),q.update?.(ie),ie}remove(z,q){const ie=this.items.get(z);if(!ie)return;const ce=O.TestId.parentId(ie.item.extId)?.toString();ce?this.items.get(ce).children.delete(ie.item.extId):this.roots.delete(ie);const Se=[[z]];for(;Se.length;)for(const De of Se.pop()){const fe=this.items.get(De);fe&&(Se.push(fe.children),this.items.delete(De),q.remove?.(fe,fe!==ie),fe.expand===2&&this.busyControllerCount--)}}retireTest(z){}updatePendingRoots(z){this.pendingRootCount+=z}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=V}),define(Ie[77],Pe([1,0,11,5,6,57,62,52]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const _=(i,n)=>i===n,y=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:_,label:_,description:_,error:_,sortText:_,tags:(i,n)=>!(i.length!==n.length||i.some(c=>!n.includes(c)))}),h=(i,n)=>{let c;for(const[u,t]of y)t(i[u],n[u])||(c?c[u]=n[u]:c={[u]:n[u]});return c};class b extends T.Disposable{get root(){return this.options.root}constructor(n){super(),this.options=n,this.debounceSendDiff=this._register(new I.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const c of this.tree.values())this.updateExpandability(c)}get resolveHandler(){return this._resolveHandler}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.diff)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.diff[this.diff.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,A.applyTestItemUpdate)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,A.applyTestItemUpdate)(c.item,n.item);return}}break}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,c){const u=this.tree.get(n);if(u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const t=this.resolveChildren(u);return t.isOpen()?this.expandChildren(u,c-1):t.wait().then(()=>this.expandChildren(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,c-1)):this.expandChildren(u,c-1)}}dispose(){for(const n of this.tree.values())this.options.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,c){switch(c.op){case 3:this.removeItem(E.TestId.joinToString(n.fullId,c.id));break;case 0:this.upsertItem(c.item,n);break;case 5:for(const u of c.ops)this.onTestItemEvent(n,u);break;case 1:this.diffTagRefs(c.new,c.old,n.fullId.toString());break;case 2:this.updateExpandability(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.documentSynced(n.actual.uri);break;default:(0,O.assertNever)(c)}}documentSynced(n){n&&this.pushDiff({op:2,uri:n,docv:this.options.getDocumentVersion(n)})}upsertItem(n,c){const u=E.TestId.fromExtHostTestItem(n,this.root.id,c?.actual),t=this.options.getApiFor(n);t.parent&&t.parent!==c?.actual&&this.options.getChildren(t.parent).delete(n.id);let f=this.tree.get(u.toString());if(!f){f={fullId:u,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(f.fullId.toString(),f),this.setItemParent(n,c),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:f.expand,item:this.options.toITestItem(n)}}),this.connectItemAndChildren(n,f,c);return}if(f.actual===n){this.connectItem(n,f,c);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.removeItem(u.toString()),this.upsertItem(n,c);const a=this.options.getChildren(f.actual),p=f.actual,l=h(this.options.toITestItem(p),this.options.toITestItem(n));this.options.getApiFor(p).listener=void 0,f.actual=n,f.resolveBarrier=void 0,f.expand=0,l&&(l.hasOwnProperty("tags")&&(this.diffTagRefs(n.tags,p.tags,u.toString()),delete l.tags),this.onTestItemEvent(f,{op:4,update:l})),this.connectItemAndChildren(n,f,c);for(const[d,w]of a)this.options.getChildren(n).get(w.id)||this.removeItem(E.TestId.joinToString(u,w.id));const D=f.expandLevels;D!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(u.toString(),D))}),this.documentSynced(f.actual.uri)}diffTagRefs(n,c,u){const t=new Set(c.map(f=>f.id));for(const f of n)t.delete(f.id)||this.incrementTagRefs(f);this.pushDiff({op:1,item:{extId:u,item:{tags:n.map(f=>(0,A.namespaceTestTag)(this.options.controllerId,f.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const c=this.tags.get(n.id);c?c.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.namespaceTestTag)(this.options.controllerId,n.id)}}))}decrementTagRefs(n){const c=this.tags.get(n);c&&!--c.refCount&&(this.tags.delete(n),this.pushDiff({op:7,id:(0,A.namespaceTestTag)(this.options.controllerId,n)}))}setItemParent(n,c){this.options.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}connectItem(n,c,u){this.setItemParent(n,u);const t=this.options.getApiFor(n);t.parent=u?.actual,t.listener=f=>this.onTestItemEvent(c,f),this.updateExpandability(c)}connectItemAndChildren(n,c,u){this.connectItem(n,c,u);for(const[t,f]of this.options.getChildren(n))this.upsertItem(f,c)}updateExpandability(n){let c;this._resolveHandler?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,c){if(c<0)return;const u=[];for(const[t,f]of this.options.getChildren(n.actual)){const a=this.expand(E.TestId.joinToString(n.fullId,f.id),c);(0,I.isThenable)(a)&&u.push(a)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const f=new I.Barrier;return f.open(),f}n.expand=2,this.pushExpandStateUpdate(n);const c=n.resolveBarrier=new I.Barrier,u=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,f)};let t;try{t=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(f){u(f)}return(0,I.isThenable)(t)?t.catch(u).then(()=>{c.open(),this.updateExpandability(n)}):(c.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}removeItem(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const u=[c];for(;u.length;){const t=u.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.decrementTagRefs(f.id);this.tree.delete(t.fullId.toString());for(const[f,a]of this.options.getChildren(t.actual))u.push(this.tree.get(E.TestId.joinToString(t.fullId,a.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.TestItemCollection=b;class m extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.DuplicateTestItemError=m;class r extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=r;class o extends Error{constructor(n,c,u){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=o;const s=(i,n,c)=>{let u=new Map;return{get size(){return u.size},forEach(t,f){for(const a of u.values())t.call(f,a,this)},[Symbol.iterator](){return u.entries()},replace(t){const f=new Map,a=new Set(u.keys()),p={op:5,ops:[]};for(const l of t){if(!(l instanceof c))throw new r(l.id);const D=n(l).controllerId;if(D!==i.controllerId)throw new o(l.id,D,i.controllerId);if(f.has(l.id))throw new m(l.id);f.set(l.id,l),a.delete(l.id),p.ops.push({op:0,item:l})}for(const l of a.keys())p.ops.push({op:3,id:l});i.listener?.(p),u=f},add(t){if(!(t instanceof c))throw new r(t.id);u.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){u.delete(t)&&i.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.createTestItemChildren=s}),define(Ie[107],Pe([1,0,77]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,T=(A,E)=>{const v={controllerId:E};return L.set(A,v),v};e.createPrivateApiFor=T;const O=A=>{const E=L.get(A);if(!E)throw new I.InvalidTestItemError(A?.id||"<unknown>");return E};e.getPrivateApiFor=O}),define(Ie[78],Pe([1,0,16,2]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=T,e.decodeAuthority=A,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function T(E,v){return E.scheme===I.Schemas.http||E.scheme===I.Schemas.https?E:(v&&v.authority&&v.isRemote&&E.scheme===I.Schemas.file&&(E=L.URI.from({scheme:I.Schemas.vscodeRemote,authority:v.authority,path:E.path})),L.URI.from({scheme:I.Schemas.https,authority:`${E.scheme}+${O(E.authority)}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}function O(E){return E.replace(/./g,v=>{const _=v.charCodeAt(0);return _>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57?v:"-"+_.toString(16).padStart(4,"0")})}function A(E){return E.replace(/-([0-9a-f]{4})/g,(v,_)=>String.fromCharCode(parseInt(_,16)))}}),define(Ie[232],Pe([1,0,5,6,78]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class O{constructor(E,v,_){this._proxy=E,this._editors=v,this._remoteInfo=_,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(v.onDidChangeVisibleTextEditors(()=>{const N=v.getVisibleTextEditors();for(const y of this._insets.values())N.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(E=>E.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(E,v,_,N,y){let h;for(const n of this._editors.getVisibleTextEditors(!0))if(n.value===E){h=n;break}if(!h)throw new Error("not a visible editor");const b=this,m=this._handlePool++,r=new I.Emitter,o=new I.Emitter,s=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(n){return(0,T.asWebviewUri)(n,b._remoteInfo)}get cspSource(){return T.webviewGenericCspSource}set options(n){this._options=n,b._proxy.$setOptions(m,n)}get options(){return this._options}set html(n){this._html=n,b._proxy.$setHtml(m,n)}get html(){return this._html}get onDidReceiveMessage(){return r.event}postMessage(n){return b._proxy.$postMessage(m,n)}},i=new class{constructor(){this.editor=E,this.line=v,this.height=_,this.webview=s,this.onDidDispose=o.event}dispose(){b._insets.has(m)&&(b._insets.delete(m),b._proxy.$disposeEditorInset(m),o.fire(),o.dispose(),r.dispose())}};return this._proxy.$createEditorInset(m,h.id,h.value.document.uri,v+1,_,N||{},y.identifier,y.extensionLocation),this._insets.set(m,{editor:E,inset:i,onDidReceiveMessage:r}),i}$onDidDispose(E){const v=this._insets.get(E);v&&v.inset.dispose()}$onDidReceiveMessage(E,v){this._insets.get(E)?.onDidReceiveMessage.fire(v)}}e.ExtHostEditorInsets=O}),define(Ie[108],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,I.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,I.createDecorator)("IAuthenticationExtensionsService")}),define(Ie[233],Pe([1,0,3]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,I.createDecorator)("configurationResolverService");var L;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(L||(e.VariableKind=L={}));class T extends Error{constructor(A,E){super(E),this.variable=A}}e.VariableError=T}),define(Ie[234],Pe([1,0,19,75,15,25,22,97,192,233,13]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,m,r,o){this._contributedVariables=new Map,this._context=b,this._labelService=m,this._userHomePromise=r,o&&(this._envVariablesPromise=o.then(s=>this.prepareEnv(s)))}prepareEnv(b){if(A.isWindows){const m=Object.create(null);return Object.keys(b).forEach(r=>{m[r.toLowerCase()]=b[r]}),m}return b}resolveWithEnvironment(b,m,r){return this.recursiveResolve({env:this.prepareEnv(b),userHome:void 0},m?m.uri:void 0,r)}async resolveAsync(b,m){const r={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(r,b?b.uri:void 0,m)}async resolveAnyBase(b,m,r,o){const s=O.deepClone(m);A.isWindows&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):A.isMacintosh&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):A.isLinux&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(i,b?b.uri:void 0,s,r,o)}async resolveAnyAsync(b,m,r){return this.resolveAnyBase(b,m,r)}async resolveAnyMap(b,m,r){const o=new Map;return{newConfig:await this.resolveAnyBase(b,m,r,o),resolvedVariables:o}}resolveWithInteractionReplace(b,m,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,m,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,m){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,m)}async recursiveResolve(b,m,r,o,s){if(T.isString(r))return this.resolveString(b,m,r,o,s);if(Array.isArray(r))return Promise.all(r.map(i=>this.recursiveResolve(b,m,i,o,s)));if(T.isObject(r)){const i=Object.create(null),n=await Promise.all(Object.keys(r).map(async c=>[await this.resolveString(b,m,c,o,s),await this.recursiveResolve(b,m,r[c],o,s)]));for(const[c,u]of n)i[c]=u;return i}return r}resolveString(b,m,r,o,s){return(0,N.replaceAsync)(r,y.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(y.VARIABLE_LHS))return i;let c=await this.evaluateSingleVariable(b,i,n,m,o);return s?.set(n,c),c!==i&&T.isString(c)&&c.match(y.VARIABLE_REGEXP)&&(c=await this.resolveString(b,m,c,o,s)),c})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}async evaluateSingleVariable(b,m,r,o,s){let i;const n=r.split(":");n.length>1&&(r=n[0],i=n[1]);const c=f=>{const a=this._context.getFilePath();if(a)return(0,E.normalizeDriveLetter)(a);throw new _.VariableError(f,(0,v.localize)(0,null,m))},u=f=>{const a=c(f);if(this._context.getWorkspaceFolderPathForFile){const p=this._context.getWorkspaceFolderPathForFile();if(p)return(0,E.normalizeDriveLetter)(p)}throw new _.VariableError(f,(0,v.localize)(1,null,m,I.basename(a)))},t=f=>{if(i){const a=this._context.getFolderUri(i);if(a)return a;throw new _.VariableError(f,(0,v.localize)(2,null,m,i))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new _.VariableError(f,(0,v.localize)(3,null,m)):new _.VariableError(f,(0,v.localize)(4,null,m))};switch(r){case"env":if(i){if(b.env){const f=b.env[A.isWindows?i.toLowerCase():i];if(T.isString(f))return f}return""}throw new _.VariableError(_.VariableKind.Env,(0,v.localize)(5,null,m));case"config":if(i){const f=this._context.getConfigurationValue(o,i);if(T.isUndefinedOrNull(f))throw new _.VariableError(_.VariableKind.Config,(0,v.localize)(6,null,m,i));if(T.isObject(f))throw new _.VariableError(_.VariableKind.Config,(0,v.localize)(7,null,m,i));return f}throw new _.VariableError(_.VariableKind.Config,(0,v.localize)(8,null,m));case"command":return this.resolveFromMap(_.VariableKind.Command,m,i,s,"command");case"input":return this.resolveFromMap(_.VariableKind.Input,m,i,s,"input");case"extensionInstallFolder":if(i){const f=await this._context.getExtension(i);if(!f)throw new _.VariableError(_.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,m,i));return this.fsPath(f.extensionLocation)}throw new _.VariableError(_.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,m));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,E.normalizeDriveLetter)(this.fsPath(t(_.VariableKind.WorkspaceFolder)));case"cwd":return o||i?(0,E.normalizeDriveLetter)(this.fsPath(t(_.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,E.normalizeDriveLetter)(I.basename(this.fsPath(t(_.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new _.VariableError(_.VariableKind.UserHome,(0,v.localize)(11,null,m))}case"lineNumber":{const f=this._context.getLineNumber();if(f)return f;throw new _.VariableError(_.VariableKind.LineNumber,(0,v.localize)(12,null,m))}case"selectedText":{const f=this._context.getSelectedText();if(f)return f;throw new _.VariableError(_.VariableKind.SelectedText,(0,v.localize)(13,null,m))}case"file":return c(_.VariableKind.File);case"fileWorkspaceFolder":return u(_.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.basename(u(_.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||i?I.relative(this.fsPath(t(_.VariableKind.RelativeFile)),c(_.VariableKind.RelativeFile)):c(_.VariableKind.RelativeFile);case"relativeFileDirname":{const f=I.dirname(c(_.VariableKind.RelativeFileDirname));if(o||i){const a=I.relative(this.fsPath(t(_.VariableKind.RelativeFileDirname)),f);return a.length===0?".":a}return f}case"fileDirname":return I.dirname(c(_.VariableKind.FileDirname));case"fileExtname":return I.extname(c(_.VariableKind.FileExtname));case"fileBasename":return I.basename(c(_.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=I.basename(c(_.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-I.extname(f).length)}case"fileDirnameBasename":return I.basename(I.dirname(c(_.VariableKind.FileDirnameBasename)));case"execPath":{const f=this._context.getExecPath();return f||m}case"execInstallFolder":{const f=this._context.getAppRoot();return f||m}case"pathSeparator":case"/":return I.sep;default:try{const f=i?`${r}:${i}`:r;return this.resolveFromMap(_.VariableKind.Unknown,m,f,s,void 0)}catch{return m}}}}resolveFromMap(b,m,r,o,s){if(r&&o){const i=s===void 0?o[r]:o[s+":"+r];if(typeof i=="string")return i;throw new _.VariableError(b,(0,v.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=y}),define(Ie[109],Pe([1,0,3,106]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=_,e.isEditorGroup=h,e.preferredSideBySideGroupDirection=b,e.IEditorGroupsService=(0,I.createDecorator)("editorGroupsService");var T;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(T||(e.GroupDirection=T={}));var O;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var E;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(E||(e.GroupsArrangement=E={}));var v;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function _(m){const r=m;return(0,L.isEditorInput)(r?.editor)&&(0,L.isEditorInput)(r?.replacement)}var N;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N||(e.GroupsOrder=N={}));var y;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function h(m){const r=m;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function b(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ie[235],Pe([1,0,3,109]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=T,e.IEditorService=(0,I.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function T(O){const A=O;return typeof O=="number"||(0,L.isEditorGroup)(A)}}),define(Ie[236],Pe([1,0,3,99]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,I.refineServiceDecorator)(L.IEnvironmentService)}),define(Ie[110],Pe([1,0,20,5,19,6,11]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class E{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.DeltaExtensionsResult=E;class v{static isHostExtension(i,n,c){if(n.getExtensionDescription(i))return!1;const u=c.getExtensionDescription(i);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(i,n){this._activationEventsReader=i,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(r),this._extensionsMap=new I.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this._extensionsMap.set(i.identifier,i),this._extensionsArr.push(i);const n=this._activationEventsReader.readActivationEvents(i);for(const c of n)this._activationMap.has(c)||this._activationMap.set(c,[]),this._activationMap.get(c).push(i)}}set(i){return this._extensionDescriptions=i,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(i,n){this._extensionDescriptions=o(this._extensionDescriptions,n),this._extensionDescriptions=this._extensionDescriptions.concat(i);const c=v._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=o(this._extensionDescriptions,c.map(u=>u.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new E(this._versionId,c)}static _findLoopingExtensions(i){const n=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(a){this._nodesSet.has(a)||(this._nodesSet.add(a),this._nodesArr.push(a))}addArc(a,p){this.addNode(a),this.addNode(p),this._arcs.has(a)?this._arcs.get(a).push(p):this._arcs.set(a,[p])}getArcs(a){return this._arcs.has(a)?this._arcs.get(a):[]}hasOnlyGoodArcs(a,p){const l=n.getArcs(a);for(let D=0;D<l.length;D++)if(!p.has(l[D]))return!1;return!0}getNodes(){return this._nodesArr}},c=new I.ExtensionIdentifierMap;for(const a of i)if(c.set(a.identifier,a),a.extensionDependencies)for(const p of a.extensionDependencies)n.addArc(I.ExtensionIdentifier.toKey(a.identifier),I.ExtensionIdentifier.toKey(p));const u=new Set;n.getNodes().filter(a=>n.getArcs(a).length===0).forEach(a=>u.add(a));const t=n.getNodes().filter(a=>!u.has(a));let f;do{f=!1;for(let a=0;a<t.length;a++){const p=t[a];n.hasOnlyGoodArcs(p,u)&&(t.splice(a,1),a--,u.add(p),f=!0)}}while(f);return t.map(a=>c.get(a))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this._activationMap.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new _(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this._extensionsMap.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this._extensionsArr)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.ExtensionDescriptionRegistry=v;class _{constructor(i,n){this.versionId=i,this.extensions=n}}e.ExtensionDescriptionRegistrySnapshot=_;class N{constructor(i){this._lock=new b,this._actual=new v(i,[])}async acquireLock(i){const n=await this._lock.acquire(i);return new y(this,n)}deltaExtensions(i,n,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(n,c)}containsActivationEvent(i){return this._actual.containsActivationEvent(i)}containsExtension(i){return this._actual.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this._actual.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(i){return this._actual.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this._actual.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this._actual.getExtensionDescriptionByIdOrUUID(i,n)}}e.LockableExtensionDescriptionRegistry=N;class y extends O.Disposable{constructor(i,n){super(),this._registry=i,this._isDisposed=!1,this._register(n)}isAcquiredFor(i){return!this._isDisposed&&this._registry===i}}e.ExtensionDescriptionRegistryLock=y;class h{constructor(i){this.name=i;const n=(0,A.promiseWithResolvers)();this.promise=n.promise,this._resolve=n.resolve}resolve(i){this._resolve(i)}}class b{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(i){const n=new h(i);return this._pendingCustomers.push(n),this._advance(),n.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const i=this._pendingCustomers.shift();this._isLocked=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{n&&(clearTimeout(c),n=!1,this._isLocked=!1,this._advance())};i.resolve((0,O.toDisposable)(u))}}var m;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(m||(m={}));function r(s,i){const n=s.isBuiltin?0:s.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==c)return n-c;const u=T.posix.basename(s.extensionLocation.path),t=T.posix.basename(i.extensionLocation.path);return u<t?-1:u>t?1:0}function o(s,i){const n=new I.ExtensionIdentifierSet(i);return s.filter(c=>!n.has(c.identifier))}}),define(Ie[79],Pe([1,0,21]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=A,e.isMessageOfType=E;var L;(function(_){_[_.Desktop=1]="Desktop",_[_.Web=2]="Web"})(L||(e.UIKind=L={}));var T;(function(_){_[_.VersionMismatch=55]="VersionMismatch",_[_.UnexpectedError=81]="UnexpectedError"})(T||(e.ExtensionHostExitCode=T={}));var O;(function(_){_[_.Initialized=0]="Initialized",_[_.Ready=1]="Ready",_[_.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(_){const N=I.VSBuffer.alloc(1);switch(_){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}function E(_,N){if(_.byteLength!==1)return!1;switch(_.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}var v;(function(_){_.Start="START_NATIVE_LOG",_.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Ie[63],Pe([1,0,3,5,12,27,79,58,59,25,2,6,179]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=r;let b=class extends y.Disposable{constructor(s,i){super(),this.initData=s,this.loggerService=i,this._onDidChangeTelemetryEnabled=this._register(new L.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new L.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=N.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=i.createLogger(this.extHostTelemetryLogFile,{id:v.extensionTelemetryLogChannelId,name:(0,h.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(i.onDidChangeLogLevel(n=>{(0,T.isLogLevel)(n)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===T.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(s,i,n){const c=this.getTelemetryDetails(),u=new m(i,n,s,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(s),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this._telemetryLoggers.get(s.identifier.value)??[];return this._telemetryLoggers.set(s.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this._level=s,this._telemetryIsSupported=i,this._productConfig=n??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,i["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,i["common.sqmid"]=this.initData.telemetryInfo.sqmId,i["common.vscodeversion"]=this.initData.version,i["common.isnewappinstall"]=r(this.initData.telemetryInfo.firstSessionDate),i["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,E.getRemoteName)((0,v.cleanRemoteAuthority)(this.initData.remote.authority)),i}$onDidChangeTelemetryLevel(s){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=s;const i=this.getTelemetryDetails();this._telemetryLoggers.forEach((n,c)=>{const u=n.filter(t=>!t.isDisposed);u.length===0?this._telemetryLoggers.delete(c):this._telemetryLoggers.set(c,u)}),this._telemetryLoggers.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(s,i){const c=this._telemetryLoggers.get(s.value)?.filter(t=>!t.isDisposed);if(!c)return this._telemetryLoggers.delete(s.value),!1;let u=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(i),u=!0);return u}};e.ExtHostTelemetry=b,e.ExtHostTelemetry=b=Ke([He(0,O.IExtHostInitDataService),He(1,T.ILoggerService)],b);class m{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,c,u,t,f){this._extension=n,this._logger=c,this._inLoggingOnlyMode=u,this._commonProperties=t,this._onDidChangeEnableStates=new L.Emitter,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=i?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=i?.additionalCommonProperties,this._sender=s,this._telemetryEnablements={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(s,i){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:s,isErrorsEnabled:i},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,v.cleanData)(i,[]),this._additionalCommonProperties&&(i=(0,_.mixin)(i,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(i=(0,_.mixin)(i,this._commonProperties)),"properties"in s?s.properties=i:s=i,s}logEvent(s,i){this._sender&&(this._extension.publisher==="vscode"?s=this._extension.name+"/"+s:s=this._extension.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(s,i),this._logger.trace(s,i))}logUsage(s,i){this._telemetryEnablements.isUsageEnabled&&this.logEvent(s,i)}logError(s,i){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof s=="string")this.logEvent(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},c=(0,v.cleanData)(n,[]),u=new Error(c.message,{cause:c.cause});u.stack=c.stack,u.name=c.name,i=this.mixInCommonPropsAndCleanData(i||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(u,i),this._logger.trace("exception",i)}}get apiTelemetryLogger(){if(!this._apiObject){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return s._telemetryEnablements.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s._onDidChangeEnableStates.event.bind(s)};this._apiObject=Object.freeze(i)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let s=this._sender;this._sender=void 0,Promise.resolve(s.flush()).then(s=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=m;function r(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.IExtHostTelemetry=(0,I.createDecorator)("IExtHostTelemetry")}),define(Ie[26],Pe([1,0,5,2,207,105,20,3]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=h,e.checkProposedApiEnabled=b,e.toExtension=s,e.toExtensionDescription=i,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");class v{constructor(u){this.dependency=u}}e.MissingExtensionDependency=v;var _;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(_||(e.ExtensionHostStartup=_={}));class N{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(u,t,f){this._versionId=u,this._allExtensions=t.slice(0),this._myExtensions=f.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:O.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(u,t,f){if(this._versionId>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this._versionId})`);const a=[],p=[],l=[],D=[],d=y(this._allExtensions),w=y(t),g=(H,$)=>H.extensionLocation.toString()===$.extensionLocation.toString()||H.isBuiltin===$.isBuiltin||H.isUserBuiltin===$.isUserBuiltin||H.isUnderDevelopment===$.isUnderDevelopment;for(const H of this._allExtensions){const $=w.get(H.identifier);if(!$){a.push(H.identifier),d.delete(H.identifier);continue}if(!g(H,$)){a.push(H.identifier),d.delete(H.identifier);continue}}for(const H of t){const $=d.get(H.identifier);if(!$){p.push(H);continue}if(!g($,H)){a.push($.identifier),d.delete($.identifier);continue}}const C=new A.ExtensionIdentifierSet(this._myExtensions),S=new A.ExtensionIdentifierSet(f);for(const H of this._myExtensions)S.has(H)||l.push(H);for(const H of f)C.has(H)||D.push(H);const k=O.ImplicitActivationEvents.createActivationEventsMap(p),P={versionId:u,toRemove:a,toAdd:p,addActivationEvents:k,myToRemove:l,myToAdd:D};return this.delta(P),P}delta(u){if(this._versionId>=u.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:a,myToAdd:p}=u,l=new A.ExtensionIdentifierSet(t),D=new A.ExtensionIdentifierSet(a);for(let d=0;d<this._allExtensions.length;d++)l.has(this._allExtensions[d].identifier)&&(this._allExtensions.splice(d,1),d--);for(let d=0;d<this._myExtensions.length;d++)D.has(this._myExtensions[d])&&(this._myExtensions.splice(d,1),d--);for(const d of f)this._allExtensions.push(d);for(const d of p)this._myExtensions.push(d);return this._myActivationEvents=null,u}containsExtension(u){for(const t of this._myExtensions)if(A.ExtensionIdentifier.equals(t,u))return!0;return!1}containsActivationEvent(u){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(u)}_readMyActivationEvents(){const u=new Set;for(const t of this._allExtensions){if(!this.containsExtension(t.identifier))continue;const f=O.ImplicitActivationEvents.readActivationEvents(t);for(const a of f)u.add(a)}return u}}e.ExtensionHostExtensions=N;function y(c){const u=new A.ExtensionIdentifierMap;for(const t of c)u.set(t.identifier,t);return u}function h(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}function b(c,u){if(!h(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class m{constructor(u,t,f,a){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=a}}e.ActivationTimes=m;class r{constructor(u,t){this.description=u,this.value=t}}e.ExtensionPointContribution=r;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function i(c,u){return{identifier:new A.ExtensionIdentifier((0,T.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=n}),define(Ie[237],Pe([1,0,14,110,20,26,12,11]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class v{static{this.NONE=new v(!1,-1,-1,-1)}constructor(s,i,n,c){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=c}}e.ExtensionActivationTimes=v;class _{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,i){return s===-1||i===-1?-1:i-s}build(){return new v(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class N{constructor(s,i,n,c,u,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=c,this.exports=u,this.subscriptions=t}}e.ActivatedExtension=N;class y extends N{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=y;class h extends N{constructor(){super(!1,null,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=h;class b extends N{constructor(s){super(!0,s,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(s,i,n,c){this._logService=c,this._registry=s,this._globalRegistry=i,this._host=n,this._operations=new T.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[s,i]of this._operations)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this._operations)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this._operations.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this._operations.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this._alreadyActivatedEvents[s])return;const n=this._registry.getExtensionDescriptionsForActivationEvent(s);await this._activateExtensions(n.map(c=>({id:c.identifier,reason:{startup:i,extensionId:c.identifier,activationEvent:s}}))),this._alreadyActivatedEvents[s]=!0}activateById(s,i){const n=this._registry.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s.value}' is not known`);return this._activateExtensions([{id:n.identifier,reason:i}])}async _activateExtensions(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this._handleActivationRequest(n));await Promise.all(i.map(n=>n.wait()))}_handleActivationRequest(s){if(this._operations.has(s.id))return this._operations.get(s.id);if(this._isHostExtension(s.id))return this._createAndSaveOperation(s,null,[],null);const i=this._registry.getExtensionDescription(s.id);if(!i){const u=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this._createAndSaveOperation(s,null,[],new b(u));return this._host.onExtensionActivationError(s.id,u,new O.MissingExtensionDependency(s.id.value)),t}const n=[],c=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const u of c){if(this._isResolvedExtension(u))continue;const t=this._operations.get(u);if(t){n.push(t);continue}if(this._isHostExtension(u)){n.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(u).identifier,reason:s.reason}));continue}const f=this._registry.getExtensionDescription(u);if(f){if(!f.main&&!f.browser)continue;n.push(this._handleActivationRequest({id:f.identifier,reason:s.reason}));continue}const a=i.displayName||i.identifier.value,p=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${u}'`),l=this._createAndSaveOperation(s,i.displayName,[],new b(p));return this._host.onExtensionActivationError(i.identifier,p,new O.MissingExtensionDependency(u)),l}return this._createAndSaveOperation(s,i.displayName,n,null)}_createAndSaveOperation(s,i,n,c){const u=new r(s.id,i,s.reason,n,c,this._host,this._logService);return this._operations.set(s.id,u),u}_isHostExtension(s){return L.ExtensionDescriptionRegistry.isHostExtension(s,this._registry,this._globalRegistry)}_isResolvedExtension(s){const i=this._globalRegistry.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.ExtensionsActivator=m,e.ExtensionsActivator=m=Ke([He(3,A.ILogService)],m);let r=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(s,i,n,c,u,t,f){this._id=s,this._displayName=i,this._reason=n,this._deps=c,this._value=u,this._host=t,this._logService=f,this._barrier=new E.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let s=0;s<this._deps.length;s++){const i=this._deps[s];if(i.value&&!i.value.activationFailed){this._deps.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this._value=new b(n),this._host.onExtensionActivationError(this._id,n,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(s=>s.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this._id.value}' failed: ${s.message}.`:i.message=`Activating extension '${this._id.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this._value=new b(i),this._isDisposed&&I.isCancellationError(s))return;this._host.onExtensionActivationError(this._id,i,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(s)}}};r=Ke([He(6,A.ILogService)],r)}),define(Ie[238],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testPreserveFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testPreserveFocus.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[239],Pe([1,0,194,14,33,100,74,29,20,238,102,105]),function(ue,e,I,L,T,O,A,E,v,_,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const h=E.Registry.as(A.Extensions.JSONContribution);class b{constructor(u,t,f){this._messageHandler=u,this._extension=t,this._extensionPointId=f}_msg(u,t){this._messageHandler({type:u,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(u){this._msg(T.default.Error,u)}warn(u){this._msg(T.default.Warning,u)}info(u){this._msg(T.default.Info,u)}}e.ExtensionMessageCollector=b;class m{static _toSet(u){const t=new v.ExtensionIdentifierSet;for(let f=0,a=u.length;f<a;f++)t.add(u[f].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new m(t,[]);if(!t||!t.length)return new m([],u);const f=this._toSet(u),a=this._toSet(t),p=t.filter(D=>!f.has(D.description.identifier)),l=u.filter(D=>!a.has(D.description.identifier));return new m(p,l)}constructor(u,t){this.added=u,this.removed=t}}e.ExtensionPointUserDelta=m;class r{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(u){if(this._handler!==null)throw new Error("Handler already set!");this._handler=u,this._handle()}acceptUsers(u){this._delta=m.compute(this._users,u),this._users=u,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(u){(0,L.onUnexpectedError)(u)}}}e.ExtensionPoint=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(_.allApiProposals),markdownEnumDescriptions:Object.values(_.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this._extensionPoints=new Map}registerExtensionPoint(u){if(this._extensionPoints.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new r(u.extensionPoint,u.defaultExtensionKind);return this._extensionPoints.set(u.extensionPoint,t),u.activationEventsGenerator&&y.ImplicitActivationEvents.register(u.extensionPoint,u.activationEventsGenerator),e.schema.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,h.registerSchema(s,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};E.Registry.add(n.ExtensionsRegistry,new i),e.ExtensionsRegistry=E.Registry.as(n.ExtensionsRegistry),h.registerSchema(s,e.schema),h.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(_.allApiProposals),markdownEnumDescriptions:Object.values(_.allApiProposals)}}]}}}})}),define(Ie[240],Pe([1,0,190,15,25,239,31,5]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const v={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var _;(function(h){function b(m,r,o){if(!m)return;const s=L.isString(m.type)?m.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const i=[];if(Array.isArray(m.required))for(const n of m.required)L.isString(n)&&i.push(n);return{extensionId:r.value,taskType:s,required:i,properties:m.properties?T.deepClone(m.properties):{},when:m.when?A.ContextKeyExpr.deserialize(m.when):void 0}}h.from=b})(_||(_={}));const N=O.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,b)=>{for(const m of h)m.type&&b.push(`onTaskType:${m.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:v}});class y{constructor(){this._onDefinitionsChanged=new E.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((b,m)=>{N.setHandler((r,o)=>{this._schema=void 0;try{for(const s of o.removed){const i=s.value;for(const n of i)this.taskTypes&&n.type&&this.taskTypes[n.type]&&delete this.taskTypes[n.type]}for(const s of o.added){const i=s.value;for(const n of i){const c=_.from(n,s.description.identifier,s.collector);c&&(this.taskTypes[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}b(void 0)})})}onReady(){return this.readyPromise}get(b){return this.taskTypes[b]}all(){return Object.keys(this.taskTypes).map(b=>this.taskTypes[b])}getJsonSchema(){if(this._schema===void 0){const b=[];for(const m of this.all()){const r={type:"object",additionalProperties:!1};m.required.length>0&&(r.required=m.required.slice(0)),m.properties!==void 0?r.properties=T.deepClone(m.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[m.taskType]},b.push(r)}this._schema={oneOf:b}}return this._schema}}e.TaskDefinitionRegistry=new y}),define(Ie[241],Pe([1,0,191,15,23,25,31,240]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,I.localize(0,null)),e.TASKS_CATEGORY=I.localize2(2,"Tasks");var v;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(v||(e.ShellQuoting=v={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(R){function z(q){if(!q)return R.Strong;switch(q.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=z}(v||(e.ShellQuoting=v={}));var _;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(_||(e.CommandOptions=_={}));var N;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(N||(e.RevealKind=N={})),function(R){function z(q){switch(q.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=z}(N||(e.RevealKind=N={}));var y;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(y||(e.RevealProblemKind=y={})),function(R){function z(q){switch(q.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=z}(y||(e.RevealProblemKind=y={}));var h;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(h||(e.PanelKind=h={})),function(R){function z(q){switch(q.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=z}(h||(e.PanelKind=h={}));var b;(function(R){R.defaults={echo:!0,reveal:N.Always,revealProblems:y.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var m;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(R){function z(ie){switch(ie.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=z;function q(ie){switch(ie){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=q}(m||(e.RuntimeType=m={}));var r;(function(R){function z(q){return L.isString(q)?q:q.value}R.value=z})(r||(e.CommandString=r={}));var o;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function z(ie){return ie===R.Clean._id||ie===R.Build._id||ie===R.Rebuild._id||ie===R.Test._id}R.is=z;function q(ie){if(ie!==void 0)return L.isString(ie)?z(ie)?{_id:ie,isDefault:!1}:void 0:ie}R.from=q})(o||(e.TaskGroup=o={}));var s;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function z(q){switch(q){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=z})(i||(e.TaskSourceKind=i={}));var n;(function(R){R.parallel="parallel",R.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var u;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(z,q,ie,ce,Se,De){this._label="",this._id=z,q&&(this._label=q),ie&&(this.type=ie),this.runOptions=ce,this.configurationProperties=Se,this._source=De}getDefinition(z){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const z={folder:this.getFolderId(),id:this._id};return JSON.stringify(z)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,q=!1){if(z===void 0)return!1;if(L.isString(z))return z===this._label||z===this.configurationProperties.identifier||q&&z===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),z&&(this._taskLoadMessages=this._taskLoadMessages.concat(z))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class f extends t{constructor(z,q,ie,ce,Se,De,fe,pe){super(z,ie,void 0,fe,pe,q),this.command={},this._source=q,this.hasDefinedMatchers=De,Se&&(this.command=Se)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case m.Shell:q="shell";break;case m.Process:q="process";break;case m.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(z){return z instanceof f}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const z=this.getFolderId();if(!z)return;let q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(q+=this._source.kind);const ie={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:q};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(z){return new f(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.CustomTask=f;class a extends t{constructor(z,q,ie,ce,Se,De,fe){super(z,ie,ce,De,fe,q),this._source=q,this.configures=Se}static is(z){return z instanceof a}fromObject(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===i.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const z=this.getFolderId();if(!z)return;let q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(q+=this._source.kind);const ie={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:q};return JSON.stringify(ie)}}e.ConfiguringTask=a;class p extends t{constructor(z,q,ie,ce,Se,De,fe,pe,Ne){super(z,ie,ce,pe,Ne,q),this.defines=Se,this.hasDefinedMatchers=fe,this.command=De,this.icon=Ne.icon,this.hide=Ne.hide}clone(){return new p(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof p}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.getFolderId(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(z){return new p(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.ContributedTask=p;class l extends t{constructor(z,q,ie,ce,Se,De){super(z,ie,ce,Se,De,q),this._source=q}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(z){return new l(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.InMemoryTask=l;var D;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(R){R._default=R.Terminal}(D||(e.ExecutionEngine=D={}));var d;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(d||(e.JsonSchemaVersion=d={}));class w{constructor(z){this._order=new Map;for(let q=0;q<z.length;q++)this._order.set(z[q].uri.toString(),q)}compare(z,q){const ie=z.getWorkspaceFolder(),ce=q.getWorkspaceFolder();if(ie&&ce){let Se=this._order.get(ie.uri.toString());Se=Se===void 0?0:Se+1;let De=this._order.get(ce.uri.toString());return De=De===void 0?0:De+1,Se===De?z._label.localeCompare(q._label):Se-De}else return!ie&&ce?-1:ie&&!ce?1:0}}e.TaskSorter=w;var g;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(g||(e.TaskEventKind=g={}));var C;(function(R){R.SingleRun="singleRun",R.Background="background"})(C||(e.TaskRunType=C={}));var S;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var k;(function(R){function z(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function q(pe,Ne,ae){return{...z(pe),kind:"start",terminalId:Ne,resolvedVariables:ae}}R.start=q;function ie(pe,Ne,ae){return{...z(pe),kind:"processStarted",terminalId:Ne,processId:ae}}R.processStarted=ie;function ce(pe,Ne,ae){return{...z(pe),kind:"processEnded",terminalId:Ne,exitCode:ae}}R.processEnded=ce;function Se(pe,Ne,ae){return{...z(pe),kind:"terminated",exitReason:ae,terminalId:Ne}}R.terminated=Se;function De(pe,Ne,ae){return{...z(Ne),kind:pe,terminalId:ae}}R.general=De;function fe(){return{kind:"changed"}}R.changed=fe})(k||(e.TaskEvent=k={}));var P;(function(R){function z(ie){const ce=Object.keys(ie).sort();let Se="";for(const De of ce){let fe=ie[De];fe instanceof Object?fe=z(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),Se+=De+","+fe+","}return Se}function q(ie){const Se={_key:z(ie),type:ie.taskType};return Object.assign(Se,ie),Se}R.create=q})(P||(e.KeyedTaskIdentifier=P={}));var H;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(H||(e.TaskSettingId=H={}));var $;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})($||(e.TasksSchemaProperties=$={}));var V;(function(R){function z(q,ie){const ce=E.TaskDefinitionRegistry.get(q.type);if(ce===void 0){const pe=O.deepClone(q);return delete pe._key,P.create(pe)}const Se=Object.create(null);Se.type=ce.taskType;const De=new Set;ce.required.forEach(pe=>De.add(pe));const fe=ce.properties;for(const pe of Object.keys(fe)){const Ne=q[pe];if(Ne!=null)Se[pe]=Ne;else if(De.has(pe)){const ae=fe[pe];if(ae.default!==void 0)Se[pe]=O.deepClone(ae.default);else switch(ae.type){case"boolean":Se[pe]=!1;break;case"number":case"integer":Se[pe]=0;break;case"string":Se[pe]="";break;default:ie.error(I.localize(1,null,JSON.stringify(q,void 0,0),pe));return}}}return P.create(Se)}R.createTaskIdentifier=z})(V||(e.TaskDefinition=V={}))}),define(Ie[242],Pe([1,0,14]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,E)=>{this._actualOk=A,this._actualErr=E,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,I.onUnexpectedError)(A))}then(A,E){return this._ensureActual().then(A,E)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=L;class T extends L{constructor(){super(),this._hasErr=!0,this._err=new I.CancellationError}}e.CanceledLazyPromise=T}),define(Ie[35],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=T,e.getStringIdentifierForProxy=O;class I{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++I.count}}e.ProxyIdentifier=I;const L=[];function T(E){const v=new I(E);return L[v.nid]=v,v}function O(E){return L[E].sid}class A{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=A}),define(Ie[4],Pe([1,0,35]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var T;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(T||(e.TabInputKind=T={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var E;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(E||(e.WebviewMessageArrayBufferViewType=E={}));var v;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var _;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(_||(e.NotebookEditorRevealType=_={}));var N;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(N||(e.CandidatePortSource=N={}));class y{static{this._n=0}static mixin(o){return o._id=y._n++,o}}e.IdObject=y;var h;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(h||(e.ISuggestDataDtoField=h={}));var b;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var m;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,I.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,I.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,I.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadInlineChat:(0,I.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,I.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.createProxyIdentifier)("MainThreadAiEmbeddingVector")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,I.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,I.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,I.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,I.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[80],Pe([1,0,3,12,4,17]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,I.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(v,_){this._extHostLogService=_,this._reportedUsages=new Set,this._telemetryShape=v.getProxy(T.MainContext.MainThreadTelemetry)}report(v,_,N){const y=this.getUsageKey(v,_);this._reportedUsages.has(y)||(this._reportedUsages.add(y),_.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${v}' is deprecated. ${N}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:_.identifier.value,apiId:v}))}getUsageKey(v,_){return`${v}-${_.identifier.value}`}};e.ExtHostApiDeprecationService=A,e.ExtHostApiDeprecationService=A=Ke([He(0,O.IExtHostRpcService),He(1,L.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(E,v,_){}})}),define(Ie[243],Pe([1,0,4]),function(ue,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(O){const A=O.getProxy(I.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(E){return A.$writeText(E)}})}}e.ExtHostClipboard=L}),define(Ie[244],Pe([1,0,25,4,27,17]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=class{constructor(N,y){this._mainThreadConsole=N.getProxy(L.MainContext.MainThreadConsole),this._includeStack=y.consoleForward.includeStack,this._logNative=y.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(N,y){const h=this,b=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){h._handleConsoleCall(N,y,b,arguments)}})}_handleConsoleCall(N,y,h,b){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:y,arguments:v(b,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(N,h,b)}};e.AbstractExtHostConsoleForwarder=A,e.AbstractExtHostConsoleForwarder=A=Ke([He(0,O.IExtHostRpcService),He(1,T.IExtHostInitDataService)],A);const E=1e5;function v(_,N){const y=[];if(_.length)for(let h=0;h<_.length;h++){let b=_[h];if(typeof b>"u")b="undefined";else if(b instanceof Error){const m=b;m.stack?b=m.stack:b=m.toString()}y.push(b)}if(N){const h=new Error().stack;h&&y.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,I.safeStringify)(y);return h.length>E?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Ie[245],Pe([1,0,2,4,26]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class O{constructor(E){this._proxy=E.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(E,v){return v?.allowUIResources&&(0,T.checkProposedApiEnabled)(E,"showLocal"),this._proxy.$showOpenDialog(v).then(_=>_?_.map(N=>I.URI.revive(N)):void 0)}showSaveDialog(E){return this._proxy.$showSaveDialog(E).then(v=>v?I.URI.revive(v):void 0)}}e.ExtHostDialogs=O}),define(Ie[246],Pe([1,0,6,4]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(A){this._handlePool=0,this._proxy=A.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const E=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(E,A),(0,I.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(E)})}}e.ExtHostLabelService=T}),define(Ie[81],Pe([1,0,22,13,2,3,12,4,27,17]),function(ue,e,I,L,T,O,A,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(h,b,m){this.logService=m,this.bundleCache=new Map,this._proxy=b.getProxy(E.MainContext.MainThreadLocalization),this.currentLanguage=h.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===I.LANGUAGE_DEFAULT}getMessage(h,b){const{message:m,args:r,comment:o}=b;if(this.isDefaultLanguage)return(0,L.format2)(m,r??{});let s=m;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const i=this.bundleCache.get(h)?.contents[s];return i||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,L.format2)(i??m,r??{})}getBundle(h){return this.bundleCache.get(h)?.contents}getBundleUri(h){return this.bundleCache.get(h)?.uri}async initializeLocalizedMessages(h){if(this.isDefaultLanguage||!h.l10n&&!h.isBuiltin||this.bundleCache.has(h.identifier.value))return;let b;const m=await this.getBundleLocation(h);if(!m){this.logService.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const r=await this._proxy.$fetchBundleContents(m),o=JSON.parse(r);b=h.isBuiltin?o.contents?.bundle:o}catch(r){this.logService.error(`Failed to load translations for ${h.identifier.value} from ${m}: ${r.message}`);return}b&&this.bundleCache.set(h.identifier.value,{contents:b,uri:m})}async getBundleLocation(h){if(h.isBuiltin){const b=await this._proxy.$fetchBuiltInBundleUri(h.identifier.value,this.currentLanguage);return T.URI.revive(b)}return h.l10n?T.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=N,e.ExtHostLocalizationService=N=Ke([He(0,v.IExtHostInitDataService),He(1,_.IExtHostRpcService),He(2,A.ILogService)],N),e.IExtHostLocalizationService=(0,O.createDecorator)("IExtHostLocalizationService")}),define(Ie[247],Pe([1,0,12,4,27,17,2,49]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let v=class extends I.AbstractLoggerService{constructor(y,h){super(h.logLevel,h.logsLocation,h.loggers.map(b=>(0,E.revive)(b))),this._proxy=y.getProxy(L.MainContext.MainThreadLogger)}$setLogLevel(y,h){h?this.setLogLevel(A.URI.revive(h),y):this.setLogLevel(y)}setVisibility(y,h){super.setVisibility(y,h),this._proxy.$setVisibility(y,h)}doCreateLogger(y,h,b){return new _(this._proxy,y,h,b)}};e.ExtHostLoggerService=v,e.ExtHostLoggerService=v=Ke([He(0,O.IExtHostRpcService),He(1,T.IExtHostInitDataService)],v);class _ extends I.AbstractMessageLogger{constructor(y,h,b,m){super(m?.logLevel==="always"),this.proxy=y,this.file=h,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(b),this.proxy.$createLogger(h,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,h){const b=[[y,h]];this.isLoggerCreated?this.doLog(b):this.buffer.push(...b)}doLog(y){this.proxy.$log(this.file,y)}flush(){this.proxy.$flush(this.file)}}}),define(Ie[82],Pe([1,0,4,3,6,17,21]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,L.createDecorator)("IExtHostManagedSockets");let E=class{constructor(y){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadManagedSockets)}setFactory(y,h){for(const b of this._managedRemoteSockets.values())b.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new v(y,h),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(y){if(!this._factory||this._factory.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const h=++this._remoteSocketIdCounter,b=await this._factory.makeConnection(),m=new T.DisposableStore;return this._managedRemoteSockets.set(h,new _(h,b,m)),m.add((0,T.toDisposable)(()=>this._managedRemoteSockets.delete(h))),m.add(b.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(h),m.dispose()})),m.add(b.onDidClose(r=>{this._proxy.$onDidManagedSocketClose(h,r?.stack??r?.message),m.dispose()})),m.add(b.onDidReceiveMessage(r=>this._proxy.$onDidManagedSocketHaveData(h,A.VSBuffer.wrap(r)))),h}$remoteSocketWrite(y,h){this._managedRemoteSockets.get(y)?.actual.send(h.buffer)}$remoteSocketEnd(y){const h=this._managedRemoteSockets.get(y);h&&(h.actual.end(),h.dispose())}async $remoteSocketDrain(y){await this._managedRemoteSockets.get(y)?.actual.drain?.()}};e.ExtHostManagedSockets=E,e.ExtHostManagedSockets=E=Ke([He(0,O.IExtHostRpcService)],E);class v{constructor(y,h){this.socketFactoryId=y,this.makeConnection=h}}class _ extends T.Disposable{constructor(y,h,b){super(),this.socketId=y,this.actual=h,this._register(b)}}}),define(Ie[248],Pe([1,0,4,12,26]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function O(E){return E&&E.title}let A=class{constructor(v,_){this._logService=_,this._proxy=v.getProxy(I.MainContext.MainThreadMessageService)}showMessage(v,_,N,y,h){const b={source:{identifier:v.identifier,label:v.displayName||v.name}};let m;typeof y=="string"||O(y)?m=[y,...h]:(b.modal=y?.modal,b.useCustom=y?.useCustom,b.detail=y?.detail,m=h),b.useCustom&&(0,T.checkProposedApiEnabled)(v,"resolvers");const r=[];let o=!1;for(let s=0;s<m.length;s++){const i=m[s];if(typeof i=="string")r.push({title:i,handle:s,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:c}=i;r.push({title:n,isCloseAffordance:!!c,handle:s}),c&&(o?this._logService.warn(`[${v.identifier}] Only one message item can have 'isCloseAffordance':`,i):o=!0)}else this._logService.warn(`[${v.identifier}] Invalid message item:`,i)}return this._proxy.$showMessage(_,N,b,r).then(s=>{if(typeof s=="number")return m[s]})}};e.ExtHostMessageService=A,e.ExtHostMessageService=A=Ke([He(1,L.ILogService)],A)}),define(Ie[249],Pe([1,0,6,15,2,26,4]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class E{constructor(_){this.handlers=new Map,this.proxy=_.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(_,N,y){if((0,O.checkProposedApiEnabled)(_,"profileContentHandlers"),this.handlers.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.handlers.set(N,y),this.proxy.$registerProfileContentHandler(N,y.name,y.description,_.identifier.value),(0,I.toDisposable)(()=>{this.handlers.delete(N),this.proxy.$unregisterProfileContentHandler(N)})}async $saveProfile(_,N,y,h){const b=this.handlers.get(_);if(!b)throw new Error(`Unknown handler with id: ${_}`);return b.saveProfile(N,y,h)}async $readProfile(_,N,y){const h=this.handlers.get(_);if(!h)throw new Error(`Unknown handler with id: ${_}`);return h.readProfile((0,L.isString)(N)?N:T.URI.revive(N),y)}}e.ExtHostProfileContentHandlers=E}),define(Ie[83],Pe([1,0,4,5,3]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class O{constructor(E){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=E.getProxy(I.MainContext.MainThreadSecretState)}async $onDidChangePassword(E){this._onDidChangePassword.fire(E)}get(E,v){return this._proxy.$getPassword(E,v)}store(E,v,_){return this._proxy.$setPassword(E,v,_)}delete(E,v){return this._proxy.$deletePassword(E,v)}}e.ExtHostSecretState=O,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(Ie[250],Pe([1,0,24,6,4]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class O{static{this.ID_POOL=1}constructor(E){this.providers=new Map,this.sessions=new Map,this.proxy=E.getProxy(T.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(E,v,_){const N=this.providers.get(E);if(!N)return;const y=new L.DisposableStore,h=new I.CancellationTokenSource;this.sessions.set(v,h);const b=y.add(N.provideSpeechToTextSession(h.token,_?{language:_}:void 0));y.add(b.onDidChange(m=>{h.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(v,m)})),y.add(h.token.onCancellationRequested(()=>y.dispose()))}async $cancelSpeechToTextSession(E){this.sessions.get(E)?.dispose(!0),this.sessions.delete(E)}async $createKeywordRecognitionSession(E,v){const _=this.providers.get(E);if(!_)return;const N=new L.DisposableStore,y=new I.CancellationTokenSource;this.sessions.set(v,y);const h=N.add(_.provideKeywordRecognitionSession(y.token));N.add(h.onDidChange(b=>{y.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(v,b)})),N.add(y.token.onCancellationRequested(()=>N.dispose()))}async $cancelKeywordRecognitionSession(E){this.sessions.get(E)?.dispose(!0),this.sessions.delete(E)}registerProvider(E,v,_){const N=O.ID_POOL++;return this.providers.set(N,_),this.proxy.$registerProvider(N,v,{extension:E,displayName:E.value}),(0,L.toDisposable)(()=>{this.proxy.$unregisterProvider(N),this.providers.delete(N)})}}e.ExtHostSpeech=O}),define(Ie[84],Pe([1,0,4,5,3]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class O{constructor(E,v){this._logService=v,this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=E.getProxy(I.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(E,v){this._proxy.$registerExtensionStorageKeysToSync(E,v)}async initializeExtensionStorage(E,v,_){const N=await this._proxy.$initializeExtensionStorage(E,v);let y;return N&&(y=this.safeParseValue(E,v,N)),y||_}setValue(E,v,_){return this._proxy.$setValue(E,v,_)}$acceptValue(E,v,_){const N=this.safeParseValue(E,v,_);N&&this._onDidChangeStorage.fire({shared:E,key:v,value:N})}safeParseValue(E,v,_){try{return JSON.parse(_)}catch(N){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${E}): ${N}`)}}}e.ExtHostStorage=O,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(Ie[251],Pe([1,0,6,16,2,4]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{static{this.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}constructor(v){this._openers=new Map,this._proxy=v.getProxy(O.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(v,_,N,y){if(this._openers.has(_))throw new Error(`Opener with id '${_}' already registered`);const h=y.schemes.find(b=>!A.supportedSchemes.has(b));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this._openers.set(_,N),this._proxy.$registerUriOpener(_,y.schemes,v,y.label),(0,I.toDisposable)(()=>{this._openers.delete(_),this._proxy.$unregisterUriOpener(_)})}async $canOpenUri(v,_,N){const y=this._openers.get(v);if(!y)throw new Error(`Unknown opener with id: ${v}`);const h=T.URI.revive(_);return y.canOpenExternalUri(h,N)}async $openUri(v,_,N){const y=this._openers.get(v);if(!y)throw new Error(`Unknown opener id: '${v}'`);return y.openExternalUri(T.URI.revive(_.resolvedUri),{sourceUri:T.URI.revive(_.sourceUri)},N)}}e.ExtHostUriOpeners=A}),define(Ie[252],Pe([1,0,4,2,6,14,20]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class E{static{this.HandlePool=0}constructor(_){this.handles=new A.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=_.getProxy(I.MainContext.MainThreadUrls)}registerUriHandler(_,N){const y=_.identifier;if(this.handles.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const h=E.HandlePool++;return this.handles.add(y),this.handlers.set(h,N),this._proxy.$registerUriHandler(h,y,_.displayName||_.name),(0,T.toDisposable)(()=>{this.handles.delete(y),this.handlers.delete(h),this._proxy.$unregisterUriHandler(h)})}$handleExternalUri(_,N){const y=this.handlers.get(_);if(!y)return Promise.resolve(void 0);try{y.handleUri(L.URI.revive(N))}catch(h){(0,O.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(_){return L.URI.revive(await this._proxy.$createAppUri(_))}}e.ExtHostUrls=E}),define(Ie[64],Pe([1,0,5,6,16,25,2,197,221,78,4]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=h,e.toExtensionData=r,e.serializeWebviewOptions=o;class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;constructor(c,u,t,f,a,p,l){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new I.Emitter,this._onDidDispose=this.#d.event,this.#e=c,this.#t=u,this.#o=t,this.#n=f,this.#s=a,this.#r=p,this.#u=h(p),this.#h=b(p),this.#i=l}#d;dispose(){this.#c=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#l=!0,(0,_.asWebviewUri)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===T.Schemas.https||c.scheme===T.Schemas.http){let u=c.toString();return u.endsWith("/")||(u+="/"),u+" "+_.webviewGenericCspSource}return _.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(c){this.assertNotDisposed(),this.#a!==c&&(this.#a=c,this.#h&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(c)))}get options(){return this.assertNotDisposed(),this.#o}set options(c){this.assertNotDisposed(),O.equals(this.#o,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const u=(0,v.serializeWebviewMessage)(c,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(c){if(!this.#h)return c;const u=this.#r.extensionLocation?.scheme===T.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===T.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,p,l,D,d)=>{const w=A.URI.from({scheme:l||"file",path:decodeURIComponent(D)}),g=(0,_.asWebviewUri)(w,{isRemote:u,authority:t}).toString();return`${a}${g}${d}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,p,l,D,d)=>{const w=A.URI.from({scheme:l||"file",path:decodeURIComponent(D)}),g=(0,_.asWebviewUri)(w,{isRemote:u,authority:t}).toString();return`${a}${g}${d}`})}}e.ExtHostWebview=y;function h(n){try{const c=(0,E.normalizeVersion)((0,E.parseVersion)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function b(n){try{const c=(0,E.normalizeVersion)((0,E.parseVersion)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class m extends L.Disposable{constructor(c,u,t,f,a){super(),this.remoteInfo=u,this.workspace=t,this._logService=f,this._deprecationService=a,this._webviews=new Map,this._webviewProxy=c.getProxy(N.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const c of this._webviews.values())c.dispose();this._webviews.clear()}$onMessage(c,u,t){const f=this.getWebview(c);if(f){const{message:a}=(0,v.deserializeWebviewMessage)(u,t.value);f._onMessageEmitter.fire(a)}}$onMissingCsp(c,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,u,t){const f=new y(c,this._webviewProxy,s(u),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(c,f);const a=f._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return f}deleteWebview(c){this._webviews.delete(c)}getWebview(c){return this._webviews.get(c)}}e.ExtHostWebviews=m;function r(n){return{id:n.identifier,location:n.extensionLocation}}function o(n,c,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||i(n,c)}}function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>A.URI.from(c))}}function i(n,c){return[...(c?.getWorkspaceFolders()||[]).map(u=>u.uri),n.extensionLocation]}}),define(Ie[111],Pe([1,0,5,16,13,2,3,17,4]),function(ue,e,I,L,T,O,A,E,v){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let N=class{static{_=this}static{this.InitialState={focused:!0,active:!0}}getState(){const h=this._state;return{get focused(){return h.focused},get active(){return h.active}}}constructor(h){this._onDidChangeWindowState=new I.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=_.InitialState,this._proxy=h.getProxy(v.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:b,isActive:m})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",m)})}$onDidChangeWindowFocus(h){this.onDidChangeWindowProperty("focused",h)}$onDidChangeWindowActive(h){this.onDidChangeWindowProperty("active",h)}onDidChangeWindowProperty(h,b){b!==this._state[h]&&(this._state={...this._state,[h]:b},this._onDidChangeWindowState.fire(this._state))}openUri(h,b){let m;if(typeof h=="string"){m=h;try{h=O.URI.parse(h)}catch{return Promise.reject(`Invalid uri - '${h}'`)}}return(0,T.isFalsyOrWhitespace)(h.scheme)?Promise.reject("Invalid scheme - cannot be empty"):h.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${h.scheme}'`):this._proxy.$openUri(h,m,b)}async asExternalUri(h,b){if((0,T.isFalsyOrWhitespace)(h.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(h,b);return O.URI.from(m)}};e.ExtHostWindow=N,e.ExtHostWindow=N=_=Ke([He(0,E.IExtHostRpcService)],N),e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ie[253],Pe([1,0,244,27,17]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let O=class extends I.AbstractExtHostConsoleForwarder{constructor(E,v){super(E,v)}_nativeConsoleLogMessage(E,v,_){v.apply(console,_)}};e.ExtHostConsoleForwarder=O,e.ExtHostConsoleForwarder=O=Ke([He(0,T.IExtHostRpcService),He(1,L.IExtHostInitDataService)],O)}),define(Ie[254],Pe([1,0,11,21,24,14,5,6,150,242,35]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=o,e.parseJsonAndRestoreBufferRefs=s;function h(S,k){try{return JSON.stringify(S,k)}catch{return"null"}}const b="$$ref$$",m={[b]:-1};class r{constructor(k,P){this.jsonString=k,this.referencedBuffers=P}}function o(S,k=null,P=!1){const H=[];return{jsonString:(P?h:JSON.stringify)(S,(V,R)=>{if(typeof R>"u")return m;if(typeof R=="object"){if(R instanceof L.VSBuffer){const z=H.push(R)-1;return{[b]:z}}if(k)return k(V,R)}return R}),referencedBuffers:H}}function s(S,k,P){return JSON.parse(S,(H,$)=>{if($){const V=$[b];if(typeof V=="number")return k[V];if(P&&$.$mid===1)return P.transformIncoming($)}return $})}function i(S,k){return JSON.stringify(S,k)}function n(S){return S?(k,P)=>P&&P.$mid===1?S.transformOutgoing(P):P:null}var c;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var u;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},f=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class p extends E.Disposable{static{y=f}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(k,P=null,H=null){super(),this[y]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=k,this._logger=P,this._uriTransformer=H,this._uriReplacer=n(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,V=N.ProxyIdentifier.count;$<V;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new I.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(k=>{const P=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k],P.resolveErr(O.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(k){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+p.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(k){this._unresponsiveTime=Date.now()+p.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(k){this._responsiveState!==k&&(this._responsiveState=k,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(k){return this._uriTransformer?(0,v.transformIncomingURIs)(k,this._uriTransformer):k}getProxy(k){const{nid:P,sid:H}=k;return this._proxies[P]||(this._proxies[P]=this._createProxy(P,H)),this._proxies[P]}_createProxy(k,P){const H={get:($,V)=>(typeof V=="string"&&!$[V]&&V.charCodeAt(0)===36&&($[V]=(...R)=>this._remoteCall(k,V,R)),V===a?P:$[V])};return new Proxy(Object.create(null),H)}set(k,P){return this._locals[k.nid]=P,P}assertRegistered(k){for(let P=0,H=k.length;P<H;P++){const $=k[P];if(!this._locals[$.nid])throw new Error(`Missing proxy instance ${$.sid}`)}}_receiveOneMessage(k){if(this._isDisposed)return;const P=k.byteLength,H=D.read(k,0),$=H.readUInt8(),V=H.readUInt32();switch($){case 1:case 2:{let{rpcId:R,method:z,args:q}=w.deserializeRequestJSONArgs(H);this._uriTransformer&&(q=(0,v.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(P,V,R,z,q,$===2);break}case 3:case 4:{let{rpcId:R,method:z,args:q}=w.deserializeRequestMixedArgs(H);this._uriTransformer&&(q=(0,v.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(P,V,R,z,q,$===4);break}case 5:{this._logger?.logIncoming(P,V,0,"ack"),this._onDidReceiveAcknowledge(V);break}case 6:{this._receiveCancel(P,V);break}case 7:{this._receiveReply(P,V,void 0);break}case 9:{let R=w.deserializeReplyOKJSON(H);this._uriTransformer&&(R=(0,v.transformIncomingURIs)(R,this._uriTransformer)),this._receiveReply(P,V,R);break}case 10:{const R=w.deserializeReplyOKJSONWithBuffers(H,this._uriTransformer);this._receiveReply(P,V,R);break}case 8:{const R=w.deserializeReplyOKVSBuffer(H);this._receiveReply(P,V,R);break}case 11:{let R=w.deserializeReplyErrError(H);this._uriTransformer&&(R=(0,v.transformIncomingURIs)(R,this._uriTransformer)),this._receiveReplyErr(P,V,R);break}case 12:{this._receiveReplyErr(P,V,void 0);break}default:console.error("received unexpected message"),console.error(k)}}_receiveRequest(k,P,H,$,V,R){this._logger?.logIncoming(k,P,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(H)}.${$}(`,V);const z=String(P);let q,ie;if(R){const Se=new T.CancellationTokenSource;V.push(Se.token),q=this._invokeHandler(H,$,V),ie=()=>Se.cancel()}else q=this._invokeHandler(H,$,V),ie=t;this._cancelInvokedHandlers[z]=ie;const ce=w.serializeAcknowledged(P);this._logger?.logOutgoing(ce.byteLength,P,1,"ack"),this._protocol.send(ce),q.then(Se=>{delete this._cancelInvokedHandlers[z];const De=w.serializeReplyOK(P,Se,this._uriReplacer);this._logger?.logOutgoing(De.byteLength,P,1,"reply:",Se),this._protocol.send(De)},Se=>{delete this._cancelInvokedHandlers[z];const De=w.serializeReplyErr(P,Se);this._logger?.logOutgoing(De.byteLength,P,1,"replyErr:",Se),this._protocol.send(De)})}_receiveCancel(k,P){this._logger?.logIncoming(k,P,1,"receiveCancel");const H=String(P);this._cancelInvokedHandlers[H]?.()}_receiveReply(k,P,H){this._logger?.logIncoming(k,P,0,"receiveReply:",H);const $=String(P);if(!this._pendingRPCReplies.hasOwnProperty($))return;const V=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],V.resolveOk(H)}_receiveReplyErr(k,P,H){this._logger?.logIncoming(k,P,0,"receiveReplyErr:",H);const $=String(P);if(!this._pendingRPCReplies.hasOwnProperty($))return;const V=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let R;H&&(H.$isError?(R=new Error,R.name=H.name,R.message=H.message,R.stack=H.stack):R=H),V.resolveErr(R)}_invokeHandler(k,P,H){try{return Promise.resolve(this._doInvokeHandler(k,P,H))}catch($){return Promise.reject($)}}_doInvokeHandler(k,P,H){const $=this._locals[k];if(!$)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(k));const V=$[P];if(typeof V!="function")throw new Error("Unknown method "+P+" on actor "+(0,N.getStringIdentifierForProxy)(k));return V.apply($,H)}_remoteCall(k,P,H){if(this._isDisposed)return new _.CanceledLazyPromise;let $=null;if(H.length>0&&T.CancellationToken.isCancellationToken(H[H.length-1])&&($=H.pop()),$&&$.isCancellationRequested)return Promise.reject(O.canceled());const V=w.serializeRequestArguments(H,this._uriReplacer),R=++this._lastMessageId,z=String(R),q=new _.LazyPromise,ie=new E.DisposableStore;$&&ie.add($.onCancellationRequested(()=>{const Se=w.serializeCancel(R);this._logger?.logOutgoing(Se.byteLength,R,0,"cancel"),this._protocol.send(w.serializeCancel(R))})),this._pendingRPCReplies[z]=new l(q,ie),this._onWillSendRequest(R);const ce=w.serializeRequest(R,k,P,V,!!$);return this._logger?.logOutgoing(ce.byteLength,R,0,`request: ${(0,N.getStringIdentifierForProxy)(k)}.${P}(`,H),this._protocol.send(ce),q}}e.RPCProtocol=p;class l{constructor(k,P){this._promise=k,this._disposable=P}resolveOk(k){this._promise.resolveOk(k),this._disposable.dispose()}resolveErr(k){this._promise.resolveErr(k),this._disposable.dispose()}}class D{static alloc(k,P,H){const $=new D(L.VSBuffer.alloc(H+1+4),0);return $.writeUInt8(k),$.writeUInt32(P),$}static read(k,P){return new D(k,P)}get buffer(){return this._buff}constructor(k,P){this._buff=k,this._offset=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(k){this._buff.writeUInt8(k,this._offset),this._offset+=1}readUInt8(){const k=this._buff.readUInt8(this._offset);return this._offset+=1,k}writeUInt32(k){this._buff.writeUInt32BE(k,this._offset),this._offset+=4}readUInt32(){const k=this._buff.readUInt32BE(this._offset);return this._offset+=4,k}static sizeShortString(k){return 1+k.byteLength}writeShortString(k){this._buff.writeUInt8(k.byteLength,this._offset),this._offset+=1,this._buff.set(k,this._offset),this._offset+=k.byteLength}readShortString(){const k=this._buff.readUInt8(this._offset);this._offset+=1;const H=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,H}static sizeLongString(k){return 4+k.byteLength}writeLongString(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readLongString(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const H=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,H}writeBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}static sizeVSBuffer(k){return 4+k.byteLength}writeVSBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readVSBuffer(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const P=this._buff.slice(this._offset,this._offset+k);return this._offset+=k,P}static sizeMixedArray(k){let P=0;P+=1;for(let H=0,$=k.length;H<$;H++){const V=k[H];switch(P+=1,V.type){case 1:P+=this.sizeLongString(V.value);break;case 2:P+=this.sizeVSBuffer(V.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(V.value);for(let R=0;R<V.buffers.length;++R)P+=this.sizeVSBuffer(V.buffers[R]);break;case 4:break}}return P}writeMixedArray(k){this._buff.writeUInt8(k.length,this._offset),this._offset+=1;for(let P=0,H=k.length;P<H;P++){const $=k[P];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt32($.buffers.length),this.writeLongString($.value);for(let V=0;V<$.buffers.length;++V)this.writeBuffer($.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const k=this._buff.readUInt8(this._offset);this._offset+=1;const P=new Array(k);for(let H=0;H<k;H++)switch(this.readUInt8()){case 1:P[H]=this.readLongString();break;case 2:P[H]=this.readVSBuffer();break;case 3:{const V=this.readUInt32(),R=this.readLongString(),z=[];for(let q=0;q<V;++q)z.push(this.readVSBuffer());P[H]=new N.SerializableObjectWithBuffers(s(R,z,null));break}case 4:P[H]=void 0;break}return P}}var d;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(d||(d={}));class w{static _useMixedArgSerialization(k){for(let P=0,H=k.length;P<H;P++)if(k[P]instanceof L.VSBuffer||k[P]instanceof N.SerializableObjectWithBuffers||typeof k[P]>"u")return!0;return!1}static serializeRequestArguments(k,P){if(this._useMixedArgSerialization(k)){const H=[];for(let $=0,V=k.length;$<V;$++){const R=k[$];if(R instanceof L.VSBuffer)H[$]={type:2,value:R};else if(typeof R>"u")H[$]={type:4};else if(R instanceof N.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:q}=o(R.value,P);H[$]={type:3,value:L.VSBuffer.fromString(z),buffers:q}}else H[$]={type:1,value:L.VSBuffer.fromString(i(R,P))}}return{type:1,args:H}}return{type:0,args:i(k,P)}}static serializeRequest(k,P,H,$,V){switch($.type){case 0:return this._requestJSONArgs(k,P,H,$.args,V);case 1:return this._requestMixedArgs(k,P,H,$.args,V)}}static _requestJSONArgs(k,P,H,$,V){const R=L.VSBuffer.fromString(H),z=L.VSBuffer.fromString($);let q=0;q+=D.sizeUInt8(),q+=D.sizeShortString(R),q+=D.sizeLongString(z);const ie=D.alloc(V?2:1,k,q);return ie.writeUInt8(P),ie.writeShortString(R),ie.writeLongString(z),ie.buffer}static deserializeRequestJSONArgs(k){const P=k.readUInt8(),H=k.readShortString(),$=k.readLongString();return{rpcId:P,method:H,args:JSON.parse($)}}static _requestMixedArgs(k,P,H,$,V){const R=L.VSBuffer.fromString(H);let z=0;z+=D.sizeUInt8(),z+=D.sizeShortString(R),z+=D.sizeMixedArray($);const q=D.alloc(V?4:3,k,z);return q.writeUInt8(P),q.writeShortString(R),q.writeMixedArray($),q.buffer}static deserializeRequestMixedArgs(k){const P=k.readUInt8(),H=k.readShortString(),$=k.readMixedArray(),V=new Array($.length);for(let R=0,z=$.length;R<z;R++){const q=$[R];typeof q=="string"?V[R]=JSON.parse(q):V[R]=q}return{rpcId:P,method:H,args:V}}static serializeAcknowledged(k){return D.alloc(5,k,0).buffer}static serializeCancel(k){return D.alloc(6,k,0).buffer}static serializeReplyOK(k,P,H){if(typeof P>"u")return this._serializeReplyOKEmpty(k);if(P instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(k,P);if(P instanceof N.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:V}=o(P.value,H,!0);return this._serializeReplyOKJSONWithBuffers(k,$,V)}else return this._serializeReplyOKJSON(k,h(P,H))}static _serializeReplyOKEmpty(k){return D.alloc(7,k,0).buffer}static _serializeReplyOKVSBuffer(k,P){let H=0;H+=D.sizeVSBuffer(P);const $=D.alloc(8,k,H);return $.writeVSBuffer(P),$.buffer}static deserializeReplyOKVSBuffer(k){return k.readVSBuffer()}static _serializeReplyOKJSON(k,P){const H=L.VSBuffer.fromString(P);let $=0;$+=D.sizeLongString(H);const V=D.alloc(9,k,$);return V.writeLongString(H),V.buffer}static _serializeReplyOKJSONWithBuffers(k,P,H){const $=L.VSBuffer.fromString(P);let V=0;V+=D.sizeUInt32,V+=D.sizeLongString($);for(const z of H)V+=D.sizeVSBuffer(z);const R=D.alloc(10,k,V);R.writeUInt32(H.length),R.writeLongString($);for(const z of H)R.writeBuffer(z);return R.buffer}static deserializeReplyOKJSON(k){const P=k.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(k,P){const H=k.readUInt32(),$=k.readLongString(),V=[];for(let R=0;R<H;++R)V.push(k.readVSBuffer());return new N.SerializableObjectWithBuffers(s($,V,P))}static serializeReplyErr(k,P){const H=P?h(O.transformErrorForSerialization(P),null):void 0;if(typeof H!="string")return this._serializeReplyErrEmpty(k);const $=L.VSBuffer.fromString(H);let V=0;V+=D.sizeLongString($);const R=D.alloc(11,k,V);return R.writeLongString($),R.buffer}static deserializeReplyErrError(k){const P=k.readLongString();return JSON.parse(P)}static _serializeReplyErrEmpty(k){return D.alloc(12,k,0).buffer}}var g;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var C;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(C||(C={}))}),define(Ie[255],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const I=function(O){const A=E=>{globalThis.removeEventListener("message",A);const v=E.data;Object.defineProperties(globalThis,{postMessage:{value(_,N){v.postMessage(_,N)}},onmessage:{get(){return v.onmessage},set(_){v.onmessage=_}}}),v.addEventListener("message",_=>{globalThis.dispatchEvent(new MessageEvent("message",{data:_.data,ports:_.ports?[..._.ports]:void 0}))}),v.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class L extends EventTarget{constructor(O,A,E){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const v=`((${I})('${A}'))`,_=new Blob([v],{type:"application/javascript"}),N=URL.createObjectURL(_),y=new MessageChannel,h=N,b={type:"_newWorker",id:h,port:y.port2,url:N,options:E};O(b,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:h}),URL.revokeObjectURL(N),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(m){y.port1.onmessage=m}},onmessageerror:{get(){return y.port1.onmessageerror},set(m){y.port1.onmessageerror=m}}}),y.port1.addEventListener("messageerror",m=>{const r=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(r)}),y.port1.addEventListener("message",m=>{const r=new MessageEvent("message",{data:m.data});this.dispatchEvent(r)}),y.port1.start()}}e.NestedWorker=L}),define(Ie[256],Pe([1,0,21,28,16,56,3]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=N,e.generate=y,e.INotebookDocumentService=(0,A.createDecorator)("notebookDocumentService");const E=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${E.join("")}]+`),_=7;function N(b){if(b.scheme!==T.Schemas.vscodeNotebookCell)return;const m=b.fragment.indexOf("s");if(m<0)return;const r=parseInt(b.fragment.substring(0,m).replace(v,""),_),o=(0,I.decodeBase64)(b.fragment.substring(m+1)).toString();if(!isNaN(r))return{handle:r,notebook:b.with({scheme:o,fragment:null})}}function y(b,m){const r=m.toString(_),s=`${r.length<E.length?E[r.length-1]:"z"}${r}s${(0,I.encodeBase64)(I.VSBuffer.fromString(b.scheme),!0,!0)}`;return b.with({scheme:T.Schemas.vscodeNotebookCell,fragment:s})}class h{constructor(){this._documents=new L.ResourceMap}getNotebook(m){if(m.scheme===T.Schemas.vscodeNotebookCell){const r=N(m);if(r){const o=this._documents.get(r.notebook);if(o)return o}}return this._documents.get(m)}addNotebookDocument(m){this._documents.set(m.uri,m)}removeNotebookDocument(m){this._documents.delete(m.uri)}}e.NotebookDocumentWorkbenchService=h,(0,O.registerSingleton)(e.INotebookDocumentService,h,1)}),define(Ie[85],Pe([1,0,21,37,42,70,16,19,22,31,256]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=f,e.isDocumentExcludePattern=p,e.notebookDocumentFilterMatch=l,e.isTextStreamMime=w,e.compressOutputItemStreams=C,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var y;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(y||(e.CellKind=y={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",O.Mimes.latex,O.Mimes.markdown,"image/png","image/jpeg",O.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[O.Mimes.latex,O.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var h;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})(h||(e.NotebookRunState=h={}));var b;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var m;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var r;(function(q){q[q.WithHardKernelDependency=0]="WithHardKernelDependency",q[q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",q[q.Pure=2]="Pure",q[q.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(q){q.Always="always",q.Never="never",q.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(q){q[q.ModelChange=1]="ModelChange",q[q.Move=2]="Move",q[q.ChangeCellLanguage=5]="ChangeCellLanguage",q[q.Initialize=6]="Initialize",q[q.ChangeCellMetadata=7]="ChangeCellMetadata",q[q.Output=8]="Output",q[q.OutputItem=9]="OutputItem",q[q.ChangeCellContent=10]="ChangeCellContent",q[q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",q[q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",q[q.ChangeCellMime=13]="ChangeCellMime",q[q.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var i;(function(q){q[q.Handle=0]="Handle",q[q.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(q){q[q.Replace=1]="Replace",q[q.Output=2]="Output",q[q.Metadata=3]="Metadata",q[q.CellLanguage=4]="CellLanguage",q[q.DocumentMetadata=5]="DocumentMetadata",q[q.Move=6]="Move",q[q.OutputItems=7]="OutputItems",q[q.PartialMetadata=8]="PartialMetadata",q[q.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(q){q.scheme=A.Schemas.vscodeNotebookCell;function ie(Ne,ae){return(0,N.generate)(Ne,ae)}q.generate=ie;function ce(Ne){return(0,N.parse)(Ne)}q.parse=ce;function Se(Ne,ae){return Ne.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ae??""},${Ne.scheme!==A.Schemas.file?Ne.scheme:""}`})}q.generateCellOutputUri=Se;function De(Ne){if(Ne.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ae=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Ne.fragment);if(!ae)return;const Re=ae[1]&&ae[1]!==""?ae[1]:void 0,ne=ae[2];return{outputId:Re,notebook:Ne.with({scheme:ne||A.Schemas.file,fragment:null})}}q.parseCellOutputUri=De;function fe(Ne,ae,Re){return q.generate(Ne,ae).with({scheme:Re})}q.generateCellPropertyUri=fe;function pe(Ne,ae){if(Ne.scheme===ae)return q.parse(Ne.with({scheme:q.scheme}))}q.parseCellPropertyUri=pe})(c||(e.CellUri=c={}));const u=q=>v.isWindows?q.replace(/\//g,"\\"):q;class t{constructor(ie=[],ce=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=ce,this.order=[...new Set(ie)].map(Se=>({pattern:Se,matches:L.parse(u(Se))}))}sort(ie){const ce=new Map(T.Iterable.map(ie,De=>[De,u(De)]));let Se=[];for(const{matches:De}of this.order)for(const[fe,pe]of ce)if(De(pe)){Se.push(fe),ce.delete(fe);break}return ce.size&&(Se=Se.concat([...ce.keys()].sort((De,fe)=>this.defaultOrder.indexOf(De)-this.defaultOrder.indexOf(fe)))),Se}prioritize(ie,ce){const Se=this.findIndex(ie);if(Se===-1){this.order.unshift({pattern:ie,matches:L.parse(u(ie))});return}const De=new Set(ce.map(pe=>this.findIndex(pe,Se)));De.delete(-1);const fe=Array.from(De).sort();this.order.splice(Se+1,0,...fe.map(pe=>this.order[pe]));for(let pe=fe.length-1;pe>=0;pe--)this.order.splice(fe[pe],1)}toArray(){return this.order.map(ie=>ie.pattern)}findIndex(ie,ce=this.order.length){const Se=u(ie);for(let De=0;De<ce;De++)if(this.order[De].matches(Se))return De;return-1}}e.MimeTypeDisplayOrder=t;function f(q,ie,ce,Se=(De,fe)=>De===fe){const De=[];function fe(ae,Re,ne){if(Re===0&&ne.length===0)return;const x=De[De.length-1];x&&x.start+x.deleteCount===ae?(x.deleteCount+=Re,x.toInsert.push(...ne)):De.push({start:ae,deleteCount:Re,toInsert:ne})}let pe=0,Ne=0;for(;;){if(pe===q.length){fe(pe,0,ie.slice(Ne));break}if(Ne===ie.length){fe(pe,q.length-pe,[]);break}const ae=q[pe],Re=ie[Ne];if(Se(ae,Re)){pe+=1,Ne+=1;continue}ce(Re)?(fe(pe,1,[]),pe+=1):(fe(pe,0,[Re]),Ne+=1)}return De}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtLineBoundary","none");var a;(function(q){q.default="default",q.option="option"})(a||(e.NotebookEditorPriority=a={}));function p(q){const ie=q;return!!((typeof ie.include=="string"||L.isRelativePattern(ie.include))&&(typeof ie.exclude=="string"||L.isRelativePattern(ie.exclude)))}function l(q,ie,ce){if(Array.isArray(q.viewType)&&q.viewType.indexOf(ie)>=0||q.viewType===ie)return!0;if(q.filenamePattern){const Se=p(q.filenamePattern)?q.filenamePattern.include:q.filenamePattern,De=p(q.filenamePattern)?q.filenamePattern.exclude:void 0;if(L.match(Se,(0,E.basename)(ce.fsPath).toLowerCase()))return!(De&&L.match(De,(0,E.basename)(ce.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class d{static{this._prefix="notebook/"}static create(ie){return`${d._prefix}${ie}`}static parse(ie){if(ie.startsWith(d._prefix))return ie.substring(d._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=d;function w(q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(q)}const g=new TextDecoder;function C(q){const ie=[];let ce=!1;for(const pe of q)(ie.length===0||ce)&&(ie.push(pe),ce=!0);let Se=P(ie);const De=I.VSBuffer.concat(ie.map(pe=>I.VSBuffer.wrap(pe))),fe=z(De);return Se=Se||fe.byteLength!==De.byteLength,{data:fe,didCompression:Se}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const S=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(q=>q.charCodeAt(0)),k=10;function P(q){let ie=!1;return q.forEach((ce,Se)=>{if(Se===0||ce.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const De=q[Se-1],fe=ce.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(fe[0]===S[0]&&fe[1]===S[1]&&fe[2]===S[2]){const pe=De.lastIndexOf(k);if(pe===-1)return;ie=!0,q[Se-1]=De.subarray(0,pe),q[Se]=ce.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ie}function H(q){let ie=q;do q=ie,ie=q.replace(/[^\n]\x08/gm,"");while(ie.length<q.length);return q}function $(q){for(q=q.replace(/\r+\n/gm,`
`);q.search(/\r[^$]/g)>-1;){const ie=q.match(/^(.*)\r+/m)[1];let ce=q.match(/\r+(.*)$/m)[1];ce=ce+ie.slice(ce.length,ie.length),q=q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return q}const V=8,R=13;function z(q){return!q.buffer.includes(V)&&!q.buffer.includes(R)?q:I.VSBuffer.fromString($(H(g.decode(q.buffer))))}}),define(Ie[7],Pe([1,0,18,14,55,28,70,13,15,2,34,20,38,104,85]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m){"use strict";var r,o,s,i,n,c,u,t,f,a,p,l,D,d,w,g,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseTextEditPart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugThread=e.DebugStackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropOrPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.HoverVerbosityAction=e.VerboseHover=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.asStatusBarItemIdentifier=$t,e.setBreakpointId=Ce,e.validateTestCoverageCount=wn;function S(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const _e=te.length===1?[]:te[1];return Reflect.construct(B,_e,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[_e,...qe]=te;return Reflect.construct(B,qe,_e.constructor)}}})}var k;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(k||(e.TerminalOutputAnchor=k={}));var P;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let H=r=class{static from(...F){let te=F;return new r(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=H,e.Disposable=H=r=Ke([S],H);let $=o=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let _e=1;_e<F.length;_e++){const qe=F[_e];qe.isBefore(te)&&(te=qe)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let _e=1;_e<F.length;_e++){const qe=F[_e];qe.isAfter(te)&&(te=qe)}return te}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:te,character:_e}=F;return typeof te=="number"&&typeof _e=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(F,te){if(F<0)throw(0,L.illegalArgument)("line must be non-negative");if(te<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=F,this._character=te}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,te=0){if(F===null||te===null)throw(0,L.illegalArgument)();let _e;return typeof F>"u"?_e=0:typeof F=="number"?_e=F:(_e=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),_e===0&&te===0?this:new o(this.line+_e,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,L.illegalArgument)();let _e;return typeof F>"u"?_e=this.line:typeof F=="number"?_e=F:(_e=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),_e===this.line&&te===this.character?this:new o(_e,te)}toJSON(){return{line:this.line,character:this.character}}};e.Position=$,e.Position=$=o=Ke([S],$);let V=s=class{static isRange(F){return F instanceof s?!0:F?$.isPosition(F.start)&&$.isPosition(F.end):!1}static of(F){if(F instanceof s)return F;if(this.isRange(F))return new s(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(F,te,_e,qe){let Ye,ut;if(typeof F=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof qe=="number"?(Ye=new $(F,te),ut=new $(_e,qe)):$.isPosition(F)&&$.isPosition(te)&&(Ye=$.of(F),ut=$.of(te)),!Ye||!ut)throw new Error("Invalid arguments");Ye.isBefore(ut)?(this._start=Ye,this._end=ut):(this._start=ut,this._end=Ye)}contains(F){return s.isRange(F)?this.contains(F.start)&&this.contains(F.end):$.isPosition(F)?!($.of(F).isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const te=$.Max(F.start,this._start),_e=$.Min(F.end,this._end);if(!te.isAfter(_e))return new s(te,_e)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=$.Min(F.start,this._start),_e=$.Max(F.end,this.end);return new s(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,te=this.end){if(F===null||te===null)throw(0,L.illegalArgument)();let _e;return F?$.isPosition(F)?_e=F:(_e=F.start||this.start,te=F.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new s(_e,te)}toJSON(){return[this.start,this.end]}};e.Range=V,e.Range=V=s=Ke([S],V);let R=i=class extends V{static isSelection(F){return F instanceof i?!0:F?V.isRange(F)&&$.isPosition(F.anchor)&&$.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(F,te,_e,qe){let Ye,ut;if(typeof F=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof qe=="number"?(Ye=new $(F,te),ut=new $(_e,qe)):$.isPosition(F)&&$.isPosition(te)&&(Ye=$.of(F),ut=$.of(te)),!Ye||!ut)throw new Error("Invalid arguments");super(Ye,ut),this._anchor=Ye,this._active=ut}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=R,e.Selection=R=i=Ke([S],R);const z=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,L.illegalArgument)("connectionToken")};class q{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,_e){if(typeof F!="string"||F.length===0)throw(0,L.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,L.illegalArgument)("port");typeof _e<"u"&&z(_e),this.host=F,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=q;class ie{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&z(te)}}e.ManagedResolvedAuthority=ie;class ce extends Error{static NotAvailable(F,te){return new ce(F,b.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ce(F,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=b.RemoteAuthorityResolverErrorCode.Unknown,_e){super(F),this._message=F,this._code=te,this._detail=_e,Object.setPrototypeOf(this,ce.prototype)}}e.RemoteAuthorityResolverError=ce;var Se;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(Se||(e.EndOfLine=Se={}));var De;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let fe=n=class{static isTextEdit(F){return F instanceof n?!0:F?V.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new n(F,te)}static insert(F,te){return n.replace(new V(F,F),te)}static delete(F){return n.replace(F,"")}static setEndOfLine(F){const te=new n(new V(new $(0,0),new $(0,0)),"");return te.newEol=F,te}get range(){return this._range}set range(F){if(F&&!V.isRange(F))throw(0,L.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,L.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,L.illegalArgument)("newEol");this._newEol=F}constructor(F,te){this._range=F,this._newText=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=fe,e.TextEdit=fe=n=Ke([S],fe);let pe=c=class{static isNotebookCellEdit(F){return F instanceof c?!0:F?gi.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new c(F,te)}static insertCells(F,te){return new c(new gi(F,F),te)}static deleteCells(F){return new c(F,[])}static updateCellMetadata(F,te){const _e=new c(new gi(F,F),[]);return _e.newCellMetadata=te,_e}static updateNotebookMetadata(F){const te=new c(new gi(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.NotebookEdit=pe,e.NotebookEdit=pe=c=Ke([S],pe);class Ne{static isSnippetTextEdit(F){return F instanceof Ne?!0:F?V.isRange(F.range)&&ne.isSnippetString(F.snippet):!1}static replace(F,te){return new Ne(F,te)}static insert(F,te){return Ne.replace(new V(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.SnippetTextEdit=Ne;var ae;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ae||(e.FileEditType=ae={}));let Re=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,te,_e,qe){this._edits.push({_type:1,from:F,to:te,options:_e,metadata:qe})}createFile(F,te,_e){this._edits.push({_type:1,from:void 0,to:F,options:te,metadata:_e})}deleteFile(F,te,_e){this._edits.push({_type:1,from:F,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(F,te,_e){this._edits.push({_type:3,metadata:_e,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(F,te,_e,qe){const Ye=te.start,ut=te.end;(Ye!==ut||_e.length>0)&&this._edits.push({_type:5,uri:F,index:Ye,count:ut-Ye,cells:_e,metadata:qe})}replaceNotebookCellMetadata(F,te,_e,qe){this._edits.push({_type:3,metadata:qe,uri:F,edit:{editType:3,index:te,metadata:_e}})}replace(F,te,_e,qe){this._edits.push({_type:2,uri:F,edit:new fe(te,_e),metadata:qe})}insert(F,te,_e,qe){this.replace(F,new V(te,te),_e,qe)}delete(F,te,_e){this.replace(F,te,"",_e)}has(F){return this._edits.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const _e of te){if(!_e)continue;let qe,Ye;Array.isArray(_e)?(qe=_e[0],Ye=_e[1]):qe=_e,pe.isNotebookCellEdit(qe)?qe.newCellMetadata?this.replaceNotebookCellMetadata(F,qe.range.start,qe.newCellMetadata,Ye):qe.newNotebookMetadata?this.replaceNotebookMetadata(F,qe.newNotebookMetadata,Ye):this.replaceNotebookCells(F,qe.range,qe.newCells,Ye):Ne.isSnippetTextEdit(qe)?this._edits.push({_type:6,uri:F,range:qe.range,edit:qe.snippet,metadata:Ye}):this._edits.push({_type:2,uri:F,edit:qe,metadata:Ye})}else{for(let _e=0;_e<this._edits.length;_e++){const qe=this._edits[_e];switch(qe._type){case 2:case 6:case 3:case 5:qe.uri.toString()===F.toString()&&(this._edits[_e]=void 0);break}}(0,I.coalesceInPlace)(this._edits)}}get(F){const te=[];for(const _e of this._edits)_e._type===2&&_e.uri.toString()===F.toString()&&te.push(_e.edit);return te}entries(){const F=new O.ResourceMap;for(const te of this._edits)if(te._type===2){let _e=F.get(te.uri);_e||(_e=[te.uri,[]],F.set(te.uri,_e)),_e[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Re,e.WorkspaceEdit=Re=Ke([S],Re);let ne=u=class{static isSnippetString(F){return F instanceof u?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this._tabstop=1,this.value=F||""}appendText(F){return this.value+=u._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this._tabstop++){if(typeof F=="function"){const _e=new u;_e._tabstop=this._tabstop,F(_e),this._tabstop=_e._tabstop,F=_e.value}else F=u._escape(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this._tabstop++){const _e=F.map(qe=>qe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const _e=new u;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.SnippetString=ne,e.SnippetString=ne=u=Ke([S],ne);var x;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(x||(e.DiagnosticTag=x={}));var J;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(J||(e.DiagnosticSeverity=J={}));let be=t=class{static isLocation(F){return F instanceof t?!0:F?V.isRange(F.range)&&_.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(V.isRange(te))this.range=V.of(te);else if($.isPosition(te))this.range=new V(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=be,e.Location=be=t=Ke([S],be);let Me=class{static is(F){return F?typeof F.message=="string"&&F.location&&V.isRange(F.location.range)&&_.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.DiagnosticRelatedInformation=Me,e.DiagnosticRelatedInformation=Me=Ke([S],Me);let ye=class{constructor(F,te,_e=J.Error){if(!V.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=_e}toJSON(){return{severity:J[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,I.equals)(F.tags,te.tags)&&(0,I.equals)(F.relatedInformation,te.relatedInformation,Me.isEqual)}};e.Diagnostic=ye,e.Diagnostic=ye=Ke([S],ye);let Ee=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.Hover=Ee,e.Hover=Ee=Ke([S],Ee);let ge=class extends Ee{constructor(F,te,_e,qe){super(F,te),this.canIncreaseHover=_e,this.canDecreaseHover=qe}};e.VerboseHover=ge,e.VerboseHover=ge=Ke([S],ge);var G;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(G||(e.HoverVerbosityAction=G={}));var Y;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let de=class{constructor(F,te=Y.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.DocumentHighlight=de,e.DocumentHighlight=de=Ke([S],de);let le=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.MultiDocumentHighlight=le,e.MultiDocumentHighlight=le=Ke([S],le);var Oe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Oe||(e.SymbolKind=Oe={}));var he;(function(B){B[B.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let ke=f=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,_e,qe,Ye){this.name=F,this.kind=te,this.containerName=Ye,typeof _e=="string"&&(this.containerName=_e),qe instanceof be?this.location=qe:_e instanceof V&&(this.location=new be(qe,_e)),f.validate(this)}toJSON(){return{name:this.name,kind:Oe[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ke,e.SymbolInformation=ke=f=Ke([S],ke);let Te=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(a.validate)}constructor(F,te,_e,qe,Ye){this.name=F,this.detail=te,this.kind=_e,this.range=qe,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.DocumentSymbol=Te,e.DocumentSymbol=Te=a=Ke([S],Te);var ze;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(ze||(e.CodeActionTriggerKind=ze={}));let U=class{constructor(F,te){this.title=F,this.kind=te}};e.CodeAction=U,e.CodeAction=U=Ke([S],U);let M=class{static{p=this}static{this.sep="."}constructor(F){this.value=F}append(F){return new p(this.value?this.value+p.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+p.sep)}};e.CodeActionKind=M,e.CodeActionKind=M=p=Ke([S],M),M.Empty=new M(""),M.QuickFix=M.Empty.append("quickfix"),M.Refactor=M.Empty.append("refactor"),M.RefactorExtract=M.Refactor.append("extract"),M.RefactorInline=M.Refactor.append("inline"),M.RefactorMove=M.Refactor.append("move"),M.RefactorRewrite=M.Refactor.append("rewrite"),M.Source=M.Empty.append("source"),M.SourceOrganizeImports=M.Source.append("organizeImports"),M.SourceFixAll=M.Source.append("fixAll"),M.Notebook=M.Empty.append("notebook");let W=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=W,e.SelectionRange=W=Ke([S],W);class j{constructor(F,te,_e,qe,Ye,ut){this.kind=F,this.name=te,this.detail=_e,this.uri=qe,this.range=Ye,this.selectionRange=ut}}e.CallHierarchyItem=j;class ee{constructor(F,te){this.fromRanges=te,this.from=F}}e.CallHierarchyIncomingCall=ee;class re{constructor(F,te){this.fromRanges=te,this.to=F}}e.CallHierarchyOutgoingCall=re;var Le;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Le||(e.LanguageStatusSeverity=Le={}));let Be=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.CodeLens=Be,e.CodeLens=Be=Ke([S],Be);let We=l=class{#e;static isMarkdownString(F){return F instanceof l?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new T.MarkdownString(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.MarkdownString=We,e.MarkdownString=We=l=Ke([S],We);let Ze=class{constructor(F,te){this.label=F,this.documentation=te}};e.ParameterInformation=Ze,e.ParameterInformation=Ze=Ke([S],Ze);let Je=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.SignatureInformation=Je,e.SignatureInformation=Je=Ke([S],Je);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=et,e.SignatureHelp=et=Ke([S],et);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var it;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let at=class{constructor(F){this.value=F}};e.InlayHintLabelPart=at,e.InlayHintLabelPart=at=Ke([S],at);let gt=class{constructor(F,te,_e){this.position=F,this.label=te,this.kind=_e}};e.InlayHint=gt,e.InlayHint=gt=Ke([S],gt);var Ue;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var st;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(st||(e.CompletionItemKind=st={}));var Q;(function(B){B[B.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let X=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&st[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=X,e.CompletionItem=X=Ke([S],X);let me=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.CompletionList=me,e.CompletionList=me=Ke([S],me);let Ve=class{constructor(F,te,_e){this.insertText=F,this.range=te,this.command=_e}};e.InlineSuggestion=Ve,e.InlineSuggestion=Ve=Ke([S],Ve);let we=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.InlineSuggestionList=we,e.InlineSuggestionList=we=Ke([S],we);var ot;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(ot||(e.PartialAcceptTriggerKind=ot={}));var ht;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ht||(e.ViewColumn=ht={}));var Pt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Pt||(e.StatusBarAlignment=Pt={}));function $t(B,F){return`${y.ExtensionIdentifier.toKey(B)}.${F}`}var Gt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Gt||(e.TextEditorLineNumbersStyle=Gt={}));var ti;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ti||(e.TextDocumentSaveReason=ti={}));var Xt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var _t;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(_t||(e.TextEditorSelectionChangeKind=_t={}));var Qt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Qt||(e.TextDocumentChangeReason=Qt={}));var Yt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(B){function F(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(_t||(e.TextEditorSelectionChangeKind=_t={}));var Qe;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Qe||(e.SyntaxTokenType=Qe={})),function(B){function F(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=F}(Qe||(e.SyntaxTokenType=Qe={}));let oi=class{constructor(F,te){if(te&&!_.URI.isUri(te))throw(0,L.illegalArgument)("target");if(!V.isRange(F)||F.isEmpty)throw(0,L.illegalArgument)("range");this.range=F,this.target=te}};e.DocumentLink=oi,e.DocumentLink=oi=Ke([S],oi);let jt=class{constructor(F,te,_e,qe){this.red=F,this.green=te,this.blue=_e,this.alpha=qe}};e.Color=jt,e.Color=jt=Ke([S],jt);let dt=class{constructor(F,te){if(te&&!(te instanceof jt))throw(0,L.illegalArgument)("color");if(!V.isRange(F)||F.isEmpty)throw(0,L.illegalArgument)("range");this.range=F,this.color=te}};e.ColorInformation=dt,e.ColorInformation=dt=Ke([S],dt);let pt=class{constructor(F){if(!F||typeof F!="string")throw(0,L.illegalArgument)("label");this.label=F}};e.ColorPresentation=pt,e.ColorPresentation=pt=Ke([S],pt);var Jt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var qt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var Mt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Mt||(e.TerminalExitReason=Mt={}));var ft;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(ft||(e.TerminalShellExecutionCommandLineConfidence=ft={}));class Bt{constructor(F,te,_e){if(this.startIndex=F,this.length=te,this.tooltip=_e,typeof F!="number"||F<0)throw(0,L.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,L.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=Bt;class Zt{constructor(F){this.uri=F}}e.TerminalQuickFixOpener=Zt;class zt{constructor(F){this.terminalCommand=F}}e.TerminalQuickFixCommand=zt;var Ge;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Ge||(e.TerminalLocation=Ge={}));class li{constructor(F){if(this.options=F,typeof F!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=li;var Kt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Kt||(e.TaskRevealKind=Kt={}));var Ht;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Ht||(e.TaskPanelKind=Ht={}));let vt=class{static{D=this}static{this.Clean=new D("clean","Clean")}static{this.Build=new D("build","Build")}static{this.Rebuild=new D("rebuild","Rebuild")}static{this.Test=new D("test","Test")}static from(F){switch(F){case"clean":return D.Clean;case"build":return D.Build;case"rebuild":return D.Rebuild;case"test":return D.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,L.illegalArgument)("name");this._id=F}get id(){return this._id}};e.TaskGroup=vt,e.TaskGroup=vt=D=Ke([S],vt);function Ft(B){let F="";for(let te=0;te<B.length;te++)F+=B[te].replace(/,/g,",,")+",";return F}let At=class{constructor(F,te,_e){if(typeof F!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=F,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,L.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(const te of this._args)F.push(te);return Ft(F)}};e.ProcessExecution=At,e.ProcessExecution=At=Ke([S],At);let Lt=class{constructor(F,te,_e){if(this._args=[],Array.isArray(te)){if(!F)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,L.illegalArgument)("command");this._command=F,this._args=te,this._options=_e}else{if(typeof F!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=F,this._options=te}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,L.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const te of this._args)F.push(typeof te=="string"?te:te.value);return Ft(F)}};e.ShellExecution=Lt,e.ShellExecution=Lt=Ke([S],Lt);var ii;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ii||(e.ShellQuoting=ii={}));var Vt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Vt||(e.TaskScope=Vt={}));class ni{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=ni;let kt=class{static{d=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(F,te,_e,qe,Ye,ut){this.__deprecated=!1,this._definition=this.definition=F;let Et;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=qe,Et=Ye,this.__deprecated=!0):te===Vt.Global||te===Vt.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=qe,this.execution=Ye,Et=ut):(this.target=te,this._name=this.name=_e,this._source=this.source=qe,this.execution=Ye,Et=ut),typeof Et=="string"?(this._problemMatchers=[Et],this._hasDefinedMatchers=!0):Array.isArray(Et)?(this._problemMatchers=Et,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof At?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof Lt?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof ni?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,N.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const te=this._definition.type;(d.EmptyType===te||d.ProcessType===te||d.ShellType===te||d.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};e.Task=kt,e.Task=kt=d=Ke([S],kt);var Ot;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Ot||(e.ProgressLocation=Ot={}));var Rt;(function(B){function F(te){const _e=te;return(0,v.isNumber)(_e.value)?_e.tooltip&&!(0,v.isString)(_e.tooltip)?(console.log("INVALID view badge, invalid tooltip",_e.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",_e.value),!1)}B.isViewBadge=F})(Rt||(e.ViewBadge=Rt={}));let It=w=class{static isTreeItem(F,te){const _e=F;if(_e.checkboxState!==void 0){const qe=(0,v.isNumber)(_e.checkboxState)?_e.checkboxState:(0,v.isObject)(_e.checkboxState)&&(0,v.isNumber)(_e.checkboxState.state)?_e.checkboxState.state:void 0,Ye=!(0,v.isNumber)(_e.checkboxState)&&(0,v.isObject)(_e.checkboxState)?_e.checkboxState.tooltip:void 0;if(qe===void 0||qe!==yt.Checked&&qe!==yt.Unchecked||Ye!==void 0&&!(0,v.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",_e.checkboxState),!1}if(F instanceof w)return!0;if(_e.label!==void 0&&!(0,v.isString)(_e.label)&&!_e.label?.label)return console.log("INVALID tree item, invalid label",_e.label),!1;if(_e.id!==void 0&&!(0,v.isString)(_e.id))return console.log("INVALID tree item, invalid id",_e.id),!1;if(_e.iconPath!==void 0&&!(0,v.isString)(_e.iconPath)&&!_.URI.isUri(_e.iconPath)&&(!_e.iconPath||!(0,v.isString)(_e.iconPath.id))){const qe=_e.iconPath;if(!qe||!(0,v.isString)(qe.light)&&!_.URI.isUri(qe.light)&&!(0,v.isString)(qe.dark)&&!_.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",_e.iconPath),!1}return _e.description!==void 0&&!(0,v.isString)(_e.description)&&typeof _e.description!="boolean"?(console.log("INVALID tree item, invalid description",_e.description),!1):_e.resourceUri!==void 0&&!_.URI.isUri(_e.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",_e.resourceUri),!1):_e.tooltip!==void 0&&!(0,v.isString)(_e.tooltip)&&!(_e.tooltip instanceof We)?(console.log("INVALID tree item, invalid tooltip",_e.tooltip),!1):_e.command!==void 0&&!_e.command.command?(console.log("INVALID tree item, invalid command",_e.command),!1):_e.collapsibleState!==void 0&&_e.collapsibleState<mt.None&&_e.collapsibleState>mt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",_e.collapsibleState),!1):_e.contextValue!==void 0&&!(0,v.isString)(_e.contextValue)?(console.log("INVALID tree item, invalid contextValue",_e.contextValue),!1):_e.accessibilityInformation!==void 0&&!_e.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",_e.accessibilityInformation),!1):!0}constructor(F,te=mt.None){this.collapsibleState=te,_.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.TreeItem=It,e.TreeItem=It=w=Ke([S],It);var mt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(mt||(e.TreeItemCollapsibleState=mt={}));var yt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(yt||(e.TreeItemCheckboxState=yt={}));let ai=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.DataTransferItem=ai,e.DataTransferItem=ai=Ke([S],ai);class Ct extends ai{}e.InternalDataTransferItem=Ct;class fi extends Ct{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.InternalFileDataTransferItem=fi;class ri{constructor(F,te,_e,qe){this.name=F,this.uri=te,this._itemId=_e,this._getData=qe}data(){return this._getData()}}e.DataTransferFile=ri;let pi=class{#e=new Map;constructor(F){for(const[te,_e]of F??[]){const qe=this.#e.get(this.#t(te));qe?qe.push(_e):this.#e.set(this.#t(te),[_e])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[_e,qe]of this.#e)for(const Ye of qe)F.call(te,Ye,_e,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const _e of te)yield[F,_e]}#t(F){return F.toLowerCase()}};e.DataTransfer=pi,e.DataTransfer=pi=Ke([S],pi);let ui=class{constructor(F,te,_e){this.insertText=F,this.title=te,this.kind=_e}};e.DocumentDropEdit=ui,e.DocumentDropEdit=ui=Ke([S],ui);var Ei;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(Ei||(e.DocumentPasteTriggerKind=Ei={}));class Dt{static{this.sep="."}constructor(F){this.value=F}append(...F){return new Dt((this.value?[this.value,...F]:F).join(Dt.sep))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+Dt.sep)}}e.DocumentDropOrPasteEditKind=Dt,Dt.Empty=new Dt("");class wi{constructor(F,te,_e){this.title=te,this.insertText=F,this.kind=_e}}e.DocumentPasteEdit=wi;let si=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.ThemeIcon=si,e.ThemeIcon=si=Ke([S],si),si.File=new si("file"),si.Folder=new si("folder");let ve=class{constructor(F){this.id=F}};e.ThemeColor=ve,e.ThemeColor=ve=Ke([S],ve);var Ae;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Ae||(e.ConfigurationTarget=Ae={}));let se=class{get base(){return this._base}set base(F){this._base=F,this._baseUri=_.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!_.URI.isUri(F)&&!_.URI.isUri(F.uri)))throw(0,L.illegalArgument)("base");if(typeof te!="string")throw(0,L.illegalArgument)("pattern");typeof F=="string"?this.baseUri=_.URI.file(F):_.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=se,e.RelativePattern=se=Ke([S],se);const K=new WeakMap;function Ce(B,F){K.set(B,F)}let $e=class{constructor(F,te,_e,qe,Ye){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof qe=="string"&&(this.logMessage=qe),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this._id||(this._id=K.get(this)??(0,N.generateUuid)()),this._id}};e.Breakpoint=$e,e.Breakpoint=$e=Ke([S],$e);let Xe=class extends $e{constructor(F,te,_e,qe,Ye,ut){if(super(te,_e,qe,Ye,ut),F===null)throw(0,L.illegalArgument)("location");this.location=F}};e.SourceBreakpoint=Xe,e.SourceBreakpoint=Xe=Ke([S],Xe);let je=class extends $e{constructor(F,te,_e,qe,Ye,ut){super(te,_e,qe,Ye,ut),this.functionName=F}};e.FunctionBreakpoint=je,e.FunctionBreakpoint=je=Ke([S],je);let lt=class extends $e{constructor(F,te,_e,qe,Ye,ut,Et,Wt){if(super(qe,Ye,ut,Et,Wt),!te)throw(0,L.illegalArgument)("dataId");this.label=F,this.dataId=te,this.canPersist=_e}};e.DataBreakpoint=lt,e.DataBreakpoint=lt=Ke([S],lt);let St=class{constructor(F,te,_e){this.command=F,this.args=te||[],this.options=_e}};e.DebugAdapterExecutable=St,e.DebugAdapterExecutable=St=Ke([S],St);let xt=class{constructor(F,te){this.port=F,this.host=te}};e.DebugAdapterServer=xt,e.DebugAdapterServer=xt=Ke([S],xt);let ct=class{constructor(F){this.path=F}};e.DebugAdapterNamedPipeServer=ct,e.DebugAdapterNamedPipeServer=ct=Ke([S],ct);let Nt=class{constructor(F){this.implementation=F}};e.DebugAdapterInlineImplementation=Nt,e.DebugAdapterInlineImplementation=Nt=Ke([S],Nt);class Ut{constructor(F,te,_e){this.session=F,this.threadId=te,this.frameId=_e}}e.DebugStackFrame=Ut;class Si{constructor(F,te){this.session=F,this.threadId=te}}e.DebugThread=Si;let Ci=class{constructor(F,te){this.range=F,this.expression=te}};e.EvaluatableExpression=Ci,e.EvaluatableExpression=Ci=Ke([S],Ci);var qi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Li=class{constructor(F,te){this.range=F,this.text=te}};e.InlineValueText=Li,e.InlineValueText=Li=Ke([S],Li);let Oi=class{constructor(F,te,_e=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=_e}};e.InlineValueVariableLookup=Oi,e.InlineValueVariableLookup=Oi=Ke([S],Oi);let Di=class{constructor(F,te){this.range=F,this.expression=te}};e.InlineValueEvaluatableExpression=Di,e.InlineValueEvaluatableExpression=Di=Ke([S],Di);let Ni=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.InlineValueContext=Ni,e.InlineValueContext=Ni=Ke([S],Ni);var Mi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Mi||(e.NewSymbolNameTag=Mi={}));var Ki;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ki||(e.NewSymbolNameTriggerKind=Ki={}));class Fi{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.NewSymbolName=Fi;var Ii;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ii||(e.FileChangeType=Ii={}));let xi=g=class extends Error{static FileExists(F){return new g(F,h.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(F){return new g(F,h.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(F){return new g(F,h.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(F){return new g(F,h.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(F){return new g(F,h.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(F){return new g(F,h.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(F,te=h.FileSystemProviderErrorCode.Unknown,_e){super(_.URI.isUri(F)?F.toString(!0):F),this.code=_e?.name??"Unknown",(0,h.markAsFileSystemProviderError)(this,te),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}};e.FileSystemError=xi,e.FileSystemError=xi=g=Ke([S],xi);let Ui=class{constructor(F,te,_e){this.start=F,this.end=te,this.kind=_e}};e.FoldingRange=Ui,e.FoldingRange=Ui=Ke([S],Ui);var bi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(bi||(e.FoldingRangeKind=bi={}));var Gi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Gi||(e.CommentThreadCollapsibleState=Gi={}));var Xi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Xi||(e.CommentMode=Xi={}));var Qi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Qi||(e.CommentState=Qi={}));var Pi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Pi||(e.CommentThreadState=Pi={}));var Yi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Yi||(e.CommentThreadApplicability=Yi={}));class Ji{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.SemanticTokensLegend=Ji;function hn(B){return typeof B>"u"||(0,v.isStringArray)(B)}class ki{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let te=0,_e=F.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(F.tokenTypes[te],te);for(let te=0,_e=F.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(F.tokenModifiers[te],te)}}push(F,te,_e,qe,Ye){if(typeof F=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof qe=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this._pushEncoded(F,te,_e,qe,Ye);if(V.isRange(F)&&typeof te=="string"&&hn(_e))return this._push(F,te,_e);throw(0,L.illegalArgument)()}_push(F,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const qe=F.start.line,Ye=F.start.character,ut=F.end.character-F.start.character,Et=this._tokenTypeStrToInt.get(te);let Wt=0;if(_e)for(const ci of _e){if(!this._tokenModifierStrToInt.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const hi=this._tokenModifierStrToInt.get(ci);Wt|=1<<hi>>>0}this._pushEncoded(qe,Ye,ut,Et,Wt)}_pushEncoded(F,te,_e,qe,Ye){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Wt=this._data.length/5|0;let ci=0,hi=0;for(let mi=0;mi<Wt;mi++){let vi=this._data[5*mi],Wi=this._data[5*mi+1];vi===0?(vi=ci,Wi+=hi):vi+=ci,this._data[5*mi]=vi,this._data[5*mi+1]=Wi,ci=vi,hi=Wi}}let ut=F,Et=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(Et-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Et,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Ye,this._prevLine=F,this._prevChar=te}static _sortAndDeltaEncode(F){const te=[],_e=F.length/5|0;for(let Et=0;Et<_e;Et++)te[Et]=Et;te.sort((Et,Wt)=>{const ci=F[5*Et],hi=F[5*Wt];if(ci===hi){const mi=F[5*Et+1],vi=F[5*Wt+1];return mi-vi}return ci-hi});const qe=new Uint32Array(F.length);let Ye=0,ut=0;for(let Et=0;Et<_e;Et++){const Wt=5*te[Et],ci=F[Wt+0],hi=F[Wt+1],mi=F[Wt+2],vi=F[Wt+3],Wi=F[Wt+4],Nn=ci-Ye,hr=Nn===0?hi-ut:hi,ji=5*Et;qe[ji+0]=Nn,qe[ji+1]=hr,qe[ji+2]=mi,qe[ji+3]=vi,qe[ji+4]=Wi,Ye=ci,ut=hi}return qe}build(F){return this._dataIsSortedAndDeltaEncoded?new zi(new Uint32Array(this._data),F):new zi(ki._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=ki;class zi{constructor(F,te){this.resultId=te,this.data=F}}e.SemanticTokens=zi;class fn{constructor(F,te,_e){this.start=F,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=fn;class gn{constructor(F,te){this.resultId=te,this.edits=F}}e.SemanticTokensEdits=gn;var Zi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));class Bi{constructor(F){this.name=F}}e.DebugVisualization=Bi;let Ti=class{static{this.Back={iconPath:new si("arrow-left")}}constructor(){}};e.QuickInputButtons=Ti,e.QuickInputButtons=Ti=Ke([S],Ti);var xe;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(xe||(e.QuickPickItemKind=xe={}));var di;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(di||(e.InputBoxValidationSeverity=di={}));var $i;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})($i||(e.ExtensionKind=$i={}));class nt{static validate(F){if(typeof F.badge=="string"){let te=(0,E.nextCharLength)(F.badge,0);if(te<F.badge.length&&(te+=(0,E.nextCharLength)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!si.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,_e){this.badge=F,this.tooltip=te,this.color=_e}}e.FileDecoration=nt;let bt=class{constructor(F){this.kind=F}};e.ColorTheme=bt,e.ColorTheme=bt=Ke([S],bt);var en;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class gi{static isNotebookRange(F){return F instanceof gi?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(F,te){if(F<0)throw(0,L.illegalArgument)("start must be positive");if(te<0)throw(0,L.illegalArgument)("end must be positive");F<=te?(this._start=F,this._end=te):(this._start=te,this._end=F)}with(F){let te=this._start,_e=this._end;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(_e=F.end),te===this._start&&_e===this._end?this:new gi(te,_e)}}e.NotebookRange=gi;class _i{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>_i.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,_e,qe,Ye,ut,Et){this.kind=F,this.value=te,this.languageId=_e,this.mime=qe,this.outputs=Ye??[],this.metadata=ut,this.executionSummary=Et,_i.validate(this)}}e.NotebookCellData=_i;class mn{constructor(F){this.cells=F}}e.NotebookData=mn;class ei{static isNotebookCellOutputItem(F){return F instanceof ei?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ei.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ei.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ei.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ei(F,te)}static#e=new TextEncoder;static text(F,te=A.Mimes.text){const _e=ei.#e.encode(String(F));return new ei(_e,te)}static json(F,te="text/x-json"){const _e=JSON.stringify(F,void 0,"	");return ei.text(_e,te)}constructor(F,te){this.data=F,this.mime=te;const _e=(0,A.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}}e.NotebookCellOutputItem=ei;class Ai{static isNotebookCellOutput(F){return F instanceof Ai?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const _e=new Set,qe=new Set;for(let Ye=0;Ye<F.length;Ye++){const ut=F[Ye],Et=(0,A.normalizeMimeType)(ut.mime);if(!_e.has(Et)||(0,m.isTextStreamMime)(Et)){_e.add(Et);continue}qe.add(Ye),te&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return qe.size===0?F:F.filter((Ye,ut)=>!qe.has(ut))}constructor(F,te,_e){this.items=Ai.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,N.generateUuid)(),this.metadata=te??_e)}}e.NotebookCellOutput=Ai;var tn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var Hi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Hi||(e.NotebookCellStatusBarAlignment=Hi={}));var rn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class pn{constructor(F,te){this.text=F,this.alignment=te}}e.NotebookCellStatusBarItem=pn;var sn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class vn{constructor(F,te=[]){this.uri=F,this.provides=(0,I.asArray)(te)}}e.NotebookRendererScript=vn;class En{constructor(F){this.label=F}}e.NotebookKernelSourceAction=En;var an;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let Vi=class{constructor(F,te){this.label=F,this.timestamp=te}};e.TimelineItem=Vi,e.TimelineItem=Vi=Ke([S],Vi);var cn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var ln;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(ln||(e.ExtensionRuntime=ln={}));var un;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(un||(e.StandardTokenType=un={}));class Z{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.LinkedEditingRanges=Z;class oe{constructor(F){this._autoForwardAction=F}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=oe;var Fe;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Fe||(e.TestResultState=Fe={}));var rt;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(rt||(e.TestRunProfileKind=rt={}));let wt=class{constructor(F=void 0,te=void 0,_e=void 0,qe=!1,Ye=!0){this.include=F,this.exclude=te,this.profile=_e,this.continuous=qe,this.preserveFocus=Ye}};e.TestRunRequest=wt,e.TestRunRequest=wt=Ke([S],wt);let Tt=C=class{static diff(F,te,_e){const qe=new C(F);return qe.expectedOutput=te,qe.actualOutput=_e,qe}constructor(F){this.message=F}};e.TestMessage=Tt,e.TestMessage=Tt=C=Ke([S],Tt);let yi=class{constructor(F){this.id=F}};e.TestTag=yi,e.TestTag=yi=Ke([S],yi);class dn{constructor(F,te){this.covered=F,this.total=te,wn(this)}}e.TestCoverageCount=dn;function wn(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class bn{static fromDetails(F,te){const _e=new dn(0,0),qe=new dn(0,0),Ye=new dn(0,0);for(const Et of te)if("branches"in Et){_e.total+=1,_e.covered+=Et.executed?1:0;for(const Wt of Et.branches)qe.total+=1,qe.covered+=Wt.executed?1:0}else Ye.total+=1,Ye.covered+=Et.executed?1:0;const ut=new bn(F,_e,qe.total>0?qe:void 0,Ye.total>0?Ye:void 0);return ut.detailedCoverage=te,ut}constructor(F,te,_e,qe){this.uri=F,this.statementCoverage=te,this.branchCoverage=_e,this.declarationCoverage=qe}}e.FileCoverage=bn;class Mn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,_e=[]){this.executed=F,this.location=te,this.branches=_e}}e.StatementCoverage=Mn;class Fn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,_e){this.executed=F,this.location=te,this.label=_e}}e.BranchCoverage=Fn;class xn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,_e){this.name=F,this.executed=te,this.location=_e}}e.DeclarationCoverage=xn;var Sn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Sn||(e.ExternalUriOpenerPriority=Sn={}));var _n;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(_n||(e.WorkspaceTrustState=_n={}));var yn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(yn||(e.PortAutoForwardAction=yn={}));class Un{constructor(F,te,_e,qe,Ye,ut){this.kind=F,this.name=te,this.detail=_e,this.uri=qe,this.range=Ye,this.selectionRange=ut}}e.TypeHierarchyItem=Un;class zn{constructor(F){this.uri=F}}e.TextTabInput=zn;class Bn{constructor(F,te){this.original=F,this.modified=te}}e.TextDiffTabInput=Bn;class $n{constructor(F,te,_e,qe){this.base=F,this.input1=te,this.input2=_e,this.result=qe}}e.TextMergeTabInput=$n;class Hn{constructor(F,te){this.uri=F,this.viewType=te}}e.CustomEditorTabInput=Hn;class Vn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=Vn;class Wn{constructor(F,te){this.uri=F,this.notebookType=te}}e.NotebookEditorTabInput=Wn;class jn{constructor(F,te,_e){this.original=F,this.modified=te,this.notebookType=_e}}e.NotebookDiffEditorTabInput=jn;class qn{constructor(){}}e.TerminalEditorTabInput=qn;class Kn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.InteractiveWindowInput=Kn;class Gn{constructor(){}}e.ChatEditorTabInput=Gn;class Xn{constructor(F){this.textDiffs=F}}e.TextMultiDiffTabInput=Xn;var Cn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var Dn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Dn||(e.ChatCopyKind=Dn={}));var In;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(In||(e.ChatVariableLevel=In={}));class Qn{constructor(F,te){this.label=F,this.values=te}}e.ChatCompletionItem=Qn;var Pn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Pn||(e.InteractiveEditorResponseFeedbackKind=Pn={}));var kn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(kn||(e.ChatResultFeedbackKind=kn={}));class Yn{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new We(F):F}}e.ChatResponseMarkdownPart=Yn;class Jn{constructor(F,te){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new We(F):F,this.vulnerabilities=te}}e.ChatResponseMarkdownWithVulnerabilitiesPart=Jn;class Zn{constructor(F,te){this.participant=F,this.command=te}}e.ChatResponseDetectedParticipantPart=Zn;class er{constructor(F,te){this.value=F,this.baseUri=te}}e.ChatResponseFileTreePart=er;class tr{constructor(F,te){this.value=F,this.title=te}}e.ChatResponseAnchorPart=tr;class ir{constructor(F){this.value=F}}e.ChatResponseProgressPart=ir;class nr{constructor(F){this.value=F}}e.ChatResponseCommandButtonPart=nr;class rr{constructor(F,te){this.value=F,this.iconPath=te}}e.ChatResponseReferencePart=rr;class sr{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.ChatResponseTextEditPart=sr;class or{constructor(F,te,_e,qe){this.prompt=F,this.command=te,this.variables=_e,this.participant=qe}}e.ChatRequestTurn=or;class ar{constructor(F,te,_e,qe){this.response=F,this.result=te,this.participant=_e,this.command=qe}}e.ChatResponseTurn=ar;var Tn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(Tn||(e.ChatLocation=Tn={}));class cr{constructor(F){this.content=F}}e.LanguageModelChatSystemMessage=cr;class lr{constructor(F,te){this.content=F,this.name=te}}e.LanguageModelChatUserMessage=lr;class ur{constructor(F,te){this.content=F,this.name=te}}e.LanguageModelChatAssistantMessage=ur;class Ri extends Error{static NotFound(F){return new Ri(F,Ri.NotFound.name)}static NoPermissions(F){return new Ri(F,Ri.NoPermissions.name)}constructor(F,te,_e){super(F,{cause:_e}),this.name="LanguageModelError",this.code=te??""}}e.LanguageModelError=Ri;var An;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(An||(e.RelatedInformationType=An={}));var Rn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Rn||(e.SpeechToTextStatus=Rn={}));var Ln;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Ln||(e.KeywordRecognitionStatus=Ln={}));class dr{constructor(F,te){this.text=F,this.range=te}}e.InlineEdit=dr;var On;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(On||(e.InlineEditTriggerKind=On={}))}),define(Ie[257],Pe([1,0,4,7]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class T{constructor(A){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(I.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,E,v){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const _=this._relatedInformationProviders.get(A);if(!_)throw new Error("related information provider not found");return await _.provideRelatedInformation(E,v)??[]}getRelatedInformation(A,E,v){return this._proxy.$getAiRelatedInformation(E,v)}registerRelatedInformationProvider(A,E,v){const _=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(_,v),this._proxy.$registerAiRelatedInformationProvider(_,E),new L.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(_),this._relatedInformationProviders.delete(_)})}}e.ExtHostRelatedInformation=T}),define(Ie[86],Pe([1,0,5,4,7,20,108,3,17]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,E.createDecorator)("IExtHostAuthentication");let _=class{constructor(h){this._authenticationProviders=new Map,this._onDidChangeSessions=new I.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new N,this._getSessionsTaskSingler=new N,this._proxy=h.getProxy(L.MainContext.MainThreadAuthentication)}async getSession(h,b,m,r={}){const o=O.ExtensionIdentifier.toKey(h.identifier),s=[...m].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${o} ${b} ${s}`,async()=>{await this._proxy.$ensureProvider(b);const i=h.displayName||h.name;return this._proxy.$getSession(b,m,o,i,r)})}async getSessions(h,b,m){const r=O.ExtensionIdentifier.toKey(h.identifier),o=[...m].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${r} ${o}`,async()=>{await this._proxy.$ensureProvider(b);const s=h.displayName||h.name;return this._proxy.$getSessions(b,m,r,s)})}async removeSession(h,b){const m=this._authenticationProviders.get(h);return m?m.provider.removeSession(b):this._proxy.$removeSession(h,b)}registerAuthenticationProvider(h,b,m,r){if(this._authenticationProviders.get(h))throw new Error(`An authentication provider with id '${h}' is already registered.`);this._authenticationProviders.set(h,{label:b,provider:m,options:r??{supportsMultipleAccounts:!1}});const o=m.onDidChangeSessions(s=>this._proxy.$sendDidChangeSessions(h,s));return this._proxy.$registerAuthenticationProvider(h,b,r?.supportsMultipleAccounts??!1),new T.Disposable(()=>{o.dispose(),this._authenticationProviders.delete(h),this._proxy.$unregisterAuthenticationProvider(h)})}$createSession(h,b,m){const r=this._authenticationProviders.get(h);if(r)return Promise.resolve(r.provider.createSession(b,m));throw new Error(`Unable to find authentication provider with handle: ${h}`)}$removeSession(h,b){const m=this._authenticationProviders.get(h);if(m)return Promise.resolve(m.provider.removeSession(b));throw new Error(`Unable to find authentication provider with handle: ${h}`)}$getSessions(h,b){const m=this._authenticationProviders.get(h);if(m)return Promise.resolve(m.provider.getSessions(b));throw new Error(`Unable to find authentication provider with handle: ${h}`)}$onDidChangeAuthenticationSessions(h,b){return h.startsWith(A.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:h,label:b}}),Promise.resolve()}};e.ExtHostAuthentication=_,e.ExtHostAuthentication=_=Ke([He(0,v.IExtHostRpcService)],_);class N{constructor(){this._inFlightPromises=new Map}getOrCreate(h,b){const m=this._inFlightPromises.get(h);if(m)return m;const r=b().finally(()=>this._inFlightPromises.delete(h));return this._inFlightPromises.set(h,r),r}}}),define(Ie[112],Pe([1,0,2,4,7,3,17,12,18,13,19,26]),function(ue,e,I,L,T,O,A,E,v,_,N,y){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class{static{h=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(r,o){this._logService=o,this._provider=new Map,this._proxy=r.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(r,o){const s=h._handlePool++;this._provider.set(s,{provider:r,extensionDescription:o}),this._proxy.$registerDecorationProvider(s,o.identifier.value);const i=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(n=>{if(!n){this._proxy.$onDidChange(s,null);return}const c=(0,v.asArray)(n);if(c.length<=h._maxEventSize){this._proxy.$onDidChange(s,c);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const u=c.map(a=>({uri:a,rank:(0,_.count)(a.path,"/")})),t=(0,v.groupBy)(u,(a,p)=>a.rank-p.rank||(0,_.compare)(a.uri.path,p.uri.path)),f=[];e:for(const a of t){let p;for(const l of a){const D=(0,N.dirname)(l.uri.path);if(p!==D&&(p=D,f.push(l.uri)>=h._maxEventSize))break e}}this._proxy.$onDidChange(s,f)});return new T.Disposable(()=>{i?.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(r,o,s){if(!this._provider.has(r))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:c}=this._provider.get(r);return await Promise.all(o.map(async u=>{try{const{uri:t,id:f}=u,a=await Promise.resolve(n.provideFileDecoration(I.URI.revive(t),s));if(!a)return;try{T.FileDecoration.validate(a),a.badge&&typeof a.badge!="string"&&(0,y.checkProposedApiEnabled)(c,"codiconDecoration"),i[f]=[a.propagate,a.tooltip,a.badge,a.color]}catch(p){this._logService.warn(`INVALID decoration from extension '${c.identifier.value}': ${p}`)}}catch(t){this._logService.error(t)}})),i}};e.ExtHostDecorations=b,e.ExtHostDecorations=b=h=Ke([He(0,A.IExtHostRpcService),He(1,E.ILogService)],b),e.IExtHostDecorations=(0,O.createDecorator)("IExtHostDecorations")}),define(Ie[258],Pe([1,0,14,2,7,4,16,24,13]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class _{static{this._handlePool=0}constructor(y,h,b){this._documentsAndEditors=h,this._logService=b,this._documentContentProviders=new Map,this._proxy=y.getProxy(O.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,h){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const b=_._handlePool++;this._documentContentProviders.set(b,h),this._proxy.$registerTextContentProvider(b,y);let m;if(typeof h.onDidChange=="function"){let r;m=h.onDidChange(async o=>{if(o.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(o))return;r&&await r;const s=this.$provideTextDocumentContent(b,o).then(async i=>{if(!i&&typeof i!="string")return;const n=this._documentsAndEditors.getDocument(o);if(!n)return;const c=(0,v.splitLines)(i);if(!n.equalLines(c))return this._proxy.$onVirtualDocumentChange(o,i)}).catch(I.onUnexpectedError).finally(()=>{r===s&&(r=void 0)});r=s})}return new T.Disposable(()=>{this._documentContentProviders.delete(b)&&this._proxy.$unregisterTextContentProvider(b),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(y,h){const b=this._documentContentProviders.get(y);return b?Promise.resolve(b.provideTextDocumentContent(L.URI.revive(h),E.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.ExtHostDocumentContentProvider=_}),define(Ie[113],Pe([1,0,57,16,13,313,159,7,18]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=N;const _=new Map;function N(m,r){r?_.set(m,r):_.delete(m)}function y(m){return _.get(m)}class h extends O.MirrorTextModel{constructor(r,o,s,i,n,c,u){super(o,s,i,n),this._proxy=r,this._languageId=c,this._isDirty=u,this._isDisposed=!1}dispose(){(0,I.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(r){return(0,v.equals)(this._lines,r)}get document(){if(!this._document){const r=this;this._document={get uri(){return r._uri},get fileName(){return r._uri.fsPath},get isUntitled(){return r._uri.scheme===L.Schemas.untitled},get languageId(){return r._languageId},get version(){return r._versionId},get isClosed(){return r._isDisposed},get isDirty(){return r._isDirty},save(){return r._save()},getText(o){return o?r._getTextInRange(o):r.getText()},get eol(){return r._eol===`
`?E.EndOfLine.LF:E.EndOfLine.CRLF},get lineCount(){return r._lines.length},lineAt(o){return r._lineAt(o)},offsetAt(o){return r._offsetAt(o)},positionAt(o){return r._positionAt(o)},validateRange(o){return r._validateRange(o)},validatePosition(o){return r._validatePosition(o)},getWordRangeAtPosition(o,s){return r._getWordRangeAtPosition(o,s)}}}return Object.freeze(this._document)}_acceptLanguageId(r){(0,I.ok)(!this._isDisposed),this._languageId=r}_acceptIsDirty(r){(0,I.ok)(!this._isDisposed),this._isDirty=r}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(r){const o=this._validateRange(r);if(o.isEmpty)return"";if(o.isSingleLine)return this._lines[o.start.line].substring(o.start.character,o.end.character);const s=this._eol,i=o.start.line,n=o.end.line,c=[];c.push(this._lines[i].substring(o.start.character));for(let u=i+1;u<n;u++)c.push(this._lines[u]);return c.push(this._lines[n].substring(0,o.end.character)),c.join(s)}_lineAt(r){let o;if(r instanceof E.Position?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this._lines.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this._lines[o],o===this._lines.length-1)}_offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.line-1)+r.character}_positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(r),s=this._lines[o.index].length;return new E.Position(o.index,Math.min(o.remainder,s))}_validateRange(r){if(!(r instanceof E.Range))throw new Error("Invalid argument");const o=this._validatePosition(r.start),s=this._validatePosition(r.end);return o===r.start&&s===r.end?r:new E.Range(o.line,o.character,s.line,s.character)}_validatePosition(r){if(!(r instanceof E.Position))throw new Error("Invalid argument");if(this._lines.length===0)return r.with(0,0);let{line:o,character:s}=r,i=!1;if(o<0)o=0,s=0,i=!0;else if(o>=this._lines.length)o=this._lines.length-1,s=this._lines[o].length,i=!0;else{const n=this._lines[o].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new E.Position(o,s):r}_getWordRangeAtPosition(r,o){const s=this._validatePosition(r);if(!o)o=y(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const i=(0,A.getWordAtText)(s.character+1,(0,A.ensureValidWordDefinition)(o),this._lines[s.line],0);if(i)return new E.Range(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.ExtHostDocumentData=h;class b{constructor(r,o,s){this._line=r,this._text=o,this._isLastLine=s}get lineNumber(){return this._line}get text(){return this._text}get range(){return new E.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new E.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=b}),define(Ie[259],Pe([1,0,4,7]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class T{constructor(A){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=A.getProxy(I.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,E,v){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const _=this._AiEmbeddingVectorProviders.get(A);if(!_)throw new Error("Embedding vector provider not found");const N=await _.provideEmbeddingVector(E,v);if(!N)throw new Error("Embedding vector provider returned undefined");return N}registerEmbeddingVectorProvider(A,E,v){const _=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(_,v),this._proxy.$registerAiEmbeddingVectorProvider(E,_),new L.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(_),this._AiEmbeddingVectorProviders.delete(_)})}}e.ExtHostAiEmbeddingVector=T}),define(Ie[65],Pe([1,0,4,38,7,21,3,17,46,6,11,23,16]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let m=b=class{constructor(o,s){this._fileSystemProvider=new Map,this._writeQueue=new N.ResourceQueue,this._proxy=o.getProxy(I.MainContext.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let c;const u=i._fileSystemProvider.get(n.scheme);return u?(await i._proxy.$ensureActivation(n.scheme),c=await u.impl.stat(n)):c=await i._proxy.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===L.FilePermission.Readonly?1:void 0}}catch(c){b._handleError(c)}},async readDirectory(n){try{const c=i._fileSystemProvider.get(n.scheme);return c?(await i._proxy.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await i._proxy.$readdir(n)}catch(c){return b._handleError(c)}},async createDirectory(n){try{const c=i._fileSystemProvider.get(n.scheme);return c&&!c.isReadonly?(await i._proxy.$ensureActivation(n.scheme),await i.mkdirp(c.impl,c.extUri,n)):await i._proxy.$mkdir(n)}catch(c){return b._handleError(c)}},async readFile(n){try{const c=i._fileSystemProvider.get(n.scheme);return c?(await i._proxy.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await i._proxy.$readFile(n)).buffer}catch(c){return b._handleError(c)}},async writeFile(n,c){try{const u=i._fileSystemProvider.get(n.scheme);return u&&!u.isReadonly?(await i._proxy.$ensureActivation(n.scheme),await i.mkdirp(u.impl,u.extUri,u.extUri.dirname(n)),await i._writeQueue.queueFor(n,()=>Promise.resolve(u.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await i._proxy.$writeFile(n,O.VSBuffer.wrap(c))}catch(u){return b._handleError(u)}},async delete(n,c){try{const u=i._fileSystemProvider.get(n.scheme);return u&&!u.isReadonly&&!c?.useTrash?(await i._proxy.$ensureActivation(n.scheme),await u.impl.delete(n,{recursive:!1,...c})):await i._proxy.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(u){return b._handleError(u)}},async rename(n,c,u){try{return await i._proxy.$rename(n,c,{overwrite:!1,...u})}catch(t){return b._handleError(t)}},async copy(n,c,u){try{return await i._proxy.$copy(n,c,{overwrite:!1,...u})}catch(t){return b._handleError(t)}},isWritableFileSystem(n){const c=s.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async mkdirp(o,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await o.stat(i)).type&L.FileType.Directory))throw T.FileSystemError.FileExists(`Unable to create folder '${i.scheme===h.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(L.toFileSystemProviderErrorCode(c)!==L.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(s.basename(i)),i=s.dirname(i)}for(let c=n.length-1;c>=0;c--){i=s.joinPath(i,n[c]);try{await o.createDirectory(i)}catch(u){if(L.toFileSystemProviderErrorCode(u)!==L.FileSystemProviderErrorCode.FileExists)throw u}}}static _handleError(o){if(o instanceof T.FileSystemError)throw o;if(o instanceof L.FileSystemProviderError)switch(o.code){case L.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(o.message);case L.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(o.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(o.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(o.message);case L.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(o.message);case L.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(o.message);default:throw new T.FileSystemError(o.message,o.name)}if(!(o instanceof Error))throw new T.FileSystemError(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw T.FileSystemError.Unavailable(o.message);switch(o.name){case L.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(o.message);case L.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(o.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(o.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(o.message);case L.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(o.message);case L.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(o.message);default:throw new T.FileSystemError(o.message,o.name)}}addFileSystemProvider(o,s,i){return this._fileSystemProvider.set(o,{impl:s,extUri:i?.isCaseSensitive?y.extUri:y.extUriIgnorePathCase,isReadonly:!!i?.isReadonly}),(0,_.toDisposable)(()=>this._fileSystemProvider.delete(o))}getFileSystemProviderExtUri(o){return this._fileSystemProvider.get(o)?.extUri??y.extUri}};e.ExtHostConsumerFileSystem=m,e.ExtHostConsumerFileSystem=m=b=Ke([He(0,E.IExtHostRpcService),He(1,v.IExtHostFileSystemInfo)],m),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[87],Pe([1,0,3,27,12,65,2]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,I.createDecorator)("IExtensionStoragePaths");let E=class{constructor(_,N,y){this._logService=N,this._extHostFileSystem=y,this._workspace=_.workspace??void 0,this._environment=_.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getWorkspaceStorageURI(_){return A.URI.joinPath(this._environment.workspaceStorageHome,_)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const _=this._workspace.id,N=await this._getWorkspaceStorageURI(_);try{return await this._extHostFileSystem.value.stat(N),this._logService.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",N),await this._extHostFileSystem.value.createDirectory(N),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),N}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(_){if(this._value)return A.URI.joinPath(this._value,_.identifier.value)}globalValue(_){return A.URI.joinPath(this._environment.globalStorageHome,_.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=E,e.ExtensionStoragePaths=E=Ke([He(0,L.IExtHostInitDataService),He(1,T.ILogService),He(2,O.IExtHostConsumerFileSystem)],E)}),define(Ie[260],Pe([1,0,7,17,5]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let O=class{constructor(E){this._actual=new I.ColorTheme(I.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(E){let v;switch(E){case"light":v=I.ColorThemeKind.Light;break;case"hcDark":v=I.ColorThemeKind.HighContrast;break;case"hcLight":v=I.ColorThemeKind.HighContrastLight;break;default:v=I.ColorThemeKind.Dark}this._actual=new I.ColorTheme(v),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=O,e.ExtHostTheming=O=Ke([He(0,L.IExtHostRpcService)],O)}),define(Ie[88],Pe([1,0,24,5,6,182,3,12,211,4,27,17,7]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class b extends v.DisposableTunnel{}var m;(function(o){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?v.TunnelPrivacyId.Public:v.TunnelPrivacyId.Private),protocol:n.protocol}}o.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==v.TunnelPrivacyId.ConstantPrivate&&n.privacy!==v.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}o.fromServiceTunnel=i})(m||(e.TunnelDtoConverter=m={})),e.IExtHostTunnelService=(0,A.createDecorator)("IExtHostTunnelService");let r=class extends T.Disposable{constructor(s,i,n){super(),this.logService=n,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new L.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=s.getProxy(_.MainContext.MainThreadTunnelService)}async openTunnel(s,i){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this._proxy.$openTunnel(i,s.displayName);if(n){const c=new b(n.remoteAddress,n.localAddress,()=>this._proxy.$closeTunnel(n.remoteAddress));return this._register(c),c}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(s,i){s.portRange===void 0&&s.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(n,{selector:s,provider:i}),this._proxy.$registerPortsAttributesProvider(s,n),new h.Disposable(()=>{this._portAttributesProviders.delete(n),this._proxy.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,c,u){const t=[];for(const a of s){const p=this._portAttributesProviders.get(a);if(!p)return[];t.push(...await Promise.all(i.map(async l=>{let D;try{D=await p.provider.providePortAttributes({port:l,pid:n,commandLine:c},u)}catch{D=await p.provider.providePortAttributes(l,n,c,u)}return{providedAttributes:D,port:l}})))}const f=t.filter(a=>!!a.providedAttributes);return f.length>0?f.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(c,u)=>await s.provideTunnel(c,u,I.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(n),Promise.resolve((0,T.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this._showCandidatePort=s.showCandidatePort,this._proxy.$setCandidateFilter());const n=s.tunnelFactory??(i?this.makeManagedTunnelFactory(i):void 0);if(n){this._forwardPortProvider=n;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const u=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this._proxy.$setTunnelProvider(u)}}else this._forwardPortProvider=void 0;return(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(s){}async $closeTunnel(s,i){if(this._extensionTunnels.has(s.host)){const n=this._extensionTunnels.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(s,i){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this._forwardPortProvider(s,i);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(s.remoteAddress.host)||this._extensionTunnels.set(s.remoteAddress.host,new Map);const u=this._register(c.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(c.remoteAddress))));return this._extensionTunnels.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:c,disposeListener:u}),m.fromApiTunnel(c)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(c=>this._showCandidatePort(c.host,c.port,c.detail??""))),n=s.filter((c,u)=>i[u]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.ExtHostTunnelService=r,e.ExtHostTunnelService=r=Ke([He(0,y.IExtHostRpcService),He(1,N.IExtHostInitDataService),He(2,E.ILogService)],r)}),define(Ie[8],Pe([1,0,18,21,138,261,55,28,127,49,70,25,133,23,15,2,30,89,101,107,106,224,85,52,62,235,7,36]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c,u,t,f,a,p,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=q,e.fromRangeOrRangeWithMessage=ce,e.pathOrURIToURI=Se;var d;(function(ve){function Ae(K){const{selectionStartLineNumber:Ce,selectionStartColumn:$e,positionLineNumber:Xe,positionColumn:je}=K,lt=new l.Position(Ce-1,$e-1),St=new l.Position(Xe-1,je-1);return new l.Selection(lt,St)}ve.to=Ae;function se(K){const{anchor:Ce,active:$e}=K;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}ve.from=se})(d||(e.Selection=d={}));var w;(function(ve){function Ae(K){if(!K)return;const{start:Ce,end:$e}=K;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}ve.from=Ae;function se(K){if(!K)return;const{startLineNumber:Ce,startColumn:$e,endLineNumber:Xe,endColumn:je}=K;return new l.Range(Ce-1,$e-1,Xe-1,je-1)}ve.to=se})(w||(e.Range=w={}));var g;(function(ve){function Ae(K){return{uri:K.uri,range:w.from(K.range)}}ve.from=Ae;function se(K){return new l.Location(r.URI.revive(K.uri),w.to(K.range))}ve.to=se})(g||(e.Location=g={}));var C;(function(ve){function Ae(se){switch(se){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}ve.to=Ae})(C||(e.TokenType=C={}));var S;(function(ve){function Ae(K){return new l.Position(K.lineNumber-1,K.column-1)}ve.to=Ae;function se(K){return{lineNumber:K.line+1,column:K.character+1}}ve.from=se})(S||(e.Position=S={}));var k;(function(ve){function Ae(Ce,$e,Xe){return(0,I.coalesce)((0,I.asArray)(Ce).map(je=>se(je,$e,Xe)))}ve.from=Ae;function se(Ce,$e,Xe){if(typeof Ce=="string")return{$serialized:!0,language:Ce,isBuiltin:Xe?.isBuiltin};if(Ce)return{$serialized:!0,language:Ce.language,scheme:K(Ce.scheme,$e),pattern:me.from(Ce.pattern)??void 0,exclusive:Ce.exclusive,notebookType:Ce.notebookType,isBuiltin:Xe?.isBuiltin}}function K(Ce,$e){return $e&&typeof Ce=="string"?$e.transformOutgoingScheme(Ce):Ce}})(k||(e.DocumentSelector=k={}));var P;(function(ve){function Ae(K){switch(K){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}ve.from=Ae;function se(K){switch(K){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}ve.to=se})(P||(e.DiagnosticTag=P={}));var H;(function(ve){function Ae(K){let Ce;return K.code&&((0,m.isString)(K.code)||(0,m.isNumber)(K.code)?Ce=String(K.code):Ce={value:String(K.code.value),target:K.code.target}),{...w.from(K.range),message:K.message,source:K.source,code:Ce,severity:V.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map($.from),tags:Array.isArray(K.tags)?(0,I.coalesce)(K.tags.map(P.from)):void 0}}ve.from=Ae;function se(K){const Ce=new l.Diagnostic(w.to(K),K.message,V.to(K.severity));return Ce.source=K.source,Ce.code=(0,m.isString)(K.code)?K.code:K.code?.value,Ce.relatedInformation=K.relatedInformation&&K.relatedInformation.map($.to),Ce.tags=K.tags&&(0,I.coalesce)(K.tags.map(P.to)),Ce}ve.to=se})(H||(e.Diagnostic=H={}));var $;(function(ve){function Ae(K){return{...w.from(K.location.range),message:K.message,resource:K.location.uri}}ve.from=Ae;function se(K){return new l.DiagnosticRelatedInformation(new l.Location(K.resource,w.to(K)),K.message)}ve.to=se})($||(e.DiagnosticRelatedInformation=$={}));var V;(function(ve){function Ae(K){switch(K){case l.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}ve.from=Ae;function se(K){switch(K){case i.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}ve.to=se})(V||(e.DiagnosticSeverity=V={}));var R;(function(ve){function Ae(K){return typeof K=="number"&&K>=l.ViewColumn.One?K-1:K===l.ViewColumn.Beside?p.SIDE_GROUP:p.ACTIVE_GROUP}ve.from=Ae;function se(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=se})(R||(e.ViewColumn=R={}));function z(ve){return typeof ve.range<"u"}function q(ve){return ve.length===0?!0:!!z(ve[0])}var ie;(function(ve){function Ae(je){return je.map(ve.from)}ve.fromMany=Ae;function se(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function K(je){let lt;if(se(je)){const{language:Nt,value:Ut}=je;lt={value:"```"+Nt+`
`+Ut+"\n```\n"}}else l.MarkdownString.isMarkdownString(je)?lt={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?lt={value:je}:lt={value:""};const St=Object.create(null);lt.uris=St;const xt=Nt=>{try{let Ut=r.URI.parse(Nt,!0);Ut=Ut.with({query:Ce(Ut.query,St)}),St[Nt]=Ut}catch{}return""},ct=new v.marked.Renderer;return ct.link=xt,ct.image=Nt=>typeof Nt=="string"?xt(A.parseHrefAndDimensions(Nt).href):"",(0,v.marked)(lt.value,{renderer:ct}),lt}ve.from=K;function Ce(je,lt){if(!je)return je;let St;try{St=(0,_.parse)(je)}catch{}if(!St)return je;let xt=!1;return St=(0,y.cloneAndChange)(St,ct=>{if(r.URI.isUri(ct)){const Nt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[Nt]=ct,xt=!0,Nt}else return}),xt?JSON.stringify(St):je}function $e(je){const lt=new l.MarkdownString(je.value,je.supportThemeIcons);return lt.isTrusted=je.isTrusted,lt.supportHtml=je.supportHtml,lt.baseUri=je.baseUri?r.URI.from(je.baseUri):void 0,lt}ve.to=$e;function Xe(je){if(je)return typeof je=="string"?je:ve.from(je)}ve.fromStrict=Xe})(ie||(e.MarkdownString=ie={}));function ce(ve){return q(ve)?ve.map(Ae=>({range:w.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?ie.fromMany(Ae.hoverMessage):Ae.hoverMessage?ie.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):ve.map(Ae=>({range:w.from(Ae)}))}function Se(ve){return typeof ve>"u"?ve:typeof ve=="string"?r.URI.file(ve):ve}var De;(function(ve){function Ae(se){return typeof se>"u"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?Se(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}ve.from=Ae})(De||(e.ThemableDecorationAttachmentRenderOptions=De={}));var fe;(function(ve){function Ae(se){return typeof se>"u"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?Se(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?De.from(se.before):void 0,after:se.after?De.from(se.after):void 0}}ve.from=Ae})(fe||(e.ThemableDecorationRenderOptions=fe={}));var pe;(function(ve){function Ae(se){if(typeof se>"u")return se;switch(se){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=Ae})(pe||(e.DecorationRangeBehavior=pe={}));var Ne;(function(ve){function Ae(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?pe.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?fe.from(se.light):void 0,dark:se.dark?fe.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?Se(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?De.from(se.before):void 0,after:se.after?De.from(se.after):void 0}}ve.from=Ae})(Ne||(e.DecorationRenderOptions=Ne={}));var ae;(function(ve){function Ae(K){return{text:K.newText,eol:K.newEol&&gt.from(K.newEol),range:w.from(K.range)}}ve.from=Ae;function se(K){const Ce=new l.TextEdit(w.to(K.range),K.text);return Ce.newEol=typeof K.eol>"u"?void 0:gt.to(K.eol),Ce}ve.to=se})(ae||(e.TextEdit=ae={}));var Re;(function(ve){function Ae(K,Ce){const $e={edits:[]};if(K instanceof l.WorkspaceEdit){const Xe=new E.ResourceSet;for(const je of K._allEntries())je._type===1&&r.URI.isUri(je.to)&&je.from===void 0&&Xe.add(je.to);for(const je of K._allEntries())if(je._type===1){let lt;je.options?.contents&&(ArrayBuffer.isView(je.options.contents)?lt={type:"base64",value:(0,L.encodeBase64)(L.VSBuffer.wrap(je.options.contents))}:lt={type:"dataTransferItem",id:je.options.contents._itemId}),$e.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contents:lt},metadata:je.metadata})}else je._type===2?$e.edits.push({resource:je.uri,textEdit:ae.from(je.edit),versionId:Xe.has(je.uri)?void 0:Ce?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?$e.edits.push({resource:je.uri,textEdit:{range:w.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Xe.has(je.uri)?void 0:Ce?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?$e.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Ce?.getNotebookDocumentVersion(je.uri)}):je._type===5&&$e.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Ce?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(ti.from)}})}return $e}ve.from=Ae;function se(K){const Ce=new l.WorkspaceEdit,$e=new E.ResourceMap;for(const Xe of K.edits)if(Xe.textEdit){const je=Xe,lt=r.URI.revive(je.resource),St=w.to(je.textEdit.range),xt=je.textEdit.text,ct=je.textEdit.insertAsSnippet;let Nt;ct?Nt=l.SnippetTextEdit.replace(St,new l.SnippetString(xt)):Nt=l.TextEdit.replace(St,xt);const Ut=$e.get(lt);Ut?Ut.push(Nt):$e.set(lt,[Nt])}else Ce.renameFile(r.URI.revive(Xe.oldResource),r.URI.revive(Xe.newResource),Xe.options);for(const[Xe,je]of $e)Ce.set(Xe,je);return Ce}ve.to=se})(Re||(e.WorkspaceEdit=Re={}));var ne;(function(ve){const Ae=Object.create(null);Ae[l.SymbolKind.File]=0,Ae[l.SymbolKind.Module]=1,Ae[l.SymbolKind.Namespace]=2,Ae[l.SymbolKind.Package]=3,Ae[l.SymbolKind.Class]=4,Ae[l.SymbolKind.Method]=5,Ae[l.SymbolKind.Property]=6,Ae[l.SymbolKind.Field]=7,Ae[l.SymbolKind.Constructor]=8,Ae[l.SymbolKind.Enum]=9,Ae[l.SymbolKind.Interface]=10,Ae[l.SymbolKind.Function]=11,Ae[l.SymbolKind.Variable]=12,Ae[l.SymbolKind.Constant]=13,Ae[l.SymbolKind.String]=14,Ae[l.SymbolKind.Number]=15,Ae[l.SymbolKind.Boolean]=16,Ae[l.SymbolKind.Array]=17,Ae[l.SymbolKind.Object]=18,Ae[l.SymbolKind.Key]=19,Ae[l.SymbolKind.Null]=20,Ae[l.SymbolKind.EnumMember]=21,Ae[l.SymbolKind.Struct]=22,Ae[l.SymbolKind.Event]=23,Ae[l.SymbolKind.Operator]=24,Ae[l.SymbolKind.TypeParameter]=25;function se(Ce){return typeof Ae[Ce]=="number"?Ae[Ce]:6}ve.from=se;function K(Ce){for(const $e in Ae)if(Ae[$e]===Ce)return Number($e);return l.SymbolKind.Property}ve.to=K})(ne||(e.SymbolKind=ne={}));var x;(function(ve){function Ae(K){switch(K){case l.SymbolTag.Deprecated:return 1}}ve.from=Ae;function se(K){switch(K){case 1:return l.SymbolTag.Deprecated}}ve.to=se})(x||(e.SymbolTag=x={}));var J;(function(ve){function Ae(K){return{name:K.name,kind:ne.from(K.kind),tags:K.tags&&K.tags.map(x.from),containerName:K.containerName,location:ge.from(K.location)}}ve.from=Ae;function se(K){const Ce=new l.SymbolInformation(K.name,ne.to(K.kind),K.containerName,ge.to(K.location));return Ce.tags=K.tags&&K.tags.map(x.to),Ce}ve.to=se})(J||(e.WorkspaceSymbol=J={}));var be;(function(ve){function Ae(K){const Ce={name:K.name||"!!MISSING: name!!",detail:K.detail,range:w.from(K.range),selectionRange:w.from(K.selectionRange),kind:ne.from(K.kind),tags:K.tags?.map(x.from)??[]};return K.children&&(Ce.children=K.children.map(Ae)),Ce}ve.from=Ae;function se(K){const Ce=new l.DocumentSymbol(K.name,K.detail,ne.to(K.kind),w.to(K.range),w.to(K.selectionRange));return(0,I.isNonEmptyArray)(K.tags)&&(Ce.tags=K.tags.map(x.to)),K.children&&(Ce.children=K.children.map(se)),Ce}ve.to=se})(be||(e.DocumentSymbol=be={}));var Me;(function(ve){function Ae(K){const Ce=new l.CallHierarchyItem(ne.to(K.kind),K.name,K.detail||"",r.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return Ce._sessionId=K._sessionId,Ce._itemId=K._itemId,Ce}ve.to=Ae;function se(K,Ce,$e){if(Ce=Ce??K._sessionId,$e=$e??K._itemId,Ce===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:$e,name:K.name,detail:K.detail,kind:ne.from(K.kind),uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(x.from)}}ve.from=se})(Me||(e.CallHierarchyItem=Me={}));var ye;(function(ve){function Ae(se){return new l.CallHierarchyIncomingCall(Me.to(se.from),se.fromRanges.map(K=>w.to(K)))}ve.to=Ae})(ye||(e.CallHierarchyIncomingCall=ye={}));var Ee;(function(ve){function Ae(se){return new l.CallHierarchyOutgoingCall(Me.to(se.to),se.fromRanges.map(K=>w.to(K)))}ve.to=Ae})(Ee||(e.CallHierarchyOutgoingCall=Ee={}));var ge;(function(ve){function Ae(K){return{range:K.range&&w.from(K.range),uri:K.uri}}ve.from=Ae;function se(K){return new l.Location(r.URI.revive(K.uri),w.to(K.range))}ve.to=se})(ge||(e.location=ge={}));var G;(function(ve){function Ae(K){const Ce=K,$e=K;return{originSelectionRange:Ce.originSelectionRange?w.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:$e.uri,range:w.from(Ce.targetRange?Ce.targetRange:$e.range),targetSelectionRange:Ce.targetSelectionRange?w.from(Ce.targetSelectionRange):void 0}}ve.from=Ae;function se(K){return{targetUri:r.URI.revive(K.uri),targetRange:w.to(K.range),targetSelectionRange:K.targetSelectionRange?w.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?w.to(K.originSelectionRange):void 0}}ve.to=se})(G||(e.DefinitionLink=G={}));var Y;(function(ve){function Ae(K){return{range:w.from(K.range),contents:ie.fromMany(K.contents),canIncreaseVerbosity:K.canIncreaseVerbosity,canDecreaseVerbosity:K.canDecreaseVerbosity}}ve.from=Ae;function se(K){const Ce=K.contents.map(ie.to),$e=w.to(K.range),Xe=K.canIncreaseVerbosity,je=K.canDecreaseVerbosity;return new l.VerboseHover(Ce,$e,Xe,je)}ve.to=se})(Y||(e.Hover=Y={}));var de;(function(ve){function Ae(K){return{range:w.from(K.range),expression:K.expression}}ve.from=Ae;function se(K){return new l.EvaluatableExpression(w.to(K.range),K.expression)}ve.to=se})(de||(e.EvaluatableExpression=de={}));var le;(function(ve){function Ae(K){if(K instanceof l.InlineValueText)return{type:"text",range:w.from(K.range),text:K.text};if(K instanceof l.InlineValueVariableLookup)return{type:"variable",range:w.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=Ae;function se(K){switch(K.type){case"text":return{range:w.to(K.range),text:K.text};case"variable":return{range:w.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:w.to(K.range),expression:K.expression}}}ve.to=se})(le||(e.InlineValue=le={}));var Oe;(function(ve){function Ae(K){return{frameId:K.frameId,stoppedLocation:w.from(K.stoppedLocation)}}ve.from=Ae;function se(K){return new l.InlineValueContext(K.frameId,w.to(K.stoppedLocation))}ve.to=se})(Oe||(e.InlineValueContext=Oe={}));var he;(function(ve){function Ae(K){return{range:w.from(K.range),kind:K.kind}}ve.from=Ae;function se(K){return new l.DocumentHighlight(w.to(K.range),K.kind)}ve.to=se})(he||(e.DocumentHighlight=he={}));var ke;(function(ve){function Ae(K){return{uri:K.uri,highlights:K.highlights.map(he.from)}}ve.from=Ae;function se(K){return new l.MultiDocumentHighlight(r.URI.revive(K.uri),K.highlights.map(he.to))}ve.to=se})(ke||(e.MultiDocumentHighlight=ke={}));var Te;(function(ve){function Ae(se){switch(se){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}ve.to=Ae})(Te||(e.CompletionTriggerKind=Te={}));var ze;(function(ve){function Ae(se){return{triggerKind:Te.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}ve.to=Ae})(ze||(e.CompletionContext=ze={}));var U;(function(ve){function Ae(K){switch(K){case l.CompletionItemTag.Deprecated:return 1}}ve.from=Ae;function se(K){switch(K){case 1:return l.CompletionItemTag.Deprecated}}ve.to=se})(U||(e.CompletionItemTag=U={}));var M;(function(ve){const Ae=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function se($e){return Ae.get($e)??9}ve.from=se;const K=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ce($e){return K.get($e)??l.CompletionItemKind.Property}ve.to=Ce})(M||(e.CompletionItemKind=M={}));var W;(function(ve){function Ae(se,K){const Ce=new l.CompletionItem(se.label);return Ce.insertText=se.insertText,Ce.kind=M.to(se.kind),Ce.tags=se.tags?.map(U.to),Ce.detail=se.detail,Ce.documentation=A.isMarkdownString(se.documentation)?ie.to(se.documentation):se.documentation,Ce.sortText=se.sortText,Ce.filterText=se.filterText,Ce.preselect=se.preselect,Ce.commitCharacters=se.commitCharacters,o.Range.isIRange(se.range)?Ce.range=w.to(se.range):typeof se.range=="object"&&(Ce.range={inserting:w.to(se.range.insert),replacing:w.to(se.range.replace)}),Ce.keepWhitespace=typeof se.insertTextRules>"u"?!1:!!(se.insertTextRules&1),typeof se.insertTextRules<"u"&&se.insertTextRules&4?Ce.insertText=new l.SnippetString(se.insertText):(Ce.insertText=se.insertText,Ce.textEdit=Ce.range instanceof l.Range?new l.TextEdit(Ce.range,Ce.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(Ce.additionalTextEdits=se.additionalTextEdits.map($e=>ae.to($e))),Ce.command=K&&se.command?K.fromInternal(se.command):void 0,Ce}ve.to=Ae})(W||(e.CompletionItem=W={}));var j;(function(ve){function Ae(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:ie.fromStrict(K.documentation)}}ve.from=Ae;function se(K){return{label:K.label,documentation:A.isMarkdownString(K.documentation)?ie.to(K.documentation):K.documentation}}ve.to=se})(j||(e.ParameterInformation=j={}));var ee;(function(ve){function Ae(K){return{label:K.label,documentation:ie.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(j.from):[],activeParameter:K.activeParameter}}ve.from=Ae;function se(K){return{label:K.label,documentation:A.isMarkdownString(K.documentation)?ie.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(j.to):[],activeParameter:K.activeParameter}}ve.to=se})(ee||(e.SignatureInformation=ee={}));var re;(function(ve){function Ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ee.from):[]}}ve.from=Ae;function se(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ee.to):[]}}ve.to=se})(re||(e.SignatureHelp=re={}));var Le;(function(ve){function Ae(se,K){const Ce=new l.InlayHint(S.to(K.position),typeof K.label=="string"?K.label:K.label.map(Be.to.bind(void 0,se)),K.kind&&We.to(K.kind));return Ce.textEdits=K.textEdits&&K.textEdits.map(ae.to),Ce.tooltip=A.isMarkdownString(K.tooltip)?ie.to(K.tooltip):K.tooltip,Ce.paddingLeft=K.paddingLeft,Ce.paddingRight=K.paddingRight,Ce}ve.to=Ae})(Le||(e.InlayHint=Le={}));var Be;(function(ve){function Ae(se,K){const Ce=new l.InlayHintLabelPart(K.label);return Ce.tooltip=A.isMarkdownString(K.tooltip)?ie.to(K.tooltip):K.tooltip,s.Command.is(K.command)&&(Ce.command=se.fromInternal(K.command)),K.location&&(Ce.location=ge.to(K.location)),Ce}ve.to=Ae})(Be||(e.InlayHintLabelPart=Be={}));var We;(function(ve){function Ae(K){return K}ve.from=Ae;function se(K){return K}ve.to=se})(We||(e.InlayHintKind=We={}));var Ze;(function(ve){function Ae(K){return{range:w.from(K.range),url:K.target,tooltip:K.tooltip}}ve.from=Ae;function se(K){let Ce;if(K.url)try{Ce=typeof K.url=="string"?r.URI.parse(K.url,!0):r.URI.revive(K.url)}catch{}return new l.DocumentLink(w.to(K.range),Ce)}ve.to=se})(Ze||(e.DocumentLink=Ze={}));var Je;(function(ve){function Ae(K){const Ce=new l.ColorPresentation(K.label);return K.textEdit&&(Ce.textEdit=ae.to(K.textEdit)),K.additionalTextEdits&&(Ce.additionalTextEdits=K.additionalTextEdits.map($e=>ae.to($e))),Ce}ve.to=Ae;function se(K){return{label:K.label,textEdit:K.textEdit?ae.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ce=>ae.from(Ce)):void 0}}ve.from=se})(Je||(e.ColorPresentation=Je={}));var et;(function(ve){function Ae(K){return new l.Color(K[0],K[1],K[2],K[3])}ve.to=Ae;function se(K){return[K.red,K.green,K.blue,K.alpha]}ve.from=se})(et||(e.Color=et={}));var tt;(function(ve){function Ae(K){return{range:w.from(K.range)}}ve.from=Ae;function se(K){return new l.SelectionRange(w.to(K.range))}ve.to=se})(tt||(e.SelectionRange=tt={}));var it;(function(ve){function Ae(se){switch(se){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}ve.to=Ae})(it||(e.TextDocumentSaveReason=it={}));var at;(function(ve){function Ae(K){switch(K){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.Interval:return 3;case l.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=Ae;function se(K){switch(K){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 3:return l.TextEditorLineNumbersStyle.Interval;case 1:default:return l.TextEditorLineNumbersStyle.On}}ve.to=se})(at||(e.TextEditorLineNumbersStyle=at={}));var gt;(function(ve){function Ae(K){if(K===l.EndOfLine.CRLF)return 1;if(K===l.EndOfLine.LF)return 0}ve.from=Ae;function se(K){if(K===1)return l.EndOfLine.CRLF;if(K===0)return l.EndOfLine.LF}ve.to=se})(gt||(e.EndOfLine=gt={}));var Ue;(function(ve){function Ae(se){if(typeof se=="object")return se.viewId;switch(se){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=Ae})(Ue||(e.ProgressLocation=Ue={}));var st;(function(ve){function Ae(K){const Ce={start:K.start+1,end:K.end+1};return K.kind&&(Ce.kind=Q.from(K.kind)),Ce}ve.from=Ae;function se(K){const Ce={start:K.start-1,end:K.end-1};return K.kind&&(Ce.kind=Q.to(K.kind)),Ce}ve.to=se})(st||(e.FoldingRange=st={}));var Q;(function(ve){function Ae(K){if(K)switch(K){case l.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}ve.from=Ae;function se(K){if(K)switch(K.value){case s.FoldingRangeKind.Comment.value:return l.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports.value:return l.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region.value:return l.FoldingRangeKind.Region}}ve.to=se})(Q||(e.FoldingRangeKind=Q={}));var X;(function(ve){function Ae(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?w.from(se.selection):void 0,override:typeof se.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ve.from=Ae})(X||(e.TextEditorOpenOptions=X={}));var me;(function(ve){function Ae($e){return $e instanceof l.RelativePattern?$e.toJSON():typeof $e=="string"?$e:se($e)||K($e)?new l.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}ve.from=Ae;function se($e){const Xe=$e;return Xe?r.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function K($e){const Xe=$e;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ce($e){return typeof $e=="string"?$e:new l.RelativePattern(r.URI.revive($e.baseUri),$e.pattern)}ve.to=Ce})(me||(e.GlobPattern=me={}));var Ve;(function(ve){function Ae(se){if(se){if(Array.isArray(se))return se.map(Ae);if(typeof se=="string")return se;{const K=se;return{language:K.language,scheme:K.scheme,pattern:me.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}ve.from=Ae})(Ve||(e.LanguageSelector=Ve={}));var we;(function(ve){function Ae(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Ce=>Array.isArray(Ce)&&Ce.every($e=>$e&&typeof $e=="object"&&"uri"in $e&&r.URI.isUri($e.uri)&&"version"in $e&&typeof $e.version=="number"&&"ranges"in $e&&Array.isArray($e.ranges)&&$e.ranges.every(Xe=>Xe instanceof l.Range)))}ve.is=Ae;function se(K){return{documents:K.documents.map(Ce=>Ce.map($e=>({uri:r.URI.from($e.uri),version:$e.version,ranges:$e.ranges.map(Xe=>w.from(Xe))})))}}ve.from=se})(we||(e.MappedEditsContext=we={}));var ot;(function(ve){function Ae(K){return{start:K.start,end:K.end}}ve.from=Ae;function se(K){return new l.NotebookRange(K.start,K.end)}ve.to=se})(ot||(e.NotebookRange=ot={}));var ht;(function(ve){function Ae(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ve.to=Ae;function se(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ve.from=se})(ht||(e.NotebookCellExecutionSummary=ht={}));var Pt;(function(ve){function Ae(se){if(se===t.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(se===t.NotebookCellExecutionState.Pending)return;if(se===t.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${se}`)}ve.to=Ae})(Pt||(e.NotebookCellExecutionState=Pt={}));var $t;(function(ve){function Ae(K){switch(K){case l.NotebookCellKind.Markup:return t.CellKind.Markup;case l.NotebookCellKind.Code:default:return t.CellKind.Code}}ve.from=Ae;function se(K){switch(K){case t.CellKind.Markup:return l.NotebookCellKind.Markup;case t.CellKind.Code:default:return l.NotebookCellKind.Code}}ve.to=se})($t||(e.NotebookCellKind=$t={}));var Gt;(function(ve){function Ae(K){const Ce={metadata:K.metadata??Object.create(null),cells:[]};for(const $e of K.cells)l.NotebookCellData.validate($e),Ce.cells.push(ti.from($e));return Ce}ve.from=Ae;function se(K){const Ce=new l.NotebookData(K.cells.map(ti.to));return(0,m.isEmptyObject)(K.metadata)||(Ce.metadata=K.metadata),Ce}ve.to=se})(Gt||(e.NotebookData=Gt={}));var ti;(function(ve){function Ae(K){return{cellKind:$t.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:ht.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(_t.from):[]}}ve.from=Ae;function se(K){return new l.NotebookCellData($t.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(_t.to):void 0,K.metadata,K.internalMetadata?ht.to(K.internalMetadata):void 0)}ve.to=se})(ti||(e.NotebookCellData=ti={}));var Xt;(function(ve){function Ae(K){return{mime:K.mime,valueBytes:L.VSBuffer.wrap(K.data)}}ve.from=Ae;function se(K){return new l.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ve.to=se})(Xt||(e.NotebookCellOutputItem=Xt={}));var _t;(function(ve){function Ae(K){return{outputId:K.id,items:K.items.map(Xt.from),metadata:K.metadata}}ve.from=Ae;function se(K){const Ce=K.items.map(Xt.to);return new l.NotebookCellOutput(Ce,K.outputId,K.metadata)}ve.to=se})(_t||(e.NotebookCellOutput=_t={}));var Qt;(function(ve){function Ae(Ce){return K(Ce)?{include:me.from(Ce.include)??void 0,exclude:me.from(Ce.exclude)??void 0}:me.from(Ce)??void 0}ve.from=Ae;function se(Ce){return K(Ce)?{include:me.to(Ce.include),exclude:me.to(Ce.exclude)}:me.to(Ce)}ve.to=se;function K(Ce){const $e=Ce;return $e?!(0,m.isUndefinedOrNull)($e.include)&&!(0,m.isUndefinedOrNull)($e.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Yt;(function(ve){function Ae(se,K,Ce){const $e=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal($e,Ce),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}ve.from=Ae})(Yt||(e.NotebookStatusBarItem=Yt={}));var Qe;(function(ve){function Ae(se,K,Ce){const $e=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{command:K.toInternal($e,Ce),label:se.label,description:se.description,detail:se.detail,documentation:se.documentation}}ve.from=Ae})(Qe||(e.NotebookKernelSourceAction=Qe={}));var oi;(function(ve){function Ae(se){return{transientOutputs:se?.transientOutputs??!1,transientCellMetadata:se?.transientCellMetadata??{},transientDocumentMetadata:se?.transientDocumentMetadata??{},cellContentMetadata:se?.cellContentMetadata??{}}}ve.from=Ae})(oi||(e.NotebookDocumentContentOptions=oi={}));var jt;(function(ve){function Ae(K){return{uri:K.uri,provides:K.provides}}ve.from=Ae;function se(K){return new l.NotebookRendererScript(r.URI.revive(K.uri),K.provides)}ve.to=se})(jt||(e.NotebookRendererScript=jt={}));var dt;(function(ve){function Ae(K){return{message:ie.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:w.from(K.location.range),uri:K.location.uri}}}ve.from=Ae;function se(K){const Ce=new l.TestMessage(typeof K.message=="string"?K.message:ie.to(K.message));return Ce.actualOutput=K.actual,Ce.expectedOutput=K.expected,Ce.contextValue=K.contextValue,Ce.location=K.location?ge.to(K.location):void 0,Ce}ve.to=se})(dt||(e.TestMessage=dt={}));var pt;(function(ve){ve.namespace=a.namespaceTestTag,ve.denamespace=a.denamespaceTestTag})(pt||(e.TestTag=pt={}));var Jt;(function(ve){function Ae(K){const Ce=(0,n.getPrivateApiFor)(K).controllerId;return{extId:f.TestId.fromExtHostTestItem(K,Ce).toString(),label:K.label,uri:r.URI.revive(K.uri),busy:K.busy,tags:K.tags.map($e=>pt.namespace(Ce,$e.id)),range:o.Range.lift(w.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&ie.fromStrict(K.error)||null}}ve.from=Ae;function se(K){return{parent:void 0,error:void 0,id:f.TestId.fromString(K.extId).localId,label:K.label,uri:r.URI.revive(K.uri),tags:(K.tags||[]).map(Ce=>{const{tagId:$e}=pt.denamespace(Ce);return new l.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:w.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}ve.toPlain=se})(Jt||(e.TestItem=Jt={})),function(ve){function Ae(K){return{id:K.id}}ve.from=Ae;function se(K){return new l.TestTag(K.id)}ve.to=se}(pt||(e.TestTag=pt={}));var qt;(function(ve){const Ae=(K,Ce)=>{const $e=K.value;if(!$e)return;const Xe={...Jt.toPlain($e.item),parent:Ce,taskStates:$e.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(lt=>lt.type===0).map(dt.to)})),children:[]};if(K.children)for(const je of K.children.values()){const lt=Ae(je,Xe);lt&&Xe.children.push(lt)}return Xe};function se(K){const Ce=new h.WellDefinedPrefixTree;for(const je of K.items)Ce.insert(f.TestId.fromString(je.item.extId).path,je);const $e=[Ce.nodes],Xe=[];for(;$e.length;)for(const je of $e.pop())je.value?Xe.push(je):je.children&&$e.push(je.children.values());return{completedAt:K.completedAt,results:Xe.map(je=>Ae(je)).filter(m.isDefined)}}ve.to=se})(qt||(e.TestResults=qt={}));var Mt;(function(ve){function Ae($e){return{covered:$e.covered,total:$e.total}}function se($e){return"line"in $e?S.from($e):w.from($e)}function K($e){if(typeof $e.executed=="number"&&$e.executed<0)throw new Error(`Invalid coverage count ${$e.executed}`);return"branches"in $e?{count:$e.executed,location:se($e.location),type:1,branches:$e.branches.length?$e.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&se(Xe.location),label:Xe.label})):void 0}:{type:0,name:$e.name,count:$e.executed,location:se($e.location)}}ve.fromDetails=K;function Ce($e,Xe){return l.validateTestCoverageCount(Xe.statementCoverage),l.validateTestCoverageCount(Xe.branchCoverage),l.validateTestCoverageCount(Xe.declarationCoverage),{id:$e,uri:Xe.uri,statement:Ae(Xe.statementCoverage),branch:Xe.branchCoverage&&Ae(Xe.branchCoverage),declaration:Xe.declarationCoverage&&Ae(Xe.declarationCoverage)}}ve.fromFile=Ce})(Mt||(e.TestCoverage=Mt={}));var ft;(function(ve){function Ae(se){switch(se){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}ve.to=Ae})(ft||(e.CodeActionTriggerKind=ft={}));var Bt;(function(ve){function Ae(K){const Ce=new l.TypeHierarchyItem(ne.to(K.kind),K.name,K.detail||"",r.URI.revive(K.uri),w.to(K.range),w.to(K.selectionRange));return Ce._sessionId=K._sessionId,Ce._itemId=K._itemId,Ce}ve.to=Ae;function se(K,Ce,$e){if(Ce=Ce??K._sessionId,$e=$e??K._itemId,Ce===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:$e,kind:ne.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:w.from(K.range),selectionRange:w.from(K.selectionRange),tags:K.tags?.map(x.from)}}ve.from=se})(Bt||(e.TypeHierarchyItem=Bt={}));var Zt;(function(ve){function Ae(se){if(se)return{value:se.value,tooltip:se.tooltip}}ve.from=Ae})(Zt||(e.ViewBadge=Zt={}));var zt;(function(ve){function Ae($e,Xe,je){const lt=Xe.fileData;return lt?new l.InternalFileDataTransferItem(new l.DataTransferFile(lt.name,r.URI.revive(lt.uri),lt.id,(0,O.createSingleCallFunction)(()=>je(lt.id)))):$e===N.Mimes.uriList&&Xe.uriListData?new l.InternalDataTransferItem(Ce(Xe.uriListData)):new l.InternalDataTransferItem(Xe.asString)}ve.to=Ae;async function se($e,Xe){const je=await Xe.asString();if($e===N.Mimes.uriList)return{asString:je,fileData:void 0,uriListData:K(je)};const lt=Xe.asFile();return{asString:je,fileData:lt?{name:lt.name,uri:lt.uri,id:lt._itemId??lt.id}:void 0}}ve.from=se;function K($e){return T.UriList.split($e).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return r.URI.parse(Xe)}catch{}return Xe})}function Ce($e){return T.UriList.create($e.map(Xe=>typeof Xe=="string"?Xe:r.URI.revive(Xe)))}})(zt||(e.DataTransferItem=zt={}));var Ge;(function(ve){function Ae(K,Ce){const $e=K.items.map(([Xe,je])=>[Xe,zt.to(Xe,je,Ce)]);return new l.DataTransfer($e)}ve.toDataTransfer=Ae;async function se(K){const Ce={items:[]},$e=[];for(const[Xe,je]of K)$e.push((async()=>{Ce.items.push([Xe,await zt.from(Xe,je)])})());return await Promise.all($e),Ce}ve.from=se})(Ge||(e.DataTransfer=Ge={}));var li;(function(ve){function Ae(K,Ce){return{kind:"reply",agentId:K.participant??Ce?.agentId??"",subCommand:K.command??Ce?.command,message:K.prompt,title:K.label}}ve.from=Ae;function se(K){return{prompt:K.message,label:K.title,participant:K.agentId,command:K.subCommand}}ve.to=se})(li||(e.ChatFollowup=li={}));var Kt;(function(ve){function Ae(se){return"commandId"in se?{kind:"command",title:se.title??"",commandId:se.commandId??"",when:se.when??"",args:se.args}:{kind:"reply",message:se.message,title:se.title,tooltip:se.tooltip}}ve.from=Ae})(Kt||(e.ChatInlineFollowup=Kt={}));var Ht;(function(ve){function Ae(K){switch(K.role){case 0:return new l.LanguageModelChatSystemMessage(K.content);case 1:return new l.LanguageModelChatUserMessage(K.content);case 2:return new l.LanguageModelChatAssistantMessage(K.content)}}ve.to=Ae;function se(K){if(K instanceof l.LanguageModelChatSystemMessage)return{role:0,content:K.content};if(K instanceof l.LanguageModelChatUserMessage)return{role:1,content:K.content};if(K instanceof l.LanguageModelChatAssistantMessage)return{role:2,content:K.content};throw new Error("Invalid LanguageModelMessage")}ve.from=se})(Ht||(e.LanguageModelMessage=Ht={}));var vt;(function(ve){function Ae(Ce){const $e={};for(const Xe of Object.keys(Ce))$e[Xe]=Ce[Xe].map(ve.to);return $e}ve.objectTo=Ae;function se(Ce){return{level:Ft.to(Ce.level),kind:Ce.kind,value:(0,r.isUriComponents)(Ce.value)?r.URI.revive(Ce.value):Ce.value,description:Ce.description}}ve.to=se;function K(Ce){return{level:Ft.from(Ce.level),kind:Ce.kind,value:Ce.value,description:Ce.description}}ve.from=K})(vt||(e.ChatVariable=vt={}));var Ft;(function(ve){function Ae(K){switch(K){case"short":return l.ChatVariableLevel.Short;case"medium":return l.ChatVariableLevel.Medium;case"full":default:return l.ChatVariableLevel.Full}}ve.to=Ae;function se(K){switch(K){case l.ChatVariableLevel.Short:return"short";case l.ChatVariableLevel.Medium:return"medium";case l.ChatVariableLevel.Full:default:return"full"}}ve.from=se})(Ft||(e.ChatVariableLevel=Ft={}));var At;(function(ve){function Ae(se){switch(se){case 1:return l.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return l.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return l.InteractiveEditorResponseFeedbackKind.Undone;case 3:return l.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return l.InteractiveEditorResponseFeedbackKind.Bug}}ve.to=Ae})(At||(e.InteractiveEditorResponseFeedbackKind=At={}));var Lt;(function(ve){function Ae(K){return{kind:"markdownContent",content:ie.from(K.value)}}ve.from=Ae;function se(K){return new l.ChatResponseMarkdownPart(ie.to(K.content))}ve.to=se})(Lt||(e.ChatResponseMarkdownPart=Lt={}));var ii;(function(ve){function Ae(K){return{kind:"markdownVuln",content:ie.from(K.value),vulnerabilities:K.vulnerabilities}}ve.from=Ae;function se(K){return new l.ChatResponseMarkdownWithVulnerabilitiesPart(ie.to(K.content),K.vulnerabilities)}ve.to=se})(ii||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ii={}));var Vt;(function(ve){function Ae(K){return{kind:"agentDetection",agentId:K.participant,command:K.command}}ve.from=Ae;function se(K){return new l.ChatResponseDetectedParticipantPart(K.agentId,K.command)}ve.to=se})(Vt||(e.ChatResponseDetectedParticipantPart=Vt={}));var ni;(function(ve){function Ae(K){const{value:Ce,baseUri:$e}=K;function Xe(je,lt){return je.map(St=>{const xt=r.URI.joinPath(lt,St.name);return{label:St.name,uri:xt,children:St.children&&Xe(St.children,xt)}})}return{kind:"treeData",treeData:{label:(0,b.basename)($e),uri:$e,children:Xe(Ce,$e)}}}ve.from=Ae;function se(K){const Ce=(0,_.revive)(K.treeData);function $e(lt){return lt.map(St=>({name:St.label,children:St.children&&$e(St.children)}))}const Xe=Ce.uri,je=Ce.children?$e(Ce.children):[];return new l.ChatResponseFileTreePart(je,Xe)}ve.to=se})(ni||(e.ChatResponseFilesPart=ni={}));var kt;(function(ve){function Ae(K){return{kind:"inlineReference",name:K.title,inlineReference:r.URI.isUri(K.value)?K.value:g.from(K.value)}}ve.from=Ae;function se(K){const Ce=(0,_.revive)(K);return new l.ChatResponseAnchorPart(r.URI.isUri(Ce.inlineReference)?Ce.inlineReference:g.to(Ce.inlineReference),K.name)}ve.to=se})(kt||(e.ChatResponseAnchorPart=kt={}));var Ot;(function(ve){function Ae(K){return{kind:"progressMessage",content:ie.from(K.value)}}ve.from=Ae;function se(K){return new l.ChatResponseProgressPart(K.content.value)}ve.to=se})(Ot||(e.ChatResponseProgressPart=Ot={}));var Rt;(function(ve){function Ae(K,Ce,$e){return{kind:"command",command:Ce.toInternal(K.value,$e)??{command:K.value.command,title:K.value.title}}}ve.from=Ae;function se(K,Ce){return new l.ChatResponseCommandButtonPart(Ce.fromInternal(K.command)??{command:K.command.id,title:K.command.title})}ve.to=se})(Rt||(e.ChatResponseCommandButtonPart=Rt={}));var It;(function(ve){function Ae(K){return{kind:"textEdit",uri:K.uri,edits:K.edits.map(Ce=>ae.from(Ce))}}ve.from=Ae;function se(K){return new l.ChatResponseTextEditPart(r.URI.revive(K.uri),K.edits.map(Ce=>ae.to(Ce)))}ve.to=se})(It||(e.ChatResponseTextEditPart=It={}));var mt;(function(ve){function Ae(K){const Ce=D.ThemeIcon.isThemeIcon(K.iconPath)?K.iconPath:void 0;return"variableName"in K.value?{kind:"reference",reference:{variableName:K.value.variableName,value:r.URI.isUri(K.value.value)||!K.value.value?K.value.value:g.from(K.value.value)},iconPath:Ce}:{kind:"reference",reference:r.URI.isUri(K.value)?K.value:g.from(K.value),iconPath:Ce}}ve.from=Ae;function se(K){const Ce=(0,_.revive)(K),$e=Xe=>r.URI.isUri(Xe)?Xe:g.to(Xe);return new l.ChatResponseReferencePart("variableName"in Ce.reference?{variableName:Ce.reference.variableName,value:Ce.reference.value&&$e(Ce.reference.value)}:$e(Ce.reference))}ve.to=se})(mt||(e.ChatResponseReferencePart=mt={}));var yt;(function(ve){function Ae(Ce,$e,Xe){return Ce instanceof l.ChatResponseMarkdownPart?Lt.from(Ce):Ce instanceof l.ChatResponseAnchorPart?kt.from(Ce):Ce instanceof l.ChatResponseReferencePart?mt.from(Ce):Ce instanceof l.ChatResponseProgressPart?Ot.from(Ce):Ce instanceof l.ChatResponseFileTreePart?ni.from(Ce):Ce instanceof l.ChatResponseCommandButtonPart?Rt.from(Ce,$e,Xe):Ce instanceof l.ChatResponseTextEditPart?It.from(Ce):Ce instanceof l.ChatResponseMarkdownWithVulnerabilitiesPart?ii.from(Ce):Ce instanceof l.ChatResponseDetectedParticipantPart?Vt.from(Ce):{kind:"markdownContent",content:ie.from("")}}ve.from=Ae;function se(Ce,$e){switch(Ce.kind){case"reference":return mt.to(Ce);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return K(Ce,$e)}}ve.to=se;function K(Ce,$e){switch(Ce.kind){case"markdownContent":return Lt.to(Ce);case"inlineReference":return kt.to(Ce);case"progressMessage":return;case"treeData":return ni.to(Ce);case"command":return Rt.to(Ce,$e)}}ve.toContent=K})(yt||(e.ChatResponsePart=yt={}));var ai;(function(ve){function Ae(se){return{prompt:se.message,command:se.command,attempt:se.attempt??0,enableCommandDetection:se.enableCommandDetection??!0,variables:se.variables.variables.map(fi.to),location:Ct.to(se.location)}}ve.to=Ae})(ai||(e.ChatAgentRequest=ai={}));var Ct;(function(ve){function Ae(se){switch(se){case u.ChatAgentLocation.Notebook:return l.ChatLocation.Notebook;case u.ChatAgentLocation.Terminal:return l.ChatLocation.Terminal;case u.ChatAgentLocation.Panel:return l.ChatLocation.Panel;case u.ChatAgentLocation.Editor:return l.ChatLocation.Editor}}ve.to=Ae})(Ct||(e.ChatLocation=Ct={}));var fi;(function(ve){function Ae(se){return{name:se.name,range:se.range&&[se.range.start,se.range.endExclusive],values:se.values.map(vt.to)}}ve.to=Ae})(fi||(e.ChatAgentResolvedVariable=fi={}));var ri;(function(ve){function Ae(se,K,Ce){return{label:se.label,values:se.values.map(vt.from),insertText:se.insertText,detail:se.detail,documentation:se.documentation,command:K.toInternal(se.command,Ce)}}ve.from=Ae})(ri||(e.ChatAgentCompletionItem=ri={}));var pi;(function(ve){function Ae(se){return{errorDetails:se.errorDetails,metadata:se.metadata}}ve.to=Ae})(pi||(e.ChatAgentResult=pi={}));var ui;(function(ve){function Ae(se,K,Ce){if(K.action.kind==="vote")return;const $e=pi.to(se);if(K.action.kind==="command"){const Xe=K.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ce.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:$e}}else return K.action.kind==="followUp"?{action:{kind:"followUp",followup:li.to(K.action.followup)},result:$e}:K.action.kind==="inlineChat"?{action:{kind:"editor",accepted:K.action.action==="accepted"},result:$e}:{action:K.action,result:$e}}ve.to=Ae})(ui||(e.ChatAgentUserActionEvent=ui={}));var Ei;(function(ve){function Ae(se,K,Ce){return"terminalCommand"in se?{terminalCommand:se.terminalCommand,shouldExecute:se.shouldExecute}:"uri"in se?{uri:se.uri}:K.toInternal(se,Ce)}ve.from=Ae})(Ei||(e.TerminalQuickFix=Ei={}));var Dt;(function(ve){function Ae(se){return{kind:wi.to(se.kind)}}ve.to=Ae})(Dt||(e.PartialAcceptInfo=Dt={}));var wi;(function(ve){function Ae(se){switch(se){case 0:return l.PartialAcceptTriggerKind.Word;case 1:return l.PartialAcceptTriggerKind.Line;case 2:return l.PartialAcceptTriggerKind.Suggest;default:return l.PartialAcceptTriggerKind.Unknown}}ve.to=Ae})(wi||(e.PartialAcceptTriggerKind=wi={}));var si;(function(ve){function Ae(se,K){return{id:K,label:se.label,description:se.description,canEdit:se.canEdit,collapsibleState:se.collapsibleState||0,contextValue:se.contextValue}}ve.from=Ae})(si||(e.DebugTreeItem=si={}))}),define(Ie[262],Pe([1,0,4,17,8,35]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(v,_){this._proxy=v.getProxy(I.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:N=>_.getDocument(N)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,_,N){const y=new O.SerializableObjectWithBuffers(T.WorkspaceEdit.from(v,this._versionInformationProvider));return this._proxy.$tryApplyWorkspaceEdit(y,void 0,N?.isRefactoring??!1)}};e.ExtHostBulkEdits=A,e.ExtHostBulkEdits=A=Ke([He(0,L.IExtHostRpcService)],A)}),define(Ie[263],Pe([1,0,18,11,44,5,42,6,66,15,2,20,4,8,7,225,26]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class s{constructor(u,t,f,a,p){this._extension=u,this._request=t,this._proxy=f,this._commandsConverter=a,this._sessionDisposables=p,this._stopWatch=v.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let t=function(a){if(u._isClosed){const p=new Error("Response stream has been closed");throw Error.captureStackTrace(p,a),p}};const u=this;this._stopWatch.reset();const f=a=>{typeof this._firstProgress>"u"&&"content"in a&&(this._firstProgress=this._stopWatch.elapsed()),this._proxy.$handleProgressChunk(this._request.requestId,a)};this._apiObject={markdown(a){t(this.markdown);const p=new m.ChatResponseMarkdownPart(a),l=b.ChatResponseMarkdownPart.from(p);return f(l),this},markdownWithVulnerabilities(a,p){t(this.markdown),p&&(0,o.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions");const l=new m.ChatResponseMarkdownWithVulnerabilitiesPart(a,p),D=b.ChatResponseMarkdownWithVulnerabilitiesPart.from(l);return f(D),this},filetree(a,p){t(this.filetree);const l=new m.ChatResponseFileTreePart(a,p),D=b.ChatResponseFilesPart.from(l);return f(D),this},anchor(a,p){t(this.anchor);const l=new m.ChatResponseAnchorPart(a,p),D=b.ChatResponseAnchorPart.from(l);return f(D),this},button(a){t(this.anchor);const p=new m.ChatResponseCommandButtonPart(a),l=b.ChatResponseCommandButtonPart.from(p,u._commandsConverter,u._sessionDisposables);return f(l),this},progress(a){t(this.progress);const p=new m.ChatResponseProgressPart(a),l=b.ChatResponseProgressPart.from(p);return f(l),this},reference(a,p){if(t(this.reference),"variableName"in a&&!a.value){const l=u._request.variables.variables.find(D=>D.name===a.variableName);if(l){let D;if(l.references?.length)D=l.references.map(d=>({kind:"reference",reference:{variableName:a.variableName,value:d.reference}}));else{const d=new m.ChatResponseReferencePart(a,p);D=[b.ChatResponseReferencePart.from(d)]}return D.forEach(d=>f(d)),this}}else{const l=new m.ChatResponseReferencePart(a,p),D=b.ChatResponseReferencePart.from(l);f(D)}return this},textEdit(a,p){t(this.textEdit),(0,o.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions");const l=new m.ChatResponseTextEditPart(a,p),D=b.ChatResponseTextEditPart.from(l);return f(D),this},detectedParticipant(a,p){t(this.detectedParticipant),(0,o.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions");const l=new m.ChatResponseDetectedParticipantPart(a,p),D=b.ChatResponseDetectedParticipantPart.from(l);return f(D),this},push(a){if(t(this.push),(a instanceof m.ChatResponseTextEditPart||a instanceof m.ChatResponseMarkdownWithVulnerabilitiesPart||a instanceof m.ChatResponseDetectedParticipantPart)&&(0,o.checkProposedApiEnabled)(u._extension,"chatParticipantAdditions"),a instanceof m.ChatResponseReferencePart)this.reference(a.value,a.iconPath);else{const p=b.ChatResponsePart.from(a,u._commandsConverter,u._sessionDisposables);f(p)}return this}}}return this._apiObject}}class i extends E.Disposable{static{this._idPool=0}constructor(u,t,f){super(),this._logService=t,this.commands=f,this._agents=new Map,this._sessionDisposables=this._register(new E.DisposableMap),this._completionDisposables=this._register(new E.DisposableStore),this._proxy=u.getProxy(h.MainContext.MainThreadChatAgents2)}transferActiveChat(u){this._proxy.$transferActiveChatSession(u)}createChatAgent(u,t,f){const a=i._idPool++,p=new n(u,t,this._proxy,a,f);return this._agents.set(a,p),this._proxy.$registerAgent(a,u.identifier,t,{},void 0),p.apiAgent}createDynamicChatAgent(u,t,f,a,p){const l=i._idPool++,D=new n(u,t,this._proxy,l,p);return this._agents.set(l,D),this._proxy.$registerAgent(l,u.identifier,t,{isSticky:!0},{name:f,description:a}),D.apiAgent}async $invokeAgent(u,t,f,a){const p=this._agents.get(u);if(!p)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let l=this._sessionDisposables.get(t.sessionId);l||(l=new E.DisposableStore,this._sessionDisposables.set(t.sessionId,l));const D=new s(p.extension,t,this._proxy,this.commands.converter,l);try{const d=await this.prepareHistoryTurns(t.agentId,f),w=p.invoke(b.ChatAgentRequest.to(t),{history:d},D.apiObject,a);return await(0,L.raceCancellation)(Promise.resolve(w).then(g=>{if(g?.metadata)try{JSON.stringify(g.metadata)}catch(C){const S=`result.metadata MUST be JSON.stringify-able. Got error: ${C.message}`;return this._logService.error(`[${p.extension.identifier.value}] [@${p.id}] ${S}`,p.extension),{errorDetails:{message:S},timings:D.timings}}return{errorDetails:g?.errorDetails,timings:D.timings,metadata:g?.metadata}}),a)}catch(d){return this._logService.error(d,p.extension),{errorDetails:{message:(0,T.toErrorMessage)(d),responseIsIncomplete:!0}}}finally{D.close()}}async prepareHistoryTurns(u,t){const f=[];for(const a of t.history){const p=b.ChatAgentResult.to(a.result),l=u===a.request.agentId?p:{...p,metadata:void 0};f.push(new m.ChatRequestTurn(a.request.message,a.request.command,a.request.variables.variables.map(b.ChatAgentResolvedVariable.to),a.request.agentId));const D=(0,I.coalesce)(a.response.map(d=>b.ChatResponsePart.toContent(d,this.commands.converter)));f.push(new m.ChatResponseTurn(D,l,a.request.agentId,a.request.command))}return f}$releaseSession(u){this._sessionDisposables.deleteAndDispose(u)}async $provideFollowups(u,t,f,a,p){const l=this._agents.get(t);if(!l)return Promise.resolve([]);const D=await this.prepareHistoryTurns(l.id,a),d=b.ChatAgentResult.to(f);return(await l.provideFollowups(d,{history:D},p)).filter(w=>{const g=!w.participant||A.Iterable.some(this._agents.values(),C=>C.id===w.participant&&y.ExtensionIdentifier.equals(C.extension.identifier,l.extension.identifier));return g||this._logService.warn(`[@${l.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),g}).map(w=>b.ChatFollowup.from(w,u))}$acceptFeedback(u,t,f,a){const p=this._agents.get(u);if(!p)return;const l=b.ChatAgentResult.to(t);let D;switch(f){case r.InteractiveSessionVoteDirection.Down:D=m.ChatResultFeedbackKind.Unhelpful;break;case r.InteractiveSessionVoteDirection.Up:D=m.ChatResultFeedbackKind.Helpful;break}p.acceptFeedback(Object.freeze(a?{result:l,kind:D,reportIssue:a}:{result:l,kind:D}))}$acceptAction(u,t,f){const a=this._agents.get(u);if(!a||f.action.kind==="vote")return;const p=b.ChatAgentUserActionEvent.to(t,f,this.commands.converter);p&&a.acceptAction(Object.freeze(p))}async $invokeCompletionProvider(u,t,f){const a=this._agents.get(u);return a?(await a.invokeCompletionProvider(t,f)).map(l=>b.ChatAgentCompletionItem.from(l,this.commands.converter,this._completionDisposables)):[]}async $provideWelcomeMessage(u,t,f){const a=this._agents.get(u);if(a)return await a.provideWelcomeMessage(b.ChatLocation.to(t),f)}async $provideSampleQuestions(u,t,f){const a=this._agents.get(u);if(a)return(await a.provideSampleQuestions(b.ChatLocation.to(t),f)).map(p=>b.ChatFollowup.from(p,void 0))}}e.ExtHostChatAgents2=i;class n{constructor(u,t,f,a,p){this.extension=u,this.id=t,this._proxy=f,this._handle=a,this._requestHandler=p,this._onDidReceiveFeedback=new O.Emitter,this._onDidPerformAction=new O.Emitter}acceptFeedback(u){this._onDidReceiveFeedback.fire(u)}acceptAction(u){this._onDidPerformAction.fire(u)}async invokeCompletionProvider(u,t){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(u,t)??[]:[]}async provideFollowups(u,t,f){if(!this._followupProvider)return[];const a=await this._followupProvider.provideFollowups(u,t,f);return a?a.filter(p=>!(p&&"commandId"in p)).filter(p=>!(p&&"message"in p)):[]}async provideWelcomeMessage(u,t){if(!this._welcomeMessageProvider)return[];const f=await this._welcomeMessageProvider.provideWelcomeMessage(u,t);return f?f.map(a=>typeof a=="string"?a:b.MarkdownString.from(a)):[]}async provideSampleQuestions(u,t){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const f=await this._welcomeMessageProvider.provideSampleQuestions(u,t);return f||[]}get apiAgent(){let u=!1,t=!1;const f=()=>{u||t||(t=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof N.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof m.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:b.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:b.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:b.MarkdownString.from(this._helpTextPostfix),sampleRequest:this._sampleRequest,supportIssueReporting:this._supportIssueReporting,requester:this._requester}),t=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._fullName??a.extension.displayName??a.extension.name},set fullName(p){(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._fullName=p,f()},get iconPath(){return a._iconPath},set iconPath(p){a._iconPath=p,f()},get requestHandler(){return a._requestHandler},set requestHandler(p){(0,_.assertType)(typeof p=="function","Invalid request handler"),a._requestHandler=p},get followupProvider(){return a._followupProvider},set followupProvider(p){a._followupProvider=p,f()},get isDefault(){return(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._isDefault},set isDefault(p){(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._isDefault=p,f()},get helpTextPrefix(){return(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._helpTextPrefix},set helpTextPrefix(p){(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._helpTextPrefix=p,f()},get helpTextVariablesPrefix(){return(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._helpTextVariablesPrefix},set helpTextVariablesPrefix(p){(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._helpTextVariablesPrefix=p,f()},get helpTextPostfix(){return(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._helpTextPostfix},set helpTextPostfix(p){(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._helpTextPostfix=p,f()},get isSecondary(){return(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._isSecondary},set isSecondary(p){(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._isSecondary=p,f()},get sampleRequest(){return a._sampleRequest},set sampleRequest(p){a._sampleRequest=p,f()},get supportIssueReporting(){return(0,o.checkProposedApiEnabled)(a.extension,"chatParticipantAdditions"),a._supportIssueReporting},set supportIssueReporting(p){(0,o.checkProposedApiEnabled)(a.extension,"chatParticipantAdditions"),a._supportIssueReporting=p,f()},get onDidReceiveFeedback(){return a._onDidReceiveFeedback.event},set participantVariableProvider(p){if((0,o.checkProposedApiEnabled)(a.extension,"chatParticipantAdditions"),a._agentVariableProvider=p,p){if(!p.triggerCharacters.length)throw new Error("triggerCharacters are required");a._proxy.$registerAgentCompletionsProvider(a._handle,p.triggerCharacters)}else a._proxy.$unregisterAgentCompletionsProvider(a._handle)},get participantVariableProvider(){return(0,o.checkProposedApiEnabled)(a.extension,"chatParticipantAdditions"),a._agentVariableProvider},set welcomeMessageProvider(p){(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._welcomeMessageProvider=p,f()},get welcomeMessageProvider(){return(0,o.checkProposedApiEnabled)(a.extension,"defaultChatParticipant"),a._welcomeMessageProvider},onDidPerformAction:(0,o.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(p){a._requester=p,f()},get requester(){return a._requester},dispose(){u=!0,a._followupProvider=void 0,a._onDidReceiveFeedback.dispose(),a._proxy.$unregisterAgent(a._handle)}}}invoke(u,t,f,a){return this._requestHandler(u,t,f,a)}}}),define(Ie[264],Pe([1,0,14,6,4,8,7,26]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class v{static{this._idPool=0}constructor(y){this._resolver=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadChatVariables)}async $resolveVariable(y,h,b,m){const r=this._resolver.get(y);if(r)try{if(r.resolver.resolve2){(0,E.checkProposedApiEnabled)(r.extension,"chatParticipantAdditions");const o=new _(h,this._proxy),s=await r.resolver.resolve2(r.data.name,{prompt:b},o.apiObject,m);if(s)return s.map(O.ChatVariable.from)}else{const o=await r.resolver.resolve(r.data.name,{prompt:b},m);if(o)return o.map(O.ChatVariable.from)}}catch(o){(0,I.onUnexpectedExternalError)(o)}}registerVariableResolver(y,h,b,m){const r=v._idPool++;return this._resolver.set(r,{extension:y,data:{name:h,description:b},resolver:m}),this._proxy.$registerVariable(r,{name:h,description:b}),(0,L.toDisposable)(()=>{this._resolver.delete(r),this._proxy.$unregisterVariable(r)})}}e.ExtHostChatVariables=v;class _{constructor(y,h){this._requestId=y,this._proxy=h,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let h=function(m){if(y._isClosed){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,m),r}};const y=this,b=m=>{this._proxy.$handleProgressChunk(this._requestId,m)};this._apiObject={progress(m){h(this.progress);const r=new A.ChatResponseProgressPart(m),o=O.ChatResponseProgressPart.from(r);return b(o),this},reference(m){h(this.reference);const r=new A.ChatResponseReferencePart(m),o=O.ChatResponseReferencePart.from(r);return b(o),this},push(m){return h(this.push),m instanceof A.ChatResponseReferencePart?b(O.ChatResponseReferencePart.from(m)):m instanceof A.ChatResponseProgressPart&&b(O.ChatResponseProgressPart.from(m)),this}}}return this._apiObject}}}),define(Ie[265],Pe([1,0,11,69,5,6,2,89,20,8,7,4,26]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=b;function b(m,r,o){const s=m.getProxy(y.MainContext.MainThreadComments);class i{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new v.ExtensionIdentifierMap,r.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const w=this._commentControllers.get(d.handle);return w?w.value:d}else if(d&&d.$mid===7){const w=d,g=this._commentControllers.get(w.commentControlHandle);if(!g)return w;const C=g.getCommentThread(w.commentThreadHandle);return C?C.value:w}else if(d&&(d.$mid===9||d.$mid===8)){const w=this._commentControllers.get(d.thread.commentControlHandle);if(!w)return d;const g=w.getCommentThread(d.thread.commentThreadHandle);return g?d.$mid===8?g.value:{thread:g.value,text:d.text}:d}else if(d&&d.$mid===10){const w=this._commentControllers.get(d.thread.commentControlHandle);if(!w)return d;const g=w.getCommentThread(d.thread.commentThreadHandle);if(!g)return d;const C=d.commentUniqueId,S=g.getCommentByUniqueId(C);return S||d}else if(d&&d.$mid===11){const w=this._commentControllers.get(d.thread.commentControlHandle);if(!w)return d;const g=w.getCommentThread(d.thread.commentThreadHandle);if(!g)return d;const C=d.text,S=d.commentUniqueId,k=g.getCommentByUniqueId(S);return k?(typeof k.body=="string"?k.body=C:k.body=new N.MarkdownString(C),k):d}return d}})}createCommentController(d,w,g){const C=i.handlePool++,S=new c(d,C,w,g);this._commentControllers.set(S.handle,S);const k=this._commentControllersByExtension.get(d.identifier)||[];return k.push(S),this._commentControllersByExtension.set(d.identifier,k),S.value}async $createCommentThreadTemplate(d,w,g){const C=this._commentControllers.get(d);C&&C.$createCommentThreadTemplate(w,g)}async $setActiveComment(d,w){const g=this._commentControllers.get(d);g&&g.$setActiveComment(w??void 0)}async $updateCommentThreadTemplate(d,w,g){const C=this._commentControllers.get(d);C&&C.$updateCommentThreadTemplate(w,g)}$deleteCommentThread(d,w){this._commentControllers.get(d)?.$deleteCommentThread(w)}async $provideCommentingRanges(d,w,g){const C=this._commentControllers.get(d);if(!C||!C.commentingRangeProvider)return Promise.resolve(void 0);const S=await o.ensureDocumentData(A.URI.revive(w));return(0,I.asPromise)(async()=>{const k=await C.commentingRangeProvider.provideCommentingRanges(S.document,g);let P;return Array.isArray(k)?P={ranges:k,fileComments:!1}:k?P={ranges:k.ranges||[],fileComments:k.fileComments||!1}:P=k??void 0,P}).then(k=>{let P;return k&&(P={ranges:k.ranges.map(H=>_.Range.from(H)),fileComments:k.fileComments}),P})}$toggleReaction(d,w,g,C,S){const k=this._commentControllers.get(d);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,I.asPromise)(()=>{const P=k.getCommentThread(w);if(P){const H=P.getCommentByUniqueId(C.uniqueIdInThread);if(k!==void 0&&H&&k.reactionHandler)return k.reactionHandler(H,f(S))}return Promise.resolve(void 0)})}}class n{static{this._handlePool=0}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){(d===void 0!=(this._range===void 0)||!d||!this._range||!d.isEqual(this._range))&&(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(d){this._state=d,typeof d=="object"?((0,h.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=d.resolved,this.modifications.applicability=d.applicability):this.modifications.state=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(d,w,g,C,S,k,P,H){this._commentControllerHandle=w,this._id=g,this._uri=C,this._range=S,this._comments=k,this.extensionDescription=P,this._isTemplate=H,this.handle=n._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputDisposables.value=new O.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),s.$createCommentThread(w,this.handle,this._id,this._uri,_.Range.from(this._range),P.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this._localDisposables.push({dispose:()=>{s.$deleteCommentThread(w,this.handle)}});const $=this;this.value={get uri(){return $.uri},get range(){return $.range},set range(V){$.range=V},get comments(){return $.comments},set comments(V){$.comments=V},get collapsibleState(){return $.collapsibleState},set collapsibleState(V){$.collapsibleState=V},get canReply(){return $.canReply},set canReply(V){$.canReply=V},get contextValue(){return $.contextValue},set contextValue(V){$.contextValue=V},get label(){return $.label},set label(V){$.label=V},get state(){return $.state},set state(V){$.state=V},dispose:()=>{$.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new O.DisposableStore);const d=g=>Object.prototype.hasOwnProperty.call(this.modifications,g),w={};d("range")&&(w.range=_.Range.from(this._range)),d("label")&&(w.label=this.label),d("contextValue")&&(w.contextValue=this.contextValue??null),d("comments")&&(w.comments=this._comments.map(g=>u(this,g,this._commentsMap,this.extensionDescription))),d("collapsibleState")&&(w.collapseState=a(this._collapseState)),d("canReply")&&(w.canReply=this.canReply),d("state")&&(w.state=p(this._state)),d("applicability")&&(w.applicability=l(this._state)),d("isTemplate")&&(w.isTemplate=this._isTemplate),this.modifications={},s.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,w)}getCommentByUniqueId(d){for(const w of this._commentsMap){const g=w[0],C=w[1];if(d===C)return g}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}Ke([(0,L.debounce)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,d?.resourceHints&&(0,h.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,d?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,s.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,h.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,h.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(d,w,g,C){this._extension=d,this._handle=w,this._id=g,this._label=C,this._threads=new Map,s.$registerCommentController(this.handle,g,C,this._extension.identifier.value);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(k){S.options=k},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(k){S.commentingRangeProvider=k},get reactionHandler(){return S.reactionHandler},set reactionHandler(k){S.reactionHandler=k},get activeCommentThread(){return S.activeCommentThread},createCommentThread(k,P,H){return S.createCommentThread(k,P,H).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(d,w,g){w===void 0&&(0,h.checkProposedApiEnabled)(this._extension,"fileComments");const C=new n(this.id,this.handle,void 0,d,w,g,this._extension,!1);return this._threads.set(C.handle,C),C}$setActiveComment(d){if(!d){this._activeComment=void 0,this._activeThread=void 0;return}const w=this._threads.get(d.commentThreadHandle);w&&(this._activeComment=d.uniqueIdInThread?w.getCommentByUniqueId(d.uniqueIdInThread):void 0,this._activeThread=w)}$createCommentThreadTemplate(d,w){const g=new n(this.id,this.handle,void 0,A.URI.revive(d),_.Range.to(w),[],this._extension,!0);return g.collapsibleState=E.CommentThreadCollapsibleState.Expanded,this._threads.set(g.handle,g),g}$updateCommentThreadTemplate(d,w){const g=this._threads.get(d);g&&(g.range=_.Range.to(w))}$deleteCommentThread(d){this._threads.get(d)?.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function u(D,d,w,g){let C=w.get(d);return C||(C=++D.commentHandle,w.set(d,C)),d.state!==void 0&&(0,h.checkProposedApiEnabled)(g,"commentsDraftState"),d.reactions?.some(S=>S.reactors!==void 0)&&(0,h.checkProposedApiEnabled)(g,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:C,body:typeof d.body=="string"?d.body:_.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(S=>t(S)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(D){return{label:D.label,iconPath:D.iconPath?_.pathOrURIToURI(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(d=>d.name):D.reactors}}function f(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?A.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(d=>({name:d}))}}function a(D){if(D!==void 0)switch(D){case N.CommentThreadCollapsibleState.Expanded:return E.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return E.CommentThreadCollapsibleState.Collapsed}return E.CommentThreadCollapsibleState.Collapsed}function p(D){let d;if(typeof D=="object"?d=D.resolved:d=D,d!==void 0)switch(d){case N.CommentThreadState.Unresolved:return E.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return E.CommentThreadState.Resolved}return E.CommentThreadState.Unresolved}function l(D){let d;if(typeof D=="object"&&(d=D.applicability),d!==void 0)switch(d){case N.CommentThreadApplicability.Current:return E.CommentThreadApplicability.Current;case N.CommentThreadApplicability.Outdated:return E.CommentThreadApplicability.Outdated}return E.CommentThreadApplicability.Current}return new i}}),define(Ie[266],Pe([1,0,24,73,6,16,23,2,8,64,76,4,7]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(f,a){this.document=f,this._storagePath=a,this._backupCounter=1,this._edits=new N.Cache("custom documents")}addEdit(f){return this._edits.add([f])}async undo(f,a){await this.getEdit(f).undo(),a||this.disposeBackup()}async redo(f,a){await this.getEdit(f).redo(),a||this.disposeBackup()}disposeEdits(f){for(const a of f)this._edits.delete(a)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const f=u(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,f)}updateBackup(f){this._backup?.delete(),this._backup=f}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(f){const a=this._edits.get(f,0);if(!a)throw new Error("No edit found");return a}}class m{constructor(){this._documents=new Map}get(f,a){return this._documents.get(this.key(f,a))}add(f,a,p){const l=this.key(f,a.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${f} resource:${a.uri}`);const D=new b(a,p);return this._documents.set(l,D),D}delete(f,a){const p=this.key(f,a.uri);this._documents.delete(p)}key(f,a){return`${f}@@@${a}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this._providers=new Map}addTextProvider(f,a,p){return this.add(0,f,a,p)}addCustomProvider(f,a,p){return this.add(1,f,a,p)}get(f){return this._providers.get(f)}add(f,a,p,l){if(this._providers.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this._providers.set(a,{type:f,extension:p,provider:l}),new h.Disposable(()=>this._providers.delete(a))}}class s{constructor(f,a,p,l,D){this._extHostDocuments=a,this._extensionStoragePaths=p,this._extHostWebview=l,this._extHostWebviewPanels=D,this._editorProviders=new o,this._documents=new m,this._proxy=f.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(f,a,p,l){const D=new T.DisposableStore;return n(p)?(D.add(this._editorProviders.addTextProvider(a,f,p)),this._proxy.$registerTextEditorProvider((0,_.toExtensionData)(f),a,l.webviewOptions||{},{supportsMove:!!p.moveCustomTextEditor},(0,_.shouldSerializeBuffersForPostMessage)(f))):(D.add(this._editorProviders.addCustomProvider(a,f,p)),i(p)&&D.add(p.onDidChangeCustomDocument(d=>{const w=this.getCustomDocumentEntry(a,d.document.uri);if(c(d)){const g=w.addEdit(d);this._proxy.$onDidEdit(d.document.uri,a,g,d.label)}else this._proxy.$onContentChange(d.document.uri,a)})),this._proxy.$registerCustomEditorProvider((0,_.toExtensionData)(f),a,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,_.shouldSerializeBuffersForPostMessage)(f))),h.Disposable.from(D,new h.Disposable(()=>{this._proxy.$unregisterEditorProvider(a)}))}async $createCustomDocument(f,a,p,l,D){const d=this._editorProviders.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${a}'`);const w=E.URI.revive(f),g=await d.provider.openCustomDocument(w,{backupId:p,untitledDocumentData:l?.buffer},D);let C;return i(d.provider)&&this._extensionStoragePaths&&(C=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(a,g,C),{editable:i(d.provider)}}async $disposeCustomDocument(f,a){const p=this._editorProviders.get(a);if(!p)throw new Error(`No provider found for '${a}'`);if(p.type!==1)throw new Error(`Invalid provider type for '${a}'`);const l=E.URI.revive(f),{document:D}=this.getCustomDocumentEntry(a,l);this._documents.delete(a,D),D.dispose()}async $resolveCustomEditor(f,a,p,l,D,d){const w=this._editorProviders.get(p);if(!w)throw new Error(`No provider found for '${p}'`);const g=v.ViewColumn.to(D),C=this._extHostWebview.createNewWebview(a,l.contentOptions,w.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(a,p,l.title,g,l.options,C,l.active),k=E.URI.revive(f);switch(w.type){case 1:{const{document:P}=this.getCustomDocumentEntry(p,k);return w.provider.resolveCustomEditor(P,S,d)}case 0:{const P=this._extHostDocuments.getDocument(k);return w.provider.resolveCustomTextEditor(P,S,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,a,p){this.getCustomDocumentEntry(a,f).disposeEdits(p)}async $onMoveCustomEditor(f,a,p){const l=this._editorProviders.get(p);if(!l)throw new Error(`No provider found for '${p}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${p}'`);const D=this._extHostWebviewPanels.getWebviewPanel(f);if(!D)throw new Error("No webview found");const d=E.URI.revive(a),w=this._extHostDocuments.getDocument(d);await l.provider.moveCustomTextEditor(w,D,I.CancellationToken.None)}async $undo(f,a,p,l){return this.getCustomDocumentEntry(a,f).undo(p,l)}async $redo(f,a,p,l){return this.getCustomDocumentEntry(a,f).redo(p,l)}async $revert(f,a,p){const l=this.getCustomDocumentEntry(a,f);await this.getCustomEditorProvider(a).revertCustomDocument(l.document,p),l.disposeBackup()}async $onSave(f,a,p){const l=this.getCustomDocumentEntry(a,f);await this.getCustomEditorProvider(a).saveCustomDocument(l.document,p),l.disposeBackup()}async $onSaveAs(f,a,p,l){const D=this.getCustomDocumentEntry(a,f);return this.getCustomEditorProvider(a).saveCustomDocumentAs(D.document,E.URI.revive(p),l)}async $backup(f,a,p){const l=this.getCustomDocumentEntry(a,f),d=await this.getCustomEditorProvider(a).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},p);return l.updateBackup(d),d.id}getCustomDocumentEntry(f,a){const p=this._documents.get(f,E.URI.revive(a));if(!p)throw new Error("No custom document found");return p}getCustomEditorProvider(f){const p=this._editorProviders.get(f)?.provider;if(!p||!i(p))throw new Error("Custom document is not editable");return p}}e.ExtHostCustomEditors=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const f=t.scheme===O.Schemas.file||t.scheme===O.Schemas.untitled?t.fsPath:t.toString();return(0,L.hash)(f)+""}}),define(Ie[267],Pe([1,0,172,101,2,4,7,8,5,12,28,46]),function(ue,e,I,L,T,O,A,E,v,_,N,y){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class b{#e;#t;#i;constructor(o,s,i,n,c,u,t,f){this._name=o,this._owner=s,this._maxDiagnosticsTotal=i,this._maxDiagnosticsPerFile=n,this._modelVersionIdProvider=c,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(n,i),this.#i=new N.ResourceMap(a=>u.getComparisonKey(a)),this.#e=t,this.#t=f}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,s){if(!o){this.clear();return}this._checkDisposed();let i=[];if(T.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),i=[o]}else if(Array.isArray(o)){i=[];let u;o=[...o].sort(b._compareIndexedTuplesByUri);for(const t of o){const[f,a]=t;if((!u||f.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=f,i.push(f),this.#i.set(f,[])),a)this.#i.get(f)?.push(...a);else{const p=this.#i.get(f);p&&(p.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let c=0;for(const u of i){let t=[];const f=this.#i.get(u);if(f)if(f.length>this._maxDiagnosticsPerFile){t=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(const l of f)if(l.severity===a[p]&&t.push({...E.Diagnostic.from(l),modelVersionId:this._modelVersionIdProvider(u)})===this._maxDiagnosticsPerFile)break e;t.push({severity:L.MarkerSeverity.Info,message:(0,I.localize)(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(a=>({...E.Diagnostic.from(a),modelVersionId:this._modelVersionIdProvider(u)}));if(n.push([u,t]),c+=t.length,c>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,n)}delete(o){this._checkDisposed(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(o,s){this._checkDisposed();for(const[i,n]of this)o.call(s,i,n,this)}*[Symbol.iterator](){this._checkDisposed();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this._checkDisposed();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this.#i.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=b;let m=class{static{h=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*h._maxDiagnosticsPerFile}static _mapper(o){const s=new N.ResourceMap;for(const i of o)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,i,n){this._logService=s,this._fileSystemInfoService=i,this._extHostDocumentsAndEditors=n,this._collections=new Map,this._onDidChangeDiagnostics=new v.DebounceEmitter({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=v.Event.map(this._onDidChangeDiagnostics.event,h._mapper),this._proxy=o.getProxy(O.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{_collections:i,_proxy:n,_onDidChangeDiagnostics:c,_logService:u,_fileSystemInfoService:t,_extHostDocumentsAndEditors:f}=this,a=new class{$changeMany(D,d){n.$changeMany(D,d),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,D,d.length===0?"CLEARING":d)}$clear(D){n.$clear(D),u.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,D)}dispose(){n.dispose()}};let p;if(!s)s="_generated_diagnostic_collection_name_#"+h._idPool++,p=s;else if(!i.has(s))p=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do p=s+h._idPool++;while(i.has(p))}return new class extends b{constructor(){super(s,p,h._maxDiagnosticsTotal,h._maxDiagnosticsPerFile,D=>f.getDocument(D)?.version,t.extUri,a,c),i.set(p,this)}dispose(){super.dispose(),i.delete(p)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const s=new Map,i=[];for(const n of this._collections.values())n.forEach((c,u)=>{let t=s.get(c.toString());typeof t>"u"&&(t=i.length,s.set(c.toString(),t),i.push([c,[]])),i[t][1]=i[t][1].concat(...u)});return i}}_getDiagnostics(o){let s=[];for(const i of this._collections.values())i.has(o)&&(s=s.concat(i.get(o)));return s}$acceptMarkersChange(o){if(!this._mirrorCollection){const s="_generated_mirror",i=new b(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,i),this._mirrorCollection=i}for(const[s,i]of o)this._mirrorCollection.set(T.URI.revive(s),i.map(E.Diagnostic.to))}};e.ExtHostDiagnostics=m,e.ExtHostDiagnostics=m=h=Ke([He(1,_.ILogService),He(2,y.IExtHostFileSystemInfo)],m)}),define(Ie[268],Pe([1,0,2,14,7,8,200,35]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class v{constructor(N,y,h,b={timeout:1500,errors:3}){this._logService=N,this._documents=y,this._mainThreadBulkEdits=h,this._thresholds=b,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(N){return(y,h,b)=>{const r={dispose:this._callbacks.push([y,h,N])};return Array.isArray(b)&&b.push(r),r}}async $participateInSave(N,y){const h=I.URI.revive(N);let b=!1;const m=setTimeout(()=>b=!0,this._thresholds.timeout),r=[];try{for(const o of[...this._callbacks]){if(b)break;const s=this._documents.getDocument(h),i=await this._deliverEventAsyncAndBlameBadListeners(o,{document:s,reason:O.TextDocumentSaveReason.to(y)});r.push(i)}}finally{clearTimeout(m)}return r}_deliverEventAsyncAndBlameBadListeners([N,y,h],b){const m=this._badListeners.get(N);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(h,N,y,b).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this._badListeners.get(N);this._badListeners.set(N,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(N,y,h,b){const m=[],r=Date.now(),{document:o,reason:s}=b,{version:i}=o,n=Object.freeze({document:o,reason:s,waitUntil(c){if(Object.isFrozen(m))throw(0,L.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{y.apply(h,[n])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,u)=>{const t=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(f=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${N.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),c(f)}).catch(f=>{clearTimeout(t),u(f)})}).then(c=>{const u={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(f=>f instanceof T.TextEdit))for(const{newText:f,newEol:a,range:p}of t)u.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:p&&O.Range.from(p),text:f,eol:a&&O.EndOfLine.from(a)}});if(u.edits.length!==0)return i===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new E.SerializableObjectWithBuffers(u)):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=v}),define(Ie[269],Pe([1,0,5,6,2,4,113,8,15,25,7]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(b,m){this._onDidAddDocument=new I.Emitter,this._onDidRemoveDocument=new I.Emitter,this._onDidChangeDocument=new I.Emitter,this._onDidSaveDocument=new I.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(O.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const o of r)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const o of r)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!b)return;const m=this._documentsAndEditors.getDocument(b);if(m)return m}getDocument(b){const m=this.getDocumentData(b);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return m.document}ensureDocumentData(b){const m=this._documentsAndEditors.getDocument(b);if(m)return Promise.resolve(m);let r=this._documentLoader.get(b.toString());return r||(r=this._proxy.$tryOpenDocument(b).then(o=>{this._documentLoader.delete(b.toString());const s=T.URI.revive(o);return(0,v.assertIsDefined)(this._documentsAndEditors.getDocument(s))},o=>(this._documentLoader.delete(b.toString()),Promise.reject(o))),this._documentLoader.set(b.toString(),r)),r}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(m=>T.URI.revive(m))}$acceptModelLanguageChanged(b,m){const r=T.URI.revive(b),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(m),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(b){const m=T.URI.revive(b),r=this._documentsAndEditors.getDocument(m);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(b,m){const r=T.URI.revive(b),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,m,r){const o=T.URI.revive(b),s=this._documentsAndEditors.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(m);let i;m.isUndoing?i=N.TextDocumentChangeReason.Undo:m.isRedoing&&(i=N.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,_.deepFreeze)({document:s.document,contentChanges:m.changes.map(n=>({range:E.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(b,m){(0,A.setWordDefinitionFor)(b,m)}}e.ExtHostDocuments=y}),define(Ie[67],Pe([1,0,270,5,15,2,3,4,17,8,7]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class y{constructor(o,s,i){this._activeTabIdGetter=i,this._parentGroup=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this._apiObject){const o=this,s={get isActive(){return o._dto.id===o._activeTabIdGetter()},get label(){return o._dto.label},get input(){return o._input},get isDirty(){return o._dto.isDirty},get isPinned(){return o._dto.isPinned},get isPreview(){return o._dto.isPreview},get group(){return o._parentGroup.apiObject}};this._apiObject=Object.freeze(s)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(o){this._dto=o,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new N.TextTabInput(O.URI.revive(this._dto.input.uri));case 2:return new N.TextDiffTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified));case 3:return new N.TextMergeTabInput(O.URI.revive(this._dto.input.base),O.URI.revive(this._dto.input.input1),O.URI.revive(this._dto.input.input2),O.URI.revive(this._dto.input.result));case 6:return new N.CustomEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new N.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new N.NotebookEditorTabInput(O.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new N.NotebookDiffEditorTabInput(O.URI.revive(this._dto.input.original),O.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new N.TerminalEditorTabInput;case 9:return new N.InteractiveWindowInput(O.URI.revive(this._dto.input.uri),O.URI.revive(this._dto.input.inputBoxUri));case 10:return new N.ChatEditorTabInput;case 11:return new N.TextMultiDiffTabInput(this._dto.input.diffEditors.map(o=>new N.TextDiffTabInput(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class h{constructor(o,s){this._tabs=[],this._activeTabId="",this._dto=o,this._activeGroupIdGetter=s;for(const i of o.tabs)i.isActive&&(this._activeTabId=i.id),this._tabs.push(new y(i,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const o=this,s={get isActive(){return o._dto.groupId===o._activeGroupIdGetter()},get viewColumn(){return _.ViewColumn.to(o._dto.viewColumn)},get activeTab(){return o._tabs.find(i=>i.tabId===o._activeTabId)?.apiObject},get tabs(){return Object.freeze(o._tabs.map(i=>i.apiObject))}};this._apiObject=Object.freeze(s)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(o){this._dto=o}acceptTabOperation(o){if(o.kind===0){const i=new y(o.tabDto,this,()=>this.activeTabId());return this._tabs.splice(o.index,0,i),o.tabDto.isActive&&(this._activeTabId=i.tabId),i}else if(o.kind===1){const i=this._tabs.splice(o.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return i.tabId===this._activeTabId&&(this._activeTabId=""),i}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this._tabs.splice(o.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this._tabs.splice(o.index,0,i),i}const s=this._tabs.find(i=>i.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this._activeTabId=o.tabDto.id:this._activeTabId===o.tabDto.id&&!o.tabDto.isActive&&(this._activeTabId=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this._activeTabId}}let b=class{constructor(o){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=o.getProxy(E.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const o=this,s={onDidChangeTabGroups:o._onDidChangeTabGroups.event,onDidChangeTabs:o._onDidChangeTabs.event,get all(){return Object.freeze(o._extHostTabGroups.map(i=>i.apiObject))},get activeTabGroup(){const i=o._activeGroupId;return(0,T.assertIsDefined)(o._extHostTabGroups.find(c=>c.groupId===i)?.apiObject)},close:async(i,n)=>{const c=Array.isArray(i)?i:[i];return c.length?m(c[0])?this._closeGroups(c,n):this._closeTabs(c,n):!0}};this._apiObject=Object.freeze(s)}return this._apiObject}$acceptEditorTabModel(o){const s=new Set(this._extHostTabGroups.map(a=>a.groupId)),i=new Set(o.map(a=>a.groupId)),n=(0,I.diffSets)(s,i),c=this._extHostTabGroups.filter(a=>n.removed.includes(a.groupId)).map(a=>a.apiObject),u=[],t=[];this._extHostTabGroups=o.map(a=>{const p=new h(a,()=>this._activeGroupId);return n.added.includes(p.groupId)?u.push(p.apiObject):t.push(p.apiObject),p});const f=(0,T.assertIsDefined)(o.find(a=>a.isActive===!0)?.groupId);f!==void 0&&this._activeGroupId!==f&&(this._activeGroupId=f),this._onDidChangeTabGroups.fire(Object.freeze({opened:u,closed:c,changed:t}))}$acceptTabGroupUpdate(o){const s=this._extHostTabGroups.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this._activeGroupId=o.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this._extHostTabGroups.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(o);switch(o.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}_findExtHostTabFromApi(o){for(const s of this._extHostTabGroups)for(const i of s.tabs)if(i.apiObject===o)return i}_findExtHostTabGroupFromApi(o){return this._extHostTabGroups.find(s=>s.apiObject===o)}async _closeTabs(o,s){const i=[];for(const n of o){const c=this._findExtHostTabFromApi(n);if(!c)throw new Error("Tab close: Invalid tab not found!");i.push(c.tabId)}return this._proxy.$closeTab(i,s)}async _closeGroups(o,s){const i=[];for(const n of o){const c=this._findExtHostTabGroupFromApi(n);if(!c)throw new Error("Group close: Invalid group not found!");i.push(c.groupId)}return this._proxy.$closeGroup(i,s)}};e.ExtHostEditorTabs=b,e.ExtHostEditorTabs=b=Ke([He(0,v.IExtHostRpcService)],b);function m(r){return r.tabs!==void 0}}),define(Ie[271],Pe([1,0,2,4,6,7,8,314,13,21,26,55]),function(ue,e,I,L,T,O,A,E,v,_,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class h{constructor(){this._schemes=[]}add(r){this._stateMachine=void 0,this._schemes.push(r)}delete(r){const o=this._schemes.indexOf(r);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const r=this._schemes.sort(),o=[];let s,i,n=14,c=14;for(const u of r){let t=s?(0,v.commonPrefixLength)(s,u):0;for(t===0?i=1:i=c;t<u.length;t++)t+1===u.length?(n=c,c=9):c+=1,o.push([i,u.toUpperCase().charCodeAt(t),c]),o.push([i,u.toLowerCase().charCodeAt(t),c]),i=c;s=u,c=n}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new E.StateMachine(o)}}provideDocumentLinks(r){this._initStateMachine();const o=[],s=E.LinkComputer.computeLinks({getLineContent(i){return r.lineAt(i-1).text},getLineCount(){return r.lineCount}},this._stateMachine);for(const i of s){const n=A.DocumentLink.to(i);n.target&&o.push(n)}return o}}class b{constructor(r,o){this._extHostLanguageFeatures=o,this._linkProvider=new h,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=r.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(r,o,s,i={}){if(b._validateFileSystemProvider(s),this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(r,"*",this._linkProvider));const n=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(n,s);let c=2;i.isCaseSensitive&&(c+=1024),i.isReadonly&&(c+=2048),typeof s.copy=="function"&&(c+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,N.checkProposedApiEnabled)(r,"fsChunks"),c+=4);let u;i.isReadonly&&(0,y.isMarkdownString)(i.isReadonly)&&i.isReadonly.value!==""&&(u={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this._proxy.$registerFileSystemProvider(n,o,c,u).catch(f=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(f)});const t=s.onDidChangeFile(f=>{const a=[];for(const p of f){const{uri:l,type:D}=p;if(l.scheme!==o)continue;let d;switch(D){case O.FileChangeType.Changed:d=0;break;case O.FileChangeType.Created:d=1;break;case O.FileChangeType.Deleted:d=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:l,type:d})}this._proxy.$onFileSystemChange(n,a)});return(0,T.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(n),this._proxy.$unregisterProvider(n)})}static _validateFileSystemProvider(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(r){const{type:o,ctime:s,mtime:i,size:n,permissions:c}=r;return{type:o,ctime:s,mtime:i,size:n,permissions:c}}$stat(r,o){return Promise.resolve(this._getFsProvider(r).stat(I.URI.revive(o))).then(s=>b._asIStat(s))}$readdir(r,o){return Promise.resolve(this._getFsProvider(r).readDirectory(I.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this._getFsProvider(r).readFile(I.URI.revive(o))).then(s=>_.VSBuffer.wrap(s))}$writeFile(r,o,s,i){return Promise.resolve(this._getFsProvider(r).writeFile(I.URI.revive(o),s.buffer,i))}$delete(r,o,s){return Promise.resolve(this._getFsProvider(r).delete(I.URI.revive(o),s))}$rename(r,o,s,i){return Promise.resolve(this._getFsProvider(r).rename(I.URI.revive(o),I.URI.revive(s),i))}$copy(r,o,s,i){const n=this._getFsProvider(r);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(I.URI.revive(o),I.URI.revive(s),i))}$mkdir(r,o){return Promise.resolve(this._getFsProvider(r).createDirectory(I.URI.revive(o)))}$watch(r,o,s,i){const n=this._getFsProvider(r).watch(I.URI.revive(s),i);this._watches.set(o,n)}$unwatch(r,o){const s=this._watches.get(o);s&&(s.dispose(),this._watches.delete(o))}$open(r,o,s){const i=this._getFsProvider(r);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(o),s))}$close(r,o){const s=this._getFsProvider(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(r,o,s,i){const n=this._getFsProvider(r);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=_.VSBuffer.alloc(i);return Promise.resolve(n.read(o,s,c.buffer,0,i)).then(u=>c.slice(0,u))}$write(r,o,s,i){const n=this._getFsProvider(r);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(o,s,i.buffer,0,i.byteLength))}_getFsProvider(r){const o=this._fsProvider.get(r);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.ExtHostFileSystem=b}),define(Ie[272],Pe([1,0,5,37,2,4,8,7,43]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(b,m,r,o,s,i){this.session=Math.random(),this._onDidCreate=new I.Emitter,this._onDidChange=new I.Emitter,this._onDidDelete=new I.Emitter,this._config=0,i?.ignoreCreateEvents&&(this._config+=1),i?.ignoreChangeEvents&&(this._config+=2),i?.ignoreDeleteEvents&&(this._config+=4);const n=(0,L.parse)(s),c=typeof s=="string",u=i?.correlate,t=o(f=>{if(!(typeof f.session=="number"&&f.session!==this.session)&&!(u&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const a of f.created){const p=T.URI.revive(a);n(p.fsPath)&&(!c||m.getWorkspaceFolder(p))&&this._onDidCreate.fire(p)}if(!i?.ignoreChangeEvents)for(const a of f.changed){const p=T.URI.revive(a);n(p.fsPath)&&(!c||m.getWorkspaceFolder(p))&&this._onDidChange.fire(p)}if(!i?.ignoreDeleteEvents)for(const a of f.deleted){const p=T.URI.revive(a);n(p.fsPath)&&(!c||m.getWorkspaceFolder(p))&&this._onDidDelete.fire(p)}}});this._disposable=E.Disposable.from(this.ensureWatching(b,r,s,i,i?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(b,m,r,o,s){const i=E.Disposable.from();if(typeof r=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return i;const n=b.getProxy(O.MainContext.MainThreadFileSystemEventService);let c=!1;(r.pattern.includes(L.GLOBSTAR)||r.pattern.includes(L.GLOB_SPLIT))&&(c=!0);let u;return s&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(u=14,o?.ignoreChangeEvents&&(u&=-3),o?.ignoreCreateEvents&&(u&=-5),o?.ignoreDeleteEvents&&(u&=-9)),n.$watch(m.identifier.value,this.session,r.baseUri,{recursive:c,excludes:o?.excludes??[],filter:u},!!s),E.Disposable.from({dispose:()=>n.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class N{constructor(b){this._events=b,this.session=this._events.session,this._created=new v.Lazy(()=>this._events.created.map(T.URI.revive)),this._changed=new v.Lazy(()=>this._events.changed.map(T.URI.revive)),this._deleted=new v.Lazy(()=>this._events.deleted.map(T.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class y{constructor(b,m,r){this._mainContext=b,this._logService=m,this._extHostDocumentsAndEditors=r,this._onFileSystemEvent=new I.Emitter,this._onDidRenameFile=new I.Emitter,this._onDidCreateFile=new I.Emitter,this._onDidDeleteFile=new I.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,m,r,o){return new _(this._mainContext,b,m,this._onFileSystemEvent.event,A.GlobPattern.from(r),o)}$onFileEvent(b){this._onFileSystemEvent.fire(new N(b))}$onDidRunFileOperation(b,m){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(r=>({oldUri:T.URI.revive(r.source),newUri:T.URI.revive(r.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(r=>T.URI.revive(r.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:m.map(r=>T.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,m){return(r,o,s)=>{const i=function(c){r.call(o,c)};return i.extension=b,m.event(i,void 0,s)}}async $onWillRunFileOperation(b,m,r,o){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(s=>({oldUri:T.URI.revive(s.source),newUri:T.URI.revive(s.target)}))},r,o);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(s=>T.URI.revive(s.target))},r,o);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(s=>T.URI.revive(s.target))},r,o)}}async _fireWillEvent(b,m,r,o){const s=new Set,i=[];if(await b.fireAsync(m,o,async(c,u)=>{const t=Date.now(),f=await Promise.resolve(c);f instanceof E.WorkspaceEdit&&(i.push([u.extension,f]),s.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>r&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),o.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,c]of i){const{edits:u}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(u)}return{edit:n,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=y}),define(Ie[273],Pe([1,0,18,11,24,14,91,6,25,66,13,15,2,30,315,89,98,174,20,8,7,26,76,4]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class a{constructor(U,M){this._documents=U,this._provider=M}async provideDocumentSymbols(U,M){const W=this._documents.getDocument(U),j=await this._provider.provideDocumentSymbols(W,M);if(!(0,I.isFalsyOrEmpty)(j))return j[0]instanceof c.DocumentSymbol?j.map(n.DocumentSymbol.from):a._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((j,ee)=>{let re=j.location.range.start.compareTo(ee.location.range.start);return re===0&&(re=ee.location.range.end.compareTo(j.location.range.end)),re});const M=[],W=[];for(const j of U){const ee={name:j.name||"!!MISSING: name!!",kind:n.SymbolKind.from(j.kind),tags:j.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:n.Range.from(j.location.range),selectionRange:n.Range.from(j.location.range),children:[]};for(;;){if(W.length===0){W.push(ee),M.push(ee);break}const re=W[W.length-1];if(b.Range.containsRange(re.range,ee.range)&&!b.Range.equalsRange(re.range,ee.range)){re.children?.push(ee),W.push(ee);break}W.pop()}}return M}}class p{constructor(U,M,W,j,ee,re){this._documents=U,this._commands=M,this._provider=W,this._extension=j,this._extTelemetry=ee,this._logService=re,this._cache=new t.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,M){const W=this._documents.getDocument(U),j=await this._provider.provideCodeLenses(W,M);if(!j||M.isCancellationRequested)return;const ee=this._cache.add(j),re=new E.DisposableStore;this._disposables.set(ee,re);const Le={cacheId:ee,lenses:[]};for(let Be=0;Be<j.length;Be++)Le.lenses.push({cacheId:[ee,Be],range:n.Range.from(j[Be].range),command:this._commands.toInternal(j[Be].command,re)});return Le}async resolveCodeLens(U,M){const W=U.cacheId&&this._cache.get(...U.cacheId);if(!W)return;let j;if(typeof this._provider.resolveCodeLens!="function"||W.isResolved?j=W:j=await this._provider.resolveCodeLens(W,M),j||(j=W),M.isCancellationRequested)return;const ee=U.cacheId&&this._disposables.get(U.cacheId[0]);if(ee){if(!j.command){const re=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,re),this._logService.error(re);return}return U.command=this._commands.toInternal(j.command,ee),U}}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}function l(ze){return Array.isArray(ze)?ze.map(n.DefinitionLink.from):ze?[n.DefinitionLink.from(ze)]:[]}class D{constructor(U,M){this._documents=U,this._provider=M}async provideDefinition(U,M,W){const j=this._documents.getDocument(U),ee=n.Position.to(M),re=await this._provider.provideDefinition(j,ee,W);return l(re)}}class d{constructor(U,M){this._documents=U,this._provider=M}async provideDeclaration(U,M,W){const j=this._documents.getDocument(U),ee=n.Position.to(M),re=await this._provider.provideDeclaration(j,ee,W);return l(re)}}class w{constructor(U,M){this._documents=U,this._provider=M}async provideImplementation(U,M,W){const j=this._documents.getDocument(U),ee=n.Position.to(M),re=await this._provider.provideImplementation(j,ee,W);return l(re)}}class g{constructor(U,M){this._documents=U,this._provider=M}async provideTypeDefinition(U,M,W){const j=this._documents.getDocument(U),ee=n.Position.to(M),re=await this._provider.provideTypeDefinition(j,ee,W);return l(re)}}class C{static{this.HOVER_MAP_MAX_SIZE=10}constructor(U,M){this._documents=U,this._provider=M,this._hoverCounter=0,this._hoverMap=new Map}async provideHover(U,M,W,j){const ee=this._documents.getDocument(U),re=n.Position.to(M);let Le;if(W&&W.verbosityRequest){const Je=W.verbosityRequest.previousHover.id,et=this._hoverMap.get(Je);if(!et)throw new Error(`Hover with id ${Je} not found`);const tt={action:W.verbosityRequest.action,previousHover:et};Le=await this._provider.provideHover(ee,re,j,tt)}else Le=await this._provider.provideHover(ee,re,j);if(!Le||(0,I.isFalsyOrEmpty)(Le.contents))return;Le.range||(Le.range=ee.getWordRangeAtPosition(re)),Le.range||(Le.range=new c.Range(re,re));const Be=n.Hover.from(Le),We=this._hoverCounter;if(this._hoverMap.size===C.HOVER_MAP_MAX_SIZE){const Je=Math.min(...this._hoverMap.keys());this._hoverMap.delete(Je)}return this._hoverMap.set(We,Le),this._hoverCounter+=1,{...Be,id:We}}releaseHover(U){this._hoverMap.delete(U)}}class S{constructor(U,M){this._documents=U,this._provider=M}async provideEvaluatableExpression(U,M,W){const j=this._documents.getDocument(U),ee=n.Position.to(M),re=await this._provider.provideEvaluatableExpression(j,ee,W);if(re)return n.EvaluatableExpression.from(re)}}class k{constructor(U,M){this._documents=U,this._provider=M}async provideInlineValues(U,M,W,j){const ee=this._documents.getDocument(U),re=await this._provider.provideInlineValues(ee,n.Range.to(M),n.InlineValueContext.to(W),j);if(Array.isArray(re))return re.map(Le=>n.InlineValue.from(Le))}}class P{constructor(U,M){this._documents=U,this._provider=M}async provideDocumentHighlights(U,M,W){const j=this._documents.getDocument(U),ee=n.Position.to(M),re=await this._provider.provideDocumentHighlights(j,ee,W);if(Array.isArray(re))return re.map(n.DocumentHighlight.from)}}class H{constructor(U,M){this._documents=U,this._provider=M}async provideMultiDocumentHighlights(U,M,W,j){const ee=this._documents.getDocument(U),re=W.map(We=>this._documents.getDocument(We)),Le=n.Position.to(M),Be=await this._provider.provideMultiDocumentHighlights(ee,Le,re,j);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class ${constructor(U,M){this._documents=U,this._provider=M}async provideLinkedEditingRanges(U,M,W){const j=this._documents.getDocument(U),ee=n.Position.to(M),re=await this._provider.provideLinkedEditingRanges(j,ee,W);if(re&&Array.isArray(re.ranges))return{ranges:(0,I.coalesce)(re.ranges.map(n.Range.from)),wordPattern:re.wordPattern}}}class V{constructor(U,M){this._documents=U,this._provider=M}async provideReferences(U,M,W,j){const ee=this._documents.getDocument(U),re=n.Position.to(M),Le=await this._provider.provideReferences(ee,re,W,j);if(Array.isArray(Le))return Le.map(n.location.from)}}class R{static{this._maxCodeActionsPerFile=1e3}constructor(U,M,W,j,ee,re,Le){this._documents=U,this._commands=M,this._diagnostics=W,this._provider=j,this._logService=ee,this._extension=re,this._apiDeprecation=Le,this._cache=new t.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,M,W,j){const ee=this._documents.getDocument(U),re=m.Selection.isISelection(M)?n.Selection.to(M):n.Range.to(M),Le=[];for(const tt of this._diagnostics.getDiagnostics(U))if(re.intersection(tt.range)&&Le.push(tt)>R._maxCodeActionsPerFile)break;const Be={diagnostics:Le,only:W.only?new c.CodeActionKind(W.only):void 0,triggerKind:n.CodeActionTriggerKind.to(W.trigger)},We=await this._provider.provideCodeActions(ee,re,Be,j);if(!(0,I.isNonEmptyArray)(We)||j.isCancellationRequested)return;const Ze=this._cache.add(We),Je=new E.DisposableStore;this._disposables.set(Ze,Je);const et=[];for(let tt=0;tt<We.length;tt++){const it=We[tt];if(it)if(R._isCommand(it))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this._commands.toInternal(it,Je)});else{Be.only&&(it.kind?Be.only.contains(it.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=it.ranges??[];et.push({cacheId:[Ze,tt],title:it.title,command:it.command&&this._commands.toInternal(it.command,Je),diagnostics:it.diagnostics&&it.diagnostics.map(n.Diagnostic.from),edit:it.edit&&n.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,u.isProposedApiEnabled)(this._extension,"codeActionAI")?it.isAI:!1,ranges:(0,u.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,I.coalesce)(at.map(n.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:Ze,actions:et}}async resolveCodeAction(U,M){const[W,j]=U,ee=this._cache.get(W,j);if(!ee||R._isCommand(ee))return{};if(!this._provider.resolveCodeAction)return{};const re=await this._provider.resolveCodeAction(ee,M)??ee;let Le;re.edit&&(Le=n.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const We=this._disposables.get(W);We&&(Be=this._commands.toInternal(re.command,We))}return{edit:Le,command:Be}}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}class z{constructor(U,M,W,j,ee){this._proxy=U,this._documents=M,this._provider=W,this._handle=j,this._extension=ee,this._cache=new t.Cache("DocumentPasteEdit")}async prepareDocumentPaste(U,M,W,j){if(!this._provider.prepareDocumentPaste)return;const ee=this._documents.getDocument(U),re=M.map(We=>n.Range.to(We)),Le=n.DataTransfer.toDataTransfer(W,()=>{throw new O.NotImplementedError});if(await this._provider.prepareDocumentPaste(ee,re,Le,j),j.isCancellationRequested)return;const Be=Array.from(Le).filter(([,We])=>!(We instanceof c.InternalDataTransferItem));return n.DataTransfer.from(Be)}async providePasteEdits(U,M,W,j,ee,re){if(!this._provider.provideDocumentPasteEdits)return[];const Le=this._documents.getDocument(M),Be=W.map(et=>n.Range.to(et)),We=n.DataTransfer.toDataTransfer(j,async et=>(await this._proxy.$resolvePasteFileData(this._handle,U,et)).buffer),Ze=await this._provider.provideDocumentPasteEdits(Le,Be,We,{only:ee.only?new c.DocumentDropOrPasteEditKind(ee.only):void 0,triggerKind:ee.triggerKind},re);if(!Ze||re.isCancellationRequested)return[];const Je=this._cache.add(Ze);return Ze.map((et,tt)=>({_cacheId:[Je,tt],title:et.title??(0,s.localize)(0,null,this._extension.displayName||this._extension.name),kind:et.kind,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,M){const[W,j]=U,ee=this._cache.get(W,j);if(!ee||!this._provider.resolveDocumentPasteEdit)return{};const re=await this._provider.resolveDocumentPasteEdit(ee,M)??ee;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(U){this._cache.delete(U)}}class q{constructor(U,M){this._documents=U,this._provider=M}async provideDocumentFormattingEdits(U,M,W){const j=this._documents.getDocument(U),ee=await this._provider.provideDocumentFormattingEdits(j,M,W);if(Array.isArray(ee))return ee.map(n.TextEdit.from)}}class ie{constructor(U,M){this._documents=U,this._provider=M}async provideDocumentRangeFormattingEdits(U,M,W,j){const ee=this._documents.getDocument(U),re=n.Range.to(M),Le=await this._provider.provideDocumentRangeFormattingEdits(ee,re,W,j);if(Array.isArray(Le))return Le.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,M,W,j){(0,y.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this._documents.getDocument(U),re=M.map(n.Range.to),Le=await this._provider.provideDocumentRangesFormattingEdits(ee,re,W,j);if(Array.isArray(Le))return Le.map(n.TextEdit.from)}}class ce{constructor(U,M){this._documents=U,this._provider=M,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,M,W,j,ee){const re=this._documents.getDocument(U),Le=n.Position.to(M),Be=await this._provider.provideOnTypeFormattingEdits(re,Le,W,j,ee);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class Se{constructor(U,M){this._provider=U,this._logService=M,this._cache=new t.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(U,M){const W=await this._provider.provideWorkspaceSymbols(U,M);if(!(0,I.isNonEmptyArray)(W))return{symbols:[]};const j=this._cache.add(W),ee={cacheId:j,symbols:[]};for(let re=0;re<W.length;re++){const Le=W[re];if(!Le||!Le.name){this._logService.warn("INVALID SymbolInformation",Le);continue}ee.symbols.push({...n.WorkspaceSymbol.from(Le),cacheId:[j,re]})}return ee}async resolveWorkspaceSymbol(U,M){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const W=this._cache.get(...U.cacheId);if(W){const j=await this._provider.resolveWorkspaceSymbol(W,M);return j&&(0,v.mixin)(U,n.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(U){this._cache.delete(U)}}class De{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,M,W){this._documents=U,this._provider=M,this._logService=W}async provideRenameEdits(U,M,W,j){const ee=this._documents.getDocument(U),re=n.Position.to(M);try{const Le=await this._provider.provideRenameEdits(ee,re,W,j);return Le?n.WorkspaceEdit.from(Le):void 0}catch(Le){const Be=De._asMessage(Le);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(U,M,W){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(U),ee=n.Position.to(M);try{const re=await this._provider.prepareRename(j,ee,W);let Le,Be;if(c.Range.isRange(re)?(Le=re,Be=j.getText(re)):(0,y.isObject)(re)&&(Le=re.range,Be=re.placeholder),!Le||!Be)return;if(Le.start.line>ee.line||Le.end.line<ee.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Le),text:Be}}catch(re){const Le=De._asMessage(re);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class fe{static{this.languageTriggerKindToVSCodeTriggerKind={[r.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(U,M,W){this._documents=U,this._provider=M,this._logService=W}async supportsAutomaticNewSymbolNamesTriggerKind(){return this._provider.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,M,W,j){const ee=this._documents.getDocument(U),re=n.Range.to(M);try{const Le=fe.languageTriggerKindToVSCodeTriggerKind[W],Be=await this._provider.provideNewSymbolNames(ee,re,Le,j);return Be?Be.map(We=>typeof We=="string"?{newSymbolName:We}:{newSymbolName:We.newSymbolName,tags:We.tags}):void 0}catch(Le){this._logService.error(fe._asMessage(Le)??JSON.stringify(Le,null,"	"));return}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class pe{constructor(U,M){this.resultId=U,this.tokens=M}}class Ne{constructor(U,M){this._documents=U,this._provider=M,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,M,W){const j=this._documents.getDocument(U),ee=M!==0?this._previousResults.get(M):null;let re=typeof ee?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,ee.resultId,W):await this._provider.provideDocumentSemanticTokens(j,W);return ee&&this._previousResults.delete(M),re?(re=Ne._fixProvidedSemanticTokens(re),this._send(Ne._convertToEdits(ee,re),re)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return Ne._isSemanticTokens(U)?Ne._isCorrectSemanticTokens(U)?U:new c.SemanticTokens(new Uint32Array(U.data),U.resultId):Ne._isSemanticTokensEdits(U)?Ne._isCorrectSemanticTokensEdits(U)?U:new c.SemanticTokensEdits(U.edits.map(M=>new c.SemanticTokensEdit(M.start,M.deleteCount,M.data?new Uint32Array(M.data):M.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const M of U.edits)if(!(M.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,M){if(!Ne._isSemanticTokens(M)||!U||!U.tokens)return M;const W=U.tokens,j=W.length,ee=M.data,re=ee.length;let Le=0;const Be=Math.min(j,re);for(;Le<Be&&W[Le]===ee[Le];)Le++;if(Le===j&&Le===re)return new c.SemanticTokensEdits([],M.resultId);let We=0;const Ze=Be-Le;for(;We<Ze&&W[j-We-1]===ee[re-We-1];)We++;return new c.SemanticTokensEdits([{start:Le,deleteCount:j-Le-We,data:ee.subarray(Le,re-We)}],M.resultId)}_send(U,M){if(Ne._isSemanticTokens(U)){const W=this._nextResultId++;return this._previousResults.set(W,new pe(U.resultId,U.data)),(0,o.encodeSemanticTokensDto)({id:W,type:"full",data:U.data})}if(Ne._isSemanticTokensEdits(U)){const W=this._nextResultId++;return Ne._isSemanticTokens(M)?this._previousResults.set(W,new pe(M.resultId,M.data)):this._previousResults.set(W,new pe(U.resultId)),(0,o.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(U.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class ae{constructor(U,M){this._documents=U,this._provider=M}async provideDocumentRangeSemanticTokens(U,M,W){const j=this._documents.getDocument(U),ee=await this._provider.provideDocumentRangeSemanticTokens(j,n.Range.to(M),W);return ee?this._send(ee):null}_send(U){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}class Re{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,M,W,j,ee){this._documents=U,this._commands=M,this._provider=W,this._apiDeprecation=j,this._extension=ee,this._cache=new t.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(U,M,W,j){const ee=this._documents.getDocument(U),re=n.Position.to(M),Le=ee.getWordRangeAtPosition(re)||new c.Range(re,re),Be=Le.with({end:re}),We=new _.StopWatch,Ze=await this._provider.provideCompletionItems(ee,re,j,n.CompletionContext.to(W));if(!Ze||j.isCancellationRequested)return;const Je=Array.isArray(Ze)?new c.CompletionList(Ze):Ze,et=Re.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),tt=new E.DisposableStore;this._disposables.set(et,tt);const it=[],at={x:et,b:it,a:{replace:n.Range.from(Le),insert:n.Range.from(Be)},c:Je.isIncomplete||void 0,d:We.elapsed()};for(let gt=0;gt<Je.items.length;gt++){const Ue=Je.items[gt],st=this._convertCompletionItem(Ue,[et,gt],Be,Le);it.push(st)}return at}async resolveCompletionItem(U,M){if(typeof this._provider.resolveCompletionItem!="function")return;const W=this._cache.get(...U);if(!W)return;const j=this._convertCompletionItem(W,U),ee=await this._provider.resolveCompletionItem(W,M);if(!ee)return;const re=this._convertCompletionItem(ee,U);return(j.h!==re.h||j.i!==re.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(j.n!==re.n||j.o!==re.o||!(0,v.equals)(j.p,re.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...j,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,M,W,j){const ee=this._disposables.get(M[0]);if(!ee)throw Error("DisposableStore is missing...");const re=this._commands.toInternal(U.command,ee),Le={x:M,a:U.label,b:U.kind!==void 0?n.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(n.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:n.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(n.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=U.textEdit.newText):typeof U.insertText=="string"?Le.h=U.insertText:U.insertText instanceof c.SnippetString&&(Le.h=U.insertText.value,Le.i|=4);let Be;return U.textEdit?Be=U.textEdit.range:U.range&&(Be=U.range),c.Range.isRange(Be)?Le.j=n.Range.from(Be):Be&&(!W?.isEqual(Be.inserting)||!j?.isEqual(Be.replacing))&&(Le.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Le}}class ne{async provideInlineCompletions(U,M,W,j){}disposeCompletions(U){}handleDidShowCompletionItem(U,M,W){}handlePartialAccept(U,M,W,j){}}class x extends ne{constructor(U,M,W,j){super(),this._extension=U,this._documents=M,this._provider=W,this._commands=j,this._references=new be,this._isAdditionsProposedApiEnabled=(0,u.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[r.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,u.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,M,W,j){const ee=this._documents.getDocument(U),re=n.Position.to(M),Le=await this._provider.provideInlineCompletionItems(ee,re,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:n.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[W.triggerKind]},j);if(!Le||j.isCancellationRequested)return;const Be=Array.isArray(Le)?Le:Le.items,We=this._isAdditionsProposedApiEnabled?Array.isArray(Le)?[]:Le.commands||[]:[],Ze=this._isAdditionsProposedApiEnabled&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let Je;return{pid:this._references.createReferenceId({dispose(){Je?.dispose()},items:Be}),items:Be.map((tt,it)=>{let at;tt.command&&(Je||(Je=new E.DisposableStore),at=this._commands.toInternal(tt.command,Je));const gt=tt.insertText;return{insertText:typeof gt=="string"?gt:{snippet:gt.value},filterText:tt.filterText,range:tt.range?n.Range.from(tt.range):void 0,command:at,idx:it,completeBracketPairs:this._isAdditionsProposedApiEnabled?tt.completeBracketPairs:!1}}),commands:We.map(tt=>(Je||(Je=new E.DisposableStore),this._commands.toInternal(tt,Je))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(U){this._references.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,M,W){const j=this._references.get(U)?.items[M];j&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(j,W)}handlePartialAccept(U,M,W,j){const ee=this._references.get(U)?.items[M];ee&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(ee,W),this._provider.handleDidPartiallyAcceptCompletionItem(ee,n.PartialAcceptInfo.to(j)))}}class J{async provideInlineEdits(U,M,W){const j=this._documents.getDocument(U),ee=await this._provider.provideInlineEdit(j,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[M.triggerKind]},W);if(!ee||W.isCancellationRequested)return;let re;const Le=this._references.createReferenceId({dispose(){re?.dispose()},item:ee});let Be;ee.accepted&&(re||(re=new E.DisposableStore),Be=this._commands.toInternal(ee.accepted,re));let We;return ee.rejected&&(re||(re=new E.DisposableStore),We=this._commands.toInternal(ee.rejected,re)),{pid:Le,text:ee.text,range:n.Range.from(ee.range),accepted:Be,rejected:We}}disposeEdit(U){this._references.disposeReferenceId(U)?.dispose()}constructor(U,M,W,j){this._documents=M,this._provider=W,this._commands=j,this._references=new be,this.languageTriggerKindToVSCodeTriggerKind={[r.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class be{constructor(){this._references=new Map,this._idPool=1}createReferenceId(U){const M=this._idPool++;return this._references.set(M,U),M}disposeReferenceId(U){const M=this._references.get(U);return this._references.delete(U),M}get(U){return this._references.get(U)}}class Me{constructor(U,M){this._documents=U,this._provider=M,this._cache=new t.Cache("SignatureHelp")}async provideSignatureHelp(U,M,W,j){const ee=this._documents.getDocument(U),re=n.Position.to(M),Le=this.reviveContext(W),Be=await this._provider.provideSignatureHelp(ee,re,j,Le);if(Be){const We=this._cache.add([Be]);return{...n.SignatureHelp.from(Be),id:We}}}reviveContext(U){let M;if(U.activeSignatureHelp){const W=n.SignatureHelp.to(U.activeSignatureHelp),j=this._cache.get(U.activeSignatureHelp.id,0);j?(M=j,M.activeSignature=W.activeSignature,M.activeParameter=W.activeParameter):M=W}return{...U,activeSignatureHelp:M}}releaseSignatureHelp(U){this._cache.delete(U)}}class ye{constructor(U,M,W,j,ee){this._documents=U,this._commands=M,this._provider=W,this._logService=j,this._extension=ee,this._cache=new t.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(U,M,W){const j=this._documents.getDocument(U),ee=n.Range.to(M),re=await this._provider.provideInlayHints(j,ee,W);if(!Array.isArray(re)||re.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(M)}`);return}if(W.isCancellationRequested)return;const Le=this._cache.add(re);this._disposables.set(Le,new E.DisposableStore);const Be={hints:[],cacheId:Le};for(let We=0;We<re.length;We++)this._isValidInlayHint(re[We],ee)&&Be.hints.push(this._convertInlayHint(re[We],[Le,We]));return this._logService.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(M)}`),Be}async resolveInlayHint(U,M){if(typeof this._provider.resolveInlayHint!="function")return;const W=this._cache.get(...U);if(!W)return;const j=await this._provider.resolveInlayHint(W,M);if(j&&this._isValidInlayHint(j))return this._convertInlayHint(j,U)}releaseHints(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_isValidInlayHint(U,M){return U.label.length===0||Array.isArray(U.label)&&U.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(M&&!M.contains(U.position))}_convertInlayHint(U,M){const W=this._disposables.get(M[0]);if(!W)throw Error("DisposableStore is missing...");const j={label:"",cacheId:M,tooltip:n.MarkdownString.fromStrict(U.tooltip),position:n.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(n.TextEdit.from),kind:U.kind&&n.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")j.label=U.label;else{const ee=[];j.label=ee;for(const re of U.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Le={label:re.value,tooltip:n.MarkdownString.fromStrict(re.tooltip)};c.Location.isLocation(re.location)&&(Le.location=n.location.from(re.location)),re.command&&(Le.command=this._commands.toInternal(re.command,W)),ee.push(Le)}}return j}}class Ee{constructor(U,M){this._documents=U,this._provider=M,this._cache=new t.Cache("DocumentLink")}async provideLinks(U,M){const W=this._documents.getDocument(U),j=await this._provider.provideDocumentLinks(W,M);if(!(!Array.isArray(j)||j.length===0)&&!M.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Ee._validateLink).map(n.DocumentLink.from)};{const ee=this._cache.add(j),re={links:[],cacheId:ee};for(let Le=0;Le<j.length;Le++){if(!Ee._validateLink(j[Le]))continue;const Be=n.DocumentLink.from(j[Le]);Be.cacheId=[ee,Le],re.links.push(Be)}return re}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,M){if(typeof this._provider.resolveDocumentLink!="function")return;const W=this._cache.get(...U);if(!W)return;const j=await this._provider.resolveDocumentLink(W,M);if(!(!j||!Ee._validateLink(j)))return n.DocumentLink.from(j)}releaseLinks(U){this._cache.delete(U)}}class ge{constructor(U,M){this._documents=U,this._provider=M}async provideColors(U,M){const W=this._documents.getDocument(U),j=await this._provider.provideDocumentColors(W,M);return Array.isArray(j)?j.map(re=>({color:n.Color.from(re.color),range:n.Range.from(re.range)})):[]}async provideColorPresentations(U,M,W){const j=this._documents.getDocument(U),ee=n.Range.to(M.range),re=n.Color.to(M.color),Le=await this._provider.provideColorPresentations(re,{document:j,range:ee},W);if(Array.isArray(Le))return Le.map(n.ColorPresentation.from)}}class G{constructor(U,M){this._documents=U,this._provider=M}async provideFoldingRanges(U,M,W){const j=this._documents.getDocument(U),ee=await this._provider.provideFoldingRanges(j,M,W);if(Array.isArray(ee))return ee.map(n.FoldingRange.from)}}class Y{constructor(U,M,W){this._documents=U,this._provider=M,this._logService=W}async provideSelectionRanges(U,M,W){const j=this._documents.getDocument(U),ee=M.map(n.Position.to),re=await this._provider.provideSelectionRanges(j,ee,W);if(!(0,I.isNonEmptyArray)(re))return[];if(re.length!==ee.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let Be=0;Be<ee.length;Be++){const We=[];Le.push(We);let Ze=ee[Be],Je=re[Be];for(;;){if(!Je.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(We.push(n.SelectionRange.from(Je)),!Je.parent)break;Ze=Je.range,Je=Je.parent}}return Le}}class de{constructor(U,M){this._documents=U,this._provider=M,this._idPool=new A.IdGenerator(""),this._cache=new Map}async prepareSession(U,M,W){const j=this._documents.getDocument(U),ee=n.Position.to(M),re=await this._provider.prepareCallHierarchy(j,ee,W);if(!re)return;const Le=this._idPool.nextId();return this._cache.set(Le,new Map),Array.isArray(re)?re.map(Be=>this._cacheAndConvertItem(Le,Be)):[this._cacheAndConvertItem(Le,re)]}async provideCallsTo(U,M,W){const j=this._itemFromCache(U,M);if(!j)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyIncomingCalls(j,W);if(ee)return ee.map(re=>({from:this._cacheAndConvertItem(U,re.from),fromRanges:re.fromRanges.map(Le=>n.Range.from(Le))}))}async provideCallsFrom(U,M,W){const j=this._itemFromCache(U,M);if(!j)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyOutgoingCalls(j,W);if(ee)return ee.map(re=>({to:this._cacheAndConvertItem(U,re.to),fromRanges:re.fromRanges.map(Le=>n.Range.from(Le))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,M){const W=this._cache.get(U),j=n.CallHierarchyItem.from(M,U,W.size.toString(36));return W.set(j._itemId,M),j}_itemFromCache(U,M){return this._cache.get(U)?.get(M)}}class le{constructor(U,M){this._documents=U,this._provider=M,this._idPool=new A.IdGenerator(""),this._cache=new Map}async prepareSession(U,M,W){const j=this._documents.getDocument(U),ee=n.Position.to(M),re=await this._provider.prepareTypeHierarchy(j,ee,W);if(!re)return;const Le=this._idPool.nextId();return this._cache.set(Le,new Map),Array.isArray(re)?re.map(Be=>this._cacheAndConvertItem(Le,Be)):[this._cacheAndConvertItem(Le,re)]}async provideSupertypes(U,M,W){const j=this._itemFromCache(U,M);if(!j)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySupertypes(j,W);if(ee)return ee.map(re=>this._cacheAndConvertItem(U,re))}async provideSubtypes(U,M,W){const j=this._itemFromCache(U,M);if(!j)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySubtypes(j,W);if(ee)return ee.map(re=>this._cacheAndConvertItem(U,re))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,M){const W=this._cache.get(U),j=n.TypeHierarchyItem.from(M,U,W.size.toString(36));return W.set(j._itemId,M),j}_itemFromCache(U,M){return this._cache.get(U)?.get(M)}}class Oe{constructor(U,M,W,j,ee){this._proxy=U,this._documents=M,this._provider=W,this._handle=j,this._extension=ee,this._cache=new t.Cache("DocumentDropEdit")}async provideDocumentOnDropEdits(U,M,W,j,ee){const re=this._documents.getDocument(M),Le=n.Position.to(W),Be=n.DataTransfer.toDataTransfer(j,async et=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,U,et)).buffer),We=await this._provider.provideDocumentDropEdits(re,Le,Be,ee);if(!We)return;const Ze=(0,I.asArray)(We),Je=this._cache.add(Ze);return Ze.map((et,tt)=>({_cacheId:[Je,tt],title:et.title??(0,s.localize)(1,null,this._extension.displayName||this._extension.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,M){const[W,j]=U,ee=this._cache.get(W,j);if(!ee||!this._provider.resolveDocumentDropEdit)return{};const re=await this._provider.resolveDocumentDropEdit(ee,M)??ee;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(U){this._cache.delete(U)}}class he{constructor(U,M){this._documents=U,this._provider=M}async provideMappedEdits(U,M,W,j){const ee=h.URI.revive(U),re=this._documents.getDocument(ee),Le=W.documents.map(Ze=>Ze.map(Je=>({uri:h.URI.revive(Je.uri),version:Je.version,ranges:Je.ranges.map(et=>n.Range.to(et))}))),Be={documents:Le,selections:Le[0]?.[0]?.ranges??[]},We=await this._provider.provideMappedEdits(re,M,Be,j);return We?n.WorkspaceEdit.from(We):null}}class ke{constructor(U,M){this.adapter=U,this.extension=M}}class Te{static{this._handlePool=0}constructor(U,M,W,j,ee,re,Le,Be){this._uriTransformer=M,this._documents=W,this._commands=j,this._diagnostics=ee,this._logService=re,this._apiDeprecation=Le,this._extensionTelemetry=Be,this._adapter=new Map,this._proxy=U.getProxy(f.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(U,M){return n.DocumentSelector.from(U,this._uriTransformer,M)}_createDisposable(U){return new c.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return Te._handlePool++}async _withAdapter(U,M,W,j,ee,re=!1){const Le=this._adapter.get(U);if(!Le||!(Le.adapter instanceof M))return j;const Be=Date.now();re||this._logService.trace(`[${Le.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const We=W(Le.adapter,Le.extension);return Promise.resolve(We).catch(Ze=>{(0,O.isCancellationError)(Ze)||(this._logService.error(`[${Le.extension.identifier.value}] provider FAILED`),this._logService.error(Ze),this._extensionTelemetry.onExtensionError(Le.extension.identifier,Ze))}).finally(()=>{re||this._logService.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),T.CancellationToken.isCancellationToken(ee)?(0,L.raceCancellationError)(We,ee):We}_addNewAdapter(U,M){const W=this._nextHandle();return this._adapter.set(W,new ke(U,M)),W}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,M,W,j){const ee=this._addNewAdapter(new a(this._documents,W),U),re=j&&j.label||Te._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(ee,this._transformDocumentSelector(M,U),re),this._createDisposable(ee)}$provideDocumentSymbols(U,M,W){return this._withAdapter(U,a,j=>j.provideDocumentSymbols(h.URI.revive(M),W),void 0,W)}registerCodeLensProvider(U,M,W){const j=this._nextHandle(),ee=typeof W.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ke(new p(this._documents,this._commands.converter,W,U,this._extensionTelemetry,this._logService),U)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(M,U),ee);let re=this._createDisposable(j);if(ee!==void 0){const Le=W.onDidChangeCodeLenses(Be=>this._proxy.$emitCodeLensEvent(ee));re=c.Disposable.from(re,Le)}return re}$provideCodeLenses(U,M,W){return this._withAdapter(U,p,j=>j.provideCodeLenses(h.URI.revive(M),W),void 0,W)}$resolveCodeLens(U,M,W){return this._withAdapter(U,p,j=>j.resolveCodeLens(M,W),void 0,void 0)}$releaseCodeLenses(U,M){this._withAdapter(U,p,W=>Promise.resolve(W.releaseCodeLenses(M)),void 0,void 0)}registerDefinitionProvider(U,M,W){const j=this._addNewAdapter(new D(this._documents,W),U);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$provideDefinition(U,M,W,j){return this._withAdapter(U,D,ee=>ee.provideDefinition(h.URI.revive(M),W,j),[],j)}registerDeclarationProvider(U,M,W){const j=this._addNewAdapter(new d(this._documents,W),U);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$provideDeclaration(U,M,W,j){return this._withAdapter(U,d,ee=>ee.provideDeclaration(h.URI.revive(M),W,j),[],j)}registerImplementationProvider(U,M,W){const j=this._addNewAdapter(new w(this._documents,W),U);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$provideImplementation(U,M,W,j){return this._withAdapter(U,w,ee=>ee.provideImplementation(h.URI.revive(M),W,j),[],j)}registerTypeDefinitionProvider(U,M,W){const j=this._addNewAdapter(new g(this._documents,W),U);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$provideTypeDefinition(U,M,W,j){return this._withAdapter(U,g,ee=>ee.provideTypeDefinition(h.URI.revive(M),W,j),[],j)}registerHoverProvider(U,M,W,j){const ee=this._addNewAdapter(new C(this._documents,W),U);return this._proxy.$registerHoverProvider(ee,this._transformDocumentSelector(M,U)),this._createDisposable(ee)}$provideHover(U,M,W,j,ee){return this._withAdapter(U,C,re=>re.provideHover(h.URI.revive(M),W,j,ee),void 0,ee)}$releaseHover(U,M){this._withAdapter(U,C,W=>Promise.resolve(W.releaseHover(M)),void 0,void 0)}registerEvaluatableExpressionProvider(U,M,W,j){const ee=this._addNewAdapter(new S(this._documents,W),U);return this._proxy.$registerEvaluatableExpressionProvider(ee,this._transformDocumentSelector(M,U)),this._createDisposable(ee)}$provideEvaluatableExpression(U,M,W,j){return this._withAdapter(U,S,ee=>ee.provideEvaluatableExpression(h.URI.revive(M),W,j),void 0,j)}registerInlineValuesProvider(U,M,W,j){const ee=typeof W.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new k(this._documents,W),U);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(M,U),ee);let Le=this._createDisposable(re);if(ee!==void 0){const Be=W.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(ee));Le=c.Disposable.from(Le,Be)}return Le}$provideInlineValues(U,M,W,j,ee){return this._withAdapter(U,k,re=>re.provideInlineValues(h.URI.revive(M),W,j,ee),void 0,ee)}registerDocumentHighlightProvider(U,M,W){const j=this._addNewAdapter(new P(this._documents,W),U);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}registerMultiDocumentHighlightProvider(U,M,W){const j=this._addNewAdapter(new H(this._documents,W),U);return this._proxy.$registerMultiDocumentHighlightProvider(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$provideDocumentHighlights(U,M,W,j){return this._withAdapter(U,P,ee=>ee.provideDocumentHighlights(h.URI.revive(M),W,j),void 0,j)}$provideMultiDocumentHighlights(U,M,W,j,ee){return this._withAdapter(U,H,re=>re.provideMultiDocumentHighlights(h.URI.revive(M),W,j.map(Le=>h.URI.revive(Le)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,M,W){const j=this._addNewAdapter(new $(this._documents,W),U);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$provideLinkedEditingRanges(U,M,W,j){return this._withAdapter(U,$,async ee=>{const re=await ee.provideLinkedEditingRanges(h.URI.revive(M),W,j);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Te._serializeRegExp(re.wordPattern):void 0}},void 0,j)}registerReferenceProvider(U,M,W){const j=this._addNewAdapter(new V(this._documents,W),U);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$provideReferences(U,M,W,j,ee){return this._withAdapter(U,V,re=>re.provideReferences(h.URI.revive(M),W,j,ee),void 0,ee)}registerCodeActionProvider(U,M,W,j){const ee=new E.DisposableStore,re=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,W,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(M,U),{providedKinds:j?.providedCodeActionKinds?.map(Le=>Le.value),documentation:j?.documentation?.map(Le=>({kind:Le.kind.value,command:this._commands.converter.toInternal(Le.command,ee)}))},Te._extLabel(U),!!W.resolveCodeAction),ee.add(this._createDisposable(re)),ee}$provideCodeActions(U,M,W,j,ee){return this._withAdapter(U,R,re=>re.provideCodeActions(h.URI.revive(M),W,j,ee),void 0,ee)}$resolveCodeAction(U,M,W){return this._withAdapter(U,R,j=>j.resolveCodeAction(M,W),{},void 0)}$releaseCodeActions(U,M){this._withAdapter(U,R,W=>Promise.resolve(W.releaseCodeActions(M)),void 0,void 0)}registerDocumentFormattingEditProvider(U,M,W){const j=this._addNewAdapter(new q(this._documents,W),U);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(M,U),U.identifier,U.displayName||U.name),this._createDisposable(j)}$provideDocumentFormattingEdits(U,M,W,j){return this._withAdapter(U,q,ee=>ee.provideDocumentFormattingEdits(h.URI.revive(M),W,j),void 0,j)}registerDocumentRangeFormattingEditProvider(U,M,W){const j=typeof W.provideDocumentRangesFormattingEdits=="function",ee=this._addNewAdapter(new ie(this._documents,W),U);return this._proxy.$registerRangeFormattingSupport(ee,this._transformDocumentSelector(M,U),U.identifier,U.displayName||U.name,j),this._createDisposable(ee)}$provideDocumentRangeFormattingEdits(U,M,W,j,ee){return this._withAdapter(U,ie,re=>re.provideDocumentRangeFormattingEdits(h.URI.revive(M),W,j,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,M,W,j,ee){return this._withAdapter(U,ie,re=>re.provideDocumentRangesFormattingEdits(h.URI.revive(M),W,j,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,M,W,j){const ee=this._addNewAdapter(new ce(this._documents,W),U);return this._proxy.$registerOnTypeFormattingSupport(ee,this._transformDocumentSelector(M,U),j,U.identifier),this._createDisposable(ee)}$provideOnTypeFormattingEdits(U,M,W,j,ee,re){return this._withAdapter(U,ce,Le=>Le.provideOnTypeFormattingEdits(h.URI.revive(M),W,j,ee,re),void 0,re)}registerWorkspaceSymbolProvider(U,M){const W=this._addNewAdapter(new Se(M,this._logService),U);return this._proxy.$registerNavigateTypeSupport(W,typeof M.resolveWorkspaceSymbol=="function"),this._createDisposable(W)}$provideWorkspaceSymbols(U,M,W){return this._withAdapter(U,Se,j=>j.provideWorkspaceSymbols(M,W),{symbols:[]},W)}$resolveWorkspaceSymbol(U,M,W){return this._withAdapter(U,Se,j=>j.resolveWorkspaceSymbol(M,W),void 0,void 0)}$releaseWorkspaceSymbols(U,M){this._withAdapter(U,Se,W=>W.releaseWorkspaceSymbols(M),void 0,void 0)}registerRenameProvider(U,M,W){const j=this._addNewAdapter(new De(this._documents,W,this._logService),U);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(M,U),De.supportsResolving(W)),this._createDisposable(j)}$provideRenameEdits(U,M,W,j,ee){return this._withAdapter(U,De,re=>re.provideRenameEdits(h.URI.revive(M),W,j,ee),void 0,ee)}$resolveRenameLocation(U,M,W,j){return this._withAdapter(U,De,ee=>ee.resolveRenameLocation(h.URI.revive(M),W,j),void 0,j)}registerNewSymbolNamesProvider(U,M,W){const j=this._addNewAdapter(new fe(this._documents,W,this._logService),U);return this._proxy.$registerNewSymbolNamesProvider(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this._withAdapter(U,fe,M=>M.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,M,W,j,ee){return this._withAdapter(U,fe,re=>re.provideNewSymbolNames(h.URI.revive(M),W,j,ee),void 0,ee)}registerDocumentSemanticTokensProvider(U,M,W,j){const ee=this._addNewAdapter(new Ne(this._documents,W),U),re=typeof W.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ee,this._transformDocumentSelector(M,U),j,re);let Le=this._createDisposable(ee);if(re){const Be=W.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(re));Le=c.Disposable.from(Le,Be)}return Le}$provideDocumentSemanticTokens(U,M,W,j){return this._withAdapter(U,Ne,ee=>ee.provideDocumentSemanticTokens(h.URI.revive(M),W,j),null,j)}$releaseDocumentSemanticTokens(U,M){this._withAdapter(U,Ne,W=>W.releaseDocumentSemanticColoring(M),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,M,W,j){const ee=this._addNewAdapter(new ae(this._documents,W),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ee,this._transformDocumentSelector(M,U),j),this._createDisposable(ee)}$provideDocumentRangeSemanticTokens(U,M,W,j){return this._withAdapter(U,ae,ee=>ee.provideDocumentRangeSemanticTokens(h.URI.revive(M),W,j),null,j)}registerCompletionItemProvider(U,M,W,j){const ee=this._addNewAdapter(new Re(this._documents,this._commands.converter,W,this._apiDeprecation,U),U);return this._proxy.$registerCompletionsProvider(ee,this._transformDocumentSelector(M,U),j,Re.supportsResolving(W),U.identifier),this._createDisposable(ee)}$provideCompletionItems(U,M,W,j,ee){return this._withAdapter(U,Re,re=>re.provideCompletionItems(h.URI.revive(M),W,j,ee),void 0,ee)}$resolveCompletionItem(U,M,W){return this._withAdapter(U,Re,j=>j.resolveCompletionItem(M,W),void 0,W)}$releaseCompletionItems(U,M){this._withAdapter(U,Re,W=>W.releaseCompletionItems(M),void 0,void 0)}registerInlineCompletionsProvider(U,M,W,j){const ee=new x(U,this._documents,W,this._commands.converter),re=this._addNewAdapter(ee,U);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(M,U),ee.supportsHandleEvents,i.ExtensionIdentifier.toKey(U.identifier.value),j?.yieldTo?.map(Le=>i.ExtensionIdentifier.toKey(Le))||[]),this._createDisposable(re)}$provideInlineCompletions(U,M,W,j,ee){return this._withAdapter(U,ne,re=>re.provideInlineCompletions(h.URI.revive(M),W,j,ee),void 0,ee)}$handleInlineCompletionDidShow(U,M,W,j){this._withAdapter(U,ne,async ee=>{ee.handleDidShowCompletionItem(M,W,j)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,M,W,j,ee){this._withAdapter(U,ne,async re=>{re.handlePartialAccept(M,W,j,ee)},void 0,void 0)}$freeInlineCompletionsList(U,M){this._withAdapter(U,ne,async W=>{W.disposeCompletions(M)},void 0,void 0)}registerInlineEditProvider(U,M,W){const j=new J(U,this._documents,W,this._commands.converter),ee=this._addNewAdapter(j,U);return this._proxy.$registerInlineEditProvider(ee,this._transformDocumentSelector(M,U),U.identifier),this._createDisposable(ee)}$provideInlineEdit(U,M,W,j){return this._withAdapter(U,J,ee=>ee.provideInlineEdits(h.URI.revive(M),W,j),void 0,j)}$freeInlineEdit(U,M){this._withAdapter(U,J,async W=>{W.disposeEdit(M)},void 0,void 0)}registerSignatureHelpProvider(U,M,W,j){const ee=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,re=this._addNewAdapter(new Me(this._documents,W),U);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(M,U),ee),this._createDisposable(re)}$provideSignatureHelp(U,M,W,j,ee){return this._withAdapter(U,Me,re=>re.provideSignatureHelp(h.URI.revive(M),W,j,ee),void 0,ee)}$releaseSignatureHelp(U,M){this._withAdapter(U,Me,W=>W.releaseSignatureHelp(M),void 0,void 0)}registerInlayHintsProvider(U,M,W){const j=typeof W.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new ye(this._documents,this._commands.converter,W,this._logService,U),U);this._proxy.$registerInlayHintsProvider(ee,this._transformDocumentSelector(M,U),typeof W.resolveInlayHint=="function",j,Te._extLabel(U));let re=this._createDisposable(ee);if(j!==void 0){const Le=W.onDidChangeInlayHints(Be=>this._proxy.$emitInlayHintsEvent(j));re=c.Disposable.from(re,Le)}return re}$provideInlayHints(U,M,W,j){return this._withAdapter(U,ye,ee=>ee.provideInlayHints(h.URI.revive(M),W,j),void 0,j)}$resolveInlayHint(U,M,W){return this._withAdapter(U,ye,j=>j.resolveInlayHint(M,W),void 0,W)}$releaseInlayHints(U,M){this._withAdapter(U,ye,W=>W.releaseHints(M),void 0,void 0)}registerDocumentLinkProvider(U,M,W){const j=this._addNewAdapter(new Ee(this._documents,W),U);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(M,U),typeof W.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(U,M,W){return this._withAdapter(U,Ee,j=>j.provideLinks(h.URI.revive(M),W),void 0,W,M.scheme==="output")}$resolveDocumentLink(U,M,W){return this._withAdapter(U,Ee,j=>j.resolveLink(M,W),void 0,void 0,!0)}$releaseDocumentLinks(U,M){this._withAdapter(U,Ee,W=>W.releaseLinks(M),void 0,void 0,!0)}registerColorProvider(U,M,W){const j=this._addNewAdapter(new ge(this._documents,W),U);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$provideDocumentColors(U,M,W){return this._withAdapter(U,ge,j=>j.provideColors(h.URI.revive(M),W),[],W)}$provideColorPresentations(U,M,W,j){return this._withAdapter(U,ge,ee=>ee.provideColorPresentations(h.URI.revive(M),W,j),void 0,j)}registerFoldingRangeProvider(U,M,W){const j=this._nextHandle(),ee=typeof W.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ke(new G(this._documents,W),U)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(M,U),U.identifier,ee);let re=this._createDisposable(j);if(ee!==void 0){const Le=W.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ee));re=c.Disposable.from(re,Le)}return re}$provideFoldingRanges(U,M,W,j){return this._withAdapter(U,G,ee=>ee.provideFoldingRanges(h.URI.revive(M),W,j),void 0,j)}registerSelectionRangeProvider(U,M,W){const j=this._addNewAdapter(new Y(this._documents,W,this._logService),U);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$provideSelectionRanges(U,M,W,j){return this._withAdapter(U,Y,ee=>ee.provideSelectionRanges(h.URI.revive(M),W,j),[],j)}registerCallHierarchyProvider(U,M,W){const j=this._addNewAdapter(new de(this._documents,W),U);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$prepareCallHierarchy(U,M,W,j){return this._withAdapter(U,de,ee=>Promise.resolve(ee.prepareSession(h.URI.revive(M),W,j)),void 0,j)}$provideCallHierarchyIncomingCalls(U,M,W,j){return this._withAdapter(U,de,ee=>ee.provideCallsTo(M,W,j),void 0,j)}$provideCallHierarchyOutgoingCalls(U,M,W,j){return this._withAdapter(U,de,ee=>ee.provideCallsFrom(M,W,j),void 0,j)}$releaseCallHierarchy(U,M){this._withAdapter(U,de,W=>Promise.resolve(W.releaseSession(M)),void 0,void 0)}registerTypeHierarchyProvider(U,M,W){const j=this._addNewAdapter(new le(this._documents,W),U);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$prepareTypeHierarchy(U,M,W,j){return this._withAdapter(U,le,ee=>Promise.resolve(ee.prepareSession(h.URI.revive(M),W,j)),void 0,j)}$provideTypeHierarchySupertypes(U,M,W,j){return this._withAdapter(U,le,ee=>ee.provideSupertypes(M,W,j),void 0,j)}$provideTypeHierarchySubtypes(U,M,W,j){return this._withAdapter(U,le,ee=>ee.provideSubtypes(M,W,j),void 0,j)}$releaseTypeHierarchy(U,M){this._withAdapter(U,le,W=>Promise.resolve(W.releaseSession(M)),void 0,void 0)}registerDocumentOnDropEditProvider(U,M,W,j){const ee=this._nextHandle();return this._adapter.set(ee,new ke(new Oe(this._proxy,this._documents,W,ee,U),U)),this._proxy.$registerDocumentOnDropEditProvider(ee,this._transformDocumentSelector(M,U),(0,u.isProposedApiEnabled)(U,"documentPaste")&&j?{supportsResolve:!!W.resolveDocumentDropEdit,dropMimeTypes:j.dropMimeTypes}:void 0),this._createDisposable(ee)}$provideDocumentOnDropEdits(U,M,W,j,ee,re){return this._withAdapter(U,Oe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(M,h.URI.revive(W),j,ee,re)),void 0,void 0)}$resolveDropEdit(U,M,W){return this._withAdapter(U,Oe,j=>j.resolveDropEdit(M,W),{},void 0)}$releaseDropEdits(U,M){this._withAdapter(U,Oe,W=>Promise.resolve(W.releaseDropEdits(M)),void 0,void 0)}registerMappedEditsProvider(U,M,W){const j=this._addNewAdapter(new he(this._documents,W),U);return this._proxy.$registerMappedEditsProvider(j,this._transformDocumentSelector(M,U)),this._createDisposable(j)}$provideMappedEdits(U,M,W,j,ee){return this._withAdapter(U,he,re=>Promise.resolve(re.provideMappedEdits(M,W,j,ee)),null,ee)}registerDocumentPasteEditProvider(U,M,W,j){const ee=this._nextHandle();return this._adapter.set(ee,new ke(new z(this._proxy,this._documents,W,ee,U),U)),this._proxy.$registerPasteEditProvider(ee,this._transformDocumentSelector(M,U),{supportsCopy:!!W.prepareDocumentPaste,supportsPaste:!!W.provideDocumentPasteEdits,supportsResolve:!!W.resolveDocumentPasteEdit,providedPasteEditKinds:j.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:j.copyMimeTypes,pasteMimeTypes:j.pasteMimeTypes}),this._createDisposable(ee)}$prepareDocumentPaste(U,M,W,j,ee){return this._withAdapter(U,z,re=>re.prepareDocumentPaste(h.URI.revive(M),W,j,ee),void 0,ee)}$providePasteEdits(U,M,W,j,ee,re,Le){return this._withAdapter(U,z,Be=>Be.providePasteEdits(M,h.URI.revive(W),j,ee,re,Le),void 0,Le)}$resolvePasteEdit(U,M,W){return this._withAdapter(U,z,j=>j.resolvePasteEdit(M,W),{},void 0)}$releasePasteEdits(U,M){this._withAdapter(U,z,W=>Promise.resolve(W.releasePasteEdits(M)),void 0,void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:U.flags}}static _serializeIndentationRule(U){return{decreaseIndentPattern:Te._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:Te._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Te._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Te._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:Te._serializeRegExp(U.beforeText),afterText:U.afterText?Te._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?Te._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(Te._serializeOnEnterRule)}static _serializeAutoClosingPair(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(M=>c.SyntaxTokenType.toString(M)):void 0}}static _serializeAutoClosingPairs(U){return U.map(Te._serializeAutoClosingPair)}setLanguageConfiguration(U,M,W){const{wordPattern:j}=W;if(j&&(0,N.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(M,j):this._documents.setWordDefinitionFor(M,void 0),W.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),W.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this._nextHandle(),re={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?Te._serializeRegExp(W.wordPattern):void 0,indentationRules:W.indentationRules?Te._serializeIndentationRule(W.indentationRules):void 0,onEnterRules:W.onEnterRules?Te._serializeOnEnterRules(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport,autoClosingPairs:W.autoClosingPairs?Te._serializeAutoClosingPairs(W.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(ee,M,re),this._createDisposable(ee)}$setWordDefinitions(U){for(const M of U)this._documents.setWordDefinitionFor(M.languageId,new RegExp(M.regexSource,M.regexFlags))}}e.ExtHostLanguageFeatures=Te}),define(Ie[90],Pe([1,0,6,4,8,7,103,20,11,5,175,108,14,3,17,86,12,42]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,e.IExtHostLanguageModels=(0,b.createDecorator)("IExtHostLanguageModels");class n{constructor(f,a){this.option=f,this.stream=new v.AsyncIterableSource,this.stream=a??new v.AsyncIterableSource}}class c{constructor(){this._responseStreams=new Map,this._defaultStream=new v.AsyncIterableSource,this._isDone=!1,this._isStreaming=!1;const f=this;this.apiObject={stream:f._defaultStream.asyncIterable}}*_streams(){if(this._responseStreams.size>0)for(const[,f]of this._responseStreams)yield f.stream;else yield this._defaultStream}handleFragment(f){if(this._isDone)return;this._isStreaming=!0;let a=this._responseStreams.get(f.index);a||(this._responseStreams.size===0?a=new n(f.index,this._defaultStream):a=new n(f.index),this._responseStreams.set(f.index,a)),a.stream.emitOne(f.part)}get isStreaming(){return this._isStreaming}reject(f){this._isDone=!0;for(const a of this._streams())a.reject(f)}resolve(){this._isDone=!0;for(const f of this._streams())f.resolve()}}let u=class{static{i=this}static{this._idPool=1}constructor(f,a,p){this._logService=a,this._extHostAuthentication=p,this._onDidChangeModelAccess=new _.Emitter,this._onDidChangeProviders=new _.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new E.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=f.getProxy(L.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(f,a,p,l){const D=i._idPool++;this._languageModels.set(D,{extension:f.identifier,provider:p,languageModelId:a});let d;l.auth&&(d={providerLabel:f.displayName||f.name,accountLabel:typeof l.auth=="object"?l.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(D,a,{extension:f.identifier,identifier:a,name:l.name??"",version:l.version,tokens:l.tokens,auth:d});const w=p.onDidReceiveLanguageModelResponse2?.(({extensionId:g,participant:C,tokenCount:S})=>{this._proxy.$whenLanguageModelChatRequestMade(a,new E.ExtensionIdentifier(g),C,S)});return(0,I.toDisposable)(()=>{this._languageModels.delete(D),this._proxy.$unregisterProvider(D),w?.dispose()})}async $provideLanguageModelResponse(f,a,p,l,D,d){const w=this._languageModels.get(f);if(!w)return;const g=new A.Progress(async C=>{if(d.isCancellationRequested){this._logService.warn(`[CHAT](${w.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(a,{index:C.index,part:C.part})});return w.provider.provideLanguageModelResponse2(l.map(T.LanguageModelMessage.to),D,E.ExtensionIdentifier.toKey(p),g,d)}$provideTokenLength(f,a,p){const l=this._languageModels.get(f);return l?Promise.resolve(l.provider.provideTokenCount(a,p)):Promise.resolve(0)}$updateLanguageModels(f){const a=[],p=[];if(f.added)for(const l of f.added)this._allLanguageModelData.set(l.identifier,l),a.push(l.identifier);if(f.removed)for(const l of f.removed){this._allLanguageModelData.delete(l),p.push(l);for(const[D,d]of this._pendingRequest)d.languageModelId===l&&(d.res.reject(new h.CancellationError),this._pendingRequest.delete(D))}this._onDidChangeProviders.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze(p)})),f.added?.forEach(this._fakeAuthPopulate,this)}getLanguageModelIds(){return Array.from(this._allLanguageModelData.keys())}$updateModelAccesslist(f){const a=new Array;for(const{from:p,to:l,enabled:D}of f){const d=this._modelAccessList.get(p)??new E.ExtensionIdentifierSet;if(d.has(l)!==D){D?d.add(l):d.delete(l),this._modelAccessList.set(p,d);const g={from:p,to:l};a.push(g),this._onDidChangeModelAccess.fire(g)}}}async sendChatRequest(f,a,p,l,D){const d=f.identifier,w=await this._proxy.$prepareChatAccess(d,a,l.justification);if(!w||!this._allLanguageModelData.has(a))throw O.LanguageModelError.NotFound(`Language model '${a}' is unknown.`);if(this._isUsingAuth(d,w)&&(!await this._getAuthAccess(f,{identifier:w.extension,displayName:w.auth.providerLabel},l.justification,l.silent)||!this._modelAccessList.get(d)?.has(w.extension)))throw O.LanguageModelError.NoPermissions(`Language model '${a}' cannot be used by '${d.value}'.`);const g=Math.random()*1e6|0,C=this._proxy.$fetchResponse(d,a,g,p.map(T.LanguageModelMessage.from),l.modelOptions??{},D),S=new v.Barrier,k=new c;this._pendingRequest.set(g,{languageModelId:a,res:k});let P;if(C.catch(H=>{S.isOpen()?k.reject(H):P=H}).finally(()=>{this._pendingRequest.delete(g),k.resolve(),S.open()}),await S.wait(),P)throw new O.LanguageModelError(`Language model '${a}' errored, check cause for more details`,"Unknown",P);return k.apiObject}async $handleResponseFragment(f,a){const p=this._pendingRequest.get(f);p&&p.res.handleFragment(a)}async _getAuthAccess(f,a,p,l){const D=y.INTERNAL_AUTH_PROVIDER_PREFIX+a.identifier.value;if(await this._extHostAuthentication.getSession(f,D,[],{silent:!0}))return this.$updateModelAccesslist([{from:f.identifier,to:a.identifier,enabled:!0}]),!0;if(l)return!1;try{const w=p?(0,N.localize)(0,null,a.displayName,p):(0,N.localize)(1,null,a.displayName);return await this._extHostAuthentication.getSession(f,D,[],{forceNewSession:{detail:w}}),this.$updateModelAccesslist([{from:f.identifier,to:a.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(f,a){return!!a.auth&&!E.ExtensionIdentifier.equals(a.extension,f)}async _fakeAuthPopulate(f){for(const a of this._languageAccessInformationExtensions)try{await this._getAuthAccess(a,{identifier:f.extension,displayName:""},void 0,!0)}catch(p){this._logService.error("Fake Auth request failed"),this._logService.error(p)}}async computeTokenLength(f,a,p){const l=this._allLanguageModelData.get(f);if(!l)throw O.LanguageModelError.NotFound(`Language model '${f}' is unknown.`);const D=s.Iterable.find(this._languageModels.values(),d=>d.languageModelId===f);return D?D.provider.provideTokenCount(a,p):this._proxy.$countTokens(l.identifier,typeof a=="string"?a:T.LanguageModelMessage.from(a),p)}getLanguageModelInfo(f){const a=this._allLanguageModelData.get(f);if(a)return{id:a.identifier,name:a.name,version:a.version,tokens:a.tokens}}createLanguageModelAccessInformation(f){this._languageAccessInformationExtensions.add(f);const a=this,p=_.Event.signal(_.Event.filter(this._onDidChangeModelAccess.event,D=>E.ExtensionIdentifier.equals(D.from,f.identifier))),l=_.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return _.Event.any(p,l)},canSendRequest(D){const d=a._allLanguageModelData.get(D);if(!d)return;if(!a._isUsingAuth(f.identifier,d))return!0;const w=a._modelAccessList.get(f.identifier);if(w)return w.has(d.extension)}}}};e.ExtHostLanguageModels=u,e.ExtHostLanguageModels=u=i=Ke([He(0,m.IExtHostRpcService),He(1,o.ILogService),He(2,r.IExtHostAuthentication)],u)}),define(Ie[274],Pe([1,0,4,8,7,33,11,6,26]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(y,h,b,m){this._documents=h,this._commands=b,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=y.getProxy(I.MainContext.MainThreadLanguages)}$acceptLanguageIds(y){this._languageIds=y}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(y,h){await this._proxy.$changeLanguage(y,h);const b=this._documents.getDocumentData(y);if(!b)throw new Error(`document '${y.toString()}' NOT found`);return b.document}async tokenAtPosition(y,h){const b=y.version,m=L.Position.from(h),r=await this._proxy.$tokensAtPosition(y.uri,m),o={type:T.StandardTokenType.Other,range:y.getWordRangeAtPosition(h)??new T.Range(h.line,h.character,h.line,h.character)};if(!r)return o;const s={range:L.Range.to(r.range),type:L.TokenType.to(r.type)};return!s.range.contains(h)||b!==y.version?o:s}createLanguageStatusItem(y,h,b){const m=this._handlePool++,r=this._proxy,o=this._ids,s=`${y.identifier.value}/${h}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${h}' ALREADY exists`);o.add(s);const i={selector:b,id:h,name:y.displayName??y.name,severity:T.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new E.DisposableStore,u=()=>{if(n?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${h}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,A.disposableTimeout)(()=>{c.clear(),this._proxy.$setLanguageStatus(m,{id:s,name:i.name??y.displayName??y.name,source:y.displayName??y.name,selector:L.DocumentSelector.from(i.selector,this._uriTransformer),label:i.text,detail:i.detail??"",severity:i.severity===T.LanguageStatusSeverity.Error?O.default.Error:i.severity===T.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:i.command&&this._commands.toInternal(i.command,c),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){c.dispose(),n?.dispose(),r.$removeLanguageStatus(m),o.delete(s)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,u()},get selector(){return i.selector},set selector(f){i.selector=f,u()},get text(){return i.text},set text(f){i.text=f,u()},set text2(f){(0,v.checkProposedApiEnabled)(y,"languageStatusText"),i.text=f,u()},get text2(){return(0,v.checkProposedApiEnabled)(y,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,u()},get severity(){return i.severity},set severity(f){i.severity=f,u()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,u()},get command(){return i.command},set command(f){i.command=f,u()},get busy(){return i.busy},set busy(f){i.busy=f,u()}};return u(),t}}e.ExtHostLanguages=_}),define(Ie[275],Pe([1,0,16,2,8,7,85]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class E{constructor(y,h,b,m){this.start=y,this.deletedCount=h,this.deletedItems=b,this.items=m}asApiEvent(){return{range:new O.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class v{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,h,b){this.notebook=y,this._extHostDocument=h,this._cellData=b,this.handle=b.handle,this.uri=L.URI.revive(b.uri),this.cellKind=b.cellKind,this._outputs=b.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=b.internalMetadata??{},this._metadata=Object.freeze(b.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return y._mime},set mime(m){y._mime=m},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}};this._apiCell=Object.freeze(b)}return this._apiCell}setOutputs(y){this._outputs=y.map(T.NotebookCellOutput.to)}setOutputItems(y,h,b){const m=b.map(T.NotebookCellOutputItem.to),r=this._outputs.find(o=>o.id===y);if(r&&(h||(r.items.length=0),r.items.push(...m),r.items.length>1&&r.items.every(o=>A.isTextStreamMime(o.mime)))){const o=new Map,s=[];r.items.forEach(i=>{let n;o.has(i.mime)?n=o.get(i.mime):(n=[],o.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),r.items.length=0,s.forEach(i=>{const n=A.compressOutputItemStreams(o.get(i));r.items.push({mime:i,data:n.data.buffer})})}}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=v;class _{static{this._handlePool=0}constructor(y,h,b,m,r){this._proxy=y,this._textDocumentsAndEditors=h,this._textDocuments=b,this.uri=m,this.handle=_._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=r.viewType,this._metadata=Object.freeze(r.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,r.cells]],!0,void 0),this._versionId=r.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const y=this,h={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===I.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(b){return b=y._validateIndex(b),y._cells[b].apiCell},getCells(b){return(b?y._getCells(b):y._cells).map(r=>r.apiCell)},save(){return y._save()}};this._notebook=Object.freeze(h)}return this._notebook}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,h,b){this._versionId=y.versionId,this._isDirty=h,this.acceptDocumentPropertiesChanged({metadata:b});const m={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},r=[];for(const s of y.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1,m.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this._moveCells(s.index,s.length,s.newIdx,m.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(s.index,s.outputs),r.push({cell:this._cells[s.index].apiCell,outputs:this._cells[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this._cells[s.index].apiCell,outputs:this._cells[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(s.index,s.language),r.push({cell:this._cells[s.index].apiCell,document:this._cells[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this._cells[s.index].apiCell,document:this._cells[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(s.index,s.metadata),r.push({cell:this._cells[s.index].apiCell,metadata:this._cells[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(s.index,s.internalMetadata),r.push({cell:this._cells[s.index].apiCell,executionSummary:this._cells[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<r.length;s++){const i=r[s],n=o.get(i.cell);if(n===void 0){const c=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});o.set(i.cell,c-1)}else m.cellChanges[n]={...m.cellChanges[n],...i}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let h=y.start|0,b=y.end|0;return h<0&&(h=0),b>this._cells.length&&(b=this._cells.length),y.with({start:h,end:b})}_getCells(y){y=this._validateRange(y);const h=[];for(let b=y.start;b<y.end;b++)h.push(this._cells[b]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,h,b){if(this._disposed)return;const m=[],r=[],o=[];if(y.reverse().forEach(s=>{const n=s[2].map(t=>{const f=new v(this,this._textDocumentsAndEditors,t);return h||r.push(v.asModelAddData(t)),f}),c=new E(s[0],s[1],[],n),u=this._cells.splice(s[0],s[1],...n);for(const t of u)o.push(t.uri),c.deletedItems.push(t.apiCell);m.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),b)for(const s of m)b.push(s.asApiEvent())}_moveCells(y,h,b,m){const r=this._cells.splice(y,h);this._cells.splice(b,0,...r);const o=[new E(y,h,r.map(s=>s.apiCell),[]),new E(b,0,[],r)];for(const s of o)m.push(s.asApiEvent())}_setCellOutputs(y,h){this._cells[y].setOutputs(h)}_setCellOutputItems(y,h,b,m){this._cells[y].setOutputItems(h,b,m)}_changeCellLanguage(y,h){const b=this._cells[y];b.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelLanguageChanged(b.uri,h)}_changeCellMime(y,h){const b=this._cells[y];b.apiCell.mime=h}_changeCellMetadata(y,h){this._cells[y].setMetadata(h)}_changeCellInternalMetadata(y,h){this._cells[y].setInternalMetadata(h)}getCellFromApiCell(y){return this._cells.find(h=>h.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(h=>h.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=_}),define(Ie[276],Pe([1,0,5,2,8,7,35]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class E{constructor(_,N,y,h={timeout:1500,errors:3}){this._logService=_,this._notebooksAndEditors=N,this._mainThreadBulkEdits=y,this._thresholds=h,this._onWillSaveNotebookDocumentEvent=new I.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(_){return(N,y,h)=>{const b=function(r){N.call(y,r)};return b.extension=_,this._onWillSaveNotebookDocumentEvent.event(b,void 0,h)}}async $participateInSave(_,N,y){const h=L.URI.revive(_),b=this._notebooksAndEditors.getNotebookDocument(h);if(!b)throw new Error("Unable to resolve notebook document");const m=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:b.apiNotebook,reason:T.TextDocumentSaveReason.to(N)},y,async(o,s)=>{const i=Date.now(),n=await await Promise.resolve(o);Date.now()-i>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!y.isCancellationRequested&&n&&(n instanceof O.WorkspaceEdit?m.push(n):this._logService.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(m.length===0)return!0;const r={edits:[]};for(const o of m){const{edits:s}=T.WorkspaceEdit.from(o);r.edits=r.edits.concat(s)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(new A.SerializableObjectWithBuffers(r))}}e.ExtHostNotebookDocumentSaveParticipant=E}),define(Ie[114],Pe([1,0,14,8,7]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(E,v,_,N,y,h){this.id=E,this._proxy=v,this.notebookData=_,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=y,this._visibleRanges=N,this._viewColumn=h}get apiEditor(){if(!this._editor){const E=this;this._editor={get notebook(){return E.notebookData.apiNotebook},get selection(){return E._selections[0]},set selection(v){this.selections=[v]},get selections(){return E._selections},set selections(v){if(!Array.isArray(v)||!v.every(T.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");E._selections=v,E._trySetSelections(v)},get visibleRanges(){return E._visibleRanges},revealRange(v,_){E._proxy.$tryRevealRange(E.id,L.NotebookRange.from(v),_??T.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn}},O.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(L.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}}e.ExtHostNotebookEditor=O}),define(Ie[277],Pe([1,0,5,12,8]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let O=class{constructor(E,v){this._logService=E,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new I.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(E,v){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,v);const _=this._notebooksAndEditors.getEditorById(E);v.visibleRanges&&_._acceptVisibleRanges(v.visibleRanges.ranges.map(T.NotebookRange.to)),v.selections&&_._acceptSelections(v.selections.selections.map(T.NotebookRange.to)),v.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:_.apiEditor,visibleRanges:_.apiEditor.visibleRanges}),v.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:_.apiEditor,selections:_.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const v in E)this._notebooksAndEditors.getEditorById(v)._acceptViewColumn(T.ViewColumn.to(E[v]))}};e.ExtHostNotebookEditors=O,e.ExtHostNotebookEditors=O=Ke([He(0,L.ILogService)],O)}),define(Ie[278],Pe([1,0,5,4,114]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class O{constructor(E,v){this._extHostNotebook=v,this._rendererMessageEmitters=new Map,this.proxy=E.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(E,v,_){const N=this._extHostNotebook.getEditorById(E);this._rendererMessageEmitters.get(v)?.fire({editor:N.apiEditor,message:_})}createRendererMessaging(E,v){if(!E.contributes?.notebookRenderer?.some(N=>N.id===v))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${v})`);return{onDidReceiveMessage:(N,y,h)=>this.getOrCreateEmitterFor(v).event(N,y,h),postMessage:(N,y)=>{T.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,y]=[y,N]);const h=y&&T.ExtHostNotebookEditor.apiEditorsToExtHost.get(y);return this.proxy.$postMessage(h?.id,v,N)}}}getOrCreateEmitterFor(E){let v=this._rendererMessageEmitters.get(E);return v||(v=new I.Emitter({onDidRemoveLastListener:()=>{v?.dispose(),this._rendererMessageEmitters.delete(E)}}),this._rendererMessageEmitters.set(E,v),v)}}e.ExtHostNotebookRenderers=O}),define(Ie[279],Pe([1,0,8,103,24,69,14]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(y){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=y}async withProgress(y,h,b){const m=this._handles++,{title:r,location:o,cancellable:s}=h,i={label:y.displayName||y.name,id:y.identifier.value};return this._proxy.$startProgress(m,{location:I.ProgressLocation.from(o),title:r,source:i,cancellable:s},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(m,b,!!s)}_withProgress(y,h,b){let m;b&&(m=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(y,m));const r=s=>{this._proxy.$progressEnd(s),this._mapHandleToCancellationSource.delete(s),m?.dispose()};let o;try{o=h(new _(this._proxy,y),b&&m?m.token:T.CancellationToken.None)}catch(s){throw r(y),s}return o.then(s=>r(y),s=>r(y)),o}$acceptProgressCanceled(y){const h=this._mapHandleToCancellationSource.get(y);h&&(h.cancel(),this._mapHandleToCancellationSource.delete(y))}}e.ExtHostProgress=E;function v(N,y){return N.message=y.message,typeof y.increment=="number"&&(typeof N.increment=="number"?N.increment+=y.increment:N.increment=y.increment),N}class _ extends L.Progress{constructor(y,h){super(b=>this.throttledReport(b)),this._proxy=y,this._handle=h}throttledReport(y){this._proxy.$progressReport(this._handle,y)}}Ke([(0,O.throttle)(100,(N,y)=>v(N,y),()=>Object.create(null))],_.prototype,"throttledReport",null)}),define(Ie[280],Pe([1,0,2,4,11,8]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{static{this.handlePool=0}constructor(v,_){this.uriTransformer=_,this.providers=new Map,this.proxy=v.getProxy(L.MainContext.MainThreadQuickDiff)}$provideOriginalResource(v,_,N){const y=I.URI.revive(_),h=this.providers.get(v);return h?(0,T.asPromise)(()=>h.provideOriginalResource(y,N)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(v,_,N,y){const h=A.handlePool++;return this.providers.set(h,_),this.proxy.$registerQuickDiffProvider(h,O.DocumentSelector.from(v,this.uriTransformer),N,y),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(h),this.providers.delete(h)}}}}e.ExtHostQuickDiff=A}),define(Ie[281],Pe([1,0,24,5,6,4,2,7,14,18,33,36,26,8]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=m;function m(r,o,s){const i=r.getProxy(O.MainContext.MainThreadQuickOpen);class n{constructor(d,w){this._sessions=new Map,this._instances=0,this._workspace=d,this._commands=w}showQuickPick(d,w,g,C=I.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(w),k=++this._instances,P=i.$show(k,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},C),H={},$=P.then(()=>H);return Promise.race([$,S]).then(V=>{if(V===H)return;const R=(0,h.isProposedApiEnabled)(d,"quickPickItemTooltip");return S.then(z=>{const q=[];for(let ie=0;ie<z.length;ie++){const ce=z[ie];if(typeof ce=="string")q.push({label:ce,handle:ie});else if(ce.kind===E.QuickPickItemKind.Separator)q.push({type:"separator",label:ce.label});else{ce.tooltip&&!R&&console.warn(`Extension '${d.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`);const Se=ce.iconPath?a(ce.iconPath):void 0;q.push({label:ce.label,iconPath:Se?.iconPath,iconClass:Se?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:R?b.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ie})}}return g&&typeof g.onDidSelectItem=="function"&&(this._onDidSelectItem=ie=>{g.onDidSelectItem(z[ie])}),i.$setItems(k,q),P.then(ie=>{if(typeof ie=="number")return z[ie];if(Array.isArray(ie))return ie.map(ce=>z[ce])})})}).then(void 0,V=>{if(!(0,v.isCancellationError)(V))return i.$setError(k,V),Promise.reject(V)})}$onItemSelected(d){this._onDidSelectItem?.(d)}showInput(d,w=I.CancellationToken.None){return this._validateInput=d?.validateInput,i.$input(d,typeof this._validateInput=="function",w).then(void 0,g=>{if(!(0,v.isCancellationError)(g))return Promise.reject(g)})}async $validateInput(d){if(!this._validateInput)return;const w=await this._validateInput(d);if(!w||typeof w=="string")return w;let g;switch(w.severity){case E.InputBoxValidationSeverity.Info:g=N.default.Info;break;case E.InputBoxValidationSeverity.Warning:g=N.default.Warning;break;case E.InputBoxValidationSeverity.Error:g=N.default.Error;break;default:g=w.message?N.default.Error:N.default.Ignore;break}return{content:w.message,severity:g}}async showWorkspaceFolderPick(d,w=I.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[d]);if(!g)return;const C=await this._workspace.getWorkspaceFolders2();if(C)return C.find(S=>S.uri.toString()===g.uri.toString())}createQuickPick(d){const w=new p(d,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(d){const w=new l(d,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}$onDidChangeValue(d,w){this._sessions.get(d)?._fireDidChangeValue(w)}$onDidAccept(d){this._sessions.get(d)?._fireDidAccept()}$onDidChangeActive(d,w){const g=this._sessions.get(d);g instanceof p&&g._fireDidChangeActive(w)}$onDidChangeSelection(d,w){const g=this._sessions.get(d);g instanceof p&&g._fireDidChangeSelection(w)}$onDidTriggerButton(d,w){this._sessions.get(d)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(d,w,g){const C=this._sessions.get(d);C instanceof p&&C._fireDidTriggerItemButton(w,g)}$onDidHide(d){this._sessions.get(d)?._fireDidHide()}}class c{static{this._nextId=1}constructor(d,w){this._extensionId=d,this._onDidDispose=w,this._id=p._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new L.Emitter,this._onDidChangeValueEmitter=new L.Emitter,this._onDidTriggerButtonEmitter=new L.Emitter,this._onDidHideEmitter=new L.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(d){this._title=d,this.update({title:d})}get step(){return this._steps}set step(d){this._steps=d,this.update({step:d})}get totalSteps(){return this._totalSteps}set totalSteps(d){this._totalSteps=d,this.update({totalSteps:d})}get enabled(){return this._enabled}set enabled(d){this._enabled=d,this.update({enabled:d})}get busy(){return this._busy}set busy(d){this._busy=d,this.update({busy:d})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(d){this._ignoreFocusOut=d,this.update({ignoreFocusOut:d})}get value(){return this._value}set value(d){this._value=d,this.update({value:d})}get placeholder(){return this._placeholder}set placeholder(d){this._placeholder=d,this.update({placeholder:d})}get buttons(){return this._buttons}set buttons(d){this._buttons=d.slice(),this._handlesToButtons.clear(),d.forEach((w,g)=>{const C=w===E.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(C,w)}),this.update({buttons:d.map((w,g)=>({...a(w.iconPath),tooltip:w.tooltip,handle:w===E.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(d){this._value=d,this._onDidChangeValueEmitter.fire(d)}_fireDidTriggerButton(d){const w=this._handlesToButtons.get(d);w&&this._onDidTriggerButtonEmitter.fire(w)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),i.$dispose(this._id))}update(d){if(!this._disposed){for(const w of Object.keys(d)){const g=d[w];this._pendingUpdate[w]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){i.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function u(D){if(D instanceof E.ThemeIcon)return{id:D.id};const d=f(D),w=t(D);return{dark:typeof d=="string"?A.URI.file(d):d,light:typeof w=="string"?A.URI.file(w):w}}function t(D){return typeof D=="object"&&"light"in D?D.light:D}function f(D){return typeof D=="object"&&"dark"in D?D.dark:D}function a(D){const d=u(D);let w,g;return"id"in d?g=y.ThemeIcon.asClassName(d):w=d,{iconPath:w,iconClass:g}}class p extends c{constructor(d,w){super(d.identifier,w),this.extension=d,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new L.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new L.Emitter,this._onDidTriggerItemButtonEmitter=new L.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(d){this._items=d.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),d.forEach((C,S)=>{this._handlesToItems.set(S,C),this._itemsToHandles.set(C,S)});const w=(0,h.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),g=[];for(let C=0;C<d.length;C++){const S=d[C];if(S.kind===E.QuickPickItemKind.Separator)g.push({type:"separator",label:S.label});else{S.tooltip&&!w&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const k=S.iconPath?a(S.iconPath):void 0;g.push({handle:C,label:S.label,iconPath:k?.iconPath,iconClass:k?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:w?b.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((P,H)=>({...a(P.iconPath),tooltip:P.tooltip,handle:H}))})}}this.update({items:g})}get canSelectMany(){return this._canSelectMany}set canSelectMany(d){this._canSelectMany=d,this.update({canSelectMany:d})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(d){this._matchOnDescription=d,this.update({matchOnDescription:d})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(d){this._matchOnDetail=d,this.update({matchOnDetail:d})}get sortByLabel(){return this._sortByLabel}set sortByLabel(d){this._sortByLabel=d,this.update({sortByLabel:d})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(d){this._keepScrollPosition=d,this.update({keepScrollPosition:d})}get activeItems(){return this._activeItems}set activeItems(d){this._activeItems=d.filter(w=>this._itemsToHandles.has(w)),this.update({activeItems:this._activeItems.map(w=>this._itemsToHandles.get(w))})}get selectedItems(){return this._selectedItems}set selectedItems(d){this._selectedItems=d.filter(w=>this._itemsToHandles.has(w)),this.update({selectedItems:this._selectedItems.map(w=>this._itemsToHandles.get(w))})}_fireDidChangeActive(d){const w=(0,_.coalesce)(d.map(g=>this._handlesToItems.get(g)));this._activeItems=w,this._onDidChangeActiveEmitter.fire(w)}_fireDidChangeSelection(d){const w=(0,_.coalesce)(d.map(g=>this._handlesToItems.get(g)));this._selectedItems=w,this._onDidChangeSelectionEmitter.fire(w)}_fireDidTriggerItemButton(d,w){const g=this._handlesToItems.get(d);if(!g||!g.buttons||!g.buttons.length)return;const C=g.buttons[w];C&&this._onDidTriggerItemButtonEmitter.fire({button:C,item:g})}}class l extends c{constructor(d,w){super(d.identifier,w),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(d){this._password=d,this.update({password:d})}get prompt(){return this._prompt}set prompt(d){this._prompt=d,this.update({prompt:d})}get valueSelection(){return this._valueSelection}set valueSelection(d){this._valueSelection=d,this.update({valueSelection:d})}get validationMessage(){return this._validationMessage}set validationMessage(d){this._validationMessage=d,d?typeof d=="string"?this.update({validationMessage:d,severity:N.default.Error}):this.update({validationMessage:d.message,severity:d.severity??N.default.Error}):this.update({validationMessage:void 0,severity:N.default.Ignore})}}return new n(o,s)}}),define(Ie[282],Pe([1,0,2,5,69,6,11,4,18,149,12,20,36,8,26,16,22]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function i(k){return k instanceof I.URI}function n(k,P){return k.scheme===r.Schemas.file&&P.scheme===r.Schemas.file&&o.isLinux?k.toString()===P.toString():k.toString().toLowerCase()===P.toString().toLowerCase()}function c(k){if(k)return typeof k.iconPath=="string"?I.URI.file(k.iconPath):I.URI.isUri(k.iconPath)||h.ThemeIcon.isThemeIcon(k.iconPath)?k.iconPath:void 0}function u(k){if(k.icon){if(I.URI.isUri(k.icon))return k.icon;if(h.ThemeIcon.isThemeIcon(k.icon))return k.icon;{const P=k.icon;return{light:P.light,dark:P.dark}}}else return}function t(k,P){if(!k.iconPath&&!P.iconPath)return 0;if(k.iconPath){if(!P.iconPath)return 1}else return-1;const H=typeof k.iconPath=="string"?k.iconPath:I.URI.isUri(k.iconPath)?k.iconPath.fsPath:k.iconPath.id,$=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,_.comparePaths)(H,$)}function f(k,P){let H=0;if(k.strikeThrough!==P.strikeThrough)return k.strikeThrough?1:-1;if(k.faded!==P.faded)return k.faded?1:-1;if(k.tooltip!==P.tooltip)return(k.tooltip||"").localeCompare(P.tooltip||"");if(H=t(k,P),H!==0)return H;if(k.light&&P.light)H=t(k.light,P.light);else{if(k.light)return 1;if(P.light)return-1}if(H!==0)return H;if(k.dark&&P.dark)H=t(k.dark,P.dark);else{if(k.dark)return 1;if(P.dark)return-1}return H}function a(k,P){if(k.command!==P.command)return k.command<P.command?-1:1;if(k.title!==P.title)return k.title<P.title?-1:1;if(k.tooltip!==P.tooltip){if(k.tooltip!==void 0&&P.tooltip!==void 0)return k.tooltip<P.tooltip?-1:1;if(k.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(k.arguments===P.arguments)return 0;if(k.arguments)if(P.arguments){if(k.arguments.length!==P.arguments.length)return k.arguments.length-P.arguments.length}else return 1;else return-1;for(let H=0;H<k.arguments.length;H++){const $=k.arguments[H],V=P.arguments[H];if($!==V&&!(i($)&&i(V)&&n($,V)))return $<V?-1:1}return 0}function p(k,P){let H=(0,_.comparePaths)(k.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(H!==0)return H;if(k.command&&P.command)H=a(k.command,P.command);else{if(k.command)return 1;if(P.command)return-1}if(H!==0)return H;if(k.decorations&&P.decorations)H=f(k.decorations,P.decorations);else{if(k.decorations)return 1;if(P.decorations)return-1}if(k.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)H=(0,_.comparePaths)(k.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(k.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(k.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)H=(0,_.comparePaths)(k.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(k.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return H}function l(k,P){for(let H=0;H<k.length;H++)if(k[H]!==P[H])return!1;return!0}function D(k,P){return k.command===P.command&&k.title===P.title&&k.tooltip===P.tooltip&&(k.arguments&&P.arguments?l(k.arguments,P.arguments):k.arguments===P.arguments)}function d(k,P){return(0,v.equals)(k,P,D)}class w{#e;#t;get value(){return this._value}set value(P){P=P??"",this.#e.$setInputBoxValue(this._sourceControlHandle,P),this.updateValue(P)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(P){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,P),this._placeholder=P}get validateInput(){return(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(P){if((0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=P,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!P)}get enabled(){return this._enabled}set enabled(P){P=!!P,this._enabled!==P&&(this._enabled=P,this.#e.$setInputBoxEnablement(this._sourceControlHandle,P))}get visible(){return this._visible}set visible(P){P=!!P,this._visible!==P&&(this._visible=P,this.#e.$setInputBoxVisibility(this._sourceControlHandle,P))}get document(){return(0,m.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(P,H,$,V,R){this._extension=P,this._sourceControlHandle=V,this._documentUri=R,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=H,this.#e=$}showValidationMessage(P,H){(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,P,H)}$onInputBoxValueChange(P){this.updateValue(P)}updateValue(P){this._value=P,this._onDidChange.fire(P)}}e.ExtHostSCMInputBox=w;class g{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(P){this._label=P,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,P)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(P){this._hideWhenEmpty=P,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(P){this._resourceStates=[...P],this._onDidUpdateResourceStates.fire()}constructor(P,H,$,V,R,z,q){this._proxy=P,this._commands=H,this._sourceControlHandle=$,this._id=V,this._label=R,this.multiDiffEditorEnableViewChanges=z,this._extension=q,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=g._handlePool++}getResourceState(P){return this._resourceStatesMap.get(P)}$executeResourceCommand(P,H){const $=this._resourceStatesCommandsMap.get(P);return $?(0,A.asPromise)(()=>this._commands.executeCommand($.command,...$.arguments||[],H)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this._resourceStates].sort(p),$=(0,v.sortedDiff)(this._resourceSnapshot,P,p).map(z=>{const q=z.toInsert.map(ie=>{const ce=this._resourceHandlePool++;this._resourceStatesMap.set(ce,ie);const Se=ie.resourceUri;let De;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const ge=new O.DisposableStore;De=this._commands.converter.toInternal(ie.command,ge),this._resourceStatesDisposablesMap.set(ce,ge)}else this._resourceStatesCommandsMap.set(ce,ie.command);const fe=(0,m.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),pe=fe?ie.multiDiffEditorOriginalUri:void 0,Ne=fe?ie.multiFileDiffEditorModifiedUri:void 0,ae=c(ie.decorations),Re=ie.decorations&&c(ie.decorations.light)||ae,ne=ie.decorations&&c(ie.decorations.dark)||ae,x=[Re,ne],J=ie.decorations&&ie.decorations.tooltip||"",be=ie.decorations&&!!ie.decorations.strikeThrough,Me=ie.decorations&&!!ie.decorations.faded,ye=ie.contextValue||"";return{rawResource:[ce,Se,x,J,be,Me,ye,De,pe,Ne],handle:ce}});return{start:z.start,deleteCount:z.deleteCount,toInsert:q}}),V=$.map(({start:z,deleteCount:q,toInsert:ie})=>[z,q,ie.map(ce=>ce.rawResource)]),R=$.reverse();for(const{start:z,deleteCount:q,toInsert:ie}of R){const ce=ie.map(De=>De.handle),Se=this._handlesSnapshot.splice(z,q,...ce);for(const De of Se)this._resourceStatesMap.delete(De),this._resourceStatesCommandsMap.delete(De),this._resourceStatesDisposablesMap.get(De)?.dispose(),this._resourceStatesDisposablesMap.delete(De)}return this._resourceSnapshot=P,V}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class C{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(P){this._count!==P&&(this._count=P,this.#e.$updateSourceControl(this.handle,{count:P}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(P){this._quickDiffProvider=P;let H;(0,m.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(H=P?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!P,quickDiffLabel:H})}get historyProvider(){return(0,m.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(P){(0,m.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=P,this._historyProviderDisposable.value=new O.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!P}),P&&this._historyProviderDisposable.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(P){P!==this._commitTemplate&&(this._commitTemplate=P,this.#e.$updateSourceControl(this.handle,{commitTemplate:P}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(P){this._acceptInputDisposables.value=new O.DisposableStore,this._acceptInputCommand=P;const H=this._commands.converter.toInternal(P,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:H})}get actionButton(){return(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(P){(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new O.DisposableStore,this._actionButton=P;const H=P!==void 0?{command:this._commands.converter.toInternal(P.command,this._actionButtonDisposables.value),secondaryCommands:P.secondaryCommands?.map($=>$.map(V=>this._commands.converter.toInternal(V,this._actionButtonDisposables.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:H??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(P){if(this._statusBarCommands&&P&&d(this._statusBarCommands,P))return;this._statusBarDisposables.value=new O.DisposableStore,this._statusBarCommands=P;const H=(P||[]).map($=>this._commands.converter.toInternal($,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:H})}get selected(){return this._selected}constructor(P,H,$,V,R,z,q){this._extension=P,this._commands=V,this._id=R,this._label=z,this._rootUri=q,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new O.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new O.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new O.MutableDisposable,this._statusBarDisposables=new O.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=C._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=$;const ie=I.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${R}/scm${this.handle}/input`,query:q?`rootUri=${encodeURIComponent(q.toString())}`:void 0});this._inputBox=new w(P,H,this.#e,this.handle,ie),this.#e.$registerSourceControl(this.handle,R,z,q,ie)}createResourceGroup(P,H,$){const V=(0,m.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&$?.multiDiffEditorEnableViewChanges===!0,R=new g(this.#e,this._commands,this.handle,P,H,V,this._extension),z=L.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,z),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const P=[],H=[];for(const[$,V]of this.createdResourceGroups){V.dispose();const R=$.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add($),this.eventuallyUpdateResourceStates()});L.Event.once($.onDidDispose)(()=>{this.updatedResourceGroups.delete($),R.dispose(),this._groups.delete($.handle),this.#e.$unregisterGroup(this.handle,$.handle)}),P.push([$.handle,$.id,$.label,$.features,$.multiDiffEditorEnableViewChanges]);const z=$._takeResourceStateSnapshot();z.length>0&&H.push([$.handle,z]),this._groups.set($.handle,$)}this.#e.$registerGroups(this.handle,P,H),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const P=[];this.updatedResourceGroups.forEach(H=>{const $=H._takeResourceStateSnapshot();$.length!==0&&P.push([H.handle,$])}),P.length>0&&this.#e.$spliceResourceStates(this.handle,P),this.updatedResourceGroups.clear()}getResourceGroup(P){return this._groups.get(P)}setSelectionState(P){this._selected=P,this._onDidChangeSelection.fire(P)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ke([(0,T.debounce)(100)],C.prototype,"eventuallyAddResourceGroups",null),Ke([(0,T.debounce)(100)],C.prototype,"eventuallyUpdateResourceStates",null);let S=class{static{s=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(P,H,$,V){this._commands=H,this._extHostDocuments=$,this.logService=V,this._sourceControls=new Map,this._sourceControlsByExtension=new y.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=P.getProxy(E.MainContext.MainThreadSCM),this._telemetry=P.getProxy(E.MainContext.MainThreadTelemetry),H.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const z=this._sourceControls.get(R.sourceControlHandle);if(!z)return R;const q=z.getResourceGroup(R.groupHandle);return q?q.getResourceState(R.handle):R}else if(R&&R.$mid===4){const z=this._sourceControls.get(R.sourceControlHandle);return z?z.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const z=this._sourceControls.get(R.handle);return z||R}return R}})}createSourceControl(P,H,$,V){this.logService.trace("ExtHostSCM#createSourceControl",P.identifier.value,H,$,V),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const R=s._handlePool++,z=new C(P,this._extHostDocuments,this._proxy,this._commands,H,$,V);this._sourceControls.set(R,z);const q=this._sourceControlsByExtension.get(P.identifier)||[];return q.push(z),this._sourceControlsByExtension.set(P.identifier,q),z}getLastInputBox(P){this.logService.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const H=this._sourceControlsByExtension.get(P.identifier),$=H&&H[H.length-1];return $&&$.inputBox}$provideOriginalResource(P,H,$){const V=I.URI.revive(H);this.logService.trace("ExtHostSCM#$provideOriginalResource",P,V.toString());const R=this._sourceControls.get(P);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(V,$)).then(z=>z||null)}$onInputBoxValueChange(P,H){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",P);const $=this._sourceControls.get(P);return $&&$.inputBox.$onInputBoxValueChange(H),Promise.resolve(void 0)}$executeResourceCommand(P,H,$,V){this.logService.trace("ExtHostSCM#$executeResourceCommand",P,H,$);const R=this._sourceControls.get(P);if(!R)return Promise.resolve(void 0);const z=R.getResourceGroup(H);return z?z.$executeResourceCommand($,V):Promise.resolve(void 0)}$validateInput(P,H,$){this.logService.trace("ExtHostSCM#$validateInput",P);const V=this._sourceControls.get(P);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>V.inputBox.validateInput(H,$)).then(R=>{if(!R)return Promise.resolve(void 0);const z=b.MarkdownString.fromStrict(R.message);return z?Promise.resolve([z,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this._sourceControls.get(P)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,H,$,V){return await this._sourceControls.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(H,$,V)??void 0}async $provideHistoryItems(P,H,$,V){return(await this._sourceControls.get(P)?.historyProvider?.provideHistoryItems(H,$,V))?.map(q=>({...q,icon:u(q)}))??void 0}async $provideHistoryItemSummary(P,H,$,V){const R=this._sourceControls.get(P)?.historyProvider;if(typeof R?.provideHistoryItemSummary!="function")return;const z=await R.provideHistoryItemSummary(H,$,V);return z?{...z,icon:u(z)}:void 0}async $provideHistoryItemChanges(P,H,$,V){return await this._sourceControls.get(P)?.historyProvider?.provideHistoryItemChanges(H,$,V)??void 0}};e.ExtHostSCM=S,e.ExtHostSCM=S=s=Ke([He(3,N.ILogService)],S)}),define(Ie[283],Pe([1,0,4,8,2]),function(ue,e,I,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class O{static{this.handlePool=0}constructor(E,v){this.uriTransformer=v,this.providers=new Map,this.proxy=E.getProxy(I.MainContext.MainThreadShare)}async $provideShare(E,v,_){return await this.providers.get(E)?.provideShare({selection:L.Range.to(v.selection),resourceUri:T.URI.revive(v.resourceUri)},_)??void 0}registerShareProvider(E,v){const _=O.handlePool++;return this.providers.set(_,v),this.proxy.$registerShareProvider(_,L.DocumentSelector.from(E,this.uriTransformer),v.id,v.label,v.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(_),this.providers.delete(_)}}}}e.ExtHostShare=O}),define(Ie[284],Pe([1,0,7,4,178,6,8,15]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class v{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new I.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(h,b,m,r,o,s=I.StatusBarAlignment.Left,i){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new O.DisposableStore,this.#e=h,this.#t=b,o&&r){this._entryId=(0,I.asStatusBarItemIdentifier)(r.identifier,o);const n=m.get(this._entryId);n&&(s=n.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=n.priority,this._visible=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this._entryId=String(v.ID_GEN++);this._extension=r,this._id=o,this._alignment=s,this._priority=this.validatePriority(i)}validatePriority(h){if((0,E.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!v.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new O.DisposableStore,typeof h=="string"?this._command={fromApi:h,internal:this.#t.toInternal({title:"",command:h},this._latestCommandRegistration)}:h?this._command={fromApi:h,internal:this.#t.toInternal(h,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let b;this._name?b=this._name:b=(0,T.localize)(0,null,this._extension.displayName||this._extension.name);let m=this._color;this._backgroundColor&&(m=v.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const r=A.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,h,this._extension?.identifier.value,b,this._text,r,this._command?.internal,m,this._backgroundColor,this._alignment===I.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=v;class _{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,T.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const b={message:h};return this._messages.unshift(b),this._update(),new I.Disposable(()=>{const m=this._messages.indexOf(b);m>=0&&(this._messages.splice(m,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class N{constructor(h,b){this._existingItems=new Map,this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=b,this._statusMessage=new _(this)}$acceptStaticEntries(h){for(const b of h)this._existingItems.set(b.entryId,b)}createStatusBarEntry(h,b,m,r){return new v(this._proxy,this._commands,this._existingItems,h,b,m,r)}setStatusBarMessage(h,b){const m=this._statusMessage.setMessage(h);let r;return typeof b=="number"?r=setTimeout(()=>m.dispose(),b):typeof b<"u"&&b.then(()=>m.dispose(),()=>m.dispose()),new I.Disposable(()=>{m.dispose(),clearTimeout(r)})}}e.ExtHostStatusBar=N}),define(Ie[115],Pe([1,0,30,107,52,77,62,8,2]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const _=(n,c,u,t)=>{let f=c;return{enumerable:!0,configurable:!1,get(){return f},set(a){if(!u(f,a)){const p=f;f=a,n.listener?.(t(a,p))}}}},N=(n,c)=>n===c,y={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(n,c)=>!(n.length!==c.length||n.some(u=>!c.find(t=>u.id===t.id)))},h=n=>c=>({op:4,update:n(c)}),b=(n,c)=>({range:(()=>{let u;const t=h(f=>({range:I.Range.lift(E.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return u},set(f){n.listener?.({op:6}),y.range(u,f)||(u=f,n.listener?.(t(f)))}}})(),label:_(n,c,y.label,h(u=>({label:u}))),description:_(n,void 0,y.description,h(u=>({description:u}))),sortText:_(n,void 0,y.sortText,h(u=>({sortText:u}))),canResolveChildren:_(n,!1,y.canResolveChildren,u=>({op:2,state:u})),busy:_(n,!1,y.busy,h(u=>({busy:u}))),error:_(n,void 0,y.error,h(u=>({error:E.MarkdownString.fromStrict(u)||null}))),tags:_(n,[],y.tags,(u,t)=>({op:1,new:u.map(E.TestTag.from),old:t.map(E.TestTag.from)}))}),m=n=>{const c=T.TestId.fromString(n.extId),u=new o(c.controllerId,c.localId,n.label,v.URI.revive(n.uri)||void 0);return u.range=E.Range.to(n.range||void 0),u.description=n.description||void 0,u.sortText=n.sortText||void 0,u.tags=n.tags.map(t=>E.TestTag.to({id:(0,A.denamespaceTestTag)(t).tagId})),u},r=n=>{let c;for(const u of n.tests){const t=m(u.item);(0,L.getPrivateApiFor)(t).parent=c,c=t}return c};e.toItemFromContext=r;class o{constructor(c,u,t,f){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const a=(0,L.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof s?void 0:a.parent}},children:{value:(0,O.createTestItemChildren)(a,L.getPrivateApiFor,o),enumerable:!0,writable:!1},...b(a,t)})}}e.TestItemImpl=o;class s extends o{constructor(c,u){super(c,c,u,void 0),this._isRoot=!0}}e.TestItemRootImpl=s;class i extends O.TestItemCollection{constructor(c,u,t){super({controllerId:c,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:L.getPrivateApiFor,getChildren:f=>f.children,root:new s(c,u),toITestItem:E.TestItem.from})}}e.ExtHostTestItemCollection=i}),define(Ie[32],Pe([1,0,15,7,8,25,4,18,12,49,30,94,2,6,3,17,115,21,35,44,66,59,63,34]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{#e;#t;#i;constructor(g,C,S){this._commands=new Map,this._apiCommands=new Map,this.#e=g.getProxy(A.MainContext.MainThreadCommands),this._logService=C,this.#i=S,this.#t=g.getProxy(A.MainContext.MainThreadTelemetry),this.converter=new p(this,k=>{const P=this._apiCommands.get(k);return P?.result===D.Void?P:void 0},C),this._argumentProcessors=[{processArgument(k){return(0,_.revive)(k)}},{processArgument(k){return(0,O.cloneAndChange)(k,function(P){if(N.Range.isIRange(P))return T.Range.to(P);if(y.Position.isIPosition(P))return T.Position.to(P);if(N.Range.isIRange(P.range)&&h.URI.isUri(P.uri))return T.location.to(P);if(P instanceof s.VSBuffer)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(g){this._argumentProcessors.push(g)}registerApiCommand(g){const C=this.registerCommand(!1,g.id,async(...S)=>{const k=g.args.map((H,$)=>{if(!H.validate(S[$]))throw new Error(`Invalid argument '${H.name}' when running '${g.id}', received: ${typeof S[$]=="object"?JSON.stringify(S[$],null,"	"):S[$]} `);return H.convert(S[$])}),P=await this.executeCommand(g.internalId,...k);return g.result.convert(P,S,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this._apiCommands.set(g.id,g),new L.Disposable(()=>{C.dispose(),this._apiCommands.delete(g.id)})}registerCommand(g,C,S,k,P,H){if(this._logService.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this._commands.has(C))throw new Error(`command '${C}' already exists`);return this._commands.set(C,{callback:S,thisArg:k,metadata:P,extension:H}),g&&this.#e.$registerCommand(C),new L.Disposable(()=>{this._commands.delete(C)&&g&&this.#e.$unregisterCommand(C)})}executeCommand(g,...C){return this._logService.trace("ExtHostCommands#executeCommand",g),this._doExecuteCommand(g,C,!0)}async _doExecuteCommand(g,C,S){if(this._commands.has(g))return this.#e.$fireCommandActivationEvent(g),this._executeContributedCommand(g,C,!1);{let k=!1;const P=(0,O.cloneAndChange)(C,function(H){if(H instanceof L.Position)return T.Position.from(H);if(H instanceof L.Range)return T.Range.from(H);if(H instanceof L.Location)return T.location.from(H);if(L.NotebookRange.isNotebookRange(H))return T.NotebookRange.from(H);if(H instanceof ArrayBuffer)return k=!0,s.VSBuffer.wrap(new Uint8Array(H));if(H instanceof Uint8Array)return k=!0,s.VSBuffer.wrap(H);if(H instanceof s.VSBuffer)return k=!0,H;if(!Array.isArray(H))return H});try{const H=await this.#e.$executeCommand(g,k?new i.SerializableObjectWithBuffers(P):P,S);return(0,_.revive)(H)}catch(H){if(H instanceof Error&&H.message==="$executeCommand:retry")return this._doExecuteCommand(g,C,!1);throw H}}}async _executeContributedCommand(g,C,S){const k=this._commands.get(g);if(!k)throw new Error("Unknown command");const{callback:P,thisArg:H,metadata:$}=k;if($?.args)for(let R=0;R<$.args.length;R++)try{(0,I.validateConstraint)(C[R],$.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${$.args[R].name}' - ${$.args[R].description}`)}const V=c.StopWatch.create();try{return await P.apply(H,C)}catch(R){if(g===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...C);z&&(g=z.command)}if(this._logService.error(R,g,k.extension?.identifier),!S)throw R;if(k.extension?.identifier){const z=this.#i.onExtensionError(k.extension.identifier,R);this._logService.trace("forwarded error to extension?",z,k.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.toErrorMessage)(R)),this.id=g,this.source=k.extension?.displayName??k.extension?.name}}}finally{this._reportTelemetry(k,g,V.elapsed())}}_reportTelemetry(g,C,S){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new u.TelemetryTrustedValue(C),duration:S})}$executeContributedCommand(g,...C){this._logService.trace("ExtHostCommands#$executeContributedCommand",g);const S=this._commands.get(g);return S?(C=C.map(k=>this._argumentProcessors.reduce((P,H)=>H.processArgument(P,S.extension?.identifier),k)),this._executeContributedCommand(g,C,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this._logService.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(C=>(g&&(C=C.filter(S=>S[0]!=="_")),C))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[C,S]of this._commands){const{metadata:k}=S;k&&(g[C]=k)}return Promise.resolve(g)}};e.ExtHostCommands=a,e.ExtHostCommands=a=Ke([He(0,r.IExtHostRpcService),He(1,v.ILogService),He(2,t.IExtHostTelemetry)],a),e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class p{constructor(g,C,S){this._commands=g,this._lookupApiCommand=C,this._logService=S,this.delegatingCommandId=`__vsc${(0,f.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(g,C){if(!g)return;const S={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return S;const k=this._lookupApiCommand(g.command);if(k)S.id=k.internalId,S.arguments=k.args.map((P,H)=>P.convert(g.arguments&&g.arguments[H]));else if((0,E.isNonEmptyArray)(g.arguments)){const P=`${g.command} /${++this._cachIdPool}`;this._cache.set(P,g),C.add((0,b.toDisposable)(()=>{this._cache.delete(P),this._logService.trace("CommandsConverter#DISPOSE",P)})),S.$ident=P,S.id=this.delegatingCommandId,S.arguments=[P],this._logService.trace("CommandsConverter#CREATE",g.command,P)}return S}fromInternal(g){return typeof g.$ident=="string"?this._cache.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this._cache.get(g[0])}_executeConvertedCommand(...g){const C=this.getActualCommand(...g);return this._logService.trace("CommandsConverter#EXECUTE",g[0],C?C.command:"MISSING"),C?this._commands.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=p;class l{static{this.Uri=new l("uri","Uri of a text document",g=>h.URI.isUri(g),g=>g)}static{this.Position=new l("position","A position in a text document",g=>L.Position.isPosition(g),T.Position.from)}static{this.Range=new l("range","A range in a text document",g=>L.Range.isRange(g),T.Range.from)}static{this.Selection=new l("selection","A selection in a text document",g=>L.Selection.isSelection(g),T.Selection.from)}static{this.Number=new l("number","",g=>typeof g=="number",g=>g)}static{this.String=new l("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=l.Arr(l.String)}static Arr(g){return new l(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,C=>Array.isArray(C)&&C.every(S=>g.validate(S)),C=>C.map(S=>g.convert(S)))}static{this.CallHierarchyItem=new l("item","A call hierarchy item",g=>g instanceof L.CallHierarchyItem,T.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new l("item","A type hierarchy item",g=>g instanceof L.TypeHierarchyItem,T.TypeHierarchyItem.from)}static{this.TestItem=new l("testItem","A VSCodium TestItem",g=>g instanceof o.TestItemImpl,T.TestItem.from)}constructor(g,C,S,k){this.name=g,this.description=C,this.validate=S,this.convert=k}optional(){return new l(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,C){return new l(g??this.name,C??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l;class D{static{this.Void=new D("no result",g=>g)}constructor(g,C){this.description=g,this.convert=C}}e.ApiCommandResult=D;class d{constructor(g,C,S,k,P){this.id=g,this.internalId=C,this.description=S,this.args=k,this.result=P}}e.ApiCommand=d}),define(Ie[285],Pe([1,0,18,16,2,89,98,31,32,8,7]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new v.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(_.DocumentHighlight.to))),new v.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,I.isFalsyOrEmpty)(r))return;class s extends N.SymbolInformation{static to(n){const c=new s(n.name,_.SymbolKind.to(n.kind),n.containerName||"",new N.Location(o[0],_.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=_.Range.to(n.selectionRange),c.children=n.children?n.children.map(s.to):[],c}}return r.map(s.to)})),new v.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(_.TextEdit.to))),new v.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(_.TextEdit.to))),new v.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,new v.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new v.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new v.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(_.TextEdit.to))),new v.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new v.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new v.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new v.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new v.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(_.location.to))),new v.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(_.Hover.to))),new v.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>N.Position.isPosition(o)),r=>r.map(_.Position.from))],new v.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(o=>{let s;for(const i of o.reverse())s=new N.SelectionRange(_.Range.to(i),s);return s}))),new v.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.ApiCommandArgument.String.with("query","Search string")],new v.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(_.WorkspaceSymbol.to))),new v.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(_.CallHierarchyItem.to))),new v.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(_.CallHierarchyIncomingCall.to))),new v.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.ApiCommandArgument.CallHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(_.CallHierarchyOutgoingCall.to))),new v.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:_.Range.to(r.range),placeholder:r.text}})),new v.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("newName","The new symbol name")],new v.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return _.WorkspaceEdit.to(r)}})),new v.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(_.DocumentLink.to))),new v.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new N.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.decodeSemanticTokensDto)(r);if(o.type==="full")return new N.SemanticTokens(o.data,void 0)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range.optional()],new v.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new N.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new v.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.decodeSemanticTokensDto)(r);if(o.type==="full")return new N.SemanticTokens(o.data,void 0)})),new v.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,o,s)=>{if(!r)return new N.CompletionList([]);const i=r.suggestions.map(n=>_.CompletionItem.to(n,s));return new N.CompletionList(i,r.incomplete)})),new v.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position,v.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return _.SignatureHelp.to(r)})),new v.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,o,s)=>b(i=>new N.CodeLens(_.Range.to(i.range),i.command&&s.fromInternal(i.command)))(r))),new v.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.ApiCommandArgument.Uri,new v.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>N.Range.isRange(r),r=>N.Selection.isSelection(r)?_.Selection.from(r):_.Range.from(r)),v.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),v.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,o,s)=>b(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new N.CodeAction(i.title,i.kind?new N.CodeActionKind(i.kind):void 0);return i.edit&&(n.edit=_.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(r))),new v.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new N.ColorInformation(_.Range.to(o.range),_.Color.to(o.color))):[])),new v.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.ApiCommandArgument("color","The color to show and insert",r=>r instanceof N.Color,_.Color.from),new v.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:_.Range.from(r.range)}))],new v.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(_.ColorPresentation.to):[])),new v.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range],new v.ApiCommandResult("A promise that resolves to an array of Inlay objects",(r,o,s)=>r.map(_.InlayHint.to.bind(void 0,s)))),new v.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(_.FoldingRange.to)})),new v.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>_.NotebookExclusiveDocumentPattern.to(o))})))),new v.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Range,new v.ApiCommandArgument("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof N.Range,r=>_.InlineValueContext.from(r))],new v.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(_.InlineValue.to))),new v.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",r=>T.URI.isUri(r)||typeof r=="string"&&(0,L.matchesSomeScheme)(r,L.Schemas.http,L.Schemas.https),r=>r),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[_.ViewColumn.from(r),void 0]:[_.ViewColumn.from(r.viewColumn),_.TextEditorOpenOptions.from(r)])).optional(),v.ApiCommandArgument.String.with("label","").optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.ApiCommandArgument.Uri.with("resource","Resource to open"),v.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[_.ViewColumn.from(r),void 0]:[_.ViewColumn.from(r.viewColumn),_.TextEditorOpenOptions.from(r)])).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),v.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),v.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new v.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[_.ViewColumn.from(r.viewColumn),_.TextEditorOpenOptions.from(r)]).optional()],v.ApiCommandResult.Void),new v.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[v.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new v.ApiCommandArgument("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[s,i,n]=o;if(!T.URI.isUri(s)||!T.URI.isUri(i)&&i!==void 0&&i!==null||!T.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},r=>r)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.Position],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(_.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(_.TypeHierarchyItem.to))),new v.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.ApiCommandArgument.TypeHierarchyItem],new v.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(_.TypeHierarchyItem.to))),new v.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.ApiCommandArgument.TestItem],v.ApiCommandResult.Void),new v.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.ApiCommandResult.Void),new v.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.ApiCommandArgument.String.with("name","The context key name"),new v.ApiCommandArgument("value","The context key value",()=>!0,r=>r)],v.ApiCommandResult.Void),new v.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[v.ApiCommandArgument.Uri,v.ApiCommandArgument.StringArray,new v.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",r=>_.MappedEditsContext.is(r),r=>_.MappedEditsContext.from(r))],new v.ApiCommandResult("A promise that resolves to a workspace edit or null",r=>r?_.WorkspaceEdit.to(r):null))];class h{static register(o){y.forEach(o.registerApiCommand,o),this._registerValidateWhenClausesCommand(o)}static _registerValidateWhenClausesCommand(o){o.registerCommand(!1,"_validateWhenClauses",E.validateWhenClauses)}}e.ExtHostApiCommands=h;function b(r){return o=>{if(Array.isArray(o))return o.map(r)}}function m(r){if(!Array.isArray(r))return;const o=[];for(const s of r)O.isLocationLink(s)?o.push(_.DefinitionLink.to(s)):o.push(_.location.to(s));return o}}),define(Ie[286],Pe([1,0,11,6,2,4,32,8,7]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class _{static{this._pool=0}constructor(b,m){this.extension=b,this.provider=m,this.handle=_._pool++}}class N{constructor(b){this.session=b,this.responses=[]}}class y{static{this._nextId=0}constructor(b,m,r,o){this._documents=r,this._logService=o,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=b.getProxy(O.MainContext.MainThreadInlineChat),m.registerApiCommand(new A.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.ApiCommandArgument("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?E.Range.from(s.initialRange):void 0,initialSelection:v.Selection.isSelection(s.initialSelection)?E.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?E.Position.from(s.position):void 0}})],A.ApiCommandResult.Void))}registerProvider(b,m,r){const o=new _(b,m);return this._inputProvider.set(o.handle,o),this._proxy.$registerInteractiveEditorProvider(o.handle,r?.label??b.displayName??b.name,b.identifier,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",r?.supportReportIssue??!1),(0,L.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(o.handle),this._inputProvider.delete(o.handle)})}async $prepareSession(b,m,r,o){const s=this._inputProvider.get(b);if(!s){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this._documents.getDocument(T.URI.revive(m)),n=E.Selection.to(r),c=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const u=y._nextId++;return this._inputSessions.set(u,new N(c)),{id:u,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:E.Range.from(c.wholeRange),message:c.message}}async $provideResponse(b,m,r,o){const s=this._inputProvider.get(b);if(!s)return;const i=this._inputSessions.get(m.id);if(!i)return;const n={prompt:r.prompt,selection:E.Selection.to(r.selection),wholeRange:E.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this._documents.getDocument(T.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let c=!1;const u={report:async w=>{if(!r.live&&w.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this._proxy.$handleProgressChunk(r.requestId,{message:w.message,edits:w.edits?.map(E.TextEdit.from),editsShouldBeInstant:w.editsShouldBeInstant,slashCommand:w.slashCommand?.command,markdownFragment:v.MarkdownString.isMarkdownString(w.content)?w.content.value:w.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,u,o));let f;try{f=await(0,I.raceCancellation)(t,o)}finally{c=!0}if(!f)return;const a=i.responses.push(f)-1,p={wholeRange:E.Range.from(f.wholeRange),placeholder:f.placeholder};if(!y._isEditResponse(f))return{...p,id:a,type:"editorEdit",message:E.MarkdownString.from(f.contents),edits:[]};const{edits:l,contents:D}=f,d=D!==void 0?E.MarkdownString.from(D):void 0;return l instanceof v.WorkspaceEdit?{...p,id:a,type:"bulkEdit",edits:E.WorkspaceEdit.from(l),message:d}:{...p,id:a,type:"editorEdit",edits:l.map(E.TextEdit.from),message:d}}async $provideFollowups(b,m,r,o){const s=this._inputProvider.get(b),i=this._inputSessions.get(m),n=i?.responses[r];if(s&&n&&s.provider.provideFollowups){const c=Promise.resolve(s.provider.provideFollowups(i.session,n,o));return(await(0,I.raceCancellation)(c,o))?.map(E.ChatInlineFollowup.from)}}$handleFeedback(b,m,r,o){const s=this._inputProvider.get(b),i=this._inputSessions.get(m),n=i?.responses[r];if(s&&n){const c=E.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,c)}}$releaseSession(b,m){}static _isEditResponse(b){return typeof b=="object"&&typeof b.edits=="object"}}e.ExtHostInteractiveEditor=y}),define(Ie[287],Pe([1,0,2,32]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class T{constructor(A,E,v,_,N){this._extHostNotebooks=E,this._textDocumentsAndEditors=v,this._commands=_;const y=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",h=>!0,h=>h),new L.ApiCommandArgument("resource","Interactive resource Uri",h=>!0,h=>h),new L.ApiCommandArgument("controllerId","Notebook controller Id",h=>!0,h=>h),new L.ApiCommandArgument("title","Interactive editor title",h=>!0,h=>h)],new L.ApiCommandResult("Notebook and input URI",h=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const b=this._extHostNotebooks.getEditorById(h.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:I.URI.revive(h.notebookUri),inputUri:I.URI.revive(h.inputUri),notebookEditor:b.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:I.URI.revive(h.notebookUri),inputUri:I.URI.revive(h.inputUri)}}));this._commands.registerApiCommand(y)}$willAddInteractiveDocument(A,E,v,_){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:E,lines:[""],languageId:v,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,E){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=T}),define(Ie[288],Pe([1,0,18,11,24,5,6,28,2,20,12,4,32,8,7,78,229,26,35,230]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=l;let c=class{constructor(d,w,g,C,S){this._initData=w,this._extHostNotebook=g,this._commands=C,this._logService=S,this._activeExecutions=new E.ResourceMap,this._activeNotebookExecutions=new E.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new O.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=d.getProxy(y.MainContext.MainThreadNotebookKernels);const k=new h.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new h.ApiCommandArgument("options","Select kernel options",H=>!0,H=>{if(H&&"notebookEditor"in H&&"id"in H){const $=this._extHostNotebook.getIdByEditor(H.notebookEditor);return{id:H.id,extension:H.extension,notebookEditorId:$}}else if(H&&"notebookEditor"in H){const $=this._extHostNotebook.getIdByEditor(H.notebookEditor);if($===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${H.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:$}}return H})],h.ApiCommandResult.Void),P=new h.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of variables",(H,$)=>H.map(V=>({variable:{name:V.name,value:V.value,expression:V.expression,type:V.type,language:V.language},hasNamedChildren:V.hasNamedChildren,indexedChildrenCount:V.indexedChildrenCount}))));this._commands.registerApiCommand(k),this._commands.registerApiCommand(P)}createNotebookController(d,w,g,C,S,k){for(const ae of this._kernelData.values())if(ae.controller.id===w&&_.ExtensionIdentifier.equals(d.identifier,ae.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const P=this._handlePool++,H=this;this._logService.trace(`NotebookController[${P}], CREATED by ${d.identifier.value}, ${w}`);const $=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${d.identifier}'`);let V=!1;const R=new O.Emitter,z=new O.Emitter,q={id:l(d.identifier,w),notebookType:g,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:C||d.identifier.value,preloads:k?k.map(b.NotebookRendererScript.from):[]};let ie=S??$,ce,Se;this._proxy.$addKernel(P,q).catch(ae=>{console.log(ae),V=!0});let De=0;const fe=()=>{if(V)return;const ae=++De;Promise.resolve().then(()=>{ae===De&&this._proxy.$updateKernel(P,q)})},pe=new E.ResourceMap,Ne={get id(){return w},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return q.label},set label(ae){q.label=ae??d.displayName??d.name,fe()},get detail(){return q.detail??""},set detail(ae){q.detail=ae,fe()},get description(){return q.description??""},set description(ae){q.description=ae,fe()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(ae){q.supportedLanguages=ae,fe()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){q.supportsExecutionOrder=ae,fe()},get rendererScripts(){return q.preloads?q.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(ae){ie=ae??$},get interruptHandler(){return ce},set interruptHandler(ae){ce=ae,q.supportsInterrupt=!!ae,fe()},set variableProvider(ae){(0,s.checkProposedApiEnabled)(d,"notebookVariableProvider"),Se=ae,q.hasVariableProvider=!!ae,ae?.onDidChangeVariables(Re=>H._proxy.$variablesUpdated(Re.uri)),fe()},get variableProvider(){return Se},createNotebookCellExecution(ae){if(V)throw new Error("notebook controller is DISPOSED");if(!pe.has(ae.notebook.uri))throw H._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Re=>Re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return H._createNotebookCellExecution(ae,l(d.identifier,this.id))},createNotebookExecution(ae){if((0,s.checkProposedApiEnabled)(d,"notebookExecution"),V)throw new Error("notebook controller is DISPOSED");if(!pe.has(ae.uri))throw H._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Re=>Re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return H._createNotebookExecution(ae,l(d.identifier,this.id))},dispose:()=>{V||(this._logService.trace(`NotebookController[${P}], DISPOSED`),V=!0,this._kernelData.delete(P),R.dispose(),z.dispose(),this._proxy.$removeKernel(P))},updateNotebookAffinity(ae,Re){Re===m.NotebookControllerAffinity2.Hidden&&(0,s.checkProposedApiEnabled)(d,"notebookControllerAffinityHidden"),H._proxy.$updateNotebookPriority(P,ae.uri,Re)},onDidReceiveMessage:z.event,postMessage(ae,Re){return(0,s.checkProposedApiEnabled)(d,"notebookMessaging"),H._proxy.$postMessage(P,Re&&H._extHostNotebook.getIdByEditor(Re),ae)},asWebviewUri(ae){return(0,s.checkProposedApiEnabled)(d,"notebookMessaging"),(0,r.asWebviewUri)(ae,H._initData.remote)}};return this._kernelData.set(P,{extensionId:d.identifier,controller:Ne,onDidReceiveMessage:z,onDidChangeSelection:R,associatedNotebooks:pe}),Ne}getIdByController(d){for(const[w,g]of this._kernelData)if(g.controller===d)return l(g.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,w){const g=this._kernelDetectionTaskHandlePool++,C=this;this._logService.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${d.identifier.value}`),this._proxy.$addKernelDetectionTask(g,w);const S={dispose:()=>{this._kernelDetectionTask.delete(g),C._proxy.$removeKernelDetectionTask(g)}};return this._kernelDetectionTask.set(g,S),S}registerKernelSourceActionProvider(d,w,g){const C=this._kernelSourceActionProviderHandlePool++,S=typeof g.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,k=this;this._kernelSourceActionProviders.set(C,g),this._logService.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${d.identifier.value}`),this._proxy.$addKernelSourceActionProvider(C,C,w);let P;return S!==void 0&&(P=g.onDidChangeNotebookKernelSourceActions(H=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(S))),{dispose:()=>{this._kernelSourceActionProviders.delete(C),k._proxy.$removeKernelSourceActionProvider(C,C),P?.dispose()}}}async $provideKernelSourceActions(d,w){const g=this._kernelSourceActionProviders.get(d);if(g){const C=new A.DisposableStore;return(await g.provideNotebookKernelSourceActions(w)??[]).map(k=>b.NotebookKernelSourceAction.from(k,this._commands.converter,C))}return[]}$acceptNotebookAssociation(d,w,g){const C=this._kernelData.get(d);if(C){const S=this._extHostNotebook.getNotebookDocument(v.URI.revive(w));g?C.associatedNotebooks.set(S.uri,!0):C.associatedNotebooks.delete(S.uri),this._logService.trace(`NotebookController[${d}] ASSOCIATE notebook`,S.uri.toString(),g),C.onDidChangeSelection.fire({selected:g,notebook:S.apiNotebook})}}async $executeCells(d,w,g){const C=this._kernelData.get(d);if(!C)return;const S=this._extHostNotebook.getNotebookDocument(v.URI.revive(w)),k=[];for(const P of g){const H=S.getCell(P);H&&k.push(H.apiCell)}try{this._logService.trace(`NotebookController[${d}] EXECUTE cells`,S.uri.toString(),k.length),await C.controller.executeHandler.call(C.controller,k,S.apiNotebook,C.controller)}catch(P){this._logService.error(`NotebookController[${d}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(d,w,g){const C=this._kernelData.get(d);if(!C)return;const S=this._extHostNotebook.getNotebookDocument(v.URI.revive(w));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,S.apiNotebook);else for(const k of g){const P=S.getCell(k);P&&this._activeExecutions.get(P.uri)?.cancel()}if(C.controller.interruptHandler){const k=this._activeNotebookExecutions.get(S.uri);g.length&&Array.isArray(k)&&k.length&&k.forEach(P=>P.dispose())}}async $provideVariables(d,w,g,C,S,k,P){const H=this._kernelData.get(d);if(!H)return;const $=this._extHostNotebook.getNotebookDocument(v.URI.revive(g)),V=H.controller.variableProvider;if(!V)return;let R;if(C!==void 0){if(R=this.variableStore[C],!R)return}else this.variableStore={};const z=S==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,q=V.provideVariables($.apiNotebook,R,z,k,P);let ie=0;for await(const ce of q){if(P.isCancellationRequested)return;const Se={id:this.id++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:H.extensionId.value};if(this.variableStore[Se.id]=ce.variable,this._proxy.$receiveVariable(w,Se),ie++>=n.variablePageSize)return}}$acceptKernelMessageFromRenderer(d,w,g){const C=this._kernelData.get(d);if(!C)return;const S=this._extHostNotebook.getEditorById(w);C.onDidReceiveMessage.fire(Object.freeze({editor:S.apiEditor,message:g}))}$cellExecutionChanged(d,w,g){const S=this._extHostNotebook.getNotebookDocument(v.URI.revive(d)).getCell(w);if(S){const k=g?b.NotebookCellExecutionState.to(g):m.NotebookCellExecutionState.Idle;k!==void 0&&this._onDidChangeCellExecutionState.fire({cell:S.apiCell,state:k})}}_createNotebookCellExecution(d,w){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this._extHostNotebook.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!C)throw new Error("invalid cell");if(this._activeExecutions.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const S=new t(w,C,this._proxy);this._activeExecutions.set(C.uri,S);const k=S.onDidChangeState(()=>{S.state===u.Resolved&&(S.dispose(),k.dispose(),this._activeExecutions.delete(C.uri))});return S.asApiObject()}_createNotebookExecution(d,w){const g=this._extHostNotebook.getNotebookDocument(d.uri),C=d.getCells().find(P=>{const H=g.getCellFromApiCell(P);return H&&this._activeExecutions.has(H.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this._activeNotebookExecutions.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const S=new a(w,g,this._proxy),k=S.onDidChangeState(()=>{S.state===f.Resolved&&(S.dispose(),k.dispose(),this._activeNotebookExecutions.delete(g.uri))});return this._activeNotebookExecutions.set(g.uri,[S,k]),S.asApiObject()}};e.ExtHostNotebookKernels=c,e.ExtHostNotebookKernels=c=Ke([He(4,N.ILogService)],c);var u;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(u||(u={}));class t extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(d,w,g){super(),this._cell=w,this._proxy=g,this._handle=t.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new T.CancellationTokenSource),this._collector=new p(10,C=>this.update(C)),this._executionOrder=w.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,d,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(d){await this._collector.addItem(d)}async update(d){const w=Array.isArray(d)?d:[d];return this._proxy.$updateExecution(this._handle,new i.SerializableObjectWithBuffers(w))}verifyStateForOutput(){if(this._state===u.Init)throw new Error("Must call start before modifying cell output");if(this._state===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(d){let w=this._cell;if(d&&(w=this._cell.notebook.getCellFromApiCell(d)),!w)throw new Error("INVALID cell");return w.handle}validateAndConvertOutputs(d){return d.map(w=>{const g=m.NotebookCellOutput.ensureUniqueMimeTypes(w.items,!0);return g===w.items?b.NotebookCellOutput.from(w):b.NotebookCellOutput.from({items:g,id:w.id,metadata:w.metadata})})}async updateOutputs(d,w,g){const C=this.cellIndexToHandle(w),S=this.validateAndConvertOutputs((0,I.asArray)(d));return this.updateSoon({editType:o.CellExecutionUpdateType.Output,cellHandle:C,append:g,outputs:S})}async updateOutputItems(d,w,g){return d=m.NotebookCellOutput.ensureUniqueMimeTypes((0,I.asArray)(d),!0),this.updateSoon({editType:o.CellExecutionUpdateType.OutputItems,items:d.map(b.NotebookCellOutputItem.from),outputId:w.id,append:g})}asApiObject(){const d=this;return Object.freeze({get token(){return d._tokenSource.token},get cell(){return d._cell.apiCell},get executionOrder(){return d._executionOrder},set executionOrder(g){d._executionOrder=g,d.update([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:d._executionOrder}])},start(g){if(d._state===u.Resolved||d._state===u.Started)throw new Error("Cannot call start again");d._state=u.Started,d._onDidChangeState.fire(),d.update({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,C,S){if(d._state===u.Resolved)throw new Error("Cannot call resolve twice");d._state=u.Resolved,d._onDidChangeState.fire(),d._collector.flush();const k=S?{message:S.message,stack:S.stack,location:S?.location?{startLineNumber:S.location.start.line,startColumn:S.location.start.character,endLineNumber:S.location.end.line,endColumn:S.location.end.character}:void 0,uri:S.uri}:void 0;d._proxy.$completeExecution(d._handle,new i.SerializableObjectWithBuffers({runEndTime:C,lastRunSuccess:g,error:k}))},clearOutput(g){return d.verifyStateForOutput(),d.updateOutputs([],g,!1)},appendOutput(g,C){return d.verifyStateForOutput(),d.updateOutputs(g,C,!0)},replaceOutput(g,C){return d.verifyStateForOutput(),d.updateOutputs(g,C,!1)},appendOutputItems(g,C){return d.verifyStateForOutput(),d.updateOutputItems(g,C,!0)},replaceOutputItems(g,C){return d.verifyStateForOutput(),d.updateOutputItems(g,C,!1)}})}}var f;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(f||(f={}));class a extends A.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(d,w,g){super(),this._notebook=w,this._proxy=g,this._handle=a.HANDLE++,this._onDidChangeState=new O.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new T.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,d,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===f.Resolved||this._state===f.Started)throw new Error("Cannot call start again");this._state=f.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===f.Resolved)throw new Error("Cannot call resolve twice");this._state=f.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class p{constructor(d,w){this.delay=d,this.callback=w,this.batch=[],this.startedTimer=Date.now()}addItem(d){return this.batch.push(d),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const d=this.currentDeferred;this.currentDeferred=void 0;const w=this.batch;return this.batch=[],this.callback(w).finally(()=>d.complete())}}function l(D,d){return`${D.value}/${d}`}}),define(Ie[53],Pe([1,0,5,4,3,2,17,6,7,180,14,208,24,34,209,36,11,8,32]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class n extends E.Disposable{constructor(g,C,S,k){super(),this._proxy=g,this._id=C,this._creationOptions=S,this._name=k,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new I.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(H=>this._pidPromiseComplete=H);const P=this;this.value={get name(){return P._name||""},get processId(){return P._pidPromise},get creationOptions(){return P._creationOptions},get exitStatus(){return P._exitStatus},get state(){return P._state},get selection(){return P._selection},get shellIntegration(){return P.shellIntegration},sendText(H,$=!0){P._checkDisposed(),P._proxy.$sendText(P._id,H,$)},show(H){P._checkDisposed(),P._proxy.$show(P._id,H)},hide(){P._checkDisposed(),P._proxy.$hide(P._id)},dispose(){P._disposed||(P._disposed=!0,P._proxy.$dispose(P._id))},get dimensions(){if(!(P._cols===void 0||P._rows===void 0))return{columns:P._cols,rows:P._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(g,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??C?.cwd??void 0,env:g.env??void 0,icon:l(g.iconPath)??void 0,color:r.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:C?.forceShellIntegration??void 0,isFeatureTerminal:C?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:C?.useShellEnvironment??void 0,location:C?.location||this._serializeParentTerminal(g.location,C?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,C,S,k,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:k,color:r.ThemeColor.isThemeColor(P)?P.id:void 0,location:C?.location||this._serializeParentTerminal(g,S),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(g,C){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&C?{parentTerminal:C}:"viewColumn"in g?{viewColumn:s.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(g){this._name=g}setExitStatus(g,C){this._exitStatus=Object.freeze({code:g,reason:C})}setDimensions(g,C){return g===this._cols&&C===this._rows||g===0||C===0?!1:(this._cols=g,this._rows=C,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(g){this._selection=g}_setProcessId(g){this._pidPromiseComplete?(this._pidPromiseComplete(g),this._pidPromiseComplete=void 0):this._pidPromise.then(C=>{C!==g&&(this._pidPromise=Promise.resolve(g))})}}e.ExtHostTerminal=n;class c{get onProcessReady(){return this._onProcessReady.event}constructor(g){this._pty=g,this.id=0,this.shouldPersist=!1,this._onProcessData=new I.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new I.Emitter,this._onDidChangeProperty=new I.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new I.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,C){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${C}`)}async start(){}shutdown(){this._pty.close()}input(g){this._pty.handleInput?.(g)}resize(g,C){this._pty.setDimensions?.({columns:g,rows:C})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this._pty.onDidWrite(C=>this._onProcessData.fire(C)),this._pty.onDidClose?.((C=void 0)=>{this._onProcessExit.fire(C===void 0?void 0:C)}),this._pty.onDidOverrideDimensions?.(C=>{C&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:C.columns,rows:C.rows}})}),this._pty.onDidChangeName?.(C=>{this._onDidChangeProperty.fire({type:"title",value:C})}),this._pty.open(g||void 0),g&&this._pty.setDimensions?.(g),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends E.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(g=>g.value)}constructor(g,C,S){super(),this._extHostCommands=C,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new E.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new I.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new I.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new I.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new I.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new I.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new I.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new I.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=S.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new m.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(g),this._extHostCommands.registerArgumentProcessor({processArgument:k=>{const P=H=>{const $=H;return this.getTerminalById($.instanceId)?.value};switch(k?.$mid){case 15:return P(k);default:{if(Array.isArray(k))for(let H=0;H<k.length&&k[H].$mid===15;H++)k[H]=P(k[H]);return k}}}}),this._register({dispose:()=>{for(const[k,P]of this._terminalProcesses)P.shutdown(!0)}})}getDefaultShell(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(g,C){const S=new n(this._proxy,(0,b.generateUuid)(),g,g.name),k=new c(g.pty);return S.createExtensionTerminal(g.location,C,this._serializeParentTerminal(g,C).resolvedExtHostIdentifier,l(g.iconPath),D(g.color)).then(P=>{const H=this._setupExtHostProcessListeners(P,k);this._terminalProcessDisposables[P]=H}),this._terminals.push(S),S.value}_serializeParentTerminal(g,C){if(C=C||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const S=g.location.parentTerminal;if(S){const k=this._terminals.find(P=>P.value===S);k&&(C.resolvedExtHostIdentifier=k._id)}}else g.location&&typeof g.location!="object"?C.location=g.location:C.location&&typeof C.location=="object"&&"splitActiveTerminal"in C.location&&(C.location={splitActiveTerminal:!0});return C}attachPtyToTerminal(g,C){if(!this.getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const k=new c(C),P=this._setupExtHostProcessListeners(g,k);this._terminalProcessDisposables[g]=P}async $acceptActiveTerminalChanged(g){const C=this._activeTerminal;if(g===null){this._activeTerminal=void 0,C!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const S=this.getTerminalById(g);S&&(this._activeTerminal=S,C!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(g,C){const S=this.getTerminalById(g);S&&this._onDidWriteTerminalData.fire({terminal:S.value,data:C})}async $acceptTerminalDimensions(g,C,S){const k=this.getTerminalById(g);k&&k.setDimensions(C,S)&&this._onDidChangeTerminalDimensions.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptDidExecuteCommand(g,C){const S=this.getTerminalById(g);S&&this._onDidExecuteCommand.fire({terminal:S.value,...C})}async $acceptTerminalMaximumDimensions(g,C,S){this._terminalProcesses.get(g)?.resize(C,S)}async $acceptTerminalTitleChange(g,C){const S=this.getTerminalById(g);S&&(S.name=C)}async $acceptTerminalClosed(g,C,S){const k=this._getTerminalObjectIndexById(this._terminals,g);if(k!==null){const P=this._terminals.splice(k,1)[0];P.setExitStatus(C,S),this._onDidCloseTerminal.fire(P.value)}}$acceptTerminalOpened(g,C,S,k){if(C){const $=this._getTerminalObjectIndexById(this._terminals,C);if($!==null){this._terminals[$]._id=g,this._onDidOpenTerminal.fire(this.terminals[$]),this._terminals[$].isOpen=!0;return}}const P={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:O.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},H=new n(this._proxy,g,P,S);this._terminals.push(H),this._onDidOpenTerminal.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(g,C){this.getTerminalById(g)?._setProcessId(C)}async $startExtensionTerminal(g,C){const S=this.getTerminalById(g);if(!S)return{message:(0,_.localize)(0,null,g)};S.isOpen||await new Promise(P=>{const H=this.onDidOpenTerminal(async $=>{$===S.value&&(H.dispose(),P())})});const k=this._terminalProcesses.get(g);k?k.startSendingEvents(C):this._extensionTerminalAwaitingStart[g]={initialDimensions:C}}_setupExtHostProcessListeners(g,C){const S=new E.DisposableStore;S.add(C.onProcessReady(P=>this._proxy.$sendProcessReady(g,P.pid,P.cwd,P.windowsPty))),S.add(C.onDidChangeProperty(P=>this._proxy.$sendProcessProperty(g,P))),this._bufferer.startBuffering(g,C.onProcessData),S.add(C.onProcessExit(P=>this._onProcessExit(g,P))),this._terminalProcesses.set(g,C);const k=this._extensionTerminalAwaitingStart[g];return k&&C instanceof c&&(C.startSendingEvents(k.initialDimensions),delete this._extensionTerminalAwaitingStart[g]),S}$acceptProcessAckDataEvent(g,C){this._terminalProcesses.get(g)?.acknowledgeDataEvent(C)}$acceptProcessInput(g,C){this._terminalProcesses.get(g)?.input(C)}$acceptTerminalInteraction(g){const C=this.getTerminalById(g);C?.setInteractedWith()&&this._onDidChangeTerminalState.fire(C.value)}$acceptTerminalSelection(g,C){this.getTerminalById(g)?.setSelection(C)}$acceptProcessResize(g,C,S){try{this._terminalProcesses.get(g)?.resize(C,S)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(g,C){this._terminalProcesses.get(g)?.shutdown(C)}$acceptProcessRequestInitialCwd(g){this._terminalProcesses.get(g)?.getInitialCwd().then(C=>this._proxy.$sendProcessProperty(g,{type:"initialCwd",value:C}))}$acceptProcessRequestCwd(g){this._terminalProcesses.get(g)?.getCwd().then(C=>this._proxy.$sendProcessProperty(g,{type:"cwd",value:C}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this._linkProviders.add(g),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new v.Disposable(()=>{this._linkProviders.delete(g),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(g,C,S){if(this._profileProviders.has(C))throw new Error(`Terminal profile provider "${C}" already registered`);return this._profileProviders.set(C,S),this._proxy.$registerProfileProvider(C,g.identifier.value),new v.Disposable(()=>{this._profileProviders.delete(C),this._proxy.$unregisterProfileProvider(C)})}registerTerminalQuickFixProvider(g,C,S){if(this._quickFixProviders.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this._quickFixProviders.set(g,S),this._proxy.$registerQuickFixProvider(g,C),new v.Disposable(()=>{this._quickFixProviders.delete(g),this._proxy.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,C){const S=new h.CancellationTokenSource().token;if(S.isCancellationRequested)return;const k=this._quickFixProviders.get(g);if(!k)return;const P=await k.provideTerminalQuickFixes(C,S);if(P===null||Array.isArray(P)&&P.length===0)return;const H=new E.DisposableStore;if(this._lastQuickFixCommands.value=H,!Array.isArray(P))return P?s.TerminalQuickFix.from(P,this._extHostCommands.converter,H):void 0;const $=[];for(const V of P){const R=s.TerminalQuickFix.from(V,this._extHostCommands.converter,H);R&&$.push(R)}return $}async $createContributedProfileTerminal(g,C){const S=new h.CancellationTokenSource().token;let k=await this._profileProviders.get(g)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(k&&!("options"in k)&&(k={options:k}),!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,C);return}this.createTerminalFromOptions(k.options,C)}}async $provideLinks(g,C){const S=this.getTerminalById(g);if(!S)return[];this._terminalLinkCache.delete(g),this._terminalLinkCancellationSource.get(g)?.dispose(!0);const P=new h.CancellationTokenSource;this._terminalLinkCancellationSource.set(g,P);const H=[],$={terminal:S.value,line:C},V=[];for(const q of this._linkProviders)V.push(o.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:q,links:[]}));const ce=await q.provideTerminalLinks($,P.token)||[];P.token.isCancellationRequested||ie({provider:q,links:ce})}));const R=await Promise.all(V);if(P.token.isCancellationRequested)return[];const z=new Map;for(const q of R)q&&q.links.length>0&&H.push(...q.links.map(ie=>{const ce={id:u++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return z.set(ce.id,{provider:q.provider,link:ie}),ce}));return this._terminalLinkCache.set(g,z),H}$activateLink(g,C){const S=this._terminalLinkCache.get(g)?.get(C);S&&S.provider.handleTerminalLink(S.link)}_onProcessExit(g,C){this._bufferer.stopBuffering(g),this._terminalProcesses.delete(g),delete this._extensionTerminalAwaitingStart[g];const S=this._terminalProcessDisposables[g];S&&(S.dispose(),delete this._terminalProcessDisposables[g]),this._proxy.$sendProcessExit(g,C)}getTerminalById(g){return this._getTerminalObjectById(this._terminals,g)}getTerminalIdByApiObject(g){const C=this._terminals.findIndex(S=>S.value===g);return C>=0?C:null}_getTerminalObjectById(g,C){const S=this._getTerminalObjectIndexById(g,C);return S!==null?g[S]:null}_getTerminalObjectIndexById(g,C){const S=g.findIndex(k=>k._id===C);return S>=0?S:null}getEnvironmentVariableCollection(g){let C=this._environmentVariableCollections.get(g.identifier.value);return C||(C=new f,this._setEnvironmentVariableCollection(g.identifier.value,C)),C.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(g,C){const S=(0,y.serializeEnvironmentVariableCollection)(C.map),k=(0,y.serializeEnvironmentDescriptionMap)(C.descriptionMap);this._proxy.$setEnvironmentVariableCollection(g,C.persistent,S.length===0?void 0:S,k)}$initEnvironmentVariableCollections(g){g.forEach(C=>{const S=C[0],k=new f(C[1]);this._setEnvironmentVariableCollection(S,k)})}$acceptDefaultProfile(g,C){const S=this._defaultProfile;this._defaultProfile=g,this._defaultAutomationProfile=C,S?.path!==g.path&&this._onDidChangeShell.fire(g.path)}_setEnvironmentVariableCollection(g,C){this._environmentVariableCollections.set(g,C),C.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(g,C)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=Ke([He(1,i.IExtHostCommands),He(2,A.IExtHostRpcService)],t);class f{get persistent(){return this._persistent}set persistent(g){this._persistent=g,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(g){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new I.Emitter,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const C=this.getScopeKey(g);let S=this.scopedCollections.get(C);return S||(S=new a(this,g),this.scopedCollections.set(C,S),S.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),S}replace(g,C,S,k){this._setIfDiffers(g,{value:C,type:v.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:k})}append(g,C,S,k){this._setIfDiffers(g,{value:C,type:v.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:k})}prepend(g,C,S,k){this._setIfDiffers(g,{value:C,type:v.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:k})}_setIfDiffers(g,C){if(C.options&&C.options.applyAtProcessCreation===!1&&!C.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.getKey(g,C.scope),k=this.map.get(S),P=C.options?{applyAtProcessCreation:C.options.applyAtProcessCreation??!1,applyAtShellIntegration:C.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!k||k.value!==C.value||k.type!==C.type||k.options?.applyAtProcessCreation!==P.applyAtProcessCreation||k.options?.applyAtShellIntegration!==P.applyAtShellIntegration||k.scope?.workspaceFolder?.index!==C.scope?.workspaceFolder?.index){const H=this.getKey(g,C.scope),$={variable:g,...C,options:P};this.map.set(H,$),this._onDidChangeCollection.fire()}}get(g,C){const S=this.getKey(g,C),k=this.map.get(S);return k?d(k):void 0}getKey(g,C){const S=this.getScopeKey(C);return S.length?`${g}:::${S}`:g}getScopeKey(g){return this.getWorkspaceKey(g?.workspaceFolder)??""}getWorkspaceKey(g){return g?g.uri.toString():void 0}getVariableMap(g){const C=new Map;for(const[S,k]of this.map)this.getScopeKey(k.scope)===this.getScopeKey(g)&&C.set(k.variable,d(k));return C}delete(g,C){const S=this.getKey(g,C);this.map.delete(S),this._onDidChangeCollection.fire()}clear(g){if(g?.workspaceFolder){for(const[C,S]of this.map)S.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(C);this.clearDescription(g)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(g,C){const S=this.getScopeKey(C),k=this.descriptionMap.get(S);if(!k||k.description!==g){let P;typeof g=="string"?P=g:P=g?.value.split(`

`)[0];const H={description:P,scope:C};this.descriptionMap.set(S,H),this._onDidChangeCollection.fire()}}getDescription(g){const C=this.getScopeKey(g);return this.descriptionMap.get(C)?.description}clearDescription(g){const C=this.getScopeKey(g);this.descriptionMap.delete(C)}}class a{get persistent(){return this.collection.persistent}set persistent(g){this.collection.persistent=g}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(g,C){this.collection=g,this.scope=C,this._onDidChangeCollection=new I.Emitter}getScoped(g){return this.collection.getScopedEnvironmentVariableCollection(g)}replace(g,C,S){this.collection.replace(g,C,S,this.scope)}append(g,C,S){this.collection.append(g,C,S,this.scope)}prepend(g,C,S){this.collection.prepend(g,C,S,this.scope)}get(g){return this.collection.get(g,this.scope)}forEach(g,C){this.collection.getVariableMap(this.scope).forEach((S,k)=>g.call(C,k,S,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(g){this.collection.delete(g,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(g){this.collection.setDescription(g,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let p=class extends t{constructor(g,C){super(!1,g,C)}createTerminal(g,C,S){throw new N.NotSupportedError}createTerminalFromOptions(g,C){throw new N.NotSupportedError}};e.WorkerExtHostTerminalService=p,e.WorkerExtHostTerminalService=p=Ke([He(0,i.IExtHostCommands),He(1,A.IExtHostRpcService)],p);function l(w){if(!(!w||typeof w=="string"))return"id"in w?{id:w.id,color:w.color}:w}function D(w){return r.ThemeColor.isThemeColor(w)?w:void 0}function d(w){const g={...w};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ie[116],Pe([1,0,7,6,3,4,17,53,5,2,11]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,T.createDecorator)("IExtHostTerminalShellIntegration");let y=class extends L.Disposable{constructor(o,s){super(),this._extHostTerminalService=s,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new v.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new v.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new v.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=o.getProxy(O.MainContext.MainThreadTerminalShellIntegration),this._register((0,L.toDisposable)(()=>{for(const[i,n]of this._activeShellIntegrations)n.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(o){const s=this._extHostTerminalService.getTerminalById(o);if(!s)return;const i=s.value;let n=this._activeShellIntegrations.get(o);n||(n=new h(s.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(o,n),n.store.add(s.onWillDispose(()=>this._activeShellIntegrations.get(o)?.dispose())),n.store.add(n.onDidRequestShellExecution(c=>this._proxy.$executeCommand(o,c))),n.store.add(n.onDidRequestEndExecution(c=>this._onDidEndTerminalShellExecution.fire(c))),n.store.add(n.onDidRequestChangeShellIntegration(c=>this._onDidChangeTerminalShellIntegration.fire(c))),s.shellIntegration=n.value),this._onDidChangeTerminalShellIntegration.fire({terminal:i,shellIntegration:n.value})}$shellExecutionStart(o,s,i,n,c){this._activeShellIntegrations.has(o)||this.$shellIntegrationChange(o);const u={value:s,confidence:i,isTrusted:n};this._activeShellIntegrations.get(o)?.startShellExecution(u,c)}$shellExecutionEnd(o,s,i,n,c){const u={value:s,confidence:i,isTrusted:n};this._activeShellIntegrations.get(o)?.endShellExecution(u,c)}$shellExecutionData(o,s){this._activeShellIntegrations.get(o)?.emitData(s)}$cwdChange(o,s){this._activeShellIntegrations.get(o)?.setCwd((0,_.isUriComponents)(s)?_.URI.revive(s):s)}$closeTerminal(o){this._activeShellIntegrations.get(o)?.dispose(),this._activeShellIntegrations.delete(o)}};e.ExtHostTerminalShellIntegration=y,e.ExtHostTerminalShellIntegration=y=Ke([He(0,A.IExtHostRpcService),He(1,E.IExtHostTerminalService)],y);class h extends L.Disposable{get currentExecution(){return this._currentExecution}constructor(o,s){super(),this._terminal=o,this._onDidStartTerminalShellExecution=s,this._ignoreNextExecution=!1,this.store=this._register(new L.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new v.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new v.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new v.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const i=this;this.value={get cwd(){return i._cwd},executeCommand(n,c){let u=n;c&&(u+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),i._onDidRequestShellExecution.fire(u);const t={value:u,confidence:I.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},f=i.startShellExecution(t,i._cwd,!0).value;return i._ignoreNextExecution=!0,f}}}startShellExecution(o,s,i){if(this._ignoreNextExecution&&this._currentExecution)this._ignoreNextExecution=!1;else{this._currentExecution&&(this._currentExecution.endExecution(void 0),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:void 0}));const n=this._currentExecution=new b(o,s);i?queueMicrotask(()=>this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:n.value})):this._onDidStartTerminalShellExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value})}return this._currentExecution}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,s){this._currentExecution&&(this._currentExecution.endExecution(o),this._onDidRequestEndExecution.fire({terminal:this._terminal,shellIntegration:this.value,execution:this._currentExecution.value,exitCode:s}),this._currentExecution=void 0)}setCwd(o){let s=!1;_.URI.isUri(this._cwd)?s=!_.URI.isUri(o)||this._cwd.toString()!==o.toString():this._cwd!==o&&(s=!0),s&&(this._cwd=o,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class b{constructor(o,s){this._commandLine=o,this.cwd=s,this._ended=!1;const i=this;this.value={get commandLine(){return i._commandLine},get cwd(){return i.cwd},read(){return i._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._ended)return N.AsyncIterableObject.EMPTY;this._dataStream=new m}return this._dataStream.createIterable()}emitData(o){this._dataStream?.emitData(o)}endExecution(o){o&&(this._commandLine=o),this._dataStream?.endExecution(),this._dataStream=void 0,this._ended=!0}}class m extends L.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){this._barrier||(this._barrier=new N.Barrier);const o=this._barrier;return new N.AsyncIterableObject(async i=>{this._emitters.push(i),await o.wait()})}emitData(o){for(const s of this._emitters)s.emitOne(o)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(Ie[289],Pe([1,0,11,21,24,5,261,73,6,15,34,12,4,17,115,8,7,52,77,62]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let c=class extends v.Disposable{constructor(P,H,$,V){super(),this.editors=V,this.resultsChangedEmitter=this._register(new O.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new O.Emitter),this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=P.getProxy(h.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new a(this.proxy,H),$.registerArgumentProcessor({processArgument:R=>{switch(R?.$mid){case 16:{const z=R,q=z.tests[z.tests.length-1].item.extId;return this.controllers.get(s.TestId.root(q))?.collection.tree.get(q)?.actual??(0,m.toItemFromContext)(R)}case 18:{const{test:z,message:q}=R,ie=z.item.extId;return{test:this.controllers.get(s.TestId.root(ie))?.collection.tree.get(ie)?.actual??(0,m.toItemFromContext)({$mid:16,tests:[z]}),message:r.TestMessage.to(q)}}default:return R}}}),$.registerCommand(!1,"testing.getExplorerSelection",async()=>{const R=await $.executeCommand("_testing.getExplorerSelection"),z=q=>{const ie=this.controllers.get(s.TestId.root(q));if(ie)return s.TestId.isRoot(q)?ie.controller:ie.collection.tree.get(q)?.actual};return{include:R?.include.map(z).filter(_.isDefined)||[],exclude:R?.exclude.map(z).filter(_.isDefined)||[]}})}createTestController(P,H,$,V){if(this.controllers.has(H))throw new Error(`Attempt to insert a duplicate controller with ID "${H}"`);const R=new v.DisposableStore,z=R.add(new m.ExtHostTestItemCollection(H,$,this.editors));z.root.label=$;const q=new Map,ie=new Set,ce=this.proxy,Se={items:z.root.children,get label(){return $},set label(fe){$=fe,z.root.label=fe,ce.$updateController(H,{label:$})},get refreshHandler(){return V},set refreshHandler(fe){V=fe,ce.$updateController(H,{canRefresh:!!fe})},get id(){return H},createRunProfile:(fe,pe,Ne,ae,Re,ne)=>{let x=(0,E.hash)(fe);for(;q.has(x);)x++;return new C(this.proxy,q,ie,this.defaultProfilesChangedEmitter.event,H,x,fe,pe,Ne,ae,Re,ne)},createTestItem(fe,pe,Ne){return new m.TestItemImpl(H,fe,pe,Ne)},createTestRun:(fe,pe,Ne=!0)=>this.runTracker.createTestRun(H,z,fe,pe,Ne),invalidateTestResults:fe=>{if(fe===void 0)this.proxy.$markTestRetired(void 0);else{const pe=fe instanceof Array?fe:[fe];this.proxy.$markTestRetired(pe.map(Ne=>s.TestId.fromExtHostTestItem(Ne,H).toString()))}},set resolveHandler(fe){z.resolveHandler=fe},get resolveHandler(){return z.resolveHandler},dispose:()=>{R.dispose()}};ce.$registerTestController(H,$,!!V),R.add((0,v.toDisposable)(()=>ce.$unregisterTestController(H)));const De={controller:Se,collection:z,profiles:q,extension:P,activeProfiles:ie};return this.controllers.set(H,De),R.add((0,v.toDisposable)(()=>this.controllers.delete(H))),R.add(z.onDidGenerateDiff(fe=>ce.$publishDiff(H,fe.map(n.TestsDiffOp.serialize)))),Se}createTestObserver(){return this.observer.checkout()}async runTests(P,H=T.CancellationToken.None){const $=p(P);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.controllers.get($.controllerId);if(!V)throw new Error("Controller not found");await this.proxy.$runTests({preserveFocus:P.preserveFocus??!0,targets:[{testIds:P.include?.map(R=>s.TestId.fromExtHostTestItem(R,V.collection.root.id).toString())??[V.collection.root.id],profileGroup:S[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:P.exclude?.map(R=>R.id)},H)}$syncTests(){for(const{collection:P}of this.controllers.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,H){return(await this.runTracker.getCoverageDetails(P,H))?.map(r.TestCoverage.fromDetails)}async $disposeRun(P){this.runTracker.disposeTestRun(P)}$configureRunProfile(P,H){this.controllers.get(P)?.profiles.get(H)?.configureHandler?.()}$setDefaultRunProfiles(P){const H=new Map;for(const[$,V]of Object.entries(P)){const R=this.controllers.get($);if(!R)continue;const z=new Map,q=V.filter(ce=>!R.activeProfiles.has(ce)),ie=[...R.activeProfiles].filter(ce=>!V.includes(ce));for(const ce of q)z.set(ce,!0),R.activeProfiles.add(ce);for(const ce of ie)z.set(ce,!1),R.activeProfiles.delete(ce);z.size&&H.set($,z)}this.defaultProfilesChangedEmitter.fire(H)}async $refreshTests(P,H){await this.controllers.get(P)?.controller.refreshHandler?.(H)}$publishTestResults(P){this.results=Object.freeze(P.map(r.TestResults.to).concat(this.results).sort((H,$)=>$.completedAt-H.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(P,H){const $=this.controllers.get(s.TestId.fromString(P).controllerId)?.collection;$&&(await $.expand(P,H<0?1/0:H),$.flushDiff())}$acceptDiff(P){this.observer.applyDiff(P.map(H=>n.TestsDiffOp.deserialize({asCanonicalUri:$=>$},H)))}async $runControllerTests(P,H){return Promise.all(P.map($=>this.runControllerTestRequest($,!1,H)))}async $startContinuousRun(P,H){const $=new T.CancellationTokenSource(H),V=await Promise.all(P.map(R=>this.runControllerTestRequest(R,!0,$.token)));return!H.isCancellationRequested&&!V.some(R=>R.error)&&await new Promise(R=>H.onCancellationRequested(R)),$.dispose(!0),V}async runControllerTestRequest(P,H,$){const V=this.controllers.get(P.controllerId);if(!V)return{};const{collection:R,profiles:z}=V,q=z.get(P.profileId);if(!q)return{};const ie=P.testIds.map(fe=>R.tree.get(fe)).filter(_.isDefined),ce=P.excludeExtIds.map(fe=>V.collection.tree.get(fe)).filter(_.isDefined).filter(fe=>ie.some(pe=>pe.fullId.compare(fe.fullId)===2));if(!ie.length)return{};const Se=new o.TestRunRequest(ie.some(fe=>fe.actual instanceof m.TestItemRootImpl)?void 0:ie.map(fe=>fe.actual),ce.map(fe=>fe.actual),q,H),De=(0,n.isStartControllerTests)(P)&&this.runTracker.prepareForMainThreadTestRun(Se,l.fromInternal(P,V.collection),q,$);try{return await q.runHandler(Se,$),{}}catch(fe){return{error:String(fe)}}finally{De&&De.hasRunningTasks&&!$.isCancellationRequested&&await O.Event.toPromise(De.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(P)}};e.ExtHostTesting=c,e.ExtHostTesting=c=Ke([He(0,b.IExtHostRpcService),He(1,y.ILogService)],c);const u=1e4;var t;(function(k){k[k.Running=0]="Running",k[k.Cancelling=1]="Cancelling",k[k.Ended=2]="Ended"})(t||(t={}));class f extends v.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(P,H,$,V,R){super(),this.dto=P,this.proxy=H,this.logService=$,this.profile=V,this.state=0,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new O.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new T.CancellationTokenSource(R));const z=this._register(new I.RunOnceScheduler(()=>this.forciblyEndTasks(),u));this._register(this.cts.token.onCancellationRequested(()=>z.schedule()));const q=new O.Emitter;this.onDidDispose=q.event,this._register((0,v.toDisposable)(()=>{q.fire(),q.dispose()}))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverageDetails(P,H){const[,$,V]=s.TestId.fromString(P).path,R=this.publishedCoverage.get(V);if(!R)return[];const z=this.tasks.get($);if(!z)throw new Error("unreachable: run task was not found");return this.profile?.loadDetailedCoverage?.(z.run,R,H)??[]}createRun(P){const H=this.dto.id,$=this.dto.controllerId,V=(0,N.generateUuid)(),R=ce=>(Se,...De)=>{if(q){this.logService.warn(`Setting the state of test "${Se.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(Se)&&(this.ensureTestIsKnown(Se),ce(Se,...De))},z=(ce,Se)=>{const De=Se instanceof Array?Se.map(r.TestMessage.from):[r.TestMessage.from(Se)];if(ce.uri&&ce.range){const fe={range:r.Range.from(ce.range),uri:ce.uri};for(const pe of De)pe.location=pe.location||fe}this.proxy.$appendTestMessagesInRun(H,V,s.TestId.fromExtHostTestItem(ce,$).toString(),De)};let q=!1;const ie={isPersisted:this.dto.isPersisted,token:this.cts.token,name:P,onDidDispose:this.onDidDispose,addCoverage:ce=>{const Se=ce.uri.toString(),De=new s.TestId([H,V,Se]).toString();this.publishedCoverage.set(Se,ce),this.proxy.$appendCoverage(H,V,r.TestCoverage.fromFile(De,ce))},enqueued:R(ce=>{this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(ce,$).toString(),1)}),skipped:R(ce=>{this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(ce,$).toString(),5)}),started:R(ce=>{this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(ce,$).toString(),2)}),errored:R((ce,Se,De)=>{z(ce,Se),this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(ce,$).toString(),6,De)}),failed:R((ce,Se,De)=>{z(ce,Se),this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(ce,$).toString(),4,De)}),passed:R((ce,Se)=>{this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString(),3,Se)}),appendOutput:(ce,Se,De)=>{q||(De&&(this.dto.isIncluded(De)?this.ensureTestIsKnown(De):De=void 0),this.proxy.$appendOutputToRun(H,V,L.VSBuffer.fromString(ce),Se&&r.location.from(Se),De&&s.TestId.fromExtHostTestItem(De,$).toString()))},end:()=>{q||(q=!0,this.proxy.$finishedTestRunTask(H,V),--this.running||this.markEnded())}};return this.running++,this.tasks.set(V,{run:ie}),this.proxy.$startedTestRunTask(H,{id:V,name:P,running:!0}),ie}forciblyEndTasks(){for(const{run:P}of this.tasks.values())P.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(P){if(!(P instanceof m.TestItemImpl))throw new i.InvalidTestItemError(P.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(P,this.dto.controllerId).toString()))return;const H=[],$=this.dto.colllection.root;for(;;){const V=r.TestItem.from(P);if(H.unshift(V),this.sharedTestIds.has(V.extId)||(this.sharedTestIds.add(V.extId),P===$))break;P=P.parent||$}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,H)}dispose(){this.markEnded(),super.dispose()}}class a{get trackers(){return this.tracked.values()}constructor(P,H){this.proxy=P,this.logService=H,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(P,H){const $=s.TestId.root(P);return this.trackedById.get($)?.getCoverageDetails(P,H)||[]}disposeTestRun(P){this.trackedById.get(P)?.dispose(),this.trackedById.delete(P);for(const[H,{id:$}]of this.tracked)$===P&&this.tracked.delete(H)}prepareForMainThreadTestRun(P,H,$,V){return this.getTracker(P,H,$,V)}cancelRunById(P){this.trackedById.get(P)?.cancel()}cancelAllRuns(){for(const P of this.tracked.values())P.cancel()}createTestRun(P,H,$,V,R){const z=this.tracked.get($);if(z)return z.createRun(V);const q=l.fromPublic(P,H,$,R),ie=p($);this.proxy.$startedExtensionTestRun({controllerId:P,continuous:!!$.continuous,profile:ie&&{group:S[ie.kind],id:ie.profileId},exclude:$.exclude?.map(Se=>s.TestId.fromExtHostTestItem(Se,H.root.id).toString())??[],id:q.id,include:$.include?.map(Se=>s.TestId.fromExtHostTestItem(Se,H.root.id).toString())??[H.root.id],preserveFocus:$.preserveFocus??!0,persist:R});const ce=this.getTracker($,q,$.profile);return O.Event.once(ce.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(q.id)}),ce.createRun(V)}getTracker(P,H,$,V){const R=new f(H,this.proxy,this.logService,$,V);return this.tracked.set(P,R),this.trackedById.set(R.id,R),R}}e.TestRunCoordinator=a;const p=k=>{if(k.profile){if(!(k.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return k.profile}};class l{static fromPublic(P,H,$,V){return new l(P,(0,N.generateUuid)(),$.include?.map(R=>s.TestId.fromExtHostTestItem(R,P).toString())??[P],$.exclude?.map(R=>s.TestId.fromExtHostTestItem(R,P).toString())??[],V,H)}static fromInternal(P,H){return new l(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,H)}constructor(P,H,$,V,R,z){this.controllerId=P,this.id=H,this.isPersisted=R,this.colllection=z,this.includePrefix=$.map(q=>q+"\0"),this.excludePrefix=V.map(q=>q+"\0")}isIncluded(P){const H=s.TestId.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(H===$||H.startsWith($))return!1;for(const $ of this.includePrefix)if(H===$||H.startsWith($))return!0;return!1}}e.TestRunDto=l;class D{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(P){this.emitter=P,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(P){this.added.add(P)}update(P){Object.assign(P.revived,r.TestItem.toPlain(P.item)),this.added.has(P)||this.updated.add(P)}remove(P){if(this.added.has(P)){this.added.delete(P);return}this.updated.delete(P);const H=s.TestId.parentId(P.item.extId);if(H&&this.alreadyRemoved.has(H.toString())){this.alreadyRemoved.add(P.item.extId);return}this.removed.add(P)}getChangeEvent(){const{added:P,updated:H,removed:$}=this;return{get added(){return[...P].map(V=>V.revived)},get updated(){return[...H].map(V=>V.revived)},get removed(){return[...$].map(V=>V.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends n.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new O.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(P){return this.items.get(P)}getMirroredTestDataByReference(P){return this.items.get(P.id)}createItem(P,H){return{...P,revived:r.TestItem.toPlain(P.item),depth:H?H.depth+1:0,children:new Set}}createChangeCollector(){return new D(this.changeEmitter)}}class w{constructor(P){this.proxy=P}checkout(){this.current||(this.current=this.createObserverData());const P=this.current;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(H=>H.revived)},dispose:(0,A.createSingleCallFunction)(()=>{--P.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(P){return this.current?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.current?.tests.apply(P)}createObserverData(){const P=new d({asCanonicalUri:H=>H});return this.proxy.$subscribeToDiffs(),{observers:0,tests:P}}}const g=(k,P,H,$)=>{H?Object.assign(H,$):P.$updateTestRunConfig(k.controllerId,k.profileId,$)};class C{#e;#t;#i;#n;#s;get label(){return this._label}set label(P){P!==this._label&&(this._label=P,g(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(P){P!==this._supportsContinuousRun&&(this._supportsContinuousRun=P,g(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),g(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,g(this,this.#e,this.#n,{tag:P?r.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(P){P!==this._configureHandler&&(this._configureHandler=P,g(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return O.Event.chain(this.#i,P=>P.map(H=>H.get(this.controllerId)?.get(this.profileId)).filter(_.isDefined))}constructor(P,H,$,V,R,z,q,ie,ce,Se=!1,De=void 0,fe=!1){this.controllerId=R,this.profileId=z,this._label=q,this.kind=ie,this.runHandler=ce,this._tag=De,this._supportsContinuousRun=fe,this.#e=P,this.#s=H,this.#t=$,this.#i=V,H.set(z,this);const pe=S[ie];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);Se&&$.add(z),this.#n={profileId:z,controllerId:R,tag:De?r.TestTag.namespace(this.controllerId,De.id):null,label:q,group:pe,isDefault:Se,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=C;const S={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ie[117],Pe([1,0,57,14,91,8,7]),function(ue,e,I,L,T,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class E{static{this._Keys=new T.IdGenerator("TextEditorDecorationType")}constructor(h,b,m){const r=E._Keys.nextId();h.$registerTextEditorDecorationType(b.identifier,r,O.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:r,dispose(){h.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=E;class v{constructor(h,b){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=h,this._documentVersionId=h.version,this._undoStopBefore=b.undoStopBefore,this._undoStopAfter=b.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(h,b){this._throwIfFinalized();let m=null;if(h instanceof A.Position)m=new A.Range(h,h);else if(h instanceof A.Range)m=h;else throw new Error("Unrecognized location");this._pushEdit(m,b,!1)}insert(h,b){this._throwIfFinalized(),this._pushEdit(new A.Range(h,h),b,!0)}delete(h){this._throwIfFinalized();let b=null;if(h instanceof A.Range)b=h;else throw new Error("Unrecognized location");this._pushEdit(b,null,!0)}_pushEdit(h,b,m){const r=this._document.validateRange(h);this._collectedEdits.push({range:r,text:b,forceMoveMarkers:m})}setEndOfLine(h){if(this._throwIfFinalized(),h!==A.EndOfLine.LF&&h!==A.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=h}}class _{constructor(h,b,m,r){this._proxy=h,this._id=b,this._accept(m),this._logService=r;const o=this;this.value={get tabSize(){return o._tabSize},set tabSize(s){o._setTabSize(s)},get indentSize(){return o._indentSize},set indentSize(s){o._setIndentSize(s)},get insertSpaces(){return o._insertSpaces},set insertSpaces(s){o._setInsertSpaces(s)},get cursorStyle(){return o._cursorStyle},set cursorStyle(s){o._setCursorStyle(s)},get lineNumbers(){return o._lineNumbers},set lineNumbers(s){o._setLineNumbers(s)}}}_accept(h){this._tabSize=h.tabSize,this._indentSize=h.indentSize,this._originalIndentSize=h.originalIndentSize,this._insertSpaces=h.insertSpaces,this._cursorStyle=h.cursorStyle,this._lineNumbers=O.TextEditorLineNumbersStyle.to(h.lineNumbers)}_validateTabSize(h){if(h==="auto")return"auto";if(typeof h=="number"){const b=Math.floor(h);return b>0?b:null}if(typeof h=="string"){const b=parseInt(h,10);return isNaN(b)?null:b>0?b:null}return null}_setTabSize(h){const b=this._validateTabSize(h);if(b!==null){if(typeof b=="number"){if(this._tabSize===b)return;this._tabSize=b}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:b}))}}_validateIndentSize(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const b=Math.floor(h);return b>0?b:null}if(typeof h=="string"){const b=parseInt(h,10);return isNaN(b)?null:b>0?b:null}return null}_setIndentSize(h){const b=this._validateIndentSize(h);if(b!==null){if(typeof b=="number"){if(this._originalIndentSize===b)return;this._indentSize=b,this._originalIndentSize=b}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:b}))}}_validateInsertSpaces(h){return h==="auto"?"auto":h==="false"?!1:!!h}_setInsertSpaces(h){const b=this._validateInsertSpaces(h);if(typeof b=="boolean"){if(this._insertSpaces===b)return;this._insertSpaces=b}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:b}))}_setCursorStyle(h){this._cursorStyle!==h&&(this._cursorStyle=h,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:h})))}_setLineNumbers(h){this._lineNumbers!==h&&(this._lineNumbers=h,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:O.TextEditorLineNumbersStyle.from(h)})))}assign(h){const b={};let m=!1;if(typeof h.tabSize<"u"){const r=this._validateTabSize(h.tabSize);r==="auto"?(m=!0,b.tabSize=r):typeof r=="number"&&this._tabSize!==r&&(this._tabSize=r,m=!0,b.tabSize=r)}if(typeof h.indentSize<"u"){const r=this._validateIndentSize(h.indentSize);r==="tabSize"?(m=!0,b.indentSize=r):typeof r=="number"&&this._originalIndentSize!==r&&(this._indentSize=r,this._originalIndentSize=r,m=!0,b.indentSize=r)}if(typeof h.insertSpaces<"u"){const r=this._validateInsertSpaces(h.insertSpaces);r==="auto"?(m=!0,b.insertSpaces=r):this._insertSpaces!==r&&(this._insertSpaces=r,m=!0,b.insertSpaces=r)}typeof h.cursorStyle<"u"&&this._cursorStyle!==h.cursorStyle&&(this._cursorStyle=h.cursorStyle,m=!0,b.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this._lineNumbers!==h.lineNumbers&&(this._lineNumbers=h.lineNumbers,m=!0,b.lineNumbers=O.TextEditorLineNumbersStyle.from(h.lineNumbers)),m&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,b))}_warnOnError(h,b){b.catch(m=>{this._logService.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this._logService.warn(m)})}}e.ExtHostTextEditorOptions=_;class N{constructor(h,b,m,r,o,s,i,n){this.id=h,this._proxy=b,this._logService=m,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._options=new _(this._proxy,this.id,s,m),this._visibleRanges=i,this._viewColumn=n;const c=this;this.value=Object.freeze({get document(){return r.value},set document(u){throw new L.ReadonlyError("document")},get selection(){return c._selections&&c._selections[0]},set selection(u){if(!(u instanceof A.Selection))throw(0,L.illegalArgument)("selection");c._selections=[u],c._trySetSelection()},get selections(){return c._selections},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof A.Selection)))throw(0,L.illegalArgument)("selections");c._selections=u,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(u){throw new L.ReadonlyError("visibleRanges")},get options(){return c._options.value},set options(u){c._disposed||c._options.assign(u)},get viewColumn(){return c._viewColumn},set viewColumn(u){throw new L.ReadonlyError("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new v(r.value,t);return u(f),c._applyEdit(f)},insertSnippet(u,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c._selections.map(p=>O.Range.from(p));else if(t instanceof A.Position){const{lineNumber:p,column:l}=O.Position.from(t);a=[{startLineNumber:p,startColumn:l,endLineNumber:p,endColumn:l}]}else if(t instanceof A.Range)a=[O.Range.from(t)];else{a=[];for(const p of t)if(p instanceof A.Range)a.push(O.Range.from(p));else{const{lineNumber:l,column:D}=O.Position.from(p);a.push({startLineNumber:l,startColumn:D,endLineNumber:l,endColumn:D})}}return b.$tryInsertSnippet(h,r.value.version,u.value,a,f)},setDecorations(u,t){const f=t.length===0;f&&!c._hasDecorationsForKey.has(u.key)||(f?c._hasDecorationsForKey.delete(u.key):c._hasDecorationsForKey.add(u.key),c._runOnProxy(()=>{if(O.isDecorationOptionsArr(t))return b.$trySetDecorations(h,u.key,O.fromRangeOrRangeWithMessage(t));{const a=new Array(4*t.length);for(let p=0,l=t.length;p<l;p++){const D=t[p];a[4*p]=D.start.line+1,a[4*p+1]=D.start.character+1,a[4*p+2]=D.end.line+1,a[4*p+3]=D.end.character+1}return b.$trySetDecorationsFast(h,u.key,a)}}))},revealRange(u,t){c._runOnProxy(()=>b.$tryRevealRange(h,O.Range.from(u),t||A.TextEditorRevealType.Default))},show(u){b.$tryShowEditor(h,O.ViewColumn.from(u))},hide(){b.$tryHideEditor(h)}})}dispose(){(0,I.ok)(!this._disposed),this._disposed=!0}_acceptOptions(h){(0,I.ok)(!this._disposed),this._options._accept(h)}_acceptVisibleRanges(h){(0,I.ok)(!this._disposed),this._visibleRanges=h}_acceptViewColumn(h){(0,I.ok)(!this._disposed),this._viewColumn=h}_acceptSelections(h){(0,I.ok)(!this._disposed),this._selections=h}async _trySetSelection(){const h=this._selections.map(O.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,h)),this.value}_applyEdit(h){const b=h.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const m=b.edits.map(o=>o.range);m.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=m.length-1;o<s;o++){const i=m[o].end;if(m[o+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=b.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,b.documentVersionId,r,{setEndOfLine:typeof b.setEndOfLine=="number"?O.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}_runOnProxy(h){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this._logService.warn(b),null))}}e.ExtHostTextEditor=N}),define(Ie[68],Pe([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class s{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let i=class{constructor(c,u){this._extHostRpc=c,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new b.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],t=[],f=[];if(c.removedDocuments)for(const a of c.removedDocuments){const p=O.URI.revive(a),l=this._documents.get(p);l?.unref()&&(this._documents.delete(p),u.push(l.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const p=O.URI.revive(a.uri);let l=this._documents.get(p);if(l&&p.scheme!==m.Schemas.vscodeNotebookCell&&p.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${p} already exists!'`);l||(l=new s(new v.ExtHostDocumentData(this._extHostRpc.getProxy(E.MainContext.MainThreadDocuments),p,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this._documents.set(p,l),t.push(l.value)),l.ref()}if(c.removedEditors)for(const a of c.removedEditors){const p=this._editors.get(a);this._editors.delete(a),p&&f.push(p)}if(c.addedEditors)for(const a of c.addedEditors){const p=O.URI.revive(a.documentUri);I.ok(this._documents.has(p),`document '${p}' does not exist`),I.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const l=this._documents.get(p).value,D=new N.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(E.MainContext.MainThreadTextEditors),this._logService,new o.Lazy(()=>l.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(d=>y.Range.to(d)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,D)}c.newActiveEditor!==void 0&&(I.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,T.dispose)(u),(0,T.dispose)(f),c.removedDocuments&&this._onDidRemoveDocuments.fire(u),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return r.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const u=this._editors.get(this._activeEditorId);return c?u:u?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=i,e.ExtHostDocumentsAndEditors=i=Ke([He(0,_.IExtHostRpcService),He(1,h.ILogService)],i),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[290],Pe([1,0,18,5,4,117,8,7]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class v{constructor(N,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new L.Emitter,this._onDidChangeTextEditorOptions=new L.Emitter,this._onDidChangeTextEditorVisibleRanges=new L.Emitter,this._onDidChangeTextEditorViewColumn=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=N.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(h=>this._onDidChangeVisibleTextEditors.fire(h)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(h=>this._onDidChangeActiveTextEditor.fire(h))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(N){const y=this._extHostDocumentsAndEditors.allEditors();return N?y:y.map(h=>h.value)}async showTextDocument(N,y,h){let b;typeof y=="number"?b={position:A.ViewColumn.from(y),preserveFocus:h}:typeof y=="object"?b={position:A.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?A.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:b={preserveFocus:!1};const m=await this._proxy.$tryShowTextDocument(N.uri,b),r=m&&this._extHostDocumentsAndEditors.getEditor(m);if(r)return r.value;throw m?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,y){return new O.TextEditorDecorationType(this._proxy,N,y).value}$acceptEditorPropertiesChanged(N,y){const h=this._extHostDocumentsAndEditors.getEditor(N);if(!h)throw new Error("unknown text editor");if(y.options&&h._acceptOptions(y.options),y.selections){const b=y.selections.selections.map(A.Selection.to);h._acceptSelections(b)}if(y.visibleRanges){const b=I.coalesce(y.visibleRanges.map(A.Range.to));h._acceptVisibleRanges(b)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:h.value,options:{...y.options,lineNumbers:A.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const b=E.TextEditorSelectionChangeKind.fromValue(y.selections.source),m=y.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:h.value,selections:m,kind:b})}if(y.visibleRanges){const b=I.coalesce(y.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:h.value,visibleRanges:b})}}$acceptEditorPositionData(N){for(const y in N){const h=this._extHostDocumentsAndEditors.getEditor(y);if(!h)throw new Error("Unknown text editor");const b=A.ViewColumn.to(N[y]);h.value.viewColumn!==b&&(h._acceptViewColumn(b),this._onDidChangeTextEditorViewColumn.fire({textEditor:h.value,viewColumn:b}))}}getDiffInformation(N){return Promise.resolve(this._proxy.$getDiffInformation(N))}}e.ExtHostEditors=v}),define(Ie[291],Pe([1,0,2,3,4,6,7,8,20,15]),function(ue,e,I,L,T,O,A,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class N{constructor(b,m){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=b.getProxy(T.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this._providers.get(r.source)&&v.ExtensionIdentifier.equals(o,this._providers.get(r.source)?.extension)){const s=r.uri===void 0?void 0:I.URI.revive(r.uri);return this._itemsBySourceAndUriMap.get(r.source)?.get(y(s))?.get(r.handle)}else return;return r}})}async $getTimeline(b,m,r,o){return this._providers.get(b)?.provider.provideTimeline(I.URI.revive(m),r,o)}registerTimelineProvider(b,m,r,o){const s=new O.DisposableStore,i=this.convertTimelineItem(m.id,o,s).bind(this);let n;m.onDidChange&&(n=m.onDidChange(u=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:m.id}),this));const c=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...m,scheme:b,onDidChange:void 0,async provideTimeline(u,t,f){t?.resetCache&&(s.clear(),c.get(m.id)?.clear());const a=await m.provideTimeline(u,t,f);if(a==null)return;const p=i(u,t);return{...a,source:m.id,items:a.items.map(p)}},dispose(){for(const u of c.values())u.get(m.id)?.clear();n?.dispose(),s.dispose()}},r)}convertTimelineItem(b,m,r){return(o,s)=>{let i;if(s?.cacheResults){let n=this._itemsBySourceAndUriMap.get(b);n===void 0&&(n=new Map,this._itemsBySourceAndUriMap.set(b,n));const c=y(o);i=n.get(c),i===void 0&&(i=new Map,n.set(c,i))}return n=>{const{iconPath:c,...u}=n,t=`${b}|${n.id??n.timestamp}`;i?.set(t,n);let f,a,p;n.iconPath&&(c instanceof A.ThemeIcon?p={id:c.id,color:c.color}:I.URI.isUri(c)?(f=c,a=c):{light:f,dark:a}=c);let l;return A.MarkdownString.isMarkdownString(u.tooltip)?l=E.MarkdownString.from(u.tooltip):(0,_.isString)(u.tooltip)?l=u.tooltip:A.MarkdownString.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=E.MarkdownString.from(u.detail)):(0,_.isString)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=u.detail),{...u,id:u.id??void 0,handle:t,source:b,command:n.command?m.toInternal(n.command,r):void 0,icon:f,iconDark:a,themeIcon:p,tooltip:l,accessibilityInformation:n.accessibilityInformation}}}}registerTimelineProviderCore(b,m){if(this._providers.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this._proxy.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this._providers.set(b.id,{provider:b,extension:m}),(0,O.toDisposable)(()=>{for(const o of this._itemsBySourceAndUriMap.values())o.get(b.id)?.clear();this._providers.delete(b.id),this._proxy.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=N;function y(h){return h?.toString()}}),define(Ie[292],Pe([1,0,181,23,2,5,6,222,11,7,15,18,8,55,24,143,26]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function s(c,u){if((0,N.isString)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class i extends A.Disposable{constructor(u,t,f){super(),this._proxy=u,this.commands=t,this.logService=f,this.treeViews=new Map,this.treeDragAndDropService=new r.TreeViewsDnDService;function a(p){return p&&p.$treeViewId&&(p.$treeItemHandle||p.$selectedTreeItems||p.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:p=>a(p)?this.convertArgument(p):Array.isArray(p)&&p.length>0?p.map(l=>a(l)?this.convertArgument(l):l):p})}registerTreeDataProvider(u,t,f){const a=this.createTreeView(u,{treeDataProvider:t},f);return{dispose:()=>a.dispose()}}createTreeView(u,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],p=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,D=!!t.dragAndDropController?.handleDrop,d=this.createExtHostTreeView(u,t,f),w={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:p,hasHandleDrag:l,hasHandleDrop:D,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this._proxy.$registerTreeViewDataProvider(u,w),C={get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get activeItem(){return(0,o.checkProposedApiEnabled)(f,"treeViewActiveItem"),d.focusedElement},get onDidChangeActiveItem(){return(0,o.checkProposedApiEnabled)(f,"treeViewActiveItem"),d.onDidChangeActiveItem},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return d.onDidChangeCheckboxState},get message(){return d.message},set message(S){(0,b.isMarkdownString)(S)&&(0,o.checkProposedApiEnabled)(f,"treeViewMarkdownMessage"),d.message=S},get title(){return d.title},set title(S){d.title=S},get description(){return d.description},set description(S){d.description=S},get badge(){return d.badge},set badge(S){S!==void 0&&_.ViewBadge.isViewBadge(S)?d.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(d.badge=void 0)},reveal:(S,k)=>d.reveal(S,k),dispose:async()=>{await g,this.treeViews.delete(u),d.dispose()}};return this._register(C),C}$getChildren(u,t){const f=this.treeViews.get(u);return f?f.getChildren(t):Promise.reject(new E.NoTreeViewError(u))}async $handleDrop(u,t,f,a,p,l,D,d){const w=this.treeViews.get(u);if(!w)return Promise.reject(new E.NoTreeViewError(u));const g=h.DataTransfer.toDataTransfer(f,async C=>(await this._proxy.$resolveDropFileData(u,t,C)).buffer);return D===u&&d&&await this.addAdditionalTransferItems(g,w,d,p,l),w.onDrop(g,a,p)}async addAdditionalTransferItems(u,t,f,a,p){const l=this.treeDragAndDropService.removeDragOperationTransfer(p);if(l)(await l)?.forEach((D,d)=>{D&&u.set(d,D)});else if(p&&t.handleDrag){const D=t.handleDrag(f,u,a);this.treeDragAndDropService.addDragOperationTransfer(p,D),await D}return u}async $handleDrag(u,t,f,a){const p=this.treeViews.get(u);if(!p)return Promise.reject(new E.NoTreeViewError(u));const l=await this.addAdditionalTransferItems(new _.DataTransfer,p,t,a,f);if(!(!l||a.isCancellationRequested))return h.DataTransfer.from(l)}async $hasResolve(u){const t=this.treeViews.get(u);if(!t)throw new E.NoTreeViewError(u);return t.hasResolve}$resolve(u,t,f){const a=this.treeViews.get(u);if(!a)throw new E.NoTreeViewError(u);return a.resolveTreeItem(t,f)}$setExpanded(u,t,f){const a=this.treeViews.get(u);if(!a)throw new E.NoTreeViewError(u);a.setExpanded(t,f)}$setSelectionAndFocus(u,t,f){const a=this.treeViews.get(u);if(!a)throw new E.NoTreeViewError(u);a.setSelectionAndFocus(t,f)}$setVisible(u,t){const f=this.treeViews.get(u);if(!f){if(!t)return;throw new E.NoTreeViewError(u)}f.setVisible(t)}$changeCheckboxState(u,t){const f=this.treeViews.get(u);if(!f)throw new E.NoTreeViewError(u);f.setCheckboxState(t)}createExtHostTreeView(u,t,f){const a=this._register(new n(u,t,this._proxy,this.commands.converter,this.logService,f));return this.treeViews.set(u,a),a}convertArgument(u){const t=this.treeViews.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=i;class n extends A.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(u=>this.getExtensionElement(u)).filter(u=>!(0,N.isUndefinedOrNull)(u))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(u,t,f,a,p,l){if(super(),this.viewId=u,this.proxy=f,this.commands=a,this.logService=p,this.extension=l,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new O.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new O.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new O.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new O.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new O.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new O.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,l.contributes&&l.contributes.views)for(const g in l.contributes.views)for(const C of l.contributes.views[g])C.id===u&&(this._title=C.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(g=>{Array.isArray(g)&&g.length===0||this._onDidChangeData.fire({message:!1,element:g})}));let D,d;const w=O.Event.debounce(this._onDidChangeData.event,(g,C)=>(g||(g={message:!1,elements:[]}),C.element!==!1&&(D||(D=new Promise(S=>d=S),this.refreshPromise=this.refreshPromise.then(()=>D)),Array.isArray(C.element)?g.elements.push(...C.element):g.elements.push(C.element)),C.message&&(g.message=!0),g),200,!0);this._register(w(({message:g,elements:C})=>{C.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const S=d;return D=null,this.refresh(C).then(()=>S())})),g&&this.proxy.$setMessage(this.viewId,h.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.logService.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let f=this.getChildrenNodes(u);return f||(f=await this.fetchChildrenNodes(t)),f?f.map(a=>a.item):void 0}getExtensionElement(u){return this.elements.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const f=(0,N.isUndefinedOrNull)(t.select)?!0:t.select,a=(0,N.isUndefinedOrNull)(t.focus)?!1:t.focus,p=(0,N.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.refreshPromise.then(()=>this.resolveUnknownParentChain(u)).then(l=>this.resolveTreeNode(u,l[l.length-1]).then(D=>this.proxy.$reveal(this.viewId,{item:D.item,parentChain:l.map(d=>d.item)},{select:f,focus:a,expand:p})),l=>this.logService.error(l)):this.proxy.$reveal(this.viewId,void 0,{select:f,focus:a,expand:p})}get message(){return this._message}set message(u){this._message=u,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(u){this._title=u,this.proxy.$setTitle(this.viewId,u,this._description)}get description(){return this._description}set description(u){this._description=u,this.proxy.$setTitle(this.viewId,this._title,u)}get badge(){return this._badge}set badge(u){this._badge?.value===u?.value&&this._badge?.tooltip===u?.tooltip||(this._badge=h.ViewBadge.from(u),this.proxy.$setBadge(this.viewId,u))}setExpanded(u,t){const f=this.getExtensionElement(u);f&&(t?this._onDidExpandElement.fire(Object.freeze({element:f})):this._onDidCollapseElement.fire(Object.freeze({element:f})))}setSelectionAndFocus(u,t){const f=!(0,y.equals)(this._selectedHandles,u);this._selectedHandles=u;const a=this._focusedHandle!==t;this._focusedHandle=t,f&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),a&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this._visible&&(this._visible=u,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async f=>{const a=this.getExtensionElement(f.treeItemHandle);return a?{extensionItem:a,treeItem:await this.dataProvider.getTreeItem(a),newState:f.newState?_.TreeItemCheckboxState.Checked:_.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?_.TreeItemCheckboxState.Checked:_.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(u,t,f){const a=[];for(const p of u){const l=this.getExtensionElement(p);l&&a.push(l)}if(!(!this.dndController?.handleDrag||a.length===0))return await this.dndController.handleDrag(a,t,f),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(u,t,f){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.dndController?.handleDrop))return(0,v.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(a,u,f):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(u,t){if(!this.dataProvider.resolveTreeItem)return;const f=this.elements.get(u);if(f){const a=this.nodes.get(f);if(a){const p=await this.dataProvider.resolveTreeItem(a.extensionItem,f,t)??a.extensionItem;return this.validateTreeItem(p),a.item.tooltip=this.getTooltip(p.tooltip),a.item.command=this.getCommand(a.disposableStore,p.command),a.item}}}resolveUnknownParentChain(u){return this.resolveParent(u).then(t=>t?this.resolveUnknownParentChain(t).then(f=>this.resolveTreeNode(t,f[f.length-1]).then(a=>(f.push(a),f))):Promise.resolve([]))}resolveParent(u){const t=this.nodes.get(u);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,v.asPromise)(()=>this.dataProvider.getParent(u))}resolveTreeNode(u,t){const f=this.nodes.get(u);return f?Promise.resolve(f):(0,v.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(a=>this.createHandle(u,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const p=this.getExtensionElement(a);if(p){const l=this.nodes.get(p);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(u){if(u){let t;if(typeof u=="string"){const f=this.getExtensionElement(u);t=f?this.nodes.get(f):void 0}else t=u;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(u){this.clearChildren(u);const t=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const f=u?this.nodes.get(u):void 0,a=await this.dataProvider.getChildren(u);if(t.token.isCancellationRequested)return;const p=(0,y.coalesce)(a||[]),l=await Promise.all((0,y.coalesce)(p).map(d=>this.dataProvider.getTreeItem(d)));if(t.token.isCancellationRequested)return;const D=l.map((d,w)=>d?this.createAndRegisterTreeNode(p[w],d,f):null);return(0,y.coalesce)(D)}finally{t.dispose()}}refresh(u){if(u.some(f=>!f))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const f=this.getHandlesToRefresh(u);if(f.length)return this.refreshHandles(f)}return Promise.resolve(void 0)}getHandlesToRefresh(u){const t=new Set,f=u.map(p=>this.nodes.get(p));for(const p of f)if(p&&!t.has(p.item.handle)){let l=p;for(;l&&l.parent&&f.findIndex(D=>l&&l.parent&&D&&D.item.handle===l.parent.item.handle)===-1;){const D=this.elements.get(l.parent.item.handle);l=D?this.nodes.get(D):void 0}l&&!l.parent&&t.add(p.item.handle)}const a=[];return t.forEach(p=>{const l=this.elements.get(p);if(l){const D=this.nodes.get(l);D&&(!D.parent||!t.has(D.parent.item.handle))&&a.push(p)}}),a}refreshHandles(u){const t={};return Promise.all(u.map(f=>this.refreshNode(f).then(a=>{a&&(t[f]=a.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(u){const t=this.getExtensionElement(u);if(t){const f=this.nodes.get(t);if(f)return this.clearChildren(t),(0,v.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(a=>{if(a){const p=this.createTreeNode(t,a,f.parent);return this.updateNodeCache(t,p,f,f.parent),f.dispose(),p}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(u,t,f){const a=this.createTreeNode(u,t,f);if(t.id&&this.elements.has(a.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.addNodeToCache(u,a),this.addNodeToParentCache(a,f),a}getTooltip(u){return _.MarkdownString.isMarkdownString(u)?h.MarkdownString.from(u):u}getCommand(u,t){return t?{...this.commands.toInternal(t,u),originalId:t.command}:void 0}getCheckbox(u){if(u.checkboxState===void 0)return;let t,f,a;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,f=u.checkboxState.tooltip,a=u.checkboxState.accessibilityInformation),{isChecked:t===_.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:a}}validateTreeItem(u){if(!_.TreeItem.isTreeItem(u,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(u,t,f){this.validateTreeItem(t);const a=this._register(new A.DisposableStore),p=this.createHandle(u,t,f),l=this.getLightIconPath(t);return{item:{handle:p,parentHandle:f?f.item.handle:void 0,label:s(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(a,t.command),contextValue:t.contextValue,icon:l,iconDark:this.getDarkIconPath(t)||l,themeIcon:this.getThemeIcon(t),collapsibleState:(0,N.isUndefinedOrNull)(t.collapsibleState)?_.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:f,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(u){return u.iconPath instanceof _.ThemeIcon?u.iconPath:void 0}createHandle(u,{id:t,label:f,resourceUri:a},p,l){if(t)return`${n.ID_HANDLE_PREFIX}/${t}`;const D=s(f,this.extension),d=p?p.item.handle:n.LABEL_HANDLE_PREFIX;let w=D?D.label:a?(0,L.basename)(a):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const g=this.nodes.has(u)?this.nodes.get(u).item.handle:void 0,C=this.getChildrenNodes(p)||[];let S,k=0;do{if(S=`${d}/${k}:${w}`,l||!this.elements.has(S)||g===S)break;k++}while(k<=C.length);return S}getLightIconPath(u){if(u.iconPath&&!(u.iconPath instanceof _.ThemeIcon))return typeof u.iconPath=="string"||T.URI.isUri(u.iconPath)?this.getIconPath(u.iconPath):this.getIconPath(u.iconPath.light)}getDarkIconPath(u){if(u.iconPath&&!(u.iconPath instanceof _.ThemeIcon)&&u.iconPath.dark)return this.getIconPath(u.iconPath.dark)}getIconPath(u){return T.URI.isUri(u)?u:T.URI.file(u)}addNodeToCache(u,t){this.elements.set(t.item.handle,u),this.nodes.set(u,t)}updateNodeCache(u,t,f,a){this.elements.delete(t.item.handle),this.nodes.delete(u),t.item.handle!==f.item.handle&&this.elements.delete(f.item.handle),this.addNodeToCache(u,t);const p=this.getChildrenNodes(a)||[],l=p.filter(D=>D.item.handle===f.item.handle)[0];l&&p.splice(p.indexOf(l),1,t)}addNodeToParentCache(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.roots||(this.roots=[]),this.roots.push(u))}clearChildren(u){if(u){const t=this.nodes.get(u);if(t){if(t.children)for(const f of t.children){const a=this.elements.get(f.item.handle);a&&this.clear(a)}t.children=void 0}}else this.clearAll()}clear(u){const t=this.nodes.get(u);if(t){if(t.children)for(const f of t.children){const a=this.elements.get(f.item.handle);a&&this.clear(a)}this.nodes.delete(u),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(u=>u.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Ie[293],Pe([1,0,5,6,2,34,8,64,4,7]),function(ue,e,I,L,T,O,A,E,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class N extends L.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;#d;constructor(m,r,o,s){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#h=this._register(new I.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new I.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=m,this.#t=r,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#l=s.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(m){this.assertNotDisposed(),this.#r!==m&&(this.#r=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(m){this.assertNotDisposed(),this.#a!==m&&(this.#a=m,this.#t.$setIconPath(this.#e,T.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#l}get visible(){return this.assertNotDisposed(),this.#c}_updateViewState(m){this.#u||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#l=m.active,this.#c=m.visible,this.#o=m.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(m,r){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:A.ViewColumn.from(m),preserveFocus:!!r})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class y extends L.Disposable{static newHandle(){return(0,O.generateUuid)()}constructor(m,r,o){super(),this.webviews=r,this.workspace=o,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(v.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(m=>m.dispose()),this._webviewPanels.clear()}createWebviewPanel(m,r,o,s,i={}){const n=typeof s=="object"?s.viewColumn:s,c={viewColumn:A.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},u=(0,E.shouldSerializeBuffersForPostMessage)(m),t=y.newHandle();this._proxy.$createWebviewPanel((0,E.toExtensionData)(m),t,r,{title:o,panelOptions:h(i),webviewOptions:(0,E.serializeWebviewOptions)(m,this.workspace,i),serializeBuffersForPostMessage:u},c);const f=this.webviews.createNewWebview(t,i,m);return this.createNewWebviewPanel(t,r,o,n,i,f,!0)}$onDidChangeWebviewPanelViewStates(m){const r=Object.keys(m);r.sort((o,s)=>{const i=m[o],n=m[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const o of r){const s=this.getWebviewPanel(o);if(!s)continue;const i=m[o];s._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,r,o){if(this._serializers.has(r))throw new Error(`Serializer for '${r}' already registered`);return this._serializers.set(r,{serializer:o,extension:m}),this._proxy.$registerSerializer(r,{serializeBuffersForPostMessage:(0,E.shouldSerializeBuffersForPostMessage)(m)}),new _.Disposable(()=>{this._serializers.delete(r),this._proxy.$unregisterSerializer(r)})}async $deserializeWebviewPanel(m,r,o,s){const i=this._serializers.get(r);if(!i)throw new Error(`No serializer found for '${r}'`);const{serializer:n,extension:c}=i,u=this.webviews.createNewWebview(m,o.webviewOptions,c),t=this.createNewWebviewPanel(m,r,o.title,s,o.panelOptions,u,o.active);await n.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(m,r,o,s,i,n,c){const u=new N(m,this._proxy,n,{viewType:r,title:o,viewColumn:s,panelOptions:i,active:c});return this._webviewPanels.set(m,u),u}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=y;function h(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ie[294],Pe([1,0,5,6,64,8,4,7]),function(ue,e,I,L,T,O,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class v extends L.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,h,b,m,r,o){super(),this.#s=!1,this.#l=this._register(new I.Emitter),this.onDidChangeVisibility=this.#l.event,this.#u=this._register(new I.Emitter),this.onDidDispose=this.#u.event,this.#i=b,this.#a=m,this.#e=y,this.#t=h,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.assertNotDisposed(),this.#a}set title(y){this.assertNotDisposed(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.assertNotDisposed(),this.#o}set description(y){this.assertNotDisposed(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.assertNotDisposed(),this.#c}set badge(y){this.assertNotDisposed(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.assertNotDisposed(),this.#t.$show(this.#e,!!y)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class _{constructor(y,h){this._extHostWebview=h,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(y,h,b,m){if(this._viewProviders.has(h))throw new Error(`View provider for '${h}' already registered`);return this._viewProviders.set(h,{provider:b,extension:y}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(y),h,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(y)}),new E.Disposable(()=>{this._viewProviders.delete(h),this._proxy.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(y,h,b,m,r){const o=this._viewProviders.get(h);if(!o)throw new Error(`No view provider found for '${h}'`);const{provider:s,extension:i}=o,n=this._extHostWebview.createNewWebview(y,{},i),c=new v(y,this._proxy,h,b,n,!0);this._webviewViews.set(y,c),await s.resolveWebviewView(c,{state:m},r)}async $onDidChangeWebviewViewVisibility(y,h){this.getWebviewView(y)._setVisible(h)}async $disposeWebviewView(y){const h=this.getWebviewView(y);this._webviewViews.delete(y),h.dispose(),this._extHostWebview.deleteWebview(y)}getWebviewView(y){const h=this._webviewViews.get(y);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=_}),define(Ie[295],Pe([1,0,5,29,31,3]),function(ue,e,I,L,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new T.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new T.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new T.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new T.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new T.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new T.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,O.createDecorator)("outputService");var A;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class E{constructor(){this.channels=new Map,this._onDidRegisterChannel=new I.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new I.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(_){this.channels.has(_.id)||(this.channels.set(_.id,_),this._onDidRegisterChannel.fire(_.id))}getChannels(){const _=[];return this.channels.forEach(N=>_.push(N)),_}getChannel(_){return this.channels.get(_)}removeChannel(_){this.channels.delete(_),this._onDidRemoveChannel.fire(_)}}L.Registry.add(e.Extensions.OutputChannels,new E),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new T.RawContextKey("activeOutputChannel","")}),define(Ie[118],Pe([1,0,4,3,17,20,12,295,65,27,46,147,21,15,38,5,6]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class s extends A.AbstractMessageLogger{get disposed(){return this._disposed}constructor(u,t,f,a,p){super(),this.id=u,this.name=t,this.logger=f,this.proxy=a,this.extension=p,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(f.getLevel()),this._register(f.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.offset;this.logger.flush(),this.proxy.$update(this.id,E.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.offset;this.info(u),this.proxy.$update(this.id,E.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(u,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.proxy.$close(this.id)}log(u,t){this.offset+=h.VSBuffer.fromString(t).byteLength,(0,A.log)(this.logger,u,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,E.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class i extends s{appendLine(u){this.append(u)}}let n=class{constructor(u,t,f,a,p,l){this.initData=t,this.extHostFileSystem=f,this.extHostFileSystemInfo=a,this.loggerService=p,this.logService=l,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=u.getProxy(I.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.visibleChannelId=u;for(const[t,f]of this.channels)f.visible=t===this.visibleChannelId}createOutputChannel(u,t,f){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,p=(0,b.isString)(t)?t:void 0;if((0,b.isString)(p)&&!p.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const D=this.initData.environment.extensionLogLevel?.find(([w])=>O.ExtensionIdentifier.equals(f.identifier,w))?.[1];D&&(l=(0,A.parseLogLevel)(D));const d=a?this.doCreateLogOutputChannel(u,l,f):this.doCreateOutputChannel(u,p,f);return d.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),a?this.createExtHostLogOutputChannel(u,l??this.logService.getLevel(),d):this.createExtHostOutputChannel(u,d)}async doCreateOutputChannel(u,t,f){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const a=await this.outputDirectoryPromise,p=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.loggerService.createLogger(p,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),D=await this.proxy.$register(u,p,t,f.identifier.value);return new s(D,u,l,this.proxy,f)}async doCreateLogOutputChannel(u,t,f){const a=await this.createExtensionLogDirectory(f),p=u.replace(/[\\/:\*\?"<>\|]/g,""),l=this.extHostFileSystemInfo.extUri.joinPath(a,`${p}.log`),D=`${f.identifier.value}.${p}`,d=this.loggerService.createLogger(l,{id:D,name:u,logLevel:t,extensionId:f.identifier.value});return new i(D,u,d,this.proxy,f)}createExtensionLogDirectory(u){let t=this.extensionLogDirectoryPromise.get(u.identifier.value);if(!t){const f=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,u.identifier.value);this.extensionLogDirectoryPromise.set(u.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(f)}catch(a){if((0,m.toFileSystemProviderErrorCode)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}return f})())}return t}createExtHostOutputChannel(u,t){let f=!1;const a=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return u},append(p){a(),t.then(l=>l.append(p))},appendLine(p){a(),t.then(l=>l.appendLine(p))},clear(){a(),t.then(p=>p.clear())},replace(p){a(),t.then(l=>l.replace(p))},show(p,l){a(),t.then(D=>D.show(p,l))},hide(){a(),t.then(p=>p.hide())},dispose(){f=!0,t.then(p=>p.dispose())}}}createExtHostLogOutputChannel(u,t,f){const a=new o.DisposableStore,p=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},l=a.add(new r.Emitter);function D(d){t=d,l.fire(d)}return f.then(d=>{a.add(d),d.logLevel!==t&&D(d.logLevel),a.add(d.onDidChangeLogLevel(w=>D(w)))}),{...this.createExtHostOutputChannel(u,f),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(d,...w){p(),f.then(g=>g.trace(d,...w))},debug(d,...w){p(),f.then(g=>g.debug(d,...w))},info(d,...w){p(),f.then(g=>g.info(d,...w))},warn(d,...w){p(),f.then(g=>g.warn(d,...w))},error(d,...w){p(),f.then(g=>g.error(d,...w))},dispose(){a.dispose()}}}};e.ExtHostOutputService=n,e.ExtHostOutputService=n=Ke([He(0,T.IExtHostRpcService),He(1,_.IExtHostInitDataService),He(2,v.IExtHostConsumerFileSystem),He(3,N.IExtHostFileSystemInfo),He(4,A.ILoggerService),He(5,A.ILogService)],n),e.IExtHostOutputService=(0,L.createDecorator)("IExtHostOutputService")}),define(Ie[119],Pe([1,0,3,11]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,I.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(T){let O=1/0;for(let E=0;E<this.maxSampleCount;E++){const v=await T.getRoundTripTime();if(v===void 0)return;O=Math.min(O,v/2),await(0,L.timeout)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((E,v)=>E+v,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((E,v)=>E+v,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ie[296],Pe([1,0,184,51,29,45,50,6,5,119,22,25,11]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new v.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const m=new b;T.Registry.add(e.Extensions.ConfigurationMigration,m);let r=class extends E.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.configurationService=i,this.workspaceService=n,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async c=>{for(const u of c.added)await this.migrateConfigurationsForFolder(u,m.migrations)})),this.migrateConfigurations(m.migrations),this._register(m.onDidRegisterConfigurationMigration(c=>this.migrateConfigurations(c)))}async migrateConfigurations(i){await this.migrateConfigurationsForFolder(void 0,i);for(const n of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(n,i)}async migrateConfigurationsForFolder(i,n){await Promise.all([n.map(c=>this.migrateConfigurationsForFolderAndOverride(c,i?.uri))])}async migrateConfigurationsForFolderAndOverride(i,n){const c=this.configurationService.inspect(i.key,{resource:n}),u=this.workspaceService.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of u){const a=c[t];if(!a)continue;const p=[];if(a.value!==void 0){const l=await this.runMigration(i,t,a.value,n,void 0);for(const D of l??[])p.push([D,[]])}for(const{identifiers:l,value:D}of a.overrides??[])if(D!==void 0){const d=await this.runMigration(i,t,D,n,l);for(const w of d??[])p.push([w,l])}p.length&&await Promise.allSettled(p.map(async([[l,D],d])=>this.configurationService.updateValue(l,D.value,{resource:n,overrideIdentifiers:d},f)))}}async runMigration(i,n,c,u,t){const f=p=>{const D=this.configurationService.inspect(p,{resource:u})[n];if(D)return t?D.overrides?.find(({identifiers:d})=>(0,y.equals)(d,t))?.value:D.value},a=await i.migrateFn(c,f);return Array.isArray(a)?a:[[i.key,a]]}};e.ConfigurationMigrationWorkbenchContribution=r,e.ConfigurationMigrationWorkbenchContribution=r=Ke([He(0,A.IConfigurationService),He(1,O.IWorkspaceContextService)],r);let o=class extends E.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.remoteAgentService=i,this._ready=new h.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!N.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==1)return;T.Registry.as(L.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.DynamicWorkbenchSecurityConfiguration=o,e.DynamicWorkbenchSecurityConfiguration=o=Ke([He(0,_.IRemoteAgentService)],o)}),define(Ie[297],Pe([1,0,37,16,19,23,193,296,51,3,29]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=r,e.globMatchesResource=o,e.IEditorResolverService=(0,_.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const y=N.Registry.as(v.Extensions.Configuration),h={...E.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(h);var b;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(b||(e.RegisteredEditorPriority=b={}));var m;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function r(s){switch(s){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function o(s,i){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(i.scheme))return!1;const u=typeof s=="string"&&s.indexOf(T.posix.sep)>=0?`${i.scheme}:${i.path}`:(0,O.basename)(i);return I.match(typeof s=="string"?s.toLowerCase():s,u.toLowerCase())}}),define(Ie[298],Pe([1,0,48,16,19,22,23,2,3,214,45,236,119]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,v.createDecorator)("pathService");let m=b=class{constructor(o,s,i,n){this.localUserHome=o,this.remoteAgentService=s,this.environmentService=i,this.contextService=n,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||O.OS)(),this.resolveUserHome=(async()=>{const c=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=c?.userHome??o})()}hasValidBasename(o,s,i){return typeof s=="string"||typeof s>"u"?this.resolveOS.then(n=>this.doHasValidBasename(o,n,s)):this.doHasValidBasename(o,s,i)}doHasValidBasename(o,s,i){return o.scheme===L.Schemas.file||o.scheme===L.Schemas.vscodeRemote?(0,I.isValidBasename)(i??(0,A.basename)(o),s===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return L.Schemas.vscodeRemote;const i=(0,_.getVirtualWorkspaceScheme)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=s.getWorkspace().configuration;return c?c.scheme:L.Schemas.file}userHome(o){return o?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(o=>o===1?T.win32:T.posix)}async fileURI(o){let s="";if(await this.resolveOS===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const n=o.indexOf("/",2);n===-1?(s=o.substring(2),o="/"):(s=o.substring(2,n),o=o.substring(n)||"/")}return E.URI.from({scheme:L.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.AbstractPathService=m,e.AbstractPathService=m=b=Ke([He(1,h.IRemoteAgentService),He(2,y.IWorkbenchEnvironmentService),He(3,N.IWorkspaceContextService)],m)}),define(Ie[120],Pe([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class I{constructor(A,E){this.line=A,this.character=E}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,E){return new I(0,0)}with(A){return new I(0,0)}}e.Position=I;class L{constructor(A,E,v,_){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(A,E),this.end=new I(v,_)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new L(0,0,0,0)}with(A){return new L(0,0,0,0)}}e.Range=L;var T;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(T||(e.TextSearchCompleteMessageType=T={}))}),define(Ie[47],Pe([1,0,18,37,25,48,13,3,19,14,120,11]),function(ue,e,I,L,T,O,A,E,v,_,N,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=s,e.isFileMatch=i,e.isProgressMessage=n,e.getExcludes=d,e.pathIncludedInQuery=w,e.deserializeSearchError=S,e.serializeSearchError=k,e.isSerializedSearchComplete=P,e.isSerializedSearchSuccess=H,e.isSerializedFileMatch=$,e.isFilePatternMatch=V,e.resolvePatternsForProvider=z,e.hasSiblingPromiseFn=ce,e.hasSiblingFn=Se,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const h="\u27EA ",b=" characters skipped \u27EB",m=(h.length+b.length+5)*2;e.ISearchService=(0,E.createDecorator)("searchService");var r;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text",fe[fe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text",fe[fe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(fe){return!!fe.preview}function i(fe){return!!fe.resource}function n(fe){return!!fe.message}var c;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class u{constructor(pe){this.resource=pe,this.results=[]}}e.FileMatch=u;class t{constructor(pe,Ne,ae,Re){this.ranges=Ne,this.webviewIndex=Re;const ne=Array.isArray(Ne)?Ne:[Ne];if(ae&&ae.matchLines===1&&f(ne)){pe=(0,A.getNLines)(pe,ae.matchLines);let x="",J=0,be=0;const Me=Math.floor(ae.charsPerLine/5),ye=[];for(const Ee of ne){const ge=Math.max(Ee.startColumn-Me,0),G=Ee.startColumn+ae.charsPerLine;if(ge>be+Me+m){const Y=h+(ge-be)+b;x+=Y+pe.slice(ge,G),J+=ge-(be+Y.length)}else x+=pe.slice(be,G);ye.push(new p(0,Ee.startColumn-J,Ee.endColumn-J)),be=G}this.preview={text:x,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const x=Array.isArray(Ne)?Ne[0].startLineNumber:Ne.startLineNumber;this.preview={text:pe,matches:(0,I.mapArrayOrNot)(Ne,J=>new a(J.startLineNumber-x,J.startColumn,J.endLineNumber-x,J.endColumn))}}}}e.TextSearchMatch=t;function f(fe){const pe=fe[0].startLineNumber;for(const Ne of fe)if(Ne.startLineNumber!==pe||Ne.endLineNumber!==pe)return!1;return!0}class a{constructor(pe,Ne,ae,Re){this.startLineNumber=pe,this.startColumn=Ne,this.endLineNumber=ae,this.endColumn=Re}}e.SearchRange=a;class p extends a{constructor(pe,Ne,ae){super(pe,Ne,pe,ae)}}e.OneLineRange=p;var l;(function(fe){fe.List="list",fe.Tree="tree"})(l||(e.ViewMode=l={}));var D;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(D||(e.SearchSortOrder=D={}));function d(fe,pe=!0){const Ne=fe&&fe.files&&fe.files.exclude,ae=pe&&fe&&fe.search&&fe.search.exclude;if(!Ne&&!ae)return;if(!Ne||!ae)return Ne||ae;let Re=Object.create(null);return Re=T.mixin(Re,T.deepClone(Ne)),Re=T.mixin(Re,T.deepClone(ae),!0),Re}function w(fe,pe){return fe.excludePattern&&L.match(fe.excludePattern,pe)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&L.match(fe.includePattern,pe)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(Ne=>{const ae=Ne.folder.fsPath;if(O.isEqualOrParent(pe,ae)){const Re=v.relative(ae,pe);return!Ne.includePattern||!!L.match(Ne.includePattern,Re)}else return!1}):!1:!0}var g;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class C extends Error{constructor(pe,Ne){super(pe),this.code=Ne}}e.SearchError=C;function S(fe){const pe=fe.message;if((0,_.isCancellationError)(fe))return new C(pe,g.canceled);try{const Ne=JSON.parse(pe);return new C(Ne.message,Ne.code)}catch{return new C(pe,g.other)}}function k(fe){const pe={message:fe.message,code:fe.code};return new Error(JSON.stringify(pe))}function P(fe){return fe.type==="error"?!0:fe.type==="success"}function H(fe){return fe.type==="success"}function $(fe){return!!fe.path}function V(fe,pe,Ne=!0){const ae=fe.searchPath?fe.searchPath:fe.relativePath;return Ne?(0,A.fuzzyContains)(ae,pe):L.match(pe,ae)}class R{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=R;function z(fe,pe){const Ne={...fe||{},...pe||{}};return Object.keys(Ne).filter(ae=>{const Re=Ne[ae];return typeof Re=="boolean"&&Re})}class q{constructor(pe,Ne){this._parsedIncludeExpression=null,this._excludeExpression={...pe.excludePattern||{},...Ne.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let ae=pe.includePattern;Ne.includePattern&&(ae?ae={...ae,...Ne.includePattern}:ae=Ne.includePattern),ae&&(this._parsedIncludeExpression=L.parse(ae))}matchesExcludesSync(pe,Ne,ae){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,Ne,ae))}includedInQuerySync(pe,Ne,ae){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,Ne,ae)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(pe,Ne,ae))}includedInQuery(pe,Ne,ae){const Re=this._parsedExcludeExpression(pe,Ne,ae),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(pe,Ne,ae):!0;return(0,y.isThenable)(Re)?Re.then(x=>x?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this._excludeExpression)}}e.QueryGlobTester=q;function ie(fe){for(const pe in fe)if(typeof fe[pe]!="boolean")return!0;return!1}function ce(fe){if(!fe)return;let pe;return Ne=>(pe||(pe=(fe()||Promise.resolve([])).then(ae=>ae?De(ae):{})),pe.then(ae=>!!ae[Ne]))}function Se(fe){if(!fe)return;let pe;return Ne=>{if(!pe){const ae=fe();pe=ae?De(ae):{}}return!!pe[Ne]}}function De(fe){const pe={};for(const Ne of fe)pe[Ne]=!0;return pe}}),define(Ie[39],Pe([1,0,18,11,24,5,6,54,16,129,23,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c,u,t,f,a,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function D(H,$,V){return new N.ExtUri(R=>C(R,V)).isEqual(H,$)}function d(H,$,V){return D(H.uri,$.uri,V)?0:(0,y.compare)(H.uri.toString(),$.uri.toString())}function w(H,$,V){return H.index!==$.index?H.index<$.index?-1:1:D(H.uri,$.uri,V)?(0,y.compare)(H.name,$.name):(0,y.compare)(H.uri.toString(),$.uri.toString())}function g(H,$,V,R){const z=H.slice(0).sort((ie,ce)=>V(ie,ce,R)),q=$.slice(0).sort((ie,ce)=>V(ie,ce,R));return(0,I.delta)(z,q,(ie,ce)=>V(ie,ce,R))}function C(H,$){const V=$.getCapabilities(H.scheme);return!(V&&V&1024)}class S extends s.Workspace{static toExtHostWorkspace($,V,R,z){if(!$)return{workspace:null,added:[],removed:[]};const{id:q,name:ie,folders:ce,configuration:Se,transient:De,isUntitled:fe}=$,pe=[],Ne=V;V?ce.forEach((x,J)=>{const be=h.URI.revive(x.uri),Me=S._findFolder(R||V,be,z);Me?(Me.name=x.name,Me.index=x.index,pe.push(Me)):pe.push({uri:be,name:x.name,index:J})}):pe.push(...ce.map(({uri:x,name:J,index:be})=>({uri:h.URI.revive(x),name:J,index:be}))),pe.sort((x,J)=>x.index<J.index?-1:1);const ae=new S(q,ie,pe,!!De,Se?h.URI.revive(Se):null,!!fe,x=>C(x,z)),{added:Re,removed:ne}=g(Ne?Ne.workspaceFolders:[],ae.workspaceFolders,d,z);return{workspace:ae,added:Re,removed:ne}}static _findFolder($,V,R){for(let z=0;z<$.folders.length;z++){const q=$.workspaceFolders[z];if(D(q.uri,V,R))return q}}constructor($,V,R,z,q,ie,ce){super($,R.map(Se=>new s.WorkspaceFolder(Se)),z,q,ce),this._name=V,this._isUntitled=ie,this._workspaceFolders=[],this._structure=E.TernarySearchTree.forUris(ce),R.forEach(Se=>{this._workspaceFolders.push(Se),this._structure.set(Se.uri,Se)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder($,V){return V&&this._structure.get($)&&($=(0,N.dirname)($)),this._structure.findSubstr($)}resolveWorkspaceFolder($){return this._structure.get($)}}let k=class{constructor($,V,R,z,q){this._onDidChangeWorkspace=new O.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new O.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new O.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=z,this._extHostFileSystemInfo=R,this._uriTransformerService=q,this._requestIdProvider=new _.Counter,this._barrier=new L.Barrier,this._proxy=$.getProxy(p.MainContext.MainThreadWorkspace),this._messageService=$.getProxy(p.MainContext.MainThreadMessageService);const ie=V.workspace;this._confirmedWorkspace=ie?new S(ie.id,ie.name,[],!!ie.transient,ie.configuration?h.URI.revive(ie.configuration):null,!!ie.isUntitled,ce=>C(ce,R)):void 0}$initializeWorkspace($,V){this._trusted=V,this.$acceptWorkspaceData($),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?h.URI.from({scheme:v.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders($,V,R,...z){const q=[];if(Array.isArray(z)&&z.forEach(fe=>{h.URI.isUri(fe.uri)&&!q.some(pe=>D(pe.uri,fe.uri,this._extHostFileSystemInfo))&&q.push({uri:fe.uri,name:fe.name||(0,N.basenameOrAuthority)(fe.uri)})}),this._unconfirmedWorkspace||[V,R].some(fe=>typeof fe!="number"||fe<0)||R===0&&q.length===0)return!1;const ie=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(V+R>ie.length)return!1;const ce=ie.slice(0);ce.splice(V,R,...q.map(fe=>({uri:fe.uri,name:fe.name||(0,N.basenameOrAuthority)(fe.uri),index:void 0})));for(let fe=0;fe<ce.length;fe++){const pe=ce[fe];if(ce.some((Ne,ae)=>ae!==fe&&D(pe.uri,Ne.uri,this._extHostFileSystemInfo)))return!1}ce.forEach((fe,pe)=>fe.index=pe);const{added:Se,removed:De}=g(ie,ce,w,this._extHostFileSystemInfo);if(Se.length===0&&De.length===0)return!1;if(this._proxy){const fe=$.displayName||$.name;this._proxy.$updateWorkspaceFolders(fe,V,R,q).then(void 0,pe=>{this._unconfirmedWorkspace=void 0;const Ne={source:{identifier:$.identifier,label:$.displayName||$.name}};this._messageService.$showMessage(o.Severity.Error,(0,b.localize)(0,null,fe,pe.toString()),Ne,[])})}return this.trySetWorkspaceFolders(ce),!0}getWorkspaceFolder($,V){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,V)}async getWorkspaceFolder2($,V){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,V)}async resolveWorkspaceFolder($){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder($)}getPath(){if(!this._actualWorkspace)return;const{folders:$}=this._actualWorkspace;if($.length!==0)return $[0].uri.fsPath}getRelativePath($,V){let R,z="";if(typeof $=="string"?(R=h.URI.file($),z=$):typeof $<"u"&&(R=$,z=$.fsPath),!R)return z;const q=this.getWorkspaceFolder(R,!0);if(!q)return z;typeof V>"u"&&this._actualWorkspace&&(V=this._actualWorkspace.folders.length>1);let ie=(0,N.relativePath)(q.uri,R);return V&&q.name&&(ie=`${q.name}/${ie}`),ie}trySetWorkspaceFolders($){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:$,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData($){const{workspace:V,added:R,removed:z}=S.toExtHostWorkspace($,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=V||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:z}))}findFiles($,V,R,z,q=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let ie="",ce=!0;return V===null?ce=!1:V!==void 0&&(typeof V=="string"?ie=V:ie=V.pattern),this._findFilesImpl($,void 0,{exclude:ie,maxResults:R,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},q)}findFiles2($,V={},R,z=T.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,$,V,z)}async _findFilesImpl($,V,R,z=T.CancellationToken.None){if(z&&z.isCancellationRequested)return Promise.resolve([]);const q=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,ie={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:q,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let ce;if($){const{includePattern:Se,folder:De}=P(u.GlobPattern.from($));ce=De,ie.includePattern=Se}else{const{includePattern:Se,folder:De}=P(u.GlobPattern.from(V));ce=De,ie.filePattern=Se}return this._proxy.$startFileSearch(ce??null,ie,z).then(Se=>Array.isArray(Se)?Se.map(De=>h.URI.revive(De)):[])}async findTextInFiles($,V,R,z,q=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const ie=this._requestIdProvider.getNext(),ce=typeof V.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:Se,folder:De}=P(u.GlobPattern.from(V.include)),fe=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,pe={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:ce,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:Se,excludePattern:fe},Ne=!1;if(this._activeSearchCallbacks[ie]=ae=>{if(Ne)return;const Re=h.URI.revive(ae.resource);ae.results.forEach(ne=>{const x=(0,l.revive)(ne);(0,a.resultIsMatch)(x)?R({uri:Re,preview:{text:x.preview.text,matches:(0,I.mapArrayOrNot)(x.preview.matches,J=>new t.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))},ranges:(0,I.mapArrayOrNot)(x.ranges,J=>new t.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))}):R({uri:Re,text:x.text,lineNumber:x.lineNumber})})},q.isCancellationRequested)return{};try{const ae=await this._proxy.$startTextSearch($,De??null,pe,ie,q);return delete this._activeSearchCallbacks[ie],ae||{}}catch(ae){throw delete this._activeSearchCallbacks[ie],ae}}$handleTextSearchResult($,V){this._activeSearchCallbacks[V]?.($)}async save($){const V=await this._proxy.$save($,{saveAs:!1});return h.URI.revive(V)}async saveAs($){const V=await this._proxy.$save($,{saveAs:!0});return h.URI.revive(V)}saveAll($){return this._proxy.$saveAll($)}resolveProxy($){return this._proxy.$resolveProxy($)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust($){return this._proxy.$requestWorkspaceTrust($)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider($,V){if(this._editSessionIdentityProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._editSessionIdentityProviders.set($,V);const R=this._uriTransformerService.transformOutgoingScheme($),z=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(z,R),(0,A.toDisposable)(()=>{this._editSessionIdentityProviders.delete($),this._proxy.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier($,V){this._logService.info("Getting edit session identifier for workspaceFolder",$);const R=await this.resolveWorkspaceFolder(h.URI.revive($));if(!R){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const z=this._editSessionIdentityProviders.get(R.uri.scheme);if(this._logService.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!z),!z)return;const q=await z.provideEditSessionIdentity(R,V);if(this._logService.info("Provider returned edit session identifier: ",q),!!q)return q}async $provideEditSessionIdentityMatch($,V,R,z){this._logService.info("Getting edit session identifier for workspaceFolder",$);const q=await this.resolveWorkspaceFolder(h.URI.revive($));if(!q){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",q);const ie=this._editSessionIdentityProviders.get(q.uri.scheme);if(this._logService.info(`Provider for scheme ${q.uri.scheme} is defined: `,!!ie),!ie)return;const ce=await ie.provideEditSessionIdentityMatch?.(V,R,z);if(this._logService.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent($){return(V,R,z)=>{const q=function(ce){V.call(R,ce)};return q.extension=$,this._onWillCreateEditSessionIdentityEvent.event(q,void 0,z)}}async $onWillCreateEditSessionIdentity($,V,R){const z=await this.resolveWorkspaceFolder(h.URI.revive($));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:z},V,async(q,ie)=>{const ce=Date.now();await Promise.resolve(q),Date.now()-ce>R&&this._logService.warn("SLOW edit session create-participant",ie.extension.identifier)}),V.isCancellationRequested}registerCanonicalUriProvider($,V){if(this._canonicalUriProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._canonicalUriProviders.set($,V);const R=this._uriTransformerService.transformOutgoingScheme($),z=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(z,R),(0,A.toDisposable)(()=>{this._canonicalUriProviders.delete($),this._proxy.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri($,V,R){const z=this._canonicalUriProviders.get($.scheme);if(!z)return;const q=await z.provideCanonicalUri?.(h.URI.revive($),V,R);if(q)return q}async $provideCanonicalUri($,V,R){return this.provideCanonicalUri(h.URI.revive($),{targetScheme:V},R)}};e.ExtHostWorkspace=k,e.ExtHostWorkspace=k=Ke([He(0,c.IExtHostRpcService),He(1,n.IExtHostInitDataService),He(2,i.IExtHostFileSystemInfo),He(3,r.ILogService),He(4,f.IURITransformerService)],k),e.IExtHostWorkspace=(0,m.createDecorator)("IExtHostWorkspace");function P(H){let $,V;return H&&(typeof H=="string"?$=H:($=H.pattern,V=h.URI.revive(H.baseUri))),{includePattern:$,folder:V}}}),define(Ie[40],Pe([1,0,25,5,39,4,7,203,51,15,11,3,17,12,2]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function r(f,a){if(a){const p=a.split(".");let l=f;for(let D=0;l&&D<p.length;D++)l=l[p[D]];return l}}function o(f){return f instanceof m.URI}function s(f){return f&&f.uri instanceof m.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof m.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function c(f){if(o(f))return{resource:f};if(s(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let u=class{constructor(a,p,l){this._proxy=a.getProxy(O.MainContext.MainThreadConfiguration),this._extHostWorkspace=p,this._logService=l,this._barrier=new N.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new t(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,p){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(a,p))}};e.ExtHostConfiguration=u,e.ExtHostConfiguration=u=Ke([He(0,h.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,b.ILogService)],u);class t{constructor(a,p,l,D){this._onDidChangeConfiguration=new L.Emitter,this._proxy=a,this._logService=D,this._extHostWorkspace=p,this._configuration=E.Configuration.parse(l,D),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,p){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=E.Configuration.parse(a,this._logService),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(p,l))}getConfiguration(a,p,l){const D=c(p)||{},d=this._toReadonlyValue(a?r(this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,D,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,D,l?.identifier);function w(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(C){return typeof r(d,C)<"u"},get:(C,S)=>{this._validateConfigurationAccess(a?`${a}.${C}`:C,D,l?.identifier);let k=r(d,C);if(typeof k>"u")k=S;else{let P;const H=($,V)=>{if((0,_.isObject)($)){let R;const z=()=>{P=P||(0,I.deepClone)(d),R=R||r(P,V)};return new Proxy($,{get:(q,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return z(),()=>R;if(P)return R=R||r(P,V),R[ie];const ce=q[ie];return typeof ie=="string"?H(ce,`${V}.${ie}`):ce},set:(q,ie,ce)=>(z(),R&&(R[ie]=ce),!0),deleteProperty:(q,ie)=>(z(),R&&delete R[ie],!0),defineProperty:(q,ie,ce)=>(z(),R&&Object.defineProperty(R,ie,ce),!0)})}return Array.isArray($)?(0,I.deepClone)($):$};k=H(k,C)}return k},update:(C,S,k,P)=>{C=a?`${a}.${C}`:C;const H=w(k);return S!==void 0?this._proxy.$updateConfigurationOption(H,C,S,D,P):this._proxy.$removeConfigurationOption(H,C,D,P)},inspect:C=>{C=a?`${a}.${C}`:C;const S=this._configuration.inspect(C,D,this._extHostWorkspace.workspace);if(S)return{key:C,defaultValue:(0,I.deepClone)(S.policy?.value??S.default?.value),globalValue:(0,I.deepClone)(S.user?.value??S.application?.value),workspaceValue:(0,I.deepClone)(S.workspace?.value),workspaceFolderValue:(0,I.deepClone)(S.workspaceFolder?.value),defaultLanguageValue:(0,I.deepClone)(S.default?.override),globalLanguageValue:(0,I.deepClone)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,I.deepClone)(S.workspace?.override),workspaceFolderLanguageValue:(0,I.deepClone)(S.workspaceFolder?.override),languageIds:(0,I.deepClone)(S.overrideIdentifiers)}}};return typeof d=="object"&&(0,I.mixin)(g,d,!1),Object.freeze(g)}_toReadonlyValue(a){const p=l=>(0,_.isObject)(l)?new Proxy(l,{get:(D,d)=>p(D[d]),set:(D,d,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(D,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(D,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return p(a)}_validateConfigurationAccess(a,p,l){const D=v.OVERRIDE_PROPERTY_REGEX.test(a)?4:this._configurationScopes.get(a),d=l?`[${l.value}] `:"";if(D===4){typeof p?.resource>"u"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(D===3){p?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,p){const l=new E.ConfigurationChangeEvent(a,p,this._configuration,this._extHostWorkspace.workspace,this._logService);return Object.freeze({affectsConfiguration:(D,d)=>l.affectsConfiguration(D,c(d))})}_toMap(a){return a.reduce((p,l)=>(p.set(l[0],l[1]),p),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")}),define(Ie[121],Pe([1,0,2,11,5,4,7,39,68,40,24,53,17,27,3,16,22,12,80,241,14]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(H){function $(R){if(R!=null)return R}H.from=$;function V(R){if(R!=null)return R}H.to=V})(u||(u={}));var t;(function(H){function $(R){if(R!=null)return R}H.from=$;function V(R){if(R!=null)return R}H.to=V})(t||(t={}));var f;(function(H){function $(R){if(R!=null)return R}H.from=$;function V(R){if(R!=null)return R}H.to=V})(f||(f={}));var a;(function(H){function $(z){if(z){const q=z;return q&&!!q.process}else return!1}H.is=$;function V(z){if(z==null)return;const q={process:z.process,args:z.args};return z.options&&(q.options=f.from(z.options)),q}H.from=V;function R(z){if(z!=null)return new A.ProcessExecution(z.process,z.args,z.options)}H.to=R})(a||(a={}));var p;(function(H){function $(R){if(R!=null)return R}H.from=$;function V(R){if(R!=null)return R}H.to=V})(p||(p={}));var l;(function(H){function $(z){if(z){const q=z;return q&&(!!q.commandLine||!!q.command)}else return!1}H.is=$;function V(z){if(z==null)return;const q={};return z.commandLine!==void 0?q.commandLine=z.commandLine:(q.command=z.command,q.args=z.args),z.options&&(q.options=p.from(z.options)),q}H.from=V;function R(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.ShellExecution(z.commandLine,z.options):new A.ShellExecution(z.command,z.args?z.args:[],z.options)}H.to=R})(l||(l={}));var D;(function(H){function $(z){if(z){const q=z;return q&&q.customExecution==="customExecution"}else return!1}H.is=$;function V(z){return{customExecution:"customExecution"}}H.from=V;function R(z,q){return q.get(z)}H.to=R})(D||(e.CustomExecutionDTO=D={}));var d;(function(H){function $(V,R){let z;return V.scope!==void 0&&typeof V.scope!="number"?z=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===A.TaskScope.Workspace&&R&&R.workspaceFile?z=R.workspaceFile:z=n.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:z}}H.from=$})(d||(e.TaskHandleDTO=d={}));var w;(function(H){function $(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}H.from=$})(w||(w={}));var g;(function(H){function $(z,q){if(z==null)return[];const ie=[];for(const ce of z){const Se=V(ce,q);Se&&ie.push(Se)}return ie}H.fromMany=$;function V(z,q){if(z==null)return;let ie;z.execution instanceof A.ProcessExecution?ie=a.from(z.execution):z.execution instanceof A.ShellExecution?ie=l.from(z.execution):z.execution&&z.execution instanceof A.CustomExecution&&(ie=D.from(z.execution));const ce=u.from(z.definition);let Se;return z.scope?typeof z.scope=="number"?Se=z.scope:Se=z.scope.uri:Se=A.TaskScope.Workspace,!ce||!Se?void 0:{_id:z._id,definition:ce,name:z.name,source:{extensionId:q.identifier.value,label:z.source,scope:Se},execution:ie,isBackground:z.isBackground,group:w.from(z.group),presentationOptions:t.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}H.from=V;async function R(z,q,ie){if(z==null)return;let ce;a.is(z.execution)?ce=a.to(z.execution):l.is(z.execution)?ce=l.to(z.execution):D.is(z.execution)&&(ce=D.to(z._id,ie));const Se=u.to(z.definition);let De;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?De=z.source.scope:De=await q.resolveWorkspaceFolder(I.URI.revive(z.source.scope)):De=A.TaskScope.Workspace),!Se||!De)return;const fe=new A.Task(Se,De,z.name,z.source.label,ce,z.problemMatchers);return z.isBackground!==void 0&&(fe.isBackground=z.isBackground),z.group!==void 0&&(fe.group=A.TaskGroup.from(z.group._id),fe.group&&z.group.isDefault&&(fe.group=new A.TaskGroup(fe.group.id,fe.group.label),z.group.isDefault===!0&&(fe.group.isDefault=z.group.isDefault))),z.presentationOptions&&(fe.presentationOptions=t.to(z.presentationOptions)),z._id&&(fe._id=z._id),z.detail&&(fe.detail=z.detail),fe}H.to=R})(g||(e.TaskDTO=g={}));var C;(function(H){function $(R){return R}H.from=$;function V(R){if(R)return Object.assign(Object.create(null),R)}H.to=V})(C||(C={}));class S{#e;constructor($,V,R){this._id=V,this._task=R,this.#e=$}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}let k=class{constructor($,V,R,z,q,ie,ce,Se){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=$.getProxy(O.MainContext.MainThreadTask),this._workspaceProvider=R,this._editorService=z,this._configurationService=q,this._terminalService=ie,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ce,this._deprecationService=Se,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,V,R){if(!R)return new A.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:V,provider:R,extension:$}),this._proxy.$registerTaskProvider(z,V),new A.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem($,V){this._proxy.$registerTaskSystem($,V)}fetchTasks($){return this._proxy.$fetchTasks(C.from($)).then(async V=>{const R=[];for(const z of V){const q=await g.to(z,this._workspaceProvider,this._providedCustomExecutions2);q&&R.push(q)}return R})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(V=>$.push(V)),$}terminateTask($){if(!($ instanceof S))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,V,R){const z=this._providedCustomExecutions2.get($.id);z&&(this._activeCustomExecutions2.set($.id,z),this._terminalService.attachPtyToTerminal(V,await z.callback(R))),this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){if(!this._taskExecutionPromises.has($.id))return;const V=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const V=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:V,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const V=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:$.exitCode})}$provideTasks($,V){const R=this._handlers.get($);if(!R)return Promise.reject(new Error("no handler found"));const z=[],q=(0,L.asPromise)(()=>R.provider.provideTasks(N.CancellationToken.None)).then(ie=>this.provideTasksInternal(V,z,R,ie));return new Promise(ie=>{q.then(ce=>{Promise.all(z).then(()=>{ie(ce)})})})}async $resolveTask($,V){const R=this._handlers.get($);if(!R)return Promise.reject(new Error("no handler found"));if(V.definition.type!==R.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${R.type}].`);const z=await g.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const q=await R.provider.resolveTask(z,N.CancellationToken.None);if(!q)return;this.checkDeprecation(q,R);const ie=g.from(q,R.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(ie.execution)&&await this.addCustomExecution(ie,q,!0),await this.resolveTaskInternal(ie)}nextHandle(){return this._handleCounter++}async addCustomExecution($,V,R){const z=await this._proxy.$createTaskId($);!R&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,V.execution)),this._providedCustomExecutions2.set(z,V.execution)}async getTaskExecution($,V){if(typeof $=="string"){const q=this._taskExecutionPromises.get($);if(!q)throw new c.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return q}const R=this._taskExecutionPromises.get($.id);if(R)return R;let z;return V?z=Promise.resolve(new S(this,$.id,V)):z=g.to($.task,this._workspaceProvider,this._providedCustomExecutions2).then(q=>{if(!q)throw new c.ErrorNoTelemetry("Unexpected: Task does not exist.");return new S(this,$.id,q)}),this._taskExecutionPromises.set($.id,z),z.then(q=>(this._taskExecutions.set($.id,q),q))}checkDeprecation($,V){$._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));const R=this._notProvidedCustomExecutions.values();let z=R.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=R.next()}};e.ExtHostTaskBase=k,e.ExtHostTaskBase=k=Ke([He(0,h.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,E.IExtHostWorkspace),He(3,v.IExtHostDocumentsAndEditors),He(4,_.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,s.ILogService),He(7,i.IExtHostApiDeprecationService)],k);let P=class extends k{constructor($,V,R,z,q,ie,ce,Se){super($,V,R,z,q,ie,ce,Se),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask($,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const R=g.from(V,$);if(R===void 0)throw new Error("Task is not valid");if(D.is(R.execution))await this.addCustomExecution(R,V,!1);else throw new c.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(R),V);return this._proxy.$executeTask(R).catch(q=>{throw new Error(q)}),z}provideTasksInternal($,V,R,z){const q=[];if(z)for(const ie of z){if(this.checkDeprecation(ie,R),!ie.definition||!$[ie.definition.type]){const Se=ie.source?ie.source:"No task source";this._logService.warn(`The task [${Se}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=g.from(ie,R.extension);ce&&D.is(ce.execution)?(q.push(ce),V.push(this.addCustomExecution(ce,ie,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:R.extension}}async resolveTaskInternal($){if(D.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,V,R){}};e.WorkerExtHostTask=P,e.WorkerExtHostTask=P=Ke([He(0,h.IExtHostRpcService),He(1,b.IExtHostInitDataService),He(2,E.IExtHostWorkspace),He(3,v.IExtHostDocumentsAndEditors),He(4,_.IExtHostConfiguration),He(5,y.IExtHostTerminalService),He(6,s.ILogService),He(7,i.IExtHostApiDeprecationService)],P),e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(Ie[299],Pe([1,0,47,30]),function(ue,e,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=T,e.genericCellMatchesToTextSearchMatches=O;function T(A){return"cellResults"in A}e.rawCellPrefix="rawCell#";function O(A,E){let v=-1;const _=[];let N=[];return A.forEach(h=>{h.range.startLineNumber!==v&&N.length>0&&(_.push([...N]),N=[]),N.push(h),v=h.range.endLineNumber}),N.length>0&&_.push([...N]),_.map(h=>{const b=[],m=h[0].range.startLineNumber,r=h[h.length-1].range.endLineNumber;for(let o=m;o<=r;o++)b.push(E.getLineContent(o));return new I.TextSearchMatch(b.join(`
`)+`
`,h.map(o=>new L.Range(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ie[300],Pe([1,0,177,21,5,6,28,13,15,2,38,76,4,32,8,7,35,275,114,25,16,231,299,297]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class a{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}constructor(l,D,d,w,g,C){this._textDocumentsAndEditors=d,this._textDocuments=w,this._extHostFileSystem=g,this._extHostSearch=C,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new y.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=l.getProxy(h.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(h.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(h.MainContext.MainThreadNotebookEditors),this._commandsConverter=D.converter,D.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const k=S.notebookEditor?.notebookUri,P=S.cell.handle,$=this._documents.get(k)?.getCell(P);if($)return $.apiCell}if(S&&S.$mid===14){const k=S.uri,P=this._documents.get(k);if(P)return P.apiNotebook}return S}}),a._registerApiCommands(D)}getEditorById(l){const D=this._editors.get(l);if(!D)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return D}getIdByEditor(l){for(const[D,d]of this._editors)if(d.apiEditor===l)return D}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,D){const d=this._documents.get(l);if(!d&&!D)throw new Error(`NO notebook document for '${l}'`);return d}static _convertNotebookRegistrationData(l,D){if(!D)return;const d=D.filenamePattern.map(w=>m.NotebookExclusiveDocumentPattern.from(w)).filter(w=>w!==void 0);if(D.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:D.displayName,filenamePattern:d,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,D,d){const w=a._notebookStatusBarItemProviderHandlePool++,g=typeof d.onDidChangeCellStatusBarItems=="function"?a._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(w,d),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(w,g,D);let C;return g!==void 0&&(C=d.onDidChangeCellStatusBarItems(S=>this._notebookProxy.$emitCellStatusBarEvent(g))),new r.Disposable(()=>{this._notebookStatusBarItemProviders.delete(w),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(w,g),C?.dispose()})}async createNotebookDocument(l){const D=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&m.NotebookData.from(l.content)});return _.URI.revive(D)}async openNotebookDocument(l){const D=this._documents.get(l);if(D)return D.apiNotebook;const d=await this._notebookDocumentsProxy.$tryOpenNotebook(l),w=this._documents.get(_.URI.revive(d));return(0,v.assertIsDefined)(w?.apiNotebook)}async showNotebookDocument(l,D){_.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let d;typeof D=="object"?d={position:m.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(m.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:d={preserveFocus:!1};const w=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,d),g=w&&this._editors.get(w)?.apiEditor;if(g)return g;throw w?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,D,d,w){const g=this._notebookStatusBarItemProviders.get(l),C=_.URI.revive(D),S=this._documents.get(C);if(!S||!g)return;const k=S.getCellFromIndex(d);if(!k)return;const P=await g.provideCellStatusBarItems(k.apiCell,w);if(!P)return;const H=new O.DisposableStore,$=this._statusBarCache.add([H]),R=(Array.isArray(P)?P:[P]).map(z=>m.NotebookStatusBarItem.from(z,this._commandsConverter,H));return{cacheId:$,items:R}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,D,d,w,g){if((0,E.isFalsyOrWhitespace)(D))throw new Error("viewType cannot be empty or just whitespace");const C=this._handlePool++;return this._notebookSerializer.set(C,{viewType:D,serializer:d,options:w}),this._notebookProxy.$registerNotebookSerializer(C,{id:l.identifier,location:l.extensionLocation},D,m.NotebookDocumentContentOptions.from(w),a._convertNotebookRegistrationData(l,g)),(0,O.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(C)})}async $dataToNotebook(l,D,d){const w=this._notebookSerializer.get(l);if(!w)throw new Error("NO serializer found");const g=await w.serializer.deserializeNotebook(D.buffer,d);return new o.SerializableObjectWithBuffers(m.NotebookData.from(g))}async $notebookToData(l,D,d){const w=this._notebookSerializer.get(l);if(!w)throw new Error("NO serializer found");const g=await w.serializer.serializeNotebook(m.NotebookData.to(D.value),d);return L.VSBuffer.wrap(g)}async $saveNotebook(l,D,d,w,g){const C=_.URI.revive(D),S=this._notebookSerializer.get(l);if(!S)throw new Error("NO serializer found");const k=this._documents.get(C);if(!k)throw new Error("Document NOT found");if(k.versionId!==d)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(C.scheme))throw new N.FileOperationError((0,I.localize)(0,null,this._resourceForError(C)),6);await this._validateWriteFile(C,w);const P={metadata:(0,n.filter)(k.apiNotebook.metadata,z=>!(S.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of k.apiNotebook.getCells()){const q=new r.NotebookCellData(z.kind,z.document.getText(),z.document.languageId,z.mime,S.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);q.metadata=(0,n.filter)(z.metadata,ie=>!(S.options?.transientCellMetadata??{})[ie]),P.cells.push(q)}const H=await S.serializer.serializeNotebook(P,g);await this._extHostFileSystem.value.writeFile(C,H);const $=this._extHostFileSystem.getFileSystemProviderExtUri(C.scheme),V=await this._extHostFileSystem.value.stat(C);return{name:$.basename(C),isFile:(V.type&N.FileType.File)!==0,isDirectory:(V.type&N.FileType.Directory)!==0,isSymbolicLink:(V.type&N.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&N.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(C.scheme),locked:!!((V.permissions??0)&N.FilePermission.Locked),etag:N.etag({mtime:V.mtime,size:V.size}),children:void 0}}async $searchInNotebooks(l,D,d,w,g){const C=this._notebookSerializer.get(l)?.serializer;if(!C)return{limitHit:!1,results:[]};const S=new A.ResourceSet;await(async(V,R,z)=>{await Promise.all(V.map(async q=>await Promise.all(q.filenamePatterns.map(ie=>{const ce={_reason:z._reason,folderQueries:z.folderQueries,includePattern:z.includePattern,excludePattern:z.excludePattern,maxResults:z.maxResults,type:1,filePattern:ie};return this._extHostSearch.doInternalFileSearchWithCustomCallback(ce,R,Se=>{Se.forEach(De=>{S.has(De)||w.some(pe=>q.isFromSettings&&!pe.isFromSettings?!1:pe.filenamePatterns.some(Ne=>(0,f.globMatchesResource)(Ne,De)))||S.add(De)})}).catch(Se=>{if(Se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Se})}))))})(d,g,D);const P=new A.ResourceMap;let H=!1;const $=Array.from(S).map(async V=>{const R=[];try{if(g.isCancellationRequested)return;if(D.maxResults&&[...P.values()].reduce((ce,Se)=>ce+Se.cellResults.length,0)>D.maxResults){H=!0;return}const z=[],q=this._documents.get(V);if(q)q.apiNotebook.getCells().forEach(Se=>z.push({input:Se.document.getText(),outputs:Se.outputs.flatMap(De=>De.items.map(fe=>fe.data.toString()))}));else{const ce=await this._extHostFileSystem.value.readFile(V),Se=L.VSBuffer.fromString(ce.toString()),De=await C.deserializeNotebook(Se.buffer,g);if(g.isCancellationRequested)return;m.NotebookData.from(De).cells.forEach(pe=>z.push({input:pe.source,outputs:pe.outputs.flatMap(Ne=>Ne.items.map(ae=>ae.valueBytes.toString()))}))}if(g.isCancellationRequested)return;z.forEach((ce,Se)=>{const De=D.contentPattern.pattern,fe=new u.CellSearchModel(ce.input,void 0,ce.outputs),pe=fe.findInInputs(De),Ne=fe.findInOutputs(De),ae=Ne.flatMap(Re=>(0,t.genericCellMatchesToTextSearchMatches)(Re.matches,Re.textBuffer)).map((Re,ne)=>(Re.webviewIndex=ne,Re));if(pe.length>0||Ne.length>0){const Re={index:Se,contentResults:(0,t.genericCellMatchesToTextSearchMatches)(pe,fe.inputTextBuffer),webviewResults:ae};R.push(Re)}});const ie={resource:V,cellResults:R};P.set(V,ie);return}catch{return}});return await Promise.all($),{limitHit:H,results:[...P.values()]}}async _validateWriteFile(l,D){const d=await this._extHostFileSystem.value.stat(l);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==N.ETAG_DISABLED&&typeof d.mtime=="number"&&typeof d.size=="number"&&D.mtime<d.mtime&&D.etag!==N.etag({mtime:D.mtime,size:d.size}))throw new N.FileOperationError((0,I.localize)(1,null),3,D)}_resourceForError(l){return l.scheme===c.Schemas.file?l.fsPath:l.toString()}_createExtHostEditor(l,D,d){if(this._editors.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const w=new i.ExtHostNotebookEditor(D,this._notebookEditorsProxy,l,d.visibleRanges.map(m.NotebookRange.to),d.selections.map(m.NotebookRange.to),typeof d.viewColumn=="number"?m.ViewColumn.to(d.viewColumn):void 0);this._editors.set(D,w)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const d of l.value.removedDocuments){const w=_.URI.revive(d),g=this._documents.get(w);g&&(g.dispose(),this._documents.delete(w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(C=>C.document.uri)}),this._onDidCloseNotebookDocument.fire(g.apiNotebook));for(const C of this._editors.values())C.notebookData.uri.toString()===w.toString()&&this._editors.delete(C.id)}if(l.value.addedDocuments){const d=[];for(const w of l.value.addedDocuments){const g=_.URI.revive(w.uri);if(this._documents.has(g))throw new Error(`adding EXISTING notebook ${g} `);const C=new s.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,g,w);d.push(...w.cells.map(S=>s.ExtHostCell.asModelAddData(S))),this._documents.get(g)?.dispose(),this._documents.set(g,C),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:d}),this._onDidOpenNotebookDocument.fire(C.apiNotebook)}}if(l.value.addedEditors)for(const d of l.value.addedEditors){if(this._editors.has(d.id))return;const w=_.URI.revive(d.documentUri),g=this._documents.get(w);g&&this._createExtHostEditor(g,d.id,d)}const D=[];if(l.value.removedEditors)for(const d of l.value.removedEditors){const w=this._editors.get(d);w&&(this._editors.delete(d),this._activeNotebookEditor?.id===w.id&&(this._activeNotebookEditor=void 0),D.push(w))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(w=>this._editors.get(w)).filter(w=>!!w);const d=new Set;this._visibleNotebookEditors.forEach(w=>d.add(w.id));for(const w of this._editors.values()){const g=d.has(w.id);w._acceptVisibility(g)}this._visibleNotebookEditors=[...this._editors.values()].map(w=>w).filter(w=>w.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._editors.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(l){const D=b.ApiCommandArgument.String.with("notebookType","A notebook type"),d=new b.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new b.ApiCommandArgument("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>L.VSBuffer.wrap(g))],new b.ApiCommandResult("Notebook Data",g=>m.NotebookData.to(g.value))),w=new b.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new b.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new o.SerializableObjectWithBuffers(m.NotebookData.from(g)))],new b.ApiCommandResult("Bytes",g=>g.buffer));l.registerApiCommand(d),l.registerApiCommand(w)}}e.ExtHostNotebookController=a}),define(Ie[301],Pe([1,0,19,24,44,37,23,66,47]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class _{constructor(h,b,m){this.config=h,this.provider=b,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=h.filePattern,this.includePattern=h.includePattern&&O.parse(h.includePattern),this.maxResults=h.maxResults||void 0,this.exists=h.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=h.excludePattern&&O.parse(h.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(h=>h.cancel()),this.activeCancellationTokens=new Set}search(h){const b=this.config.folderQueries||[];return new Promise((m,r)=>{const o=s=>{this.resultCount++,h(s)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(s=>{const i=s.toString(),n=I.basename(i);this.globalExcludePattern&&this.globalExcludePattern(i,n)||this.matchFile(o,{base:s,basename:n})}),Promise.all(b.map(s=>this.searchInFolder(s,o))).then(s=>{m({limitHit:this.isLimitHit,stats:s[0]||void 0})},s=>{r(new Error((0,T.toErrorMessage)(s)))})})}async searchInFolder(h,b){const m=new L.CancellationTokenSource,r=this.getSearchOptionsForFolder(h),o=this.initDirectoryTree(),s=new v.QueryGlobTester(this.config,h),i=!s.hasSiblingExcludeClauses();let n;try{this.activeCancellationTokens.add(m),n=E.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},r,m.token),u=n.elapsed(),t=E.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(f=>{const a=I.posix.relative(h.folder.path,f.path);if(i){const p=I.basename(f.path);this.matchFile(b,{base:h.folder,relativePath:a,basename:p});return}this.addDirectoryEntries(o,h.folder,a,b)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(o,s,b),{providerTime:u,postProcessTime:t.elapsed()})}finally{m.dispose(),this.activeCancellationTokens.delete(m)}}getSearchOptionsForFolder(h){const b=(0,v.resolvePatternsForProvider)(this.config.includePattern,h.includePattern),m=(0,v.resolvePatternsForProvider)(this.config.excludePattern,h.excludePattern);return{folder:h.folder,excludes:m,includes:b,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}addDirectoryEntries({pathToEntries:h},b,m,r){if(m===this.filePattern){const s=I.basename(this.filePattern);this.matchFile(r,{base:b,relativePath:this.filePattern,basename:s})}function o(s){const i=I.basename(s),n=I.dirname(s);let c=h[n];c||(c=h[n]=[],o(n)),c.push({base:b,relativePath:s,basename:i})}o(m)}matchDirectoryTree({rootEntries:h,pathToEntries:b},m,r){const o=this,s=this.filePattern;function i(n){const c=(0,v.hasSiblingFn)(()=>n.map(u=>u.basename));for(let u=0,t=n.length;u<t;u++){const f=n[u],{relativePath:a,basename:p}=f;if(m.matchesExcludesSync(a,p,s!==p?c:void 0))continue;const l=b[a];if(l)i(l);else{if(a===s)continue;o.matchFile(r,f)}if(o.isLimitHit)break}}i(h)}matchFile(h,b){(!this.includePattern||b.relativePath&&this.includePattern(b.relativePath,b.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||h(b))}}class N{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(h,b,m,r){const o=this.getSessionTokenSource(h.cacheKey),s=new _(h,b,o&&o.token);let i=0;const n=c=>{i+=c.length,m(c.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(s,N.BATCH_SIZE,n,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:c.stats}}))}clearCache(h){this.getSessionTokenSource(h)?.cancel()}getSessionTokenSource(h){if(h)return this.sessions.has(h)||this.sessions.set(h,new L.CancellationTokenSource),this.sessions.get(h)}rawMatchToSearchItem(h){return h.relativePath?{resource:A.joinPath(h.base,h.relativePath)}:{resource:h.base}}doSearch(h,b,m,r){const o=r.onCancellationRequested(()=>{h.cancel()}),s=n=>{n&&(i.push(n),b>0&&i.length>=b&&(m(i),i=[]))};let i=[];return h.search(s).then(n=>(i.length&&m(i),o.dispose(),n),n=>(i.length&&m(i),o.dispose(),Promise.reject(n)))}}e.FileSearchManager=N}),define(Ie[302],Pe([1,0,18,270,37,97,28,16,19,23,13,15,2,96,195,50,12,45,109,298,47]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.resolveResourcesForSearchIncludes=w;let u=class{constructor(C,S,k,P,H){this.configurationService=C,this.workspaceContextService=S,this.editorGroupsService=k,this.logService=P,this.pathService=H}text(C,S,k={}){C=this.getContentPattern(C,k);const P=this.configurationService.getValue(),H=S&&S.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep);return{...this.commonQuery(S?.map(s.toWorkspaceFolder),k),type:2,contentPattern:C,previewOptions:k.previewOptions,maxFileSize:k.maxFileSize,usePCRE2:P.search.usePCRE2||H||!1,beforeContext:k.beforeContext,afterContext:k.afterContext,userDisabledExcludesAndIgnoreFiles:k.disregardExcludeSettings&&k.disregardIgnoreFiles}}getContentPattern(C,S){const k=this.configurationService.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const P={...C,wordSeparators:k.editor.wordSeparators};return this.isCaseSensitive(C,S)&&(P.isCaseSensitive=!0),this.isMultiline(C)&&(P.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),P}file(C,S={}){return{...this.commonQuery(C,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey,shouldGlobMatchFilePattern:S.shouldGlobSearch}}handleIncludeExclude(C,S){return C?(C=Array.isArray(C)?C.map(l):l(C),S?this.parseSearchPaths(C):{pattern:f(...Array.isArray(C)?C:[C])}):{}}commonQuery(C=[],S={}){const k=this.handleIncludeExclude(S.includePattern,S.expandPatterns),P=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),H=C.length>1,$=(k.searchPaths&&k.searchPaths.length?k.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,S,P)):C.map(z=>this.getFolderQueryForRoot(z,S,P,H))).filter(z=>!!z),V={_reason:S._reason,folderQueries:$,usingSearchPaths:!!(k.searchPaths&&k.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:P.pattern,includePattern:k.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const z=I.coalesce(I.flatten(this.editorGroupsService.groups.map(ce=>ce.editors.map(Se=>Se.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const q=z.filter(ce=>(0,c.pathIncludedInQuery)(V,ce.fsPath)),ie=this.commonQueryFromFileList(q);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...V,...ie}}const R=S.extraFileResources&&S.extraFileResources.filter(z=>(0,c.pathIncludedInQuery)(V,z.fsPath));return V.extraFileResources=R&&R.length?R:void 0,V}commonQueryFromFileList(C){const S=[],k=new A.ResourceMap,P={};let H=!1;return C.forEach($=>{if($.scheme===E.Schemas.walkThrough)return;if((0,_.isAbsolutePath)($)){const R=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:v.dirname($.fsPath)});let z=k.get(R);z||(H=!0,z={folder:R,includePattern:{}},S.push(z),k.set(R,z));const q=v.relative(R.fsPath,$.fsPath);(0,y.assertIsDefined)(z.includePattern)[q.replace(/\\/g,"/")]=!0}else $.fsPath&&(H=!0,P[$.fsPath]=!0)}),{folderQueries:S,includePattern:P,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}isCaseSensitive(C,S){if(S.isSmartCase){if(C.isRegExp){if(N.containsUppercaseCharacter(C.pattern,!0))return!0}else if(N.containsUppercaseCharacter(C.pattern))return!0}return!!C.isCaseSensitive}isMultiline(C){return C.isMultiline||C.isRegExp&&(0,b.isMultilineRegexSource)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const S=ie=>v.isAbsolute(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(C)?C:a(C)).map(ie=>{const ce=this.pathService.resolvedUserHome;return ce?(0,O.untildify)(ie,ce.scheme===E.Schemas.file?ce.fsPath:ce.path):ie}),H=L.groupBy(P,ie=>S(ie)?"searchPaths":"exprSegments"),$=(H.exprSegments||[]).map(ie=>N.rtrim(ie,"/")).map(ie=>N.rtrim(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),p(ie))),V={},R=this.expandSearchPathPatterns(H.searchPaths||[]);R&&R.length&&(V.searchPaths=R);const z=I.flatten($),q=f(...z);return q&&(V.pattern=q),V}getExcludesForFolder(C,S){return S.disregardExcludeSettings?void 0:(0,c.getExcludes)(C,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(C){if(!C||!C.length)return[];const S=C.flatMap(P=>{let{pathPortion:H,globPortion:$}=t(P);return $&&($=D($)),this.expandOneSearchPath(H).flatMap(R=>this.resolveOneSearchPathPattern(R,$))}),k=new Map;return S.forEach(P=>{const H=P.searchPath.toString(),$=k.get(H);$?P.pattern&&($.pattern=$.pattern||{},$.pattern[P.pattern]=!0):k.set(H,{searchPath:P.searchPath,pattern:P.pattern?f(P.pattern):void 0})}),Array.from(k.values())}expandOneSearchPath(C){if(v.isAbsolute(C)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==E.Schemas.file?[{searchPath:S[0].uri.with({path:C})}]:[{searchPath:h.URI.file(v.normalize(C))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(C=l(C),C.startsWith("../")||C===".."){const P=v.posix.resolve(S.path,C);return[{searchPath:S.with({path:P})}]}const k=D(C);return[{searchPath:S,pattern:k}]}else{if(C==="./"||C===".\\")return[];{const S=C.replace(/^\.[\/\\]/,""),P=this.workspaceContextService.getWorkspace().folders.map(H=>{const $=S.match(new RegExp(`^${N.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return $?{match:$,folder:H}:null}).filter(y.isDefined);if(P.length)return P.map(H=>{const $=H.match[1];return{searchPath:H.folder.uri,pattern:$&&D($)}});{const H=C.match(/\.[\/\\](.+)[\/\\]?/),$=H?H[1]:C,V=m.localize(0,null,$);throw new Error(V)}}}}resolveOneSearchPathPattern(C,S){const k=C.pattern&&S?`${C.pattern}/${S}`:C.pattern||S,P=[{searchPath:C.searchPath,pattern:k}];return k&&!k.endsWith("**")&&P.push({searchPath:C.searchPath,pattern:k+"/**"}),P}getFolderQueryForSearchPath(C,S,k){const P=this.getFolderQueryForRoot((0,s.toWorkspaceFolder)(C.searchPath),S,k,!1);return P?{...P,includePattern:C.pattern}:null}getFolderQueryForRoot(C,S,k,P){let H;const $=h.URI.isUri(C)?C:C.uri;if(k.searchPaths){const ie=k.searchPaths.filter(ce=>(0,_.isEqual)(ce.searchPath,$))[0];if(ie&&!ie.pattern)return null;ie&&(H=ie.pattern)}const V=this.configurationService.getValue({resource:$}),z={...this.getExcludesForFolder(V,S)||{},...H||{}},q=h.URI.isUri(C)?(0,_.basename)(C):C.name;return{folder:$,folderName:P?q:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!V.search.followSymlinks}}};e.QueryBuilder=u,e.QueryBuilder=u=Ke([He(0,r.IConfigurationService),He(1,s.IWorkspaceContextService),He(2,i.IEditorGroupsService),He(3,o.ILogService),He(4,n.IPathService)],u);function t(g){const C=g.match(/[\*\{\}\(\)\[\]\?]/);if(C){const S=C.index,k=g.substr(0,S).match(/[/|\\][^/\\]*$/);if(k){let P=g.substr(0,k.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:g.substr((k.index||0)+1)}}}return{pathPortion:g}}function f(...g){return g.length?g.reduce((C,S)=>(C[S]=!0,C),Object.create(null)):void 0}function a(g){return T.splitGlobAware(g,",").map(C=>C.trim()).filter(C=>!!C.length)}function p(g){return[`**/${g}/**`,`**/${g}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function l(g){return g.replace(/\\/g,"/")}function D(g){return l(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(g){return g.replace(/([?*[\]])/g,"[$1]")}function w(g,C){g=I.distinct(g,P=>P.toString());const S=[],k=C.getWorkspace();return g&&g.forEach(P=>{let H;if(C.getWorkbenchState()===2)H=(0,_.relativePath)(k.folders[0].uri,P),H&&H!=="."&&(H="./"+H);else{const $=C.getWorkspaceFolder(P);if($){const V=$.name;if(k.folders.filter(z=>z.name===V).length===1){const z=(0,_.relativePath)($.uri,P);z===""?H=`./${$.name}`:H=`./${$.name}/${z}`}else H=P.fsPath}}H&&S.push(d(H))}),S}}),define(Ie[303],Pe([1,0,23,2,24,14,3,302,47,45,11]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=h,e.checkGlobFileExists=r;const y=7e3;function h(o,s){const i=s.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],c=[];for(const l of i)if(/^workspaceContains:/.test(l)){const D=l.substr(18);D.indexOf("*")>=0||D.indexOf("?")>=0||o.forceUsingSearch?c.push(D):n.push(D)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:u,resolve:t}=(0,N.promiseWithResolvers)(),f=l=>t({activationEvent:l}),a=Promise.all(n.map(l=>b(o,l,f))).then(()=>{}),p=m(o,s.identifier,c,f);return Promise.all([a,p]).then(()=>{t(void 0)}),u}async function b(o,s,i){for(const n of o.folders)if(await o.exists(I.joinPath(L.URI.revive(n),s))){i(`workspaceContains:${s}`);return}}async function m(o,s,i,n){if(i.length===0)return Promise.resolve(void 0);const c=new T.CancellationTokenSource,u=o.checkExists(o.folders,i,c.token),t=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},y);let f=!1;try{f=await u}catch(a){O.isCancellationError(a)||O.onUnexpectedError(a)}c.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function r(o,s,i,n){const c=o.get(A.IInstantiationService),u=o.get(v.ISearchService),f=c.createInstance(E.QueryBuilder).file(s.map(a=>(0,_.toWorkspaceFolder)(L.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return u.fileSearch(f,n).then(a=>!!a.limitHit,a=>O.isCancellationError(a)?!1:Promise.reject(a))}}),define(Ie[41],Pe([1,0,173,19,60,23,11,6,54,2,12,4,40,237,84,39,26,110,14,20,21,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,22,82]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c,u,t,f,a,p,l,D,d,w,g,C,S,k,P,H,$,V,R,z,q){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let ce=ie=class extends E.Disposable{constructor(x,J,be,Me,ye,Ee,ge,G,Y,de,le,Oe,he){super(),this._extHostManagedSockets=Oe,this._extHostLanguageModels=he,this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=J,this._extHostContext=be,this._initData=ge,this._extHostWorkspace=Me,this._extHostConfiguration=ye,this._logService=Ee,this._extHostTunnelService=Y,this._extHostTerminalService=de,this._extHostLocalizationService=le,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._activationEventsReader=new Re(this._initData.extensions.activationEvents),this._globalRegistry=new s.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const ke=new n.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new s.ExtensionDescriptionRegistry(this._activationEventsReader,Ne(this._globalRegistry,ke)),z.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${fe(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${fe(this._myRegistry)}`)),this._storage=new m.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new P.ExtHostSecretState(this._extHostContext),this._storagePath=G,this._instaService=x.createChild(new d.ServiceCollection([m.IExtHostStorage,this._storage],[P.IExtHostSecretState,this._secretState])),this._activator=this._register(new b.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Te,ze,U)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Te,i.transformErrorForSerialization(ze),U)},actualActivateExtension:async(Te,ze)=>{if(s.ExtensionDescriptionRegistry.isHostExtension(Te,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Te,ze),new b.HostExtension;const U=this._myRegistry.getExtensionDescription(Te);return this._activateExtension(U,ze)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){i.onUnexpectedError(x)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let x=[];try{x=this._myRegistry.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this._deactivate(ye))}catch{}await Promise.all(x)}terminate(x,J=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${x}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),i.setUnexpectedErrorHandler(Me=>{this._logService.error(Me)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,A.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${J}`):this._logService.info(`Extension host exiting with code ${J}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(J)})}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}async getExtension(x){const J=await this._mainThreadExtensionsProxy.$getExtension(x);return J&&{...J,identifier:new n.ExtensionIdentifier(J.identifier.value),extensionLocation:_.URI.revive(J.extensionLocation)}}_activateByEvent(x,J){return this._activator.activateByEvent(x,J)}_activateById(x,J){return this._activator.activateById(x,J)}activateByIdWithErrors(x,J){return this._activateById(x,J).then(()=>{const be=this._activator.getActivatedExtension(x);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._myRegistry)}getExtensionExports(x){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(x).exports;try{return this._activator.getActivatedExtension(x).exports}catch{return null}}async _realPathExtensionUri(x){if(x.scheme===$.Schemas.file&&this._hostUtils.fsRealpath){const J=x.fsPath;this._realPathCache.has(J)||this._realPathCache.set(J,this._hostUtils.fsRealpath(J));const be=await this._realPathCache.get(J);return _.URI.file(be)}return x}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(x=>new ae(x))),this._extensionPathIndex}async _createExtensionPathIndex(x){const J=v.TernarySearchTree.forUris(be=>O.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(x.map(async be=>{if(this._getEntryPoint(be)){const Me=await this._realPathExtensionUri(be.extensionLocation);J.set(Me,be)}})),J}_deactivate(x){let J=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return J;const be=this._activator.getActivatedExtension(x);if(!be)return J;try{typeof be.module.deactivate=="function"&&(J=Promise.resolve(be.module.deactivate()).then(void 0,Me=>(this._logService.error(Me),Promise.resolve(void 0))))}catch(Me){this._logService.error(`An error occurred when deactivating the extension '${x.value}':`),this._logService.error(Me)}try{(0,E.dispose)(be.subscriptions)}catch(Me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this._logService.error(Me)}return J}async _activateExtension(x,J){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,J).then(be=>{const Me=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,Me.codeLoadingTime,Me.activateCallTime,Me.activateResolvedTime,J),this._logExtensionActivationTimes(x,J,"success",Me),be},be=>{throw this._logExtensionActivationTimes(x,J,"failure"),be})}_logExtensionActivationTimes(x,J,be,Me){const ye=De(x,J);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ye,...Me||{},outcome:be})}_doActivateExtension(x,J){const be=De(x,J);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const Me=this._getEntryPoint(x);if(!Me)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${x.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this._logService.flush();const ye=new b.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this._loadCommonJSModule(x,(0,O.joinPath)(x.extensionLocation,Me),ye),this._loadExtensionContext(x)]).then(Ee=>(T.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),ie._callActivate(this._logService,x.identifier,Ee[0],Ee[1],ye))).then(Ee=>(T.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Ee))}_loadExtensionContext(x){const J=this._extHostLanguageModels.createLanguageModelAccessInformation(x),be=new u.ExtensionGlobalMemento(x,this._storage),Me=new u.ExtensionMemento(x.identifier.value,!1,this._storage),ye=new H.ExtensionSecrets(x,this._secretState),Ee=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([be.whenReady,Me.whenReady,this._storagePath.whenReady]).then(()=>{const G=this;let Y,de;const le=(0,o.isProposedApiEnabled)(x,"ipc")?this._initData.messagePorts?.get(n.ExtensionIdentifier.toKey(x.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Me,secrets:ye,subscriptions:[],get languageModelAccessInformation(){return J},get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(Oe){return L.join(x.extensionLocation.fsPath,Oe)},get storagePath(){return G._storagePath.workspaceValue(x)?.fsPath},get globalStoragePath(){return G._storagePath.globalValue(x).fsPath},get logPath(){return L.join(G._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return _.URI.joinPath(G._initData.logsLocation,x.identifier.value)},get storageUri(){return G._storagePath.workspaceValue(x)},get globalStorageUri(){return G._storagePath.globalValue(x)},get extensionMode(){return Ee},get extension(){return Y===void 0&&(Y=new pe(G,x.identifier,x,ge,!1)),Y},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(x,"extensionRuntime"),G.extensionRuntime},get environmentVariableCollection(){return G._extHostTerminalService.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!de){if(!le)return;const Oe=S.Event.buffer(S.Event.fromDOMEventEmitter(le,"message",he=>he.data));le.start(),de={onDidReceiveMessage:Oe,postMessage:le.postMessage.bind(le)}}return de}})})}static _callActivate(x,J,be,Me,ye){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,J,be,Me,ye).then(Ee=>new b.ActivatedExtension(!1,null,ye.build(),be,Ee,Me.subscriptions))}static _callActivateOptional(x,J,be,Me,ye){if(typeof be.activate=="function")try{ye.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Ee=typeof global=="object"?global:self,ge=be.activate.apply(Ee,[Me]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(ge).then(G=>(ye.activateResolveStop(),G))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(be)}_activateOneStartupFinished(x,J){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:J}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinishedDeferred(x,J=0){const Me=Date.now();(0,z.setTimeout0)(()=>{for(let ye=J;ye<x.length;ye+=1){const Ee=x[ye];for(const ge of Ee.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Me>50){this._activateAllStartupFinishedDeferred(x,ye);break}else this._activateOneStartupFinished(Ee,ge)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks()),this._extHostConfiguration.getConfigProvider().then(x=>{const J=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this._myRegistry.getAllExtensionDescriptions();if(J)this._activateAllStartupFinishedDeferred(be);else for(const Me of be)if(Me.activationEvents)for(const ye of Me.activationEvents)ye==="onStartupFinished"&&this._activateOneStartupFinished(Me,ye)})}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,Ee=>{this._logService.error(Ee)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Ee=>this._handleWorkspaceContainsEagerExtensions(Ee.added)));const J=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(J),Me=this._handleRemoteResolverEagerExtensions(),ye=Promise.all([Me,x,be]).then(()=>{});return Promise.race([ye,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ye}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(J=>this._handleWorkspaceContainsEagerExtension(x,J))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,J){if(this.isActivated(J.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Me={logService:this._logService,folders:x.map(Ee=>Ee.uri),forceUsingSearch:be||!this._hostUtils.fsExists,exists:Ee=>this._hostUtils.fsExists(Ee.fsPath),checkExists:(Ee,ge,G)=>this._mainThreadWorkspaceProxy.$checkExists(Ee,ge,G)},ye=await(0,k.checkActivateWorkspaceContainsExtension)(Me,J);if(ye)return this._activateById(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:ye.activationEvent}).then(void 0,Ee=>this._logService.error(Ee))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:J}=this._initData.environment;if(!x||!J)throw new Error(I.localize(0,null));const be=await this._loadCommonJSModule(null,J,new b.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(I.localize(1,null,J.toString()));return new Promise((Me,ye)=>{const Ee=(Y,de)=>{Y?(z.isCI&&this._logService.error("Test runner called back with error",Y),ye(Y)):(z.isCI&&(de?this._logService.info(`Test runner called back with ${de} failures.`):this._logService.info("Test runner called back with successful outcome.")),Me(typeof de=="number"&&de>0?1:0))},ge=(0,O.originalFSPath)(J),G=be.run(ge,Ee);G&&G.then&&G.then(()=>{z.isCI&&this._logService.info("Test runner finished successfully."),Me(0)}).catch(Y=>{z.isCI&&this._logService.error("Test runner finished with error",Y),ye(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,J){return this._resolvers[x]=J,(0,E.toDisposable)(()=>{delete this._resolvers[x]})}async getRemoteExecServer(x){const{resolver:J}=await this._activateAndGetResolver(x);return J?.resolveExecServer?.(x,{resolveAttempt:0})}async _activateAndGetResolver(x){const J=x.indexOf("+");if(J===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=x.substr(0,J);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(x,J){const be=R.StopWatch.create(!1),Me=()=>`[resolveAuthority(${(0,f.getRemoteAuthorityPrefix)(x)},${J})][${be.elapsed()}ms] `,ye=M=>this._logService.info(`${Me()}${M}`),Ee=M=>this._logService.warn(`${Me()}${M}`),ge=(M,W=void 0)=>this._logService.error(`${Me()}${M}`,W),G=M=>{if(M instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:M._code,message:M._message,detail:M._detail}};throw M},Y=async M=>{ye(`activating resolver for ${M}...`);const{resolver:W,authorityPrefix:j}=await this._activateAndGetResolver(M);if(!W)throw ge(`no resolver for ${j}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${j}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:W,authorityPrefix:j,remoteAuthority:M}},de=x.split(/@|%40/g).reverse();ye(`activating remote resolvers ${de.join(" -> ")}`);let le;try{le=await Promise.all(de.map(Y)).catch(async M=>{if(!(M instanceof t.RemoteAuthorityResolverError)||M._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw M;return Ee(`resolving nested authorities failed: ${M.message}`),[await Y(x)]})}catch(M){return G(M)}const Oe=new A.IntervalTimer;Oe.cancelAndSet(()=>ye("waiting..."),1e3);let he,ke;for(const[M,{authorityPrefix:W,resolver:j,remoteAuthority:ee}]of le.entries())try{if(M===le.length-1)ye("invoking final resolve()..."),T.mark(`code/extHost/willResolveAuthority/${W}`),he=await j.resolve(ee,{resolveAttempt:J,execServer:ke}),T.mark(`code/extHost/didResolveAuthorityOK/${W}`),ye("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(j,t.ManagedResolvedAuthority.isManagedResolvedAuthority(he)?he:void 0));else{if(ye(`invoking resolveExecServer() for ${ee}`),T.mark(`code/extHost/willResolveExecServer/${W}`),ke=await j.resolveExecServer?.(ee,{resolveAttempt:J,execServer:ke}),!ke)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${ee}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);T.mark(`code/extHost/didResolveExecServerOK/${W}`)}}catch(re){return T.mark(`code/extHost/didResolveAuthorityError/${W}`),ge("returned an error",re),Oe.dispose(),G(re)}Oe.dispose();const Te={environmentTunnels:he.environmentTunnels,features:he.tunnelFeatures?{elevation:he.tunnelFeatures.elevation,privacyOptions:he.tunnelFeatures.privacyOptions,protocol:he.tunnelFeatures.protocol===void 0?!0:he.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:he.extensionHostEnv,isTrusted:he.isTrusted,authenticationSession:he.authenticationSessionForInitializingExtensions?{id:he.authenticationSessionForInitializingExtensions.id,providerId:he.authenticationSessionForInitializingExtensions.providerId}:void 0};ye(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(he)?"managed authority":`${he.host}:${he.port}`}`);let U;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(he)){const M=J;this._extHostManagedSockets.setFactory(M,he.makeConnection),U={authority:x,connectTo:new f.ManagedRemoteConnection(M),connectionToken:he.connectionToken}}else U={authority:x,connectTo:new f.WebSocketRemoteConnection(he.host,he.port),connectionToken:he.connectionToken};return{type:"ok",value:{authority:U,options:ze,tunnelInformation:Te}}}async $getCanonicalURI(x,J){this._logService.info(`$getCanonicalURI invoked for authority (${(0,f.getRemoteAuthorityPrefix)(x)})`);const{resolver:be}=await this._activateAndGetResolver(x);if(!be)return null;const Me=_.URI.revive(J);if(typeof be.getCanonicalURI>"u")return Me;const ye=await(0,A.asPromise)(()=>be.getCanonicalURI(Me));return ye||Me}async $startExtensionHost(x){x.toAdd.forEach(Ee=>Ee.extensionLocation=_.URI.revive(Ee.extensionLocation));const{globalRegistry:J,myExtensions:be}=Se(this._activationEventsReader,this._globalRegistry,this._myRegistry,x),Me=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(Me),this._globalRegistry.set(J.getAllExtensionDescriptions()),this._myRegistry.set(be),z.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${fe(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${fe(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(x,J){return J===1?this._almostReadyToRunExtensions.wait().then(be=>this._activateByEvent(x,!1)):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(x,!1))}async $activate(x,J){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(x)?(await this._activateById(x,J),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(Ee=>Ee.extensionLocation=_.URI.revive(Ee.extensionLocation));const{globalRegistry:J,myExtensions:be}=Se(this._activationEventsReader,this._globalRegistry,this._myRegistry,x),Me=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(Me),this._globalRegistry.set(J.getAllExtensionDescriptions()),this._myRegistry.set(be),z.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${fe(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${fe(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const J=c.VSBuffer.alloc(x),be=Math.random()%256;for(let Me=0;Me<x;Me++)J.writeUInt8(be,Me);return J}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=ce,e.AbstractExtHostExtensionService=ce=ie=Ke([He(0,a.IInstantiationService),He(1,e.IHostUtils),He(2,D.IExtHostRpcService),He(3,r.IExtHostWorkspace),He(4,h.IExtHostConfiguration),He(5,N.ILogService),He(6,p.IExtHostInitDataService),He(7,l.IExtensionStoragePaths),He(8,w.IExtHostTunnelService),He(9,g.IExtHostTerminalService),He(10,V.IExtHostLocalizationService),He(11,q.IExtHostManagedSockets),He(12,C.IExtHostLanguageModels)],ce);function Se(ne,x,J,be){ne.addActivationEvents(be.addActivationEvents);const Me=new s.ExtensionDescriptionRegistry(ne,x.getAllExtensionDescriptions());Me.deltaExtensions(be.toAdd,be.toRemove);const ye=new n.ExtensionIdentifierSet(J.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of be.myToRemove)ye.delete(ge);for(const ge of be.myToAdd)ye.add(ge);const Ee=Ne(Me,ye);return{globalRegistry:Me,myExtensions:Ee}}function De(ne,x){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}function fe(ne){return ne.getAllExtensionDescriptions().map(x=>x.identifier.value).join(",")}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(x,J,be,Me,ye){this.#e=x,this.#t=J,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=L.normalize((0,O.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Me,this.isFromDifferentExtensionHost=ye}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=pe;function Ne(ne,x){return ne.getAllExtensionDescriptions().filter(J=>x.has(J.identifier))}class ae{constructor(x){this._searchTree=x}setSearchTree(x){this._searchTree=x}findSubstr(x){return this._searchTree.findSubstr(x)}forEach(x){return this._searchTree.forEach(x)}}e.ExtensionPaths=ae;class Re{constructor(x){this._map=new n.ExtensionIdentifierMap,this.addActivationEvents(x)}readActivationEvents(x){return this._map.get(x.identifier)??[]}addActivationEvents(x){for(const J of Object.keys(x))this._map.set(J,x[J])}}}),define(Ie[304],Pe([1,0,60,2,4,40,26,20,17,27,3,41,12,13]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(c,u,t,f,a,p,l){this._apiFactory=c,this._extensionRegistry=u,this._instaService=t,this._extHostConfiguration=f,this._extHostExtensionService=a,this._initData=p,this._logService=l,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),I.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,u,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(i,u,this._initData.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const u of c.nodeModuleName)this._factories.set(u,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(u=>c.alternativeModuleName(u))}};e.RequireInterceptor=r,e.RequireInterceptor=r=Ke([He(2,N.IInstantiationService),He(3,O.IExtHostConfiguration),He(4,y.IExtHostExtensionService),He(5,_.IExtHostInitDataService),He(6,h.ILogService)],r);let o=class{static{m=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&m.aliased.size){const u=(0,b.escapeRegExpCharacters)(this.forceForwardSlashes(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${u}/${a}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(c){if(!this.re)return;const u=this.re.exec(this.forceForwardSlashes(c));if(!u)return;const[,t,f,a]=u,p=m.aliased.get(f);if(p!==void 0)return console.warn(`${f} as been renamed to ${p}, please update your imports`),t+p+a}forceForwardSlashes(c){return c.replace(/\\/g,"/")}};o=m=Ke([He(0,_.IExtHostInitDataService)],o);class s{constructor(c,u,t,f,a){this._apiFactory=c,this._extensionPaths=u,this._extensionRegistry=t,this._configProvider=f,this._logService=a,this.nodeModuleName="vscode",this._extApiImpl=new E.ExtensionIdentifierMap}load(c,u){const t=this._extensionPaths.findSubstr(u);if(t){let f=this._extApiImpl.get(t.identifier);return f||(f=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,f)),f}if(!this._defaultApiImpl){let f="";this._extensionPaths.forEach((a,p)=>f+=`	${p} -> ${a.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${f}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let i=class{constructor(c,u,t){this._extensionPaths=c,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(T.MainContext.MainThreadTelemetry);const f=t.getProxy(T.MainContext.MainThreadWindow);this._impl=(a,p)=>{const l=L.URI.parse(a);return p?this.callOriginal(a,p):l.scheme==="http"||l.scheme==="https"?f.$openUri(l,a,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this._appUriScheme?f.$openUri(l,a,{}):this.callOriginal(a,p)}}load(c,u,t){const f=this._extensionPaths.findSubstr(u);return f&&(this._extensionId=f.identifier.value,this.sendShimmingTelemetry()),this._original=t(c),this._impl}callOriginal(c,u){return this.sendNoForwardTelemetry(),this._original(c,u)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};i=Ke([He(2,v.IExtHostRpcService)],i)}),define(Ie[122],Pe([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class m extends h.AbstractVariableResolverService{constructor(s,i,n,c,u,t,f){function a(){if(n){const p=n.activeEditor();if(p)return p.document.uri;const l=c.tabGroups.all.find(D=>D.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof N.TextDiffTabInput||l.input instanceof N.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof N.TextTabInput||l.input instanceof N.NotebookEditorTabInput||l.input instanceof N.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:p=>{const l=t.folders.filter(D=>D.name===p);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(p,l)=>u.getConfiguration(void 0,p).get(l),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const p=a();if(p)return T.normalize(p.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const p=a();if(p){const l=i.getWorkspaceFolder(p);if(l)return T.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(n){const p=n.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(n){const p=n.activeEditor();if(p)return String(p.selection.end.line+1)}},getExtension:p=>s.getExtension(p)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(O.env))}}let r=class extends L.Disposable{constructor(s,i,n,c,u){super(),this.extensionService=s,this.workspaceService=i,this.editorService=n,this.configurationService=c,this.editorTabs=u,this._resolver=new I.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),a={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async p=>{a.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new m(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,a,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=r,e.ExtHostVariableResolverProviderService=r=Ke([He(0,_.IExtHostExtensionService),He(1,y.IExtHostWorkspace),He(2,E.IExtHostDocumentsAndEditors),He(3,b.IExtHostConfiguration),He(4,v.IExtHostEditorTabs)],r)}),define(Ie[123],Pe([1,0,11,5,2,20,3,4,67,41,17,7,39,226,228,40,122,6,36,32,8]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(d,w,g,C,S,k,P){this._workspaceService=w,this._extensionService=g,this._configurationService=C,this._editorTabs=S,this._variableResolver=k,this._commands=P,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new L.Emitter,this._onDidTerminateDebugSession=new L.Emitter,this._onDidChangeActiveDebugSession=new L.Emitter,this._onDidReceiveDebugSessionCustomEvent=new L.Emitter,this._debugServiceProxy=d.getProxy(E.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new L.Emitter,this._onDidChangeActiveStackItem=new L.Emitter,this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(H=>{H.onDidChange($=>{this.registerAllDebugTypes(H)}),this.registerAllDebugTypes(H)})}async $getVisualizerTreeItem(d,w){const g=this.hydrateVisualizationContext(w);if(!g)return;const C=await this._debugVisualizationTrees.get(d)?.getTreeItem?.(g);return C?this.convertVisualizerTreeItem(d,C):void 0}registerDebugVisualizationTree(d,w,g){const C=O.ExtensionIdentifier.toKey(d.identifier),S=this.extensionVisKey(C,w);if(this._debugVisualizationProviders.has(S))throw new Error(`A debug visualization provider with id '${w}' is already registered`);return this._debugVisualizationTrees.set(S,g),this._debugServiceProxy.$registerDebugVisualizerTree(S,!!g.editItem),(0,s.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(S),this._debugVisualizationTrees.delete(w)})}async $getVisualizerTreeItemChildren(d,w){const g=this._debugVisualizationElements.get(w)?.item;return g?(await this._debugVisualizationTrees.get(d)?.getChildren?.(g))?.map(S=>this.convertVisualizerTreeItem(d,S))||[]:[]}async $editVisualizerTreeItem(d,w){const g=this._debugVisualizationElements.get(d);if(!g)return;const C=await this._debugVisualizationTrees.get(g.provider)?.editItem?.(g.item,w);return this.convertVisualizerTreeItem(g.provider,C||g.item)}$disposeVisualizedTree(d){const w=this._debugVisualizationElements.get(d);if(!w)return;const g=[w.children];for(const C of g)if(C)for(const S of C)g.push(this._debugVisualizationElements.get(S)?.children),this._debugVisualizationElements.delete(S)}convertVisualizerTreeItem(d,w){let g=this._debugVisualizationTreeItemIds.get(w);return g||(g=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(w,g),this._debugVisualizationElements.set(g,{provider:d,item:w})),c.DebugTreeItem.from(w,g)}asDebugSourceUri(d,w){const g=d;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let C=`debug:${encodeURIComponent(g.path||"")}`,S="?";return w&&(C+=`${S}session=${encodeURIComponent(w.id)}`,S="&"),C+=`${S}ref=${g.sourceReference}`,T.URI.parse(C)}else{if(g.path)return T.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const w=[];for(const g of d.getAllExtensionDescriptions())if(g.contributes){const C=g.contributes.debuggers;if(C&&C.length>0)for(const S of C)(0,m.isDebuggerMainContribution)(S)&&w.push(S.type)}this._debugServiceProxy.$registerDebugTypes(w)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const d=[];return this._breakpoints.forEach(w=>d.push(w)),d}async $resolveDebugVisualizer(d,w){const g=this._visualizers.get(d);if(!g)throw new Error(`No debug visualizer found with id '${d}'`);let{v:C,provider:S,extensionId:k}=g;if(C.visualization||(C=await S.resolveDebugVisualization?.(C,w)||C,g.v=C),!C.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${S}'`);return this.serializeVisualization(k,C.visualization)}async $executeDebugVisualizerCommand(d){const w=this._visualizers.get(d);if(!w)throw new Error(`No debug visualizer found with id '${d}'`);const g=w.v.visualization;g&&"command"in g&&this._commands.executeCommand(g.command,...g.arguments||[])}hydrateVisualizationContext(d){const w=this._debugSessions.get(d.sessionId);return w&&{session:w.api,variable:d.variable,containerId:d.containerId,frameId:d.frameId,threadId:d.threadId}}async $provideDebugVisualizers(d,w,g,C){const S=this.hydrateVisualizationContext(g),k=this.extensionVisKey(d,w),P=this._debugVisualizationProviders.get(k);if(!S||!P)return[];const H=await P.provideDebugVisualization(S,C);return H?H.map($=>{const V=++this._visualizerIdCounter;this._visualizers.set(V,{v:$,provider:P,extensionId:d});const R=$.iconPath?this.getIconPathOrClass($.iconPath):void 0;return{id:V,name:$.name,iconClass:R?.iconClass,iconPath:R?.iconPath,visualization:this.serializeVisualization(d,$.visualization)}}):[]}$disposeDebugVisualizers(d){for(const w of d)this._visualizers.delete(w)}registerDebugVisualizationProvider(d,w,g){if(!d.contributes?.debugVisualizers?.some(k=>k.id===w))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${w})`);const C=O.ExtensionIdentifier.toKey(d.identifier),S=this.extensionVisKey(C,w);if(this._debugVisualizationProviders.has(S))throw new Error(`A debug visualization provider with id '${w}' is already registered`);return this._debugVisualizationProviders.set(S,g),this._debugServiceProxy.$registerDebugVisualizer(C,w),(0,s.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(C,w),this._debugVisualizationProviders.delete(w)})}addBreakpoints(d){const w=d.filter(S=>{const k=S.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,S),!0)});this.fireBreakpointChanges(w,[],[]);const g=[],C=new Map;for(const S of w)if(S instanceof y.SourceBreakpoint){let k=C.get(S.location.uri.toString());k||(k={type:"sourceMulti",uri:S.location.uri,lines:[]},C.set(S.location.uri.toString(),k),g.push(k)),k.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character,mode:S.mode})}else S instanceof y.FunctionBreakpoint&&g.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName,mode:S.mode});return this._debugServiceProxy.$registerBreakpoints(g)}removeBreakpoints(d){const w=d.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],w,[]);const g=w.filter(k=>k instanceof y.SourceBreakpoint).map(k=>k.id),C=w.filter(k=>k instanceof y.FunctionBreakpoint).map(k=>k.id),S=w.filter(k=>k instanceof y.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(g,C,S)}startDebugging(d,w,g){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,w,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,w,g){if(!w)return new y.Disposable(()=>{});const C=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:C,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,g,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,C),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(C)})}registerDebugAdapterDescriptorFactory(d,w,g){if(!g)return new y.Disposable(()=>{});if(!this.definesDebugType(d,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const C=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:C,factory:g}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,C),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==g),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(C)})}registerDebugAdapterTrackerFactory(d,w){if(!w)return new y.Disposable(()=>{});const g=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:g,factory:w}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(C=>C.factory!==w)})}async $runInTerminal(d,w){return Promise.resolve(void 0)}async $substituteVariables(d,w){let g;const C=await this.getFolder(d);return C&&(g={uri:C.uri,name:C.name,index:C.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(g,w)}createDebugAdapter(d,w){if(d.type==="implementation")return new p(d.implementation)}createSignService(){}async $startDASession(d,w){const g=this,C=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(C.type),C).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${C.type}' (extension might have failed to activate)`);const k=this.convertToDto(S),P=this.createDebugAdapter(k,C);if(!P)throw new Error(`Couldn't create a debug adapter for type '${C.type}'.`);const H=P;return this._debugAdapters.set(d,H),this.getDebugAdapterTrackers(C).then($=>($&&this._debugAdaptersTrackers.set(d,$),H.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const R=V,z={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const q=await this._signService.sign(R.arguments.value);z.body={signature:q},H.sendResponse(z)}else throw new Error("no signer")}catch(q){z.success=!1,z.message=q.message,H.sendResponse(z)}}else $&&$.onDidSendMessage&&$.onDidSendMessage(V),V=(0,m.convertToVSCPaths)(V,!0),g._debugServiceProxy.$acceptDAMessage(d,V)}),H.onError(V=>{$&&$.onError&&$.onError(V),this._debugServiceProxy.$acceptDAError(d,V.name,V.message,V.stack)}),H.onExit(V=>{$&&$.onExit&&$.onExit(V??void 0,void 0),this._debugServiceProxy.$acceptDAExit(d,V??void 0,void 0)}),$&&$.onWillStartSession&&$.onWillStartSession(),H.startSession()))})}$sendDAMessage(d,w){w=(0,m.convertToDAPaths)(w,!1);const g=this._debugAdaptersTrackers.get(d);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(w),this._debugAdapters.get(d)?.sendMessage(w)}$stopDASession(d){const w=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),w&&w.onWillStopSession&&w.onWillStopSession();const g=this._debugAdapters.get(d);return this._debugAdapters.delete(d),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const w=[],g=[],C=[];if(d.added)for(const S of d.added){const k=S.id;if(k&&!this._breakpoints.has(k)){let P;if(S.type==="function")P=new y.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode);else if(S.type==="data")P=new y.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage,S.mode);else{const H=T.URI.revive(S.uri);P=new y.SourceBreakpoint(new y.Location(H,new y.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode)}(0,y.setBreakpointId)(P,k),this._breakpoints.set(k,P),w.push(P)}}if(d.removed)for(const S of d.removed){const k=this._breakpoints.get(S);k&&(this._breakpoints.delete(S),g.push(k))}if(d.changed){for(const S of d.changed)if(S.id){const k=this._breakpoints.get(S.id);if(k){if(k instanceof y.FunctionBreakpoint&&S.type==="function"){const P=k;P.enabled=S.enabled,P.condition=S.condition,P.hitCondition=S.hitCondition,P.logMessage=S.logMessage,P.functionName=S.functionName}else if(k instanceof y.SourceBreakpoint&&S.type==="source"){const P=k;P.enabled=S.enabled,P.condition=S.condition,P.hitCondition=S.hitCondition,P.logMessage=S.logMessage,P.location=new y.Location(T.URI.revive(S.uri),new y.Position(S.line,S.character))}C.push(k)}}}this.fireBreakpointChanges(w,g,C)}async $acceptStackFrameFocus(d){let w;if(d){const g=await this.getSession(d.sessionId);d.kind==="thread"?w=new y.DebugThread(g.api,d.threadId):w=new y.DebugStackFrame(g.api,d.threadId,d.frameId)}this._activeStackItem=w,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(d,w,g){return(0,I.asPromise)(async()=>{const C=this.getConfigProviderByHandle(d);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(w);return C.provideDebugConfigurations(S,g)}).then(C=>{if(!C)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return C})}$resolveDebugConfiguration(d,w,g,C){return(0,I.asPromise)(async()=>{const S=this.getConfigProviderByHandle(d);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(w);return S.resolveDebugConfiguration(k,g,C)})}$resolveDebugConfigurationWithSubstitutedVariables(d,w,g,C){return(0,I.asPromise)(async()=>{const S=this.getConfigProviderByHandle(d);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(w);return S.resolveDebugConfigurationWithSubstitutedVariables(k,g,C)})}async $provideDebugAdapter(d,w){const g=this.getAdapterDescriptorFactoryByHandle(d);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const C=await this.getSession(w);return this.getAdapterDescriptor(g,C).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${C.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(d){const w=await this.getSession(d);this._onDidStartDebugSession.fire(w.api)}async $acceptDebugSessionTerminated(d){const w=await this.getSession(d);w&&(this._onDidTerminateDebugSession.fire(w.api),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(d,w){(await this.getSession(d))?._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(d,w){const C={session:(await this.getSession(d)).api,event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(C)}convertToDto(d){if(d instanceof y.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof y.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const w=this._adapterFactories.filter(g=>g.type===d);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(d){const w=this._adapterFactories.filter(g=>g.handle===d);if(w.length>0)return w[0].factory}getConfigProviderByHandle(d){const w=this._configProviders.filter(g=>g.handle===d);if(w.length>0)return w[0].provider}definesDebugType(d,w){if(d.contributes){const g=d.contributes.debuggers;if(g&&g.length>0){for(const C of g)if(C.label&&C.type&&C.type===w)return!0}}return!1}getDebugAdapterTrackers(d){const g=d.configuration.type,C=this._trackerFactories.filter(S=>S.type===g||S.type==="*").map(S=>(0,I.asPromise)(()=>S.factory.createDebugAdapterTracker(d.api)).then(k=>k,k=>null));return Promise.race([Promise.all(C).then(S=>{const k=S.filter(P=>!!P);if(k.length>0)return new a(k)}),new Promise(S=>setTimeout(()=>S(void 0),1e3))]).catch(S=>{})}async getAdapterDescriptor(d,w){const g=w.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new y.DebugAdapterServer(g));if(d){const S=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>d.createDebugAdapterDescriptor(w.api,this.daExecutableFromPackage(w,S))).then(k=>{if(k)return k})}const C=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,C))}daExecutableFromPackage(d,w){}fireBreakpointChanges(d,w,g){(d.length>0||w.length>0||g.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:w,changed:g}))}async getSession(d){if(d)if(typeof d=="string"){const w=this._debugSessions.get(d);if(w)return w}else{let w=this._debugSessions.get(d.id);if(!w){const g=await this.getFolder(d.folderUri),C=d.parent?this._debugSessions.get(d.parent):void 0;w=new t(this._debugServiceProxy,d.id,d.type,d.name,g,d.configuration,C?.api),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(d){if(d){const w=T.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}extensionVisKey(d,w){return`${d}\0${w}`}serializeVisualization(d,w){if(w){if("title"in w&&"command"in w)return{type:0};if("treeId"in w)return{type:1,id:`${d}\0${w.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(d){const w=this.getIconUris(d);let g,C;return"id"in w?C=i.ThemeIcon.asClassName(w):g=w,{iconPath:g,iconClass:C}}getIconUris(d){if(d instanceof y.ThemeIcon)return{id:d.id};const w=typeof d=="object"&&"dark"in d?d.dark:d,g=typeof d=="object"&&"light"in d?d.light:d;return{dark:typeof w=="string"?T.URI.file(w):w,light:typeof g=="string"?T.URI.file(g):g}}};e.ExtHostDebugServiceBase=u,e.ExtHostDebugServiceBase=u=Ke([He(0,N.IExtHostRpcService),He(1,h.IExtHostWorkspace),He(2,_.IExtHostExtensionService),He(3,r.IExtHostConfiguration),He(4,v.IExtHostEditorTabs),He(5,o.IExtHostVariableResolverProvider),He(6,n.IExtHostCommands)],u);class t{constructor(d,w,g,C,S,k,P){this._debugServiceProxy=d,this._id=w,this._type=g,this._name=C,this._workspaceFolder=S,this._configuration=k,this._parentSession=P}get api(){const d=this;return this.apiSession??=Object.freeze({id:d._id,type:d._type,get name(){return d._name},set name(w){d._name=w,d._debugServiceProxy.$setDebugSessionName(d._id,w)},parentSession:d._parentSession,workspaceFolder:d._workspaceFolder,configuration:d._configuration,customRequest(w,g){return d._debugServiceProxy.$customDebugAdapterRequest(d._id,w,g)},getDebugProtocolBreakpoint(w){return d._debugServiceProxy.$getDebugProtocolBreakpoint(d._id,w.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(d){this._name=d}get configuration(){return this._configuration}}e.ExtHostDebugSession=t;class f{constructor(d){this.value=Object.freeze({append(w){d.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=f;class a{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(w=>w.onError?w.onError(d):void 0)}onExit(d,w){this.trackers.forEach(g=>g.onExit?g.onExit(d,w):void 0)}}class p extends b.AbstractDebugAdapter{constructor(d){super(),this.implementation=d,d.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends u{constructor(d,w,g,C,S,k,P){super(d,w,g,C,S,k,P)}};e.WorkerExtHostDebugService=l,e.WorkerExtHostDebugService=l=Ke([He(0,N.IExtHostRpcService),He(1,h.IExtHostWorkspace),He(2,_.IExtHostExtensionService),He(3,r.IExtHostConfiguration),He(4,v.IExtHostEditorTabs),He(5,o.IExtHostVariableResolverProvider),He(6,n.IExtHostCommands)],l)}),define(Ie[305],Pe([1,0,14,60,2,4,254,12,56,72,27,199,17,61,41,63]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class o{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(E.ILogService),t=n.get(h.IExtHostRpcService).getProxy(O.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(f=>{c.error(f);const a=I.transformErrorForSerialization(f);t.$onUnexpectedError(a)})}static async installFullHandler(n){const c=n.get(E.ILogService),u=n.get(h.IExtHostRpcService),t=n.get(m.IExtHostExtensionService),f=n.get(r.IExtHostTelemetry),a=u.getProxy(O.MainContext.MainThreadExtensionService),p=u.getProxy(O.MainContext.MainThreadErrors),l=await t.getExtensionPathIndex(),D=new WeakMap;function d(C,S){if(D.has(C))return D.get(C).stack;let k="",P,H;for(const V of S)k+=`
	at ${V.toString()}`,H=V.getFileName(),!P&&H&&(P=l.findSubstr(T.URI.file(H)));const $=`${C.name||"Error"}: ${C.message||""}${k}`;return D.set(C,{extensionIdentifier:P?.identifier,stack:$}),$}const w=Symbol("prepareStackTrace wrapped");let g=d;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(C){if(C===d||!C||C[w]){g=C||d;return}g=function(S,k){return d(S,k),C.call(Error,S,k)},Object.assign(g,{[w]:!0})}}),I.setUnexpectedErrorHandler(C=>{c.error(C);const S=I.transformErrorForSerialization(C),k=D.get(C);if(!k?.extensionIdentifier){p.$onUnexpectedError(S);return}a.$onExtensionRuntimeError(k.extensionIdentifier,S);const P=f.onExtensionError(k.extensionIdentifier,C);c.trace("forwarded error to extension?",P,k)})}}e.ErrorHandler=o;class s{constructor(n,c,u,t,f){this._hostUtils=u,this._rpcProtocol=new A.RPCProtocol(n,null,t),c=s._transform(c,this._rpcProtocol);const a=new _.ServiceCollection(...(0,v.getSingletonServiceDescriptors)());a.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...c,messagePorts:f}),a.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),a.set(b.IURITransformerService,new b.URITransformerService(t)),a.set(m.IHostUtils,u);const p=new y.InstantiationService(a,!0);p.invokeFunction(o.installEarlyHandler),this._logService=p.invokeFunction(l=>l.get(E.ILogService)),L.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",c),this._extensionService=p.invokeFunction(l=>l.get(m.IExtHostExtensionService)),this._extensionService.initialize(),p.invokeFunction(o.installFullHandler)}async asBrowserUri(n){const c=this._rpcProtocol.getProxy(O.MainContext.MainThreadExtensionService);return T.URI.revive(await c.$asBrowserUri(n))}terminate(n){this._extensionService.terminate(n)}static _transform(n,c){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=T.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=T.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const u=n.environment.extensionDevelopmentLocationURI;return u&&(n.environment.extensionDevelopmentLocationURI=u.map(t=>T.URI.revive(c.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=T.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=T.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=T.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=T.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=T.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=T.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.ExtensionHostMain=s}),define(Ie[306],Pe([1,0,18,11,24,44,16,19,23,2,47]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,e.extensionResultIsMatch=r;class y{constructor(i,n,c){this.queryProviderPair=i,this.fileUtils=n,this.processType=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(i,n){const c=this.query.folderQueries||[],u=new T.CancellationTokenSource(n);return new Promise((t,f)=>{this.collector=new b(i);let a=!1;const p=(l,D)=>{if(!a&&!this.isLimitHit){const d=this.resultSize(l);r(l)&&typeof this.query.maxResults=="number"&&this.resultCount+d>this.query.maxResults&&(this.isLimitHit=!0,a=!0,u.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const w=this.resultSize(l);this.resultCount+=w,(w>0||!r(l))&&this.collector.add(l,D)}};Promise.all(c.map((l,D)=>this.searchInFolder(l,d=>p(d,D),u.token))).then(l=>{u.dispose(),this.collector.flush();const D=l.some(d=>!!d&&!!d.limitHit);t({limitHit:this.isLimitHit||D,messages:(0,I.flatten)(l.map(d=>d?.message?Array.isArray(d.message)?d.message:[d.message]:[])),stats:{type:this.processType}})},l=>{u.dispose();const D=(0,O.toErrorMessage)(l);f(new Error(D))})})}resultSize(i){return r(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}trimResultToSize(i,n){const c=Array.isArray(i.ranges)?i.ranges:[i.ranges],u=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:c.slice(0,n),preview:{matches:u.slice(0,n),text:i.preview.text},uri:i.uri}}async searchInFolder(i,n,c){const u=new N.QueryGlobTester(this.query,i),t=[],f={report:l=>{if(!this.validateProviderResult(l))return;const D=i.folder.scheme===A.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(v.dirname(l.uri))):void 0,d=v.relativePath(i.folder,l.uri);if(d){const w=u.includedInQuery(d,E.basename(d),D);(0,L.isThenable)(w)?t.push(w.then(g=>{g&&n(l)})):w&&n(l)}}},a=this.getSearchOptionsForFolder(i);let p;return this.queryProviderPair.query.type===3?p=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,a,f,c):p=await this.queryProviderPair.provider.provideTextSearchResults(h(this.queryProviderPair.query.contentPattern),a,f,c),t.length&&await Promise.all(t),p}validateProviderResult(i){if(r(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(i){const n=(0,N.resolvePatternsForProvider)(this.query.includePattern,i.includePattern),c=(0,N.resolvePatternsForProvider)(this.query.excludePattern,i.excludePattern),u={folder:_.URI.from(i.folder),excludes:c,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.fileUtils.toCanonicalName(i.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return"usePCRE2"in this.query&&(u.usePCRE2=this.query.usePCRE2),u}}e.TextSearchManager=y;function h(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class b{constructor(i){this._onResult=i,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new o(512,n=>this.sendItems(n))}add(i,n){this._currentFileMatch&&(this._currentFolderIdx!==n||!v.isEqual(this._currentUri,i.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=n,this._currentFileMatch={resource:i.uri,results:[]}),this._currentFileMatch.results.push(m(i))}pushToCollector(){const i=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,i)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(i){this._onResult(i)}}e.TextSearchResultsCollector=b;function m(s){return r(s)?{preview:{matches:(0,I.mapArrayOrNot)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,I.mapArrayOrNot)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class o{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(i,n){this.maxBatchSize=i,this.cb=n,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(i,n){i&&this.addItemToBatch(i,n)}addItems(i,n){i&&this.addItemsToBatch(i,n)}addItemToBatch(i,n){this.batch.push(i),this.batchSize+=n,this.onUpdate()}addItemsToBatch(i,n){this.batch=this.batch.concat(i),this.batchSize+=n,this.onUpdate()}onUpdate(){this.totalNumberCompleted<o.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},o.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=o}),define(Ie[124],Pe([1,0,6,4,3,301,17,61,12,2,306]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=h,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let y=class{constructor(r,o,s){this.extHostRpc=r,this._uriTransformer=o,this._logService=s,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new O.FileSearchManager}_transformScheme(r){return this._uriTransformer.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this._textSearchUsedSchemes.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this._textSearchUsedSchemes.add(r);const s=this._handlePool++;return this._textSearchProvider.set(s,o),this._proxy.$registerTextSearchProvider(s,this._transformScheme(r)),(0,I.toDisposable)(()=>{this._textSearchUsedSchemes.delete(r),this._textSearchProvider.delete(s),this._proxy.$unregisterProvider(s)})}registerAITextSearchProvider(r,o){if(this._aiTextSearchUsedSchemes.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this._aiTextSearchUsedSchemes.add(r);const s=this._handlePool++;return this._aiTextSearchProvider.set(s,o),this._proxy.$registerAITextSearchProvider(s,this._transformScheme(r)),(0,I.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(r),this._aiTextSearchProvider.delete(s),this._proxy.$unregisterProvider(s)})}registerFileSearchProvider(r,o){if(this._fileSearchUsedSchemes.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this._fileSearchUsedSchemes.add(r);const s=this._handlePool++;return this._fileSearchProvider.set(s,o),this._proxy.$registerFileSearchProvider(s,this._transformScheme(r)),(0,I.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(r),this._fileSearchProvider.delete(s),this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(r,o,s,i){const n=h(s),c=this._fileSearchProvider.get(r);if(c)return this._fileSearchManager.fileSearch(n,c,u=>{this._proxy.$handleFileMatch(r,o,u.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,s){return{messages:[]}}$clearCache(r){return this._fileSearchManager.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,s,i){const n=this._textSearchProvider.get(r);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const c=h(s);return this.createTextSearchManager(c,n).search(t=>this._proxy.$handleTextMatch(r,o,t),i)}$provideAITextSearchResults(r,o,s,i){const n=this._aiTextSearchProvider.get(r);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const c=h(s);return this.createAITextSearchManager(c,n).search(t=>this._proxy.$handleTextMatch(r,o,t),i)}$enableExtensionHostSearch(){}createTextSearchManager(r,o){return new N.TextSearchManager({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}createAITextSearchManager(r,o){return new N.TextSearchManager({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.ExtHostSearch=y,e.ExtHostSearch=y=Ke([He(0,A.IExtHostRpcService),He(1,E.IURITransformerService),He(2,v.ILogService)],y);function h(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(r=>_.URI.revive(r))}}function b(m){return{...m,folder:_.URI.revive(m.folder)}}}),define(Ie[307],Pe([1,0,24,14,5,6,16,33,2,158,154,141,95,20,38,12,58,59,213,4,257,285,80,86,262,263,264,243,232,32,265,40,266,123,112,267,245,258,268,269,68,67,259,41,271,65,272,46,27,286,287,246,273,90,274,81,82,248,300,276,219,277,288,278,118,249,279,280,281,17,282,124,83,283,250,284,84,87,121,63,53,116,289,290,260,291,292,88,8,7,251,61,252,64,293,294,111,39,227,79,26,120]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c,u,t,f,a,p,l,D,d,w,g,C,S,k,P,H,$,V,R,z,q,ie,ce,Se,De,fe,pe,Ne,ae,Re,ne,x,J,be,Me,ye,Ee,ge,G,Y,de,le,Oe,he,ke,Te,ze,U,M,W,j,ee,re,Le,Be,We,Ze,Je,et,tt,it,at,gt,Ue,st,Q,X,me,Ve,we,ot,ht,Pt,$t,Gt,ti,Xt,_t,Qt,Yt,Qe,oi){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=jt;function jt(dt){const pt=dt.get(ae.IExtHostInitDataService),Jt=dt.get(Ne.IExtHostFileSystemInfo),qt=dt.get(fe.IExtHostConsumerFileSystem),Mt=dt.get(Se.IExtHostExtensionService),ft=dt.get(_t.IExtHostWorkspace),Bt=dt.get(tt.IExtHostTelemetry),Zt=dt.get(C.IExtHostConfiguration),zt=dt.get(ht.IURITransformerService),Ge=dt.get(W.IExtHostRpcService),li=dt.get(Ze.IExtHostStorage),Kt=dt.get(Je.IExtensionStoragePaths),Ht=dt.get(r.ILoggerService),vt=dt.get(r.ILogService),Ft=dt.get(me.IExtHostTunnelService),At=dt.get(t.IExtHostApiDeprecationService),Lt=dt.get(Xt.IExtHostWindow),ii=dt.get(re.IExtHostSecretState),Vt=dt.get(ie.IExtHostEditorTabs),ni=dt.get(Ee.IExtHostManagedSockets),kt=dt.get(f.IExtHostAuthentication),Ot=dt.get(be.IExtHostLanguageModels);Ge.set(n.ExtHostContext.ExtHostFileSystemInfo,Jt),Ge.set(n.ExtHostContext.ExtHostLogLevelServiceShape,Ht),Ge.set(n.ExtHostContext.ExtHostWorkspace,ft),Ge.set(n.ExtHostContext.ExtHostConfiguration,Zt),Ge.set(n.ExtHostContext.ExtHostExtensionService,Mt),Ge.set(n.ExtHostContext.ExtHostStorage,li),Ge.set(n.ExtHostContext.ExtHostTunnelService,Ft),Ge.set(n.ExtHostContext.ExtHostWindow,Lt),Ge.set(n.ExtHostContext.ExtHostSecretState,ii),Ge.set(n.ExtHostContext.ExtHostTelemetry,Bt),Ge.set(n.ExtHostContext.ExtHostEditorTabs,Vt),Ge.set(n.ExtHostContext.ExtHostManagedSockets,ni),Ge.set(n.ExtHostContext.ExtHostAuthentication,kt),Ge.set(n.ExtHostContext.ExtHostChatProvider,Ot);const Rt=Ge.set(n.ExtHostContext.ExtHostDecorations,dt.get(P.IExtHostDecorations)),It=Ge.set(n.ExtHostContext.ExtHostDocumentsAndEditors,dt.get(q.IExtHostDocumentsAndEditors)),mt=Ge.set(n.ExtHostContext.ExtHostCommands,dt.get(w.IExtHostCommands)),yt=Ge.set(n.ExtHostContext.ExtHostTerminalService,dt.get(it.IExtHostTerminalService)),ai=Ge.set(n.ExtHostContext.ExtHostTerminalShellIntegration,dt.get(at.IExtHostTerminalShellIntegration)),Ct=Ge.set(n.ExtHostContext.ExtHostDebugService,dt.get(k.IExtHostDebugService)),fi=Ge.set(n.ExtHostContext.ExtHostSearch,dt.get(ee.IExtHostSearch)),ri=Ge.set(n.ExtHostContext.ExtHostTask,dt.get(et.IExtHostTask)),pi=Ge.set(n.ExtHostContext.ExtHostOutputService,dt.get(ke.IExtHostOutputService)),ui=Ge.set(n.ExtHostContext.ExtHostLocalization,dt.get(ye.IExtHostLocalizationService)),Ei=Ge.set(n.ExtHostContext.ExtHostUrls,new Pt.ExtHostUrls(Ge)),Dt=Ge.set(n.ExtHostContext.ExtHostDocuments,new z.ExtHostDocuments(Ge,It)),wi=Ge.set(n.ExtHostContext.ExtHostDocumentContentProviders,new V.ExtHostDocumentContentProvider(Ge,It,vt)),si=Ge.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new R.ExtHostDocumentSaveParticipant(vt,Dt,Ge.getProxy(n.MainContext.MainThreadBulkEdits))),ve=Ge.set(n.ExtHostContext.ExtHostNotebook,new G.ExtHostNotebookController(Ge,mt,It,Dt,qt,fi)),Ae=Ge.set(n.ExtHostContext.ExtHostNotebookDocuments,new de.ExtHostNotebookDocuments(ve)),se=Ge.set(n.ExtHostContext.ExtHostNotebookEditors,new le.ExtHostNotebookEditors(vt,ve)),K=Ge.set(n.ExtHostContext.ExtHostNotebookKernels,new Oe.ExtHostNotebookKernels(Ge,pt,ve,mt,vt)),Ce=Ge.set(n.ExtHostContext.ExtHostNotebookRenderers,new he.ExtHostNotebookRenderers(Ge,ve)),$e=Ge.set(n.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Y.ExtHostNotebookDocumentSaveParticipant(vt,ve,Ge.getProxy(n.MainContext.MainThreadBulkEdits))),Xe=Ge.set(n.ExtHostContext.ExtHostEditors,new Ue.ExtHostEditors(Ge,It)),je=Ge.set(n.ExtHostContext.ExtHostTreeViews,new X.ExtHostTreeViews(Ge.getProxy(n.MainContext.MainThreadTreeViews),mt,vt)),lt=Ge.set(n.ExtHostContext.ExtHostEditorInsets,new d.ExtHostEditorInsets(Ge.getProxy(n.MainContext.MainThreadEditorInsets),Xe,pt.remote)),St=Ge.set(n.ExtHostContext.ExtHostDiagnostics,new H.ExtHostDiagnostics(Ge,vt,Jt,It)),xt=Ge.set(n.ExtHostContext.ExtHostLanguages,new Me.ExtHostLanguages(Ge,Dt,mt.converter,zt)),ct=Ge.set(n.ExtHostContext.ExtHostLanguageFeatures,new J.ExtHostLanguageFeatures(Ge,zt,Dt,mt,St,vt,At,Bt)),Nt=Ge.set(n.ExtHostContext.ExtHostFileSystem,new De.ExtHostFileSystem(Ge,ct)),Ut=Ge.set(n.ExtHostContext.ExtHostFileSystemEventService,new pe.ExtHostFileSystemEventService(Ge,vt,It)),Si=Ge.set(n.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Ge,ft,mt)),Ci=Ge.set(n.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(Ge,mt,Dt,vt)),qi=Ge.set(n.ExtHostContext.ExtHostQuickDiff,new U.ExtHostQuickDiff(Ge,zt)),Li=Ge.set(n.ExtHostContext.ExtHostShare,new Le.ExtHostShare(Ge,zt)),Oi=Ge.set(n.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(Ge,mt,Dt)),Di=Ge.set(n.ExtHostContext.ExtHostProgress,new ze.ExtHostProgress(Ge.getProxy(n.MainContext.MainThreadProgress))),Ni=Ge.set(n.ExtHostContext.ExtHostLabelService,new x.ExtHostLabelService(Ge)),Mi=Ge.set(n.ExtHostContext.ExtHostTheming,new st.ExtHostTheming(Ge)),Ki=Ge.set(n.ExtHostContext.ExtHostTimeline,new Q.ExtHostTimeline(Ge,mt)),Fi=Ge.set(n.ExtHostContext.ExtHostWebviews,new $t.ExtHostWebviews(Ge,pt.remote,ft,vt,At)),Ii=Ge.set(n.ExtHostContext.ExtHostWebviewPanels,new Gt.ExtHostWebviewPanels(Ge,Fi,ft)),xi=Ge.set(n.ExtHostContext.ExtHostCustomEditors,new S.ExtHostCustomEditors(Ge,Dt,Kt,Fi,Ii)),Ui=Ge.set(n.ExtHostContext.ExtHostWebviewViews,new ti.ExtHostWebviewViews(Ge,Fi)),bi=Ge.set(n.ExtHostContext.ExtHostTesting,new gt.ExtHostTesting(Ge,vt,mt,It)),Gi=Ge.set(n.ExtHostContext.ExtHostUriOpeners,new ot.ExtHostUriOpeners(Ge)),Xi=Ge.set(n.ExtHostContext.ExtHostProfileContentHandlers,new Te.ExtHostProfileContentHandlers(Ge));Ge.set(n.ExtHostContext.ExtHostInteractive,new ne.ExtHostInteractive(Ge,ve,It,mt,vt));const Qi=Ge.set(n.ExtHostContext.ExtHostInlineChat,new Re.ExtHostInteractiveEditor(Ge,mt,Dt,vt)),Pi=Ge.set(n.ExtHostContext.ExtHostChatAgents2,new p.ExtHostChatAgents2(Ge,vt,mt)),Yi=Ge.set(n.ExtHostContext.ExtHostChatVariables,new l.ExtHostChatVariables(Ge)),Ji=Ge.set(n.ExtHostContext.ExtHostAiRelatedInformation,new c.ExtHostRelatedInformation(Ge)),hn=Ge.set(n.ExtHostContext.ExtHostAiEmbeddingVector,new ce.ExtHostAiEmbeddingVector(Ge)),ki=Ge.set(n.ExtHostContext.ExtHostStatusBar,new We.ExtHostStatusBar(Ge,mt.converter)),zi=Ge.set(n.ExtHostContext.ExtHostSpeech,new Be.ExtHostSpeech(Ge)),fn=Object.values(n.ExtHostContext);Ge.assertRegistered(fn);const gn=new a.ExtHostBulkEdits(Ge,It),Zi=new D.ExtHostClipboard(Ge),Bi=new ge.ExtHostMessageService(Ge,vt),Ti=new $.ExtHostDialogs(Ge);return u.ExtHostApiCommands.register(mt),function(xe,di,$i){function nt(Z){return(oe,Fe,rt)=>{const wt=Z(Tt=>{try{oe.call(Fe,Tt)}catch(yi){L.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${xe.identifier.value}' FAILED to handle event: ${yi.toString()}`,{cause:yi})),Bt.onExtensionError(xe.identifier,yi)}});return rt?.push(wt),wt}}const bt=function(){let Z=!xe.isUnderDevelopment;function oe(){Z||(vt.info(`Extension '${xe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")oe();else{const wt=rt;typeof wt.scheme>"u"&&oe(),typeof wt.exclusive=="boolean"&&(0,Qe.checkProposedApiEnabled)(xe,"documentFiltersExclusive")}return rt}}(),en={getSession(Z,oe,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,Qe.checkProposedApiEnabled)(xe,"authLearnMore"),kt.getSession(xe,Z,oe,Fe)},getSessions(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"authGetSessions"),kt.getSessions(xe,Z,oe)},async hasSession(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"authSession"),!!await kt.getSession(xe,Z,oe,{silent:!0})},get onDidChangeSessions(){return nt(kt.onDidChangeSessions)},registerAuthenticationProvider(Z,oe,Fe,rt){return kt.registerAuthenticationProvider(Z,oe,Fe,rt)}},gi={registerCommand(Z,oe,Fe){return mt.registerCommand(!0,Z,oe,Fe,void 0,xe)},registerTextEditorCommand(Z,oe,Fe){return mt.registerCommand(!0,Z,(...rt)=>{const wt=Xe.getActiveTextEditor();if(!wt){vt.warn("Cannot execute "+Z+" because there is no active text editor.");return}return wt.edit(Tt=>{oe.apply(Fe,[wt,Tt,...rt])}).then(Tt=>{Tt||vt.warn("Edits from command "+Z+" were not applied.")},Tt=>{vt.warn("An error occurred while running command "+Z,Tt)})},void 0,void 0,xe)},registerDiffInformationCommand:(Z,oe,Fe)=>((0,Qe.checkProposedApiEnabled)(xe,"diffCommand"),mt.registerCommand(!0,Z,async(...rt)=>{const wt=It.activeEditor(!0);if(!wt){vt.warn("Cannot execute "+Z+" because there is no active text editor.");return}const Tt=await Xe.getDiffInformation(wt.id);oe.apply(Fe,[Tt,...rt])},void 0,void 0,xe)),executeCommand(Z,...oe){return mt.executeCommand(Z,...oe)},getCommands(Z=!1){return mt.getCommands(Z)}},_i={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Zi.value},get shell(){return yt.getDefaultShell(!1)},get onDidChangeShell(){return nt(yt.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Qe.checkProposedApiEnabled)(xe,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Qe.checkProposedApiEnabled)(xe,"telemetry"),nt(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(Z,oe){return tt.ExtHostTelemetryLogger.validateSender(Z),Bt.instantiateLogger(xe,Z,oe)},openExternal(Z,oe){return Lt.openUri(Z,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===pt.environment.appUriScheme)return Ei.createAppUri(Z);try{return await Lt.asExternalUri(Z,{allowTunneling:!!pt.remote.authority})}catch(oe){if((0,A.matchesScheme)(Z,A.Schemas.http)||(0,A.matchesScheme)(Z,A.Schemas.https))return Z;throw oe}},get remoteName(){return(0,o.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,Qe.checkProposedApiEnabled)(xe,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return nt(vt.onDidChangeLogLevel)},get appQuality(){return(0,Qe.checkProposedApiEnabled)(xe,"resolvers"),pt.quality},get appCommit(){return(0,Qe.checkProposedApiEnabled)(xe,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(_i);const mn={createTestController(Z,oe,Fe){return bi.createTestController(xe,Z,oe,Fe)},createTestObserver(){return(0,Qe.checkProposedApiEnabled)(xe,"testObserver"),bi.createTestObserver()},runTests(Z){return(0,Qe.checkProposedApiEnabled)(xe,"testObserver"),bi.runTests(Z)},get onDidChangeTestResults(){return(0,Qe.checkProposedApiEnabled)(xe,"testObserver"),nt(bi.onResultsChanged)},get testResults(){return(0,Qe.checkProposedApiEnabled)(xe,"testObserver"),bi.results}},ei=pt.remote.isRemote?we.ExtensionKind.Workspace:we.ExtensionKind.UI,Ai={getExtension(Z,oe){(0,Qe.isProposedApiEnabled)(xe,"extensionsAny")||(oe=!1);const Fe=di.mine.getExtensionDescription(Z);if(Fe)return new Se.Extension(Mt,xe.identifier,Fe,ei,!1);if(oe){const rt=di.all.getExtensionDescription(Z);if(rt)return new Se.Extension(Mt,xe.identifier,rt,ei,!0)}},get all(){const Z=[];for(const oe of di.mine.getAllExtensionDescriptions())Z.push(new Se.Extension(Mt,xe.identifier,oe,ei,!1));return Z},get allAcrossExtensionHosts(){(0,Qe.checkProposedApiEnabled)(xe,"extensionsAny");const Z=new b.ExtensionIdentifierSet(di.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),oe=[];for(const Fe of di.all.getAllExtensionDescriptions()){const rt=!Z.has(Fe.identifier);oe.push(new Se.Extension(Mt,xe.identifier,Fe,ei,rt))}return oe},get onDidChange(){return(0,Qe.isProposedApiEnabled)(xe,"extensionsAny")?nt(T.Event.any(di.mine.onDidChange,di.all.onDidChange)):nt(di.mine.onDidChange)}},tn={createDiagnosticCollection(Z){return St.createDiagnosticCollection(xe.identifier,Z)},get onDidChangeDiagnostics(){return nt(St.onDidChangeDiagnostics)},getDiagnostics:Z=>St.getDiagnostics(Z),getLanguages(){return xt.getLanguages()},setTextDocumentLanguage(Z,oe){return xt.changeLanguage(Z.uri,oe)},match(Z,oe){const Fe=Ve.LanguageSelector.from(Z);let rt;return(0,N.targetsNotebooks)(Fe)&&(rt=ve.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Tt=>Tt.document===oe))?.apiNotebook),(0,N.score)(Fe,oe.uri,oe.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(Z,oe,Fe){return ct.registerCodeActionProvider(xe,bt(Z),oe,Fe)},registerDocumentPasteEditProvider(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"documentPaste"),ct.registerDocumentPasteEditProvider(xe,bt(Z),oe,Fe)},registerCodeLensProvider(Z,oe){return ct.registerCodeLensProvider(xe,bt(Z),oe)},registerDefinitionProvider(Z,oe){return ct.registerDefinitionProvider(xe,bt(Z),oe)},registerDeclarationProvider(Z,oe){return ct.registerDeclarationProvider(xe,bt(Z),oe)},registerImplementationProvider(Z,oe){return ct.registerImplementationProvider(xe,bt(Z),oe)},registerTypeDefinitionProvider(Z,oe){return ct.registerTypeDefinitionProvider(xe,bt(Z),oe)},registerHoverProvider(Z,oe){return ct.registerHoverProvider(xe,bt(Z),oe,xe.identifier)},registerEvaluatableExpressionProvider(Z,oe){return ct.registerEvaluatableExpressionProvider(xe,bt(Z),oe,xe.identifier)},registerInlineValuesProvider(Z,oe){return ct.registerInlineValuesProvider(xe,bt(Z),oe,xe.identifier)},registerDocumentHighlightProvider(Z,oe){return ct.registerDocumentHighlightProvider(xe,bt(Z),oe)},registerMultiDocumentHighlightProvider(Z,oe){return ct.registerMultiDocumentHighlightProvider(xe,bt(Z),oe)},registerLinkedEditingRangeProvider(Z,oe){return ct.registerLinkedEditingRangeProvider(xe,bt(Z),oe)},registerReferenceProvider(Z,oe){return ct.registerReferenceProvider(xe,bt(Z),oe)},registerRenameProvider(Z,oe){return ct.registerRenameProvider(xe,bt(Z),oe)},registerNewSymbolNamesProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(xe,bt(Z),oe)},registerDocumentSymbolProvider(Z,oe,Fe){return ct.registerDocumentSymbolProvider(xe,bt(Z),oe,Fe)},registerWorkspaceSymbolProvider(Z){return ct.registerWorkspaceSymbolProvider(xe,Z)},registerDocumentFormattingEditProvider(Z,oe){return ct.registerDocumentFormattingEditProvider(xe,bt(Z),oe)},registerDocumentRangeFormattingEditProvider(Z,oe){return ct.registerDocumentRangeFormattingEditProvider(xe,bt(Z),oe)},registerOnTypeFormattingEditProvider(Z,oe,Fe,...rt){return ct.registerOnTypeFormattingEditProvider(xe,bt(Z),oe,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(Z,oe,Fe){return ct.registerDocumentSemanticTokensProvider(xe,bt(Z),oe,Fe)},registerDocumentRangeSemanticTokensProvider(Z,oe,Fe){return ct.registerDocumentRangeSemanticTokensProvider(xe,bt(Z),oe,Fe)},registerSignatureHelpProvider(Z,oe,Fe,...rt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(xe,bt(Z),oe,Fe):ct.registerSignatureHelpProvider(xe,bt(Z),oe,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(Z,oe,...Fe){return ct.registerCompletionItemProvider(xe,bt(Z),oe,Fe)},registerInlineCompletionItemProvider(Z,oe,Fe){return oe.handleDidShowCompletionItem&&(0,Qe.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Qe.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),Fe&&(0,Qe.checkProposedApiEnabled)(xe,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(xe,bt(Z),oe,Fe)},registerInlineEditProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"inlineEdit"),ct.registerInlineEditProvider(xe,bt(Z),oe)},registerDocumentLinkProvider(Z,oe){return ct.registerDocumentLinkProvider(xe,bt(Z),oe)},registerColorProvider(Z,oe){return ct.registerColorProvider(xe,bt(Z),oe)},registerFoldingRangeProvider(Z,oe){return ct.registerFoldingRangeProvider(xe,bt(Z),oe)},registerSelectionRangeProvider(Z,oe){return ct.registerSelectionRangeProvider(xe,Z,oe)},registerCallHierarchyProvider(Z,oe){return ct.registerCallHierarchyProvider(xe,Z,oe)},registerTypeHierarchyProvider(Z,oe){return ct.registerTypeHierarchyProvider(xe,Z,oe)},setLanguageConfiguration:(Z,oe)=>ct.setLanguageConfiguration(xe,Z,oe),getTokenInformationAtPosition(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"tokenInformation"),xt.tokenAtPosition(Z,oe)},registerInlayHintsProvider(Z,oe){return ct.registerInlayHintsProvider(xe,Z,oe)},createLanguageStatusItem(Z,oe){return xt.createLanguageStatusItem(xe,Z,oe)},registerDocumentDropEditProvider(Z,oe,Fe){return ct.registerDocumentOnDropEditProvider(xe,Z,oe,(0,Qe.isProposedApiEnabled)(xe,"documentPaste")?Fe:void 0)}},nn={get activeTextEditor(){return Xe.getActiveTextEditor()},get visibleTextEditors(){return Xe.getVisibleTextEditors()},get activeTerminal(){return yt.activeTerminal},get terminals(){return yt.terminals},async showTextDocument(Z,oe,Fe){v.URI.isUri(Z)&&Z.scheme===A.Schemas.vscodeRemote&&!Z.authority&&At.report("workspace.showTextDocument",xe,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(v.URI.isUri(Z)?Promise.resolve(Hi.openTextDocument(Z)):Promise.resolve(Z));return Xe.showTextDocument(rt,oe,Fe)},createTextEditorDecorationType(Z){return Xe.createTextEditorDecorationType(xe,Z)},onDidChangeActiveTextEditor(Z,oe,Fe){return nt(Xe.onDidChangeActiveTextEditor)(Z,oe,Fe)},onDidChangeVisibleTextEditors(Z,oe,Fe){return nt(Xe.onDidChangeVisibleTextEditors)(Z,oe,Fe)},onDidChangeTextEditorSelection(Z,oe,Fe){return nt(Xe.onDidChangeTextEditorSelection)(Z,oe,Fe)},onDidChangeTextEditorOptions(Z,oe,Fe){return nt(Xe.onDidChangeTextEditorOptions)(Z,oe,Fe)},onDidChangeTextEditorVisibleRanges(Z,oe,Fe){return nt(Xe.onDidChangeTextEditorVisibleRanges)(Z,oe,Fe)},onDidChangeTextEditorViewColumn(Z,oe,Fe){return nt(Xe.onDidChangeTextEditorViewColumn)(Z,oe,Fe)},onDidCloseTerminal(Z,oe,Fe){return nt(yt.onDidCloseTerminal)(Z,oe,Fe)},onDidOpenTerminal(Z,oe,Fe){return nt(yt.onDidOpenTerminal)(Z,oe,Fe)},onDidChangeActiveTerminal(Z,oe,Fe){return nt(yt.onDidChangeActiveTerminal)(Z,oe,Fe)},onDidChangeTerminalDimensions(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"terminalDimensions"),nt(yt.onDidChangeTerminalDimensions)(Z,oe,Fe)},onDidChangeTerminalState(Z,oe,Fe){return nt(yt.onDidChangeTerminalState)(Z,oe,Fe)},onDidWriteTerminalData(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"terminalDataWriteEvent"),nt(yt.onDidWriteTerminalData)(Z,oe,Fe)},onDidExecuteTerminalCommand(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"terminalExecuteCommandEvent"),nt(yt.onDidExecuteTerminalCommand)(Z,oe,Fe)},onDidChangeTerminalShellIntegration(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"terminalShellIntegration"),nt(ai.onDidChangeTerminalShellIntegration)(Z,oe,Fe)},onDidStartTerminalShellExecution(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"terminalShellIntegration"),nt(ai.onDidStartTerminalShellExecution)(Z,oe,Fe)},onDidEndTerminalShellExecution(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"terminalShellIntegration"),nt(ai.onDidEndTerminalShellExecution)(Z,oe,Fe)},get state(){return Lt.getState()},onDidChangeWindowState(Z,oe,Fe){return nt(Lt.onDidChangeWindowState)(Z,oe,Fe)},showInformationMessage(Z,...oe){return Bi.showMessage(xe,E.default.Info,Z,oe[0],oe.slice(1))},showWarningMessage(Z,...oe){return Bi.showMessage(xe,E.default.Warning,Z,oe[0],oe.slice(1))},showErrorMessage(Z,...oe){return Bi.showMessage(xe,E.default.Error,Z,oe[0],oe.slice(1))},showQuickPick(Z,oe,Fe){return Si.showQuickPick(xe,Z,oe,Fe)},showWorkspaceFolderPick(Z){return Si.showWorkspaceFolderPick(Z)},showInputBox(Z,oe){return Si.showInput(Z,oe)},showOpenDialog(Z){return Ti.showOpenDialog(xe,Z)},showSaveDialog(Z){return Ti.showSaveDialog(Z)},createStatusBarItem(Z,oe,Fe){let rt,wt,Tt;return typeof Z=="string"?(rt=Z,wt=oe,Tt=Fe):(wt=Z,Tt=oe),ki.createStatusBarEntry(xe,rt,wt,Tt)},setStatusBarMessage(Z,oe){return ki.setStatusBarMessage(Z,oe)},withScmProgress(Z){return At.report("window.withScmProgress",xe,"Use 'withProgress' instead."),Di.withProgress(xe,{location:we.ProgressLocation.SourceControl},(oe,Fe)=>Z({report(rt){}}))},withProgress(Z,oe){return Di.withProgress(xe,Z,oe)},createOutputChannel(Z,oe){return pi.createOutputChannel(Z,oe,xe)},createWebviewPanel(Z,oe,Fe,rt){return Ii.createWebviewPanel(xe,Z,oe,Fe,rt)},createWebviewTextEditorInset(Z,oe,Fe,rt){return(0,Qe.checkProposedApiEnabled)(xe,"editorInsets"),lt.createWebviewEditorInset(Z,oe,Fe,rt,xe)},createTerminal(Z,oe,Fe){return typeof Z=="object"?"pty"in Z?yt.createExtensionTerminal(Z):yt.createTerminalFromOptions(Z):yt.createTerminal(Z,oe,Fe)},registerTerminalLinkProvider(Z){return yt.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,oe){return yt.registerProfileProvider(xe,Z,oe)},registerTerminalQuickFixProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"terminalQuickFixProvider"),yt.registerTerminalQuickFixProvider(Z,xe.identifier.value,oe)},registerTreeDataProvider(Z,oe){return je.registerTreeDataProvider(Z,oe,xe)},createTreeView(Z,oe){return je.createTreeView(Z,oe,xe)},registerWebviewPanelSerializer:(Z,oe)=>Ii.registerWebviewPanelSerializer(xe,Z,oe),registerCustomEditorProvider:(Z,oe,Fe={})=>xi.registerCustomEditorProvider(xe,Z,oe,Fe),registerFileDecorationProvider(Z){return Rt.registerFileDecorationProvider(Z,xe)},registerUriHandler(Z){return Ei.registerUriHandler(xe,Z)},createQuickPick(){return Si.createQuickPick(xe)},createInputBox(){return Si.createInputBox(xe)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(Z,oe,Fe){return nt(Mi.onDidChangeActiveColorTheme)(Z,oe,Fe)},registerWebviewViewProvider(Z,oe,Fe){return Ui.registerWebviewViewProvider(xe,Z,oe,Fe?.webviewOptions)},get activeNotebookEditor(){return ve.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,oe,Fe){return nt(ve.onDidChangeActiveNotebookEditor)(Z,oe,Fe)},get visibleNotebookEditors(){return ve.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(ve.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(Z,oe,Fe){return nt(se.onDidChangeNotebookEditorSelection)(Z,oe,Fe)},onDidChangeNotebookEditorVisibleRanges(Z,oe,Fe){return nt(se.onDidChangeNotebookEditorVisibleRanges)(Z,oe,Fe)},showNotebookDocument(Z,oe){return ve.showNotebookDocument(Z,oe)},registerExternalUriOpener(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"externalUriOpener"),Gi.registerExternalUriOpener(xe.identifier,Z,oe,Fe)},registerProfileContentHandler(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"profileContentHandlers"),Xi.registerProfileContentHandler(xe,Z,oe)},registerQuickDiffProvider(Z,oe,Fe,rt){return(0,Qe.checkProposedApiEnabled)(xe,"quickDiffProvider"),qi.registerQuickDiffProvider(bt(Z),oe,Fe,rt)},get tabGroups(){return Vt.tabGroups},registerShareProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"shareProvider"),Li.registerShareProvider(bt(Z),oe)}},Hi={get rootPath(){return At.report("workspace.rootPath",xe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(Z){throw new L.ReadonlyError("rootPath")},getWorkspaceFolder(Z){return ft.getWorkspaceFolder(Z)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(Z){throw new L.ReadonlyError("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(Z){throw new L.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(Z,oe,...Fe)=>ft.updateWorkspaceFolders(xe,Z,oe||0,...Fe),onDidChangeWorkspaceFolders:function(Z,oe,Fe){return nt(ft.onDidChangeWorkspace)(Z,oe,Fe)},asRelativePath:(Z,oe)=>ft.getRelativePath(Z,oe),findFiles:(Z,oe,Fe,rt)=>ft.findFiles(Z,oe,Fe,xe.identifier,rt),findFiles2:(Z,oe,Fe)=>((0,Qe.checkProposedApiEnabled)(xe,"findFiles2"),ft.findFiles2(Z,oe,xe.identifier,Fe)),findTextInFiles:(Z,oe,Fe,rt)=>{(0,Qe.checkProposedApiEnabled)(xe,"findTextInFiles");let wt,Tt;return typeof oe=="object"?(wt=oe,Tt=Fe):(wt={},Tt=oe,rt=Fe),ft.findTextInFiles(Z,wt||{},Tt,xe.identifier,rt)},save:Z=>ft.save(Z),saveAs:Z=>ft.saveAs(Z),saveAll:Z=>ft.saveAll(Z),applyEdit(Z,oe){return gn.applyWorkspaceEdit(Z,xe,oe)},createFileSystemWatcher:(Z,oe,Fe,rt)=>{let wt;return typeof oe=="boolean"?wt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!rt,correlate:!1}:oe&&((0,Qe.checkProposedApiEnabled)(xe,"createFileSystemWatcher"),wt={...oe,correlate:!0}),Ut.createFileSystemWatcher(ft,xe,Z,wt)},get textDocuments(){return Dt.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw new L.ReadonlyError("textDocuments")},openTextDocument(Z){let oe;const Fe=Z;if(typeof Z=="string")oe=Promise.resolve(v.URI.file(Z));else if(v.URI.isUri(Z))oe=Promise.resolve(Z);else if(!Fe||typeof Fe=="object")oe=Dt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(rt=>(rt.scheme===A.Schemas.vscodeRemote&&!rt.authority&&At.report("workspace.openTextDocument",xe,"A URI of 'vscode-remote' scheme requires an authority."),Dt.ensureDocumentData(rt).then(wt=>wt.document)))},onDidOpenTextDocument:(Z,oe,Fe)=>nt(Dt.onDidAddDocument)(Z,oe,Fe),onDidCloseTextDocument:(Z,oe,Fe)=>nt(Dt.onDidRemoveDocument)(Z,oe,Fe),onDidChangeTextDocument:(Z,oe,Fe)=>nt(Dt.onDidChangeDocument)(Z,oe,Fe),onDidSaveTextDocument:(Z,oe,Fe)=>nt(Dt.onDidSaveDocument)(Z,oe,Fe),onWillSaveTextDocument:(Z,oe,Fe)=>nt(si.getOnWillSaveTextDocumentEvent(xe))(Z,oe,Fe),get notebookDocuments(){return ve.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,oe){let Fe;if(v.URI.isUri(Z))Fe=Z,await ve.openNotebookDocument(Z);else if(typeof Z=="string")Fe=v.URI.revive(await ve.createNotebookDocument({viewType:Z,content:oe}));else throw new Error("Invalid arguments");return ve.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(Z,oe,Fe){return nt(Ae.onDidSaveNotebookDocument)(Z,oe,Fe)},onDidChangeNotebookDocument(Z,oe,Fe){return nt(Ae.onDidChangeNotebookDocument)(Z,oe,Fe)},onWillSaveNotebookDocument(Z,oe,Fe){return nt($e.getOnWillSaveNotebookDocumentEvent(xe))(Z,oe,Fe)},get onDidOpenNotebookDocument(){return nt(ve.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(ve.onDidCloseNotebookDocument)},registerNotebookSerializer(Z,oe,Fe,rt){return ve.registerNotebookSerializer(xe,Z,oe,Fe,(0,Qe.isProposedApiEnabled)(xe,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(Z,oe,Fe)=>nt($i.onDidChangeConfiguration)(Z,oe,Fe),getConfiguration(Z,oe){return oe=arguments.length===1?void 0:oe,$i.getConfiguration(Z,oe,xe)},registerTextDocumentContentProvider(Z,oe){return wi.registerTextDocumentContentProvider(Z,oe)},registerTaskProvider:(Z,oe)=>(At.report("window.registerTaskProvider",xe,"Use the corresponding function on the 'tasks' namespace instead"),ri.registerTaskProvider(xe,Z,oe)),registerFileSystemProvider(Z,oe,Fe){return(0,O.combinedDisposable)(Nt.registerFileSystemProvider(xe,Z,oe,Fe),qt.addFileSystemProvider(Z,oe,Fe))},get fs(){return qt.value},registerFileSearchProvider:(Z,oe)=>((0,Qe.checkProposedApiEnabled)(xe,"fileSearchProvider"),fi.registerFileSearchProvider(Z,oe)),registerTextSearchProvider:(Z,oe)=>((0,Qe.checkProposedApiEnabled)(xe,"textSearchProvider"),fi.registerTextSearchProvider(Z,oe)),registerAITextSearchProvider:(Z,oe)=>((0,Qe.checkProposedApiEnabled)(xe,"aiTextSearchProvider"),(0,Qe.checkProposedApiEnabled)(xe,"textSearchProvider"),fi.registerAITextSearchProvider(Z,oe)),registerRemoteAuthorityResolver:(Z,oe)=>((0,Qe.checkProposedApiEnabled)(xe,"resolvers"),Mt.registerRemoteAuthorityResolver(Z,oe)),registerResourceLabelFormatter:Z=>((0,Qe.checkProposedApiEnabled)(xe,"resolvers"),Ni.$registerResourceLabelFormatter(Z)),getRemoteExecServer:Z=>((0,Qe.checkProposedApiEnabled)(xe,"resolvers"),Mt.getRemoteExecServer(Z)),onDidCreateFiles:(Z,oe,Fe)=>nt(Ut.onDidCreateFile)(Z,oe,Fe),onDidDeleteFiles:(Z,oe,Fe)=>nt(Ut.onDidDeleteFile)(Z,oe,Fe),onDidRenameFiles:(Z,oe,Fe)=>nt(Ut.onDidRenameFile)(Z,oe,Fe),onWillCreateFiles:(Z,oe,Fe)=>nt(Ut.getOnWillCreateFileEvent(xe))(Z,oe,Fe),onWillDeleteFiles:(Z,oe,Fe)=>nt(Ut.getOnWillDeleteFileEvent(xe))(Z,oe,Fe),onWillRenameFiles:(Z,oe,Fe)=>nt(Ut.getOnWillRenameFileEvent(xe))(Z,oe,Fe),openTunnel:Z=>((0,Qe.checkProposedApiEnabled)(xe,"tunnels"),Ft.openTunnel(xe,Z).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Qe.checkProposedApiEnabled)(xe,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(Z,oe,Fe)=>((0,Qe.checkProposedApiEnabled)(xe,"tunnels"),nt(Ft.onDidChangeTunnels)(Z,oe,Fe)),registerPortAttributesProvider:(Z,oe)=>((0,Qe.checkProposedApiEnabled)(xe,"portsAttributes"),Ft.registerPortsAttributesProvider(Z,oe)),registerTunnelProvider:(Z,oe)=>((0,Qe.checkProposedApiEnabled)(xe,"tunnelFactory"),Ft.registerTunnelProvider(Z,oe)),registerTimelineProvider:(Z,oe)=>((0,Qe.checkProposedApiEnabled)(xe,"timeline"),Ki.registerTimelineProvider(Z,oe,xe.identifier,mt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:Z=>((0,Qe.checkProposedApiEnabled)(xe,"workspaceTrust"),ft.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,oe,Fe)=>nt(ft.onDidGrantWorkspaceTrust)(Z,oe,Fe),registerEditSessionIdentityProvider:(Z,oe)=>((0,Qe.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(Z,oe)),onWillCreateEditSessionIdentity:(Z,oe,Fe)=>((0,Qe.checkProposedApiEnabled)(xe,"editSessionIdentityProvider"),nt(ft.getOnWillCreateEditSessionIdentityEvent(xe))(Z,oe,Fe)),registerCanonicalUriProvider:(Z,oe)=>((0,Qe.checkProposedApiEnabled)(xe,"canonicalUriProvider"),ft.registerCanonicalUriProvider(Z,oe)),getCanonicalUri:(Z,oe,Fe)=>((0,Qe.checkProposedApiEnabled)(xe,"canonicalUriProvider"),ft.provideCanonicalUri(Z,oe,Fe))},rn={get inputBox(){return At.report("scm.inputBox",xe,"Use 'SourceControl.inputBox' instead"),Ci.getLastInputBox(xe)},createSourceControl(Z,oe,Fe){return Ci.createSourceControl(xe,Z,oe,Fe)}},pn={createCommentController(Z,oe){return Oi.createCommentController(xe,Z,oe)}},sn={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get activeStackItem(){if((0,Qe.isProposedApiEnabled)(xe,"debugFocus"))return Ct.activeStackItem},registerDebugVisualizationProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"debugVisualization"),Ct.registerDebugVisualizationProvider(xe,Z,oe)},registerDebugVisualizationTreeProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"debugVisualization"),Ct.registerDebugVisualizationTree(xe,Z,oe)},onDidStartDebugSession(Z,oe,Fe){return nt(Ct.onDidStartDebugSession)(Z,oe,Fe)},onDidTerminateDebugSession(Z,oe,Fe){return nt(Ct.onDidTerminateDebugSession)(Z,oe,Fe)},onDidChangeActiveDebugSession(Z,oe,Fe){return nt(Ct.onDidChangeActiveDebugSession)(Z,oe,Fe)},onDidReceiveDebugSessionCustomEvent(Z,oe,Fe){return nt(Ct.onDidReceiveDebugSessionCustomEvent)(Z,oe,Fe)},onDidChangeBreakpoints(Z,oe,Fe){return nt(Ct.onDidChangeBreakpoints)(Z,oe,Fe)},onDidChangeActiveStackItem(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"debugFocus"),nt(Ct.onDidChangeActiveStackItem)(Z,oe,Fe)},registerDebugConfigurationProvider(Z,oe,Fe){return Ct.registerDebugConfigurationProvider(Z,oe,Fe||Qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,oe){return Ct.registerDebugAdapterDescriptorFactory(xe,Z,oe)},registerDebugAdapterTrackerFactory(Z,oe){return Ct.registerDebugAdapterTrackerFactory(Z,oe)},startDebugging(Z,oe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?Ct.startDebugging(Z,oe,{parentSession:Fe}):Ct.startDebugging(Z,oe,Fe||{})},stopDebugging(Z){return Ct.stopDebugging(Z)},addBreakpoints(Z){return Ct.addBreakpoints(Z)},removeBreakpoints(Z){return Ct.removeBreakpoints(Z)},asDebugSourceUri(Z,oe){return Ct.asDebugSourceUri(Z,oe)}},on={registerTaskProvider:(Z,oe)=>ri.registerTaskProvider(xe,Z,oe),fetchTasks:Z=>ri.fetchTasks(Z),executeTask:Z=>ri.executeTask(xe,Z),get taskExecutions(){return ri.taskExecutions},onDidStartTask:(Z,oe,Fe)=>nt(ri.onDidStartTask)(Z,oe,Fe),onDidEndTask:(Z,oe,Fe)=>nt(ri.onDidEndTask)(Z,oe,Fe),onDidStartTaskProcess:(Z,oe,Fe)=>nt(ri.onDidStartTaskProcess)(Z,oe,Fe),onDidEndTaskProcess:(Z,oe,Fe)=>nt(ri.onDidEndTaskProcess)(Z,oe,Fe)},vn={createNotebookController(Z,oe,Fe,rt,wt){return K.createNotebookController(xe,Z,oe,Fe,rt,(0,Qe.isProposedApiEnabled)(xe,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(Z,oe)=>ve.registerNotebookCellStatusBarItemProvider(xe,Z,oe),createRendererMessaging(Z){return Ce.createRendererMessaging(xe,Z)},createNotebookControllerDetectionTask(Z){return(0,Qe.checkProposedApiEnabled)(xe,"notebookKernelSource"),K.createNotebookControllerDetectionTask(xe,Z)},registerKernelSourceActionProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"notebookKernelSource"),K.registerKernelSourceActionProvider(xe,Z,oe)},onDidChangeNotebookCellExecutionState(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"notebookCellExecutionState"),nt(K.onDidChangeNotebookCellExecutionState)(Z,oe,Fe)}},En={t(...Z){if(typeof Z[0]=="string"){const oe=Z.shift(),Fe=!Z||typeof Z[0]!="object"?Z:Z[0];return ui.getMessage(xe.identifier.value,{message:oe,args:Fe})}return ui.getMessage(xe.identifier.value,Z[0])},get bundle(){return ui.getBundle(xe.identifier.value)},get uri(){return ui.getBundleUri(xe.identifier.value)}},an={_version:1,registerInteractiveEditorSessionProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"interactive"),Qi.registerProvider(xe,Z,oe)},transferActiveChat(Z){return(0,Qe.checkProposedApiEnabled)(xe,"interactive"),Pi.transferActiveChat(Z)}},Vi={getRelatedInformation(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"aiRelatedInformation"),Ji.getRelatedInformation(xe,Z,oe)},registerRelatedInformationProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"aiRelatedInformation"),Ji.registerRelatedInformationProvider(xe,Z,oe)},registerEmbeddingVectorProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"aiRelatedInformation"),hn.registerEmbeddingVectorProvider(xe,Z,oe)}},cn={registerChatResponseProvider(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"chatProvider"),Ot.registerLanguageModel(xe,Z,oe,Fe)},registerChatVariableResolver(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"chatVariableResolver"),Yi.registerVariableResolver(xe,Z,oe,Fe)},registerMappedEditsProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"mappedEditsProvider"),ct.registerMappedEditsProvider(xe,Z,oe)},createChatParticipant(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"chatParticipant"),Pi.createChatAgent(xe,Z,oe)},createDynamicChatParticipant(Z,oe,Fe,rt){return(0,Qe.checkProposedApiEnabled)(xe,"chatParticipantAdditions"),Pi.createDynamicChatAgent(xe,Z,oe,Fe,rt)}},ln={get languageModels(){return(0,Qe.checkProposedApiEnabled)(xe,"languageModels"),Ot.getLanguageModelIds()},onDidChangeLanguageModels:(Z,oe,Fe)=>((0,Qe.checkProposedApiEnabled)(xe,"languageModels"),Ot.onDidChangeProviders(Z,oe,Fe)),sendChatRequest(Z,oe,Fe,rt){return(0,Qe.checkProposedApiEnabled)(xe,"languageModels"),Ot.sendChatRequest(xe,Z,oe,Fe,rt)},computeTokenLength(Z,oe,Fe){return(0,Qe.checkProposedApiEnabled)(xe,"languageModels"),Fe??=I.CancellationToken.None,Ot.computeTokenLength(Z,oe,Fe)},getLanguageModelInformation(Z){return(0,Qe.checkProposedApiEnabled)(xe,"languageModels"),Ot.getLanguageModelInfo(Z)}},un={registerSpeechProvider(Z,oe){return(0,Qe.checkProposedApiEnabled)(xe,"speech"),zi.registerProvider(xe.identifier,Z,oe)}};return{version:pt.version,ai:Vi,authentication:en,commands:gi,comments:pn,chat:cn,debug:sn,env:_i,extensions:Ai,interactive:an,l10n:En,languages:tn,lm:ln,notebooks:vn,scm:rn,speech:un,tasks:on,tests:mn,window:nn,workspace:Hi,Breakpoint:we.Breakpoint,TerminalOutputAnchor:we.TerminalOutputAnchor,ChatResultFeedbackKind:we.ChatResultFeedbackKind,ChatVariableLevel:we.ChatVariableLevel,ChatCompletionItem:we.ChatCompletionItem,CallHierarchyIncomingCall:we.CallHierarchyIncomingCall,CallHierarchyItem:we.CallHierarchyItem,CallHierarchyOutgoingCall:we.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:we.CodeAction,CodeActionKind:we.CodeActionKind,CodeActionTriggerKind:we.CodeActionTriggerKind,CodeLens:we.CodeLens,Color:we.Color,ColorInformation:we.ColorInformation,ColorPresentation:we.ColorPresentation,ColorThemeKind:we.ColorThemeKind,CommentMode:we.CommentMode,CommentState:we.CommentState,CommentThreadCollapsibleState:we.CommentThreadCollapsibleState,CommentThreadState:we.CommentThreadState,CommentThreadApplicability:we.CommentThreadApplicability,CompletionItem:we.CompletionItem,CompletionItemKind:we.CompletionItemKind,CompletionItemTag:we.CompletionItemTag,CompletionList:we.CompletionList,CompletionTriggerKind:we.CompletionTriggerKind,ConfigurationTarget:we.ConfigurationTarget,CustomExecution:we.CustomExecution,DebugAdapterExecutable:we.DebugAdapterExecutable,DebugAdapterInlineImplementation:we.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:we.DebugAdapterNamedPipeServer,DebugAdapterServer:we.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:we.DebugConsoleMode,DebugVisualization:we.DebugVisualization,DecorationRangeBehavior:we.DecorationRangeBehavior,Diagnostic:we.Diagnostic,DiagnosticRelatedInformation:we.DiagnosticRelatedInformation,DiagnosticSeverity:we.DiagnosticSeverity,DiagnosticTag:we.DiagnosticTag,Disposable:we.Disposable,DocumentHighlight:we.DocumentHighlight,DocumentHighlightKind:we.DocumentHighlightKind,MultiDocumentHighlight:we.MultiDocumentHighlight,DocumentLink:we.DocumentLink,DocumentSymbol:we.DocumentSymbol,EndOfLine:we.EndOfLine,EnvironmentVariableMutatorType:we.EnvironmentVariableMutatorType,EvaluatableExpression:we.EvaluatableExpression,InlineValueText:we.InlineValueText,InlineValueVariableLookup:we.InlineValueVariableLookup,InlineValueEvaluatableExpression:we.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:we.InlineCompletionTriggerKind,EventEmitter:T.Emitter,ExtensionKind:we.ExtensionKind,ExtensionMode:we.ExtensionMode,ExternalUriOpenerPriority:we.ExternalUriOpenerPriority,FileChangeType:we.FileChangeType,FileDecoration:we.FileDecoration,FileDecoration2:we.FileDecoration,FileSystemError:we.FileSystemError,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:we.FoldingRange,FoldingRangeKind:we.FoldingRangeKind,FunctionBreakpoint:we.FunctionBreakpoint,InlineCompletionItem:we.InlineSuggestion,InlineCompletionList:we.InlineSuggestionList,Hover:we.Hover,VerboseHover:we.VerboseHover,HoverVerbosityAction:we.HoverVerbosityAction,IndentAction:y.IndentAction,Location:we.Location,MarkdownString:we.MarkdownString,OverviewRulerLane:h.OverviewRulerLane,ParameterInformation:we.ParameterInformation,PortAutoForwardAction:we.PortAutoForwardAction,Position:we.Position,ProcessExecution:we.ProcessExecution,ProgressLocation:we.ProgressLocation,QuickInputButtons:we.QuickInputButtons,Range:we.Range,RelativePattern:we.RelativePattern,Selection:we.Selection,SelectionRange:we.SelectionRange,SemanticTokens:we.SemanticTokens,SemanticTokensBuilder:we.SemanticTokensBuilder,SemanticTokensEdit:we.SemanticTokensEdit,SemanticTokensEdits:we.SemanticTokensEdits,SemanticTokensLegend:we.SemanticTokensLegend,ShellExecution:we.ShellExecution,ShellQuoting:we.ShellQuoting,SignatureHelp:we.SignatureHelp,SignatureHelpTriggerKind:we.SignatureHelpTriggerKind,SignatureInformation:we.SignatureInformation,SnippetString:we.SnippetString,SourceBreakpoint:we.SourceBreakpoint,StandardTokenType:we.StandardTokenType,StatusBarAlignment:we.StatusBarAlignment,SymbolInformation:we.SymbolInformation,SymbolKind:we.SymbolKind,SymbolTag:we.SymbolTag,Task:we.Task,TaskGroup:we.TaskGroup,TaskPanelKind:we.TaskPanelKind,TaskRevealKind:we.TaskRevealKind,TaskScope:we.TaskScope,TerminalLink:we.TerminalLink,TerminalQuickFixTerminalCommand:we.TerminalQuickFixCommand,TerminalQuickFixOpener:we.TerminalQuickFixOpener,TerminalLocation:we.TerminalLocation,TerminalProfile:we.TerminalProfile,TerminalExitReason:we.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:we.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:we.TextDocumentSaveReason,TextEdit:we.TextEdit,SnippetTextEdit:we.SnippetTextEdit,TextEditorCursorStyle:_.TextEditorCursorStyle,TextEditorLineNumbersStyle:we.TextEditorLineNumbersStyle,TextEditorRevealType:we.TextEditorRevealType,TextEditorSelectionChangeKind:we.TextEditorSelectionChangeKind,SyntaxTokenType:we.SyntaxTokenType,TextDocumentChangeReason:we.TextDocumentChangeReason,ThemeColor:we.ThemeColor,ThemeIcon:we.ThemeIcon,TreeItem:we.TreeItem,TreeItemCheckboxState:we.TreeItemCheckboxState,TreeItemCollapsibleState:we.TreeItemCollapsibleState,TypeHierarchyItem:we.TypeHierarchyItem,UIKind:Yt.UIKind,Uri:v.URI,ViewColumn:we.ViewColumn,WorkspaceEdit:we.WorkspaceEdit,DocumentPasteTriggerKind:we.DocumentPasteTriggerKind,DocumentDropEdit:we.DocumentDropEdit,DocumentDropOrPasteEditKind:we.DocumentDropOrPasteEditKind,DocumentPasteEdit:we.DocumentPasteEdit,InlayHint:we.InlayHint,InlayHintLabelPart:we.InlayHintLabelPart,InlayHintKind:we.InlayHintKind,RemoteAuthorityResolverError:we.RemoteAuthorityResolverError,ResolvedAuthority:we.ResolvedAuthority,ManagedResolvedAuthority:we.ManagedResolvedAuthority,SourceControlInputBoxValidationType:we.SourceControlInputBoxValidationType,ExtensionRuntime:we.ExtensionRuntime,TimelineItem:we.TimelineItem,NotebookRange:we.NotebookRange,NotebookCellKind:we.NotebookCellKind,NotebookCellExecutionState:we.NotebookCellExecutionState,NotebookCellData:we.NotebookCellData,NotebookData:we.NotebookData,NotebookRendererScript:we.NotebookRendererScript,NotebookCellStatusBarAlignment:we.NotebookCellStatusBarAlignment,NotebookEditorRevealType:we.NotebookEditorRevealType,NotebookCellOutput:we.NotebookCellOutput,NotebookCellOutputItem:we.NotebookCellOutputItem,NotebookCellStatusBarItem:we.NotebookCellStatusBarItem,NotebookControllerAffinity:we.NotebookControllerAffinity,NotebookControllerAffinity2:we.NotebookControllerAffinity2,NotebookEdit:we.NotebookEdit,NotebookKernelSourceAction:we.NotebookKernelSourceAction,NotebookVariablesRequestKind:we.NotebookVariablesRequestKind,PortAttributes:we.PortAttributes,LinkedEditingRanges:we.LinkedEditingRanges,TestResultState:we.TestResultState,TestRunRequest:we.TestRunRequest,TestRunRequest2:we.TestRunRequest,TestMessage:we.TestMessage,TestTag:we.TestTag,TestRunProfileKind:we.TestRunProfileKind,TextSearchCompleteMessageType:oi.TextSearchCompleteMessageType,DataTransfer:we.DataTransfer,DataTransferItem:we.DataTransferItem,TestCoverageCount:we.TestCoverageCount,FileCoverage:we.FileCoverage,StatementCoverage:we.StatementCoverage,BranchCoverage:we.BranchCoverage,DeclarationCoverage:we.DeclarationCoverage,WorkspaceTrustState:we.WorkspaceTrustState,LanguageStatusSeverity:we.LanguageStatusSeverity,QuickPickItemKind:we.QuickPickItemKind,InputBoxValidationSeverity:we.InputBoxValidationSeverity,TabInputText:we.TextTabInput,TabInputTextDiff:we.TextDiffTabInput,TabInputTextMerge:we.TextMergeTabInput,TabInputCustom:we.CustomEditorTabInput,TabInputNotebook:we.NotebookEditorTabInput,TabInputNotebookDiff:we.NotebookDiffEditorTabInput,TabInputWebview:we.WebviewEditorTabInput,TabInputTerminal:we.TerminalEditorTabInput,TabInputInteractiveWindow:we.InteractiveWindowInput,TabInputChat:we.ChatEditorTabInput,TabInputTextMultiDiff:we.TextMultiDiffTabInput,TelemetryTrustedValue:s.TelemetryTrustedValue,LogLevel:r.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:we.InteractiveSessionVoteDirection,ChatCopyKind:we.ChatCopyKind,InteractiveEditorResponseFeedbackKind:we.InteractiveEditorResponseFeedbackKind,DebugStackFrame:we.DebugStackFrame,DebugThread:we.DebugThread,RelatedInformationType:we.RelatedInformationType,SpeechToTextStatus:we.SpeechToTextStatus,PartialAcceptTriggerKind:we.PartialAcceptTriggerKind,KeywordRecognitionStatus:we.KeywordRecognitionStatus,ChatResponseMarkdownPart:we.ChatResponseMarkdownPart,ChatResponseFileTreePart:we.ChatResponseFileTreePart,ChatResponseAnchorPart:we.ChatResponseAnchorPart,ChatResponseProgressPart:we.ChatResponseProgressPart,ChatResponseReferencePart:we.ChatResponseReferencePart,ChatResponseTextEditPart:we.ChatResponseTextEditPart,ChatResponseMarkdownWithVulnerabilitiesPart:we.ChatResponseMarkdownWithVulnerabilitiesPart,ChatResponseCommandButtonPart:we.ChatResponseCommandButtonPart,ChatResponseDetectedParticipantPart:we.ChatResponseDetectedParticipantPart,ChatRequestTurn:we.ChatRequestTurn,ChatResponseTurn:we.ChatResponseTurn,ChatLocation:we.ChatLocation,LanguageModelChatSystemMessage:we.LanguageModelChatSystemMessage,LanguageModelChatUserMessage:we.LanguageModelChatUserMessage,LanguageModelChatAssistantMessage:we.LanguageModelChatAssistantMessage,LanguageModelSystemMessage:we.LanguageModelChatSystemMessage,LanguageModelUserMessage:we.LanguageModelChatUserMessage,LanguageModelAssistantMessage:we.LanguageModelChatAssistantMessage,LanguageModelError:we.LanguageModelError,NewSymbolName:we.NewSymbolName,NewSymbolNameTag:we.NewSymbolNameTag,NewSymbolNameTriggerKind:we.NewSymbolNameTriggerKind,InlineEdit:we.InlineEdit,InlineEditTriggerKind:we.InlineEditTriggerKind}}}}),define(Ie[308],Pe([1,0,56,118,39,112,40,32,68,53,121,123,124,84,88,80,111,65,46,83,63,67,247,12,122,81,82,86,90,116]),function(ue,e,I,L,T,O,A,E,v,_,N,y,h,b,m,r,o,s,i,n,c,u,t,f,a,p,l,D,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.registerSingleton)(p.IExtHostLocalizationService,p.ExtHostLocalizationService,1),(0,I.registerSingleton)(f.ILoggerService,t.ExtHostLoggerService,1),(0,I.registerSingleton)(r.IExtHostApiDeprecationService,r.ExtHostApiDeprecationService,1),(0,I.registerSingleton)(E.IExtHostCommands,E.ExtHostCommands,0),(0,I.registerSingleton)(D.IExtHostAuthentication,D.ExtHostAuthentication,0),(0,I.registerSingleton)(d.IExtHostLanguageModels,d.ExtHostLanguageModels,0),(0,I.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,0),(0,I.registerSingleton)(s.IExtHostConsumerFileSystem,s.ExtHostConsumerFileSystem,0),(0,I.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService,0),(0,I.registerSingleton)(O.IExtHostDecorations,O.ExtHostDecorations,0),(0,I.registerSingleton)(v.IExtHostDocumentsAndEditors,v.ExtHostDocumentsAndEditors,0),(0,I.registerSingleton)(l.IExtHostManagedSockets,l.ExtHostManagedSockets,0),(0,I.registerSingleton)(i.IExtHostFileSystemInfo,i.ExtHostFileSystemInfo,0),(0,I.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService,1),(0,I.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch,0),(0,I.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,I.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,I.registerSingleton)(_.IExtHostTerminalService,_.WorkerExtHostTerminalService,0),(0,I.registerSingleton)(w.IExtHostTerminalShellIntegration,w.ExtHostTerminalShellIntegration,0),(0,I.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,I.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,I.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace,0),(0,I.registerSingleton)(n.IExtHostSecretState,n.ExtHostSecretState,0),(0,I.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,0),(0,I.registerSingleton)(u.IExtHostEditorTabs,u.ExtHostEditorTabs,0),(0,I.registerSingleton)(a.IExtHostVariableResolverProvider,a.ExtHostVariableResolverProviderService,0)}),define(Ie[309],Pe([1,0,307,41,2,304,7,11,253]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class _ extends O.RequireInterceptor{_installInterceptor(){}getModule(b,m){for(const r of this._alternatives){const o=r(b);if(o){b=o;break}}if(this._factories.has(b))return this._factories.get(b).load(b,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends L.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(v.ExtHostConsoleForwarder);const b=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(_,b,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(b){return b.browser}async _loadCommonJSModule(b,m,r){m=m.with({path:y(m.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=T.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(m)),i=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),c=`${m.toString(!0)}#vscode-extension`,u=`${n}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",u)}catch(l){throw console.error(o?`Loading code for extension ${o} failed: ${l.message}`:`Loading code failed: ${l.message}`),console.error(`${m.toString(!0)}${typeof l.line=="number"?` line ${l.line}`:""}${typeof l.column=="number"?` column ${l.column}`:""}`),console.error(l),l}b&&await this._extHostLocalizationService.initializeLocalizedMessages(b);const f={},a={exports:f},p=l=>{const D=this._fakeModules.getModule(l,m);if(D===void 0)throw new Error(`Cannot load module '${l}'`);return D};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(a,f,p),a.exports!==f?a.exports:f}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(b){}async _waitForDebuggerAttachment(b=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+b;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,E.timeout)(10)}}e.ExtHostExtensionService=N;function y(h,b){return h.endsWith(b)?h:h+b}}),define(Ie[310],Pe([1,0,71,56,12,41,217,87,309]),function(ue,e,I,L,T,O,A,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.registerSingleton)(T.ILogService,new I.SyncDescriptor(A.ExtHostLogService,[!0],!0)),(0,L.registerSingleton)(O.IExtHostExtensionService,v.ExtHostExtensionService,0),(0,L.registerSingleton)(E.IExtensionStoragePaths,E.ExtensionStoragePaths,0)}),define(Ie[316],Pe([1,0,21,5,79,305,255,19,60,16,2,308,310]),function(ue,e,I,L,T,O,A,E,v,_,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=u;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function r(t){self.fetch=async function(f,a){return f instanceof Request||b(String(f))&&(f=(await t(N.URI.parse(String(f)))).toString(!0)),m(f,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,a,p,l,D){(async()=>(b(a.toString())&&(a=(await t(N.URI.parse(a.toString()))).toString(!0)),super.open(f,a,p??!0,l,D)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(f,a){if(/^file:/i.test(f.toString()))f=_.FileAccess.uriToBrowserUri(N.URI.parse(f.toString())).toString(!0);else if(/^vscode-remote:/i.test(f.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const l=`(${function(g){function C(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const S=fetch.bind(self);self.fetch=function(P,H){return P instanceof Request?S(P,H):S(C(P),H)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,H,$,V,R){return super.open(P,C(H),$??!0,V,R)}};const k=importScripts.bind(self);self.importScripts=(...P)=>{k(...P.map(C))},k(g)}.toString()}('${f}'))`;a=a||{},a.name=`${name} -> ${a.name||E.basename(f.toString())}`;const D=new Blob([l],{type:"application/javascript"}),d=URL.createObjectURL(D);return new t(d,a)}}else self.Worker=class extends A.NestedWorker{constructor(t,f){super(h,t,{name:E.basename(t.toString()),...f})}};const o=new class{constructor(){this.pid=void 0}exit(t){y()}};class s{constructor(){const f=new MessageChannel,a=new L.Emitter;let p=!1;h(f.port2,[f.port2]),f.port1.onmessage=l=>{const{data:D}=l;if(!(D instanceof ArrayBuffer)){console.warn("UNKNOWN data received",D);return}const d=I.VSBuffer.wrap(new Uint8Array(D,0,D.byteLength));if((0,T.isMessageOfType)(d,2)){p=!0,n("received terminate message from renderer");return}a.fire(d)},this.protocol={onMessage:a.event,send:l=>{if(!p){const D=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);f.port1.postMessage(D,[D])}}}}}function i(t){return new Promise(f=>{const a=t.onMessage(p=>{a.dispose();const l=JSON.parse(p.toString());t.send((0,T.createMessageOfType)(0)),f({protocol:t,initData:l})});t.send((0,T.createMessageOfType)(1))})}let n=t=>y();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){v.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(f){c(f)&&i(t.protocol).then(a=>{v.mark("code/extHost/didWaitForInitData");const p=new O.ExtensionHostMain(a.protocol,a.initData,o,null,f.data);r(l=>p.asBrowserUri(l)),n=l=>p.terminate(l)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4379b66f0d4dd9881ba96fa086f387725b69a24b/core/vs/workbench/api/worker/extensionHostWorker.js.map
