/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var de=["require","exports","vs/base/common/platform","vs/base/common/errors","vs/base/common/path","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/cancellation","vs/base/common/types","vs/base/common/event","vs/base/common/buffer","vs/base/common/strings","vs/base/common/lazy","vs/base/common/objects","vs/base/common/process","vs/base/common/network","vs/base/common/async","vs/base/common/arrays","vs/base/common/functional","vs/base/common/map","vs/base/common/extpath","vs/base/common/processes","vs/base/common/resources","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uuid","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/amdX","vs/base/node/pfs","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/instantiation","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryUtils","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/nls","vs/nls!vs/workbench/contrib/debug/node/telemetryApp","fs","os","util","child_process","https","vs/workbench/contrib/debug/node/telemetryApp"],me=function(ce){for(var e=[],b=0,W=ce.length;b<W;b++)e[b]=de[ce[b]];return e};define(de[23],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class b{static get(){const T=new Map,L=new Map,z=new Map,D=new Map;function r(O,l){O.has(l.detail)||O.set(l.detail,-l.timestamp)}function y(O,l){const h=O.get(l.detail);h&&(h>=0||O.set(l.detail,h+l.timestamp))}let S=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(S=ce.getStats().slice(0).sort((O,l)=>O.timestamp-l.timestamp));for(const O of S)switch(O.type){case 10:r(T,O);break;case 11:case 12:y(T,O);break;case 21:r(L,O);break;case 22:y(L,O);break;case 33:r(z,O);break;case 34:y(z,O);break;case 31:r(D,O);break;case 32:y(D,O);break}let j=0;z.forEach(O=>j+=O);function U(O){const l=[];return O.forEach((h,P)=>l.push([P,h])),l}return{amdLoad:U(T),amdInvoke:U(L),nodeRequire:U(z),nodeEval:U(D),nodeRequireTotal:j}}static toMarkdownTable(T,L){let z="";const D=[];return T.forEach((r,y)=>{D[y]=r.length}),L.forEach(r=>{r.forEach((y,S)=>{typeof y>"u"&&(y=r[S]="-");const j=y.toString().length;D[S]=Math.max(j,D[S])})}),T.forEach((r,y)=>{z+=`| ${r+" ".repeat(D[y]-r.toString().length)} `}),z+=`|
`,T.forEach((r,y)=>{z+=`| ${"-".repeat(D[y])} `}),z+=`|
`,L.forEach(r=>{r.forEach((y,S)=>{typeof y<"u"&&(z+=`| ${y+" ".repeat(D[S]-y.toString().length)} `)}),z+=`|
`}),z}}e.LoaderStats=b}),define(de[24],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=b,e.findLastIdx=W,e.findLastMonotonous=T,e.findLastIdxMonotonous=L,e.findFirstMonotonous=z,e.findFirstIdxMonotonousOrArrLen=D,e.findFirstIdxMonotonous=r,e.findFirstMax=S,e.findLastMax=j,e.findFirstMin=U,e.findMaxIdx=O,e.mapFindFirst=l;function b(h,P){const v=W(h,P);if(v!==-1)return h[v]}function W(h,P,v=h.length-1){for(let A=v;A>=0;A--){const $=h[A];if(P($))return A}return-1}function T(h,P){const v=L(h,P);return v===-1?void 0:h[v]}function L(h,P,v=0,A=h.length){let $=v,N=A;for(;$<N;){const o=Math.floor(($+N)/2);P(h[o])?$=o+1:N=o}return $-1}function z(h,P){const v=D(h,P);return v===h.length?void 0:h[v]}function D(h,P,v=0,A=h.length){let $=v,N=A;for(;$<N;){const o=Math.floor(($+N)/2);P(h[o])?N=o:$=o+1}return $}function r(h,P,v=0,A=h.length){const $=D(h,P,v,A);return $===h.length?-1:$}class y{static{this.assertInvariants=!1}constructor(P){this._array=P,this._findLastMonotonousLastIdx=0}findLastMonotonous(P){if(y.assertInvariants){if(this._prevFindLastPredicate){for(const A of this._array)if(this._prevFindLastPredicate(A)&&!P(A))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=P}const v=L(this._array,P,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=v+1,v===-1?void 0:this._array[v]}}e.MonotonousArray=y;function S(h,P){if(h.length===0)return;let v=h[0];for(let A=1;A<h.length;A++){const $=h[A];P($,v)>0&&(v=$)}return v}function j(h,P){if(h.length===0)return;let v=h[0];for(let A=1;A<h.length;A++){const $=h[A];P($,v)>=0&&(v=$)}return v}function U(h,P){return S(h,(v,A)=>-P(v,A))}function O(h,P){if(h.length===0)return-1;let v=0;for(let A=1;A<h.length;A++){const $=h[A];P($,h[v])>0&&(v=A)}return v}function l(h,P){for(const v of h){const A=P(v);if(A!==void 0)return A}}}),define(de[25],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=b,e.diffSets=W,e.diffMaps=T,e.intersection=L;function b(z,D){const r=Object.create(null);for(const y of z){const S=D(y);let j=r[S];j||(j=r[S]=[]),j.push(y)}return r}function W(z,D){const r=[],y=[];for(const S of z)D.has(S)||r.push(S);for(const S of D)z.has(S)||y.push(S);return{removed:r,added:y}}function T(z,D){const r=[],y=[];for(const[S,j]of z)D.has(S)||r.push(j);for(const[S,j]of D)z.has(S)||y.push(j);return{removed:r,added:y}}function L(z,D){const r=new Set;for(const y of D)z.has(y)&&r.add(y);return r}}),define(de[26],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=W,e.debounce=T,e.throttle=L;function b(z){return(D,r,y)=>{let S=null,j=null;if(typeof y.value=="function"?(S="value",j=y.value):typeof y.get=="function"&&(S="get",j=y.get),!j)throw new Error("not supported");y[S]=z(j,r)}}function W(z,D,r){let y=null,S=null;if(typeof r.value=="function"?(y="value",S=r.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(y="get",S=r.get),!S)throw new Error("not supported");const j=`$memoize$${D}`;r[y]=function(...U){return this.hasOwnProperty(j)||Object.defineProperty(this,j,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,U)}),this[j]}}function T(z,D,r){return b((y,S)=>{const j=`$debounce$${S}`,U=`$debounce$result$${S}`;return function(...O){this[U]||(this[U]=r?r():void 0),clearTimeout(this[j]),D&&(this[U]=D(this[U],...O),O=[this[U]]),this[j]=setTimeout(()=>{y.apply(this,O),this[U]=r?r():void 0},z)}})}function L(z,D,r){return b((y,S)=>{const j=`$throttle$timer$${S}`,U=`$throttle$result$${S}`,O=`$throttle$lastRun$${S}`,l=`$throttle$pending$${S}`;return function(...h){if(this[U]||(this[U]=r?r():void 0),(this[O]===null||this[O]===void 0)&&(this[O]=-Number.MAX_VALUE),D&&(this[U]=D(this[U],...h)),this[l])return;const P=this[O]+z;P<=Date.now()?(this[O]=Date.now(),y.apply(this,[this[U]]),this[U]=r?r():void 0):(this[l]=!0,this[j]=setTimeout(()=>{this[l]=!1,this[O]=Date.now(),y.apply(this,[this[U]]),this[U]=r?r():void 0},P-Date.now()))}})}}),define(de[3],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=W,e.isSigPipeError=T,e.onUnexpectedError=L,e.onUnexpectedExternalError=z,e.transformErrorForSerialization=D,e.isCancellationError=y,e.canceled=j,e.illegalArgument=U,e.illegalState=O,e.getErrorMessage=h;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?$.isErrorNoTelemetry(t)?new $(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function W(o){e.errorHandler.setUnexpectedErrorHandler(o)}function T(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function L(o){y(o)||e.errorHandler.onUnexpectedError(o)}function z(o){y(o)||e.errorHandler.onUnexpectedExternalError(o)}function D(o){if(o instanceof Error){const{name:t,message:n}=o,s=o.stacktrace||o.stack;return{$isError:!0,name:t,message:n,stack:s,noTelemetry:$.isErrorNoTelemetry(o)}}return o}const r="Canceled";function y(o){return o instanceof S?!0:o instanceof Error&&o.name===r&&o.message===r}class S extends Error{constructor(){super(r),this.name=this.message}}e.CancellationError=S;function j(){const o=new Error(r);return o.name=o.message,o}function U(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function O(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class l extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=l;function h(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class P extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=P;class v extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=v;class A extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=A;class $ extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof $)return t;const n=new $;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=$;class N extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,N.prototype)}}e.BugIndicatingError=N}),define(de[17],me([0,1,3,24]),function(ce,e,b,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=T,e.tail2=L,e.equals=z,e.removeFastWithoutKeepingOrder=D,e.binarySearch=r,e.binarySearch2=y,e.quickSelect=S,e.groupBy=j,e.groupAdjacentBy=U,e.forEachAdjacent=O,e.forEachWithNeighbors=l,e.sortedDiff=h,e.delta=P,e.top=v,e.topAsync=A,e.coalesce=N,e.coalesceInPlace=o,e.move=t,e.isFalsyOrEmpty=n,e.isNonEmptyArray=s,e.distinct=a,e.uniqueFilter=g,e.firstOrDefault=p,e.lastOrDefault=u,e.commonPrefixLength=E,e.flatten=H,e.range=_,e.index=m,e.insert=f,e.remove=R,e.arrayInsert=k,e.shuffle=x,e.pushToStart=le,e.pushToEnd=ae,e.pushMany=K,e.mapArrayOrNot=J,e.asArray=te,e.getRandomElement=ne,e.insertInto=M,e.splice=w,e.compareBy=ie,e.tieBreakComparators=oe,e.reverseOrder=pe;function T(I,F=0){return I[I.length-(1+F)]}function L(I){if(I.length===0)throw new Error("Invalid tail call");return[I.slice(0,I.length-1),I[I.length-1]]}function z(I,F,d=(i,C)=>i===C){if(I===F)return!0;if(!I||!F||I.length!==F.length)return!1;for(let i=0,C=I.length;i<C;i++)if(!d(I[i],F[i]))return!1;return!0}function D(I,F){const d=I.length-1;F<d&&(I[F]=I[d]),I.pop()}function r(I,F,d){return y(I.length,i=>d(I[i],F))}function y(I,F){let d=0,i=I-1;for(;d<=i;){const C=(d+i)/2|0,V=F(C);if(V<0)d=C+1;else if(V>0)i=C-1;else return C}return-(d+1)}function S(I,F,d){if(I=I|0,I>=F.length)throw new TypeError("invalid index");const i=F[Math.floor(F.length*Math.random())],C=[],V=[],G=[];for(const Z of F){const X=d(Z,i);X<0?C.push(Z):X>0?V.push(Z):G.push(Z)}return I<C.length?S(I,C,d):I<C.length+G.length?G[0]:S(I-(C.length+G.length),V,d)}function j(I,F){const d=[];let i;for(const C of I.slice(0).sort(F))!i||F(i[0],C)!==0?(i=[C],d.push(i)):i.push(C);return d}function*U(I,F){let d,i;for(const C of I)i!==void 0&&F(i,C)?d.push(C):(d&&(yield d),d=[C]),i=C;d&&(yield d)}function O(I,F){for(let d=0;d<=I.length;d++)F(d===0?void 0:I[d-1],d===I.length?void 0:I[d])}function l(I,F){for(let d=0;d<I.length;d++)F(d===0?void 0:I[d-1],I[d],d+1===I.length?void 0:I[d+1])}function h(I,F,d){const i=[];function C(Z,X,se){if(X===0&&se.length===0)return;const re=i[i.length-1];re&&re.start+re.deleteCount===Z?(re.deleteCount+=X,re.toInsert.push(...se)):i.push({start:Z,deleteCount:X,toInsert:se})}let V=0,G=0;for(;;){if(V===I.length){C(V,0,F.slice(G));break}if(G===F.length){C(V,I.length-V,[]);break}const Z=I[V],X=F[G],se=d(Z,X);se===0?(V+=1,G+=1):se<0?(C(V,1,[]),V+=1):se>0&&(C(V,0,[X]),G+=1)}return i}function P(I,F,d){const i=h(I,F,d),C=[],V=[];for(const G of i)C.push(...I.slice(G.start,G.start+G.deleteCount)),V.push(...G.toInsert);return{removed:C,added:V}}function v(I,F,d){if(d===0)return[];const i=I.slice(0,d).sort(F);return $(I,F,i,d,I.length),i}function A(I,F,d,i,C){return d===0?Promise.resolve([]):new Promise((V,G)=>{(async()=>{const Z=I.length,X=I.slice(0,d).sort(F);for(let se=d,re=Math.min(d+i,Z);se<Z;se=re,re=Math.min(re+i,Z)){if(se>d&&await new Promise(fe=>setTimeout(fe)),C&&C.isCancellationRequested)throw new b.CancellationError;$(I,F,X,se,re)}return X})().then(V,G)})}function $(I,F,d,i,C){for(const V=d.length;i<C;i++){const G=I[i];if(F(G,d[V-1])<0){d.pop();const Z=(0,W.findFirstIdxMonotonousOrArrLen)(d,X=>F(G,X)<0);d.splice(Z,0,G)}}}function N(I){return I.filter(F=>!!F)}function o(I){let F=0;for(let d=0;d<I.length;d++)I[d]&&(I[F]=I[d],F+=1);I.length=F}function t(I,F,d){I.splice(d,0,I.splice(F,1)[0])}function n(I){return!Array.isArray(I)||I.length===0}function s(I){return Array.isArray(I)&&I.length>0}function a(I,F=d=>d){const d=new Set;return I.filter(i=>{const C=F(i);return d.has(C)?!1:(d.add(C),!0)})}function g(I){const F=new Set;return d=>{const i=I(d);return F.has(i)?!1:(F.add(i),!0)}}function p(I,F){return I.length>0?I[0]:F}function u(I,F){return I.length>0?I[I.length-1]:F}function E(I,F,d=(i,C)=>i===C){let i=0;for(let C=0,V=Math.min(I.length,F.length);C<V&&d(I[C],F[C]);C++)i++;return i}function H(I){return[].concat(...I)}function _(I,F){let d=typeof F=="number"?I:0;typeof F=="number"?d=I:(d=0,F=I);const i=[];if(d<=F)for(let C=d;C<F;C++)i.push(C);else for(let C=d;C>F;C--)i.push(C);return i}function m(I,F,d){return I.reduce((i,C)=>(i[F(C)]=d?d(C):C,i),Object.create(null))}function f(I,F){return I.push(F),()=>R(I,F)}function R(I,F){const d=I.indexOf(F);if(d>-1)return I.splice(d,1),F}function k(I,F,d){const i=I.slice(0,F),C=I.slice(F);return i.concat(d,C)}function x(I,F){let d;if(typeof F=="number"){let i=F;d=()=>{const C=Math.sin(i++)*179426549;return C-Math.floor(C)}}else d=Math.random;for(let i=I.length-1;i>0;i-=1){const C=Math.floor(d()*(i+1)),V=I[i];I[i]=I[C],I[C]=V}}function le(I,F){const d=I.indexOf(F);d>-1&&(I.splice(d,1),I.unshift(F))}function ae(I,F){const d=I.indexOf(F);d>-1&&(I.splice(d,1),I.push(F))}function K(I,F){for(const d of F)I.push(d)}function J(I,F){return Array.isArray(I)?I.map(F):F(I)}function te(I){return Array.isArray(I)?I:[I]}function ne(I){return I[Math.floor(Math.random()*I.length)]}function M(I,F,d){const i=B(I,F),C=I.length,V=d.length;I.length=C+V;for(let G=C-1;G>=i;G--)I[G+V]=I[G];for(let G=0;G<V;G++)I[G+i]=d[G]}function w(I,F,d,i){const C=B(I,F);let V=I.splice(C,d);return V===void 0&&(V=[]),M(I,C,i),V}function B(I,F){return F<0?Math.max(F+I.length,0):Math.min(F,I.length)}var Q;(function(I){function F(V){return V<0}I.isLessThan=F;function d(V){return V<=0}I.isLessThanOrEqual=d;function i(V){return V>0}I.isGreaterThan=i;function C(V){return V===0}I.isNeitherLessOrGreaterThan=C,I.greaterThan=1,I.lessThan=-1,I.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function ie(I,F){return(d,i)=>F(I(d),I(i))}function oe(...I){return(F,d)=>{for(const i of I){const C=i(F,d);if(!Q.isNeitherLessOrGreaterThan(C))return C}return Q.neitherLessOrGreaterThan}}const ge=(I,F)=>I-F;e.numberComparator=ge;const he=(I,F)=>(0,e.numberComparator)(I?1:0,F?1:0);e.booleanComparator=he;function pe(I){return(F,d)=>-I(F,d)}class ve{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let d=this.firstIdx;for(;d<this.items.length&&F(this.items[d]);)d++;const i=d===this.firstIdx?null:this.items.slice(this.firstIdx,d);return this.firstIdx=d,i}takeFromEndWhile(F){let d=this.lastIdx;for(;d>=0&&F(this.items[d]);)d--;const i=d===this.lastIdx?null:this.items.slice(d+1,this.lastIdx+1);return this.lastIdx=d,i}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const F=this.items[this.firstIdx];return this.firstIdx++,F}removeLast(){const F=this.items[this.lastIdx];return this.lastIdx--,F}takeCount(F){const d=this.items.slice(this.firstIdx,this.firstIdx+F);return this.firstIdx+=F,d}}e.ArrayQueue=ve;class ye{static{this.empty=new ye(F=>{})}constructor(F){this.iterate=F}forEach(F){this.iterate(d=>(F(d),!0))}toArray(){const F=[];return this.iterate(d=>(F.push(d),!0)),F}filter(F){return new ye(d=>this.iterate(i=>F(i)?d(i):!0))}map(F){return new ye(d=>this.iterate(i=>d(F(i))))}some(F){let d=!1;return this.iterate(i=>(d=F(i),!d)),d}findFirst(F){let d;return this.iterate(i=>F(i)?(d=i,!1):!0),d}findLast(F){let d;return this.iterate(i=>(F(i)&&(d=i),!0)),d}findLastMaxBy(F){let d,i=!0;return this.iterate(C=>((i||Q.isGreaterThan(F(C,d)))&&(i=!1,d=C),!0)),d}}e.CallbackIterable=ye;class Ce{constructor(F){this._indexMap=F}static createSortPermutation(F,d){const i=Array.from(F.keys()).sort((C,V)=>d(F[C],F[V]));return new Ce(i)}apply(F){return F.map((d,i)=>F[this._indexMap[i]])}inverse(){const F=this._indexMap.slice();for(let d=0;d<this._indexMap.length;d++)F[this._indexMap[d]]=d;return new Ce(F)}}e.Permutation=Ce}),define(de[18],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=b;function b(W,T){const L=this;let z=!1,D;return function(){if(z)return D;if(z=!0,T)try{D=W.apply(L,arguments)}finally{T()}else D=W.apply(L,arguments);return D}}}),define(de[27],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(W){function T(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}W.is=T;const L=Object.freeze([]);function z(){return L}W.empty=z;function*D(t){yield t}W.single=D;function r(t){return T(t)?t:D(t)}W.wrap=r;function y(t){return t||L}W.from=y;function*S(t){for(let n=t.length-1;n>=0;n--)yield t[n]}W.reverse=S;function j(t){return!t||t[Symbol.iterator]().next().done===!0}W.isEmpty=j;function U(t){return t[Symbol.iterator]().next().value}W.first=U;function O(t,n){for(const s of t)if(n(s))return!0;return!1}W.some=O;function l(t,n){for(const s of t)if(n(s))return s}W.find=l;function*h(t,n){for(const s of t)n(s)&&(yield s)}W.filter=h;function*P(t,n){let s=0;for(const a of t)yield n(a,s++)}W.map=P;function*v(...t){for(const n of t)yield*n}W.concat=v;function A(t,n,s){let a=s;for(const g of t)a=n(a,g);return a}W.reduce=A;function*$(t,n,s=t.length){for(n<0&&(n+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);n<s;n++)yield t[n]}W.slice=$;function N(t,n=Number.POSITIVE_INFINITY){const s=[];if(n===0)return[s,t];const a=t[Symbol.iterator]();for(let g=0;g<n;g++){const p=a.next();if(p.done)return[s,W.empty()];s.push(p.value)}return[s,{[Symbol.iterator](){return a}}]}W.consume=N;async function o(t){const n=[];for await(const s of t)n.push(s);return Promise.resolve(n)}W.asyncToArray=o})(b||(e.Iterable=b={}))}),define(de[12],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(T){this.executor=T,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=b}),define(de[28],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{static{this.Undefined=new b(void 0)}constructor(L){this.element=L,this.next=b.Undefined,this.prev=b.Undefined}}class W{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let L=this._first;for(;L!==b.Undefined;){const z=L.next;L.prev=b.Undefined,L.next=b.Undefined,L=z}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,z){const D=new b(L);if(this._first===b.Undefined)this._first=D,this._last=D;else if(z){const y=this._last;this._last=D,D.prev=y,y.next=D}else{const y=this._first;this._first=D,D.next=y,y.prev=D}this._size+=1;let r=!1;return()=>{r||(r=!0,this._remove(D))}}shift(){if(this._first!==b.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==b.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==b.Undefined&&L.next!==b.Undefined){const z=L.prev;z.next=L.next,L.next.prev=z}else L.prev===b.Undefined&&L.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):L.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):L.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==b.Undefined;)yield L.element,L=L.next}}e.LinkedList=W}),define(de[19],me([0,1]),function(ce,e){"use strict";var b,W,T;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=L,e.mapToString=z,e.setToString=D,e.mapsStrictEqualIgnoreOrder=N;function L(o,t,n){let s=o.get(t);return s===void 0&&(s=n,o.set(t,s)),s}function z(o){const t=[];return o.forEach((n,s)=>{t.push(`${s} => ${n}`)}),`Map(${o.size}) {${t.join(", ")}}`}function D(o){const t=[];return o.forEach(n=>{t.push(n)}),`Set(${o.size}) {${t.join(", ")}}`}class r{constructor(t,n){this.uri=t,this.value=n}}function y(o){return Array.isArray(o)}class S{static{this.defaultToKey=t=>t.toString()}constructor(t,n){if(this[b]="ResourceMap",t instanceof S)this.map=new Map(t.map),this.toKey=n??S.defaultToKey;else if(y(t)){this.map=new Map,this.toKey=n??S.defaultToKey;for(const[s,a]of t)this.set(s,a)}else this.map=new Map,this.toKey=t??S.defaultToKey}set(t,n){return this.map.set(this.toKey(t),new r(t,n)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,n){typeof n<"u"&&(t=t.bind(n));for(const[s,a]of this.map)t(a.value,a.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=S;class j{constructor(t,n){this[W]="ResourceSet",!t||typeof t=="function"?this._map=new S(t):(this._map=new S(n),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,n){this._map.forEach((s,a)=>t.call(n,a,a,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(W=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=j;var U;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(U||(e.Touch=U={}));class O{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,n=0){const s=this._map.get(t);if(s)return n!==0&&this.touch(s,n),s.value}set(t,n,s=0){let a=this._map.get(t);if(a)a.value=n,s!==0&&this.touch(a,s);else{switch(a={key:t,value:n,next:void 0,previous:void 0},s){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(t,a),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const n=this._map.get(t);if(n)return this._map.delete(t),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,n){const s=this._state;let a=this._head;for(;a;){if(n?t.bind(n)(a.value,a.key,this):t(a.value,a.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,n=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const g={value:s.key,done:!1};return s=s.next,g}else return{value:void 0,done:!0}}};return a}values(){const t=this,n=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const g={value:s.value,done:!1};return s=s.next,g}else return{value:void 0,done:!0}}};return a}entries(){const t=this,n=this._state;let s=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const g={value:[s.key,s.value],done:!1};return s=s.next,g}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let n=this._head,s=this.size;for(;n&&s>t;)this._map.delete(n.key),n=n.next,s--;this._head=n,this._size=s,n&&(n.previous=void 0),this._state++}trimNew(t){if(t>=this.size)return;if(t===0){this.clear();return}let n=this._tail,s=this.size;for(;n&&s>t;)this._map.delete(n.key),n=n.previous,s--;this._tail=n,this._size=s,n&&(n.next=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const n=t.next,s=t.previous;if(!n||!s)throw new Error("Invalid list");n.previous=s,s.next=n}t.next=void 0,t.previous=void 0,this._state++}touch(t,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(t===this._head)return;const s=t.next,a=t.previous;t===this._tail?(a.next=void 0,this._tail=a):(s.previous=a,a.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(n===2){if(t===this._tail)return;const s=t.next,a=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=a,a.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((n,s)=>{t.push([s,n])}),t}fromJSON(t){this.clear();for(const[n,s]of t)this.set(n,s)}}e.LinkedMap=O;class l extends O{constructor(t,n=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,n=2){return super.get(t,n)}peek(t){return super.get(t,0)}set(t,n){return super.set(t,n,2),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class h extends l{constructor(t,n=1){super(t,n)}trim(t){this.trimOld(t)}set(t,n){return super.set(t,n),this.checkTrim(),this}}e.LRUCache=h;class P extends l{constructor(t,n=1){super(t,n)}trim(t){this.trimNew(t)}set(t,n){return this._limit<=this.size&&!this.has(t)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(t,n),this}}e.MRUCache=P;class v{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let n=this.map.get(t)||0;return n===0?!1:(n--,n===0?this.map.delete(t):this.map.set(t,n),!0)}has(t){return this.map.has(t)}}e.CounterSet=v;class A{constructor(t){if(this._m1=new Map,this._m2=new Map,t)for(const[n,s]of t)this.set(n,s)}clear(){this._m1.clear(),this._m2.clear()}set(t,n){this._m1.set(t,n),this._m2.set(n,t)}get(t){return this._m1.get(t)}getKey(t){return this._m2.get(t)}delete(t){const n=this._m1.get(t);return n===void 0?!1:(this._m1.delete(t),this._m2.delete(n),!0)}forEach(t,n){this._m1.forEach((s,a)=>{t.call(n,s,a,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=A;class ${constructor(){this.map=new Map}add(t,n){let s=this.map.get(t);s||(s=new Set,this.map.set(t,s)),s.add(n)}delete(t,n){const s=this.map.get(t);s&&(s.delete(n),s.size===0&&this.map.delete(t))}forEach(t,n){const s=this.map.get(t);s&&s.forEach(n)}get(t){const n=this.map.get(t);return n||new Set}}e.SetMap=$;function N(o,t){if(o===t)return!0;if(o.size!==t.size)return!1;for(const[n,s]of o)if(!t.has(n)||t.get(n)!==s)return!1;for(const[n]of t)if(!o.has(n))return!1;return!0}}),define(de[6],me([0,1,17,25,19,18,27]),function(ce,e,b,W,T,L,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=S,e.trackDisposable=j,e.markAsDisposed=U,e.markAsSingleton=h,e.isDisposable=P,e.dispose=v,e.disposeIfDisposable=A,e.combinedDisposable=$,e.toDisposable=N,e.disposeOnReturn=H;const D=!1;let r=null;class y{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(f){let R=this.livingDisposables.get(f);return R||(R={parent:null,source:null,isSingleton:!1,value:f,idx:y.idx++},this.livingDisposables.set(f,R)),R}trackDisposable(f){const R=this.getDisposableData(f);R.source||(R.source=new Error().stack)}setParent(f,R){const k=this.getDisposableData(f);k.parent=R}markAsDisposed(f){this.livingDisposables.delete(f)}markAsSingleton(f){this.getDisposableData(f).isSingleton=!0}getRootParent(f,R){const k=R.get(f);if(k)return k;const x=f.parent?this.getRootParent(this.getDisposableData(f.parent),R):f;return R.set(f,x),x}getTrackedDisposables(){const f=new Map;return[...this.livingDisposables.entries()].filter(([,k])=>k.source!==null&&!this.getRootParent(k,f).isSingleton).flatMap(([k])=>k)}computeLeakingDisposables(f=10,R){let k;if(R)k=R;else{const J=new Map,te=[...this.livingDisposables.values()].filter(M=>M.source!==null&&!this.getRootParent(M,J).isSingleton);if(te.length===0)return;const ne=new Set(te.map(M=>M.value));if(k=te.filter(M=>!(M.parent&&ne.has(M.parent))),k.length===0)throw new Error("There are cyclic diposable chains!")}if(!k)return;function x(J){function te(M,w){for(;M.length>0&&w.some(B=>typeof B=="string"?B===M[0]:M[0].match(B));)M.shift()}const ne=J.source.split(`
`).map(M=>M.trim().replace("at ","")).filter(M=>M!=="");return te(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const le=new T.SetMap;for(const J of k){const te=x(J);for(let ne=0;ne<=te.length;ne++)le.add(te.slice(0,ne).join(`
`),J)}k.sort((0,b.compareBy)(J=>J.idx,b.numberComparator));let ae="",K=0;for(const J of k.slice(0,f)){K++;const te=x(J),ne=[];for(let M=0;M<te.length;M++){let w=te[M];w=`(shared with ${le.get(te.slice(0,M+1).join(`
`)).size}/${k.length} leaks) at ${w}`;const Q=le.get(te.slice(0,M).join(`
`)),ie=(0,W.groupBy)([...Q].map(oe=>x(oe)[M]),oe=>oe);delete ie[te[M]];for(const[oe,ge]of Object.entries(ie))ne.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${oe}`);ne.unshift(w)}ae+=`


==================== Leaking disposable ${K}/${k.length}: ${J.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return k.length>f&&(ae+=`


... and ${k.length-f} more leaking disposables

`),{leaks:k,details:ae}}}e.DisposableTracker=y;function S(m){r=m}if(D){const m="__is_disposable_tracked__";S(new class{trackDisposable(f){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[m]||console.log(R)},3e3)}setParent(f,R){if(f&&f!==t.None)try{f[m]=!0}catch{}}markAsDisposed(f){if(f&&f!==t.None)try{f[m]=!0}catch{}}markAsSingleton(f){}})}function j(m){return r?.trackDisposable(m),m}function U(m){r?.markAsDisposed(m)}function O(m,f){r?.setParent(m,f)}function l(m,f){if(r)for(const R of m)r.setParent(R,f)}function h(m){return r?.markAsSingleton(m),m}function P(m){return typeof m=="object"&&m!==null&&typeof m.dispose=="function"&&m.dispose.length===0}function v(m){if(z.Iterable.is(m)){const f=[];for(const R of m)if(R)try{R.dispose()}catch(k){f.push(k)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}function A(m){for(const f of m)P(f)&&f.dispose();return[]}function $(...m){const f=N(()=>v(m));return l(m,f),f}function N(m){const f=j({dispose:(0,L.createSingleCallFunction)(()=>{U(f),m()})});return f}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,j(this)}dispose(){this._isDisposed||(U(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{v(this._toDispose)}finally{this._toDispose.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return O(f,this),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(f),f}delete(f){if(f){if(f===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(f),f.dispose()}}deleteAndLeak(f){f&&this._toDispose.has(f)&&(this._toDispose.delete(f),O(f,null))}}e.DisposableStore=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new o,j(this),O(this._store,this)}dispose(){U(this),this._store.dispose()}_register(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(f)}}e.Disposable=t;class n{constructor(){this._isDisposed=!1,j(this)}get value(){return this._isDisposed?void 0:this._value}set value(f){this._isDisposed||f===this._value||(this._value?.dispose(),f&&O(f,this),this._value=f)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,U(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const f=this._value;return this._value=void 0,f&&O(f,null),f}}e.MutableDisposable=n;class s{constructor(f){this._disposable=new n,this._isDisposed=!1,this._disposable.value=f}get value(){return this._disposable.value}set value(f){this._isDisposed||f===this._disposable.value||(this._disposable.value=f)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class a{constructor(f){this._disposable=f,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,j(this)}set(f){let R=f;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,U(this))},this}}e.SafeDisposable=g;class p{constructor(){this.references=new Map}acquire(f,...R){let k=this.references.get(f);k||(k={counter:0,object:this.createReferencedObject(f,...R)},this.references.set(f,k));const{object:x}=k,le=(0,L.createSingleCallFunction)(()=>{--k.counter===0&&(this.destroyReferencedObject(f,k.object),this.references.delete(f))});return k.counter++,{object:x,dispose:le}}}e.ReferenceCollection=p;class u{constructor(f){this.referenceCollection=f}async acquire(f,...R){const k=this.referenceCollection.acquire(f,...R);try{return{object:await k.object,dispose:()=>k.dispose()}}catch(x){throw k.dispose(),x}}}e.AsyncReferenceCollection=u;class E{constructor(f){this.object=f}dispose(){}}e.ImmortalReference=E;function H(m){const f=new o;try{m(f)}finally{f.dispose()}}class _{constructor(){this._store=new Map,this._isDisposed=!1,j(this)}dispose(){U(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{v(this._store.values())}finally{this._store.clear()}}has(f){return this._store.has(f)}get size(){return this._store.size}get(f){return this._store.get(f)}set(f,R,k=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),k||this._store.get(f)?.dispose(),this._store.set(f,R)}deleteAndDispose(f){this._store.get(f)?.dispose(),this._store.delete(f)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=_}),define(de[29],me([0,1,19]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=T,e.normalizeNFD=z;const W=new b.LRUCache(1e4);function T(y){return r(y,"NFC",W)}const L=new b.LRUCache(1e4);function z(y){return r(y,"NFD",L)}const D=/[^\u0000-\u0080]/;function r(y,S,j){if(!y)return y;const U=j.get(y);if(U)return U;let O;return D.test(y)?O=y.normalize(S):O=y,j.set(y,O),O}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(S){return z(S).replace(y,"")}}()}),define(de[30],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const b=globalThis.performance&&typeof globalThis.performance.now=="function";class W{static create(L){return new W(L)}constructor(L){this._now=b&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=W}),define(de[9],me([0,1,3,18,6,28,30]),function(ce,e,b,W,T,L,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=O;const D=!1,r=!1,y=!1;var S;(function(R){R.None=()=>T.Disposable.None;function k(Z){if(y){const{onDidAddListener:X}=Z,se=h.create();let re=0;Z.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),se.print()),X?.()}}}function x(Z,X){return Q(Z,()=>{},0,void 0,!0,void 0,X)}R.defer=x;function le(Z){return(X,se=null,re)=>{let fe=!1,we;return we=Z(be=>{if(!fe)return we?we.dispose():fe=!0,X.call(se,be)},null,re),fe&&we.dispose(),we}}R.once=le;function ae(Z,X,se){return w((re,fe=null,we)=>Z(be=>re.call(fe,X(be)),null,we),se)}R.map=ae;function K(Z,X,se){return w((re,fe=null,we)=>Z(be=>{X(be),re.call(fe,be)},null,we),se)}R.forEach=K;function J(Z,X,se){return w((re,fe=null,we)=>Z(be=>X(be)&&re.call(fe,be),null,we),se)}R.filter=J;function te(Z){return Z}R.signal=te;function ne(...Z){return(X,se=null,re)=>{const fe=(0,T.combinedDisposable)(...Z.map(we=>we(be=>X.call(se,be))));return B(fe,re)}}R.any=ne;function M(Z,X,se,re){let fe=se;return ae(Z,we=>(fe=X(fe,we),fe),re)}R.reduce=M;function w(Z,X){let se;const re={onWillAddFirstListener(){se=Z(fe.fire,fe)},onDidRemoveLastListener(){se?.dispose()}};X||k(re);const fe=new o(re);return X?.add(fe),fe.event}function B(Z,X){return X instanceof Array?X.push(Z):X&&X.add(Z),Z}function Q(Z,X,se=100,re=!1,fe=!1,we,be){let Ee,Ae,Te,Se=0,Me;const qe={leakWarningThreshold:we,onWillAddFirstListener(){Ee=Z(ze=>{Se++,Ae=X(Ae,ze),re&&!Te&&(Ue.fire(Ae),Ae=void 0),Me=()=>{const $e=Ae;Ae=void 0,Te=void 0,(!re||Se>1)&&Ue.fire($e),Se=0},typeof se=="number"?(clearTimeout(Te),Te=setTimeout(Me,se)):Te===void 0&&(Te=0,queueMicrotask(Me))})},onWillRemoveListener(){fe&&Se>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,Ee.dispose()}};be||k(qe);const Ue=new o(qe);return be?.add(Ue),Ue.event}R.debounce=Q;function ie(Z,X=0,se){return R.debounce(Z,(re,fe)=>re?(re.push(fe),re):[fe],X,void 0,!0,void 0,se)}R.accumulate=ie;function oe(Z,X=(re,fe)=>re===fe,se){let re=!0,fe;return J(Z,we=>{const be=re||!X(we,fe);return re=!1,fe=we,be},se)}R.latch=oe;function ge(Z,X,se){return[R.filter(Z,X,se),R.filter(Z,re=>!X(re),se)]}R.split=ge;function he(Z,X=!1,se=[],re){let fe=se.slice(),we=Z(Ae=>{fe?fe.push(Ae):Ee.fire(Ae)});re&&re.add(we);const be=()=>{fe?.forEach(Ae=>Ee.fire(Ae)),fe=null},Ee=new o({onWillAddFirstListener(){we||(we=Z(Ae=>Ee.fire(Ae)),re&&re.add(we))},onDidAddFirstListener(){fe&&(X?setTimeout(be):be())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return re&&re.add(Ee),Ee.event}R.buffer=he;function pe(Z,X){return(re,fe,we)=>{const be=X(new ye);return Z(function(Ee){const Ae=be.evaluate(Ee);Ae!==ve&&re.call(fe,Ae)},void 0,we)}}R.chain=pe;const ve=Symbol("HaltChainable");class ye{constructor(){this.steps=[]}map(X){return this.steps.push(X),this}forEach(X){return this.steps.push(se=>(X(se),se)),this}filter(X){return this.steps.push(se=>X(se)?se:ve),this}reduce(X,se){let re=se;return this.steps.push(fe=>(re=X(re,fe),re)),this}latch(X=(se,re)=>se===re){let se=!0,re;return this.steps.push(fe=>{const we=se||!X(fe,re);return se=!1,re=fe,we?fe:ve}),this}evaluate(X){for(const se of this.steps)if(X=se(X),X===ve)break;return X}}function Ce(Z,X,se=re=>re){const re=(...Ee)=>be.fire(se(...Ee)),fe=()=>Z.on(X,re),we=()=>Z.removeListener(X,re),be=new o({onWillAddFirstListener:fe,onDidRemoveLastListener:we});return be.event}R.fromNodeEventEmitter=Ce;function I(Z,X,se=re=>re){const re=(...Ee)=>be.fire(se(...Ee)),fe=()=>Z.addEventListener(X,re),we=()=>Z.removeEventListener(X,re),be=new o({onWillAddFirstListener:fe,onDidRemoveLastListener:we});return be.event}R.fromDOMEventEmitter=I;function F(Z){return new Promise(X=>le(Z)(X))}R.toPromise=F;function d(Z){const X=new o;return Z.then(se=>{X.fire(se)},()=>{X.fire(void 0)}).finally(()=>{X.dispose()}),X.event}R.fromPromise=d;function i(Z,X,se){return X(se),Z(re=>X(re))}R.runAndSubscribe=i;class C{constructor(X,se){this._observable=X,this._counter=0,this._hasChanged=!1;const re={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};se||k(re),this.emitter=new o(re),se&&se.add(this.emitter)}beginUpdate(X){this._counter++}handlePossibleChange(X){}handleChange(X,se){this._hasChanged=!0}endUpdate(X){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function V(Z,X){return new C(Z,X).emitter.event}R.fromObservable=V;function G(Z){return(X,se,re)=>{let fe=0,we=!1;const be={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(Z.reportChanges(),we&&(we=!1,X.call(se)))},handlePossibleChange(){},handleChange(){we=!0}};Z.addObserver(be),Z.reportChanges();const Ee={dispose(){Z.removeObserver(be)}};return re instanceof T.DisposableStore?re.add(Ee):Array.isArray(re)&&re.push(Ee),Ee}}R.fromObservableLight=G})(S||(e.Event=S={}));class j{static{this.all=new Set}static{this._idPool=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${j._idPool++}`,j.all.add(this)}start(k){this._stopWatch=new z.StopWatch,this.listenerCount=k}stop(){if(this._stopWatch){const k=this._stopWatch.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=j;let U=-1;function O(R){const k=U;return U=R,{dispose(){U=k}}}class l{constructor(k,x=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=x,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(k,x){const le=this.threshold;if(le<=0||x<le)return;this._stacks||(this._stacks=new Map);const ae=this._stacks.get(k.value)||0;if(this._stacks.set(k.value,ae+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=le*.5;let K,J=0;for(const[te,ne]of this._stacks)(!K||J<ne)&&(K=te,J=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${x} listeners already. MOST frequent listener (${J}):`),console.warn(K)}return()=>{const K=this._stacks.get(k.value)||0;this._stacks.set(k.value,K-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let P=0;class v{constructor(k){this.value=k,this.id=P++}}const A=2,$=(R,k)=>{if(R instanceof v)k(R);else for(let x=0;x<R.length;x++){const le=R[x];le&&k(le)}},N=D?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class o{constructor(k){this._size=0,this._options=k,this._leakageMon=U>0||this._options?.leakWarningThreshold?new l(this._options?.leakWarningThreshold??U):void 0,this._perfMon=this._options?._profName?new j(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(r){const k=this._listeners;queueMicrotask(()=>{$(k,x=>x.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(k,x,le)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),T.Disposable.None;if(this._disposed)return T.Disposable.None;x&&(k=k.bind(x));const ae=new v(k);let K,J;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ae.stack=h.create(),K=this._leakageMon.check(ae.stack,this._size+1)),r&&(ae.stack=J??h.create()),this._listeners?this._listeners instanceof v?(this._deliveryQueue??=new n,this._listeners=[this._listeners,ae]):this._listeners.push(ae):(this._options?.onWillAddFirstListener?.(this),this._listeners=ae,this._options?.onDidAddFirstListener?.(this)),this._size++;const te=(0,T.toDisposable)(()=>{N?.unregister(te),K?.(),this._removeListener(ae)});if(le instanceof T.DisposableStore?le.add(te):Array.isArray(le)&&le.push(te),N){const ne=new Error().stack.split(`
`).slice(2).join(`
`).trim();N.register(te,ne,te)}return te},this._event}_removeListener(k){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const x=this._listeners,le=x.indexOf(k);if(le===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,x[le]=void 0;const ae=this._deliveryQueue.current===this;if(this._size*A<=x.length){let K=0;for(let J=0;J<x.length;J++)x[J]?x[K++]=x[J]:ae&&(this._deliveryQueue.end--,K<this._deliveryQueue.i&&this._deliveryQueue.i--);x.length=K}}_deliver(k,x){if(!k)return;const le=this._options?.onListenerError||b.onUnexpectedError;if(!le){k.value(x);return}try{k.value(x)}catch(ae){le(ae)}}_deliverQueue(k){const x=k.current._listeners;for(;k.i<k.end;)this._deliver(x[k.i++],k.value);k.reset()}fire(k){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof v)this._deliver(this._listeners,k);else{const x=this._deliveryQueue;x.enqueue(this,k,this._listeners.length),this._deliverQueue(x)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=o;const t=()=>new n;e.createEventDeliveryQueue=t;class n{constructor(){this.i=-1,this.end=0}enqueue(k,x,le){this.i=0,this.end=le,this.current=k,this.value=x}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends o{async fireAsync(k,x,le){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList),$(this._listeners,ae=>this._asyncDeliveryQueue.push([ae.value,k]));this._asyncDeliveryQueue.size>0&&!x.isCancellationRequested;){const[ae,K]=this._asyncDeliveryQueue.shift(),J=[],te={...K,token:x,waitUntil:ne=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");le&&(ne=le(ne,ae)),J.push(ne)}};try{ae(te)}catch(ne){(0,b.onUnexpectedError)(ne);continue}Object.freeze(J),await Promise.allSettled(J).then(ne=>{for(const M of ne)M.status==="rejected"&&(0,b.onUnexpectedError)(M.reason)})}}}e.AsyncEmitter=s;class a extends o{get isPaused(){return this._isPaused!==0}constructor(k){super(k),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=k?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const k=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(k))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(k){this._size&&(this._isPaused!==0?this._eventQueue.push(k):super.fire(k))}}e.PauseableEmitter=a;class g extends a{constructor(k){super(k),this._delay=k.delay??100}fire(k){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(k)}}e.DebounceEmitter=g;class p extends o{constructor(k){super(k),this._queuedEvents=[],this._mergeFn=k?.merge}fire(k){this.hasListeners()&&(this._queuedEvents.push(k),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(x=>super.fire(x)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=p;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(k){const x={event:k,listener:null};this.events.push(x),this.hasListeners&&this.hook(x);const le=()=>{this.hasListeners&&this.unhook(x);const ae=this.events.indexOf(x);this.events.splice(ae,1)};return(0,T.toDisposable)((0,W.createSingleCallFunction)(le))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(k=>this.hook(k))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(k=>this.unhook(k))}hook(k){k.listener=k.event(x=>this.emitter.fire(x))}unhook(k){k.listener?.dispose(),k.listener=null}dispose(){this.emitter.dispose();for(const k of this.events)k.listener?.dispose();this.events=[]}}e.EventMultiplexer=u;class E{constructor(k,x,le,ae){this._store=new T.DisposableStore;const K=this._store.add(new u),J=this._store.add(new T.DisposableMap);function te(ne){J.set(ne,K.add(ae(ne)))}for(const ne of k)te(ne);this._store.add(x(ne=>{te(ne)})),this._store.add(le(ne=>{J.deleteAndDispose(ne)})),this.event=K.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=E;class H{constructor(){this.buffers=[]}wrapEvent(k){return(x,le,ae)=>k(K=>{const J=this.buffers[this.buffers.length-1];J?J.push(()=>x.call(le,K)):x.call(le,K)},void 0,ae)}bufferEvents(k){const x=[];this.buffers.push(x);const le=k();return this.buffers.pop(),x.forEach(ae=>ae()),le}}e.EventBufferer=H;class _{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=T.Disposable.None,this.emitter=new o({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(k){this.inputEvent=k,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=k(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_;class m{static const(k){return new f(k)}constructor(k){this._value=k,this._onDidChange=new o,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(k){k!==this._value&&(this._value=k,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=m;class f{constructor(k){this.value=k,this.onDidChange=S.None}}}),define(de[7],me([0,1,9]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=D;const W=Object.freeze(function(r,y){const S=setTimeout(r.bind(y),0);return{dispose(){clearTimeout(S)}}});var T;(function(r){function y(S){return S===r.None||S===r.Cancelled||S instanceof L?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}r.isCancellationToken=y,r.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),r.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:W})})(T||(e.CancellationToken=T={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?W:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class z{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=T.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=z;function D(r){const y=new z;return r.add({dispose(){y.cancel()}}),y.token}}),define(de[31],me([0,1,7]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=T;class W{constructor(r){this.task=r,this.result=null}get(){if(this.result)return this.result;const r=new b.CancellationTokenSource,y=this.task(r.token);return this.result={promise:y,dispose:()=>{this.result=null,r.cancel(),r.dispose()}},this.result}}e.Cache=W;function T(D){return D}class L{constructor(r,y){this.lastCache=void 0,this.lastArgKey=void 0,typeof r=="function"?(this._fn=r,this._computeKey=T):(this._fn=y,this._computeKey=r.getCacheKey)}get(r){const y=this._computeKey(r);return this.lastArgKey!==y&&(this.lastArgKey=y,this.lastCache=this._fn(r)),this.lastCache}}e.LRUCachedFunction=L;class z{get cachedValues(){return this._map}constructor(r,y){this._map=new Map,this._map2=new Map,typeof r=="function"?(this._fn=r,this._computeKey=T):(this._fn=y,this._computeKey=r.getCacheKey)}get(r){const y=this._computeKey(r);if(this._map2.has(y))return this._map2.get(y);const S=this._fn(r);return this._map.set(r,S),this._map2.set(y,S),S}}e.CachedFunction=z}),define(de[32],me([0,1,3,6]),function(ce,e,b,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=T,e.isReadableStream=L,e.isReadableBufferedStream=z,e.newWriteableStream=D,e.consumeReadable=y,e.peekReadable=S,e.consumeStream=j,e.listenStream=U,e.peekStream=O,e.toStream=l,e.emptyStream=h,e.toReadable=P,e.transform=v,e.prefixedReadable=A,e.prefixedStream=$;function T(N){const o=N;return o?typeof o.read=="function":!1}function L(N){const o=N;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function z(N){const o=N;return o?L(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function D(N,o){return new r(N,o)}class r{constructor(o,t){this.reducer=o,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o<"u"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(t=>t(o))}emitError(o){this.listeners.error.length===0?(0,b.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(t=>t(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,t){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(o,t){if(this.state.destroyed)return;let n;switch(o){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const s=n.indexOf(t);s>=0&&n.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(N,o){const t=[];let n;for(;(n=N.read())!==null;)t.push(n);return o(t)}function S(N,o,t){const n=[];let s;for(;(s=N.read())!==null&&n.length<t;)n.push(s);return s===null&&n.length>0?o(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s<"u"){const a=s;return s=void 0,a}return N.read()}}}function j(N,o){return new Promise((t,n)=>{const s=[];U(N,{onData:a=>{o&&s.push(a)},onError:a=>{o?n(a):t(void 0)},onEnd:()=>{t(o?o(s):void 0)}})})}function U(N,o,t){N.on("error",n=>{t?.isCancellationRequested||o.onError(n)}),N.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),N.on("data",n=>{t?.isCancellationRequested||o.onData(n)})}function O(N,o){return new Promise((t,n)=>{const s=new W.DisposableStore,a=[],g=E=>{if(a.push(E),a.length>o)return s.dispose(),N.pause(),t({stream:N,buffer:a,ended:!1})},p=E=>(s.dispose(),n(E)),u=()=>(s.dispose(),t({stream:N,buffer:a,ended:!0}));s.add((0,W.toDisposable)(()=>N.removeListener("error",p))),N.on("error",p),s.add((0,W.toDisposable)(()=>N.removeListener("end",u))),N.on("end",u),s.add((0,W.toDisposable)(()=>N.removeListener("data",g))),N.on("data",g)})}function l(N,o){const t=D(o);return t.end(N),t}function h(){const N=D(()=>{throw new Error("not supported")});return N.end(),N}function P(N){let o=!1;return{read:()=>o?null:(o=!0,N)}}function v(N,o,t){const n=D(t);return U(N,{onData:s=>n.write(o.data(s)),onError:s=>n.error(o.error?o.error(s):s),onEnd:()=>n.end()}),n}function A(N,o,t){let n=!1;return{read:()=>{const s=o.read();return n?s:(n=!0,s!==null?t([N,s]):N)}}}function $(N,o,t){let n=!1;const s=D(t);return U(o,{onData:a=>n?s.write(a):(n=!0,s.write(t([N,a]))),onError:a=>s.error(a),onEnd:()=>{n||(n=!0,s.write(N)),s.end()}}),s}}),define(de[10],me([0,1,12,32]),function(ce,e,b,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=y,e.readUInt16LE=S,e.writeUInt16LE=j,e.readUInt32BE=U,e.writeUInt32BE=O,e.readUInt32LE=l,e.writeUInt32LE=h,e.readUInt8=P,e.writeUInt8=v,e.readableToBuffer=A,e.bufferToReadable=$,e.streamToBuffer=N,e.bufferedStreamToBuffer=o,e.bufferToStream=t,e.streamToBufferReadableStream=n,e.newWriteableBufferStream=s,e.prefixedBufferReadable=a,e.prefixedBufferStream=g,e.decodeBase64=p,e.encodeBase64=H;const T=typeof Buffer<"u",L=new b.Lazy(()=>new Uint8Array(256));let z,D;class r{static alloc(m){return T?new r(Buffer.allocUnsafe(m)):new r(new Uint8Array(m))}static wrap(m){return T&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new r(m)}static fromString(m,f){return!(f?.dontUseNodeBuffer||!1)&&T?new r(Buffer.from(m)):(z||(z=new TextEncoder),new r(z.encode(m)))}static fromByteArray(m){const f=r.alloc(m.length);for(let R=0,k=m.length;R<k;R++)f.buffer[R]=m[R];return f}static concat(m,f){if(typeof f>"u"){f=0;for(let x=0,le=m.length;x<le;x++)f+=m[x].byteLength}const R=r.alloc(f);let k=0;for(let x=0,le=m.length;x<le;x++){const ae=m[x];R.set(ae,k),k+=ae.byteLength}return R}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=r.alloc(this.byteLength);return m.set(this),m}toString(){return T?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(m,f){return new r(this.buffer.subarray(m,f))}set(m,f){if(m instanceof r)this.buffer.set(m.buffer,f);else if(m instanceof Uint8Array)this.buffer.set(m,f);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),f);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return U(this.buffer,m)}writeUInt32BE(m,f){O(this.buffer,m,f)}readUInt32LE(m){return l(this.buffer,m)}writeUInt32LE(m,f){h(this.buffer,m,f)}readUInt8(m){return P(this.buffer,m)}writeUInt8(m,f){v(this.buffer,m,f)}indexOf(m,f=0){return y(this.buffer,m instanceof r?m.buffer:m,f)}}e.VSBuffer=r;function y(_,m,f=0){const R=m.byteLength,k=_.byteLength;if(R===0)return 0;if(R===1)return _.indexOf(m[0]);if(R>k-f)return-1;const x=L.value;x.fill(m.length);for(let J=0;J<m.length;J++)x[m[J]]=m.length-J-1;let le=f+m.length-1,ae=le,K=-1;for(;le<k;)if(_[le]===m[ae]){if(ae===0){K=le;break}le--,ae--}else le+=Math.max(m.length-ae,x[_[le]]),ae=m.length-1;return K}function S(_,m){return _[m+0]<<0>>>0|_[m+1]<<8>>>0}function j(_,m,f){_[f+0]=m&255,m=m>>>8,_[f+1]=m&255}function U(_,m){return _[m]*2**24+_[m+1]*2**16+_[m+2]*2**8+_[m+3]}function O(_,m,f){_[f+3]=m,m=m>>>8,_[f+2]=m,m=m>>>8,_[f+1]=m,m=m>>>8,_[f]=m}function l(_,m){return _[m+0]<<0>>>0|_[m+1]<<8>>>0|_[m+2]<<16>>>0|_[m+3]<<24>>>0}function h(_,m,f){_[f+0]=m&255,m=m>>>8,_[f+1]=m&255,m=m>>>8,_[f+2]=m&255,m=m>>>8,_[f+3]=m&255}function P(_,m){return _[m]}function v(_,m,f){_[f]=m}function A(_){return W.consumeReadable(_,m=>r.concat(m))}function $(_){return W.toReadable(_)}function N(_){return W.consumeStream(_,m=>r.concat(m))}async function o(_){return _.ended?r.concat(_.buffer):r.concat([..._.buffer,await N(_.stream)])}function t(_){return W.toStream(_,m=>r.concat(m))}function n(_){return W.transform(_,{data:m=>typeof m=="string"?r.fromString(m):r.wrap(m)},m=>r.concat(m))}function s(_){return W.newWriteableStream(m=>r.concat(m),_)}function a(_,m){return W.prefixedReadable(_,m,f=>r.concat(f))}function g(_,m){return W.prefixedStream(_,m,f=>r.concat(f))}function p(_){let m=0,f=0,R=0;const k=new Uint8Array(Math.floor(_.length/4*3)),x=ae=>{switch(f){case 3:k[R++]=m|ae,f=0;break;case 2:k[R++]=m|ae>>>2,m=ae<<6,f=3;break;case 1:k[R++]=m|ae>>>4,m=ae<<4,f=2;break;default:m=ae<<2,f=1}};for(let ae=0;ae<_.length;ae++){const K=_.charCodeAt(ae);if(K>=65&&K<=90)x(K-65);else if(K>=97&&K<=122)x(K-97+26);else if(K>=48&&K<=57)x(K-48+52);else if(K===43||K===45)x(62);else if(K===47||K===95)x(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${_[ae]}`)}}const le=R;for(;f>0;)x(0);return r.wrap(k).slice(0,le)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function H({buffer:_},m=!0,f=!1){const R=f?E:u;let k="";const x=_.byteLength%3;let le=0;for(;le<_.byteLength-x;le+=3){const ae=_[le+0],K=_[le+1],J=_[le+2];k+=R[ae>>>2],k+=R[(ae<<4|K>>>4)&63],k+=R[(K<<2|J>>>6)&63],k+=R[J&63]}if(x===1){const ae=_[le+0];k+=R[ae>>>2],k+=R[ae<<4&63],m&&(k+="==")}else if(x===2){const ae=_[le+0],K=_[le+1];k+=R[ae>>>2],k+=R[(ae<<4|K>>>4)&63],k+=R[K<<2&63],m&&(k+="=")}return k}}),define(de[11],me([0,1,31,12]),function(ce,e,b,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=T,e.format=z,e.format2=r,e.htmlAttributeEncodeValue=y,e.escape=S,e.escapeRegExpCharacters=j,e.count=U,e.truncate=O,e.truncateMiddle=l,e.trim=h,e.ltrim=P,e.rtrim=v,e.convertSimple2RegExpPattern=A,e.stripWildcards=$,e.createRegExp=N,e.regExpLeadsToEndlessLoop=o,e.splitLines=t,e.splitLinesIncludeSeparators=n,e.firstNonWhitespaceIndex=s,e.getLeadingWhitespace=a,e.lastNonWhitespaceIndex=g,e.replaceAsync=p,e.compare=u,e.compareSubstring=E,e.compareIgnoreCase=H,e.compareSubstringIgnoreCase=_,e.isAsciiDigit=m,e.isLowerAsciiLetter=f,e.isUpperAsciiLetter=R,e.equalsIgnoreCase=k,e.startsWithIgnoreCase=x,e.commonPrefixLength=le,e.commonSuffixLength=ae,e.isHighSurrogate=K,e.isLowSurrogate=J,e.computeCodePoint=te,e.getNextCodePoint=ne,e.nextCharLength=Q,e.prevCharLength=ie,e.getCharContainingOffset=oe,e.charCount=ge,e.containsRTL=ve,e.isBasicASCII=Ce,e.containsUnusualLineTerminators=I,e.isFullWidthCharacter=F,e.isEmojiImprecise=d,e.lcut=i,e.forAnsiStringParts=V,e.removeAnsiEscapeCodes=G,e.startsWithUTF8BOM=Z,e.stripUTF8BOM=X,e.fuzzyContains=se,e.containsUppercaseCharacter=re,e.uppercaseFirstLetter=fe,e.getNLines=we,e.singleLetterHash=be,e.getGraphemeBreakType=Ee,e.getLeftDeleteOffset=qe;function T(c){return!c||typeof c!="string"?!0:c.trim().length===0}const L=/{(\d+)}/g;function z(c,...q){return q.length===0?c:c.replace(L,function(Y,ee){const ue=parseInt(ee,10);return isNaN(ue)||ue<0||ue>=q.length?Y:q[ue]})}const D=/{([^}]+)}/g;function r(c,q){return Object.keys(q).length===0?c:c.replace(D,(Y,ee)=>q[ee]??Y)}function y(c){return c.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function S(c){return c.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function j(c){return c.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function U(c,q){let Y=0;const ee=q.charCodeAt(0);for(let ue=c.length-1;ue>=0;ue--)c.charCodeAt(ue)===ee&&Y++;return Y}function O(c,q,Y="\u2026"){return c.length<=q?c:`${c.substr(0,q)}${Y}`}function l(c,q,Y="\u2026"){if(c.length<=q)return c;const ee=Math.ceil(q/2)-Y.length/2,ue=Math.floor(q/2)-Y.length/2;return`${c.substr(0,ee)}${Y}${c.substr(c.length-ue)}`}function h(c,q=" "){const Y=P(c,q);return v(Y,q)}function P(c,q){if(!c||!q)return c;const Y=q.length;if(Y===0||c.length===0)return c;let ee=0;for(;c.indexOf(q,ee)===ee;)ee=ee+Y;return c.substring(ee)}function v(c,q){if(!c||!q)return c;const Y=q.length,ee=c.length;if(Y===0||ee===0)return c;let ue=ee,_e=-1;for(;_e=c.lastIndexOf(q,ue-1),!(_e===-1||_e+Y!==ue);){if(_e===0)return"";ue=_e}return c.substring(0,ue)}function A(c){return c.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function $(c){return c.replace(/\*/g,"")}function N(c,q,Y={}){if(!c)throw new Error("Cannot create regex from empty string");q||(c=j(c)),Y.wholeWord&&(/\B/.test(c.charAt(0))||(c="\\b"+c),/\B/.test(c.charAt(c.length-1))||(c=c+"\\b"));let ee="";return Y.global&&(ee+="g"),Y.matchCase||(ee+="i"),Y.multiline&&(ee+="m"),Y.unicode&&(ee+="u"),new RegExp(c,ee)}function o(c){return c.source==="^"||c.source==="^$"||c.source==="$"||c.source==="^\\s*$"?!1:!!(c.exec("")&&c.lastIndex===0)}function t(c){return c.split(/\r\n|\r|\n/)}function n(c){const q=[],Y=c.split(/(\r\n|\r|\n)/);for(let ee=0;ee<Math.ceil(Y.length/2);ee++)q.push(Y[2*ee]+(Y[2*ee+1]??""));return q}function s(c){for(let q=0,Y=c.length;q<Y;q++){const ee=c.charCodeAt(q);if(ee!==32&&ee!==9)return q}return-1}function a(c,q=0,Y=c.length){for(let ee=q;ee<Y;ee++){const ue=c.charCodeAt(ee);if(ue!==32&&ue!==9)return c.substring(q,ee)}return c.substring(q,Y)}function g(c,q=c.length-1){for(let Y=q;Y>=0;Y--){const ee=c.charCodeAt(Y);if(ee!==32&&ee!==9)return Y}return-1}function p(c,q,Y){const ee=[];let ue=0;for(const _e of c.matchAll(q)){if(ee.push(c.slice(ue,_e.index)),_e.index===void 0)throw new Error("match.index should be defined");ue=_e.index+_e[0].length,ee.push(Y(_e[0],..._e.slice(1),_e.index,c,_e.groups))}return ee.push(c.slice(ue)),Promise.all(ee).then(_e=>_e.join(""))}function u(c,q){return c<q?-1:c>q?1:0}function E(c,q,Y=0,ee=c.length,ue=0,_e=q.length){for(;Y<ee&&ue<_e;Y++,ue++){const Le=c.charCodeAt(Y),Ie=q.charCodeAt(ue);if(Le<Ie)return-1;if(Le>Ie)return 1}const Pe=ee-Y,Oe=_e-ue;return Pe<Oe?-1:Pe>Oe?1:0}function H(c,q){return _(c,q,0,c.length,0,q.length)}function _(c,q,Y=0,ee=c.length,ue=0,_e=q.length){for(;Y<ee&&ue<_e;Y++,ue++){let Le=c.charCodeAt(Y),Ie=q.charCodeAt(ue);if(Le===Ie)continue;if(Le>=128||Ie>=128)return E(c.toLowerCase(),q.toLowerCase(),Y,ee,ue,_e);f(Le)&&(Le-=32),f(Ie)&&(Ie-=32);const De=Le-Ie;if(De!==0)return De}const Pe=ee-Y,Oe=_e-ue;return Pe<Oe?-1:Pe>Oe?1:0}function m(c){return c>=48&&c<=57}function f(c){return c>=97&&c<=122}function R(c){return c>=65&&c<=90}function k(c,q){return c.length===q.length&&_(c,q)===0}function x(c,q){const Y=q.length;return q.length>c.length?!1:_(c,q,0,Y)===0}function le(c,q){const Y=Math.min(c.length,q.length);let ee;for(ee=0;ee<Y;ee++)if(c.charCodeAt(ee)!==q.charCodeAt(ee))return ee;return Y}function ae(c,q){const Y=Math.min(c.length,q.length);let ee;const ue=c.length-1,_e=q.length-1;for(ee=0;ee<Y;ee++)if(c.charCodeAt(ue-ee)!==q.charCodeAt(_e-ee))return ee;return Y}function K(c){return 55296<=c&&c<=56319}function J(c){return 56320<=c&&c<=57343}function te(c,q){return(c-55296<<10)+(q-56320)+65536}function ne(c,q,Y){const ee=c.charCodeAt(Y);if(K(ee)&&Y+1<q){const ue=c.charCodeAt(Y+1);if(J(ue))return te(ee,ue)}return ee}function M(c,q){const Y=c.charCodeAt(q-1);if(J(Y)&&q>1){const ee=c.charCodeAt(q-2);if(K(ee))return te(ee,Y)}return Y}class w{get offset(){return this._offset}constructor(q,Y=0){this._str=q,this._len=q.length,this._offset=Y}setOffset(q){this._offset=q}prevCodePoint(){const q=M(this._str,this._offset);return this._offset-=q>=65536?2:1,q}nextCodePoint(){const q=ne(this._str,this._len,this._offset);return this._offset+=q>=65536?2:1,q}eol(){return this._offset>=this._len}}e.CodePointIterator=w;class B{get offset(){return this._iterator.offset}constructor(q,Y=0){this._iterator=new w(q,Y)}nextGraphemeLength(){const q=Se.getInstance(),Y=this._iterator,ee=Y.offset;let ue=q.getGraphemeBreakType(Y.nextCodePoint());for(;!Y.eol();){const _e=Y.offset,Pe=q.getGraphemeBreakType(Y.nextCodePoint());if(Ae(ue,Pe)){Y.setOffset(_e);break}ue=Pe}return Y.offset-ee}prevGraphemeLength(){const q=Se.getInstance(),Y=this._iterator,ee=Y.offset;let ue=q.getGraphemeBreakType(Y.prevCodePoint());for(;Y.offset>0;){const _e=Y.offset,Pe=q.getGraphemeBreakType(Y.prevCodePoint());if(Ae(Pe,ue)){Y.setOffset(_e);break}ue=Pe}return ee-Y.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=B;function Q(c,q){return new B(c,q).nextGraphemeLength()}function ie(c,q){return new B(c,q).prevGraphemeLength()}function oe(c,q){q>0&&J(c.charCodeAt(q))&&q--;const Y=q+Q(c,q);return[Y-ie(c,Y),Y]}function ge(c){const q=new B(c);let Y=0;for(;!q.eol();)Y++,q.nextGraphemeLength();return Y}let he;function pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(c){return he||(he=pe()),he.test(c)}const ye=/^[\t\n\r\x20-\x7E]*$/;function Ce(c){return ye.test(c)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function I(c){return e.UNUSUAL_LINE_TERMINATORS.test(c)}function F(c){return c>=11904&&c<=55215||c>=63744&&c<=64255||c>=65281&&c<=65374}function d(c){return c>=127462&&c<=127487||c===8986||c===8987||c===9200||c===9203||c>=9728&&c<=10175||c===11088||c===11093||c>=127744&&c<=128591||c>=128640&&c<=128764||c>=128992&&c<=129008||c>=129280&&c<=129535||c>=129648&&c<=129782}function i(c,q,Y=""){const ee=c.trimStart();if(ee.length<q)return ee;const ue=/\b/g;let _e=0;for(;ue.test(ee)&&!(ee.length-ue.lastIndex<q);)_e=ue.lastIndex,ue.lastIndex+=1;return _e===0?ee:Y+ee.substring(_e).trimStart()}const C=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*V(c){let q=0;for(const Y of c.matchAll(C))q!==Y.index&&(yield{isCode:!1,str:c.substring(q,Y.index)}),yield{isCode:!0,str:Y[0]},q=Y.index+Y[0].length;q!==c.length&&(yield{isCode:!1,str:c.substring(q)})}function G(c){return c&&(c=c.replace(C,"")),c}e.UTF8_BOM_CHARACTER="\uFEFF";function Z(c){return!!(c&&c.length>0&&c.charCodeAt(0)===65279)}function X(c){return Z(c)?c.substr(1):c}function se(c,q){if(!c||!q||c.length<q.length)return!1;const Y=q.length,ee=c.toLowerCase();let ue=0,_e=-1;for(;ue<Y;){const Pe=ee.indexOf(q[ue],_e+1);if(Pe<0)return!1;_e=Pe,ue++}return!0}function re(c,q=!1){return c?(q&&(c=c.replace(/\\./g,"")),c.toLowerCase()!==c):!1}function fe(c){return c.charAt(0).toUpperCase()+c.slice(1)}function we(c,q=1){if(q===0)return"";let Y=-1;do Y=c.indexOf(`
`,Y+1),q--;while(q>0&&Y>=0);return Y===-1?c:(c[Y-1]==="\r"&&Y--,c.substr(0,Y))}function be(c){return c=c%(2*26),c<26?String.fromCharCode(97+c):String.fromCharCode(65+c-26)}function Ee(c){return Se.getInstance().getGraphemeBreakType(c)}function Ae(c,q){return c===0?q!==5&&q!==7:c===2&&q===3?!1:c===4||c===2||c===3||q===4||q===2||q===3?!0:!(c===8&&(q===8||q===9||q===11||q===12)||(c===11||c===9)&&(q===9||q===10)||(c===12||c===10)&&q===10||q===5||q===13||q===7||c===1||c===13&&q===14||c===6&&q===6)}var Te;(function(c){c[c.Other=0]="Other",c[c.Prepend=1]="Prepend",c[c.CR=2]="CR",c[c.LF=3]="LF",c[c.Control=4]="Control",c[c.Extend=5]="Extend",c[c.Regional_Indicator=6]="Regional_Indicator",c[c.SpacingMark=7]="SpacingMark",c[c.L=8]="L",c[c.V=9]="V",c[c.T=10]="T",c[c.LV=11]="LV",c[c.LVT=12]="LVT",c[c.ZWJ=13]="ZWJ",c[c.Extended_Pictographic=14]="Extended_Pictographic"})(Te||(e.GraphemeBreakType=Te={}));class Se{static{this._INSTANCE=null}static getInstance(){return Se._INSTANCE||(Se._INSTANCE=new Se),Se._INSTANCE}constructor(){this._data=Me()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const Y=this._data,ee=Y.length/3;let ue=1;for(;ue<=ee;)if(q<Y[3*ue])ue=2*ue;else if(q>Y[3*ue+1])ue=2*ue+1;else return Y[3*ue+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(c,q){if(c===0)return 0;const Y=Ue(c,q);if(Y!==void 0)return Y;const ee=new w(q,c);return ee.prevCodePoint(),ee.offset}function Ue(c,q){const Y=new w(q,c);let ee=Y.prevCodePoint();for(;ze(ee)||ee===65039||ee===8419;){if(Y.offset===0)return;ee=Y.prevCodePoint()}if(!d(ee))return;let ue=Y.offset;return ue>0&&Y.prevCodePoint()===8205&&(ue=Y.offset),ue}function ze(c){return 127995<=c&&c<=127999}var $e;(function(c){c[c.zwj=8205]="zwj",c[c.emojiVariantSelector=65039]="emojiVariantSelector",c[c.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class Ne{static{this.ambiguousCharacterData=new W.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new b.LRUCachedFunction({getCacheKey:JSON.stringify},q=>{function Y(De){const ke=new Map;for(let Re=0;Re<De.length;Re+=2)ke.set(De[Re],De[Re+1]);return ke}function ee(De,ke){const Re=new Map(De);for(const[We,je]of ke)Re.set(We,je);return Re}function ue(De,ke){if(!De)return ke;const Re=new Map;for(const[We,je]of De)ke.has(We)&&Re.set(We,je);return Re}const _e=this.ambiguousCharacterData.value;let Pe=q.filter(De=>!De.startsWith("_")&&De in _e);Pe.length===0&&(Pe=["_default"]);let Oe;for(const De of Pe){const ke=Y(_e[De]);Oe=ue(Oe,ke)}const Le=Y(_e._common),Ie=ee(Le,Oe);return new Ne(Ie)})}static getInstance(q){return Ne.cache.get(Array.from(q))}static{this._locales=new W.Lazy(()=>Object.keys(Ne.ambiguousCharacterData.value).filter(q=>!q.startsWith("_")))}static getLocales(){return Ne._locales.value}constructor(q){this.confusableDictionary=q}isAmbiguous(q){return this.confusableDictionary.has(q)}getPrimaryConfusable(q){return this.confusableDictionary.get(q)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ne;class Fe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Fe.getRawData())),this._data}static isInvisibleCharacter(q){return Fe.getData().has(q)}static get codePoints(){return Fe.getData()}}e.InvisibleCharacters=Fe}),define(de[33],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(de[8],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=b,e.isStringArray=W,e.isObject=T,e.isTypedArray=L,e.isNumber=z,e.isIterable=D,e.isBoolean=r,e.isUndefined=y,e.isDefined=S,e.isUndefinedOrNull=j,e.assertType=U,e.assertIsDefined=O,e.assertAllDefined=l,e.isEmptyObject=P,e.isFunction=v,e.areFunctions=A,e.validateConstraints=$,e.validateConstraint=N;function b(o){return typeof o=="string"}function W(o){return Array.isArray(o)&&o.every(t=>b(t))}function T(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function L(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function z(o){return typeof o=="number"&&!isNaN(o)}function D(o){return!!o&&typeof o[Symbol.iterator]=="function"}function r(o){return o===!0||o===!1}function y(o){return typeof o>"u"}function S(o){return!j(o)}function j(o){return y(o)||o===null}function U(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function O(o){if(j(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function l(...o){const t=[];for(let n=0;n<o.length;n++){const s=o[n];if(j(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(s)}return t}const h=Object.prototype.hasOwnProperty;function P(o){if(!T(o))return!1;for(const t in o)if(h.call(o,t))return!1;return!0}function v(o){return typeof o=="function"}function A(...o){return o.length>0&&o.every(v)}function $(o,t){const n=Math.min(o.length,t.length);for(let s=0;s<n;s++)N(o[s],t[s])}function N(o,t){if(b(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(v(t)){try{if(o instanceof t)return}catch{}if(!j(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(de[13],me([0,1,8]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=W,e.deepFreeze=T,e.cloneAndChange=z,e.mixin=r,e.equals=y,e.safeStringify=S,e.distinct=j,e.getCaseInsensitive=U,e.filter=O,e.getAllPropertyNames=l,e.getAllMethodNames=h,e.createProxyObject=P;function W(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const A=Array.isArray(v)?[]:{};return Object.entries(v).forEach(([$,N])=>{A[$]=N&&typeof N=="object"?W(N):N}),A}function T(v){if(!v||typeof v!="object")return v;const A=[v];for(;A.length>0;){const $=A.shift();Object.freeze($);for(const N in $)if(L.call($,N)){const o=$[N];typeof o=="object"&&!Object.isFrozen(o)&&!(0,b.isTypedArray)(o)&&A.push(o)}}return v}const L=Object.prototype.hasOwnProperty;function z(v,A){return D(v,A,new Set)}function D(v,A,$){if((0,b.isUndefinedOrNull)(v))return v;const N=A(v);if(typeof N<"u")return N;if(Array.isArray(v)){const o=[];for(const t of v)o.push(D(t,A,$));return o}if((0,b.isObject)(v)){if($.has(v))throw new Error("Cannot clone recursive data-structure");$.add(v);const o={};for(const t in v)L.call(v,t)&&(o[t]=D(v[t],A,$));return $.delete(v),o}return v}function r(v,A,$=!0){return(0,b.isObject)(v)?((0,b.isObject)(A)&&Object.keys(A).forEach(N=>{N in v?$&&((0,b.isObject)(v[N])&&(0,b.isObject)(A[N])?r(v[N],A[N],$):v[N]=A[N]):v[N]=A[N]}),v):A}function y(v,A){if(v===A)return!0;if(v==null||A===null||A===void 0||typeof v!=typeof A||typeof v!="object"||Array.isArray(v)!==Array.isArray(A))return!1;let $,N;if(Array.isArray(v)){if(v.length!==A.length)return!1;for($=0;$<v.length;$++)if(!y(v[$],A[$]))return!1}else{const o=[];for(N in v)o.push(N);o.sort();const t=[];for(N in A)t.push(N);if(t.sort(),!y(o,t))return!1;for($=0;$<o.length;$++)if(!y(v[o[$]],A[o[$]]))return!1}return!0}function S(v){const A=new Set;return JSON.stringify(v,($,N)=>{if((0,b.isObject)(N)||Array.isArray(N)){if(A.has(N))return"[Circular]";A.add(N)}return typeof N=="bigint"?`[BigInt ${N.toString()}]`:N})}function j(v,A){const $=Object.create(null);return!v||!A||Object.keys(A).forEach(o=>{const t=v[o],n=A[o];y(t,n)||($[o]=n)}),$}function U(v,A){const $=A.toLowerCase(),N=Object.keys(v).find(o=>o.toLowerCase()===$);return N?v[N]:v[A]}function O(v,A){const $=Object.create(null);for(const[N,o]of Object.entries(v))A(N,o)&&($[N]=o);return $}function l(v){let A=[];for(;Object.prototype!==v;)A=A.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return A}function h(v){const A=[];for(const $ of l(v))typeof v[$]=="function"&&A.push($);return A}function P(v,A){const $=o=>function(){const t=Array.prototype.slice.call(arguments,0);return A(o,t)},N={};for(const o of v)N[o]=$(o);return N}}),define(de[34],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=W;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function W(T){return b.test(T)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(D){for(let r=0;r<D.length;r++)D[r]=Math.floor(Math.random()*256);return D};const L=new Uint8Array(16),z=[];for(let D=0;D<256;D++)z.push(D.toString(16).padStart(2,"0"));return function(){T(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let r=0,y="";return y+=z[L[r++]],y+=z[L[r++]],y+=z[L[r++]],y+=z[L[r++]],y+="-",y+=z[L[r++]],y+=z[L[r++]],y+="-",y+=z[L[r++]],y+=z[L[r++]],y+="-",y+=z[L[r++]],y+=z[L[r++]],y+="-",y+=z[L[r++]],y+=z[L[r++]],y+=z[L[r++]],y+=z[L[r++]],y+=z[L[r++]],y+=z[L[r++]],y}}()}),define(de[35],me([51,52]),function(ce,e){return ce.create("vs/base/common/platform",e)}),define(de[2],me([0,1,35]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=n,e.isLittleEndian=E,e.isBigSurOrNewer=H,e.LANGUAGE_DEFAULT="en";let W=!1,T=!1,L=!1,z=!1,D=!1,r=!1,y=!1,S=!1,j=!1,U=!1,O,l=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT,P,v;const A=globalThis;let $;typeof A.vscode<"u"&&typeof A.vscode.process<"u"?$=A.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const N=typeof $?.versions?.electron=="string",o=N&&$?.type==="renderer";if(typeof $=="object"){W=$.platform==="win32",T=$.platform==="darwin",L=$.platform==="linux",z=L&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,y=N,j=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,O=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT;const _=$.env.VSCODE_NLS_CONFIG;if(_)try{const m=JSON.parse(_),f=m.availableLanguages["*"];O=m.locale,h=m.osLocale,l=f||e.LANGUAGE_DEFAULT,P=m._translationsConfigFile}catch{}D=!0}else typeof navigator=="object"&&!o?(v=navigator.userAgent,W=v.indexOf("Windows")>=0,T=v.indexOf("Macintosh")>=0,S=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=v.indexOf("Linux")>=0,U=v?.indexOf("Mobi")>=0,r=!0,O=b.getConfiguredDefaultLocale(b.localize(0,null))||e.LANGUAGE_DEFAULT,l=O,h=navigator.language):console.error("Unable to resolve platform.");var t;(function(_){_[_.Web=0]="Web",_[_.Mac=1]="Mac",_[_.Linux=2]="Linux",_[_.Windows=3]="Windows"})(t||(e.Platform=t={}));function n(_){switch(_){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;T?s=1:W?s=3:L&&(s=2),e.isWindows=W,e.isMacintosh=T,e.isLinux=L,e.isLinuxSnap=z,e.isNative=D,e.isElectron=y,e.isWeb=r,e.isWebWorker=r&&typeof A.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?A.origin:void 0,e.isIOS=S,e.isMobile=U,e.isCI=j,e.platform=s,e.userAgent=v,e.language=l;var a;(function(_){function m(){return e.language}_.value=m;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}_.isDefaultVariant=f;function R(){return e.language==="en"}_.isDefault=R})(a||(e.Language=a={})),e.locale=O,e.platformLocale=h,e.translationsConfigFile=P,e.setTimeout0IsFaster=typeof A.postMessage=="function"&&!A.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const _=[];A.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let R=0,k=_.length;R<k;R++){const x=_[R];if(x.id===f.data.vscodeScheduleAsyncWork){_.splice(R,1),x.callback();return}}});let m=0;return f=>{const R=++m;_.push({id:R,callback:f}),A.postMessage({vscodeScheduleAsyncWork:R},"*")}}return _=>setTimeout(_)})();var g;(function(_){_[_.Windows=1]="Windows",_[_.Macintosh=2]="Macintosh",_[_.Linux=3]="Linux"})(g||(e.OperatingSystem=g={})),e.OS=T||S?2:W?1:3;let p=!0,u=!1;function E(){if(!u){u=!0;const _=new Uint8Array(2);_[0]=1,_[1]=2,p=new Uint16Array(_.buffer)[0]===513}return p}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function H(_){return parseFloat(_)>=20}}),define(de[14],me([0,1,2]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let W;const T=globalThis.vscode;if(typeof T<"u"&&typeof T.process<"u"){const L=T.process;W={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?W={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:W={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=W.cwd,e.env=W.env,e.platform=W.platform,e.arch=W.arch}),define(de[4],me([0,1,14]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const W=65,T=97,L=90,z=122,D=46,r=47,y=92,S=58,j=63;class U extends Error{constructor(n,s,a){let g;typeof s=="string"&&s.indexOf("not ")===0?(g="must not be",s=s.replace(/^not /,"")):g="must be";const p=n.indexOf(".")!==-1?"property":"argument";let u=`The "${n}" ${p} ${g} of type ${s}`;u+=`. Received type ${typeof a}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function O(t,n){if(t===null||typeof t!="object")throw new U(n,"Object",t)}function l(t,n){if(typeof t!="string")throw new U(n,"string",t)}const h=b.platform==="win32";function P(t){return t===r||t===y}function v(t){return t===r}function A(t){return t>=W&&t<=L||t>=T&&t<=z}function $(t,n,s,a){let g="",p=0,u=-1,E=0,H=0;for(let _=0;_<=t.length;++_){if(_<t.length)H=t.charCodeAt(_);else{if(a(H))break;H=r}if(a(H)){if(!(u===_-1||E===1))if(E===2){if(g.length<2||p!==2||g.charCodeAt(g.length-1)!==D||g.charCodeAt(g.length-2)!==D){if(g.length>2){const m=g.lastIndexOf(s);m===-1?(g="",p=0):(g=g.slice(0,m),p=g.length-1-g.lastIndexOf(s)),u=_,E=0;continue}else if(g.length!==0){g="",p=0,u=_,E=0;continue}}n&&(g+=g.length>0?`${s}..`:"..",p=2)}else g.length>0?g+=`${s}${t.slice(u+1,_)}`:g=t.slice(u+1,_),p=_-u-1;u=_,E=0}else H===D&&E!==-1?++E:E=-1}return g}function N(t,n){O(n,"pathObject");const s=n.dir||n.root,a=n.base||`${n.name||""}${n.ext||""}`;return s?s===n.root?`${s}${a}`:`${s}${t}${a}`:a}e.win32={resolve(...t){let n="",s="",a=!1;for(let g=t.length-1;g>=-1;g--){let p;if(g>=0){if(p=t[g],l(p,"path"),p.length===0)continue}else n.length===0?p=b.cwd():(p=b.env[`=${n}`]||b.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==n.toLowerCase()&&p.charCodeAt(2)===y)&&(p=`${n}\\`));const u=p.length;let E=0,H="",_=!1;const m=p.charCodeAt(0);if(u===1)P(m)&&(E=1,_=!0);else if(P(m))if(_=!0,P(p.charCodeAt(1))){let f=2,R=f;for(;f<u&&!P(p.charCodeAt(f));)f++;if(f<u&&f!==R){const k=p.slice(R,f);for(R=f;f<u&&P(p.charCodeAt(f));)f++;if(f<u&&f!==R){for(R=f;f<u&&!P(p.charCodeAt(f));)f++;(f===u||f!==R)&&(H=`\\\\${k}\\${p.slice(R,f)}`,E=f)}}}else E=1;else A(m)&&p.charCodeAt(1)===S&&(H=p.slice(0,2),E=2,u>2&&P(p.charCodeAt(2))&&(_=!0,E=3));if(H.length>0)if(n.length>0){if(H.toLowerCase()!==n.toLowerCase())continue}else n=H;if(a){if(n.length>0)break}else if(s=`${p.slice(E)}\\${s}`,a=_,_&&n.length>0)break}return s=$(s,!a,"\\",P),a?`${n}\\${s}`:`${n}${s}`||"."},normalize(t){l(t,"path");const n=t.length;if(n===0)return".";let s=0,a,g=!1;const p=t.charCodeAt(0);if(n===1)return v(p)?"\\":t;if(P(p))if(g=!0,P(t.charCodeAt(1))){let E=2,H=E;for(;E<n&&!P(t.charCodeAt(E));)E++;if(E<n&&E!==H){const _=t.slice(H,E);for(H=E;E<n&&P(t.charCodeAt(E));)E++;if(E<n&&E!==H){for(H=E;E<n&&!P(t.charCodeAt(E));)E++;if(E===n)return`\\\\${_}\\${t.slice(H)}\\`;E!==H&&(a=`\\\\${_}\\${t.slice(H,E)}`,s=E)}}}else s=1;else A(p)&&t.charCodeAt(1)===S&&(a=t.slice(0,2),s=2,n>2&&P(t.charCodeAt(2))&&(g=!0,s=3));let u=s<n?$(t.slice(s),!g,"\\",P):"";return u.length===0&&!g&&(u="."),u.length>0&&P(t.charCodeAt(n-1))&&(u+="\\"),a===void 0?g?`\\${u}`:u:g?`${a}\\${u}`:`${a}${u}`},isAbsolute(t){l(t,"path");const n=t.length;if(n===0)return!1;const s=t.charCodeAt(0);return P(s)||n>2&&A(s)&&t.charCodeAt(1)===S&&P(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,s;for(let p=0;p<t.length;++p){const u=t[p];l(u,"path"),u.length>0&&(n===void 0?n=s=u:n+=`\\${u}`)}if(n===void 0)return".";let a=!0,g=0;if(typeof s=="string"&&P(s.charCodeAt(0))){++g;const p=s.length;p>1&&P(s.charCodeAt(1))&&(++g,p>2&&(P(s.charCodeAt(2))?++g:a=!1))}if(a){for(;g<n.length&&P(n.charCodeAt(g));)g++;g>=2&&(n=`\\${n.slice(g)}`)}return e.win32.normalize(n)},relative(t,n){if(l(t,"from"),l(n,"to"),t===n)return"";const s=e.win32.resolve(t),a=e.win32.resolve(n);if(s===a||(t=s.toLowerCase(),n=a.toLowerCase(),t===n))return"";let g=0;for(;g<t.length&&t.charCodeAt(g)===y;)g++;let p=t.length;for(;p-1>g&&t.charCodeAt(p-1)===y;)p--;const u=p-g;let E=0;for(;E<n.length&&n.charCodeAt(E)===y;)E++;let H=n.length;for(;H-1>E&&n.charCodeAt(H-1)===y;)H--;const _=H-E,m=u<_?u:_;let f=-1,R=0;for(;R<m;R++){const x=t.charCodeAt(g+R);if(x!==n.charCodeAt(E+R))break;x===y&&(f=R)}if(R!==m){if(f===-1)return a}else{if(_>m){if(n.charCodeAt(E+R)===y)return a.slice(E+R+1);if(R===2)return a.slice(E+R)}u>m&&(t.charCodeAt(g+R)===y?f=R:R===2&&(f=3)),f===-1&&(f=0)}let k="";for(R=g+f+1;R<=p;++R)(R===p||t.charCodeAt(R)===y)&&(k+=k.length===0?"..":"\\..");return E+=f,k.length>0?`${k}${a.slice(E,H)}`:(a.charCodeAt(E)===y&&++E,a.slice(E,H))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.win32.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===y){if(n.charCodeAt(1)===y){const s=n.charCodeAt(2);if(s!==j&&s!==D)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(A(n.charCodeAt(0))&&n.charCodeAt(1)===S&&n.charCodeAt(2)===y)return`\\\\?\\${n}`;return t},dirname(t){l(t,"path");const n=t.length;if(n===0)return".";let s=-1,a=0;const g=t.charCodeAt(0);if(n===1)return P(g)?t:".";if(P(g)){if(s=a=1,P(t.charCodeAt(1))){let E=2,H=E;for(;E<n&&!P(t.charCodeAt(E));)E++;if(E<n&&E!==H){for(H=E;E<n&&P(t.charCodeAt(E));)E++;if(E<n&&E!==H){for(H=E;E<n&&!P(t.charCodeAt(E));)E++;if(E===n)return t;E!==H&&(s=a=E+1)}}}}else A(g)&&t.charCodeAt(1)===S&&(s=n>2&&P(t.charCodeAt(2))?3:2,a=s);let p=-1,u=!0;for(let E=n-1;E>=a;--E)if(P(t.charCodeAt(E))){if(!u){p=E;break}}else u=!1;if(p===-1){if(s===-1)return".";p=s}return t.slice(0,p)},basename(t,n){n!==void 0&&l(n,"ext"),l(t,"path");let s=0,a=-1,g=!0,p;if(t.length>=2&&A(t.charCodeAt(0))&&t.charCodeAt(1)===S&&(s=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let u=n.length-1,E=-1;for(p=t.length-1;p>=s;--p){const H=t.charCodeAt(p);if(P(H)){if(!g){s=p+1;break}}else E===-1&&(g=!1,E=p+1),u>=0&&(H===n.charCodeAt(u)?--u===-1&&(a=p):(u=-1,a=E))}return s===a?a=E:a===-1&&(a=t.length),t.slice(s,a)}for(p=t.length-1;p>=s;--p)if(P(t.charCodeAt(p))){if(!g){s=p+1;break}}else a===-1&&(g=!1,a=p+1);return a===-1?"":t.slice(s,a)},extname(t){l(t,"path");let n=0,s=-1,a=0,g=-1,p=!0,u=0;t.length>=2&&t.charCodeAt(1)===S&&A(t.charCodeAt(0))&&(n=a=2);for(let E=t.length-1;E>=n;--E){const H=t.charCodeAt(E);if(P(H)){if(!p){a=E+1;break}continue}g===-1&&(p=!1,g=E+1),H===D?s===-1?s=E:u!==1&&(u=1):s!==-1&&(u=-1)}return s===-1||g===-1||u===0||u===1&&s===g-1&&s===a+1?"":t.slice(s,g)},format:N.bind(null,"\\"),parse(t){l(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const s=t.length;let a=0,g=t.charCodeAt(0);if(s===1)return P(g)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(P(g)){if(a=1,P(t.charCodeAt(1))){let f=2,R=f;for(;f<s&&!P(t.charCodeAt(f));)f++;if(f<s&&f!==R){for(R=f;f<s&&P(t.charCodeAt(f));)f++;if(f<s&&f!==R){for(R=f;f<s&&!P(t.charCodeAt(f));)f++;f===s?a=f:f!==R&&(a=f+1)}}}}else if(A(g)&&t.charCodeAt(1)===S){if(s<=2)return n.root=n.dir=t,n;if(a=2,P(t.charCodeAt(2))){if(s===3)return n.root=n.dir=t,n;a=3}}a>0&&(n.root=t.slice(0,a));let p=-1,u=a,E=-1,H=!0,_=t.length-1,m=0;for(;_>=a;--_){if(g=t.charCodeAt(_),P(g)){if(!H){u=_+1;break}continue}E===-1&&(H=!1,E=_+1),g===D?p===-1?p=_:m!==1&&(m=1):p!==-1&&(m=-1)}return E!==-1&&(p===-1||m===0||m===1&&p===E-1&&p===u+1?n.base=n.name=t.slice(u,E):(n.name=t.slice(u,p),n.base=t.slice(u,E),n.ext=t.slice(p,E))),u>0&&u!==a?n.dir=t.slice(0,u-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(h){const t=/\\/g;return()=>{const n=b.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>b.cwd()})();e.posix={resolve(...t){let n="",s=!1;for(let a=t.length-1;a>=-1&&!s;a--){const g=a>=0?t[a]:o();l(g,"path"),g.length!==0&&(n=`${g}/${n}`,s=g.charCodeAt(0)===r)}return n=$(n,!s,"/",v),s?`/${n}`:n.length>0?n:"."},normalize(t){if(l(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===r,s=t.charCodeAt(t.length-1)===r;return t=$(t,!n,"/",v),t.length===0?n?"/":s?"./":".":(s&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return l(t,"path"),t.length>0&&t.charCodeAt(0)===r},join(...t){if(t.length===0)return".";let n;for(let s=0;s<t.length;++s){const a=t[s];l(a,"path"),a.length>0&&(n===void 0?n=a:n+=`/${a}`)}return n===void 0?".":e.posix.normalize(n)},relative(t,n){if(l(t,"from"),l(n,"to"),t===n||(t=e.posix.resolve(t),n=e.posix.resolve(n),t===n))return"";const s=1,a=t.length,g=a-s,p=1,u=n.length-p,E=g<u?g:u;let H=-1,_=0;for(;_<E;_++){const f=t.charCodeAt(s+_);if(f!==n.charCodeAt(p+_))break;f===r&&(H=_)}if(_===E)if(u>E){if(n.charCodeAt(p+_)===r)return n.slice(p+_+1);if(_===0)return n.slice(p+_)}else g>E&&(t.charCodeAt(s+_)===r?H=_:_===0&&(H=0));let m="";for(_=s+H+1;_<=a;++_)(_===a||t.charCodeAt(_)===r)&&(m+=m.length===0?"..":"/..");return`${m}${n.slice(p+H)}`},toNamespacedPath(t){return t},dirname(t){if(l(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===r;let s=-1,a=!0;for(let g=t.length-1;g>=1;--g)if(t.charCodeAt(g)===r){if(!a){s=g;break}}else a=!1;return s===-1?n?"/":".":n&&s===1?"//":t.slice(0,s)},basename(t,n){n!==void 0&&l(n,"ext"),l(t,"path");let s=0,a=-1,g=!0,p;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let u=n.length-1,E=-1;for(p=t.length-1;p>=0;--p){const H=t.charCodeAt(p);if(H===r){if(!g){s=p+1;break}}else E===-1&&(g=!1,E=p+1),u>=0&&(H===n.charCodeAt(u)?--u===-1&&(a=p):(u=-1,a=E))}return s===a?a=E:a===-1&&(a=t.length),t.slice(s,a)}for(p=t.length-1;p>=0;--p)if(t.charCodeAt(p)===r){if(!g){s=p+1;break}}else a===-1&&(g=!1,a=p+1);return a===-1?"":t.slice(s,a)},extname(t){l(t,"path");let n=-1,s=0,a=-1,g=!0,p=0;for(let u=t.length-1;u>=0;--u){const E=t.charCodeAt(u);if(E===r){if(!g){s=u+1;break}continue}a===-1&&(g=!1,a=u+1),E===D?n===-1?n=u:p!==1&&(p=1):n!==-1&&(p=-1)}return n===-1||a===-1||p===0||p===1&&n===a-1&&n===s+1?"":t.slice(n,a)},format:N.bind(null,"/"),parse(t){l(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const s=t.charCodeAt(0)===r;let a;s?(n.root="/",a=1):a=0;let g=-1,p=0,u=-1,E=!0,H=t.length-1,_=0;for(;H>=a;--H){const m=t.charCodeAt(H);if(m===r){if(!E){p=H+1;break}continue}u===-1&&(E=!1,u=H+1),m===D?g===-1?g=H:_!==1&&(_=1):g!==-1&&(_=-1)}if(u!==-1){const m=p===0&&s?1:p;g===-1||_===0||_===1&&g===u-1&&g===p+1?n.base=n.name=t.slice(m,u):(n.name=t.slice(m,g),n.base=t.slice(m,u),n.ext=t.slice(g,u))}return p>0?n.dir=t.slice(0,p-1):s&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h?e.win32.normalize:e.posix.normalize,e.isAbsolute=h?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h?e.win32.join:e.posix.join,e.resolve=h?e.win32.resolve:e.posix.resolve,e.relative=h?e.win32.relative:e.posix.relative,e.dirname=h?e.win32.dirname:e.posix.dirname,e.basename=h?e.win32.basename:e.posix.basename,e.extname=h?e.win32.extname:e.posix.extname,e.format=h?e.win32.format:e.posix.format,e.parse=h?e.win32.parse:e.posix.parse,e.toNamespacedPath=h?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h?e.win32.sep:e.posix.sep,e.delimiter=h?e.win32.delimiter:e.posix.delimiter}),define(de[20],me([0,1,4,2,11,8]),function(ce,e,b,W,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=z,e.toSlashes=D,e.toPosixPath=r,e.getRoot=y,e.isUNC=S,e.isValidBasename=l,e.isEqual=h,e.isEqualOrParent=P,e.isWindowsDriveLetter=v,e.sanitizeFilePath=A,e.removeTrailingPathSeparator=$,e.isRootOrDriveLetter=N,e.hasDriveLetter=o,e.getDriveLetter=t,e.indexOfPath=n,e.parseLineAndColumnAware=s,e.randomPath=p;function z(u){return u===47||u===92}function D(u){return u.replace(/[\\/]/g,b.posix.sep)}function r(u){return u.indexOf("/")===-1&&(u=D(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function y(u,E=b.posix.sep){if(!u)return"";const H=u.length,_=u.charCodeAt(0);if(z(_)){if(z(u.charCodeAt(1))&&!z(u.charCodeAt(2))){let f=3;const R=f;for(;f<H&&!z(u.charCodeAt(f));f++);if(R!==f&&!z(u.charCodeAt(f+1))){for(f+=1;f<H;f++)if(z(u.charCodeAt(f)))return u.slice(0,f+1).replace(/[\\/]/g,E)}}return E}else if(v(_)&&u.charCodeAt(1)===58)return z(u.charCodeAt(2))?u.slice(0,2)+E:u.slice(0,2);let m=u.indexOf("://");if(m!==-1){for(m+=3;m<H;m++)if(z(u.charCodeAt(m)))return u.slice(0,m+1)}return""}function S(u){if(!W.isWindows||!u||u.length<5)return!1;let E=u.charCodeAt(0);if(E!==92||(E=u.charCodeAt(1),E!==92))return!1;let H=2;const _=H;for(;H<u.length&&(E=u.charCodeAt(H),E!==92);H++);return!(_===H||(E=u.charCodeAt(H+1),isNaN(E)||E===92))}const j=/[\\/:\*\?"<>\|]/g,U=/[\\/]/g,O=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(u,E=W.isWindows){const H=E?j:U;return!(!u||u.length===0||/^\s+$/.test(u)||(H.lastIndex=0,H.test(u))||E&&O.test(u)||u==="."||u===".."||E&&u[u.length-1]==="."||E&&u.length!==u.trim().length||u.length>255)}function h(u,E,H){const _=u===E;return!H||_?_:!u||!E?!1:(0,T.equalsIgnoreCase)(u,E)}function P(u,E,H,_=b.sep){if(u===E)return!0;if(!u||!E||E.length>u.length)return!1;if(H){if(!(0,T.startsWithIgnoreCase)(u,E))return!1;if(E.length===u.length)return!0;let f=E.length;return E.charAt(E.length-1)===_&&f--,u.charAt(f)===_}return E.charAt(E.length-1)!==_&&(E+=_),u.indexOf(E)===0}function v(u){return u>=65&&u<=90||u>=97&&u<=122}function A(u,E){return W.isWindows&&u.endsWith(":")&&(u+=b.sep),(0,b.isAbsolute)(u)||(u=(0,b.join)(E,u)),u=(0,b.normalize)(u),$(u)}function $(u){return W.isWindows?(u=(0,T.rtrim)(u,b.sep),u.endsWith(":")&&(u+=b.sep)):(u=(0,T.rtrim)(u,b.sep),u||(u=b.sep)),u}function N(u){const E=(0,b.normalize)(u);return W.isWindows?u.length>3?!1:o(E)&&(u.length===2||E.charCodeAt(2)===92):E===b.posix.sep}function o(u,E=W.isWindows){return E?v(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}function t(u,E=W.isWindows){return o(u,E)?u[0]:void 0}function n(u,E,H){return E.length>u.length?-1:u===E?0:(H&&(u=u.toLowerCase(),E=E.toLowerCase()),u.indexOf(E))}function s(u){const E=u.split(":");let H,_,m;for(const f of E){const R=Number(f);(0,L.isNumber)(R)?_===void 0?_=R:m===void 0&&(m=R):H=H?[H,f].join(":"):f}if(!H)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:H,line:_!==void 0?_:void 0,column:m!==void 0?m:_!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(u,E,H=8){let _="";for(let f=0;f<H;f++){let R;f===0&&W.isWindows&&!E&&(H===3||H===4)?R=g:R=a,_+=R.charAt(Math.floor(Math.random()*R.length))}let m;return E?m=`${E}-${_}`:m=_,u?(0,b.join)(u,m):m}}),define(de[21],me([0,1,2]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=L,e.removeDangerousEnvVariables=z;var W;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(W||(e.Source=W={}));var T;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(T||(e.TerminateResponseCode=T={}));function L(D,...r){const y=r.reduce((U,O)=>(U[O]=!0,U),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(U=>!y[U]).forEach(U=>{for(let O=0;O<S.length;O++)if(U.search(S[O])!==-1){delete D[U];break}})}function z(D){D&&(delete D.DEBUG,b.isMacintosh&&delete D.DYLD_LIBRARY_PATH,b.isLinux&&delete D.LD_PRELOAD)}}),define(de[5],me([0,1,4,2]),function(ce,e,b,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=l,e.uriToFsPath=N;const T=/^\w[\w\d+.-]*$/,L=/^\//,z=/^\/\//;function D(a,g){if(!a.scheme&&g)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!T.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!L.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(z.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function r(a,g){return!a&&!g?"file":a}function y(a,g){switch(a){case"https":case"http":case"file":g?g[0]!==j&&(g=j+g):g=j;break}return g}const S="",j="/",U=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class O{static isUri(g){return g instanceof O?!0:g?typeof g.authority=="string"&&typeof g.fragment=="string"&&typeof g.path=="string"&&typeof g.query=="string"&&typeof g.scheme=="string"&&typeof g.fsPath=="string"&&typeof g.with=="function"&&typeof g.toString=="function":!1}constructor(g,p,u,E,H,_=!1){typeof g=="object"?(this.scheme=g.scheme||S,this.authority=g.authority||S,this.path=g.path||S,this.query=g.query||S,this.fragment=g.fragment||S):(this.scheme=r(g,_),this.authority=p||S,this.path=y(this.scheme,u||S),this.query=E||S,this.fragment=H||S,D(this,_))}get fsPath(){return N(this,!1)}with(g){if(!g)return this;let{scheme:p,authority:u,path:E,query:H,fragment:_}=g;return p===void 0?p=this.scheme:p===null&&(p=S),u===void 0?u=this.authority:u===null&&(u=S),E===void 0?E=this.path:E===null&&(E=S),H===void 0?H=this.query:H===null&&(H=S),_===void 0?_=this.fragment:_===null&&(_=S),p===this.scheme&&u===this.authority&&E===this.path&&H===this.query&&_===this.fragment?this:new P(p,u,E,H,_)}static parse(g,p=!1){const u=U.exec(g);return u?new P(u[2]||S,s(u[4]||S),s(u[5]||S),s(u[7]||S),s(u[9]||S),p):new P(S,S,S,S,S)}static file(g){let p=S;if(W.isWindows&&(g=g.replace(/\\/g,j)),g[0]===j&&g[1]===j){const u=g.indexOf(j,2);u===-1?(p=g.substring(2),g=j):(p=g.substring(2,u),g=g.substring(u)||j)}return new P("file",p,g,S,S)}static from(g,p){return new P(g.scheme,g.authority,g.path,g.query,g.fragment,p)}static joinPath(g,...p){if(!g.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return W.isWindows&&g.scheme==="file"?u=O.file(b.win32.join(N(g,!0),...p)).path:u=b.posix.join(g.path,...p),g.with({path:u})}toString(g=!1){return o(this,g)}toJSON(){return this}static revive(g){if(g){if(g instanceof O)return g;{const p=new P(g);return p._formatted=g.external??null,p._fsPath=g._sep===h?g.fsPath??null:null,p}}else return g}}e.URI=O;function l(a){return!a||typeof a!="object"?!1:typeof a.scheme=="string"&&(typeof a.authority=="string"||typeof a.authority>"u")&&(typeof a.path=="string"||typeof a.path>"u")&&(typeof a.query=="string"||typeof a.query>"u")&&(typeof a.fragment=="string"||typeof a.fragment>"u")}const h=W.isWindows?1:void 0;class P extends O{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=N(this,!1)),this._fsPath}toString(g=!1){return g?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const g={$mid:1};return this._fsPath&&(g.fsPath=this._fsPath,g._sep=h),this._formatted&&(g.external=this._formatted),this.path&&(g.path=this.path),this.scheme&&(g.scheme=this.scheme),this.authority&&(g.authority=this.authority),this.query&&(g.query=this.query),this.fragment&&(g.fragment=this.fragment),g}}const v={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function A(a,g,p){let u,E=-1;for(let H=0;H<a.length;H++){const _=a.charCodeAt(H);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||g&&_===47||p&&_===91||p&&_===93||p&&_===58)E!==-1&&(u+=encodeURIComponent(a.substring(E,H)),E=-1),u!==void 0&&(u+=a.charAt(H));else{u===void 0&&(u=a.substr(0,H));const m=v[_];m!==void 0?(E!==-1&&(u+=encodeURIComponent(a.substring(E,H)),E=-1),u+=m):E===-1&&(E=H)}}return E!==-1&&(u+=encodeURIComponent(a.substring(E))),u!==void 0?u:a}function $(a){let g;for(let p=0;p<a.length;p++){const u=a.charCodeAt(p);u===35||u===63?(g===void 0&&(g=a.substr(0,p)),g+=v[u]):g!==void 0&&(g+=a[p])}return g!==void 0?g:a}function N(a,g){let p;return a.authority&&a.path.length>1&&a.scheme==="file"?p=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?g?p=a.path.substr(1):p=a.path[1].toLowerCase()+a.path.substr(2):p=a.path,W.isWindows&&(p=p.replace(/\//g,"\\")),p}function o(a,g){const p=g?$:A;let u="",{scheme:E,authority:H,path:_,query:m,fragment:f}=a;if(E&&(u+=E,u+=":"),(H||E==="file")&&(u+=j,u+=j),H){let R=H.indexOf("@");if(R!==-1){const k=H.substr(0,R);H=H.substr(R+1),R=k.lastIndexOf(":"),R===-1?u+=p(k,!1,!1):(u+=p(k.substr(0,R),!1,!1),u+=":",u+=p(k.substr(R+1),!1,!0)),u+="@"}H=H.toLowerCase(),R=H.lastIndexOf(":"),R===-1?u+=p(H,!1,!0):(u+=p(H.substr(0,R),!1,!0),u+=H.substr(R))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const R=_.charCodeAt(1);R>=65&&R<=90&&(_=`/${String.fromCharCode(R+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const R=_.charCodeAt(0);R>=65&&R<=90&&(_=`${String.fromCharCode(R+32)}:${_.substr(2)}`)}u+=p(_,!0,!1)}return m&&(u+="?",u+=p(m,!1,!1)),f&&(u+="#",u+=g?f:A(f,!1,!1)),u}function t(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+t(a.substr(3)):a}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(a){return a.match(n)?a.replace(n,g=>t(g)):a}}),define(de[36],me([0,1,5]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=W,e.parse=T,e.getFirstFrame=L,e.log=D;function W(y){const S=y;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function T(y){const S=[];let j;try{const U=JSON.parse(y.arguments),O=U[U.length-1];O&&O.__$stack&&(U.pop(),j=O.__$stack),S.push(...U)}catch{S.push("Unable to log remote console arguments",y.arguments)}return{args:S,stack:j}}function L(y){if(typeof y!="string")return L(T(y).stack);const S=y;if(S){const j=z(S),U=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(j||"");if(U&&U.length===4)return{uri:b.URI.file(U[1]),line:Number(U[2]),column:Number(U[3])}}}function z(y){if(!y)return y;const S=y.indexOf(`
`);return S===-1?y:y.substring(0,S)}function D(y,S){const{args:j,stack:U}=T(y),O=typeof j[0]=="string"&&j.length===1;let l=z(U);l&&(l=`(${l.trim()})`);let h=[];if(typeof j[0]=="string"?l&&O?h=[`%c[${S}] %c${j[0]} %c${l}`,r("blue"),r(""),r("grey")]:h=[`%c[${S}] %c${j[0]}`,r("blue"),r(""),...j.slice(1)]:h=[`%c[${S}]%`,r("blue"),...j],l&&!O&&h.push(l),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,h)}function r(y){return`color: ${y}`}}),define(de[37],me([0,1,10,5]),function(ce,e,b,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=T,e.parse=L,e.revive=D;function T(r){return JSON.stringify(r,z)}function L(r){let y=JSON.parse(r);return y=D(y),y}function z(r,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function D(r,y=0){if(!r||y>200)return r;if(typeof r=="object"){switch(r.$mid){case 1:return W.URI.revive(r);case 2:return new RegExp(r.source,r.flags);case 17:return new Date(r.source)}if(r instanceof b.VSBuffer||r instanceof Uint8Array)return r;if(Array.isArray(r))for(let S=0;S<r.length;++S)r[S]=D(r[S],y+1);else for(const S in r)Object.hasOwnProperty.call(r,S)&&(r[S]=D(r[S],y+1))}return r}}),define(de[15],me([0,1,3,2,11,5,4]),function(ce,e,b,W,T,L,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=r,e.matchesSomeScheme=y,e.getServerRootPath=j;var D;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(D||(e.Schemas=D={}));function r(l,h){return L.URI.isUri(l)?(0,T.equalsIgnoreCase)(l.scheme,h):(0,T.startsWithIgnoreCase)(l,h+":")}function y(l,...h){return h.some(P=>r(l,P))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h,P){this._serverRootPath=j(h,P)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return z.posix.join(this._serverRootPath,D.vscodeRemoteResource)}set(h,P,v){this._hosts[h]=P,this._ports[h]=v}setConnectionToken(h,P){this._connectionTokens[h]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)try{return this._delegate(h)}catch(o){return b.onUnexpectedError(o),h}const P=h.authority;let v=this._hosts[P];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const A=this._ports[P],$=this._connectionTokens[P];let N=`path=${encodeURIComponent(h.path)}`;return typeof $=="string"&&(N+=`&${e.connectionTokenQueryName}=${encodeURIComponent($)}`),L.URI.from({scheme:W.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${v}:${A}`,path:this._remoteResourcesPath,query:N})}}e.RemoteAuthorities=new S;function j(l,h){return z.posix.join(h??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class U{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(h){const P=this.toUri(h,ce);return this.uriToBrowserUri(P)}uriToBrowserUri(h){return h.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(h):h.scheme===D.file&&(W.isNative||W.webWorkerOrigin===`${D.vscodeFileResource}://${U.FALLBACK_AUTHORITY}`)?h.with({scheme:D.vscodeFileResource,authority:h.authority||U.FALLBACK_AUTHORITY,query:null,fragment:null}):h}asFileUri(h){const P=this.toUri(h,ce);return this.uriToFileUri(P)}uriToFileUri(h){return h.scheme===D.vscodeFileResource?h.with({scheme:D.file,authority:h.authority!==U.FALLBACK_AUTHORITY?h.authority:null,query:null,fragment:null}):h}toUri(h,P){return L.URI.isUri(h)?h:L.URI.parse(P.toUrl(h))}}e.FileAccess=new U;var O;(function(l){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(h.get("3"));const P="vscode-coi";function v($){let N;typeof $=="string"?N=new URL($).searchParams:$ instanceof URL?N=$.searchParams:L.URI.isUri($)&&(N=new URL($.toString(!0)).searchParams);const o=N?.get(P);if(o)return h.get(o)}l.getHeadersFromQuery=v;function A($,N,o){if(!globalThis.crossOriginIsolated)return;const t=N&&o?"3":o?"2":"1";$ instanceof URLSearchParams?$.set(P,t):$[P]=t}l.addSearchParam=A})(O||(e.COI=O={}))}),define(de[38],me([0,1,23,15,2,5]),function(ce,e,b,W,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=S;class z{constructor(U,O,l){this.id=U,this.dependencies=O,this.callback=l}}class D{static{this.INSTANCE=new D}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(U,O,l)=>{typeof U!="string"&&(l=O,O=U,U=null),(typeof O!="object"||!Array.isArray(O))&&(l=O,O=null),this._defineCalls.push(new z(U,O,l))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(U){if(U.startsWith(window.location.origin)||U.startsWith("vscode-file://vscode-app"))return U;throw new Error(`[trusted_script_src] Invalid script url: ${U}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(U){return U}})))}async load(U){this._initialize();const O=await(this._isWebWorker?this._workerLoadScript(U):this._isRenderer?this._rendererLoadScript(U):this._nodeJSLoadScript(U));if(!O)throw new Error(`Did not receive a define call from script ${U}`);if(Array.isArray(O.dependencies)&&O.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${U}. The dependencies are: ${O.dependencies.join(", ")}`);return typeof O.callback=="function"?O.callback([]):O.callback}_rendererLoadScript(U){return new Promise((O,l)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const P=()=>{h.removeEventListener("load",v),h.removeEventListener("error",A)},v=$=>{P(),O(this._defineCalls.pop())},A=$=>{P(),l($)};h.addEventListener("load",v),h.addEventListener("error",A),this._amdPolicy&&(U=this._amdPolicy.createScriptURL(U)),h.setAttribute("src",U),window.document.getElementsByTagName("head")[0].appendChild(h)})}_workerLoadScript(U){return new Promise((O,l)=>{try{this._amdPolicy&&(U=this._amdPolicy.createScriptURL(U)),importScripts(U),O(this._defineCalls.pop())}catch(h){l(h)}})}async _nodeJSLoadScript(U){try{const O=globalThis._VSCODE_NODE_MODULES.fs,l=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,P=L.URI.parse(U).fsPath,v=O.readFileSync(P).toString(),A=h.wrap(v.replace(/^#!.*/,""));return new l.Script(A).runInThisContext().apply(),this._defineCalls.pop()}catch(O){throw O}}}const r=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function S(j,U,O){if(b.isESM){O===void 0&&(O=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[j]&&(j=y[j]);const l=`${j}/${U}`;if(r.has(l))return r.get(l);let h;if(/^\w[\w\d+.-]*:\/\//.test(l))h=l;else{const $=`${O&&!T.isWeb?W.nodeModulesAsarPath:W.nodeModulesPath}/${l}`;h=W.FileAccess.asBrowserUri($).toString(!0)}const P=D.INSTANCE.load(h);return r.set(l,P),P}else return await new Promise((l,h)=>{ce([j],l,h)})}}),define(de[22],me([0,1,20,15,4,2,11,5]),function(ce,e,b,W,T,L,z,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=r,e.distinctParents=S,e.toLocalResource=U;function r(O){return(0,D.uriToFsPath)(O,!0)}class y{constructor(l){this._ignorePathCasing=l}compare(l,h,P=!1){return l===h?0:(0,z.compare)(this.getComparisonKey(l,P),this.getComparisonKey(h,P))}isEqual(l,h,P=!1){return l===h?!0:!l||!h?!1:this.getComparisonKey(l,P)===this.getComparisonKey(h,P)}getComparisonKey(l,h=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,h,P=!1){if(l.scheme===h.scheme){if(l.scheme===W.Schemas.file)return b.isEqualOrParent(r(l),r(h),this._ignorePathCasing(l))&&l.query===h.query&&(P||l.fragment===h.fragment);if((0,e.isEqualAuthority)(l.authority,h.authority))return b.isEqualOrParent(l.path,h.path,this._ignorePathCasing(l),"/")&&l.query===h.query&&(P||l.fragment===h.fragment)}return!1}joinPath(l,...h){return D.URI.joinPath(l,...h)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return T.posix.basename(l.path)}extname(l){return T.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let h;return l.scheme===W.Schemas.file?h=D.URI.file(T.dirname(r(l))).path:(h=T.posix.dirname(l.path),l.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),h="/")),l.with({path:h})}normalizePath(l){if(!l.path.length)return l;let h;return l.scheme===W.Schemas.file?h=D.URI.file(T.normalize(r(l))).path:h=T.posix.normalize(l.path),l.with({path:h})}relativePath(l,h){if(l.scheme!==h.scheme||!(0,e.isEqualAuthority)(l.authority,h.authority))return;if(l.scheme===W.Schemas.file){const A=T.relative(r(l),r(h));return L.isWindows?b.toSlashes(A):A}let P=l.path||"/";const v=h.path||"/";if(this._ignorePathCasing(l)){let A=0;for(const $=Math.min(P.length,v.length);A<$&&!(P.charCodeAt(A)!==v.charCodeAt(A)&&P.charAt(A).toLowerCase()!==v.charAt(A).toLowerCase());A++);P=v.substr(0,A)+P.substr(A)}return T.posix.relative(P,v)}resolvePath(l,h){if(l.scheme===W.Schemas.file){const P=D.URI.file(T.resolve(r(l),h));return l.with({authority:P.authority,path:P.path})}return h=b.toPosixPath(h),l.with({path:T.posix.resolve(l.path,h)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,h){return l===h||l!==void 0&&h!==void 0&&(0,z.equalsIgnoreCase)(l,h)}hasTrailingPathSeparator(l,h=T.sep){if(l.scheme===W.Schemas.file){const P=r(l);return P.length>b.getRoot(P).length&&P[P.length-1]===h}else{const P=l.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,h=T.sep){return(0,e.hasTrailingPathSeparator)(l,h)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,h=T.sep){let P=!1;if(l.scheme===W.Schemas.file){const v=r(l);P=v!==void 0&&v.length===b.getRoot(v).length&&v[v.length-1]===h}else{h="/";const v=l.path;P=v.length===1&&v.charCodeAt(v.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(l,h)?l.with({path:l.path+"/"}):l}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(O=>O.scheme===W.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new y(O=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function S(O,l){const h=[];for(let P=0;P<O.length;P++){const v=l(O[P]);O.some((A,$)=>$===P?!1:(0,e.isEqualOrParent)(v,l(A)))||h.push(O[P])}return h}var j;(function(O){O.META_DATA_LABEL="label",O.META_DATA_DESCRIPTION="description",O.META_DATA_SIZE="size",O.META_DATA_MIME="mime";function l(h){const P=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach($=>{const[N,o]=$.split(":");N&&o&&P.set(N,o)});const A=h.path.substring(0,h.path.indexOf(";"));return A&&P.set(O.META_DATA_MIME,A),P}O.parseMetaData=l})(j||(e.DataUri=j={}));function U(O,l,h){if(l){let P=O.path;return P&&P[0]!==T.posix.sep&&(P=T.posix.sep+P),O.with({scheme:h,authority:l,path:P})}return O.with({scheme:h})}}),define(de[16],me([0,1,7,3,9,6,22,2,33,12]),function(ce,e,b,W,T,L,z,D,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=S,e.createCancelablePromise=j,e.raceCancellation=U,e.raceCancellationError=O,e.raceCancellablePromises=l,e.raceTimeout=h,e.asPromise=P,e.promiseWithResolvers=v,e.timeout=p,e.disposableTimeout=u,e.sequence=E,e.first=H,e.firstParallel=_,e.retry=w,e.createCancelableAsyncIterable=I;function S(d){return!!d&&typeof d.then=="function"}function j(d){const i=new b.CancellationTokenSource,C=d(i.token),V=new Promise((G,Z)=>{const X=i.token.onCancellationRequested(()=>{X.dispose(),Z(new W.CancellationError)});Promise.resolve(C).then(se=>{X.dispose(),i.dispose(),G(se)},se=>{X.dispose(),i.dispose(),Z(se)})});return new class{cancel(){i.cancel(),i.dispose()}then(G,Z){return V.then(G,Z)}catch(G){return this.then(void 0,G)}finally(G){return V.finally(G)}}}function U(d,i,C){return new Promise((V,G)=>{const Z=i.onCancellationRequested(()=>{Z.dispose(),V(C)});d.then(V,G).finally(()=>Z.dispose())})}function O(d,i){return new Promise((C,V)=>{const G=i.onCancellationRequested(()=>{G.dispose(),V(new W.CancellationError)});d.then(C,V).finally(()=>G.dispose())})}async function l(d){let i=-1;const C=d.map((V,G)=>V.then(Z=>(i=G,Z)));try{return await Promise.race(C)}finally{d.forEach((V,G)=>{G!==i&&V.cancel()})}}function h(d,i,C){let V;const G=setTimeout(()=>{V?.(void 0),C?.()},i);return Promise.race([d.finally(()=>clearTimeout(G)),new Promise(Z=>V=Z)])}function P(d){return new Promise((i,C)=>{const V=d();S(V)?V.then(i,C):i(V)})}function v(){let d,i;return{promise:new Promise((V,G)=>{d=V,i=G}),resolve:d,reject:i}}class A{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(i){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=i,!this.queuedPromise){const C=()=>{if(this.queuedPromise=null,this.isDisposed)return;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(C,C).then(V)})}return new Promise((C,V)=>{this.queuedPromise.then(C,V)})}return this.activePromise=i(),new Promise((C,V)=>{this.activePromise.then(G=>{this.activePromise=null,C(G)},G=>{this.activePromise=null,V(G)})})}dispose(){this.isDisposed=!0}}e.Throttler=A;class ${constructor(){this.current=Promise.resolve(null)}queue(i){return this.current=this.current.then(()=>i(),()=>i())}}e.Sequencer=$;class N{constructor(){this.promiseMap=new Map}queue(i,C){const G=(this.promiseMap.get(i)??Promise.resolve()).catch(()=>{}).then(C).finally(()=>{this.promiseMap.get(i)===G&&this.promiseMap.delete(i)});return this.promiseMap.set(i,G),G}}e.SequencerByKey=N;const o=(d,i)=>{let C=!0;const V=setTimeout(()=>{C=!1,i()},d);return{isTriggered:()=>C,dispose:()=>{clearTimeout(V),C=!1}}},t=d=>{let i=!0;return queueMicrotask(()=>{i&&(i=!1,d())}),{isTriggered:()=>i,dispose:()=>{i=!1}}};class n{constructor(i){this.defaultDelay=i,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(i,C=this.defaultDelay){this.task=i,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,Z)=>{this.doResolve=G,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=C===r.MicrotaskDelay?t(V):o(C,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new W.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=n;class s{constructor(i){this.delayer=new n(i),this.throttler=new A}trigger(i,C){return this.delayer.trigger(()=>this.throttler.queue(i),C)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=s;class a{constructor(){this._isOpen=!1,this._promise=new Promise((i,C)=>{this._completePromise=i})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class g extends a{constructor(i){super(),this._timeout=setTimeout(()=>this.open(),i)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function p(d,i){return i?new Promise((C,V)=>{const G=setTimeout(()=>{Z.dispose(),C()},d),Z=i.onCancellationRequested(()=>{clearTimeout(G),Z.dispose(),V(new W.CancellationError)})}):j(C=>p(d,C))}function u(d,i=0,C){const V=setTimeout(()=>{d(),C&&G.dispose()},i),G=(0,L.toDisposable)(()=>{clearTimeout(V),C?.deleteAndLeak(G)});return C?.add(G),G}function E(d){const i=[];let C=0;const V=d.length;function G(){return C<V?d[C++]():null}function Z(X){X!=null&&i.push(X);const se=G();return se?se.then(Z):Promise.resolve(i)}return Promise.resolve(null).then(Z)}function H(d,i=V=>!!V,C=null){let V=0;const G=d.length,Z=()=>{if(V>=G)return Promise.resolve(C);const X=d[V++];return Promise.resolve(X()).then(re=>i(re)?Promise.resolve(re):Z())};return Z()}function _(d,i=V=>!!V,C=null){if(d.length===0)return Promise.resolve(C);let V=d.length;const G=()=>{V=-1;for(const Z of d)Z.cancel?.()};return new Promise((Z,X)=>{for(const se of d)se.then(re=>{--V>=0&&i(re)?(G(),Z(re)):V===0&&Z(C)}).catch(re=>{--V>=0&&(G(),X(re))})})}class m{constructor(i){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=i,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}whenIdle(){return this.size>0?T.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(i){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((C,V)=>{this.outstandingPromises.push({factory:i,c:C,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const i=this.outstandingPromises.shift();this.runningPromises++;const C=i.factory();C.then(i.c,i.e),C.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=m;class f extends m{constructor(){super(1)}}e.Queue=f;class R{constructor(){this.sequentializer=new B,this.tasks=0}queue(i){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,i())):this.sequentializer.run(this.tasks++,i())}}e.LimitedQueue=R;class k{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const i=new oe;return this.drainers.add(i),i.p}isDrained(){for(const[,i]of this.queues)if(i.size>0)return!1;return!0}queueSize(i,C=z.extUri){const V=C.getComparisonKey(i);return this.queues.get(V)?.size??0}queueFor(i,C,V=z.extUri){const G=V.getComparisonKey(i);let Z=this.queues.get(G);if(!Z){Z=new f;const X=this.drainListenerCount++,se=T.Event.once(Z.onDrained)(()=>{Z?.dispose(),this.queues.delete(G),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(X),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new L.DisposableMap),this.drainListeners.set(X,se),this.queues.set(G,Z)}return Z.queue(C)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const i of this.drainers)i.complete();this.drainers.clear()}dispose(){for(const[,i]of this.queues)i.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=k;class x{constructor(i,C){this._token=-1,typeof i=="function"&&typeof C=="number"&&this.setIfNotSet(i,C)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(i,C){this.cancel(),this._token=setTimeout(()=>{this._token=-1,i()},C)}setIfNotSet(i,C){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,i()},C))}}e.TimeoutTimer=x;class le{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(i,C,V=globalThis){this.cancel();const G=V.setInterval(()=>{i()},C);this.disposable=(0,L.toDisposable)(()=>{V.clearInterval(G),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=le;class ae{constructor(i,C){this.timeoutToken=-1,this.runner=i,this.timeout=C,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(i=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,i)}get delay(){return this.timeout}set delay(i){this.timeout=i}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ae;class K{constructor(i,C){C%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.runner=i,this.timeout=C,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(i=this.timeout){i%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${i}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(i/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=K;class J extends ae{constructor(i,C){super(i,C),this.units=[]}work(i){this.units.push(i),this.isScheduled()||this.schedule()}doRun(){const i=this.units;this.units=[],this.runner?.(i)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=J;class te extends L.Disposable{constructor(i,C){super(),this.options=i,this.handler=C,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(i){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+i.length>this.options.maxBufferedWork)return!1}else if(this.pending+i.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const C of i)this.pendingWork.push(C);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ae(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=te,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(d,i)=>{(0,D.setTimeout0)(()=>{if(C)return;const V=Date.now()+15;i(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let C=!1;return{dispose(){C||(C=!0)}}}:e._runWhenIdle=(d,i,C)=>{const V=d.requestIdleCallback(i,typeof C=="number"?{timeout:C}:void 0);let G=!1;return{dispose(){G||(G=!0,d.cancelIdleCallback(V))}}},e.runWhenGlobalIdle=d=>(0,e._runWhenIdle)(globalThis,d)}();class ne{constructor(i,C){this._didRun=!1,this._executor=()=>{try{this._value=C()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(i,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ne;class M extends ne{constructor(i){super(globalThis,i)}}e.GlobalIdleValue=M;async function w(d,i,C){let V;for(let G=0;G<C;G++)try{return await d()}catch(Z){V=Z,await p(i)}throw V}class B{isRunning(i){return typeof i=="number"?this._running?.taskId===i:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(i,C,V){return this._running={taskId:i,cancel:()=>V?.(),promise:C},C.then(()=>this.doneRunning(i),()=>this.doneRunning(i)),C}doneRunning(i){this._running&&i===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const i=this._queued;this._queued=void 0,i.run().then(i.promiseResolve,i.promiseReject)}}queue(i){if(this._queued)this._queued.run=i;else{const{promise:C,resolve:V,reject:G}=v();this._queued={run:i,promise:C,promiseResolve:V,promiseReject:G}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=B;class Q{constructor(i,C=()=>Date.now()){this.interval=i,this.nowFn=C,this.lastIncrementTime=0,this.value=0}increment(){const i=this.nowFn();return i-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=i,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;var ie;(function(d){d[d.Resolved=0]="Resolved",d[d.Rejected=1]="Rejected"})(ie||(ie={}));class oe{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((i,C)=>{this.completeCallback=i,this.errorCallback=C})}complete(i){return new Promise(C=>{this.completeCallback(i),this.outcome={outcome:0,value:i},C()})}error(i){return new Promise(C=>{this.errorCallback(i),this.outcome={outcome:1,value:i},C()})}cancel(){return this.error(new W.CancellationError)}}e.DeferredPromise=oe;var ge;(function(d){async function i(V){let G;const Z=await Promise.all(V.map(X=>X.then(se=>se,se=>{G||(G=se)})));if(typeof G<"u")throw G;return Z}d.settled=i;function C(V){return new Promise(async(G,Z)=>{try{await V(G,Z)}catch(X){Z(X)}})}d.withAsyncBody=C})(ge||(e.Promises=ge={}));class he{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(i){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=i.then(C=>(this._value=C,this._isResolved=!0,C),C=>{throw this._error=C,this._isResolved=!0,C})}requireValue(){if(!this._isResolved)throw new W.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=he;class pe{constructor(i){this._compute=i,this._promise=new y.Lazy(()=>new he(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=pe;var ve;(function(d){d[d.Initial=0]="Initial",d[d.DoneOK=1]="DoneOK",d[d.DoneError=2]="DoneError"})(ve||(ve={}));class ye{static fromArray(i){return new ye(C=>{C.emitMany(i)})}static fromPromise(i){return new ye(async C=>{C.emitMany(await i)})}static fromPromises(i){return new ye(async C=>{await Promise.all(i.map(async V=>C.emitOne(await V)))})}static merge(i){return new ye(async C=>{await Promise.all(i.map(async V=>{for await(const G of V)C.emitOne(G)}))})}static{this.EMPTY=ye.fromArray([])}constructor(i,C){this._state=0,this._results=[],this._error=null,this._onReturn=C,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const V={emitOne:G=>this.emitOne(G),emitMany:G=>this.emitMany(G),reject:G=>this.reject(G)};try{await Promise.resolve(i(V)),this.resolve()}catch(G){this.reject(G)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}[Symbol.asyncIterator](){let i=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(i<this._results.length)return{done:!1,value:this._results[i++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(i,C){return new ye(async V=>{for await(const G of i)V.emitOne(C(G))})}map(i){return ye.map(this,i)}static filter(i,C){return new ye(async V=>{for await(const G of i)C(G)&&V.emitOne(G)})}filter(i){return ye.filter(this,i)}static coalesce(i){return ye.filter(i,C=>!!C)}coalesce(){return ye.coalesce(this)}static async toPromise(i){const C=[];for await(const V of i)C.push(V);return C}toPromise(){return ye.toPromise(this)}emitOne(i){this._state===0&&(this._results.push(i),this._onStateChanged.fire())}emitMany(i){this._state===0&&(this._results=this._results.concat(i),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(i){this._state===0&&(this._state=2,this._error=i,this._onStateChanged.fire())}}e.AsyncIterableObject=ye;class Ce extends ye{constructor(i,C){super(C),this._source=i}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Ce;function I(d){const i=new b.CancellationTokenSource,C=d(i.token);return new Ce(i,async V=>{const G=i.token.onCancellationRequested(()=>{G.dispose(),i.dispose(),V.reject(new W.CancellationError)});try{for await(const Z of C){if(i.token.isCancellationRequested)return;V.emitOne(Z)}G.dispose(),i.dispose()}catch(Z){G.dispose(),i.dispose(),V.reject(Z)}})}class F{constructor(i){this._deferred=new oe,this._asyncIterable=new ye(G=>{if(C){G.reject(C);return}return V&&G.emitMany(V),this._errorFn=Z=>G.reject(Z),this._emitFn=Z=>G.emitOne(Z),this._deferred.p},i);let C,V;this._emitFn=G=>{V||(V=[]),V.push(G)},this._errorFn=G=>{C||(C=G)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(i){this._errorFn(i),this._deferred.complete()}emitOne(i){this._emitFn(i)}}e.AsyncIterableSource=F}),define(de[39],me([0,1,53,54,55,16,20,29,4,2,22,5]),function(ce,e,b,W,T,L,z,D,r,y,S,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=P,e.readdirSync=$,e.whenDeleted=t,e.configureFlushOnWrite=p,e.writeFileSync=E;var U;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(U||(e.RimRafMode=U={}));async function O(K,J=U.UNLINK,te){if((0,z.isRootOrDriveLetter)(K))throw new Error("rimraf - will refuse to recursively delete root");return J===U.UNLINK?h(K):l(K,te)}async function l(K,J=(0,z.randomPath)((0,W.tmpdir)())){try{try{await b.promises.rename(K,J)}catch(te){return te.code==="ENOENT"?void 0:h(K)}h(J).catch(te=>{})}catch(te){if(te.code!=="ENOENT")throw te}}async function h(K){return(0,T.promisify)(b.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function P(K){if((0,z.isRootOrDriveLetter)(K))throw new Error("rimraf - will refuse to recursively delete root");b.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}async function v(K,J){return N(await(J?A(K):(0,T.promisify)(b.readdir)(K)))}async function A(K){try{return await(0,T.promisify)(b.readdir)(K,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const J=[],te=await v(K);for(const ne of te){let M=!1,w=!1,B=!1;try{const Q=await e.Promises.lstat((0,r.join)(K,ne));M=Q.isFile(),w=Q.isDirectory(),B=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}J.push({name:ne,isFile:()=>M,isDirectory:()=>w,isSymbolicLink:()=>B})}return J}function $(K){return N(b.readdirSync(K))}function N(K){return K.map(J=>typeof J=="string"?y.isMacintosh?(0,D.normalizeNFC)(J):J:(J.name=y.isMacintosh?(0,D.normalizeNFC)(J.name):J.name,J))}async function o(K){const J=await v(K),te=[];for(const ne of J)await n.existsDirectory((0,r.join)(K,ne))&&te.push(ne);return te}function t(K,J=1e3){return new Promise(te=>{let ne=!1;const M=setInterval(()=>{ne||(ne=!0,b.access(K,w=>{ne=!1,w&&(clearInterval(M),te(void 0))}))},J)})}var n;(function(K){async function J(M){let w;try{if(w=await e.Promises.lstat(M),!w.isSymbolicLink())return{stat:w}}catch{}try{return{stat:await e.Promises.stat(M),symbolicLink:w?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&w)return{stat:w,symbolicLink:{dangling:!0}};if(y.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&w)return{stat:w,symbolicLink:{dangling:!0}};throw Q}throw B}}K.stat=J;async function te(M){try{const{stat:w,symbolicLink:B}=await K.stat(M);return w.isFile()&&B?.dangling!==!0}catch{}return!1}K.existsFile=te;async function ne(M){try{const{stat:w,symbolicLink:B}=await K.stat(M);return w.isDirectory()&&B?.dangling!==!0}catch{}return!1}K.existsDirectory=ne})(n||(e.SymlinkSupport=n={}));const s=new L.ResourceQueue;function a(K,J,te){return s.queueFor(j.URI.file(K),()=>{const ne=H(te);return new Promise((M,w)=>u(K,J,ne,B=>B?w(B):M()))},S.extUriBiasedIgnorePathCase)}let g=!0;function p(K){g=K}function u(K,J,te,ne){if(!g)return b.writeFile(K,J,{mode:te.mode,flag:te.flag},ne);b.open(K,te.flag,te.mode,(M,w)=>{if(M)return ne(M);b.writeFile(w,J,B=>{if(B)return b.close(w,()=>ne(B));b.fdatasync(w,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),p(!1)),b.close(w,ie=>ne(ie))))})})}function E(K,J,te){const ne=H(te);if(!g)return b.writeFileSync(K,J,{mode:ne.mode,flag:ne.flag});const M=b.openSync(K,ne.flag,ne.mode);try{b.writeFileSync(M,J);try{b.fdatasyncSync(M)}catch(w){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",w),p(!1)}}finally{b.closeSync(M)}}function H(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function _(K,J,te=6e4){if(K!==J)try{y.isWindows&&typeof te=="number"?await m(K,J,Date.now(),te):await(0,T.promisify)(b.rename)(K,J)}catch(ne){if(K.toLowerCase()!==J.toLowerCase()&&ne.code==="EXDEV"||K.endsWith("."))await f(K,J,{preserveSymlinks:!1}),await O(K,U.MOVE);else throw ne}}async function m(K,J,te,ne,M=0){try{return await(0,T.promisify)(b.rename)(K,J)}catch(w){if(w.code!=="EACCES"&&w.code!=="EPERM"&&w.code!=="EBUSY")throw w;if(Date.now()-te>=ne)throw console.error(`[node.js fs] rename failed after ${M} retries with error: ${w}`),w;if(M===0){let B=!1;try{const{stat:Q}=await n.stat(J);Q.isFile()||(B=!0)}catch{}if(B)throw w}return await(0,L.timeout)(Math.min(100,M*10)),m(K,J,te,ne,M+1)}}async function f(K,J,te){return k(K,J,{root:{source:K,target:J},options:te,handledSourcePaths:new Set})}const R=511;async function k(K,J,te){if(te.handledSourcePaths.has(K))return;te.handledSourcePaths.add(K);const{stat:ne,symbolicLink:M}=await n.stat(K);if(M){if(te.options.preserveSymlinks)try{return await ae(K,J,te)}catch{}if(M.dangling)return}return ne.isDirectory()?x(K,J,ne.mode&R,te):le(K,J,ne.mode&R)}async function x(K,J,te,ne){await e.Promises.mkdir(J,{recursive:!0,mode:te});const M=await v(K);for(const w of M)await k((0,r.join)(K,w),(0,r.join)(J,w),ne)}async function le(K,J,te){await e.Promises.copyFile(K,J),await e.Promises.chmod(J,te)}async function ae(K,J,te){let ne=await e.Promises.readlink(K);(0,z.isEqualOrParent)(ne,te.root.source,!y.isLinux)&&(ne=(0,r.join)(te.root.target,ne.substr(te.root.source.length+1))),await e.Promises.symlink(ne,J)}e.Promises=new class{get access(){return(0,T.promisify)(b.access)}get stat(){return(0,T.promisify)(b.stat)}get lstat(){return(0,T.promisify)(b.lstat)}get utimes(){return(0,T.promisify)(b.utimes)}get read(){return(K,J,te,ne,M)=>new Promise((w,B)=>{b.read(K,J,te,ne,M,(Q,ie,oe)=>Q?B(Q):w({bytesRead:ie,buffer:oe}))})}get readFile(){return(0,T.promisify)(b.readFile)}get write(){return(K,J,te,ne,M)=>new Promise((w,B)=>{b.write(K,J,te,ne,M,(Q,ie,oe)=>Q?B(Q):w({bytesWritten:ie,buffer:oe}))})}get appendFile(){return(0,T.promisify)(b.appendFile)}get fdatasync(){return(0,T.promisify)(b.fdatasync)}get truncate(){return(0,T.promisify)(b.truncate)}get copyFile(){return(0,T.promisify)(b.copyFile)}get open(){return(0,T.promisify)(b.open)}get close(){return(0,T.promisify)(b.close)}get symlink(){return(0,T.promisify)(b.symlink)}get readlink(){return(0,T.promisify)(b.readlink)}get chmod(){return(0,T.promisify)(b.chmod)}get mkdir(){return(0,T.promisify)(b.mkdir)}get unlink(){return(0,T.promisify)(b.unlink)}get rmdir(){return(0,T.promisify)(b.rmdir)}get realpath(){return(0,T.promisify)(b.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return o}get writeFile(){return a}get rm(){return O}get rename(){return _}get copy(){return f}}}),define(de[40],me([0,1,4,2,14,21,8,39]),function(ce,e,b,W,T,L,z,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=r,e.createQueuedSender=y,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function r(j=T.env){return j.comspec||"cmd.exe"}function y(j){let U=[],O=!1;const l=function(h){if(O){U.push(h);return}(!j.send(h,v=>{if(v&&console.error(v),O=!1,U.length>0){const A=U.slice(0);U=[],A.forEach($=>l($))}})||W.isWindows)&&(O=!0)};return{send:l}}var S;(function(j){async function U(O,l,h){if(b.isAbsolute(O))return O;if(l===void 0&&(l=T.cwd()),b.dirname(O)!=="."||(h===void 0&&z.isString(T.env.PATH)&&(h=T.env.PATH.split(b.delimiter)),h===void 0||h.length===0))return b.join(l,O);async function v(A){if(await D.Promises.exists(A)){let $;try{$=await D.Promises.stat(A)}catch(N){N.message.startsWith("EACCES")&&($=await D.Promises.lstat(A))}return $?!$.isDirectory():!1}return!1}for(const A of h){let $;if(b.isAbsolute(A)?$=b.join(A,O):$=b.join(l,A,O),await v($))return $;let N=$+".com";if(await v(N)||(N=$+".exe",await v(N)))return N}return b.join(l,O)}j.findExecutable=U})(S||(e.win32=S={}))});var Be=this&&this.__decorate||function(ce,e,b,W){var T=arguments.length,L=T<3?e:W===null?W=Object.getOwnPropertyDescriptor(e,b):W,z;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ce,e,b,W);else for(var D=ce.length-1;D>=0;D--)(z=ce[D])&&(L=(T<3?z(L):T>3?z(e,b,L):z(e,b))||L);return T>3&&L&&Object.defineProperty(e,b,L),L};define(de[41],me([0,1,17,16,10,7,26,3,9,6,37,11,8]),function(ce,e,b,W,T,L,z,D,r,y,S,j,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=p,e.deserialize=u,e.getDelayedChannel=R,e.getNextTickChannel=k;var O;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(O||(O={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(h||(h={}));function P(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(v||(v={}));function A(M){let w=0;for(let B=0;;B+=7){const Q=M.read(1);if(w|=(Q.buffer[0]&127)<<B,!(Q.buffer[0]&128))return w}}const $=s(0);function N(M,w){if(w===0){M.write($);return}let B=0;for(let ie=w;ie!==0;ie=ie>>>7)B++;const Q=T.VSBuffer.alloc(B);for(let ie=0;w!==0;ie++)Q.buffer[ie]=w&127,w=w>>>7,w>0&&(Q.buffer[ie]|=128);M.write(Q)}class o{constructor(w){this.buffer=w,this.pos=0}read(w){const B=this.buffer.slice(this.pos,this.pos+w);return this.pos+=B.byteLength,B}}e.BufferReader=o;class t{constructor(){this.buffers=[]}get buffer(){return T.VSBuffer.concat(this.buffers)}write(w){this.buffers.push(w)}}e.BufferWriter=t;var n;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(n||(n={}));function s(M){const w=T.VSBuffer.alloc(1);return w.writeUInt8(M,0),w}const a={Undefined:s(n.Undefined),String:s(n.String),Buffer:s(n.Buffer),VSBuffer:s(n.VSBuffer),Array:s(n.Array),Object:s(n.Object),Uint:s(n.Int)},g=typeof Buffer<"u";function p(M,w){if(typeof w>"u")M.write(a.Undefined);else if(typeof w=="string"){const B=T.VSBuffer.fromString(w);M.write(a.String),N(M,B.byteLength),M.write(B)}else if(g&&Buffer.isBuffer(w)){const B=T.VSBuffer.wrap(w);M.write(a.Buffer),N(M,B.byteLength),M.write(B)}else if(w instanceof T.VSBuffer)M.write(a.VSBuffer),N(M,w.byteLength),M.write(w);else if(Array.isArray(w)){M.write(a.Array),N(M,w.length);for(const B of w)p(M,B)}else if(typeof w=="number"&&(w|0)===w)M.write(a.Uint),N(M,w);else{const B=T.VSBuffer.fromString(JSON.stringify(w));M.write(a.Object),N(M,B.byteLength),M.write(B)}}function u(M){switch(M.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return M.read(A(M)).toString();case n.Buffer:return M.read(A(M)).buffer;case n.VSBuffer:return M.read(A(M));case n.Array:{const B=A(M),Q=[];for(let ie=0;ie<B;ie++)Q.push(u(M));return Q}case n.Object:return JSON.parse(M.read(A(M)).toString());case n.Int:return A(M)}}class E{constructor(w,B,Q=null,ie=1e3){this.protocol=w,this.ctx=B,this.logger=Q,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(oe=>this.onRawMessage(oe)),this.sendResponse({type:200})}registerChannel(w,B){this.channels.set(w,B),setTimeout(()=>this.flushPendingRequests(w),0)}sendResponse(w){switch(w.type){case 200:{const B=this.send([w.type]);this.logger?.logOutgoing(B,0,1,P(w.type));return}case 201:case 202:case 204:case 203:{const B=this.send([w.type,w.id],w.data);this.logger?.logOutgoing(B,w.id,1,P(w.type),w.data);return}}}send(w,B=void 0){const Q=new t;return p(Q,w),p(Q,B),this.sendBuffer(Q.buffer)}sendBuffer(w){try{return this.protocol.send(w),w.byteLength}catch{return 0}}onRawMessage(w){const B=new o(w),Q=u(B),ie=u(B),oe=Q[0];switch(oe){case 100:return this.logger?.logIncoming(w.byteLength,Q[1],1,`${l(oe)}: ${Q[2]}.${Q[3]}`,ie),this.onPromise({type:oe,id:Q[1],channelName:Q[2],name:Q[3],arg:ie});case 102:return this.logger?.logIncoming(w.byteLength,Q[1],1,`${l(oe)}: ${Q[2]}.${Q[3]}`,ie),this.onEventListen({type:oe,id:Q[1],channelName:Q[2],name:Q[3],arg:ie});case 101:return this.logger?.logIncoming(w.byteLength,Q[1],1,`${l(oe)}`),this.disposeActiveRequest({type:oe,id:Q[1]});case 103:return this.logger?.logIncoming(w.byteLength,Q[1],1,`${l(oe)}`),this.disposeActiveRequest({type:oe,id:Q[1]})}}onPromise(w){const B=this.channels.get(w.channelName);if(!B){this.collectPendingRequest(w);return}const Q=new L.CancellationTokenSource;let ie;try{ie=B.call(this.ctx,w.name,w.arg,Q.token)}catch(he){ie=Promise.reject(he)}const oe=w.id;ie.then(he=>{this.sendResponse({id:oe,data:he,type:201})},he=>{he instanceof Error?this.sendResponse({id:oe,data:{message:he.message,name:he.name,stack:he.stack?he.stack.split?he.stack.split(`
`):he.stack:void 0},type:202}):this.sendResponse({id:oe,data:he,type:203})}).finally(()=>{ge.dispose(),this.activeRequests.delete(w.id)});const ge=(0,y.toDisposable)(()=>Q.cancel());this.activeRequests.set(w.id,ge)}onEventListen(w){const B=this.channels.get(w.channelName);if(!B){this.collectPendingRequest(w);return}const Q=w.id,oe=B.listen(this.ctx,w.name,w.arg)(ge=>this.sendResponse({id:Q,data:ge,type:204}));this.activeRequests.set(w.id,oe)}disposeActiveRequest(w){const B=this.activeRequests.get(w.id);B&&(B.dispose(),this.activeRequests.delete(w.id))}collectPendingRequest(w){let B=this.pendingRequests.get(w.channelName);B||(B=[],this.pendingRequests.set(w.channelName,B));const Q=setTimeout(()=>{console.error(`Unknown channel: ${w.channelName}`),w.type===100&&this.sendResponse({id:w.id,data:{name:"Unknown channel",message:`Channel name '${w.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:w,timeoutTimer:Q})}flushPendingRequests(w){const B=this.pendingRequests.get(w);if(B){for(const Q of B)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.onPromise(Q.request);break;case 102:this.onEventListen(Q.request);break}this.pendingRequests.delete(w)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=E;var H;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(H||(e.RequestInitiator=H={}));class _{constructor(w,B=null){this.protocol=w,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new r.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Q=>this.onBuffer(Q)),this.logger=B}getChannel(w){const B=this;return{call(Q,ie,oe){return B.isDisposed?Promise.reject(new D.CancellationError):B.requestPromise(w,Q,ie,oe)},listen(Q,ie){return B.isDisposed?r.Event.None:B.requestEvent(w,Q,ie)}}}requestPromise(w,B,Q,ie=L.CancellationToken.None){const oe=this.lastRequestId++,he={id:oe,type:100,channelName:w,name:B,arg:Q};if(ie.isCancellationRequested)return Promise.reject(new D.CancellationError);let pe;return new Promise((ye,Ce)=>{if(ie.isCancellationRequested)return Ce(new D.CancellationError);const I=()=>{const C=V=>{switch(V.type){case 201:this.handlers.delete(oe),ye(V.data);break;case 202:{this.handlers.delete(oe);const G=new Error(V.data.message);G.stack=Array.isArray(V.data.stack)?V.data.stack.join(`
`):V.data.stack,G.name=V.data.name,Ce(G);break}case 203:this.handlers.delete(oe),Ce(V.data);break}};this.handlers.set(oe,C),this.sendRequest(he)};let F=null;this.state===v.Idle?I():(F=(0,W.createCancelablePromise)(C=>this.whenInitialized()),F.then(()=>{F=null,I()}));const d=()=>{F?(F.cancel(),F=null):this.sendRequest({id:oe,type:101}),Ce(new D.CancellationError)},i=ie.onCancellationRequested(d);pe=(0,y.combinedDisposable)((0,y.toDisposable)(d),i),this.activeRequests.add(pe)}).finally(()=>{pe.dispose(),this.activeRequests.delete(pe)})}requestEvent(w,B,Q){const ie=this.lastRequestId++,ge={id:ie,type:102,channelName:w,name:B,arg:Q};let he=null;const pe=new r.Emitter({onWillAddFirstListener:()=>{he=(0,W.createCancelablePromise)(ye=>this.whenInitialized()),he.then(()=>{he=null,this.activeRequests.add(pe),this.sendRequest(ge)})},onDidRemoveLastListener:()=>{he?(he.cancel(),he=null):(this.activeRequests.delete(pe),this.sendRequest({id:ie,type:103}))}}),ve=ye=>pe.fire(ye.data);return this.handlers.set(ie,ve),pe.event}sendRequest(w){switch(w.type){case 100:case 102:{const B=this.send([w.type,w.id,w.channelName,w.name],w.arg);this.logger?.logOutgoing(B,w.id,0,`${l(w.type)}: ${w.channelName}.${w.name}`,w.arg);return}case 101:case 103:{const B=this.send([w.type,w.id]);this.logger?.logOutgoing(B,w.id,0,l(w.type));return}}}send(w,B=void 0){const Q=new t;return p(Q,w),p(Q,B),this.sendBuffer(Q.buffer)}sendBuffer(w){try{return this.protocol.send(w),w.byteLength}catch{return 0}}onBuffer(w){const B=new o(w),Q=u(B),ie=u(B),oe=Q[0];switch(oe){case 200:return this.logger?.logIncoming(w.byteLength,0,0,P(oe)),this.onResponse({type:Q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(w.byteLength,Q[1],0,P(oe),ie),this.onResponse({type:Q[0],id:Q[1],data:ie})}}onResponse(w){if(w.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}this.handlers.get(w.id)?.(w)}get onDidInitializePromise(){return r.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=_,Be([z.memoize],_.prototype,"onDidInitializePromise",null);class m{get connections(){const w=[];return this._connections.forEach(B=>w.push(B)),w}constructor(w,B,Q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new r.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new r.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new y.DisposableStore,this.disposables.add(w(({protocol:ie,onDidClientDisconnect:oe})=>{const ge=r.Event.once(ie.onMessage);this.disposables.add(ge(he=>{const pe=new o(he),ve=u(pe),ye=new E(ie,ve,B,Q),Ce=new _(ie,B);this.channels.forEach((F,d)=>ye.registerChannel(d,F));const I={channelServer:ye,channelClient:Ce,ctx:ve};this._connections.add(I),this._onDidAddConnection.fire(I),this.disposables.add(oe(()=>{ye.dispose(),Ce.dispose(),this._connections.delete(I),this._onDidRemoveConnection.fire(I)}))}))}))}getChannel(w,B){const Q=this;return{call(ie,oe,ge){let he;if((0,U.isFunction)(B)){const ve=(0,b.getRandomElement)(Q.connections.filter(B));he=ve?Promise.resolve(ve):r.Event.toPromise(r.Event.filter(Q.onDidAddConnection,B))}else he=B.routeCall(Q,ie,oe);const pe=he.then(ve=>ve.channelClient.getChannel(w));return R(pe).call(ie,oe,ge)},listen(ie,oe){if((0,U.isFunction)(B))return Q.getMulticastEvent(w,B,ie,oe);const ge=B.routeEvent(Q,ie,oe).then(he=>he.channelClient.getChannel(w));return R(ge).listen(ie,oe)}}}getMulticastEvent(w,B,Q,ie){const oe=this;let ge;const he=new r.Emitter({onWillAddFirstListener:()=>{ge=new y.DisposableStore;const pe=new r.EventMultiplexer,ve=new Map,ye=I=>{const d=I.channelClient.getChannel(w).listen(Q,ie),i=pe.add(d);ve.set(I,i)},Ce=I=>{const F=ve.get(I);F&&(F.dispose(),ve.delete(I))};oe.connections.filter(B).forEach(ye),r.Event.filter(oe.onDidAddConnection,B)(ye,void 0,ge),oe.onDidRemoveConnection(Ce,void 0,ge),pe.event(he.fire,he,ge),ge.add(pe)},onDidRemoveLastListener:()=>{ge?.dispose(),ge=void 0}});return he.event}registerChannel(w,B){this.channels.set(w,B);for(const Q of this._connections)Q.channelServer.registerChannel(w,B)}dispose(){this.disposables.dispose();for(const w of this._connections)w.channelClient.dispose(),w.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=m;class f{constructor(w,B,Q=null){const ie=new t;p(ie,B),w.send(ie.buffer),this.channelClient=new _(w,Q),this.channelServer=new E(w,B,Q)}getChannel(w){return this.channelClient.getChannel(w)}registerChannel(w,B){this.channelServer.registerChannel(w,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=f;function R(M){return{call(w,B,Q){return M.then(ie=>ie.call(w,B,Q))},listen(w,B){const Q=new r.Relay;return M.then(ie=>Q.input=ie.listen(w,B)),Q.event}}}function k(M){let w=!1;return{call(B,Q,ie){return w?M.call(B,Q,ie):(0,W.timeout)(0).then(()=>w=!0).then(()=>M.call(B,Q,ie))},listen(B,Q){if(w)return M.listen(B,Q);const ie=new r.Relay;return(0,W.timeout)(0).then(()=>w=!0).then(()=>ie.input=M.listen(B,Q)),ie.event}}}class x{constructor(w){this.fn=w}routeCall(w){return this.route(w)}routeEvent(w){return this.route(w)}async route(w){for(const B of w.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await r.Event.toPromise(w.onDidAddConnection),await this.route(w)}}e.StaticRouter=x;var le;(function(M){function w(oe,ge,he){const pe=oe,ve=he&&he.disableMarshalling,ye=new Map;for(const Ce in pe)Q(Ce)&&ye.set(Ce,r.Event.buffer(pe[Ce],!0,void 0,ge));return new class{listen(Ce,I,F){const d=ye.get(I);if(d)return d;const i=pe[I];if(typeof i=="function"){if(ie(I))return i.call(pe,F);if(Q(I))return ye.set(I,r.Event.buffer(pe[I],!0,void 0,ge)),ye.get(I)}throw new D.ErrorNoTelemetry(`Event not found: ${I}`)}call(Ce,I,F){const d=pe[I];if(typeof d=="function"){if(!ve&&Array.isArray(F))for(let C=0;C<F.length;C++)F[C]=(0,S.revive)(F[C]);let i=d.apply(pe,F);return i instanceof Promise||(i=Promise.resolve(i)),i}throw new D.ErrorNoTelemetry(`Method not found: ${I}`)}}}M.fromService=w;function B(oe,ge){const he=ge&&ge.disableMarshalling;return new Proxy({},{get(pe,ve){if(typeof ve=="string")return ge?.properties?.has(ve)?ge.properties.get(ve):ie(ve)?function(ye){return oe.listen(ve,ye)}:Q(ve)?oe.listen(ve):async function(...ye){let Ce;ge&&!(0,U.isUndefinedOrNull)(ge.context)?Ce=[ge.context,...ye]:Ce=ye;const I=await oe.call(ve,Ce);return he?I:(0,S.revive)(I)};throw new D.ErrorNoTelemetry(`Property not found: ${String(ve)}`)}})}M.toService=B;function Q(oe){return oe[0]==="o"&&oe[1]==="n"&&j.isUpperAsciiLetter(oe.charCodeAt(2))}function ie(oe){return/^onDynamic/.test(oe)&&j.isUpperAsciiLetter(oe.charCodeAt(9))}})(le||(e.ProxyChannel=le={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const w=M.toString();if(w!=="[object Object]")return w}return M}function J(M){return Array.isArray(M)?M.map(K):K(M)}function te(M,w,B,Q,ie,oe,ge){ge=J(ge);const he=ae[ie],pe=he[Q%he.length];let ve=[`%c[${M}]%c[${String(w).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(oe)?(ve=ve.concat(ge),ve.push(")")):ve.push(ge),console.log.apply(console,ve)}class ne{constructor(w,B){this._outgoingPrefix=w,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(w,B,Q,ie,oe){this._totalOutgoing+=w,te(this._outgoingPrefix,this._totalOutgoing,w,B,Q,ie,oe)}logIncoming(w,B,Q,ie,oe){this._totalIncoming+=w,te(this._incomingPrefix,this._totalIncoming,w,B,Q,ie,oe)}}e.IPCLogger=ne}),define(de[42],me([0,1,56,16,10,7,36,3,9,6,13,40,21,41]),function(ce,e,b,W,T,L,z,D,r,y,S,j,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class l extends O.ChannelServer{constructor(v){super({send:A=>{try{process.send?.(A.buffer.toString("base64"))}catch{}},onMessage:r.Event.fromNodeEventEmitter(process,"message",A=>T.VSBuffer.wrap(Buffer.from(A,"base64")))},v),process.once("disconnect",()=>this.dispose())}}e.Server=l;class h{constructor(v,A){this.modulePath=v,this.options=A,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new r.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const $=A&&A.timeout?A.timeout:6e4;this.disposeDelayer=new W.Delayer($),this.child=null,this._client=null}getChannel(v){const A=this;return{call($,N,o){return A.requestPromise(v,$,N,o)},listen($,N){return A.requestEvent(v,$,N)}}}requestPromise(v,A,$,N=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(N.isCancellationRequested)return Promise.reject(D.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(v),t=(0,W.createCancelablePromise)(a=>o.call(A,$,a)),n=N.onCancellationRequested(()=>t.cancel()),s=(0,y.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{n.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(v,A,$){if(!this.disposeDelayer)return r.Event.None;this.disposeDelayer.cancel();let N;const o=new r.Emitter({onWillAddFirstListener:()=>{N=this.getCachedChannel(v).listen(A,$)(o.fire,o),this.activeRequests.add(N)},onDidRemoveLastListener:()=>{this.activeRequests.delete(N),N.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],A=Object.create(null);A.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(A.env={...A.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(A.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(A.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(A.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),A.execArgv===void 0&&(A.execArgv=process.execArgv.filter(p=>!/^--inspect(-brk)?=/.test(p)).filter(p=>!p.startsWith("--vscode-"))),(0,U.removeDangerousEnvVariables)(A.env),this.child=(0,b.fork)(this.modulePath,v,A);const $=new r.Emitter,o=r.Event.fromNodeEventEmitter(this.child,"message",p=>p)(p=>{if((0,z.isRemoteConsoleLog)(p)){(0,z.log)(p,`IPC Library: ${this.options.serverName}`);return}$.fire(T.VSBuffer.wrap(Buffer.from(p,"base64")))}),t=this.options.useQueue?(0,j.createQueuedSender)(this.child):this.child,n=p=>this.child&&this.child.connected&&t.send(p.buffer.toString("base64")),s=$.event,a={send:n,onMessage:s};this._client=new O.ChannelClient(a);const g=()=>this.disposeClient();process.once("exit",g),this.child.on("error",p=>console.warn('IPC "'+this.options.serverName+'" errored with '+p)),this.child.on("exit",(p,u)=>{process.removeListener("exit",g),o.dispose(),this.activeRequests.forEach(E=>(0,y.dispose)(E)),this.activeRequests.clear(),p!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+p+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:p,signal:u})})}return this._client}getCachedChannel(v){let A=this.channels.get(v);return A||(A=this.client.getChannel(v),this.channels.set(v,A)),A}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(de[43],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=T,e.refineServiceDecorator=L;var b;(function(z){z.serviceIds=new Map,z.DI_TARGET="$di$target",z.DI_DEPENDENCIES="$di$dependencies";function D(r){return r[z.DI_DEPENDENCIES]||[]}z.getServiceDependencies=D})(b||(e._util=b={})),e.IInstantiationService=T("instantiationService");function W(z,D,r){D[b.DI_TARGET]===D?D[b.DI_DEPENDENCIES].push({id:z,index:r}):(D[b.DI_DEPENDENCIES]=[{id:z,index:r}],D[b.DI_TARGET]=D)}function T(z){if(b.serviceIds.has(z))return b.serviceIds.get(z);const D=function(r,y,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");W(D,r,S)};return D.toString=()=>z,b.serviceIds.set(z,D),D}function L(z){return z}}),define(de[44],me([0,1,15]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=W,e.getRemoteName=T,e.parseAuthorityWithPort=L,e.parseAuthorityWithOptionalPort=z;function W(r){return r.scheme===b.Schemas.vscodeRemote?r.authority:void 0}function T(r){if(!r)return;const y=r.indexOf("+");return y<0?r:r.substr(0,y)}function L(r){const{host:y,port:S}=D(r);if(typeof S>"u")throw new Error(`Invalid remote authority: ${r}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:S}}function z(r,y){let{host:S,port:j}=D(r);return typeof j>"u"&&(j=y),{host:S,port:j}}function D(r){const y=r.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const S=r.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const j=r.match(/(.*):(\d+)$/);return j?{host:j[1],port:parseInt(j[2],10)}:{host:r,port:void 0}}}),define(de[45],me([0,1,2,14,34]),function(ce,e,b,W,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=z,e.verifyMicrosoftInternalDomain=D;function L(r){if(b.platform===2&&/^penguin(\.|$)/i.test(r))return"chromebook"}function z(r,y,S,j,U,O,l,h,P){const v=Object.create(null);v["common.machineId"]=O,v["common.sqmId"]=l,v.sessionID=(0,T.generateUuid)()+Date.now(),v.commitHash=j,v.version=U,v["common.platformVersion"]=(r||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,b.PlatformToString)(b.platform),v["common.nodePlatform"]=W.platform,v["common.nodeArch"]=S,v["common.product"]=P||"desktop",h&&(v["common.msftInternal"]=h);let A=0;const $=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>A++,enumerable:!0}}),b.isLinuxSnap&&(v["common.snap"]="true");const N=L(y);return N&&(v["common.platformDetail"]=N),v}function D(r){const y=W.env.USERDNSDOMAIN;if(!y)return!1;const S=y.toLowerCase();return r.some(j=>S===j)}}),define(de[46],me([0,1,43]),function(ce,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,b.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,b.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var W;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(W||(e.TelemetryLevel=W={}));var T;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(T||(e.TelemetryConfiguration=T={}))}),define(de[47],me([0,1]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class b{constructor(L){this.appenders=L}listen(L,z){throw new Error(`Event not found: ${z}`)}call(L,z,{eventName:D,data:r}){return this.appenders.forEach(y=>y.log(D,r)),Promise.resolve(null)}}e.TelemetryAppenderChannel=b;class W{constructor(L){this.channel=L}log(L,z){return this.channel.call("log",{eventName:L,data:z}).then(void 0,D=>`Failed to log telemetry: ${console.warn(D)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=W}),define(de[48],me([0,1,13,8,44,45,46]),function(ce,e,b,W,T,L,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=S,e.isLoggingOnly=j,e.getTelemetryLevel=U,e.validateTelemetryData=O,e.cleanRemoteAuthority=h,e.isInternalTelemetry=v,e.getPiiPathsFromEnvironment=A,e.cleanData=o;class D{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=D;class r{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=r,e.NullTelemetryService=new r;class y{async publicLog(n,s,a){}async publicLogError(n,s,a){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}function j(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function U(t){const n=t.getValue(z.TELEMETRY_SETTING_ID),s=t.getValue(z.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(z.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function O(t){const n={},s={},a={};P(t,a);for(let g in a){g=g.length>150?g.substr(g.length-149):g;const p=a[g];typeof p=="number"?s[g]=p:typeof p=="boolean"?s[g]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${p.length}`),n[g]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(n[g]=p)}return{properties:n,measurements:s}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const n=(0,T.getRemoteName)(t);return l.has(n)?n:"other"}function P(t,n,s=0,a){if(t)for(const g of Object.getOwnPropertyNames(t)){const p=t[g],u=a?a+g:g;Array.isArray(p)?n[u]=(0,b.safeStringify)(p):p instanceof Date?n[u]=p.toISOString():(0,W.isObject)(p)?s<2?P(p,n,s+1,u+"."):n[u]=(0,b.safeStringify)(p):n[u]=p}}function v(t,n){const s=t.msftInternalDomains||[],a=n.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(s)||a}function A(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function $(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const a=[];for(const E of n)for(;;){const H=E.exec(t);if(!H)break;a.push([H.index,E.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(s="";;){const E=p.exec(t);if(!E)break;const H=a.some(([_,m])=>E.index<m&&_<p.lastIndex);!g.test(E[0])&&!H&&(s+=t.substring(u,E.index)+"<REDACTED: user-file-path>",u=p.lastIndex)}return u<t.length&&(s+=t.substr(u)),s}function N(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of n)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function o(t,n){return(0,b.cloneAndChange)(t,s=>{if(s instanceof D||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let a=s.replaceAll("%20"," ");a=$(a,n);for(const g of n)a=a.replace(g,"");return a=N(a),a}})}}),define(de[49],me([0,1,38,3,13,48]),function(ce,e,b,W,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const z="https://0.0.0.0/OneCollector/1.0",D="https://0.0.0.0/ping";async function r(S,j,U){const O=await(0,b.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,b.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),h=new O.AppInsightsCore,P=new l.PostChannel,v={instrumentationKey:S,endpointUrl:z,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[P]]};if(U){v.extensionConfig={};const A={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:U};v.extensionConfig[P.identifier]=A}return h.initialize(v,[]),h.addTelemetryInitializer(A=>{A.ext=A.ext??{},A.ext.web=A.ext.web??{},A.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',j&&(A.ext.utc=A.ext.utc??{},A.ext.utc.flags=8462029)}),h}class y{constructor(j,U,O,l,h){this._isInternalTelemetry=j,this._eventPrefix=U,this._defaultData=O,this._xhrOverride=h,this.endPointUrl=z,this.endPointHealthUrl=D,this._defaultData||(this._defaultData={}),typeof l=="function"?this._aiCoreOrKey=l():this._aiCoreOrKey=l,this._asyncAiCore=null}_withAIClient(j){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){j(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=r(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(U=>{j(U)},U=>{(0,W.onUnexpectedError)(U),console.error(U)})}}log(j,U){if(!this._aiCoreOrKey)return;U=(0,T.mixin)(U,this._defaultData),U=(0,L.validateTelemetryData)(U);const O=this._eventPrefix+"/"+j;try{this._withAIClient(l=>{l.pluginVersionString=U?.properties.version??"Unknown",l.track({name:O,baseData:{name:O,properties:U?.properties,measurements:U?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(j=>{this._withAIClient(U=>{U.unload(!0,()=>{this._aiCoreOrKey=void 0,j(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=y}),define(de[50],me([0,1,10,7,57,49]),function(ce,e,b,W,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function z(S,j){const U=await j.request(S,W.CancellationToken.None),O=(await(0,b.streamToBuffer)(U.stream)).toString(),l=U.res.statusCode??200;return{headers:U.res.headers,statusCode:l,responseData:O}}async function D(S){const j={method:S.type,headers:S.headers};return new Promise((O,l)=>{const h=T.request(S.url??"",j,P=>{P.on("data",function(v){O({headers:P.headers,statusCode:P.statusCode??200,responseData:v.toString()})}),P.on("error",function(v){l(v)})});h.write(S.data,P=>{P&&l(P)}),h.end()})}async function r(S,j,U){const O=typeof j.data=="string"?j.data:new TextDecoder().decode(j.data),l={type:"POST",headers:{...j.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(j.data).toString()},url:j.urlString,data:O};try{const h=S?await z(l,S):await D(l);U(h.statusCode,h.headers,h.responseData)}catch{U(0,{})}}class y extends L.AbstractOneDataSystemAppender{constructor(j,U,O,l,h){const P={sendPOST:(v,A)=>{r(j,v,A)}};super(U,O,l,h,P)}}e.OneDataSystemAppender=y}),define(de[58],me([0,1,42,47,50]),function(ce,e,b,W,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});const L=new T.OneDataSystemAppender(void 0,!1,process.argv[2],JSON.parse(process.argv[3]),process.argv[4]);process.once("exit",()=>L.flush());const z=new W.TelemetryAppenderChannel([L]);new b.Server("telemetry").registerChannel("telemetryAppender",z)})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4379b66f0d4dd9881ba96fa086f387725b69a24b/core/vs/workbench/contrib/debug/node/telemetryApp.js.map
